﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			ELEMENT PROCESS	  		Version 0.4.0									***/
/***				   				   Dernière Mise à Jour : 10-08-14										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         			   	 Gestionnaire Éléments											***/
/***	Ce Script est basé sur la gestion et archivage d'éléments uniques ou assemblés. 					***/
/***	La création d'élément que ce soit multiple ou unique, il permet d'archiver des créations 			***/
/***	particulières d'éléments et de les utiliser ensuite.												***/
/***												      													***/
/***	En outre, ce script permet, également, de gérer des éléments isolés par le biais de méthodes 		***/
/***	spéciales. 																							***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Creation {

	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*—*/
	
	// —— - - DISPLAY
	import flash.display.MovieClip;
	import flash.display.Sprite;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	import drOIde.Visual.ShowProcess;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class ElementProcess extends MiscTools {
		
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		// —————— LINK
  	    // Liens vers les autres scripts
		public var Show:ShowProcess;

		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function ElementProcess( TheLink:* = null		// ———— - - Lien vers la scène
									 ):void {
			/*—*/
			
			// Établit la connexion
			Connexion( TheLink );
			
			// Créait la liaison des scripts
			Show = new ShowProcess( TheLink );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					FIGURE						  		  				  */
		/*						Méthodes permettant d'achiver des éléments uniques et de les utiliser 			  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables de gestion de cet ensemble
		//*—*//
		
	    // —————— FIGURES
  	    // Conteneur des archives pour les figures
		public var Figures:Object = new Object();
		
		
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Les méthodes pour archiver les éléments
		//*—*//
		
	    // —————— NEW FIGURE GROUP
  	    // Créait un nouveau groupe d'élément
		
		public function NewFigureGroup( Nom:String ,		// ———— - - Nom du groupe
										Parametres:* = null	// ———— - - Parametres du groupe
									  ):void {
			/*—*/
			
			// Créait le groupe
			Figures[ Nom ] = new Object();
			
			// Intégre les paramètres au groupe
			Figures[ Nom ].Parametres = Parametres || new Object();
		}
	  
	  	
	  	// —————— NEW FIGURE
		// Archive un nouvel élément
		
		public function NewFigure( Groupe:String , 				// ———— - - Groupe de l'élément
								   Nom:String ,	   				// ———— - - Nom de l'élément
								   ElementsComposant:Object ,	// ———— - - Elements composants
								   Parametres:* = null			// ———— - - Les parametres de l'élément
								  ):void {
			/*—*/
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			
			// Si le groupe n'existe pas —— - - Créait ce groupe
			if( !Figures[ Groupe ] ){ NewFigureGroup( Groupe ); }
			
			// Créait l'élément
			Figures[ Groupe ][ Nom ] = Parametres;
			//
			Figures[ Groupe ][ Nom ].Figures = ElementsComposant;
		}
		
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Les méthodes pour créer et manipuler des éléments
		//*—*//
		
	  	// —————— ADD FIGURE
		// Créait un nouvel élément à partir d'une archive
		
		public function AddFigure( Groupe:String , 		// ———— - - Groupe de l'élément
								   Nom:String ,	   		// ———— - - Nom de l'élément
								   Conteneur:* = null ,	// ———— - - Conteneur de l'élément
								   Etat:* = null ,		// ———— - - Etats pour cet élément
								   LeNom:String = "" 	// ———— - - Nom de l'élément
								  ):* {
			/*—*/
			
			// Si le groupe existe —— - -
			if( Figures[ Groupe ] ){
				
				// Si l'élément existe —— - -
				if( Figures[ Groupe ][ Nom ] ){
				
					// Argument par défaut
					LeNom = ( LeNom != "" ) ? LeNom : Nom;
					// 
					// Si on a transmis aucun conteneur —— - -
					if( !Conteneur ){
						
						// S'il est archivé avec l'élément —— - - Le récupère
						if( Figures[ Groupe ][ Nom ].Conteneur ){
							//
							Conteneur = Figures[ Groupe ][ Nom ].Conteneur;
							
						// Sinon, S'il est archivé avec le groupe —— - - Le récupére
						} else if( Figures[ Groupe ].Parametres.Conteneur ){
							//
							Conteneur = Figures[ Groupe ].Parametres.Conteneur;
							
						// Sinon —— - - Trace l'erreur
						} else {
							//
							TraceError( "VisualProcess" , "Element" , [ "Vous n'avez transmis aucun conteneur pour l'élément " + Nom + " du groupe " + Groupe ,
																	   "Comme votre élément archivé ou son groupe ne contienne pas de conteneur eux-même" ,
																	   "l'élément ne pourra pas être créé" ] );
							//
							return null;
						}
					}
					
					// Créait l'élément
					var leNouvelElement:* = NewElement( Figures[ Groupe ][ Nom ].Figures ,
													    Conteneur , 
													    LeNom ,
													    Figures[ Groupe ].Parametres.Etat );
					
					// Applique les états d'éléments
					SetAll( leNouvelElement , Figures[ Groupe ][ Nom ].Etat );
					
					// Applique les états immédiats
					SetAll( leNouvelElement , Etat );
					
					// S'il y a une animation —— - -
					if( Figures[ Groupe ][ Nom ].Animation ){
						
						// Applique l'animation
						TotalApplyAnimation( leNouvelElement , Figures[ Groupe ][ Nom ].Animation );
					}
					
					// Retourne l'élément
					return leNouvelElement;
				
				// Si l'élément —— - - Trace l'erreur
				} else {
					//
					TraceError( "VisualProcess" , "Element" , "L'élément «" + Nom + "» n'existe pas dans le groupe " + Groupe + "." );
				}
			
			// Si le groupe n'existe pas —— - - Trace l'erreur
			} else {
				//
				TraceError( "VisualProcess" , "Element" , "Le groupe «" + Groupe + "» n'existe pas." );
			}
			
			// Retourne à vide au cas où
			return null;
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				   BUILDING						  		  				  */
		/*				  Méthodes permettant d'achiver des assemblage d'éléments et de les utiliser 			  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables de gestion de cet ensemble
		//*—*//
		
	    // —————— BUILDINGS
  	    // Conteneur des archives pour les buildings
		public var Buildings:Object = new Object();
		
		
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Les méthodes pour archiver les assemblages
		//*—*//
		
	    // —————— NEW BUILDING GROUP
  	    // Conteneur des archives pour les buildings
		
		public function NewBuildingGroup( Nom:String 	// ———— - - Le nom du groupe
										 ):void {
			/*—*/
			
			// S'il n'existe pas déjà —— - -
			if( !Buildings[ Nom ] ){
				
				// Créait le groupe
				Buildings[ Nom ] = new Object();
				
			// S'il existe déjà —— - - Trace l'erreur
			} else {
				//
				TraceError( "ElemenProcess" , "NewBuildingGroup" , "Le groupe \"" + Nom + "\" existe déjà." );
			}
		}
		
		
	    // —————— NEW BUILDING
  	    // Conteneur des archives pour les buildings
		
		public function NewBuilding( Groupe:String ,			// ———— - - Le Groupe du Building
									 Nom:String	,				// ———— - - Le nom du Building
									 Clip:* = null ,			// ¤¤—— - - La class de clip des éléments du Building
									 Construction:*	= null ,	// ¤¤—— - - Le mode de construction du Building
									 Etat:* = null ,			// ¤¤—— - - Les états des éléments du Building
									 Conteneur:* = null			// ———— - - Le Conteneur
									):void {
			/*—*/
					
			// Switch des arguments
			if( TypeOf( Clip , "Object" ) ){
				//
				Etat = Clip;
				Clip = null;
				
			} 
			//
			if( TypeOf( Clip , [ "MovieClip" , "MainTimeline" ] ) ){
				//
				Conteneur = Clip;
				Clip = null;
				//
			} else if( TypeOf( Construction , [ "MovieClip" , "MainTimeline" ] ) ){
				//
				Conteneur = Construction;
				Construction = null;
			}
			//
			if( Etat ){
				//
				if( Etat.Type ){
					//
					Construction = Etat;
					Etat = null;
				}
			}
			
			// Créait le groupe s'il n'existe pas
			if( !Buildings[ Groupe ] ){
				//
				NewBuildingGroup( Groupe );
			}
			
			// Créait l'objet de ce building
			var NouveauBuilding:Object = Buildings[ Groupe ][ Nom ] = new Object();
			
			// Donne au building ses paramètres
			NouveauBuilding.Clip = Clip;
			NouveauBuilding.Etat = Etat;
			NouveauBuilding.Construction = Construction;
		}
		
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Les méthodes pour créer et manipuler des assemblages
		//*—*//
		
	    // —————— ADD BUILDING
  	    // Intégrer un building
		
		public function AddBuilding( Groupe:String ,			// ———— - - Le Groupe du Building
									 Nom:String ,				// ———— - - Le Nom du Building
									 Clip:* = null ,			// ———— - - La Class de clip des éléments du Building
									 Construction:* = null ,	// ———— - - Le Mode de construction du Building
									 Etat:* = null ,			// ———— - - Les États des éléments du Building
									 Conteneur:* = null ,		// ———— - - Le Conteneur des éléments du Building
									 NomElement:String = ""		// ———— - - Le Nom des éléments du Building
									):Array {
			/*—*/
			
			/* —— - - ARGUMENTS - - —— */
			/**/
					
			// Switch des arguments
			if( TypeOf( Clip , "Object" ) ){
				//
				Etat = Clip;
				Clip = null;
				
			} else if( TypeOf( Clip , [ "MovieClip" , "MainTimeline" ] ) ){
				//
				Conteneur = Clip;
				Clip = null;
				
			} else if( TypeOf( Clip , "String" ) ){
				//
				NomElement = Clip;
				Clip = null;
			}
			//
			if( Construction ){
				//
				if( Construction.x || Construction.rotation ){
					//
					Etat = Construction;
					Construction = null;
				}
			}
			//
			if( Etat ){
				//
				if( Etat.Type ){
					//
					Construction = Etat;
					Etat = null;
				}
			}
			
			
			// Si le groupe existe —— - -
			if( Buildings[ Groupe ] ){
			
				// Si le Building existe —— - -
				if( Buildings[ Groupe ][ Nom ] ){
					
					// Récupère le Building
					var Building:Object = Buildings[ Groupe ][ Nom ];
					
					
					/* —— - - PARAMETRES - - —— */
					/**/
					
					// Récupère ses parametres
					var BuildingEtat:Object = CloneObject( Building.Etat ) || new Object();
					var BuildingConstruction:Object = CloneObject( Building.Construction ) || new Object();
					//
					var BuildingClip:* = Clip || Building.Clip;
					var BuildingConteneur:* = Conteneur || Building.Conteneur;
					var BuildingNom:* = ( NomElement != "" ) ? NomElement : BuildingNom;
					
					// Recompile les objets
					if( Etat ){ SetAll( BuildingEtat , Etat , { Aspiration:false } ); }
					if( Construction ){ SetAll( BuildingConstruction , Construction , { Aspiration:false } ); }
					
					
					/* —— - - VALEURS - - —— */
					/**/
					
					// Définit les valeurs pas défaut
					BuildingConstruction.type = BuildingConstruction.type || "Spot";
					BuildingConstruction.number = BuildingConstruction.number || 10;
					//
					BuildingConstruction.xPoint1 = BuildingConstruction.xPoint || BuildingConstruction.xPoint1 || 0;
					BuildingConstruction.yPoint1 = BuildingConstruction.yPoint || BuildingConstruction.yPoint1 || 0;
					//
					BuildingConstruction.xPoint2 = BuildingConstruction.xPoint2 || 0;
					BuildingConstruction.yPoint2 = BuildingConstruction.yPoint2 || 0;
					//
					BuildingConstruction.diameter = BuildingConstruction.diameter || 100;
					
					// Valeurs de positions
					var PositionX:Number = BuildingConstruction.xPoint1;
					var PositionY:Number = BuildingConstruction.yPoint1;
					
					// Valeur d'angle
					var Angle:Number = 0; 
					
					// Tableau de sortie
					var Sortie:Array = new Array();
					
					
					
					// Autant de fois qu'il faut d'élément —— - -
					for( var iNumber:int = 1 ; iNumber <= BuildingConstruction.number ; iNumber++ ){
						
						
						/* —— - - INTEGRATION - - —— */
						/**/
							
						// Créait l'objet de position
						var ObjetPosition:Object = new Object();
						
						// Intégre la position
						ObjetPosition.x = PositionX;
						ObjetPosition.y = PositionY;
						
						// S'il s'agit d'une construction en cercle —— - - 
						if( BuildingConstruction.type == "Circle" ){
							
							// Modifie la position en rapport à la direction de l'angle
							SetDirectionTo( ObjetPosition , BuildingConstruction.diameter , Angle );
						}
						
						// Modifie la position
						ObjetPosition.x += Aspiration( BuildingEtat.x || 0 );
						ObjetPosition.y += Aspiration( BuildingEtat.y || 0 );
						
						// Compile l'objet de position avec les états
						SetAll( ObjetPosition , BuildingEtat , [ "x" , "y" ] );
						
						// Intégre l'élément
						var NouvelElement:* = NewElement( BuildingClip , 
														  BuildingConteneur , 
														  BuildingNom + iNumber , 
														  ObjetPosition );
						
						// Donne à l'élément le tableau de sortie
						NouvelElement.Building = Sortie;
						
						// Donne à l'élément la méthode de destruction du building —— - -
						NouvelElement.DestroyBuilding = function():void {
							//
							// Pour chaque élément du building —— - -
							for( var iBuilding:int = 0 ; iBuilding < this.Building.length ; iBuilding++ ){
								//
								// Détruit l'élément si ce n'est pas lui
								if( this.Building[ iBuilding ].name != this.name ){
									//	
									DestroyElement( this.Building[ iBuilding ] );
								}
							}
							
							// Se détruit 
							DestroyElement( this );
						}
						
						// Ajoute l'élément à la sortie
						Sortie.push( NouvelElement );
						
						
						/* —— - - CALCUL - - —— */
						/**/
						
						// Récupère les points
						var ActuelPoint1X:Number = Aspiration( BuildingConstruction.xPoint1 );
						var ActuelPoint1Y:Number = Aspiration( BuildingConstruction.yPoint1 );
						//
						var ActuelPoint2X:Number = Aspiration( BuildingConstruction.xPoint2 );
						var ActuelPoint2Y:Number = Aspiration( BuildingConstruction.yPoint2 );
						
						// Suivant le type de construction —— - -
						//
						// LINE —— - -
						if( BuildingConstruction.type == "Line" ){
							
							// Modifie la position pour le prochain suivant la ligne
							PositionX += ( ActuelPoint2X - ActuelPoint1X ) / ( BuildingConstruction.number - 1 );
							PositionY += ( ActuelPoint2Y - ActuelPoint1Y ) / ( BuildingConstruction.number - 1 );
							
						// CIRCLE —— - - 
						} else if( BuildingConstruction.type == "Circle" ){
							
							// Modifie la position pour le prochain suivant l'angle
							Angle = ( 360 / BuildingConstruction.number ) * iNumber;
						}
					}
				
					// Renvoie la sortie
					return Sortie;
				
				}
				
				// Renvoie un tableau vide
				return [];
			}
				
			// Renvoie un tableau vide
			return [];
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					ANIMATION					  		  				  */
		/*						Méthodes permettant d'achiver des animations et de les utiliser 				  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables de gestion de cet ensemble
		//*—*//
		
	    // —————— ANIMATIONS
  	    // Conteneur des archives pour les animations
		public var Animations:Object = new Object();
		
		
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Les méthodes pour archiver les animations
		//*—*//
		
	    // —————— NEW ANIMATION GROUP
		// Créait un nouveau groupe d'animation
		
		public function NewAnimationGroup( Nom:String ,			// ———— - - Nom du groupe
										   Parametres:* = null	// ———— - - Parametres du groupe
										  ):void {
			/*—*/
			
			// Créait le groupe
			Animations[ Nom ] = new Object();
			
			// Intégre les paramètres au groupe
			Animations[ Nom ].Parametres = Parametres || new Object();
		}
	  	
		
	  	// —————— NEW ANIMATION
		// Archive un nouvel élément
		
		public function NewAnimation( Groupe:String , 				// ———— - - Groupe de l'animation
									  Nom:String ,	   				// ———— - - Nom de l'élément
									  AnimationsComposant:Object ,	// ———— - - Animations composants
									  Parametres:* = null			// ———— - - Les parametres de l'animation
									 ):void {
			/*—*/
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			
			// Si le groupe n'existe pas —— - - Créait ce groupe
			if( !Animations[ Groupe ] ){ NewAnimationGroup( Groupe ); }
			
			// Créait l'élément
			Animations[ Groupe ][ Nom ] = Parametres;
			//
			Animations[ Groupe ][ Nom ].Animation = AnimationsComposant;
		}
		
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Les méthodes pour créer et manipuler des animations
		//*—*//
		
	    // —————— APLY ANIMATION
		// Applique une nouvelle animation à partir d'une archive
		
		public function ApplyAnimation( Groupe:String , // ———— - - Groupe de l'animation
									    Nom:String , 	// ———— - - Nom de l'animation
									    Cible:*			// ———— - - Cible de l'animation
									  ):void {
			/*—*/
			
			// Si le groupe existe —— - -
			if( Animations[ Groupe ] ){
				
				// Si l'animation existe —— - -
				if( Animations[ Groupe ][ Nom ] ){
					
					// Applique l'animation
					Show.TimeLine( Cible , Animations[ Groupe ][ Nom ].Animation );
				
				// Si l'animation —— - - Trace l'erreur
				} else {
					//
					TraceError( "VisualProcess" , "Element" , "L'animation «" + Nom + "» n'existe pas dans le groupe " + Groupe + "." );
				}
			
			// Si le groupe n'existe pas —— - - Trace l'erreur
			} else {
				//
				TraceError( "VisualProcess" , "Animation" , "Le groupe «" + Groupe + "» n'existe pas." );
			}
		}
	  
	  	
	  	// —————— FULL ANIMATION
		// Applique un ensemble d'animation pour un clip et ses enfants
		
		public function TotalApplyAnimation( Cible:* ,			// ———— - - Cible initiale
											 Ensemble:Array		// ———— - - Tableau des animations transmisent
											):void {
			/*—*/
			
			// Pour chaque animation —— - -
			for( var i:int = 0 ; i < Ensemble.length ; i++ ){
					
				// S'il a toutes les clées —— - -
				if( TraceIfNotKey( Ensemble[ i ] , [ "Groupe" , "Nom" ] , "VisualProcess" , "FullAnimation" , "Animation n°" + i ) ){
					
					// La cible est égale à lui-même
					var CibleEnfant:* = Cible;
					
					// S'il y a un element —— - -
					if( Ensemble[ i ].Element ){
						
						// Si on trouve l'enfant recevant cette animation —— - -
						if( StringToElement( Ensemble[ i ].Element , Cible , false ) ){
							
							// Le récupère pour la cible
							CibleEnfant = StringToElement( Ensemble[ i ].Element , Cible );
						
						// Si on ne le trouve pas mais qu'on le trouve de façon générale —— - -
						} else if( GetTheChild( Cible , Ensemble[ i ].Element ) ) {
							
							// Le récupère pour la cible
							CibleEnfant = GetTheChild( Cible , Ensemble[ i ].Element );
						
						// Si on le trouve pas —— - - Trace l'erreur
						} else {
							//
							TraceError( "VisualProcess" , "FullAnimation" , 
										 [ "L'élément «" + Ensemble[ i ].Element + "» est introuvable sur la cible " + Cible.name + "." ,
										   "par défaut, c'est la cible immédiate qui le remplace. Pour éviter cette erreur si vous vouliez prendre la cible" ,
										   "pour cette animation, ne mettez pas de clé «Element»" ] );
						}
					}
						
					// Lui applique son animation
					ApplyAnimation( Ensemble[ i ].Groupe , Ensemble[ i ].Nom , CibleEnfant );
				}
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					ELEMENTS					  		  				  */
		/*							    Méthodes permettant d'agir sur des éléments isolés 				  		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - COPY - - —————————————————————————————————————————— */
		// Les méthodes permettant de copier des états, formes ou autres valeurs issues d'éléments
		//*—*//
		
		// —————— NEW COPY
		// Duplique un élément y comprit en prenant en considération ses événements et son intelligence
		
		public function NewCopy( Clip:* ,			// ———— - - Clip dupliqué
								 Cible:* = null ,	// ———— - - Le Conteneur
								 Nom:String = "" ,	// ———— - - Nouveau nom de la duplication
								 Etat:Object = null  // ———— - - Etats supplémentaires de la copy
							   ):* {
			/*—*/
			
			// Aruments par défaut
			Etat = Etat || new Object();
			Cible = Cible || Clip.parent;
			
			// Si on a choisit aucun nom —— - - Lui donne le même nom
			if( Nom == "" ){ Nom = Clip.name; }
			
			// Essaye —— - -
			try{
				
				// Créait un nouveau clip de sa classe
				var NouveauClip:* = NewElement( ElementToClass( Clip ) , Cible , Nom , Etat );
				
				// Ce nouveau clip se met en mimétisme pour les valeurs de formes
				CopyValue( NouveauClip , Clip );
				//
				// Ce nouveau clip se met en mimétisme pour les animations
				CopyAnimation( NouveauClip , Clip );
				//
				// Ce nouveau clip récupére les variables de son créateur
				SetAll( NouveauClip , Clip , [ "EvenementsImplantes" ] );
				//
				// Ce nouveau clip récupére les événements de son créateur
				CopyEvent( NouveauClip , Clip );
				
				// Renvoie le clip créé
				return NouveauClip;
				
			} catch( e ){ return null; }
		}
		
		
		// —————— COPY
		// Un clip copie un autre sur ses valeurs, ses animations et ses événements
		
		public function Copy( Clip:* ,				// ———— - - Objet récupérant les valeurs
							  Cible:* 			// ———— - - Cible mimée
							 ):void {
			/*—*/
			
			// Copie les valeurs
			CopyValue( Clip , Cible );
			
			// Copie les animations
			CopyAnimation( Clip , Cible );
			
			// Copie les événements
			CopyEvent( Clip , Cible );
		}
		
		
		// —————— COPY VALUE
		// Donne les mêmes valeurs qu'un certains objet ou clip à un autre, soit au choix, soit par défaut
		
		public function CopyValue( Clip:* ,				// ———— - - Objet récupérant les valeurs
								   Cible:* ,			// ———— - - Cible mimée
								   Extrait:Array = null	// ———— - - Éléments mimés
								 ):void {
			/*—*/
			
			// Lance le cumul de SetAll et d'ExtractAll pour faire le mimétisme
			SetAll( Clip , GetAll( Cible , Extrait ) );
		}
		
		
		// —————— COPY ANIMATION
		// Donne les mêmes positionnement des tête de lectures d'un clip sur un autre
		// ( Par contre, il faut que les empilements des enfants soient les même sinon ça ne fonctionne pas )
		
		public function CopyAnimation( Clip:* , 			// ———— - - Clip récupérant les modifications
									   Cible:* ,			// ———— - - Cible contenant les animations à mimer
									   laRacine:* = null	// ———— - - Racine total en cas de repassage
									  ):void {
			/*—*/
			
			// Calibre la racine par défaut pour le lancement de la fonction
			laRacine = ( TypeOf( laRacine , "global" ) ? Cible : laRacine );
			//
			// Positionne la tête de lecture du clip par rapport à la cible centrale
			Clip.gotoAndPlay( laRacine.currentFrame );
			
			// Pour chaque enfant du parent —— - -
			for( var i:int = 0 ; i < Cible.numChildren ; i++ ){
				
				// Récupére l'instance de l'enfant
				var leClip:* = Cible.getChildAt( i );
				
				// Essaye —— - -
				try{
					
					// Calibre la tête sur celle de la cible
					var TableauRecup:Array = ElementToArray( leClip , laRacine );
				
					// S'il ne possède pas "instance" dans son nom —— - -
					if( !FindIn( TableauRecup[ TableauRecup.length - 1 ] , "instance" ) ){
						
						// Retire le premier parent
						TableauRecup.shift();
						//
						// Positionne la tête de lecture du clip par rapport à la cible
						ArrayToElement( TableauRecup , Clip ).gotoAndPlay( leClip.currentFrame );
						//
						// Lance l'AnimaMimétisme à l'enfant
						CopyAnimation( Clip , leClip , laRacine );
					}
					
				} catch( e ){}
			}
		}
		
		
		// —————— COPY EVENT
		// Donne les mêmes événements d'un élément à un autre
		
		public function CopyEvent( Clip:* ,	// ———— - - Objet récupérant les événements
								   Cible:*	// ———— - - Cible mimée
								 ):void {
			/*—*/
			
			// Variables
			var Regroupe:Array = [];
			
			// Pour chaque événements implantés à la cible —— - -
			//for( var Evenement:* in Cible.EvenementsImplantes ){
				
				// Récupére l'event
				//AddEvents2( Clip , Cible.EvenementsImplantes[ Evenement ] );
			//}
			
			TraceError( "ElementProcess" , "CopyEvent" , 
					    "La fonction n'a pas été mise à jour au niveau de l'objet des événements" );
		}
		
		
		
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}