﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			 BRAIN PROCESS	  	   Version 1.4.0									***/
/***				   				   Dernière Mise à Jour : 10-08-28										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         			  Gestionnaire Intelligence											***/
/***	Ce script archive et gére des notions d'intelligence artificielle pour des éléments agissant seul   ***/
/***	ou par la gesion du joueur.																		 	***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Dynamic {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	
	// —— - - DISPLAY
	import flash.display.MovieClip;
	//
	// —— - - EVENT
	import flash.events.Event;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	import drOIde.Port.KeyboardPort;
	import drOIde.Port.MousePort;
	import drOIde.Dynamic.HitProcess;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class BrainProcess extends MiscTools {
		
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		// —————— ACTIVE
	    // Activité du BrainProcess
		public var Active:Boolean = true;
		
		
		// —————— FIRST END FUNCTION LIST
	    // Liste des méthodes qui se lance à deux reprises, en début et en fin
		public var FirstEndFunctionList:Array = [ "Shift" ];
		
		
		// —————— LINK
	    // Liaisons des scripts
		public var Mouse:*;
		public var Keyboard:*;
		public var Hit:*;
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function BrainProcess( TheLink:* = null ,		// ———— - - Lien vers la scène
									   LienMouse:* = null ,		// ———— - - La Souris
									   LienKeyboard:* = null ,	// ———— - - Le Clavier
									   LienHit:* = null			// ———— - - Le HitProcess
									  ):void {
			/*—*/
			
			// Lance la connexion
			Connexion( TheLink );
			
			// Établie s'il faut faire tout les liens
			if( LienMouse == true ){
				//
				var TotalConnect:Boolean = true;
				LienMouse = null;
			}
			
			// Récupération des instances des scripts
			Mouse = TotalConnect ? new MousePort( TheLink ) : LienMouse;
			Keyboard = TotalConnect ? new KeyboardPort( TheLink ) : LienKeyboard;
			Hit = TotalConnect ? new HitProcess( TheLink ) : LienHit;
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				 CHARACTER					  		  					  */
		/*							Méthodes de création et gestion de personnages entiers 					  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
		
		// —————— CHARACTERS
	    // L'Archive des personnages
		public var Characters:Object = new Object();
		
		// —————— SMART CHARACTERS
	    // La liste des personnages contrôlés par intelligences
		public var SmartCharacters:Object = new Object();
		
		
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Les méthodes pour sauvegarder des personnages
		//*—*//
		
		// —————— NEW CHARACTER GROUP
		// Créait un groupe de personnage
	  
		public function NewCharacterGroup( Nom:String ,				// ———— - - Nom du groupe
										   Parametres:Object = null	// ———— - - Parametres du groupe
										  ):void {
			/*—*/
			
			// Créait le groupe de personnage
			Characters[ Nom ] = new Object();
			
			// Donne les paramètres au groupe de personnages
			Characters[ Nom ].Parametres = Parametres || {};
		}
		
		
		// —————— NEW CHARACTER
		// Créait un personnage
	  
		public function NewCharacter( Groupe:String ,	// ———— - - Le Groupe
									  Nom:String ,		// ———— - - Nom d'archive du personnage
									  Parametres:Object	// ———— - - Les paramètres du monstre
								   ):void {
		  	/*—*/
			
			// Créait le groupe s'il n'existe pas
			if( !Characters[ Groupe ] ){
				//
				NewCharacterGroup( Groupe );
			}
			
			// Vérifie les clées de l'objet —— - -
			if( TraceIfNotKey( Parametres , [ "Class" , "Conteneur" ] , "BrainProcess" , "NewCharacter" , "Parametres" ) ){
				
				// Créait le personnage avec ses parametres
				Characters[ Groupe ][ Nom ] = Parametres;
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Les méthodes pour créer et manipuler les personnages
		//*—*//
		
		// —————— ADD CHARACTER
		// Créait un personnage à partir d'une archive
	  
		public function AddCharacter( Groupe:String ,		// ———— - - Groupe du personnage
									  Nom:String ,			// ———— - - Nom d'archive du personnage
									  Etat:Object = null	// ———— - - Etat du personnage
								    ):* {
			/*—*/
			
			// Récupère le personnage en question
			var CharacterObject:Object = Characters[ Groupe ][ Nom ];
			//
			// Ajoute à l'état transmis ses états initiaux
			var EtatTransmis:Object = CloneObject( CharacterObject.Etat || {} );
			//
			SetAll( EtatTransmis , Etat );
			SetAll( EtatTransmis , ( Characters[ Groupe ].Parametres.Etat || {} ) );
			
			// Récupère les valeurs de création du personnage
			var laClass:* = CharacterObject.Class
			var Conteneur:* = CharacterObject.Conteneur
			var Nom:String = Etat.name || CharacterObject.Nom
			var Etat:* = EtatTransmis
			var Boucle:* = CharacterObject.Boucle || Characters[ Groupe ].Parametres.Boucle
			var Intelligence:* = CharacterObject.Intelligence || Characters[ Groupe ].Parametres.Intelligence
			var HitTest:* = CharacterObject.HitTest || Characters[ Groupe ].Parametres.HitTest
			
			
			// Création du personnage
			var NouveauPersonnage:* = NewElement( laClass , Conteneur , Nom , Etat );
			
			// Tire un mot caractéristique aléatoire
			var MotCaracteristique:String = RandomWord();
			
			// S'il a une boucle —— - -
			if( Boucle ){
				
				// Si la boucle est un tableau —— - -
				if( TypeOf( Boucle , "Array" ) ){
				  
					// Essaye —— - -
					try {
					  
						// Si tout est correctement calibrée —— - -
						if( Boucle[ 0 ][ Boucle[ 1 ] ] ){
						  
							// Donne la boucle au personnage
							AddEvents( NouveauPersonnage , Boucle[ 0 ][ Boucle[ 1 ] ] , "ENTER_FRAME" );
						  
						// Sinon —— - -
						} else {
						  
							// Pour chaque Tableau du tableau —— - -
							for( var iBoucle:int = 0 ; iBoucle < Boucle.length ; iBoucle++ ){
							  
								// S'il est un tableau lui-même —— - -
								if( TypeOf( Boucle[ iBoucle ] , "Array" ) ){
									
									// Si tout est correctement calibrée —— - -
									if( Boucle[ iBoucle ][ 0 ][ Boucle[ iBoucle ][ 1 ] ] ){
									  
										// Donne la boucle au personnage
										AddEvents( NouveauPersonnage , Boucle[ iBoucle ][ 0 ][ Boucle[ iBoucle ][ 1 ] ] , "ENTER_FRAME" );
									}
								}
							}
						}
					  
					// Si échoue —— - - Trace l'erreur
					} catch( e ){
						//
						TraceError( "BrainProcess" , "NouveauPersonnage" , [ "L'argument «Boucle» doit être un tableau contenant :" ,
																			 "[ Cible de la fonction , Nom en string de la fonction ]" ] );
					}
				  
				// Sinon —— - - Trace l'erreur  
				} else {
					//
					TraceError( "BrainProcess" , "NouveauPersonnage" , [ "L'argument «Boucle» doit être un tableau contenant :" ,
																		 "[ Cible de la fonction , Nom en string de la fonction ]" ] );
				}
			}
			
			// S'il a une intelligence —— - -
			if( Intelligence ){
					  
				// Si tout est correctement calibrée —— - -
				if( TypeOf( Intelligence , "Array" ) ){
					//
					if( Intelligence[ 0 ] && Intelligence[ 1 ] ){
					
						// Applique l'intelligence
						ApplyBrain( Intelligence[ 0 ] , Intelligence[ 1 ] , NouveauPersonnage );
					  
					// Sinon —— - - Trace l'erreur
					} else {
						//
						TraceError( "BrainProcess" , "NouveauPersonnage" , [ "L'argument «Intelligence» doit être un tableau contenant :" ,
																			 "[ Groupe de l'intelligence , Nom de l'intelligence ]" ] );
					}
				  
				// Sinon —— - - Trace l'erreur
				} else {
					//
					TraceError( "BrainProcess" , "NouveauPersonnage" , [ "L'argument «Intelligence» doit être un tableau contenant :" ,
																		 "[ Groupe de l'intelligence , Nom de l'intelligence ]" ] );
				}
			}
			
			// S'il a un HitTest —— - -
			if( HitTest ){
				
				// S'il s'agit bien d'un objet —— - -
				if( TypeOf( HitTest , "Object" ) ){
					
					// S'il contient les clés voulues —— - -
					if( TraceIfNotKey( HitTest , [ "Nom" , "Type" , "Element" , "Fonction" ] , 
									 "BrainProcess" , "NouveauPersonnage" , "HitTest" ) ){
						
						// S'il possède un lien HitProcess —— - -
						if( Hit ){
							
							// Créait la collision
							Hit.CreationHitTest( ( HitTest.Nom || "" ) + NouveauPersonnage.name , 
											   HitTest.Type , 
											   HitTest.Element , 
											   ( HitTest.Interne ) ? 
												[ 
												  NouveauPersonnage.name + MotCaracteristique , 
												  StringToElement( HitTest.Interne , NouveauPersonnage ) ,
												  NouveauPersonnage
												]: 
												[ NouveauPersonnage.name + MotCaracteristique , NouveauPersonnage ] , 
											   HitTest.Fonction , 
											   HitTest.Parametres );
						  
						// Sinon —— - - Trace l'erreur
						} else {
							//
							TraceError( "BrainProcess" , "NouveauPersonnage" , 
										[ "Une demande de collision a été faites pour le personnage «" + 
										  NouveauPersonnage.name + "» sans que le lien HitProcess n'ait été donné." ,
										  "Pour ce faire, vous devez le rentrer en troisième arguments lors de la" ,
										  "création du BrainProcess :" ,
										  "var Player:BrainProcess = new BrainProcess( Mouse , Keyboard , Hit );" ] );
						}
					}
				
				// S'il s'agit d'un tableau —— - -
				} else if( TypeOf( HitTest , "Array" ) ){
				
					// Pour chaque élément du tableau —— - -
					for( var Hi:int = 0 ; Hi < HitTest.length ; Hi++ ){
						
						// S'il n'est pas null —— - -
						if( HitTest[ Hi ] ){
						
							  // S'il s'agit bien d'un objet —— - -
							  if( TypeOf( HitTest[ Hi ] , "Object" ) ){
								  
								  // S'il contient les clés voulues —— - -
								  if( TraceIfNotKey( HitTest[ Hi ] , [ "Nom" , "Type" , "Element" , "Fonction" ] , 
													 "BrainProcess" , "NouveauPersonnage" , "HitTest" ) ){
									  
									  // S'il possède un lien HitProcess —— - -
									  if( Hit ){
										  
										  // Créait la collision
										  Hit.CreationHitTest( ( HitTest[ Hi ].Nom || "" ) + NouveauPersonnage.name , 
															   HitTest[ Hi ].Type , 
															   HitTest[ Hi ].Element , 
															   ( HitTest[ Hi ].Interne ) ? 
																[ 
																  NouveauPersonnage.name + MotCaracteristique , 
																  StringToElement( HitTest[ Hi ].Interne , NouveauPersonnage ) ,
																  NouveauPersonnage
																] : 
																[ NouveauPersonnage.name + MotCaracteristique , NouveauPersonnage ] , 
															   HitTest[ Hi ].Fonction , 
															   HitTest[ Hi ].Parametres );
										  
									  // Sinon —— - - Trace l'erreur
									  } else {
										  //
										  TraceError( "BrainProcess" , "NouveauPersonnage" , 
													  [ "Une demande de collision a été faites pour le personnage «" + 
														 NouveauPersonnage.name + "» sans que le lien HitProcess n'ait " + 
														 "été donné." ,
														 "Pour ce faire, vous devez le rentrer en troisième arguments " + 
														 "lors de la" ,
														 "création du BrainProcess :" ,
														 "var Player:BrainProcess = new BrainProcess( Mouse , " + 
														 "Keyboard , Hit );" ] );
									  }
								  }
							  }
						  }
					}
				
				// Sinon —— - - Trace l'erreur
				} else {
				  //
				  TraceError( "BrainProcess" , "NouveauPersonnage" , [ "L'argument «HitTest» doit être un objet contenant les clés :" ,
																		 "Nom, Type, Element et Fonction ou un Tableau contenant une série d'objet." ] );
				}
			}
			
			// Retourne le personnage
			return NouveauPersonnage;
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				 	 BRAIN					  		  					  */
		/*						Méthodes pour donner un cerveau, ensemble de savoir, à un élément 				  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
		
		// —————— BRAINS
	    //— L'Archive des intelligences
		public var Brains:Object = new Object();
		
		
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Les méthodes pour sauvegarder de nouveau cerveaux
		//*—*//
		
		// —————— NEW BRAIN GROUP
		// Ajoute un nouveau groupe d'intelligences
	  
		public function NewBrainGroup( Nom:String 	// ———— - - Le Nom du groupe
									  ):void {
			/*—*/
			
			// Créait ce nouveau groupe
			Brains[ Nom ] = new Object();
		}
	  
	  
		// —————— NEW BRAIN
		// Ajoute une nouvelle intelligence
	  
		public function NewBrain( Groupe:String ,		// ———— - - Le Groupe
								  Nom:String ,			// ———— - - Le Nom de l'intelligence
								  Intelligence:Object	// ———— - - Le Contenu de l'intelligence
								):void {
			/*—*/
			
			// Si le groupe n'existe pas —— - - Créait ce groupe
			if( !Brains[ Groupe ] ){ NewBrainGroup( Groupe ); }
			
			// Créait cette nouvelle intelligence
			Brains[ Groupe ][ Nom ] = Intelligence;
		}
	  	
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Les méthodes pour appliquer ou modifier des cerveaux sur des éléments
		//*—*//
		
		// —————— APPLY BRAIN
		// Applique une intelligence sur un élément
	  
		public function ApplyBrain( Groupe:String ,					// ———— - - Le Groupe
								  Nom:String ,						// ———— - - Le Nom de l'intelligence
								  Element:* ,						// ———— - - L'Élément qui acquiert l'intelligence
								  Parametres:Object = null ,		// ———— - - Les Parametres additifs
								  NomIntelligence:String = "Intel"	// ———— - - Le Nom de l'intelligence
							   ):void {
			/*—*/
			
			// Si le groupe existe —— - -
			if( Brains[ Groupe ] ){ 
			
				// Si l'intelligence existe —— - -
				if( Brains[ Groupe ][ Nom ] ){ 
					
					// Définie l'objet d'intelligence
					var NewIntelligence:Object = CloneObject( Brains[ Groupe ][ Nom ] );
					
					// Pour chaque paramètres transmis —— - -
					for( var ParamTransmi:* in Parametres ){
					
						// Pour chaque intelligence —— - -
						for( var Int:* in NewIntelligence ){
							
							// Pour chaque parametres de l'intelligence —— - -
							for( var Param:* in NewIntelligence[ Int ] ){
								
								// S'il est le même —— - -
								if( ParamTransmi == Param ){
									
									// Il est modifié sur l'intelligence
									NewIntelligence[ Int ][ Param ] = Parametres[ ParamTransmi ];
								}
							}
						}   
					}
					
					// Donne le cerveau à l'élément
					ApplyMultiKnowledge( Element , NewIntelligence , NomIntelligence );
				
				// Si l'intelligence n'existe pas —— - - Trace l'erreur
				} else { TraceError( "BrainProcess" , "ApplyBrain" , "L'intelligence «" + Nom + "» n'existe pas." ); }
			
			// Si le groupe n'existe pas —— - - Trace l'erreur
			} else { TraceError( "BrainProcess" , "ApplyBrain" , "Le groupe «" + Groupe + "» n'existe pas." ); }
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				 KNOWLEDGE					  		  					  */
		/*								Méthodes pour donner un savoir à un élément 					  	  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Les méthodes pour appliquer ou retirer un savoir à un élément
		//*—*//
		
		// —————— APPLY MULTI KNOWLEDGE
		// Donne un ensemble d'intelligence à un élément
		
		public function ApplyMultiKnowledge( Element:* ,						// ———— - - L'Élément acquérant l'intelligence
											 Intelligences:Object ,				// ———— - - Les intelligences données
											 NomIntelligence:String = "Intel"	// ———— - - le nom de l'intelligence
										   ):void {
			/*—*/
		  
			// Pour chaque intelligence —— - -
			for( var Int:* in Intelligences ){
			  
				// Donne cette intelligence à l'élément
				ApplyKnowledge( Element , Int , Intelligences[ Int ] , NomIntelligence );
			}
		}
		
		
		// —————— APPLY KNOWLEDGE
		// Donne l'intelligence à l'élément
	  
		public function ApplyKnowledge( Element:* ,							// ———— - - L'Élément acquérant l'intelligence
										Intelligence:String ,				// ———— - - L'Intelligence donnée à l'élément
										Parametres:Object = null ,			// ———— - - Les Paramètres de son intelligence
										NomIntelligence:String = "Intel"	// ———— - - Le Nom de l'intelligence
									  ):void {
			/*—*/
			
			/* —— - - INITIALISATION - - —— */
			/**/
			
			// Arguments par défaut 
			Parametres = Parametres || {};
			
			// Donne l'élément aux paramètres
			Parametres.Element = Parametres.Element || Element;
			
			// S'il n'en a pas déjà un, donne à l'élément son objet d'intelligence
			Element.Brain = Element.Brain || new Object();
			//
			// Donne à l'objet d'intelligence de l'élément la nouvelle intelligence
			Element.Brain[ Intelligence ] = Parametres;
			
			// Donne à l'élément les vitesses qu'il n'aurait pas déjà
			Element.Brain.speed = Element.Brain.speed || 0;
			Element.Brain.speedX = Element.Brain.speedX || 0;
			Element.Brain.speedY = Element.Brain.speedY || 0;
			Element.Brain.speedRotation = Element.Brain.speedRotation || 0;
			Element.Brain.speedHeight = Element.Brain.speedHeight || 0;
			Element.Brain.speedWidth = Element.Brain.speedWidth || 0;
			
			// Donne à l'élément les parametres qu'il n'aurait pas déjà
			Element.Brain.directionX = Element.Brain.directionX || "Droite";
			Element.Brain.directionY = Element.Brain.directionY || "Haut";
			//
			Element.Brain.MemoX = new Object();
			Element.Brain.MemoY = new Object();
			//
			Element.Brain.MemoX.StandardX = Element.x;
			Element.Brain.MemoY.StandardY = Element.y;
			
			// Récupére l'instance du BrainProcess
			Element.Brain.BrainProcess = this;
			
			
			/* —— - - ACTION - - —— */
			/**/
			
			// Si l'élément n'a pas encore sa méthode pour transférer ses méthodes d'actions
			if( !Element.Action ){
			  
				// Lui donne sa méthode de transfére d'action —— - -
				Element.Action = function( Transfere:String , Arguments:Object = null ){
				  
					// Essaye —— - -
					try { 
					
						// Transfére d'action par argument
						if( Arguments ){ Element.Brain.BrainProcess[ Transfere ]( Element , Arguments ); }
						//
						// Transfére d'action sans argument
						else { Element.Brain.BrainProcess[ Transfere ]( Element ); }
					  
					// Si échoue —— - -
					} catch( e ){
					  
						// Trace l'erreur
						TraceError( "BrainProcess" , "Action sur " + Element.name , [ "Impossible de lancer la méthode «" + Transfere + "»." ] );
					}
				}
			}
			
			
			/* —— - - KEYBOARD - - —— */
			/**/
			
			// Si on a définit des appels de touches —— - -
			if( Parametres.Keyboard ){
			  
				// Pour chaque touche —— - -
				for( var Touche:* in Parametres.Keyboard ){
					
					// Donne l'appel d'événement de la touche
					Keyboard.NewKeyEvent( Element.name + RandomWord() + Touche ,
										  //
										  Touche ,
										  //
										 { 
										   Cible:this ,
										   Fonction:( ( !TypeOf( Parametres.Keyboard[ Touche ] , "String" ) ) ? 
										  Parametres.Keyboard[ Touche ].Touche : Parametres.Keyboard[ Touche ] ) ,
										   Argument:Parametres
										 } ,
										 //
										 ( ( !TypeOf( Parametres.Keyboard[ Touche ] , "String" ) ) ? 
										  Parametres.Keyboard[ Touche ].Appuie : 0 ) ,
										 //
										 Element ,
										 //
										 Parametres.keyState || "Appuie"
										);
				}
			}
			
			
			/* —— - - PARAMETRES - - —— */
			/**/
			
			// Traite les parametres de l'intelligences
			TreatKnowledge( Element.Brain , Element );
			
			
			/* —— - - LOOP - - —— */
			/**/
			
			// Si l'élément n'a pas encore sa boucle —— - -
			if( !Element.Brain.BouclePlayer ){
			  
				// Constemment —— - -
				Element.Brain.BouclePlayer = KnowledgeLoop;
				//
				// Donne l'événément de boucle à l'élément
				AddEvents( Element , Element.Brain.BouclePlayer , "ENTER_FRAME" , "BrainLoop" );
				
				// Transfere l'élément dans le Control
				SmartCharacters[ NomIntelligence ] = SmartCharacters[ NomIntelligence ] || new Array();
				//
				SmartCharacters[ NomIntelligence ].push( Element );
			}
		}
		//
		// —————— KNOWLEDGE LOOP
		// Boucle d'intelligence
		public function KnowledgeLoop( event:Event ):void {
			/*—*/
			
			// Récupére l'instance de l'élément
			var Cible:* = event.target;
			var Element:* = Cible;
			
			// Si on a le lien du BrainProcess —— - -
			if( Cible.Brain.BrainProcess ){
			  
				// Si on est Active —— - -
				if( Cible.Brain.BrainProcess.Active ){
				
				
					/* —— - - DEBUT - - —— */
					/**/
					
					// Pour chaque intelligence de démarrage de l'élément —— - -
					for( var KeyD:* in Cible.Brain ){
					  
						// Essaye —— - -
						try{
						
							// Donne et augmente sa valeur de framing de ce mouvement
							Cible.Brain[ KeyD ].Temps = Cible.Brain[ KeyD ].Temps || 0;
							//
							Cible.Brain[ KeyD ].Temps++;
							
							// Si elle est de démarrage ou est listé en tans que méthode Debut/Fin —— - -
							if( Cible.Brain[ KeyD ].Debut || IndexOf( FirstEndFunctionList , KeyD ) ){
							  
								// Si elle ne doit pas être lancée sur un élément particulier —— - -
								if( !Cible.Brain[ KeyD ].Cible ){
								  
									// Calibre en tans que Début
									Cible.Brain[ KeyD ].EtatLancement = "Debut";
									
									// Si elle ne comprend pas d'underscore —— - -
									if( !FindIn( KeyD , "_" ) ){
									  
										// Essaye de lancer l'action de l'intelligence
										try{ Cible.Brain.BrainProcess[ KeyD ]( Cible , Cible.Brain[ KeyD ] );
										  
										} catch( e ){}
										
									// Si elle comprend un underscore —— - -
									} else {
									  
										// Essaye de lancer l'action de l'intelligence en ommettant ce qui se trouve après l'underscore
										try{ Cible.Brain.BrainProcess[ KeyD.split( "_" )[ 0 ] ]( Cible , Cible.Brain[ KeyD ] );
										  
										} catch( e ){}
									}
								  
								// Si elle doit être lancée sur un élément particulier —— - -
								} else {
								  
									// Essaye de lancer l'action sur la cible
									try{ Cible.Brain[ KeyD ].Cible[ KeyD ]();
									  
									} catch( e ){}
								}
							}
						} catch( e ){}
					}
				  
				  
					// Si l'élément n'a pas de retardement —— - -
					if( !Element.Brain.Countdown ){
			
			
						/* —— - - MILIEU - - —— */
						/**/
					  
						// Pour chaque intelligence de l'élément —— - -
						for( var KeyIn:* in Cible.Brain ){
						  
							// Essaye —— - -
							try{
							
								// Si elle n'est ni de fin, ni de démarrage et n'est pas listée en tans que méthde Debut/Fin —— - -
								if( !Cible.Brain[ KeyIn ].Fin && !Cible.Brain[ KeyIn ].Debut && !IndexOf( FirstEndFunctionList , KeyIn ) ){
									
									// Si elle ne doit pas être lancée sur un élément particulier —— - -
									if( !Cible.Brain[ KeyIn ].Cible ){
									  
										// Calibre en tans que milieu
										Cible.Brain[ KeyIn ].EtatLancement = "Milieu";
										
										// Si elle ne comprend pas d'underscore —— - -
										if( !FindIn( KeyIn , "_" ) ){
										  
											// Essaye de lancer l'action de l'intelligence
											try{ Cible.Brain.BrainProcess[ KeyIn ]( Cible , Cible.Brain[ KeyIn ] );
											  
											} catch( e ){}
										
										// Si elle comprend un underscore —— - -
										} else {
										  
											// Essaye de lancer l'action de l'intelligence en ommettant ce qui se trouve après l'underscore
											try{ Cible.Brain.BrainProcess[ KeyIn.split( "_" )[ 0 ] ]( Cible , Cible.Brain[ KeyIn ] );
											  
											} catch( e ){}
										}
									  
									// Si elle doit être lancée sur un élément particulier —— - -
									} else {
									  
										// Essaye de lancer l'action sur la cible
										try{ Cible.Brain[ KeyIn ].Cible[ KeyIn ]();
										  
										} catch( e ){}
									}
								}
							} catch( e ){}
						}
			
			
						/* —— - - FIN - - —— */
						/**/
					  
						// Pour chaque intelligence de fin de l'élément —— - -
						for( var KeyF:* in Cible.Brain ){
						  
							// Essaye —— - -
							try {
							  
								// Si elle est de fin ou est listé en tans que méthde Debut/Fin —— - -
								if( Cible.Brain[ KeyF ].Fin || IndexOf( FirstEndFunctionList , KeyF ) ){
								  
									// Si elle ne doit pas être lancée sur un élément particulier —— - -
									if( !Cible.Brain[ KeyF ].Cible ){
									  
										// Calibre en tans que fin
										Cible.Brain[ KeyF ].EtatLancement = "Fin";
										
										// Si elle ne comprend pas d'underscore —— - -
										if( !FindIn( KeyF , "_" ) ){
										  
											// Essaye de lancer l'action de l'intelligence
											try { Cible.Brain.BrainProcess[ KeyF ]( Cible , Cible.Brain[ KeyF ] );
											  
											} catch( e ){}
										
										// Si elle comprend un underscore —— - -
										} else {
										  
											// Essaye de lancer l'action de l'intelligence en ommettant ce qui se trouve après l'underscore
											try{ Cible.Brain.BrainProcess[ KeyF.split( "_" )[ 0 ] ]( Cible , Cible.Brain[ KeyF ] );
											  
											} catch( e ){}
										}
									  
									// Si elle doit être lancée sur un élément particulier —— - -
									} else {
									  
										// Essaye de lancer l'action sur la cible
										try{ Cible.Brain[ KeyF ].Cible[ KeyF ]();
										  
										} catch( e ){}
									}
								}
							} catch( e ){}
						}
			
			
						/* —— - - CALIBRAGE - - —— */
						/**/
					  
						// Aspire chaque vitesse et les convertie en chiffre
						Cible.Brain.speedX = Number( Aspiration( Cible.Brain.speedX ) );
						Cible.Brain.speedY = Number( Aspiration( Cible.Brain.speedY ) );
						//
						Cible.Brain.speedFront = Number( Aspiration( Cible.Brain.speedFront ) );
						Cible.Brain.speedRotation = Number( Aspiration( Cible.Brain.speedRotation ) );
						//
						Cible.Brain.speedHeight = Number( Aspiration( Cible.Brain.speedHeight ) );
						Cible.Brain.speedWidth = Number( Aspiration( Cible.Brain.speedWidth ) );
						
						// Modifie la position de l'élément suivant ses vitesses de positions
						Cible.x += Cible.Brain.speedX;
						Cible.y += Cible.Brain.speedY;
						
						// Modifie la rotation de l'élément suivant ses vitesses de rotations
						Cible.rotation += Cible.Brain.speedRotation;
						
						// Modifie la taille de l'élément suivant ses vitesses de tailles
						Cible.height = SetRealScale( Cible , "+" + Cible.Brain.speedHeight , "height" );
						Cible.width = SetRealScale( Cible , "+" + Cible.Brain.speedHeight , "width" );
						
						// Vérifie la direction pour le faire se retourner le cas échéant
						if( Cible.Brain.directionX == "Gauche" ){ Cible.scaleX = -1; }
						if( Cible.Brain.directionY == "Bas" ){ Cible.scaleY = -1; }
			
			
						/* —— - - LOCK - - —— */
						/**/
					  
						// Pour chaque intelligence lock de l'élément —— - -
						for( var KeyLock:* in Cible.BrainLock ){
						 
							// Essaye —— - -
							try{
							  
								// Si elle ne doit pas être lancée sur un élément particulier —— - -
								if( !Cible.BrainLock[ KeyLock ].Cible ){
								
									// Essaye de lancer l'action de l'intelligence
									try{ Cible.Brain.BrainProcess[ KeyLock ]( Cible , Cible.BrainLock[ KeyLock ] );
									  
									} catch( e ){}
									
								// Si elle doit être lancée sur un élément particulier —— - -
								} else {
								  
									// Essaye de lancer l'action sur la cible
									try{ Cible.BrainLock[ KeyLock ].Cible[ KeyLock ]();
									
									} catch( e ){}
								}
							} catch( e ){}
						}
			
			
						/* —— - - MEGA LOCK - - —— */
						/**/
					  
						// Pour chaque intelligence MegaLock de l'élément —— - -
						for( var KeyMegaLock:* in Cible.BrainMegaLock ){
						
							// Essaye —— - -
							try{
							  
								// Si elle ne doit pas être lancée sur un élément particulier —— - -
								if( !Cible.BrainMegaLock[ KeyMegaLock ].Cible ){
									
									// Essaye de lancer l'action de l'intelligence
									try{ Cible.Brain.BrainProcess[ KeyMegaLock ]( Cible , Cible.BrainMegaLock[ KeyMegaLock ] );
									  
									} catch( e ){}
								  
								// Si elle doit être lancée sur un élément particulier —— - -
								} else {
								  
									// Essaye de lancer l'action sur la cible
									try{ Cible.BrainMegaLock[ KeyMegaLock ].Cible[ KeyMegaLock ]();
									  
									} catch( e ){}
								}
							} catch( e ){}
						}
					}
				}
			}
		}
	  
	  
		// —————— TREAT KNOWLEDGE
		// Traite les parametres d'une intelligence appliqué à un élément
	  
		private function TreatKnowledge( Objet:Object ,		// ———— - - Objet transmis
									     Element:* 			// ———— - - Élement contenant
									   ):void {
			/*—*/
			
			// Pour chaque parametres —— - -
			for( var i:* in Objet ){
			  
				// Convertie le type
				if( !isNaN( Number( Objet[ i ] ) ) ){ Objet[ i ] = Number( Objet[ i ] ); }
				
				// S'il contient *Nom* —— - - Le convertie pour son nom
				if( FindIn( String( Objet[ i ] ) , "*Nom*" ) ){ Objet[ i ] = CharacterConversion( Objet[ i ] , "*Nom*" , Element.name ); }
				
				// S'il est un objet ou un tableau —— - -
				if( TypeOf( Objet[ i ] , "Object" ) || TypeOf( Objet[ i ] , "Array" ) ){
				
					// Il envoie à traiter le niveau suivant
					TreatKnowledge( Objet[ i ] , Element );
				}
			}
		}
		
		
		// —————— REMOVE KNOWLEDGE
		// Retire l'intelligence à l'élément
	  
		public function RemoveKnowledge( Element:* ,					// ———— - - L'Élément perdant l'intelligence
									     Intelligence:String = "All" , 	// ———— - - L'Intelligence retiré à l'élément
									     Variables:* = null ,			// ———— - - Les Autres variables retirées à l'éléments
									     Preserve:* = null				// ———— - - Les Variables à préservés de la destruction
									   ):void {
			/*—*/
			
			// Si on a transmis une demande de destruction de variables —— - -
			if( Variables ){
			  
				// Si la demande est en string, convertie en tableau
				if( TypeOf( Variables , "String" ) ){ Variables = [ Variables ]; }
				
				// Pour chaque variables —— - -
				for( var j:int = 0 ; j < Variables.length ; j++ ){
				  
					// Si on a transmis une demande pour toutes les vitesse —— - -
					if( Variables[ j ] == "All Vitesse" ){
					  
						// Donne toutes les vitesses au tableau
						Variables = FusionArray( Variables , [ "Vitesse" , "speedX" , "speedY" , "speedRotation" , "speedWidth" , "speedHeight" ] );
					}
				}
				
			// Si on a transmis aucune demande de destruction de variables —— - - Donne un tableau par défaut
			} else { Variables = new Array(); }
			
			// Préserve par défaut
			Preserve = Preserve || new Array();
			
			// Fait passer l'intelligence à null
			Element.Brain[ Intelligence ] = null;
			
			// Pour chaque variables à détruire —— - - Fait passer la variables à null
			for( var i:int = 0 ; i < Variables.length ; i++ ){ Element.Brain[ Variables[ i ] ] = null; }
			
			
			// Pour une destruction « Absolut » —— - -
			if( Intelligence == "Absolut" ){
			  
				// Retire l'événément de boucle à l'élément
				RemoveEvents( Element , Element.Brain.BouclePlayer , "ENTER_FRAME" , "BrainLoop" );
			}
			
			
			// Pour une destruction « All » ou « Absolut » d'intelligence —— - - 
			if( Intelligence == "All" || Intelligence == "Absolut" ){
			  
				// Pour chaque éléments du Brain de l'élément —— - - 
				for( var Key in Element.Brain ){ 
				
					// Si ce n'est pas la boucle d'intelligence ou bien qu'on a demandé une destruction totale et si ce n'est pas une variable préservé —— - -
					if( Key != "BouclePlayer" || Intelligence == "Absolut" ){
						//
						if( !IndexOf( Preserve , Key ) ){
						
							// Le fait passer à null
							Element.Brain[ Key ] = null; 
						}
					}
				}
			}
		}
		
		
		// —————— REFRESH ALL KNOWLEDGE
		// Retire un ensemble d'intelligences
	  
		public function RefreshAllKnowledge( Nom:String = "Intel" 	// ———— - - Nom du Savoir à rafraichir
										  ):void {
			/*—*/
			
			// Si le groupe nommé existe —— - -
			if( SmartCharacters[ Nom ] ){
			  
				// Pour chaque élément comprit —— - -
				for( var i:int = 0 ; i < SmartCharacters[ Nom ].length ; i++ ){
				  
					// S'il existe —— - -
					if( SmartCharacters[ Nom ][ i ] ){
						
						// Retire son intelligence
						RemoveEvents( SmartCharacters[ Nom ][ i ] , SmartCharacters[ Nom ][ i ].Brain.BouclePlayer , "ENTER_FRAME" , "BrainLoop" );
					}
				}
				
				// Mes à null le groupe
				SmartCharacters[ Nom ] = null;
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				 	 INITIAL					  		  				  */
		/*						   Méthodes de savoir au déclanchement unique au commencement 				  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VALUE - - —————————————————————————————————————————— */
		// Les méthodes pour appliquer des valeurs
		//*—*//
		
		// —————— TRANSFER
		// Donne une valeur à l'objet Brain
	  
		public function Transfer( Clip:* ,			// ———— - - L'Élément
								  Parametres:Object	// ———— - - Les Parametres
								 ):void {
			/*—*/
		  
			// Pour chaque élément à transférer
			for( var i:* in Parametres ){
			  
				// Le transfère
				Clip.Brain[ i ] = Aspiration( Parametres[ i ] );
			}
			
			// Retire la méthode
			Clip.Brain.Transfer = null;
		}
		
		
		
		/* —————————————————————————————————————————— - - TIMING - - —————————————————————————————————————————— */
		// Les méthodes pour modifier l'application de l'intelligence dans le temps
		//*—*//
		
		// —————— COUNTDOWN
		// L'élément patiente un certains temps avant de démarer ses mouvements centrals
	  
		public function Countdown( Clip:* ,				// ———— - - L'Élément
								   Parametres:Object	// ———— - - Les Parametres
								 ):void {
			/*—*/
			
			// Parametres par défaut
			var Palier:Number = Aspiration( Parametres.time , 1 );
			
			// Le Temps réduit
			Clip.Brain.Countdown.Retard -= Palier;
			
			// S'il a atteint zéro —— - - Il est retiré
			if( Clip.Brain.Countdown.Retard <= 0 ){ 
				//
				Clip.Brain.Countdown = null;
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				 	 LOOP					  		  				  	  */
		/*						   Méthodes ayant un déclanchement en boucle par le cerveau 				  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - LAUNCH - - —————————————————————————————————————————— */
		// Les méthodes pour lancer des fonctions particulières
		//*—*//
		
		// —————— LAUNCHING
		// Lance une fonction parametrées
	  
		public function Launching( Parametres:Object 	// ———— - - Les Parametres
								  ):void {
		 	/*—*/
		 
			// Parametres par défaut
			var Element:* = Parametres.Element;
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
			
				// Lance la fonction
				Launch( Parametres.Fonction );
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - POSITION - - —————————————————————————————————————————— */
		// Les méthodes pour modifier la position de l'élément
		//*—*//
		
		// —————— MOVE DIRECT
		// L'élément se déplace dans une direction
	  
		public function MoveDirect( Clip:* ,			// ———— - - L'Élément
								    Parametres:Object	// ———— - - Les Parametres
							      ):void {
		  	/*—*/
			
			// Parametres par défaut
			var X:Number = Aspiration( Parametres.x , 0 );
			var Y:Number = Aspiration( Parametres.y , 0 );
			
			// Déplacement de l'élément dans la direction
			Clip.x += X;
			Clip.y += Y;
		}
		
		
		// —————— MOVE SPEED
		// La vitesse de l'élément évolue dans une direction
	  
		public function MoveSpeed( Clip:* ,				// ———— - - L'Élément
								   Parametres:Object	// ———— - - Les Parametres
							     ):void {
			/*—*/
			
			// Parametres par défaut
			var X:Number = Aspiration( Parametres.x , 0 );
			var Y:Number = Aspiration( Parametres.y , 0 );
			
			// Déplacement de l'élément dans la direction
			Clip.Brain.speedX += X;
			Clip.Brain.speedY += Y;
		}
		
		
		// —————— MOVE FRONT
		// L'élément avance ou recule en fonction de son regard
	  
		public function MoveFront( Clip:* ,				// ———— - - L'Élément
							       Parametres:Object	// ———— - - Les Parametres
							     ):void {
		  	/*—*/
			
			// Parametres par défaut
			var Decalage:Number = Aspiration( Parametres.shift , 0 );
			var Vitesse:Number = Aspiration( Parametres.speed , 0 );
			
			// L'élément bouge dans sa direction selon sa vitesse générale
			SetDirectionTo( Clip , Clip.Brain.speed + Vitesse , Clip , Decalage );
		}
		
		
		// —————— CHAOS DIRECT
		// Chaos de placement de l'élément
	  
		public function ChaosDirect( Clip:* ,				// ———— - - L'Élément
									 Parametres:Object		// ———— - - Les Parametres
								   ):void {
			/*—*/
			
			// Parametres par défaut
			var X:Number = Aspiration( Parametres.x , 0 );
			var Y:Number = Aspiration( Parametres.y , 0 );
			var Rotation:Number = Aspiration( Parametres.rotation , 0 );
			//
			var MinX:Number = Aspiration( Parametres.xMin , -X );
			var MaxX:Number = Aspiration( Parametres.xMax , X );
			//
			var MinY:Number = Aspiration( Parametres.yMin , -Y );
			var MaxY:Number = Aspiration( Parametres.yMax , Y );
			//
			var MinR:Number = Aspiration( Parametres.rotationMin , -Rotation );
			var MaxR:Number = Aspiration( Parametres.rotationMax , Rotation );
			
			// Bump de la position
			Clip.x += Random( MinX , MaxX );
			Clip.y += Random( MinY , MaxY );
			Clip.rotation += Random( MinR , MaxR );
		}
		
		
		// —————— CHAOS SPEED
		// Chaos de la vitesse de l'élément
	  
		public function ChaosSpeed( Clip:* ,				// ———— - - L'Élément
									Parametres:Object		// ———— - - Les Parametres
								   ):void {
		  	/*—*/
			
			// Parametres par défaut
			var X:Number = Aspiration( Parametres.x , 0 );
			var Y:Number = Aspiration( Parametres.y , 0 );
			var Rotation:Number = Aspiration( Parametres.rotation , 0 );
			//
			var MinX:Number = Aspiration( Parametres.xMin , -X );
			var MaxX:Number = Aspiration( Parametres.xMax , X );
			//
			var MinY:Number = Aspiration( Parametres.yMin , -Y );
			var MaxY:Number = Aspiration( Parametres.yMax , Y );
			//
			var MinR:Number = Aspiration( Parametres.rotationMin , -Rotation );
			var MaxR:Number = Aspiration( Parametres.rotationMax , Rotation );
			
			// Donne la modification
			Clip.Brain.speedX += Random( MinX , MaxX );
			Clip.Brain.speedY += Random( MinY , MaxY );
			Clip.Brain.speedRotation += Random( MinR , MaxR );
		}
		
		
		// —————— BRAKE
		// L'élément freine automatiquement sa vitesse
	  
		public function Brake( Clip:* ,				// ———— - - L'Élément
							   Parametres:Object	// ———— - - Les Parametres
							):void {
		  	/*—*/
			
			// Parametres par défaut
			var Frein:Number = Aspiration( Parametres.strength , 95 );
			//
			var FreinX:Number = Aspiration( Parametres.strengthX , 100 );
			var FreinY:Number = Aspiration( Parametres.strengthY , 100 );
			//
			var FreinRotation:Number = Aspiration( Parametres.strengthRotation , 95 );
			var FreinTaille:Number = Aspiration( Parametres.strengthSize , 95 );
			  
			// Freine la vitesse générale
			Clip.Brain.speed *= Frein / 100;
			
			// Freine la vitesse de position
			Clip.Brain.speedX *= ( Frein / 100 ) * ( FreinX / 100 );
			Clip.Brain.speedY *= ( Frein / 100 ) * ( FreinY / 100 );
			
			// Freine la vitesse de rotation
			Clip.Brain.speedRotation *= FreinRotation / 100;
			  
			// Freine la vitesse de taille
			Clip.Brain.speedHeight *= FreinTaille / 100;
			Clip.Brain.speedWidth *= FreinTaille / 100;
		}
		
		
		// —————— SHIFT
		// Décale l'élément dans une direction
	  
		public function Shift( Clip:* ,				// ———— - - L'Élément
							   Parametres:Object	// ———— - - Les Parametres
							 ):void {
			/*—*/
			
			// Parametres par défaut
			var DecalageX:Number = Aspiration( Parametres.shiftX , 0 );
			var DecalageY:Number = Aspiration( Parametres.shiftY , 0 );
			//
			var DecalageR:Number = Aspiration( Parametres.shiftRotation , 0 );
			//
			var Etat:String = Parametres.EtatLancement;
			
			// Si le temps est supérieur à 1 ou que c'est en fin —— - -
			if( Parametres.Temps > 1 || Etat == "Fin" ){
			
				// L'élément se décale en fonction de si le lancement est de début ou de fin
				Clip.x += ( Etat == "Debut" ) ? -DecalageX : DecalageX;
				Clip.y += ( Etat == "Debut" ) ? -DecalageY : DecalageY;
				//
				Clip.rotation += ( Etat == "Debut" ) ? -DecalageR : DecalageR;
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - LIMITATION - - —————————————————————————————————————————— */
		// Les méthodes pour limiter la position de l'élément
		//*—*//
		
		// —————— LIMIT STOP
		// Limitation des états de façon immédiate
	  
		public function LimitStop( Clip:* ,				// ———— - - L'Élément
								   Parametres:Object	// ———— - - Les Parametres
								 ):void {
			/*—*/
			
			// Parametres par défaut
			var Cible:* = Parametres.Cible || { x:0 , y:0 };
			//
			var MinX:Number = Aspiration( Parametres.xMin , NaN );
			var MaxX:Number = Aspiration( Parametres.xMax , NaN );
			//
			var MinY:Number = Aspiration( Parametres.yMin , NaN );
			var MaxY:Number = Aspiration( Parametres.yMax , NaN );
			//
			var MinR:Number = Aspiration( Parametres.rotationMin , NaN );
			var MaxR:Number = Aspiration( Parametres.rotationMax , NaN );
			//
			var MinW:Number = Aspiration( Parametres.widthMin , NaN );
			var MaxW:Number = Aspiration( Parametres.widthMax , NaN );
			//
			var MinH:Number = Aspiration( Parametres.heightMin , NaN );
			var MaxH:Number = Aspiration( Parametres.heightMax , NaN );
			
			// Bump de la position
			Clip.x = BumpNumber( Clip.x , MinX , MaxX );
			Clip.y = BumpNumber( Clip.y , MinY , MaxY );
			//
			if( Clip.x == MinX && Clip.Brain.speedX < 0 || Clip.x == MaxX && Clip.Brain.speedX > 0 ){ Clip.Brain.speedX = 0; }
			if( Clip.y == MinY && Clip.Brain.speedY < 0 || Clip.y == MaxY && Clip.Brain.speedY > 0 ){ Clip.Brain.speedY = 0; }
			//
			//
			// Bump de la rotation
			Clip.rotation = BumpNumber( Clip.rotation , MinR , MaxR );
			//
			if( Clip.rotation == MinR && Clip.Brain.speedRotation < 0 
			|| Clip.rotation == MaxR && Clip.Brain.speedRotation > 0 ){ Clip.Brain.speedRotation = 0; }
			//
			//
			// Bump de la taille
			Clip.width = BumpNumber( Clip.width , MinW , MaxW );
			Clip.height = BumpNumber( Clip.height , MinH , MaxH );
			//
			if( Clip.width == MinW && Clip.Brain.speedWidth < 0 
			|| Clip.width == MaxW && Clip.Brain.speedWidth > 0 ){ Clip.Brain.speedWidth = 0; }
			if( Clip.height == MinH && Clip.Brain.speedHeight < 0
			|| Clip.height == MaxH && Clip.Brain.speedHeight > 0 ){ Clip.Brain.speedHeight = 0; }
						  
			// Vérifie la direction pour le faire se retourner le cas échéant
			if( Cible.Brain.directionX == "Gauche" ){ Cible.scaleX = -1; }
			if( Cible.Brain.directionY == "Bas" ){ Cible.scaleY = -1; }
		}
		
		
		// —————— LIMIT BOUNCE
		// Limitation des états qui fait rebondir la vitesse
	  
		public function LimitBounce( Clip:* ,				// ———— - - L'Élément
									 Parametres:Object		// ———— - - Les Parametres
									):void {
			/*—*/
			
			// Parametres par défaut
			var Cible:* = Parametres.Cible || { x:0 , y:0 };
			//
			var MinX:Number = Aspiration( Parametres.xMin , NaN );
			var MaxX:Number = Aspiration( Parametres.xMax , NaN );
			//
			var MinY:Number = Aspiration( Parametres.yMin , NaN );
			var MaxY:Number = Aspiration( Parametres.yMax , NaN );
			//
			var MinR:Number = Aspiration( Parametres.rotationMin , NaN );
			var MaxR:Number = Aspiration( Parametres.rotationMax , NaN );
			//
			var MinW:Number = Aspiration( Parametres.widthMin , NaN );
			var MaxW:Number = Aspiration( Parametres.widthMax , NaN );
			//
			var MinH:Number = Aspiration( Parametres.heightMin , NaN );
			var MaxH:Number = Aspiration( Parametres.heightMax , NaN );
			// 
			var RebondX:Number = Aspiration( Parametres.bounceX , 1 );
			var RebondY:Number = Aspiration( Parametres.bounceY , 1 );
			//
			var RebondR:Number = Aspiration( Parametres.bounceRotation , 1 );
			//
			var RebondW:Number = Aspiration( Parametres.bouncewidth , 1 );
			var RebondH:Number = Aspiration( Parametres.bounceHeight , 1 );
			// 
			var BumpX:Number = Aspiration( Parametres.BumpX , 1 );
			var BumpY:Number = Aspiration( Parametres.BumpY , 1 );
			//
			var BumpR:Number = Aspiration( Parametres.BumpRotation , 1 );
			//
			var BumpW:Number = Aspiration( Parametres.BumpWidth , 1 );
			var BumpH:Number = Aspiration( Parametres.BumpHeight , 1 );
			
			
			// Bump de la position
			Clip.x = BumpNumber( Clip.x , MinX , MaxX );
			Clip.y = BumpNumber( Clip.y , MinY , MaxY );
			//
			if( Clip.x >= MaxX || Clip.x <= MinX ){ Clip.Brain.speedX *= -RebondX; }
			if( Clip.y >= MaxY || Clip.y <= MinY ){ Clip.Brain.speedY *= -RebondY; }
			//
			//
			// Bump de la rotation
			Clip.rotation = BumpNumber( Clip.rotation , MinR , MaxR );
			//
			if( Clip.rotation>= MaxR || Clip.rotation <= MinR ){ Clip.Brain.speedRotation *= -RebondR; }
			//
			//
			// Bump de la taille
			Clip.width = BumpNumber( Clip.width , MinW , MaxW );
			Clip.height = BumpNumber( Clip.height , MinH , MaxH );
			//
			if( Clip.width >= MaxW || Clip.width <= MinW ){ Clip.Brain.speedWidth *= -RebondW; }
			if( Clip.height >= MaxH || Clip.height <= MinH ){ Clip.Brain.speedHeight *= -RebondH; }
			
			// Bump des valeurs
			if( NearEqual( Clip.x , MinX , BumpX ) && NearEqual( Clip.Brain.speedX , 0 , BumpX ) ){ 
				Clip.x = MinX;
				Clip.Brain.speedX = 0;
			}
			if( NearEqual( Clip.x , MaxX , BumpX ) && NearEqual( Clip.Brain.speedX , 0 , BumpX ) ){
				Clip.x = MaxX;
				Clip.Brain.speedX = 0;
			}
			//
			if( NearEqual( Clip.y , MinY , BumpY ) && NearEqual( Clip.Brain.speedY , 0 , BumpY ) ){
				Clip.y = MinY;
				Clip.Brain.speedY = 0;
			}
			if( NearEqual( Clip.y , MaxY , BumpY ) && NearEqual( Clip.Brain.speedY , 0 , BumpY ) ){
				Clip.y = MaxY;
				Clip.Brain.speedY = 0;
			}
			//
			if( NearEqual( Clip.rotation , MinR , BumpR ) && NearEqual( Clip.Brain.speedRotation , 0 , BumpR ) ){ 
				Clip.rotation = MinR;
				Clip.Brain.speedRotation = 0;
			}
			if( NearEqual( Clip.rotation , MaxR , BumpR ) && NearEqual( Clip.Brain.speedRotation , 0 , BumpR ) ){ 
				Clip.rotation = MaxR;
				Clip.Brain.speedRotation = 0;
			}
			//
			if( NearEqual( Clip.width , MinW , BumpW ) && NearEqual( Clip.Brain.speedWidth , 0 , BumpW ) ){ 
				Clip.width = MinW; 
				Clip.Brain.speedWidth = 0;
			}
			if( NearEqual( Clip.width , MaxW , BumpW ) && NearEqual( Clip.Brain.speedWidth , 0 , BumpW ) ){ 
				Clip.width = MaxW; 
				Clip.Brain.speedWidth = 0;
			}
			//
			if( NearEqual( Clip.height , MinH , BumpH ) && NearEqual( Clip.Brain.speedHeight , 0 , BumpH ) ){ 
				Clip.height = MinH;
				Clip.Brain.speedHeight = 0;
			}
			if( NearEqual( Clip.height , MaxH , BumpH ) && NearEqual( Clip.Brain.speedHeight , 0 , BumpH ) ){
				Clip.height = MaxH;
				Clip.Brain.speedHeight = 0;
			}
		}
		
		
		// —————— LIMIT AROUND
		// Limitation des états qui fait faire de l'un à l'autre ou l'autre à l'un
	  
		public function LimitAround( Clip:* ,				// ———— - - L'Élément
								   Parametres:Object	// ———— - - Les Parametres
								):void {
			/*—*/
			
			// Parametres par défaut
			var Cible:* = Parametres.Cible || { x:0 , y:0 };
			//
			var MinX:Number = Aspiration( Parametres.xMin , NaN );
			var MaxX:Number = Aspiration( Parametres.xMax , NaN );
			//
			var MinY:Number = Aspiration( Parametres.yMin , NaN );
			var MaxY:Number = Aspiration( Parametres.yMax , NaN );
			//
			var MinR:Number = Aspiration( Parametres.rotationMin , NaN );
			var MaxR:Number = Aspiration( Parametres.rotationMax , NaN );
			//
			var MinW:Number = Aspiration( Parametres.widthMin , NaN );
			var MaxW:Number = Aspiration( Parametres.widthMax , NaN );
			//
			var MinH:Number = Aspiration( Parametres.heightMin , NaN );
			var MaxH:Number = Aspiration( Parametres.heightMax , NaN );
			
			// Bump de la position
			Clip.x = BumpNumber( Clip.x , MinX , MaxX );
			Clip.y = BumpNumber( Clip.y , MinY , MaxY );
			//
			// S'il est sur l'un —— - - Il va sur l'autre
			if( Clip.x == MinX ){ Clip.x = MaxX; }
			else if( Clip.x == MaxX ){ Clip.x = MinX; }
			//
			if( Clip.y == MinY ){ Clip.y = MaxY; }
			else if( Clip.y == MaxY ){ Clip.y = MinY; }
			//
			//
			// Bump de la rotation
			Clip.rotation = BumpNumber( Clip.rotation , MinR , MaxR );
			//
			if( Clip.rotation == MinR ){ Clip.rotation = MaxR; }
			else if( Clip.rotation == MaxR ){ Clip.rotation = MinR; }
			//
			// Bump de la taille
			Clip.width = BumpNumber( Clip.width , MinW , MaxW );
			Clip.height = BumpNumber( Clip.height , MinH , MaxH );
			//
			if( Clip.width == MinW ){ Clip.width = MaxW; }
			else if( Clip.width == MaxW ){ Clip.width = MinW; }
			//
			if( Clip.height == MinH ){ Clip.height = MaxH; }
			else if( Clip.height == MaxH ){ Clip.height = MinH; }
						  
			// Vérifie la direction pour le faire se retourner le cas échéant
			if( Cible.Brain.directionX == "Gauche" ){ Cible.scaleX = -1; }
			if( Cible.Brain.directionY == "Bas" ){ Cible.scaleY = -1; }
		}
		
		
		// —————— LIMIT SPEED
		// Action de mise à un max une vitesse
	  
		public function LimitSpeed( Clip:* ,				// ———— - - L'Élément
								  Parametres:Object		// ———— - - Les Parametres
								):void {
			/*—*/
			
			// Parametres par défaut
			var Cible:* = Parametres.Cible || { x:0 , y:0 };
			//
			var MaxVitesse:Number = Aspiration( Parametres.speed , NaN );
			var MaxspeedX:Number = Aspiration( Parametres.speedX , NaN );
			var MaxspeedY:Number = Aspiration( Parametres.speedY , NaN );
			var MaxspeedRotation:Number = Aspiration( Parametres.speedRotation , NaN );
			var MaxspeedWidth:Number = Aspiration( Parametres.speedWidth , NaN );
			var MaxspeedHeight:Number = Aspiration( Parametres.speedHeight , NaN );
			
			// Bump de la vitesse générale
			Clip.Brain.speed = BumpNumber( Clip.Brain.speed , -MaxVitesse , MaxVitesse );
			//
			// Bump de la vitesse de position
			Clip.Brain.speedX = BumpNumber( Clip.Brain.speedX , -MaxspeedX , MaxspeedX );
			Clip.Brain.speedY = BumpNumber( Clip.Brain.speedY , -MaxspeedY , MaxspeedY );
			//
			// Bump de la vitesse de rotation
			Clip.Brain.speedRotation = BumpNumber( Clip.Brain.speedRotation , -MaxspeedRotation , MaxspeedRotation );
			//
			// Bump de la vitesse de taille
			Clip.Brain.speedWidth = BumpNumber( Clip.Brain.speedWidth , -MaxspeedWidth , MaxspeedWidth );
			Clip.Brain.speedHeight = BumpNumber( Clip.Brain.speedHeight , -MaxspeedHeight , MaxspeedHeight );
		}
		
		
		
		/* —————————————————————————————————————————— - - LOOKING - - —————————————————————————————————————————— */
		// Les méthodes pour modifier la rotation et direction de l'élément
		//*—*//
		
		// —————— LOOK DIRECTION ANGLE
		// L'élément regarde dans la direction de son mouvement
	  
		public function LookDirectionAngle( Clip:* ,				// ———— - - L'Élément
										    Parametres:Object		// ———— - - Les Parametres
									   ):void {
			/*—*/
			
			// Parametres par défaut
			var Decalage:Number = Aspiration( Parametres.shift , 0 );
			
			// Regarde dans la direction voulu
			Clip.rotation = GetAngle( { x:Clip.Brain.MemoX.Directionnel , y:Clip.Brain.MemoY.Directionnel } , Clip ) + Decalage;
			  
			// Récupére les positions en mémoire
			Clip.Brain.MemoX.Directionnel = Clip.x;
			Clip.Brain.MemoY.Directionnel = Clip.y;
		}
		
		
		// —————— LOOK DIRECTION SHAPE
		// L'élément modifie sa forme selon son angle par son déplacement
	  
		public function LookDirectionShape( Clip:* ,				// ———— - - L'Élément
										    Parametres:Object		// ———— - - Les Parametres
										  ):void {
			/*—*/
			
			// Parametres par défaut
			var Decalage:Number = Aspiration( Parametres.shift , 0 );
			var Vise:* = ( Parametres.target ) ? ( 
						 ( !TypeOf( Aspiration( Parametres.target ) , "String" ) ) ? 
								   Aspiration( Parametres.target ) : 
								   Clip[ Aspiration( Parametres.target ) ] )
					  :Clip;
			
			// Regarde dans la direction voulue
			var Angle:Number = GetAngle( { x:Clip.Brain.MemoX.DirectionForme , y:Clip.Brain.MemoY.DirectionForme } , Clip ) + Decalage;
			
			// Pour chaque forme dans les parametres —— - -
			for( var Param:* in Parametres ){
			  
				// Si elle existe en tans qu'objet —— - -
				if( TypeOf( Parametres[ Param ] , "Object" ) ){
				  
					// Si elle a des angle —— - -
					if( Parametres[ Param ].Min != null ){
					 
						// Si elle est dans les marges
						if( Angle > Parametres[ Param ].Min && Angle < Parametres[ Param ].Max ){
							//
							// Modifie la forme pour elle
							Vise.gotoAndStop( Aspiration( Parametres[ Param ].Forme ) || Param );
						}
					}
				}
			}
			
			// Interrompt son animation s'il n'a pas bougé
			Vise.stop();
			  
			// Récupére les positions en mémoire
			Clip.Brain.MemoX.DirectionForme = Clip.x;
			Clip.Brain.MemoY.DirectionForme = Clip.y;
		}
		
		
		// —————— LOOK ROTATION SHAPE
		// L'élément modifie sa forme selon son angle par sa rotation
	  
		public function LookRotationShape( Clip:* ,					// ———— - - L'Élément
										   Parametres:Object		// ———— - - Les Parametres
									   	 ):void {
			/*—*/
			
			// Parametres par défaut
			var Decalage:Number = Aspiration( Parametres.shift , 0 );
			var Multiplicande:Number = Aspiration( Parametres.multiply , 0 );
			//
			var MemoVise:* = Parametres.target;
			var Vise:* = ( Parametres.target ) ? ( ( !TypeOf( Aspiration( Parametres.target ) , "String" ) ) ? 
												   Aspiration( Parametres.target ) : 
												   Clip[ Aspiration( Parametres.target ) ] ) : Clip;
			//
			Vise = ( Vise == null || Vise == undefined ) ? StringToElement( MemoVise , Clip ) : Vise;
			
			// Si ce n'est pas en Complet —— - -
			if( !Parametres.Complet ){
			  
				// Pour chaque forme dans les parametres —— - -
				for( var Param:* in Parametres ){
				  
					// Si elle existe en tans qu'objet —— - -
					if( TypeOf( Parametres[ Param ] , "Object" ) ){
					  
						// Si elle a des angle —— - -
						if( Parametres[ Param ].Min != null ){
						 
							// Si elle est dans les marges
							if( Vise.rotation * Multiplicande > Parametres[ Param ].Min && Vise.rotation * Multiplicande < Parametres[ Param ].Max ){
								//
								// Modifie la forme pour elle
								Vise.gotoAndStop( Aspiration( Parametres[ Param ].Forme ) || Param );
							}
						}
					}
				}
			  
			// Si c'est en complet —— - -
			} else {
			
				// Modifie la forme pour l'angle en cour
				Vise.gotoAndStop( Math.round( Math.abs( ( Vise.rotation + 180 ) * Multiplicande ) * ( Parametres.Complet / 360 ) ) );
			}
			
			// Interrompt son animation s'il n'a pas bougé
			Vise.stop();
		}
		
		
		// —————— LOOK DOUBLE
		// L'élément peut se retourner selon sa direction
	  
		public function LookDouble( Clip:* ,				// ———— - - L'Élément
								    Parametres:Object		// ———— - - Les Parametres
							      ):void {
			/*—*/
			
			// Parametres par défaut
			var Decalage:Number = Parametres.shift || 0;
			var Direction:String = Parametres.direction || "X";
			var Mode:String = Parametres.mode || "Rotation";
			
			// Mode Rotatif —— - -
			if( Mode == "Rotation" ){
				
				// Limites
				var Angles:Array = [ Decalage ];
				//
				Angles.push( ( Decalage > 0 ) ? Decalage - 180 : Decalage + 180 );
				//
				if( Angles[ 0 ] > Angles[ 1 ] ){ Angles.reverse(); }
				
				// Test de la rotation
				if( Clip.rotation > Angles[ 0 ] && Clip.rotation < Angles[ 1 ] ){
				  
					// Changement en horizontal
					if( Direction == "X" ){ Clip.Brain.directionX = "Droite"; }
					//
					// Changement en vertical
					else { Clip.Brain.directionY = "Haut"; }
				  
				} else {
				  
					// Changement en horizontal
					if( Direction == "X" ){ Clip.Brain.directionX = "Gauche"; }
					//
					// Changement en vertical
					else { Clip.Brain.directionY = "Bas"; }			  
				}
			}
			
			// Mode Mouvement —— - -
			if( Mode == "Mouvement" ){
			  
			  if( Clip.Brain.MemoX.BiDirectionnel > Clip.x && Direction == "X" ){ Clip.Brain.directionX = "Gauche"; } 
			  else if( Direction == "X" ){ Clip.Brain.directionX = "Droite"; }
			  //
			  if( Clip.Brain.MemoY.BiDirectionnel > Clip.y && Direction == "Y" ){ Clip.Brain.directionY = "Bas"; } 
			  else if( Direction == "Y" ){ Clip.Brain.directionY = "Haut"; }
			  
			  Clip.Brain.MemoX.BiDirectionnel = Clip.x;
			  Clip.Brain.MemoY.BiDirectionnel = Clip.y;
			}
		}
		
		
		// —————— LOOK NONE
		// L'élément tourne bel et bien mais n'emet pas de rotation car s'oppose à une rotation inverse dans son clip
	  
		public function LookNone( Clip:* ,				// ———— - - L'Élément
								  Parametres:Object		// ———— - - Les Parametres
							    ):void {
			/*—*/
			
			// Parametres par défaut
			var MemoVise:* = Parametres.target;
			var Vise:* = ( Parametres.target ) ? ( ( !TypeOf( Aspiration( Parametres.target ) , "String" ) ) ? 
													   Aspiration( Parametres.target ) : 
													   Clip[ Aspiration( Parametres.target ) ] ) : Clip;
			//
			Vise = ( Vise == null || Vise == undefined ) ? StringToElement( MemoVise , Clip ) : Vise;
			
			
			// La méthode se self-lock
			//
			// Création de l'objet d'IA Lock
			if( !Clip.BrainLock ){ Clip.BrainLock = new Object(); }
			//
			// Si présence de cette méthode en unlock —— - -
			if( Clip.Brain.NoAngle ){
				//
				// Clone la méthode en lock
				Clip.BrainLock.NoAngle = CloneObject( Clip.Brain.NoAngle );
				//
				// La détruit en unlock
				Clip.Brain.NoAngle = null;
			}
			
			// Met la rotation à l'inverse pour la cible
			Vise.rotation = - Clip.rotation + Aspiration( Parametres.Decalage , 0 );
		}
		
		
		
		/* —————————————————————————————————————————— - - TRANSPOSITION - - —————————————————————————————————————————— */
		// Les méthodes pour alterner certaines valeurs de l'élément vers d'autres
		//*—*//
		
		// —————— TRANSPOSITION TWIST
		// L'élément transpose la modification d'un paramètres sur un autre
	  
		public function TranspositionTwist( Clip:* ,				// ———— - - L'Élément
										    Parametres:Object		// ———— - - Les Parametres
										   ):void {
			/*—*/
			
			// La méthode se self-lock
			//
			// Création de l'objet d'IA Lock
			if( !Clip.BrainLock ){ Clip.BrainLock = new Object(); }
			//
			// Si présence de cette méthode en unlock —— - -
			if( Clip.Brain.Transposition ){
				//
				// Clone la méthode en lock
				Clip.BrainLock.Transposition = CloneObject( Clip.Brain.Transposition );
				//
				// La détruit en unlock
				Clip.Brain.Transposition = null;
			}
			
			// Pour chaque paramètres —— - -
			for( var Param:* in Parametres.Parametres ){
			  
				// Créait sa mémoire s'il n'en pas
				Clip.BrainLock.Transposition[ Param ] = Clip.BrainLock.Transposition[ Param ] || new Object();
				//
				Clip.BrainLock.Transposition[ Param ].Memo = Clip.BrainLock.Transposition[ Param ].Memo || Clip[ Param ];
				
				// Récupère le décalage
				Clip.BrainLock.Transposition[ Param ].Decalage = Clip.BrainLock.Transposition[ Param ].Memo - Clip[ Param ];
			}
			
			// Pour chaque paramètres —— - -
			for( var ParamApply:* in Parametres.Parametres ){
			  
				// Impose le décalage
				Clip[ Parametres.Parametres[ ParamApply ] ] -= Clip.BrainLock.Transposition[ ParamApply ].Decalage * 
														   ( Aspiration( Parametres.Decalage ) || 1 );
				
				// Remet la valeur du paramètre sans le décalage
				Clip[ ParamApply ] += Clip.BrainLock.Transposition[ ParamApply ].Decalage;
			}
			
			// Pour chaque paramètres —— - -
			for( var ParamMemo:* in Parametres.Parametres ){
			  
				// Récupère la mémoire
				Clip.BrainLock.Transposition[ ParamMemo ].Memo = Clip[ ParamMemo ];
			}
		}
		
		
		// —————— TRANSPOSITION EGAL
		// L'élément donne la même modification d'un paramètres à un autre
	  
		public function TranspositionEgal( Clip:* ,				// ———— - - L'Élément
										   Parametres:Object	// ———— - - Les Parametres
										  ):void {
			/*—*/
			
			// Pour chaque paramètres —— - -
			for( var Param:* in Parametres.Parametres ){
			  
				// Créait sa mémoire s'il n'en pas
				Clip.Brain.Egalisation[ Param ] = Clip.Brain.Egalisation[ Param ] || new Object();
				//
				Clip.Brain.Egalisation[ Param ].Memo = Clip.Brain.Egalisation[ Param ].Memo || Clip[ Param ];
				
				// Récupère le décalage
				Clip.Brain.Egalisation[ Param ].Decalage = Clip.Brain.Egalisation[ Param ].Memo - Clip[ Param ];
			}
			
			// Pour chaque paramètres —— - -
			for( var ParamApply:* in Parametres.Parametres ){
				
				// Impose le décalage
				Clip[ Parametres.Parametres[ ParamApply ] ] -= Clip.Brain.Egalisation[ ParamApply ].Decalage * 
														   ( Aspiration( Parametres.Decalage ) || 1 );
			}
			
			// Pour chaque paramètres —— - -
			for( var ParamMemo:* in Parametres.Parametres ){
			  
				// Récupère la mémoire
				Clip.Brain.Egalisation[ ParamMemo ].Memo = Clip[ ParamMemo ];
			}
		}
		
		
		// —————— TRANSPOSITION NONE
		// Rétablie tous les parametres
	  
		public function TranspositionNone( Clip:* ,				// ———— - - L'Élément
										   Parametres:Object	// ———— - - Les Parametres
									     ):void {
			/*—*/
			
			// La méthode self-megaLock
			//
			// Création de l'objet d'IA MegaLock
			if( !Clip.BrainMegaLock ){ Clip.BrainMegaLock = new Object(); }
			//
			// Créait le parametres de Rétablissement de Fin
			Clip.BrainMegaLock.RetablissementFin = Clip.BrainMegaLock.RetablissementFin || new Object();
			
			// Récupère les données mémoires
			for( var Param:* in Parametres.Parametres ){
			  
				// S'il y a une mémoire
				if( Clip.Brain.Retablissement[ Param ] ){
				
					// Replace la donnée à l'état mémorisé
					Clip[ Param ] = Clip.Brain.Retablissement[ Param ].Memo;
				}
			}
		}
		
		
		// —————— TRANSPOSITION END
		// Fin de rétablissement
	  
		public function TranspositionEnd( Clip:* ,				// ———— - - L'Élément
										  Parametres:Object		// ———— - - Les Parametres
								  		):void {
			/*—*/
			
			// La méthode se self-megaLock
			//
			// Création de l'objet d'IA MegaLock
			if( !Clip.BrainMegaLock ){ Clip.BrainMegaLock = new Object(); }
			//
			// Si présence de cette méthode en unlock —— - -
			if( Clip.Brain.RetablissementFin ){
				//
				// Clone la méthode en lock
				Clip.BrainMegaLock.RetablissementFin = CloneObject( Clip.Brain.RetablissementFin );
				//
				// La détruit en unlock
				Clip.Brain.RetablissementFin = null;
			}
			
			// Pour chaque paramètres —— - -
			for( var Param:* in Clip.Brain.Retablissement.Parametres ){
			  
				// Créait sa mémoire s'il n'en pas
				Clip.Brain.Retablissement[ Param ] = Clip.Brain.Retablissement[ Param ] || new Object();
				//
				Clip.Brain.Retablissement[ Param ].Memo = Clip[ Param ];
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - FOLLOWING - - —————————————————————————————————————————— */
		// Les méthodes pour appliquer un suivis par l'élément
		//*—*//
		
		// —————— FOLLOW DIRECT
		// Action de suivre un élément
	  
		public function FollowDirect( Clip:* ,			// ———— - - L'Élément
									  Parametres:Object	// ———— - - Les Parametres
								     ):void {
			/*—*/
			
			// Parametres par défaut
			var Cible:* = Parametres.target || { x:0 , y:0 };
			Cible = ( Cible == "Mouse" ) ? Mouse : Cible;
			//
			var Type:String = Parametres.type || "Deceleration";
			var Vitesse:Number = Aspiration( Parametres.speed , 10 );
			
			// Si la cible est la souris —— - -
			if( TypeOf( Cible , "MousePort" ) ){
			  
				// Si le parent du clip n'est pas la racine —— - - Redéfinie la cible comme un objet réceptionnant 
				//												   la position souris dans le parent du clip
				if( !TypeOf( Clip.parent , "MainTimeline" ) ){
					//
					Cible = { x:Cible.localX( Clip.parent as MovieClip ) , y:Cible.localY( Clip.parent as MovieClip ) };
				  
				// Si le parent du clip est la racine —— - - Redéfinie la cible comme un objet réceptionnant la position souris générale
				} else { Cible = { x:Cible.x , y:Cible.y }; }
			}
			
			// Si le suivis est de type décélératif —— - -
			if( Type == "Deceleration" ){
			  
				// Le clip se dirige en décélérant vers sa cible
				Clip.x += ( Cible.x - Clip.x ) / Vitesse;
				Clip.y += ( Cible.y - Clip.y ) / Vitesse;
			}
		}
		
		
		// —————— FOLLOW SPEED
		// Action de suivre un élément avec une notion de vitesse
	  
		public function FollowSpeed( Clip:* ,			// ———— - - L'Élément
								     Parametres:Object	// ———— - - Les Parametres
								    ):void {
			/*—*/
			
			// Parametres par défaut
			var Cible:* = Parametres.target || { x:0 , y:0 };
			Cible = ( Cible == "Mouse" ) ? Mouse : Cible;
			//
			var Type:String = Parametres.type || "Deceleration";
			var Vitesse:Number = Aspiration( Parametres.speed , 10 );
			
			// Si la cible est la souris —— - -
			if( TypeOf( Cible , "MousePort" ) ){
			  
				// Si le parent du clip n'est pas la racine —— - - Redéfinie la cible comme un objet réceptionnant 
				// 												   la position souris dans le parent du clip
				if( !TypeOf( Clip.parent , "MainTimeline" ) ){
					//
				  	Cible = { x:Cible.localX( Clip.parent as MovieClip ) , y:Cible.localY( Clip.parent as MovieClip ) };
				  
				// Si le parent du clip est la racine —— - - Redéfinie la cible comme un objet réceptionnant la position souris générale
				} else { Cible = { x:Cible.X , y:Cible.Y }; }
			}
			
			// Si le suivis est de type décélératif —— - -
			if( Type == "Deceleration" ){
			  
				// La vitesse du clip va en s'orientant vers la cible
				Clip.Brain.speedX += ( Cible.x - Clip.x ) / ( Vitesse * 10 );
				Clip.Brain.speedY += ( Cible.y - Clip.y ) / ( Vitesse * 10 );
			}
		}
	  
		
		// —————— FOLLOW LOOK
		// Action de suivre un élément du regard
	  
		public function FollowLook( Clip:* ,			// ———— - - L'Élément
									Parametres:Object	// ———— - - Les Parametres
								   ):void {
			/*—*/
			
			// Parametres par défaut
			var Cible:* = Parametres.target || { x:0 , y:0 };
			Cible = ( Cible == "Mouse" ) ? Mouse : Cible;
			//
			var Vitesse:Number = Aspiration( Parametres.speed , 10 );
			//
			Vitesse = ( Vitesse <= 0 ) ? 1 : Vitesse;
			
			// Si la cible est la souris —— - -
			if( TypeOf( Cible , "MousePort" ) ){
				
				// Si le parent du clip n'est pas la racine —— - - Redéfinie la cible comme un objet réceptionnant 
				//												   la position souris dans le parent du clip
				if( !TypeOf( Clip.parent , "MainTimeline" ) ){
					//
				  Cible = { x:Cible.localX( Clip.parent as MovieClip ) , y:Cible.localY( Clip.parent as MovieClip ) };
				  
				// Si le parent du clip est la racine —— - - Redéfinie la cible comme un objet réceptionnant la position souris générale
				} else { Cible = { x:Cible.X , y:Cible.Y }; }
			}
			
			// Le clip regarde vers sa cible
			AngleGoTo( Clip , GetAngle( Clip , Cible ) , Vitesse );
		}
	  	
		
		
		/* —————————————————————————————————————————— - - WALKING - - —————————————————————————————————————————— */
		// Les méthodes pour appliquer des chemins de marche à l'élément
		//*—*//
		
		// —————— WALK RECTANGLE
		// Mouvement en forme de chemin de rectangle
	  
		public function WalkRectangle( Clip:* ,				// ———— - - L'Élément
									   Parametres:Object	// ———— - - Les Parametres
									 ):void {
			/*—*/
			
			// Parametres par défaut
			var Vitesse:Number = Aspiration( Parametres.speed , 1 );
			
			var CrantX:Number = Aspiration( Parametres.crantX , 0 );
			var CrantY:Number = Aspiration( Parametres.crantY , 0 );
			//
			var Sens:Boolean = Parametres.mean || false;
			//
			var DirectionInitial:String = Parametres.direction || "Droite";
			
			
			// Créait le rectangle de mouvement s'il n'existe pas ou est incomplet
			Clip.Brain.WalkRectangle.Rectangle = Clip.Brain.WalkRectangle.Rectangle || new Array();
			Clip.Brain.WalkRectangle.Rectangle[ 0 ] = SetDefault( Clip.Brain.WalkRectangle.Rectangle[ 0 ] , 0 );
			Clip.Brain.WalkRectangle.Rectangle[ 1 ] = SetDefault( Clip.Brain.WalkRectangle.Rectangle[ 1 ] , 0 ); 
			Clip.Brain.WalkRectangle.Rectangle[ 2 ] = SetDefault( Clip.Brain.WalkRectangle.Rectangle[ 2 ] , 100 );
			Clip.Brain.WalkRectangle.Rectangle[ 3 ] = SetDefault( Clip.Brain.WalkRectangle.Rectangle[ 3 ] , 100 );
			//
			// Récupére le rectangle en argument
			var Rectangle:Array = Clip.Brain.WalkRectangle.Rectangle;
			
			
			// Modifie la vitesse pour exclure le mouvement précédent si mouvement précédent il y a ( A condition qu'il ne touche pas un bord ) —— - -
			if( Clip.Brain.MemoCheminX != null && Clip.Brain.speedX != 0 ){
				Clip.Brain.speedX -= Clip.Brain.WalkSpecialX - Clip.Brain.MemoCheminX;
			}
			//
			if( Clip.Brain.MemoCheminY != null && Clip.Brain.speedY != 0 ){
				Clip.Brain.speedY -= Clip.Brain.WalkSpecialY - Clip.Brain.MemoCheminY;
			}
			
			
			// Créait les variables de chemin s'il n'en a pas
			Clip.Brain.WalkSpecialX = SetDefault( Clip.Brain.WalkSpecialX , Clip.x );
			Clip.Brain.WalkSpecialY = SetDefault( Clip.Brain.WalkSpecialY , Clip.y );
			//
			Clip.Brain.MemoCheminX = Clip.Brain.WalkSpecialX;
			Clip.Brain.MemoCheminY = Clip.Brain.WalkSpecialY;
			
			
			
			// Créait les variables de référence s'il n'en a pas
			if( Clip.Brain.WalkRectangle.ReferenceX == null ){ Clip.Brain.WalkRectangle.ReferenceX = SetDefault( Parametres.startX , 0 ); }
			if( Clip.Brain.WalkRectangle.ReferenceY == null ){ Clip.Brain.WalkRectangle.ReferenceY = SetDefault( Parametres.startY , 0 ); }
			//
			// Définit sa direction
			Clip.Brain.WalkRectangle.direction = SetDefault( Clip.Brain.WalkRectangle.direction , DirectionInitial );
			
			
			// Opére le déplacement ( Sur le chemin, il est répercuté ensuite sur la position du clip )
			//
			// Vers la droite —— - -
			if( Clip.Brain.WalkRectangle.direction == "Droite" ){ 
				
				// Déplace
				Clip.Brain.WalkSpecialX += Vitesse;
				Clip.Brain.WalkRectangle.ReferenceX += Vitesse;
				
				// S'il est au bout —— - -
				if( Clip.Brain.WalkRectangle.ReferenceX >= Rectangle[ 2 ] ){ 
					//
					if( Sens ){
							
						// Bump de la référence dans l'autre sens pour récupérer le déplacement superflue
						Clip.Brain.WalkRectangle.ReferenceY += Clip.Brain.WalkRectangle.ReferenceX - Rectangle[ 2 ];
						Clip.Brain.WalkSpecialY += Clip.Brain.WalkRectangle.ReferenceX - Rectangle[ 2 ];
						//
						// Calibre la référence de ce sens
						Clip.Brain.WalkSpecialX -= Clip.Brain.WalkRectangle.ReferenceX - Rectangle[ 2 ];
						Clip.Brain.WalkRectangle.ReferenceX = Rectangle[ 2 ];
						
						// Change la direction
						Clip.Brain.WalkRectangle.direction = "Bas";
						
						// Opére la modification par crantage
						Clip.Brain.WalkRectangle.Rectangle[ 2 ] += CrantX;
						Clip.Brain.WalkRectangle.Rectangle[ 0 ] += CrantX;
					
					} else {
							
						// Bump de la référence dans l'autre sens pour récupérer le déplacement superflue
						Clip.Brain.WalkRectangle.ReferenceY -= Clip.Brain.WalkRectangle.ReferenceX - Rectangle[ 2 ];
						Clip.Brain.WalkSpecialY -= Clip.Brain.WalkRectangle.ReferenceX - Rectangle[ 2 ];
						//
						// Calibre la référence de ce sens
						Clip.Brain.WalkSpecialX -= Clip.Brain.WalkRectangle.ReferenceX - Rectangle[ 2 ];
						Clip.Brain.WalkRectangle.ReferenceX = Rectangle[ 2 ];
						
						// Change la direction
						Clip.Brain.WalkRectangle.direction = "Haut";
						
						// Opére la modification par crantage
						Clip.Brain.WalkRectangle.Rectangle[ 2 ] += CrantX;
						Clip.Brain.WalkRectangle.Rectangle[ 0 ] += CrantX;
					}
				}
			}
			//
			// Vers la gauche
			else if( Clip.Brain.WalkRectangle.direction == "Gauche" ){ 
			
				// Déplace
				Clip.Brain.WalkSpecialX -= Vitesse; 
				Clip.Brain.WalkRectangle.ReferenceX -= Vitesse;
				
				// S'il est au bout —— - -
				if( Clip.Brain.WalkRectangle.ReferenceX <= Rectangle[ 0 ] ){
					
					if( Sens ){
							
						// Bump de la référence dans l'autre sens pour récupérer le déplacement superflue
						Clip.Brain.WalkRectangle.ReferenceY -= Rectangle[ 0 ] - Clip.Brain.WalkRectangle.ReferenceX;
						Clip.Brain.WalkSpecialY -= Rectangle[ 0 ] - Clip.Brain.WalkRectangle.ReferenceX;
						//
						// Calibre la référence de ce sens
						Clip.Brain.WalkSpecialX += Rectangle[ 0 ] - Clip.Brain.WalkRectangle.ReferenceX;
						Clip.Brain.WalkRectangle.ReferenceX = Rectangle[ 0 ];
						
						// Change la direction
						Clip.Brain.WalkRectangle.direction = "Haut"; 
						
						// Opére la modification par crantage
						Clip.Brain.WalkRectangle.Rectangle[ 2 ] += CrantX;
						Clip.Brain.WalkRectangle.Rectangle[ 0 ] += CrantX;
						
					} else {
							
						// Bump de la référence dans l'autre sens pour récupérer le déplacement superflue
						Clip.Brain.WalkRectangle.ReferenceY += Rectangle[ 0 ] - Clip.Brain.WalkRectangle.ReferenceX;
						Clip.Brain.WalkSpecialY += Rectangle[ 0 ] - Clip.Brain.WalkRectangle.ReferenceX;
						//
						// Calibre la référence de ce sens
						Clip.Brain.WalkSpecialX += Rectangle[ 0 ] - Clip.Brain.WalkRectangle.ReferenceX;
						Clip.Brain.WalkRectangle.ReferenceX = Rectangle[ 0 ];
						
						// Change la direction
						Clip.Brain.WalkRectangle.direction = "Bas"; 
						
						// Opére la modification par crantage
						Clip.Brain.WalkRectangle.Rectangle[ 2 ] += CrantX;
						Clip.Brain.WalkRectangle.Rectangle[ 0 ] += CrantX;
					}
				}
			}
			//
			// Vers le bas
			else if( Clip.Brain.WalkRectangle.direction == "Bas" ){ 
			
				// Déplace
				Clip.Brain.WalkSpecialY += Vitesse; 
				Clip.Brain.WalkRectangle.ReferenceY += Vitesse;
				
				// S'il est au bout —— - -
				if( Clip.Brain.WalkRectangle.ReferenceY >= Rectangle[ 3 ] ){ 
					
					if( Sens ){
						
						// Bump de la référence dans l'autre sens pour récupérer le déplacement superflue
						Clip.Brain.WalkRectangle.ReferenceX += Rectangle[ 3 ] - Clip.Brain.WalkRectangle.ReferenceY;
						Clip.Brain.WalkSpecialX += Rectangle[ 3 ] - Clip.Brain.WalkRectangle.ReferenceY;
						//
						// Calibre la référence de ce sens
						Clip.Brain.WalkSpecialY += Rectangle[ 3 ] - Clip.Brain.WalkRectangle.ReferenceY;
						Clip.Brain.WalkRectangle.ReferenceY = Rectangle[ 3 ];
							
						// Change la direction
						Clip.Brain.WalkRectangle.direction = "Gauche"; 
						
						// Opére la modification par crantage
						Clip.Brain.WalkRectangle.Rectangle[ 1 ] += CrantY;
						Clip.Brain.WalkRectangle.Rectangle[ 3 ] += CrantY;
						
					} else {
						
						// Bump de la référence dans l'autre sens pour récupérer le déplacement superflue
						Clip.Brain.WalkRectangle.ReferenceX -= Rectangle[ 3 ] - Clip.Brain.WalkRectangle.ReferenceY;
						Clip.Brain.WalkSpecialX -= Rectangle[ 3 ] - Clip.Brain.WalkRectangle.ReferenceY;
						//
						// Calibre la référence de ce sens
						Clip.Brain.WalkSpecialY += Rectangle[ 3 ] - Clip.Brain.WalkRectangle.ReferenceY;
						Clip.Brain.WalkRectangle.ReferenceY = Rectangle[ 3 ];
							
						// Change la direction
						Clip.Brain.WalkRectangle.direction = "Droite"; 
						
						// Opére la modification par crantage
						Clip.Brain.WalkRectangle.Rectangle[ 1 ] += CrantY;
						Clip.Brain.WalkRectangle.Rectangle[ 3 ] += CrantY;
					}
				}
			}
			//
			// Vers le haut
			else if( Clip.Brain.WalkRectangle.direction == "Haut" ){ 
			
				// Déplace
				Clip.Brain.WalkSpecialY -= Vitesse; 
				Clip.Brain.WalkRectangle.ReferenceY -= Vitesse;
				
				// S'il est au bout —— - -
				if( Clip.Brain.WalkRectangle.ReferenceY <= Rectangle[ 1 ] ){ 
					
					if( Sens ){
						
						// Bump de la référence dans l'autre sens pour récupérer le déplacement superflue
						Clip.Brain.WalkRectangle.ReferenceX -= Clip.Brain.WalkRectangle.ReferenceY - Rectangle[ 1 ];
						Clip.Brain.WalkSpecialX -= Clip.Brain.WalkRectangle.ReferenceY - Rectangle[ 1 ];
						//
						// Calibre la référence de ce sens
						Clip.Brain.WalkSpecialY -= Clip.Brain.WalkRectangle.ReferenceY - Rectangle[ 1 ];  
						Clip.Brain.WalkRectangle.ReferenceY = Rectangle[ 1 ];
						
						// Change la direction
						Clip.Brain.WalkRectangle.direction = "Droite"; 
						
						// Opére la modification par crantage
						Clip.Brain.WalkRectangle.Rectangle[ 1 ] += CrantY;
						Clip.Brain.WalkRectangle.Rectangle[ 3 ] += CrantY;
						
					} else {
						
						// Bump de la référence dans l'autre sens pour récupérer le déplacement superflue
						Clip.Brain.WalkRectangle.ReferenceX += Clip.Brain.WalkRectangle.ReferenceY - Rectangle[ 1 ];
						Clip.Brain.WalkSpecialX += Clip.Brain.WalkRectangle.ReferenceY - Rectangle[ 1 ];
						//
						// Calibre la référence de ce sens
						Clip.Brain.WalkSpecialY -= Clip.Brain.WalkRectangle.ReferenceY - Rectangle[ 1 ];  
						Clip.Brain.WalkRectangle.ReferenceY = Rectangle[ 1 ];
						
						// Change la direction
						Clip.Brain.WalkRectangle.direction = "Gauche"; 
						
						// Opére la modification par crantage
						Clip.Brain.WalkRectangle.Rectangle[ 1 ] += CrantY;
						Clip.Brain.WalkRectangle.Rectangle[ 3 ] += CrantY;
					}
				}
			}
			
			// A l'aide des mouvements du chemin, modifie la vitesse pour inclure le mouvement
			Clip.Brain.speedX += Clip.Brain.WalkSpecialX - Clip.Brain.MemoCheminX;
			Clip.Brain.speedY += Clip.Brain.WalkSpecialY - Clip.Brain.MemoCheminY;
		}
	  
	  
		// —————— WALK CIRCLE
		// Mouvement en forme de chemin de rond
	  
		public function WalkCircle( Clip:* ,				// ———— - - L'Élément
								    Parametres:Object		// ———— - - Les Parametres
								 ):void {
			/*—*/
			
			// Parametres par défaut
			var Vitesse:Number = Aspiration( Parametres.speed , 1 );
			//
			var AngleInitial:Number = Aspiration( Parametres.angle , 0 );
			//
			var MouvementX:Number = Aspiration( Parametres.speedX , 0 );
			var MouvementY:Number = Aspiration( Parametres.speedY , 0 );
			//
			var InflectionX:Number = Aspiration( Parametres.inflectionX , 100 );
			var InflectionY:Number = Aspiration( Parametres.inflectionY , 100 );
			//
			var EvolutionDiametre:Number = Aspiration( Parametres.speedDiametre , 0 );
			//
			var Sens:Boolean = Parametres.mean || false;
			
			
			// Modifie la vitesse pour exclure le mouvement précédent si mouvement précédent il y a ( A condition qu'il ne touche pas un bord ) —— - -
			if( Clip.Brain.MemoCheminX != null && Clip.Brain.speedX != 0 ){
				Clip.Brain.speedX -= ( Clip.Brain.WalkSpecialX - Clip.Brain.MemoCheminX ) * ( InflectionX / 100 );
			}
			//
			if( Clip.Brain.MemoCheminY != null && Clip.Brain.speedY != 0 ){
				Clip.Brain.speedY -= ( Clip.Brain.WalkSpecialY - Clip.Brain.MemoCheminY ) * ( InflectionY / 100 );
			}
			
			
			// Créait les variables de chemin s'il n'en a pas
			Clip.Brain.WalkSpecialX = SetDefault( Clip.Brain.WalkSpecialX , Clip.x );
			Clip.Brain.WalkSpecialY = SetDefault( Clip.Brain.WalkSpecialY , Clip.y );
			//
			Clip.Brain.MemoCheminX = Clip.Brain.WalkSpecialX;
			Clip.Brain.MemoCheminY = Clip.Brain.WalkSpecialY;
			
			
			// Créait les variables de référence s'il n'en a pas
			if( Clip.Brain.WalkCircle.diametre == null ){ Clip.Brain.WalkCircle.diametre = SetDefault( Parametres.diametre , 100 ); }
			if( Clip.Brain.WalkCircle.angle == null ){ Clip.Brain.WalkCircle.angle = AngleInitial; }
			
			
			// Créait le point de référence
			if( Clip.Brain.WalkCircle.CentreX == null ){ Clip.Brain.WalkCircle.CentreX = GetDirectionTo( { x:Clip.Brain.WalkSpecialX } ,
																									  Clip.Brain.WalkCircle.diametre , 
																									  Clip.Brain.WalkCircle.angle + 180 ).x; }
			if( Clip.Brain.WalkCircle.CentreY == null ){ Clip.Brain.WalkCircle.CentreY = GetDirectionTo( { y:Clip.Brain.WalkSpecialY } ,
																									  Clip.Brain.WalkCircle.diametre , 
																									  Clip.Brain.WalkCircle.angle + 180 ).y; }
			
			// Positionne le chemin selon le diametre, l'angle et le point de référence
			Clip.Brain.WalkSpecialX = GetDirectionTo( { x:Clip.Brain.WalkCircle.CentreX } , 
										   Clip.Brain.WalkCircle.diametre , 
										   Clip.Brain.WalkCircle.angle ).x;
			//
			Clip.Brain.WalkSpecialY = GetDirectionTo( { y:Clip.Brain.WalkCircle.CentreY } , 
										   Clip.Brain.WalkCircle.diametre , 
										   Clip.Brain.WalkCircle.angle ).y;
			
			// Fait tourner l'angle selon la vitesse
			Clip.Brain.WalkCircle.angle += ( Sens ) ? Vitesse : -Vitesse;
			
			// Fait évoluer le diametre
			Clip.Brain.WalkCircle.diametre += EvolutionDiametre;
			Clip.Brain.WalkCircle.diametre = ( Clip.Brain.WalkCircle.diametre < 0 ) ? 0 : Clip.Brain.WalkCircle.diametre;
			
			// Fait évoluer le point central
			Clip.Brain.WalkCircle.CentreX += MouvementX;
			Clip.Brain.WalkCircle.CentreY += MouvementY;
			
			
			// A l'aide des mouvements du chemin, modifie la vitesse pour inclure le mouvement
			Clip.Brain.speedX += ( Clip.Brain.WalkSpecialX - ( Clip.Brain.MemoCheminX || 0 ) ) * ( InflectionX / 100 );
			Clip.Brain.speedY += ( Clip.Brain.WalkSpecialY - ( Clip.Brain.MemoCheminY || 0 ) ) * ( InflectionY / 100 );
		}
	  
	  
		// —————— WALK SPECIAL
		// Mouvement en forme de chemin définis
	  
		public function WalkSpecial( Clip:* ,				// ———— - - L'Élément
									 Parametres:Object		// ———— - - Les Parametres
								   ):void {
			/*—*/
			
			// Parametres par défaut
			var Vitesse:Number = Aspiration( Parametres.speed , 100 );
			var Boucle:Boolean = ( Parametres.loop != null ) ? Parametres.loop : true;
			
			
			// Modifie la vitesse pour exclure le mouvement précédent si mouvement précédent il y a ( A condition qu'il ne touche pas un bord ) —— - -
			if( Clip.Brain.MemoCheminX != null && Clip.Brain.speedX != 0 ){
				Clip.Brain.speedX -= Clip.Brain.WalkSpecialX - Clip.Brain.MemoCheminX;
			}
			//
			if( Clip.Brain.MemoCheminY != null && Clip.Brain.speedY != 0 ){
				Clip.Brain.speedY -= Clip.Brain.WalkSpecialY - Clip.Brain.MemoCheminY;
			}
			
			
			// Créait les variables de chemin s'il n'en a pas
			Clip.Brain.WalkSpecialX = Round( SetDefault( Clip.Brain.WalkSpecialX , Clip.x ) , 4 );
			Clip.Brain.WalkSpecialY = Round( SetDefault( Clip.Brain.WalkSpecialY , Clip.y ) , 4 );
			//
			Clip.Brain.MemoCheminX = Clip.Brain.WalkSpecialX;
			Clip.Brain.MemoCheminY = Clip.Brain.WalkSpecialY;
			
			
			// Pour le premier appel —— - -
			//
			// Créait les variables d'étapes et les définit pour que l'élément aille vers son premier point —— - -
			if( Clip.Brain.WalkSpecial.EtapeX == null ){
				
				// Définit la tête du point en cour
				Clip.Brain.WalkSpecial.Point = 0;
				
				// Définit les valeurs des étapes 
				Clip.Brain.WalkSpecial.EtapeX = Round( ( Clip.Brain.WalkSpecial.Points[ 0 ].x - Clip.x ) 
														/ ( Clip.Brain.WalkSpecial.Points[ Clip.Brain.WalkSpecial.Point ].speed || Vitesse ) , 4 );
				Clip.Brain.WalkSpecial.EtapeY = Round( ( Clip.Brain.WalkSpecial.Points[ 0 ].y - Clip.y ) 
														/ ( Clip.Brain.WalkSpecial.Points[ Clip.Brain.WalkSpecial.Point ].speed || Vitesse ) , 4 );
			}
			
			// Le chemin avance suivant les étapes
			Clip.Brain.WalkSpecialX += Clip.Brain.WalkSpecial.EtapeX;
			Clip.Brain.WalkSpecialY += Clip.Brain.WalkSpecial.EtapeY;
			
			
			// S'il est plus ou moins égal à la fin de son trajet en cour —— - -
			if( NearEqual( Clip.Brain.WalkSpecialX , Clip.Brain.WalkSpecial.Points[ Clip.Brain.WalkSpecial.Point ].x ) ){ 
				
				// Lance la fonction rattachée s'il y en a une
				Launch( Clip.Brain.WalkSpecial.Points[ Clip.Brain.WalkSpecial.Point ].fonction );
				
				// Avance la tête du point
				Clip.Brain.WalkSpecial.Point++; 
				
				// S'il y a un chemin suivant ou si on tourne en boucle —— - -
				if( Clip.Brain.WalkSpecial.Points[ Clip.Brain.WalkSpecial.Point ] || Boucle ){
					
					// S'il n'y a pas de chemin suivant, retourne au premier
					if( !Clip.Brain.WalkSpecial.Points[ Clip.Brain.WalkSpecial.Point ] ){ Clip.Brain.WalkSpecial.Point = 0; }
				
					// Définit les valeurs des étapes
					Clip.Brain.WalkSpecial.EtapeX = Round( ( Clip.Brain.WalkSpecial.Points[ Clip.Brain.WalkSpecial.Point ].x - Clip.Brain.WalkSpecialX ) 
																/ ( Clip.Brain.WalkSpecial.Points[ Clip.Brain.WalkSpecial.Point ].speed || Vitesse ) , 4 );
					Clip.Brain.WalkSpecial.EtapeY = Round( ( Clip.Brain.WalkSpecial.Points[ Clip.Brain.WalkSpecial.Point ].y - Clip.Brain.WalkSpecialY ) 
																/ ( Clip.Brain.WalkSpecial.Points[ Clip.Brain.WalkSpecial.Point ].speed || Vitesse ) , 4 );
				
				// S'il n'y a pas de chemin suivant et qu'on ne tourne pas en boucle —— - -
				} else {
					
					// Bloque le déplacement des étapes
					Clip.Brain.WalkSpecial.EtapeX = 0;
					Clip.Brain.WalkSpecial.EtapeY = 0;
				}
			}
			
			// A l'aide des mouvements du chemin, modifie la vitesse pour inclure le mouvement
			Clip.Brain.speedX += Clip.Brain.WalkSpecialX - ( Clip.Brain.MemoCheminX || 0 );
			Clip.Brain.speedY += Clip.Brain.WalkSpecialY - ( Clip.Brain.MemoCheminY || 0 );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				   REACTION					  		  				  	  */
		/*					 Méthodes ayant un déclanchement lors d'un agissement de l'utilisateur 				  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - POSITION - - —————————————————————————————————————————— */
		// Les méthodes pour modifier la position de l'élément
		//*—*//
		
		// —————— RIGHT DIRECT
		// L'élément se dirige vers la droite
	  
		public function RightDirect( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var Vitesse:Number = Aspiration( Parametres.speed , 3 );
			var speedX:Number = Aspiration( Parametres.speedX , 0 );
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
			
				// Le clip va vers la droite
				Element.x += Vitesse + speedX;
			}
		}
	  
		
		// —————— LEFT DIRECT
		// L'élément se dirige vers la gauche
	  
		public function LeftDirect( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var Vitesse:Number = Aspiration( Parametres.speed , 3 );
			var speedX:Number = Aspiration( Parametres.speedX , 0 );
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
				
				// Le clip va vers la gauche
				Element.x -= Vitesse + speedX;
			}
		}
	  
		
		// —————— DOWN DIRECT
		// L'élément se dirige vers le bas
	  
		public function DownDirect( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var Vitesse:Number = Aspiration( Parametres.speed , 3 );
			var speedY:Number = Aspiration( Parametres.speedY , 0 );
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
			
				// Le clip va vers le bas
				Element.y += Vitesse + speedY;
			}
		}
	  
		
		// —————— UP DIRECT
		// L'élément se dirige vers le haut
	  
		public function UpDirect( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var Vitesse:Number = Aspiration( Parametres.speed , 3 );
			var speedY:Number = Aspiration( Parametres.speedY , 0 );
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
				
				// Le clip va vers le haut
				Element.y -= Vitesse + speedY;
			}
		}
		
		
		// —————— FRONT SPEED
		// Fait tendre la vitesse au-dessus de zéro
	  
		public function FrontSpeed( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var Vitesse:Number = Aspiration( Parametres.speed , 3 );
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
			  
				// La vitesse avance
				Element.Brain.speed += Vitesse;
			}
		}
	  
		
		// —————— BACK SPEED
		// Fait tendre la vitesse au-dessus de zéro
	  
		public function BackSpeed( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var Vitesse:Number = Aspiration( Parametres.speed , 3 );
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
			  
				// La vitesse recule
				Element.Brain.speed -= Vitesse;
			}
		}
		
		
		// —————— RIGHT SPEED
		// L'élément se dirige vers la droite
	  
		public function RightSpeed( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var Vitesse:Number = Aspiration( Parametres.speed , 3 );
			var speedX:Number = Aspiration( Parametres.speedX , 0 );
			//
			var MaxVitesse:Number = Aspiration( Parametres.speedMax , 100 );
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
				
				// La vitesse tend vers la droite
				Element.Brain.speedX += Vitesse + speedX;
			}
		}
	  
		
		// —————— LEFT SPEED
		// L'élément se dirige vers la gauche avec un effet de vitesse
	  
		public function LeftSpeed( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var Vitesse:Number = Aspiration( Parametres.speed , 3 );
			var speedX:Number = Aspiration( Parametres.speedX , 0 );
			//
			var MaxVitesse:Number = Aspiration( Parametres.speedMax , 100 );
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
			  
				// La vitesse tend vers la gauche
				Element.Brain.speedX -= Vitesse + speedX;
			}
		}
	  
		
		// —————— DOWN SPEED
		// L'élément se dirige vers le bas avec un effet de vitesse
	  
		public function DownSpeed( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var Vitesse:Number = Aspiration( Parametres.speed , 3 );
			var speedY:Number = Aspiration( Parametres.speedY , 0 );
			//
			var MaxVitesse:Number = Aspiration( Parametres.speedMax , 100 );
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
			  
				// La vitesse tend vers le bas
				Element.Brain.speedY += Vitesse + speedY;
			}
		}
	  
		
		// —————— UP SPEED
		// L'élément se dirige vers le haut avec un effet de vitesse
	  
		public function UpSpeed( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var Vitesse:Number = Aspiration( Parametres.speed , 3 );
			var speedY:Number = Aspiration( Parametres.speedY , 0 );
			//
			var MaxVitesse:Number = Aspiration( Parametres.speedMax , 100 );
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
			
				// La vitesse tend vers le haut
				Element.Brain.speedY -= Vitesse + speedY;
			}
		}
	  
		
		// —————— UP LEFT SPEED
		// L'élément se dirige vers la diagonale haut-gauche avec un effet de vitesse
	  
		public function UpLeftSpeed( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var Vitesse:Number = Aspiration( Parametres.speed , 3 );
			var MaxVitesse:Number = Aspiration( Parametres.speedMax , 100 );
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
			
				// La vitesse tend vers la diagonale
				Element.Brain.speedX += Vitesse / 2;
				Element.Brain.speedY -= Vitesse / 2;
			}
		}
	  
		
		// —————— UP RIGHT SPEED
		// L'élément se dirige vers la diagonale haut-droite avec un effet de vitesse
	  
		public function UpRightSpeed( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var Vitesse:Number = Aspiration( Parametres.speed , 3 );
			var MaxVitesse:Number = Aspiration( Parametres.speedMax , 100 );
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
			
				// La vitesse tend vers la diagonale
				Element.Brain.speedX -= Vitesse / 2;
				Element.Brain.speedY -= Vitesse / 2;
			}
		}
	  
		
		// —————— DOWN LEFT SPEED
		// L'élément se dirige vers la diagonale bas-gauche avec un effet de vitesse
	  
		public function DownLeftSpeed( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var Vitesse:Number = Aspiration( Parametres.speed , 3 );
			var MaxVitesse:Number = Aspiration( Parametres.speedMax , 100 );
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
				
				// La vitesse tend vers la diagonale
				Element.Brain.speedX += Vitesse / 2;
				Element.Brain.speedY += Vitesse / 2;
			}
		}
	  
		
		// —————— DOWN RIGHT SPEED
		// L'élément se dirige vers la diagonale bas-droite avec un effet de vitesse
	  
		public function DownRightSpeed( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var Vitesse:Number = Aspiration( Parametres.speed , 3 );
			var MaxVitesse:Number = Aspiration( Parametres.speedMax , 100 );
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
			  
				// La vitesse tend vers la diagonale
				Element.Brain.speedX -= Vitesse / 2;
				Element.Brain.speedY += Vitesse / 2;
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - ROTATION - - —————————————————————————————————————————— */
		// Les méthodes pour modifier la rotation de l'élément
		//*—*//
		
		// —————— TURN RIGHT DIRECT
		// L'élément tourne vers la droite
	  
		public function TurnRightDirect( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var speedRotation:Number = Aspiration( Parametres.speedRotation , 3 );
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
			
				// Le clip tourne vers la droite
				Element.rotation += speedRotation
			}
		}
	  
		
		// —————— TURN LEFT DIRECT
		// L'élément tourne vers la gauche
	  
		public function TurnLeftDirect( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var speedRotation:Number = Aspiration( Parametres.speedRotation , 3 );
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
			  
				// Le clip tourne vers la gauche
				Element.rotation -= speedRotation
			}
		}
	  
		
		// —————— TURN RIGHT SPEED
		// L'élément tourne vers la droite avec un effet de vitesse
	  
		public function TurnRightSpeed( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var speedRotation:Number = Aspiration( Parametres.speedRotation , 3 );
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
			  
				// Le vitesse de rotation tend vers la droite
				Element.Brain.speedRotation += speedRotation;
			}
		}
	  
		
		// —————— TURN LEFT SPEED
		// L'élément tourne vers la gauche avec un effet de vitesse
	  
		public function TurnLeftSpeed( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var speedRotation:Number = Aspiration( Parametres.speedRotation , 3 );
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
			  
				// La vitesse de rotation tend vers la droite
				Element.Brain.speedRotation -= speedRotation;
			}
		}
		
		
		// —————— TURN LEFT DIRECTION
		// Se tourne de façon à regarder en direction de la gauche
	  
		public function TurnLeftDirection( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var speedRotation:Number = Aspiration( Parametres.speedRotation , 10 );
			//
			speedRotation = ( speedRotation <= 0 ) ? 1 : speedRotation;
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
				
				// Le clip regarde vers sa cible
				AngleGoTo( Element , 180 , speedRotation );
			}
		}
		
		
		// —————— TURN RIGHT DIRECTION
		// Se tourne de façon à regarder en direction de la gauche
	  
		public function TurnRightDirection( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var speedRotation:Number = Aspiration( Parametres.speedRotation , 10 );
			//
			speedRotation = ( speedRotation <= 0 ) ? 1 : speedRotation;
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
				
				// Le clip regarde vers sa cible
				AngleGoTo( Element , 0 , speedRotation );
			}
		}
		
		
		// —————— TURN UP DIRECTION
		// Se tourne de façon à regarder en direction de la gauche
	  
		public function TurnUpDirection( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var speedRotation:Number = Aspiration( Parametres.speedRotation , 10 );
			//
			speedRotation = ( speedRotation <= 0 ) ? 1 : speedRotation;
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
				
				// Le clip regarde vers sa cible
				AngleGoTo( Element , -90 , speedRotation );
			}
		}
		
		
		// —————— TURN DOWN DIRECTION
		// Se tourne de façon à regarder en direction de la gauche
	  
		public function TurnDownDirection( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var speedRotation:Number = Aspiration( Parametres.speedRotation , 10 );
			//
			speedRotation = ( speedRotation <= 0 ) ? 1 : speedRotation;
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
			  
				// Le clip regarde vers sa cible
				AngleGoTo( Element , 90 , speedRotation );
			}
		}
		
		
		// —————— TURN UP LEFT DIRECTION
		// Se tourne de façon à regarder en direction de la diagonale haut-gauche
	  
		public function TurnUpLeftDirection( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var speedRotation:Number = Aspiration( Parametres.speedRotation , 10 );
			//
			speedRotation = ( speedRotation <= 0 ) ? 1 : speedRotation;
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
				
				// Le clip regarde vers sa cible
				AngleGoTo( Element , -135 , speedRotation );
			}
		}
		
		
		// —————— TURN UP RIGHT DIRECTION
		// Se tourne de façon à regarder en direction de la diagonale haut-droite
	  
		public function TurnUpRightDirection( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var speedRotation:Number = Aspiration( Parametres.speedRotation , 10 );
			//
			speedRotation = ( speedRotation <= 0 ) ? 1 : speedRotation;
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
				
				// Le clip regarde vers sa cible
				AngleGoTo( Element , -45 , speedRotation );
			}
		}
		
		
		// —————— TURN DOWN LEFT DIRECTION
		// Se tourne de façon à regarder en direction de la diagonale bas-gauche
	  
		public function TurnDownLeftDirection( Parametres:Object ):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var speedRotation:Number = Aspiration( Parametres.speedRotation , 10 );
			//
			speedRotation = ( speedRotation <= 0 ) ? 1 : speedRotation;
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
				
				// Le clip regarde vers sa cible
				AngleGoTo( Element , 135 , speedRotation );
			}
		}
		
		
		// —————— TURN DOWN RIGHT DIRECTION
		// Se tourne de façon à regarder en direction de la diagonale bas-droite
	  
		public function TurnDownRightDirection( Parametres:Object	):void {
			/*—*/
			
			// Parametres par défaut
			var Element:* = Parametres.Element;
			var speedRotation:Number = Aspiration( Parametres.speedRotation , 10 );
			//
			speedRotation = ( speedRotation <= 0 ) ? 1 : speedRotation;
			
			// Si le Player est Active —— - -
			if( Element.Brain.BrainProcess.Active ){
				
				// Le clip regarde vers sa cible
				AngleGoTo( Element , 45 , speedRotation );
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				   MODIFICATION					  		  				  */
		/*					 				Méthodes ayant un déclanchement en externe 				  			  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - POSITION - - —————————————————————————————————————————— */
		// Les méthodes pour modifier la position de l'élément
		//*—*//
		
		// —————— BOUNCE
		// Fait rebondir le joueur
	  
		public function Bounce( Element:* , 		// ———— - - L'Élément
							    Arguments:Object	// ———— - - Les Arguments
							  ):void {
			/*—*/
			
			// Rebond dans une direction choisie
			//
			// Droite
			if( Arguments.right ){ Element.Brain.speedX -= Arguments.right; }
			//
			// Gauche
			if( Arguments.left ){ Element.Brain.speedX -= Arguments.left; }
			//
			// Haut
			if( Arguments.up ){ Element.Brain.speedY -= Arguments.up; }
			//
			// Bas
			if( Arguments.down ){ Element.Brain.speedY -= Arguments.down; }
			
			// Rebond par rapport à une cible —— - -
			if( Arguments.target ){
			  
				// Si la cible est particulière —— - -
				if( Arguments.target.X ){
				  
					// Récupére ses valeurs de position majuscule dans un objet de position minuscule
					var TransfereCible:Object = { x:Arguments.target.X , y:Arguments.target.Y };
					Arguments.target = TransfereCible;
				}
				
				// Rebond par rapport à l'angle avec l'élément
				Element.Brain.speedX -= Math.cos( GetAngle( Element , Arguments.target ) / 180 * Math.PI ) * ( Arguments.strength || 1 );
				Element.Brain.speedY -= Math.sin( GetAngle( Element , Arguments.target ) / 180 * Math.PI ) * ( Arguments.strength || 1 );
			}
		}
		
		
		
	
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}