﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			DESKTOP CHIP	 		Version 0.7.2									***/
/***				   				   Dernière Mise à Jour : 10-09-29										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         			   Intelligence Bureautique											***/
/***		 Ce script forme un clip pour qu'il puisse agir comme un élément de style bureautique.		    ***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Dynamic {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	
	// —— - - DISPLAY
	import flash.display.MovieClip;
	//
	// —— - - EVENT
	import flash.events.Event;
	import flash.events.MouseEvent;
	//
	// —— - - TEXT
	import flash.text.TextField;
	import flash.text.TextFormat;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	import drOIde.Port.*;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class DesktopChip extends MiscTools {
		
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		
		// —————— ELEMENT
	    //— L'élément auquel est rattaché le script
		private var Element:*;
		
		
		// —————— TYPE LIST
	    // Liste des différents éléments possibles
		private var TypeList:Object = { Elevator:[ "UpArrow" , "DownArrow" , "Center" ] ,
										InputText:[ "Input" ] ,
										PointButton:[ "Button" , "!Text" , "!Combo" ] ,
										TextButton:[ "Button" , "Text" , "!Combo" ] ,
										ComboBox:[ "Button" , "Text" , "Combo" ] ,
										Bubble:[ "BubbleText" ]
									  };
		
		
		// —————— LINK
	    // Les scripts en chargement externe
		private var Mouse:MousePort;

		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function DesktopChip():void { 
			/*—*/
			
			// Instance de l'élément porteur
			Element = this; 
			
			// Établie la connexion
			Connexion( Element );
			
			// Lance le checking elements avec une frame de retard
			CountdownLaunch( Check , 1 );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					GLOBAL					  		  					  */
		/*								   Méthodes d'exploitation global du script 					  		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - CHECK - - —————————————————————————————————————————— */
		// Les méthodes qui sonde l'état de l'élément pour lui donner son intelligence
		//*—*//
		
		// —————— CHECK           									 	
		// Vérifie le nom d'un MovieClip pour voir s'il contient un nom relatif pour une fonction
	
		public function Check():void {
			/*—*/
			
			// Sortie initiale
			var Sortie:String = "";
			
			// Pour chaque élément potentiel —— - -
			for( var Clip:* in TypeList ){
				
				// Résultat des check clip à zéro
				var Test:int = 0;
				
				// Pour chaque clip de l'élément —— - -
				for( var i:int = 0 ; i < TypeList[ Clip ].length ; i++ ){
					
					// Si le nom du clip correspond à un dans l'élément ou ne correspond pas suivant la demande —— - - Augmente la valeur de test
					//
					if( !FindIn( TypeList[ Clip ][ i ] , "!" ) ){
						//
						if( Element[ TypeList[ Clip ][ i ] ] ){ Test++; }
						//
					} else if( FindIn( TypeList[ Clip ][ i ] , "!" ) ){
						//
						if( !Element[ Pop( TypeList[ Clip ][ i ] , "!" ) ] ){ Test++; }
					}
				}
				
				// Si on les a tous trouvé —— - - On calibre la sortie sur cet élément
				if( Test == TypeList[ Clip ].length ){ Sortie = Clip; }
			}
			
			// Si on a trouvé une sortie —— - - On lance son calibrage
			if( Sortie != "" ){ this[ Sortie ](); }
			//
			// Sinon —— - - Trace l'erreur
			else {
				//
				TraceError( "ManipChip" , "Check" , [ "Aucun élément ne peux être conçut à partir des clips de l'élément" , "" , TellMeList() ] );
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				  ELEVATOR					  		  					  */
		/*								 Méthodes pour un élément de type ascenseur 					  		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - APPLY - - —————————————————————————————————————————— */
		// Les méthodes de fonctionnement de l'ascenseur
		//*—*//
	  
		// —————— ELEVATOR
		// Calibre un élément de type Ascenseur
	
		public function Elevator():void {
			/*—*/
			
			// Variable de captation d'erreur vérifiant l'intégrité des éléments avant de débuter la mise en place
			var Erreur:Boolean = false
			
			var Center:* = Element.Center;
			var DownArrow:* = Element.DownArrow;
			var UpArrow:* = Element.UpArrow;
			
			// Si la fléche bas est au-dessus de la fléche haut —— - - Affiche une erreur
			if( Element.UpArrow.y > Element.DownArrow.y ){
				//
				TraceError( "DesktopChip" , "Elevator" , "La UpArrow ( Fléche du haut ) doit se trouver plus haut que la DownArrow ( Fléche du bas )." );
				//
				Erreur = true;
			}
			
			// Si le Center ne se trouve pas entre les deux fléches —— - - Affiche une erreur
			if( Element.Center.y > Element.DownArrow.y || Element.Center.y < Element.UpArrow.y ){
				//
				TraceError( "DesktopChip" , "Elevator" , "Le Center doit se trouver entre les deux fléches." );
				//
				Erreur = true;
			}
			
			// Si le Center ne se trouve pas le stage —— - - Affiche une erreur
			if( !StageLink ){
				//
				TraceError( "DesktopChip" , "Elevator" , [ "L'Elevator n'a pas de lien vers stage." , 
															 "Cette erreur viens certainement du fait que l'Elevator a été créait dynamiquement." ,
															 "Vous devrez donner le lien du stage à la main à l'Elevator puis relancer la méthode Elevator()"
															 ] );
				//
				Erreur = true;
			}
			
			
			// S'il n'y a pas eu d'erreur —— - -
			if( !Erreur ){
				
				// Créait la souris
				Mouse = new MousePort( Element );
				
				// Définit un pourcentage initial
				Element.ratio = Element.ratio || 100;
				Element.downShift = Element.downShift || 0;
				Element.Decalage;
				
				// Définit les éléments de type bouton
				Element.Center.buttonMode = true;
				Element.DownArrow.buttonMode = true;
				Element.UpArrow.buttonMode = true;
				
				
				// Lorsqu'on clic sur le Center —— - -
				Center.Drag = function( event:MouseEvent ):void {
					/**/
					
					// Définit le décalage en Y par rapport à la souris
					Center.DecalageY = Mouse.Y - Center.y;
					
					// Donne l'événement de mouvement souris pour le déplacement du Center
					AddEvents( StageLink , Center.Deplace , "MOUSE_MOVE" , Element.name + "CenterDrag" );
					
					// Lance la fonction relative au clic du Center
					Launch( Element.centerDown );
				}
				
				
				// Lorsqu'on relache le Center —— - -
				Center.Drop = function( event:MouseEvent ):void {
					/**/
					
					// Chut préalable au cas où on fasse un déclic sans clic
					Chut();
					
					// Retire l'événement de déplacement souris
					RemoveEvents( StageLink , Center.Deplace , "MOUSE_MOVE" , Element.name + "CenterDrag" );
					
					// Lance la fonction relative au relachement du Center
					Launch( Element.centerUp );
					
					// Fin de Chut
					Chut( false );
				}
				
				
				//  Lorsqu'on fait bouger la molette —— - -
				Center.Roule = function( event:MouseEvent ):void {
					/**/
					
					// S'il est visible —— - -
					if( Element.visible ){
						
						// Tente —— - -
						try{
								
							// Si la souris se trouve au-dessus de la zone du contenu —— - -
							if( Mouse.Y > Element.target.PositionZero && Mouse.Y < Element.target.PositionZero + Element.hide
							 && Mouse.X > Element.target.x && Mouse.X < Element.target.x + Element.target.width ){
								
								// Déplace le Center dans la direction molette
								Element.ModifieCenter( Center.y - event.delta );
							
								// Lance la fonction relative a la molette
								Launch( Element.centerWheel );
							}
						} catch( e ){}
					}
				}
				
				
				// Lorsqu'on bouge la souris —— - -
				Center.Deplace = function( event:MouseEvent ):void {
					/**/
					
					// S'il est visible —— - -
					if( Element.visible ){
					
						// On déplace le Center sur la souris
						Element.ModifieCenter( Mouse.Y - Center.DecalageY );
					}
				}
				
				
				// Lorsqu'on modifie la position du Center —— - -
				Element.ModifieCenter = function( Valeur:Number ):void {
					/**/
					
					// Modifie la position du Center
					Center.y = Valeur;
					
					// S'il dépasse par le bas —— - - Bloque en bas
					if( Center.y > DownArrow.y - Center.height ){ Center.y = DownArrow.y - Center.height; }
					//
					// S'il dépasse par le haut —— - - Bloque en haut
					if( Center.y < UpArrow.y ){ Center.y = UpArrow.y; }
					
					// S'il a une cible —— - -
					if( Element.target ){
						
						// Modifie la position du contenu en fonction du Center
						Element.target.y = Element.target.PositionZero - ( ( Center.y - UpArrow.y ) * ( Element.PasMouvement || 1 ) );
					}
					
					// Lance la fonction relative à la modification du Center
					Launch( Element.centerChange );
				}
				
				
				// Lorsqu'on clic sur une fleche —— - -
				Element.ClicFleche = function( event:MouseEvent ):void {
					/**/
					
					// On donne la boucle de déplacement du Center
					AddEvents( event.target , Element.BoucleFleche , "ENTER_FRAME" , "ArrowLoop" );
					
					
					// Si c'est la fléche du bas —— - -
					if( event.target.name == "DownArrow" ){
						
						// Lance la fonction relative au clic fleche bas
						Launch( Element.downDown );
					
					// Si c'est la fléche du haut —— - -
					} else {
						
						// Lance la fonction relative au clic fleche hait
						Launch( Element.upDown );
					}
				}
				//
				// Lorsqu'on déclic sur une fleche —— - -
				Element.DeclicFleche = function( event:MouseEvent ):void {
					/**/
					
					// Chut préalable au cas où on fasse un déclic sans clic
					Chut();
						
					// On retire la boucle de déplacement du Center
					RemoveEvents( event.target , Element.BoucleFleche , "ENTER_FRAME" , "ArrowLoop" );
					
					
					// Si c'est la fléche du bas —— - -
					if( event.target.name == "DownArrow" ){
						
						// Lance la fonction relative au relachement fleche bas
						Launch( Element.downUp );
					
					// Si c'est la fléche du haut —— - -
					} else {
						
						// Lance la fonction relative au relachement fleche hait
						Launch( Element.upUp );
					}
					
					// Fin de Chut
					Chut( false );
				}
				//
				// Constemment quand on a cliqué sur la fléche —— - -
				Element.BoucleFleche = function( event:Event ):void {
					/**/
					
					// Si c'est la fléche du bas —— - -
					if( event.target.name == "DownArrow" ){
						
						// On déplace le Center vers le bas
						Element.ModifieCenter( Center.y + 2 );
					
					// Si c'est la fléche du haut —— - -
					} else {
						
						// On déplace le Center vers le haut
						Element.ModifieCenter( Center.y - 2 );
					}
				}
				//
				// Constemment —— - -
				Element.Boucle = function( event:Event ):void {
					/**/
					
					// Calibrage des éléments
					Element.Decalage = Element.Decalage || 0;
					
					// Récupére la distance entre les deux fléches
					Element.DistanceFleches = DownArrow.y - UpArrow.y;
					
					// Récupére la taille général en retirant la taille du Center
					Element.TailleGeneral = Element.DistanceFleches - Center.height;
					
					
					// S'il y a une cible de contenu —— - -
					if( Element.target ){ 
						
						// Si elle n'a pas encore de point zéro —— - -
						if( Element.target.PositionZero == null ){
							//
							// Lui donne son point zéro à partir de sa position
							Element.target.PositionZero = Element.target.y;
						}
						
						// Si elle n'est pas encore calibré —— - -
						if( !Element.target.EstCalibre ){
							
							// Positionne la cible une première fois en fonction de la position du Center
							Element.target.y = Element.target.PositionZero - ( ( Center.y - UpArrow.y ) * ( Element.PasMouvement || 1 ) );
							//
							// Elle est calibrée
							Element.target.EstCalibre = true;
						}
						
						// Si un cache a été définit —— - -
						if( Element.hide ){
							
							// Si la molette n'a pas été calibré —— - -
							if( !Element.target.MoletteEstCalibre ){
								
								// Donne l'événement de molette
								AddEvents( StageLink , Center.Roule , "MOUSE_WHEEL" , Element.name + "Roll" );
								//
								// La molette est calibrée
								Element.target.MoletteEstCalibre = true;
							}
							
							// Si le cache n'est pas un chiffre brut mais un clip —— - - Le transforme pour sa hauteur
							if( !TypeOf( Element.hide , "Number" ) ){ Element.hide = Element.hide.height; }
							
							// Si le cache est plus grand que le contenu —— - -
							if( Element.hide >= Element.target.height - Element.Decalage ){
								
								// Rend l'Elevator invisible —— - -
								Element.visible = false;
								
							// Si le cache est plus petit que le contenu
							} else {
								
								// Rend l'Elevator visible —— - -
								Element.visible = true;
							}
							
							// Définit le pourcentage de déplacement du contenu
							Element.PasMouvement = ( ( ( Element.target.height - Element.Decalage ) + Element.downShift ) - Element.hide ) 
												   / Element.TailleGeneral;
							
							// Modifie la hauteur du Center suivant la taille du contenu
							Center.height = ( Element.DistanceFleches * ( Element.hide / ( Element.target.height - Element.Decalage ) ) ) 
																	  * ( Element.ratio / 100 );
							//
							// Bump de la hauteur du contenu
							//
							// Min
							if( Center.height < ( Element.sizeMin || 10 ) ){ Center.height = ( Element.sizeMin || 10 ); }
							//
							// Max
							if( Center.height > ( Element.sizeMax || Element.DistanceFleches ) ){ 
													Center.height = ( Element.sizeMax || Element.DistanceFleches ); }
						}
					}
					
					// Lance la fonction relative à la boucle
					Launch( Element.loop );
				}
				//
				// Donne les événements à l'Elevator
				AddEvents( Center , Center.Drag , "MOUSE_DOWN" );
				AddEvents( StageLink , Center.Drop , "MOUSE_UP" , Element.name + "CenterDrop" );
				AddEvents( Element , Element.Boucle , "ENTER_FRAME" );
				//
				AddEvents( DownArrow , Element.ClicFleche , "MOUSE_DOWN" );
				AddEvents( UpArrow , Element.ClicFleche , "MOUSE_DOWN" );
				//
				AddEvents( DownArrow , Element.DeclicFleche , "MOUSE_UP" );
				AddEvents( UpArrow , Element.DeclicFleche , "MOUSE_UP" );
				
				
				
				// Fonction de post-vérification du calibrage externe —— - -
				Element.PostVerif = function():void {
					
					// Si rien n'a été modifié —— - -
					if( !Element.sizeMin && !Element.sizeMax && Element.ratio == 100
					 && !Element.hide && !Element.target
					 && !Element.centerDown && !Element.centerUp && !Element.centerWheel && !Element.centerChange
					 && !Element.downDown && !Element.downUp && !Element.upDown && !Element.upUp
					 && !Element.loop ){
						//
						// Trace l'erreur
						TraceError( "DesktopChip" , "Elevator" , [ "Aucune modification n'a été apportée à l'Elevator" , 
																	 "Afin que l'Elevator soit calibré correctement, vous devez utiliser au moins quelques" ,
																	 "une de ces variables :" ,
																	 "\t-ratio ( Pourcentage d'adaptation du Center sur la taille du contenu )" ,
																	 "\t-sizeMin ( Taille minimale du Center )" ,
																	 "\t-sizeMax ( Taille maximale du Center )" ,
																	 "\t-downShift ( Ajout de décalage par le bas au défilement du contenu )" ,
																	 "\t-target ( Le contenu qui bouge )" ,
																	 "\t-hide ( Le cache définissant ce qui est présenté du contenu, masque ou autre )" ,
																	 "" ,
																	 "\t-centerDown ( Fonction lancée au clic sur le Center )" ,
																	 "\t-centerUp ( Fonction lancée au relachement du Center )" ,
																	 "\t-centerWheel ( Fonction lancée au mouvement molette )" ,
																	 "\t-centerChange ( Fonction lancée lors de la modification de position du Center )" ,
																	 "\t-downDown ( Fonction lancée lors du clic fleche bas )" ,
																	 "\t-downUp ( Fonction lancée lors du relachement fleche bas )" ,
																	 "\t-upDown ( Fonction lancée lors du clic fleche haut )" ,
																	 "\t-upUp ( Fonction lancée lors du relachement fleche haut )" ,
																	 "\t-loop ( Fonction lancée constemment )" ] );
					}
				}
				//
				// Donne le reboursde fonction
				CountdownLaunch( { Fonction:Element.PostVerif } , 10 );
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				   INPUT					  		  					  */
		/*							  Méthodes pour un élément de type champ de saisie 					  		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - APPLY - - —————————————————————————————————————————— */
		// Les méthodes de fonctionnement de champ de saisie
		//*—*//
	  	
		// —————— INPUT TEXT
		// Calibre un élément de type champ de saisie uniligne
	
		public function InputText():void {
			/*—*/
			
			// Récupère ses valeurs
			var Input:* = Element.Input;
			var WidthMin:* = Element.widthMin || 50;
			var WidthMax:* = Element.widthMax;
			//
			var Background:* = Element.Background;
			var BackgroundBump:* = Element.backgroundBump || ( Background != null ? Background.width - Input.width : 0 );
			//
			var fonctionLoop:* = Element.fonction || Element.fonctionLoop || Element.fonctionChange;
			//
			var Auto:Boolean = Element.auto || ( WidthMin != 50 || WidthMax != null ) ? true : false;
			//
			var WidthInput:* = Element.widthInput;
			var MaxChars:* = Element.maxChars;
			
			// Calibre ses caractère maximals s'il en a —— - -
			if( MaxChars ){
				//
				Input.maxChars = MaxChars;
			}
			
			// Donne la fonction de changement —— - -
			Element.Change = function( Taille:Number ):void {
				
				// Calibre la taille de la zone de saisie
				Input.width = Taille;
				
				// S'il y a un background —— - -
				if( Background ){
					
					// Calibre la taille du background
					Background.width = Input.width + BackgroundBump;
				}
				
				// Lance la fonction de boucle
				Launch( fonctionLoop );
			}
			
			// Calibre sa taille
			Element.Change( WidthInput );
			
			
			// Donne sa fonction de boucle —— - -
			var BoucleInput:Function = function( event:Event ):void {
				
				// Calibre la taille de la zone de saisie
				Element.Change( BumpNumber( Input.textWidth , WidthMin , WidthMax ) + 20 );
			}
			
			// S'il est auto-change —— - -
			if( Auto ){
				
				// Lance la boucle
				AddEvents( Element , BoucleInput , "ENTER_FRAME" );
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				   BUTTON					  		  					  */
		/*							  	  Méthodes pour un élément de type bouton 					  		  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - APPLY - - —————————————————————————————————————————— */
		// Les méthodes de fonctionnement bouton
		//*—*//
	  	
		// —————— POINT BUTTON
		// Calibre un élément de type bouton simple
	
		public function PointButton():void {
			/*—*/
			
			// Récupère ses valeurs
			var Button:* = Element.Button;
			//
			var fonctionOver:* = Element.fonctionOver;
			var fonctionOut:* = Element.fonctionOut;
			//
			var fonctionDown:* = Element.fonctionDown;
			var fonctionUp:* = Element.fonctionUp;
			//
			var fonctionChange:* = Element.fonctionChange;
			//
			var Tie:* = Element.Tie;
				
			// S'il a un élément lié —— - - Mémorise sa position
			if( Tie ){
				//
				Element.TieX = ( Element.Tie.InitialX || Element.Tie.x ) - ( Element.InitialX || Element.x ) - Element.width;
			}
			
			// Donne la fonction de modification à l'élément —— - -
			Element.Change = function( Nothing:* = null ):void {
				
				// Lance la fonction de changement
				Launch( fonctionChange );
				
				// S'il a un élément lié —— - - Modifie sa position
				if( Tie ){
					//
					if( Element.Tie.Change ){
						//
						Element.Tie.Change( Element.Tie.text );
					}
					//
					Element.Tie.InitialX = Element.Tie.InitialX || Element.Tie.x;
					//
					Element.Tie.x = Element.x + Element.TieX + Element.width;
				}
			}
			
			// Lance la modification du texte
			Element.Change();
			
			// Définit le bouton en Cliquable
			Element.buttonMode = true;
			
			// Interrompt l'animation du bouton
			Button.gotoAndStop( "normal" );
			
			
			// Fonction au survol —— - -
			var StateMouseOver:Function = function( event:MouseEvent ):void {
				
				// Lance la fonction d'Over
				Launch( fonctionOver );
			
				// Modifie la forme du bouton
				Button.gotoAndStop( "over" );
			}
			
			
			// Fonction au désurvol —— - -
			var StateMouseOut:Function = function( event:MouseEvent ):void {
				
				// Lance la fonction d'Out
				Launch( fonctionOut );
			
				// Modifie la forme du bouton
				Button.gotoAndStop( "normal" );
			}
			
			
			// Fonction à l'appuis —— - -
			var StateMouseDown:Function = function( event:MouseEvent ):void {
				
				// Lance la fonction de Down
				Launch( fonctionDown );
			
				// Modifie la forme du bouton
				Button.gotoAndStop( "down" );
			}
			
			
			// Fonction au relachement —— - -
			var StateMouseUp:Function = function( event:MouseEvent ):void {
				
				// Lance la fonction de Up
				Launch( fonctionUp );
			
				// Modifie la forme du bouton
				Button.gotoAndStop( "over" );
			}
			
			// Définit les événements
			AddEvents( Element , StateMouseOver , "MOUSE_OVER" );
			AddEvents( Element , StateMouseOut , "MOUSE_OUT" );
			AddEvents( Element , StateMouseDown , "MOUSE_DOWN" );
			AddEvents( Element , StateMouseUp , "MOUSE_UP" );
		}
	  	
		
		// —————— TEXT BUTTON
		// Calibre un élément de type bouton à texte
	
		public function TextButton():void {
			/*—*/
			
			// Récupère ses valeurs
			var Text:* = Element.Text;
			var Button:* = Element.Button;
			var ButtonBump:* = Element.buttonBump || Button.width - Text.width;
			var Shift:Number = Element.shift || 5;
			var Align:String = Element.align || "left";
			//
			var text:String = Element.text || Text.text;
			//
			var fonctionOver:* = Element.fonctionOver;
			var fonctionOut:* = Element.fonctionOut;
			//
			var fonctionDown:* = Element.fonctionDown;
			var fonctionUp:* = Element.fonctionUp;
			//
			var fonctionChange:* = Element.fonctionChange;
			//
			var Tie:* = Element.Tie;
			var Tied:* = Element.Tied;
			//
			var InitialX:Number = Element.x;
			var InitialWidth:Number = Element.width;
				
			// S'il a un élément lié —— - - Mémorise sa position
			if( Tie ){
				//
				Element.TieX = ( Element.Tie.InitialX || Element.Tie.x ) - 
							   ( Element.InitialX || Element.x ) - 
							   ( Align == "left" ? Element.width : 0 ) + 
							   ( Align == "right" ? Element.Tie.InitialWidth || Element.Tie.width : 0 );
				//
				if( Align == "center" ){
					//
					Element.TieX += ( Tie.align == "left" ? -Element.width : Element.width );
				}
				//
				Tie.Tied = Element;
			}
			
			// Donne la fonction de modification à l'élément —— - -
			Element.Change = function( ContenuText:String ):void {
				
				// Modifie le contenu du champ de texte
				Text.text = Element.text = TrimSpace( ContenuText , " " );
				
				// Modifie la largeur du champ de texte
				Text.width = Text.textWidth + Shift;
				
				// Modifie la largeur du bouton
				Button.width = Text.width + ButtonBump;
				
				// Lance la fonction de changement
				Launch( fonctionChange , [ ContenuText ] );
				
				// Modifie sa position suivant son alignement s'il n'est pas attaché —— - -
				if( !Tied ){
					//
					if( Align == "right" ){
						//
						Element.x = InitialX - ( Element.width - InitialWidth );
						//
					} else if( Align == "center" ){
						//
						Element.x = InitialX - ( Element.width - InitialWidth ) / 2;
					}
				
				// S'il est attaché —— - - Provoque son calibrage
				} else {
					//
					Tied.Change( Tied.text );
				}
				
				// S'il a un élément lié —— - - Modifie sa position
				if( Tie ){
					//
					Element.Tie.InitialX = Element.Tie.InitialX || Element.Tie.x;
					//
					Element.Tie.x = Element.x;
					//
					if( Align == "left" ){
						//
						Element.Tie.x += Element.TieX + Element.width;
						//
					} else if( Align == "center" ){
						//
						Element.Tie.x += Element.TieX + Element.width;
						//
					} else if( Align == "right" ){
						//
						Element.Tie.x += Element.TieX - Element.Tie.width;
					}
				}
			}
			
			// Lance la modification du texte
			Element.Change( text );
			
			// Définit le bouton en Cliquable
			Element.buttonMode = true;
			
			// Définit le texte en nom cliquable
			Text.mouseEnabled = false;
			
			// Interrompt l'animation du bouton
			Button.gotoAndStop( "normal" );
			
			
			// Fonction au survol —— - -
			var StateMouseOver:Function = function( event:MouseEvent ):void {
				
				// Lance la fonction d'Over
				Launch( fonctionOver );
			
				// Modifie la forme du bouton
				Button.gotoAndStop( "over" );
			}
			
			
			// Fonction au désurvol —— - -
			var StateMouseOut:Function = function( event:MouseEvent ):void {
				
				// Lance la fonction d'Out
				Launch( fonctionOut );
			
				// Modifie la forme du bouton
				Button.gotoAndStop( "normal" );
			}
			
			
			// Fonction à l'appuis —— - -
			var StateMouseDown:Function = function( event:MouseEvent ):void {
				
				// Lance la fonction de Down
				Launch( fonctionDown );
			
				// Modifie la forme du bouton
				Button.gotoAndStop( "down" );
			}
			
			
			// Fonction au relachement —— - -
			var StateMouseUp:Function = function( event:MouseEvent ):void {
				
				// Lance la fonction de Up
				Launch( fonctionUp );
			
				// Modifie la forme du bouton
				Button.gotoAndStop( "over" );
			}
			
			// Définit les événements
			AddEvents( Element , StateMouseOver , "MOUSE_OVER" );
			AddEvents( Element , StateMouseOut , "MOUSE_OUT" );
			AddEvents( Element , StateMouseDown , "MOUSE_DOWN" );
			AddEvents( Element , StateMouseUp , "MOUSE_UP" );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				 COMBO BOX					  		  					  */
		/*							    Méthodes pour un élément de type combo box 					  		  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - APPLY - - —————————————————————————————————————————— */
		// Les méthodes de fonctionnement combo box
		//*—*//
	  	
		// —————— COMBO BOX
		// Calibre un élément de type Combo Box Standard
	
		public function ComboBox():void {
			/*—*/
			
			// Récupère ses valeurs
			var Button:* = Element.Button;
			var Text:* = Element.Text;
			var Combo:* = Element.Combo;
			//
			var ComboValues = Element.ComboValues || [];
			//
			var fonctionOver:* = Element.fonctionOver;
			var fonctionOut:* = Element.fonctionOut;
			//
			var fonctionDown:* = Element.fonctionDown;
			var fonctionUp:* = Element.fonctionUp;
			//
			var fonctionElementOver:* = Element.fonctionElementOver;
			var fonctionElementOut:* = Element.fonctionElementOut;
			//
			var fonctionElementDown:* = Element.fonctionElementDown;
			var fonctionElementUp:* = Element.fonctionElementUp;
			//
			var fonctionChange:* = Element.fonctionChange;
			//
			var NumberElements:int = 0;
			var ClassElement:* = Element.ClassElement;
			var Elements:Array = Element.Elements;
			//
			var ObjectElements:Object = new Object();
			//
			var Open:Boolean = Element.open || false;
			
			// Donne la fonction de modification à l'élément —— - -
			Element.Change = function( Choix:String ):void {
				
				// Modifie le texte
				Text.text = Choix;
				
				// Lance la fonction de changement
				Launch( fonctionChange , [ ObjectElements[ StringToName( Choix ) ] ] );
			}
			
			// Ajoute un élément à la combo-box —— - -
			Element.Add = function( Element:* ):void {
				
				// Compile la valeur
				Element = TypeOf( Element , "Object" ) ? Element : { name:Element };
				
				// Ajoute l'élément à l'objet
				ObjectElements[ StringToName( Element.name ) ] = Element.value || Element.name;
				
				// Créait son élément
				var NouvelElement:* = NewElement( ClassElement , Combo , StringToName( Element.name ) , { value:Element.name } );
				//
				NouvelElement.y = NouvelElement.height * NumberElements;
				
				// S'il possède ce qu'il faut —— - -
				if( NouvelElement.Text && NouvelElement.Button ){
				
					// Calibre son texte
					NouvelElement.Text.text = Element.name;
					
					// Interrompt son bouton
					NouvelElement.Button.stop();
					
					// Définit le bouton en Cliquable
					NouvelElement.Button.buttonMode = true;
					
					// Rend le texte non clickable
					NouvelElement.Text.mouseEnabled = false;
				
					// Définit ses événements
					AddEvents( NouvelElement.Button , StateMouseOverElement , "MOUSE_OVER" );
					AddEvents( NouvelElement.Button , StateMouseOutElement , "MOUSE_OUT" );
					AddEvents( NouvelElement.Button , StateMouseDownElement , "MOUSE_DOWN" );
					AddEvents( NouvelElement.Button , StateMouseUpElement , "MOUSE_UP" );
				
				// Sinon —— - - Trace l'erreur
				} else {
					//
					TraceError( "DesktopChip" , "ComboBox" , 
							    "L'élément intégré via ClassElement doit contenir au moins un clip \"Button\" et un clip \"Text\"." );
				}
				
				// Augmente le nombre d'elements
				NumberElements++;
			}
			
			
			// Fonction au survol —— - -
			var StateMouseOver:Function = function( event:MouseEvent ):void {
				
				// Lance la fonction d'Over
				Launch( fonctionOver );
			
				// Modifie la forme du bouton
				Button.gotoAndStop( "over" );
			}
			
			
			// Fonction au désurvol —— - -
			var StateMouseOut:Function = function( event:MouseEvent ):void {
				
				// Lance la fonction d'Out
				Launch( fonctionOut );
			
				// Modifie la forme du bouton
				Button.gotoAndStop( "normal" );
			}
			
			
			// Fonction à l'appuis —— - -
			var StateMouseDown:Function = function( event:MouseEvent ):void {
				
				// Lance la fonction de Down
				Launch( fonctionDown );
			
				// Modifie la forme du bouton
				Button.gotoAndStop( "down" );
			}
			
			
			// Fonction au relachement —— - -
			var StateMouseUp:Function = function( event:MouseEvent ):void {
				
				// Lance la fonction de Up
				Launch( fonctionUp );
				
				// Switch l'open
				Open = !Open;
			
				// Modifie la présence du combo
				Combo.visible = Open;
			
				// Modifie la forme du bouton
				Button.gotoAndStop( "over" );
			}
			
			
			// Fonction au survol d'un élément —— - -
			var StateMouseOverElement:Function = function( event:MouseEvent ):void {
				
				// Lance la fonction d'Over
				Launch( fonctionElementOver );
			
				// Modifie la forme du bouton
				event.target.gotoAndStop( "over" );
			}
			
			
			// Fonction au désurvol d'un élément —— - -
			var StateMouseOutElement:Function = function( event:MouseEvent ):void {
				
				// Lance la fonction d'Out
				Launch( fonctionElementOut );
			
				// Modifie la forme du bouton
				event.target.gotoAndStop( "normal" );
			}
			
			
			// Fonction à l'appuis d'un élément —— - -
			var StateMouseDownElement:Function = function( event:MouseEvent ):void {
				
				// Lance la fonction de Down
				Launch( fonctionElementDown );
			
				// Modifie la forme du bouton
				event.target.gotoAndStop( "down" );
			}
			
			
			// Fonction au relachement d'un élément —— - -
			var StateMouseUpElement:Function = function( event:MouseEvent ):void {
				
				// Lance la fonction de Up
				Launch( fonctionElementUp );
				
				// Retire l'open
				Open = false;
			
				// Modifie la présence du combo
				Combo.visible = Open;
				
				// Modifie la valeur de la combo box
				Element.Change( event.currentTarget.parent.value );
			
				// Modifie la forme du bouton
				event.target.gotoAndStop( "over" );
			}
			
			// Pour chaque éléments —— - -
			for( var iElement:int = 0 ; iElement < Elements.length ; iElement++ ){
				
				// Ajoute l'élément
				Element.Add( Elements[ iElement ] );
				
				// S'il est un objet —— - -
				if( TypeOf( Elements[ iElement ] , "Object" ) ){
					
					// S'il est la valeur par défaut —— - - Calibre sur le choix
					if( Elements[ iElement ].index ){
						//
						Element.value = Elements[ iElement ].name;
					}
				}
			}
			
			// Calibre la valeur
			Element.value = Element.value || Elements[ 0 ].name;
			
			// Lance la modification sur cette dernière
			Element.Change( Element.value );
			
			// Définit le bouton en Cliquable
			Button.buttonMode = true;
			
			// Rend le texte non clickable
			Text.mouseEnabled = false;
			
			// Interrompt l'animation du bouton
			Button.gotoAndStop( "normal" );
			
			// Modifie la présence du combo
			Combo.visible = Open;
			
			// Définit les événements
			AddEvents( Button , StateMouseOver , "MOUSE_OVER" );
			AddEvents( Button , StateMouseOut , "MOUSE_OUT" );
			AddEvents( Button , StateMouseDown , "MOUSE_DOWN" );
			AddEvents( Button , StateMouseUp , "MOUSE_UP" );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				  BUBBLE					  		  					  */
		/*							    Méthodes pour un élément de type info-bulle					  		  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - APPLY - - —————————————————————————————————————————— */
		// Les méthodes de fonctionnement info-bulle
		//*—*//
	  	
		// —————— BUBBLE
		// Calibre un élément de type info-bulle Standard
	
		public function Bubble():void {
			/*—*/
			
			// Récupère ses valeurs
			var BubbleText:* = Element.BubbleText;
			//
			var Fonction:* = Element.fonction || Element.fonctionLoop;
			//
			var Position:String = Element.position || "BL";
			//
			var ShiftX:Number = Element.shiftX || 0;
			var ShiftY:Number = Element.shiftY || 0;
			//
			Element.active = Element.active || false;
			Element.visible = Element.active;
			Element.alpha = Element.active ? 1 : 0;
			
			// Fonction de changement du texte —— - -
			Element.Change = function( Texte:String ):void {
				
				// Modifie le texte
				BubbleText.text = Texte;
			}
			
			// Fonction d'ajout de lien —— - -
			Element.Add = function( Cible:* , 
								    Description:String
								   ):void {
				
				// Fonction de survol —— - -
				Cible.BubbleOver = function( event:MouseEvent ):void {
					//
					Element.Change( Description );
					Element.active = true;
				}
				
				// Fonction de désurvol —— - -
				Cible.BubbleOut = function( event:MouseEvent ):void {
					//
					Element.active = false;
				}
				
				// Donne à l'élément les fonctions
				AddEvents( Cible , Cible.BubbleOver , "MOUSE_OVER" );
				AddEvents( Cible , Cible.BubbleOut , "MOUSE_OUT" );
			}
			//
			// Pour chaque éléments —— - -
			for( var iElement:int = 0 ; iElement < Element.Elements.length ; iElement++ ){
				
				// Ajoute l'élément
				Element.Add( Element.Elements[ iElement ].target , Element.Elements[ iElement ].description );
			}
			
			// Fonction en boucle —— - -
			var BoucleBulle:Function = function( event:Event ):void {
				
				// Définit sa visibilité par rapport à son état
				if( Element.active && Element.alpha < 1 ){
					//
					Element.alpha += 0.2;
					//
				} else if( !Element.active && Element.alpha > 0 ){
					//
					Element.alpha -= 0.2;
				}
				
				// Switch sa visibilité suivant son alpha
				if( Element.alpha > 0 ){
					//
					Element.visible = true;
					//
				} else {
					//
					Element.visible = false;
				}
				
				// S'il est visible —— - -
				if( Element.visible ){
					
					// Lance la fonction de boucle
					Launch( Fonction );
					
					// Récupère la position
					var PositionY:String = Position.split( "" )[ 0 ];
					var PositionX:String = Position.split( "" )[ 1 ];
					
					// Si elle dépasse par un côté à l'horizontal —— - - Elle se renverse
					if( Element.parent.mouseX + ShiftX + Element.width > StageLink.stageWidth ){
						//
						PositionX = "R";
						//
					} else if( Element.parent.mouseX - ShiftX - Element.width < 0 ){
						//
						PositionX = "L";
					}
					
					// Si elle dépasse par un côté à la vertical —— - - Elle se renverse
					if( Element.parent.mouseY + ShiftY + Element.height > StageLink.stageHeight ){
						//
						PositionY = "T";
						//
					} else if( Element.parent.mouseY - ShiftY - Element.height < 0 ){
						//
						PositionY = "B";
					}
					
					
					// Suivant la position —— - - Place la bulle
					if( PositionX == "L" ){
						//
						Element.x = Element.parent.mouseX + ShiftX;
						//
					} else {
						//
						Element.x = Element.parent.mouseX - ShiftX - Element.width;
					}
					//
					if( PositionY == "B" ){
						//
						Element.y = Element.parent.mouseY + ShiftY;
						//
					} else {
						//
						Element.y = Element.parent.mouseY - ShiftY - Element.height;
					}
				}
			}
				
			// Définit les événements
			AddEvents( Element , BoucleBulle , "ENTER_FRAME" );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 HELP					  		  					  */
		/*						   				    Méthodes d'aide générale 					  	  			  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - TRACE - - —————————————————————————————————————————— */
		// Les méthodes pour provoquer des traces
		//*—*//
	  
		// —————— TELL ME LIST
		// Retourne la liste des éléments et des clips pour les composer
	
		public function TellMeList():String { 
			/*—*/
			
			// Définie le début
			var Debut:String = "Les clips pour les différents éléments à consevoir sont :\r"
			
			// Pour chaque élément de la liste —— - -
			for( var Clip:* in TypeList ){
				
				// Ajoute le nom de l'élément —— - -
				Debut += "\t" + Clip + " :\r"
				
				// Pour chaque clip le composant —— - -
				for( var i:int = 0 ; i < TypeList[ Clip ].length ; i++ ){
					
					// Ajoute le nom du clip
					Debut += "\t\t" + TypeList[ Clip ][ i ] + "\r";
				}
			}
			
			// Retourne la chaine
			return Debut;
		}
		
		
		
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}