﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			DRAW PROCESS	  		Version 0.3.0									***/
/***				   				   Dernière Mise à Jour : 10-08-19										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         				  Gestionnaire Dessin											***/
/***		Ce script contient les méthodes pour permettre à l'utilisateur de générer l'effet visuel.    	***/
/***		Il est possible d'archiver des outils de dessin et de les lancer quand on le souhaite.	    	***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Dynamic {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	
	// —— - - DISPLAY
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.BitmapData;
	import flash.display.Bitmap;
	//
	// —— - - EVENT
	import flash.events.Event;
	import flash.events.MouseEvent;
	//
	// —— - - GEOMETRY
	import flash.geom.Matrix;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	import drOIde.Port.MousePort;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class DrawProcess extends MiscTools {
		
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*—*//
	
		// —————— LINK
	    // La liaison des autres scripts
		var Mouse:MousePort;
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function DrawProcess( TheLink:* = null ,		// ———— - - Lien vers la scene
									 LinkMouse:* = null		// ———— - - Lien vers un MousePort si on en a un
									){
			/*—*/
			
			// S'il y a un lien vers le stage —— - -
			if( Connexion( TheLink ) ){ 
			
				// S'il y a un lien MousePort —— - —
				if( LinkMouse ){ 
					
					// Récupère le lien
					Mouse = LinkMouse; 
					
				// S'il n'y a pas de lien MousePort —— - -
				} else {
					
					// Créait un nouveau MousePort
					Mouse = new MousePort( TheLink );
				}
				
				// Lance la boucle
				AddEvents( This , GlobalLoop , "ENTER_FRAME" );
			
			// S'il n'y a pas de lien vers le stage —— - - Trace l'erreur
			} else {
				//
				TraceError( "DrawProcess" , "Initialisation" , 
							 "Un lien vers la scene doit être donné à l'initialisation comme premier argument." );
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 GLOBAL					  		  					  */
		/*						  	  Méthodes d'ordre général pour la gestion du script 					  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - LOOP - - —————————————————————————————————————————— */
		// Boucle de gestion
		//*—*//
		
		// —————— GLOBAL LOOP
		// La boucle générale du script
		
		public function GlobalLoop( event:Event ):void {
			/*—*/
			
			// Pour chaque outils —— - -
			for( var iTool:* in Tools ){
				
				// Pour chaque groupe de l'outils —— - -
				for( var iGroupe:* in Tools[ iTool ] ){
					
					// Pour chaque outils du groupe —— - -
					for( var iOutil:* in Tools[ iTool ][ iGroupe ] ){
						
						// S'il est actif —— - - Lance sa procédure
						if( Tools[ iTool ][ iGroupe ][ iOutil ].Parametres.active ){
							//
							ToolLoop( iTool , Tools[ iTool ][ iGroupe ][ iOutil ] );
						}
					}
				}
			}
		}
		
		
		// —————— TOOL LOOP
		// Boucle de tous les outils de façon générale
		
		private function ToolLoop( Type:String ,	// ———— - - Type de l'outils
								   Outils:Object 	// ———— - - Objet de l'outils
								 ):void {
			/*—*/
								
			/* —— - - ARGUMENTS - - —— */
			/**/
			
			// Récupère les objets
			var Parametres:Object = Outils.Parametres;
			
			// Définit les valeurs par défauts
			SetAll( Parametres , ToolDefaultList[ Type ] , null , { Unicite:true , Aspiration:false } );
			
					
			/* —— - - CALIBRAGE - - —— */
			/**/
					
			// Créait la forme s'il n'en possède pas déjà une
			Outils.Form = Outils.Form || new Shape;
			
			// S'il possède une cible et un container —— - -
			if( Parametres.container && Parametres.target ){
				
				// Si la form n'est pas dans le conteneur —— - -
				if( Outils.Form.parent != Parametres.container ){
					//
					// L'y intégre
					Parametres.container.addChild( Outils.Form );
				}
				
					
				/* —— - - POSITION - - —— */
				/**/
				
				// Variables de position
				var xPosition:Number = 0;
				var yPosition:Number = 0;
					
				// Convertie la cible
				Parametres.target = ( Parametres.target == "Mouse" || Parametres.target == "Souris" ) ? Mouse : Parametres.target;
				
				// Si la cible n'est pas la souris —— - -
				if( !TypeOf( Parametres.target , "MousePort" ) ){
				
					// Récupère la position de la cible
					xPosition = Parametres.target.x || 0;
					yPosition = Parametres.target.y || 0;
				
				// Si la cible est la souris —— - -
				} else {
				
					// Récupère la position de la cible
					xPosition = Parametres.target.localX( Parametres.container );
					yPosition = Parametres.target.localY( Parametres.container );
				}
				
				// Récupère la position mémoire
				var xMemoPosition:Number = ( Parametres.xMemo != null ) ? Parametres.xMemo : xPosition;
				var yMemoPosition:Number = ( Parametres.yMemo != null ) ? Parametres.yMemo : yPosition;
				
					
				/* —— - - PRÉPARATION - - —— */
				/**/
					
				// Récupère les états d'activation
				var activeMemo:Boolean = Parametres.activeMemo || false;
				var activeNew:Boolean = !activeMemo;
				
				// Créait l'objet de calibrage
				var Calibrage:Object = { x:xPosition , y:yPosition , xMemo:xMemoPosition , yMemo:yMemoPosition ,
										 activeMemo:activeMemo , activeNew:activeNew 
									   };
				
					
				/* —— - - DESSIN - - —— */
				/**/
				
				// Lance la boucle interne de l'outils, et lance le post-calibrage si cela s'est bien passé —— - -
				if( This[ Type + "Loop" ]( Outils , Parametres , Calibrage ) ){
				
					
					/* —— - - POST-CALIBRAGE - - —— */
					/**/
						
					// Mémorise les positions
					Parametres.xMemo = xPosition;
					Parametres.yMemo = yPosition;
					
					// Mémorise l'activation
					Parametres.activeMemo = true;
				}
			
					
			/* —— - - ERREURS - - —— */
			/**/
					
			// S'il ne possède pas de container —— - - Trace l'erreur
			} else if( !Parametres.container && !Parametres.target ){
				//
				TraceSoftError( "DrawProcess" , "PencilLoop" , "Le container (Conteneur) et la target (Cible) ne sont pas définis." );
			
			// S'il ne possède pas de container —— - - Trace l'erreur
			} else if( !Parametres.container ){
				//
				TraceSoftError( "DrawProcess" , "PencilLoop" , "Le container (Conteneur) n'est pas défini." );
				
			// S'il ne possède pas de cible —— - - Trace l'erreur
			} else if( !Parametres.target ){
				//
				TraceSoftError( "DrawProcess" , "PencilLoop" , "La target (Cible) n'est pas défini." );
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 TOOLS					  		  					  */
		/*						  Méthodes pour générer des outils ou des effets de dessins 					  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
		
		// —————— TOOL LIST
		// Liste des outils
		var ToolList:Array = [ "Pencil" , "Brush" , "Pen" , "Buffer" , "Aerosol" , "Pipette" , "Compass" ];
		
		// —————— TOOL DEFAULT LIST
		// Liste des valeurs par défaut pour chaque outils
		var ToolDefaultList:Object = { Pencil:{ size:1 , color:"000000" , alpha:1 } ,
									   Brush:{ size:1 , alpha:1 , sensibility:10 } ,
									   Buffer:{ size:1 , alpha:1 , sensibility:3 } ,
									   Aerosol:{ size:1 , alpha:0.1 , sizeMax:4 , alphaStep:0.05 , sizeStep:0.1 } ,
									   Pen:{ size:1 , color:"000000" , alpha:1 , sensibility:5 } ,
									   Compass:{ size:1 , color:"000000" , alpha:1 , sensibility:5 } ,
									   Pipette:{}
									 };
		
		// —————— TOOLS
		// Archive des outils
		var Tools:Object = new Object();
		
		
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Méthodes pour générer et archiver des outils de dessins
		//*—*//
		
		// —————— NEW TOOL GROUP
		// Créait un nouveau groupe d'outils
		
		public function NewToolGroup( Nom:String ,				// ———— - - Le Nom du groupe
									  Type:String = "Pencil"	// ———— - - Le Type du groupe
									 ):Boolean {
			/*—*/
			
			// Si l'outil existe —— - -
			if( CheckType( Type , "NewToolGroup" ) ){
				
				// Créait l'objet de l'outils s'il n'y est pas déjà
				Tools[ Type ] = Tools[ Type ] || new Object();
				
				// Créait le groupe
				Tools[ Type ][ Nom ] = new Object();
				
				// Retourne vrai
				return true;
			}
			
			// Retourne faux
			return false;
		}
		
		
		// —————— NEW TOOL
		// Créait un nouvel outil
		
		public function NewTool( Groupe:String ,			// ———— - - Le Nom du groupe
								 Nom:String ,				// ———— - - Le Nom de l'outils
								  
								 Parametres:* = null ,		// ———— - - Les Parametres de l'outils
															//		 ou Type
								  
								 Type:* = null				// ———— - - Le Type de l'outils ( Au cas où on aurait pas créer le groupe avant )
															//		 ou Parametres
								):Boolean {
			/*—*/
			
			// Switch des arguments
			if( TypeOf( Parametres , "String" ) ){
				//
				var MemoType:* = Type;
				Type = Parametres;
				Parametres = MemoType;
			}
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			
			// Levier de lancement
			var Levier:Boolean = true;
			
			// Si on a indiqué un type —— - -
			if( Type ){
			
				// Créait le groupe s'il n'existe pas —— - -
				if( !Tools[ Groupe ] ){ 
					//
					Levier = NewToolGroup( Groupe , Type ); 
				}
			
			// S'il n'y a pas de type indiqué —— - -
			} else {
				
				// Désactive le levier
				Levier = false;
				
				// Pour chaque outils —— - -
				for( var iTool in Tools ){
					
					// S'il possède le groupe —— - - Active le levier
					if( Tools[ iTool ][ Groupe ] ){ Levier = true; }
				}
				
				// Si le levier ne s'est pas activté —— - - Créait le groupe par défaut sur Pencil
				if( !Levier ){
					//
					Levier = NewToolGroup( Groupe , "Pencil" );
				}
			}
			
			// Si le levier est bon —— - -
			if( Levier ){
				
				// Créait l'outils
				Tools[ Type ][ Groupe ][ Nom ] = new Object();
				
				// Lui donne ses parametres
				Tools[ Type ][ Groupe ][ Nom ].Parametres = CloneObject( Parametres );
				
				// Retourne vrai
				return true;
			}
			
			// Retourne faux
			return false;
		}
		
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Méthodes permettant la gestion et la modification d'un outils
		//*—*//
		
		// —————— CHANGE TOOL
		// Modifie l'état d'un outils
		
		public function ChangeTool( Groupe:String ,				// ———— - - Le Groupe de l'outils
									Nom:String ,				// ———— - - Le Nom de l'outils
									Type:* ,					// ———— - - Le type de l'outils
																//		 ou Parametres
									
									Parametres:Object = null	// ———— - - Les Parametres à modifier et leur valeurs
								  ):void {
			/*—*/
			
			// Switch des arguments
			if( TypeOf( Type , "Object" ) ){
				//
				Parametres = Type;
				Type = null;
			}
			
			// Objet de l'outils
			var ToolObject:Object;
			
			// Si l'on a indiqué le Type —— - -
			if( Type ){
				
				// Si le type d'outils existe —— - -
				if( CheckType( Type ) ){
				
					// Si le groupe existe —— - -
					if( Tools[ Type ][ Groupe ] ){
				
						// Si l'outils existe —— - -
						if( Tools[ Type ][ Groupe ][ Nom ] ){
					
							// Récupère l'objet de l'outils
							ToolObject = Tools[ Type ][ Groupe ][ Nom ];
						
						// Si l'outils n'existe pas —— - - Trace l'erreur
						} else {
							//
							TraceError( "DrawProcess" , "ChangeTool" , 
									    "L'outils \"" + Groupe + "\" n'existe pas dans le groupe \"" + Groupe + "\"." );
						}
				
					// Si le groupe n'existe pas —— - - Trace l'erreur
					} else {
						//
						TraceError( "DrawProcess" , "ChangeTool" , 
								    "Le groupe \"" + Groupe + "\" n'existe pas parmis les outils " + Type + "." );
					}
				}
			
			// Si l'on n'a pas indiqué de Type —— - -
			} else {
				
				// Pour chaque outils —— - -
				for( var iTool in Tools ){
					
					// S'il possède le groupe —— - - Récupère le type
					if( Tools[ iTool ][ Groupe ] ){ Type = iTool; }
				}
				
				// S'il a le type —— - -
				if( Type ){
					
					// Récupère l'objet de l'outils
					ToolObject = Tools[ Type ][ Groupe ][ Nom ];
				
				// S'il n'a pas le type —— - - Trace l'erreur
				} else {
					//
					TraceError( "DrawProcess" , "ChangeTool" , 
							    "Le groupe \"" + Groupe + "\" est introuvable." );
				}
			}
			
			// S'il a l'objet de l'outils —— - -
			if( ToolObject ){
					
				// Modifie ses parametres
				SetAll( ToolObject.Parametres , Parametres , { Aspiration:false } );
				
				// S'il a été désactivé —— - - Active sa mémoire d'activité
				ToolObject.Parametres.activeMemo = !ToolObject.Parametres.active ? false : ToolObject.Parametres.activeMemo;
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - LOOP - - —————————————————————————————————————————— */
		// Méthodes bouclée lancée par la boucle centrale du script lorsque l'outils est actif
		//*—*//
		
		// —————— PENCIL LOOP
		// Boucle du crayon,
		// Le crayon dessine des traits
		
		public function PencilLoop( Outils:Object ,		// ———— - - L'Objet de l'outils
									Parametres:Object ,	// ———— - - Les Paramètres de l'outils
									Calibrage:Object		// ———— - - Les calibrage de l'outils
								  ):Boolean {
			/*—*/
			
			// Définie le style de ligne
			Outils.Form.graphics.lineStyle( Parametres.size , Parametres.color , Parametres.alpha );
			
			// Si c'est un nouveau clic —— - -
			if( Calibrage.activeNew ){
			
				// Positionne le point de départ
				Outils.Form.graphics.moveTo( Calibrage.x , Calibrage.y );
			
			// Si c'est la continuité —— - -
			} else {
				
				// Positionne le point de sortie
				Outils.Form.graphics.lineTo( Calibrage.x , Calibrage.y );
			}
			
			// Retourne vrai
			return true;
		}
		
		
		// —————— BRUSH LOOP
		// Boucle du pinceau
		// Le pinceau disperse des clips selon des intervales régulières et les fait se lier entre eux sur une déformation
		
		public function BrushLoop( Outils:Object ,		// ———— - - L'Objet de l'outils
								   Parametres:Object ,	// ———— - - Les Paramètres de l'outils
								   Calibrage:Object		// ———— - - Les calibrage de l'outils
								  ):Boolean {
			/*—*/
			
			// S'il a parcouru une distance suffisante ou que c'est le premier clic —— - -
			if( GetDistance( { x:Calibrage.xMemo , y:Calibrage.yMemo } , 
							 { x:Calibrage.x , y:Calibrage.y } ) 
			   				>= Aspiration( Parametres.sensibility )
			 || Calibrage.activeNew ){
				
				// S'il y a un clip —— - -
				if( Parametres.clip ){
					
					// Si ce n'est pas un nouveau click —— - -
					if( !Calibrage.activeNew ){
					
						// Pose un nouvel élément
						var NouvelleParticule:* = NewElement( Parametres.clip , 
															  Parametres.container , 
															  Parametres.container.name + "Brush" + RandomWord() , 
															  { x:Calibrage.x , y:Calibrage.y ,
																scaleX:Calibrage.size , scaleY:Calibrage.size ,
																color:Parametres.color , alpha:Parametres.alpha
															  } );
						
						// Applique la déformation de l'élément
					ApplyLinkEffect( NouvelleParticule , { x:Calibrage.x , y:Calibrage.y } , { x:Calibrage.xMemo , y:Calibrage.yMemo } );
					}
					// Retourn vrai
					return true;
				
				// S'il n'y a pas de clip —— - - Trace l'erreur
				} else {
					// 
					TraceSoftError( "DrawProcess" , "BrushLoop" , "Cet outils doit avoir un \"clip\" définit donne le clip des particules." );
				}
			}
			
			// Retourne faux
			return false;
		}
		
		
		// —————— BUFFER LOOP
		// Boucle du tampon
		// Le Tampon disperse des clips selon des intervales régulières
		
		public function BufferLoop( Outils:Object ,		// ———— - - L'Objet de l'outils
								    Parametres:Object ,	// ———— - - Les Paramètres de l'outils
								    Calibrage:Object	// ———— - - Les calibrage de l'outils
								   ):Boolean {
			/*—*/
			
			// S'il a parcouru une distance suffisante ou que c'est le premier clic —— - -
			if( GetDistance( { x:Calibrage.xMemo , y:Calibrage.yMemo } , 
							 { x:Calibrage.x , y:Calibrage.y } ) 
			   				>= Aspiration( Parametres.sensibility )
			 || Calibrage.activeNew ){
				
				// S'il y a un clip —— - -
				if( Parametres.clip ){
					
					// Pose un nouvel élément
					var NouvelleParticule:* = NewElement( Parametres.clip , 
														  Parametres.container , 
														  Parametres.container.name + "Brush" + RandomWord() , 
														  { x:Calibrage.x , y:Calibrage.y ,
															scaleX:Calibrage.size , scaleY:Calibrage.size ,
															color:Parametres.color , alpha:Parametres.alpha
														  } );
					
					// Retourn vrai
					return true;
				
				// S'il n'y a pas de clip —— - - Trace l'erreur
				} else {
					// 
					TraceSoftError( "DrawProcess" , "BrushLoop" , "Cet outils doit avoir un \"clip\" définit donne le clip des particules." );
				}
			}
			
			// Retourne faux
			return false;
		}
		
		
		// —————— AEROSOL LOOP
		// Boucle de l'aérosol
		// L'aérosol disperse des clips si on ne touche aucun des précédents créés, si on en touche un qui n'est pas
		// déjà trop saturé, à la place, on le fait grossir et on le rend plus opaque
		
		public function AerosolLoop( Outils:Object ,		// ———— - - L'Objet de l'outils
								     Parametres:Object ,	// ———— - - Les Paramètres de l'outils
								     Calibrage:Object		// ———— - - Les calibrage de l'outils
								   ):Boolean {
			/*—*/
			
			// Tableau des clips touchés
			var ClipsTouches:Array = new Array();
			
			// Pour chaque clip du conteneur —— - -
			for( var iClip:int = 0 ; iClip < Parametres.container.numChildren ; iClip++ ){
				
				// Récupère le clip
				var Clip:* = Parametres.container.getChildAt( iClip );
				
				// S'il fait partie des particules créés que sa taille n'est pas au max —— - -
				if( FindIn( Clip.name , Parametres.container.name )
				 && Clip.scaleX < Parametres.sizeMax ){
					
					// Si on le touche —— - -
					if( Clip.hitTestPoint( Calibrage.x , Calibrage.y ) ){
					
						// Ajoute le clip au tableau des clips touchées
						ClipsTouches.push( Parametres.container.getChildAt( iClip ) );
					}
				}
			}
			
			// Si on ne touche aucun clip —— - -
			if( ClipsTouches.length == 0 ){
				
				// S'il y a un clip —— - -
				if( Parametres.clip ){
					
					// Pose un nouvel élément
					var NouvelleParticule:* = NewElement( Parametres.clip , 
														  Parametres.container , 
														  Parametres.container.name + "Brush" + RandomWord() , 
														  { x:Calibrage.x , y:Calibrage.y ,
															scaleX:Calibrage.size , scaleY:Calibrage.size ,
															color:Parametres.color , alpha:Parametres.alpha
														  } );
				
				// S'il n'y a pas de clip —— - - Trace l'erreur
				} else {
					// 
					TraceSoftError( "DrawProcess" , "BrushLoop" , "Cet outils doit avoir un \"clip\" définit donne le clip des particules." );
				}
			
			// Si on touche des clips —— - -
			} else {
				
				// Pour chaque clips touchées —— - -
				for( var iClipsTouches:int = 0 ; iClipsTouches < ClipsTouches.length ; iClipsTouches++ ){
					
					// Grossit et rend plus opaque ce clip
					ClipsTouches[ iClipsTouches ].scaleX += Aspiration( Parametres.sizeStep );
					ClipsTouches[ iClipsTouches ].scaleY += Aspiration( Parametres.sizeStep );
					ClipsTouches[ iClipsTouches ].alpha += Aspiration( Parametres.alphaStep );
				}
			}
			
			// Retourne vrai
			return true;
		}
		
		
		// —————— PEN LOOP
		// Boucle du stylo
		// Le stylo trace des ligne droites entre deux points
		
		public function PenLoop( Outils:Object ,		// ———— - - L'Objet de l'outils
								 Parametres:Object ,	// ———— - - Les Paramètres de l'outils
								 Calibrage:Object		// ———— - - Les calibrage de l'outils
							   ):Boolean {
			/*—*/
			
			// S'il n'a pas son tableau des formes —— - - Lui donne
			Parametres.container.forms = Parametres.container.forms || new Array();
			
			// Si c'est un nouveau clic —— - -
			if( Calibrage.activeNew || !Outils.Clip ){
				
				// S'il n'y a pas de forme —— - -
				if( Outils.Clip == null ){
					
					// Créait une nouvelle forme
					var NouvelleForme:MovieClip = Outils.Clip = NewElement( MovieClip , 
																			Parametres.container , 
																			Parametres.container.name + "Form" );
					//
					var NouvelleShape:Shape = NouvelleForme.Form = new Shape();
					NouvelleForme.addChild( NouvelleShape );
					//
					Parametres.container.forms.push( NouvelleForme );
					
					// Donne à cette forme son tableau de points
					NouvelleForme.Points = new Array();
					
					// Ajoute le point au tableau
					Outils.Clip.Points.push( { x:Calibrage.x , y:Calibrage.y } );
					
				// S'il y a une forme —— - -
				} else {
					
					// Ajoute le nouveau point au tableau
					Outils.Clip.Points.push( { x:Calibrage.xMemo , y:Calibrage.yMemo } );
				
					// S'il y a plus d'un point —— - -
					if( Outils.Clip.Points.length > 1 ){
						
						// Si le point de sortie est proche du premier point —— - -
						if( NearEqual( Outils.Clip.Points[ 0 ].x , 
							Outils.Clip.Points[ Outils.Clip.Points.length - 1 ].x , 
							Parametres.sensibility ) 
						 && NearEqual( Outils.Clip.Points[ 0 ].y , 
							Outils.Clip.Points[ Outils.Clip.Points.length - 1 ].y , 
							Parametres.sensibility )
						 && Outils.Clip.Points.length > 1 ){
							
							// Égalise les points
							Outils.Clip.Points[ Outils.Clip.Points.length - 1 ].x = Outils.Clip.Points[ 0 ].x;
							Outils.Clip.Points[ Outils.Clip.Points.length - 1 ].y = Outils.Clip.Points[ 0 ].y;
							
							// Retire la forme
							Outils.Clip = null
							
							// Nouveau click
							Calibrage.activeNew = true;
							
							// Retourne vrai
							return true;
						}
					}
				}
				
				// S'il y a plus d'un point —— - -
				if( Outils.Clip.Points.length > 1 ){
					
					// Si le point de sortie est proche du premier point —— - -
					if( NearEqual( Outils.Clip.Points[ 0 ].x , Calibrage.x , Parametres.sensibility ) 
					 && NearEqual( Outils.Clip.Points[ 0 ].y , Calibrage.y , Parametres.sensibility )
					 && Outils.Clip.Points.length > 1 ){
						
						// Relache l'activité
						Parametres.active = false;
						
						// Lock le levier
						var LevierFinal:Boolean = true;
					}
				}
			}
			
			// Efface les lignes précédentes
			Outils.Clip.Form.graphics.clear();
			
			// Définie le style de ligne
			Outils.Clip.Form.graphics.lineStyle( Parametres.size , Parametres.color , Parametres.alpha );
			
			// Positionne le point de départ
			Outils.Clip.Form.graphics.moveTo( Outils.Clip.Points[ 0 ].x , Outils.Clip.Points[ 0 ].y );
			
			// Pour chaque point —— - -
			for( var iPoint:int = 1 ; iPoint < Outils.Clip.Points.length ; iPoint++ ){
				
				// Positionne le point de départ
				Outils.Clip.Form.graphics.lineTo( Outils.Clip.Points[ iPoint ].x , Outils.Clip.Points[ iPoint ].y );
			}
			
			// Si le point de sortie est proche du premier point —— - -
			if( NearEqual( Outils.Clip.Points[ 0 ].x , Calibrage.x , Parametres.sensibility ) 
			 && NearEqual( Outils.Clip.Points[ 0 ].y , Calibrage.y , Parametres.sensibility )
			 && Outils.Clip.Points.length > 1 ){
				
				// Positionne dessus
				Calibrage.x = Outils.Clip.Points[ 0 ].x;
				Calibrage.y = Outils.Clip.Points[ 0 ].y;
			}
			
			// Si c'est le dernier point —— - -
			if( LevierFinal ){
				
				// Relie au premier point
				Outils.Clip.Form.graphics.lineTo( Outils.Clip.Points[ 0 ].x , Outils.Clip.Points[ 0 ].y );
					
				// Retire la forme
				Outils.Clip = null;
				
			// Si ce n'est pas le dernier point —— - -
			} else {
				
				// Relie a la position en cours
				Outils.Clip.Form.graphics.lineTo( Calibrage.x , Calibrage.y );
			}
			
			// Retourne vrai
			return true;
		}
		
		
		// —————— COMPASS LOOP
		// Boucle du stylo
		// Le compas trace des ligne, comme le stylo, mais, entre deux points, il arrondie ces lignes par rapport au maintient
		
		public function CompassLoop( Outils:Object ,		// ———— - - L'Objet de l'outils
									 Parametres:Object ,	// ———— - - Les Paramètres de l'outils
									 Calibrage:Object		// ———— - - Les calibrage de l'outils
								   ):Boolean {
			/*—*/
			
			// S'il n'a pas son tableau des formes —— - - Lui donne
			Parametres.container.forms = Parametres.container.forms || new Array();
			
			// Si c'est un nouveau clic —— - -
			if( Calibrage.activeNew ){
				
				// S'il n'y a pas de forme —— - -
				if( Outils.Clip == null ){
					
					// Créait une nouvelle forme
					var NouvelleForme:MovieClip = Outils.Clip = NewElement( MovieClip , 
																			Parametres.container , 
																			Parametres.container.name + "Form" );
					//
					var NouvelleShape:Shape = NouvelleForme.Form = new Shape();
					NouvelleForme.addChild( NouvelleShape );
					//
					Parametres.container.forms.push( NouvelleForme );
					
					// Donne à cette forme son tableau de points
					NouvelleForme.Points = new Array();
				}
					
				// Ajoute le nouveau point au tableau
				Outils.Clip.Points.push( { x:Calibrage.x , y:Calibrage.y } );
				
				// S'il y a plus d'un point —— - -
				if( Outils.Clip.Points.length > 1 ){
					
					// Si le point de sortie est proche du premier point —— - -
					if( NearEqual( Outils.Clip.Points[ 0 ].x , Calibrage.x , Parametres.sensibility ) 
					 && NearEqual( Outils.Clip.Points[ 0 ].y , Calibrage.y , Parametres.sensibility )
					 && Outils.Clip.Points.length > 1 ){
						
						// Relache l'activité
						Parametres.active = false;
						
						// Lock le levier
						var LevierFinal:Boolean = true;
					}
				}
			}
			
			// Efface les lignes précédentes
			Outils.Clip.Form.graphics.clear();
			
			// Définie le style de ligne
			Outils.Clip.Form.graphics.lineStyle( Parametres.size , Parametres.color , Parametres.alpha );
			
			// Positionne le point de départ
			Outils.Clip.Form.graphics.moveTo( Outils.Clip.Points[ 0 ].x , Outils.Clip.Points[ 0 ].y );
			
			// Pour chaque point —— - -
			for( var iPoint:int = 1 ; iPoint < Outils.Clip.Points.length ; iPoint++ ){
				
				// Si ce n'est pas le dernier point —— - -
				if( iPoint != Outils.Clip.Points.length - 1 ){
				
					// Positionne le point de départ
					Outils.Clip.Form.graphics.curveTo( Outils.Clip.Points[ iPoint ].xCurve || Outils.Clip.Points[ iPoint ].x , 
													   Outils.Clip.Points[ iPoint ].yCurve || Outils.Clip.Points[ iPoint ].y , 
													   Outils.Clip.Points[ iPoint ].x , Outils.Clip.Points[ iPoint ].y );
					
				// Si c'est le dernier point —— - -
				} else {
				
					// Positionne le point de départ
					Outils.Clip.Form.graphics.curveTo( Outils.Clip.Points[ iPoint ].x + ( Outils.Clip.Points[ iPoint ].x - Calibrage.x ) , 
													   Outils.Clip.Points[ iPoint ].y + ( Outils.Clip.Points[ iPoint ].y - Calibrage.y ) , 
													   Outils.Clip.Points[ iPoint ].x , Outils.Clip.Points[ iPoint ].y );
				}
			}
			
			// Si le point de sortie est proche du premier point —— - -
			if( NearEqual( Outils.Clip.Points[ 0 ].x , Calibrage.x , Parametres.sensibility ) 
			 && NearEqual( Outils.Clip.Points[ 0 ].y , Calibrage.y , Parametres.sensibility )
			 && Outils.Clip.Points.length > 1 ){
				
				// Positionne dessus
				Calibrage.x = Outils.Clip.Points[ 0 ].x;
				Calibrage.y = Outils.Clip.Points[ 0 ].y;
			}
				
			// Définit sa curve
			var DernierPoint:Object = Outils.Clip.Points[ Outils.Clip.Points.length - 1 ];
			//
			DernierPoint.xCurve = DernierPoint.x + ( DernierPoint.x - Calibrage.x );
			DernierPoint.yCurve = DernierPoint.y + ( DernierPoint.y - Calibrage.y );
			
			// Si c'est le dernier point —— - -
			if( LevierFinal ){
				
				// Retire la forme
				Outils.Clip = null;
			}
			
			// Retourne vrai
			return true;
		}
		
		
		// —————— PIPETTE LOOP
		// Boucle de la pipette
		// La pipette récupère la couleur du pixel d'un clip à une position donnée et la renvoie à une fonction
		
		public function PipetteLoop( Outils:Object ,		// ———— - - L'Objet de l'outils
								     Parametres:Object ,	// ———— - - Les Paramètres de l'outils
								     Calibrage:Object		// ———— - - Les calibrage de l'outils
								   ):Boolean {
			/*—*/
			
			if( Parametres.container.width && Parametres.container.height ){
				
				// Création des données bitmap
				var NouveauBitmap:BitmapData = new BitmapData( Parametres.container.width , Parametres.container.height , true );
				var NouvelleImage:Bitmap = new Bitmap( NouveauBitmap );
				
				// Transformation du Bitmap
				var NouvelleMatrice:Matrix = NouvelleImage.transform.matrix;
				
				// Affiche le bitmap
				Parametres.container.parent.addChild( NouvelleImage );
				
				// Applique le dessin
				NouveauBitmap.draw( Parametres.container , NouvelleMatrice );
				
				// Récupère la couleur
				var Couleur:String = NouveauBitmap.getPixel( Calibrage.x , Calibrage.y ).toString( 16 );
				
				// Retire l'image
				Parametres.container.parent.removeChild( NouvelleImage );
				
				// Vide l'image
				NouvelleImage = null;
				
				// Renvoie la couleur à la fonction
				Launch( Parametres.fonction , Couleur );
			}
			
			// Retourne vrai
			return true;
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 HELP					  		  					  */
		/*						  		  Méthodes d'aide à l'exploitation du script 					  		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - CHECK - - —————————————————————————————————————————— */
		// Les méthodes qui établissent une vérification et retourne une boolean en conséquence en plus de tracer une erreur
		//*—*//
		
		// —————— CHECK TYPE
		// Vérifie que le type demander existe
		
		function CheckType( Type:String = "" ,				// ———— - - Le type vérifié
						    Methode:String = "CheckType"	// ———— - - La méthode qui en demande la vérification
						   ):Boolean {
			/*—*/
			
			// Si le type ne se trouve pas dans la liste des types —— - -
			if( !IndexOf( ToolList , Type ) ){
				
				// Trace l'erreur
				TraceError( "DrawProcess" , Methode , [ "Le type \"" + Type + "\" n'existe pas, les types existants sont :" ,
						   								ToolList.join( ", " ) ] );
				
				// Renvoie faux
				return false;
			}
			
			// Renvoie vrai
			return true;
		}
		
		
		
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}