﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			 DYNAMIC TOOLS	  		Version 0.4.0									***/
/***				   				   Dernière Mise à Jour : 10-08-28										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         			    Outils Interactivité											***/
/***	Ce script contient les méthodes pour faciliter la création et gestion d'interactivité sur des 	    ***/
/***	objets.																								***/
/***												      													***/
/***	Il contient des méthodes permettant de gagner du temps sur la mise de fonction pratique où 		 	***/
/***	l'utilisateur peut agir, comme un Drag & Drop par exemple.								 		 	***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Dynamic {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*—*//
	
	// —— - - DISPLAY
	import flash.display.MovieClip;
	//
	// —— - - EVENT
	import flash.events.Event;
	import flash.events.MouseEvent;
	//
	// —— - - UTILS
	import flash.utils.*;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	import drOIde.Port.MousePort;
	import drOIde.Visual.PixelTools;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	
	public class DynamicTools extends MiscTools {

		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function DynamicTools( TheLink:* = null		// ———— - - Lien vers la scène
									 ):void {
			/*—*/
			
			// Établit la connexion
			Connexion( TheLink );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					FUNCTION				  		  					  */
		/*						  Méthodes d'intéractivités reliées spécialement aux fonctions 				 	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - APPLY - - —————————————————————————————————————————— */
		// Les méthodes pour appliquer des intéractivités de fonctions
		/*—*/
		
		// —————— NEW DYNAMIC COUNTDOWN         									 	
		//	Génére un objet de compte à rebours avant le lancement d'une fonction mais dont le compteur peut être remodifiée
		
		public function NewDynamicCountdown( Fonction:* ,		// ———— - - La Fonction à lancer
											 Temps:int = 50		// ———— - - Le Temps du compte à rebours
										   ):Object {
			/*—*/
			
			// Génére l'objet de compte à rebours
			var NouveauCompte:Object = new Object();
			//
			// Donne les paramètres au compte à rebours
			NouveauCompte.Fonction = Fonction;
			NouveauCompte.Temps = Temps;
			NouveauCompte.Actif = true;
			//
			// Donne son porteur pour la méthode
			NouveauCompte.Porteur = new MovieClip();
			
			// Donne au porteur la boucle —— - -
			NouveauCompte.Porteur.Boucle = function( event:Event ):void {
				
				// Si le compte à rebours est actif —— - -
				if( NouveauCompte.Actif ){
					
					// Le temps réduit
					NouveauCompte.Temps--;
					
					// Si le temp a ateint zéro —— - -
					if( NouveauCompte.Temps <= 0 ){
						
						// Lance la fonction
						Launch( NouveauCompte.Fonction );
						//
						// Détruit le compte à rebouts
						NouveauCompte.Detruit()
					}
				}
			}
			//
			// Donne l'événement de boucle
			AddEvents( NouveauCompte.Porteur , NouveauCompte.Porteur.Boucle , "ENTER_FRAME" );
			
			
			// Donne au compte à rebours la méthode d'auto-destruction —— - -
			NouveauCompte.Detruit = function():void {
				
				// Retire ses événements
				RemoveEvents( NouveauCompte.Porteur );
				
				// La mes à null
				TotalNull( NouveauCompte );
			}
			
			// Renvoie le compte à rebours
			return NouveauCompte;
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 SHOT					  		  					  */
		/*								 Méthodes permettant de projeter des éléments 							  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - LAUNCH - - —————————————————————————————————————————— */
		// Les méthodes pour provoquer une projection
		/*—*/
		
		// —————— SHOT           									 	
		// Introduit un clip dans un conteneur ou dans un parent d'un autre clip de sorte qu'il soit "tiré" par un autre clip
		// dans la direction de ce dernier comme s'il s'agissait d'une balle
		//
		// ¤VorteX Compatible¤ 
		
		public function Shot( Tireur:* ,				// ———— - - Le Clip qui tire ( Influence la position x , y , rotation, etc. )
							  ClipTir:* ,				// ———— - - Le Clip tiré
							  Conteneur:* = null ,		// ———— - - Conteneur recevant le clip tiré ( Parent du clip si rien n'est mis )
							  Etat:* = null				// ¤¤—— - - Parametres additif au clip tiré
							):* {
			/*—*/
			
			// Récupére le conteneur par défaut comme étant le parent du tireur si rien n'a été mis pour lui
			if( !Conteneur ){ Conteneur = Tireur.parent; }
			
			// Créait et affiche le tir
			var leTir:* = NewElement( ClipTir , Conteneur , TypeOf( ClipTir ) + "_" + Tireur.name , Etat );
			
			// Parametres par défaut
			leTir.rotationShift = ( leTir.rotationShift == null ) ? 0 : leTir.rotationShift;
			leTir.xShift = ( leTir.xShift == null ) ? 0 : leTir.xShift;
			leTir.yShift = ( leTir.yShift == null ) ? 0 : leTir.yShift;
			leTir.speed = ( leTir.speed == null ) ? 5 : leTir.speed;
			//
			leTir.fonctionLoop = leTir.fonctionLoop || leTir.fonction;
			
			// Place le tir
			leTir.x = ( Etat.x || Tireur.x ) + leTir.xShift;
			leTir.y = ( Etat.y || Tireur.y ) + leTir.yShift;
			//
			// Donne la rotation au tir
			leTir.rotation = Tireur.rotation + leTir.rotationShift;
			
			
			// Donne la fonction de boucle au tir —— - -
			leTir.ShotLoop = function( event:Event ){
			
				// Instancie le tir
				var ceTir:* = event.target;
				
				// Va dans la direction de sa rotation
				SetDirectionTo( ceTir , Aspiration( ceTir.speed ) , ceTir );
				
				// S'il a une fonction —— - -
				if( ceTir.fonctionLoop ){
					
					// Lance la fonction
					Launch( ceTir.fonctionLoop , ceTir );
				}
			}
			//
			// Donne l'événement de boucle au tir
			AddEvents( leTir , leTir.ShotLoop , "ENTER_FRAME" );
			
			
			// Renvoie le clip de tir créé
			return leTir;
		}
		
		
		
		/* —————————————————————————————————————————— - - APPLY - - —————————————————————————————————————————— */
		// Les méthodes pour appliquer des principes de projections
		/*—*/
		
		// —————— MULTI SHOT           									 	
		//	Un clip tire constemment
		//
		// ¤VorteX Compatible¤ 
		
		public function MultiShot( Tireur:* ,				// ———— - - Le Clip qui tire
								   ClipTir:* ,				// ———— - - La class du clip tiré
								   							//		 ou "false" pour interrompre
								   
								   Conteneur:* = null ,		// ———— - - Conteneur recevant le clip tiré
								   Etat:* = null ,			// ———— - - Etat des clips
								   Parametres:* = null		// ¤¤—— - - Parametres additif au clip tiré
								):* {
			/*—*/
			
			// Arguments par défaut 
			Parametres = Parametres || new Object();
			
			// Si le second argument n'est pas une booléenne —— - -
			if( !TypeOf( ClipTir , "Boolean" ) ){
				
				// Si le clip qui tire a déjà un objet de tir —— - - Retire son ancien événement de boucle de tir
				if( Tireur.ObjetMitraille ){ 
					//
					RemoveEvents( Tireur , Tireur.ObjetMitraille.BoucleMitraille , "ENTER_FRAME" , "ShotLoop" ); 
				}
				
				// Créait l'objet de tir
				Tireur.ObjetMitraille = new Object();
				//
				// Donne les parametres de tir
				Tireur.ObjetMitraille.cadenceStep = 0;
				Tireur.ObjetMitraille.pack = Parametres.pack || 1;
				Tireur.ObjetMitraille.cadence = Parametres.cadence || 1;
				//
				// Donne l'activité du tir
				Tireur.ObjetMitraille.active = Parametres.active || false;
				
				
				// Fonction de tir —— - -
				Tireur.ObjetMitraille.Tir = function():void {
					/**/
					
					// Pour chaque tir dans une rafale —— - -
					for( var j:int = 0 ; j < Tireur.ObjetMitraille.pack ; j++ ){
						
						// Créait un nouveau tir
						var NouveauTir:* = Shot( Tireur , ClipTir , Conteneur , Etat );
						//
						// Tableau de décalage par pack
						var packList:Array = [ "x" , "y" , "rotation" , "width" , "height" ];
						
						// Pour chaque shift —— - -
						for( var iPack:int = 0 ; iPack < packList.length ; iPack++ ){
							
							// Récupère
							var NomPack:String = packList[ iPack ] ;
							var Pack:* = Parametres[ NomPack + "Pack" ];
							
							// S'il y en a un —— - -
							if( Pack ){
								//
								// Décalage par tableau
								if( TypeOf( Pack , "Array" ) ){ NouveauTir[ NomPack ] += Pack[ j ]; }
								//
								// Décalage par nombre
								else { NouveauTir[ NomPack ] += Pack * j; }  
							}
						}
						
						// Décalage basique de Position
						NouveauTir.x += Aspiration( Parametres.xShift , 0 );
						NouveauTir.y += Aspiration( Parametres.yShift , 0 );
						//
						// Décalage basique de Rotation
						NouveauTir.rotation += Aspiration( Parametres.rotationShift , 0 );
						//
						// Décalage basique de Taille
						NouveauTir.width += Aspiration( Parametres.widthShift , 0 );
						NouveauTir.height += Aspiration( Parametres.heightShift , 0 );
						
						
						// S'il y a une fonction de début —— - -
						if( Parametres.fonctionStart ){
						
							// Lance la fonction de début de tir avec le tir en argument
							Launch( Parametres.fonctionStart , NouveauTir );
						}
					}
				}
				
				
				// Fonction en boucle pour tirer —— - -
				Tireur.ObjetMitraille.BoucleMitraille = function( event:Event ):void {
					/**/
					
					// Si le palier de cadence a atteint zéro —— - -
					if( Tireur.ObjetMitraille.cadenceStep == 0 ){
						
						// Si le tir est actif —— - -
						if( Tireur.ObjetMitraille.active ){
							
							// Récupére la valeur de cadence par aspiration
							var Cadence:int = Aspiration( Tireur.ObjetMitraille.cadence );
							
							// Si la cadence est inférieur ou sur 1 —— - -
							if( Cadence <= 1 ){
								
								// Mes la cadence en positif
								Cadence = Math.abs( Cadence );
								
								// Pour chaque valeur de cadence —— - -
								for( var i:int = 0 ; i < Cadence ; i++ ){
									
									// Lance un tir
									Tireur.ObjetMitraille.Tir();
								}
								
							// Si la cadence est supérieur à 1 —— - -
							} else {
								
								// Lance un tir
								Tireur.ObjetMitraille.Tir();
								
								// Redénit la valeur du palier de cadence
								Tireur.ObjetMitraille.cadenceStep = Cadence;
							}
						}
						
					// Si le palier de cadence n'est pas sur zéro —— - - Il diminue
					} else { Tireur.ObjetMitraille.cadenceStep--; }
				}
				//
				// Donne l'événement de boucle au clip qui tir
				AddEvents( Tireur , Tireur.ObjetMitraille.BoucleMitraille , "ENTER_FRAME" , "ShotLoop" );
				
				
			// Si le second argument est une boolean —— - - 
			} else { 
				
				// S'il a un objet de mitraillage —— - - Redéfinie par elle l'activité du tir
				if( Tireur.ObjetMitraille ){ Tireur.ObjetMitraille.active = ClipTir; }
				
				// S'il n'a pas d'objet de mitraillage —— - - Trace l'erreur
				else {
					//
					TraceError( "DynamicTools" , "Mitraille" , 
							    "L'élément " + Tireur.name + " n'a pas reçut de mitraille initiale." );
				}
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					MOUSE					  		  					  */
		/*							Méthodes d'intéractivité orientées autour de la souris 						  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - APPLY - - —————————————————————————————————————————— */
		// Les méthodes pour appliquer des intéractivité souris
		/*—*/
	  
		// —————— DRAG AND DROP           									 	
		//	Permetre à un objet d'être déplaçable et de lui ajouter différents paramètres en rapport avec le Drag & Drop
	
	  	public function DragAndDrop( Cible:MovieClip ,			// ———— - - La Cible à rendre Drag & Dropable
									 Parametres:* = null ,		// ———— - - Les parametres du Drag & Drop
									 							//		 ou "false" pour le retirer de l'objet
									 
									 Zone:Array = null			// ———— - - Tableau de zones donnant une action si on lache l'élément dessus
								  ):void {
			/*—*/
			
			// Si on l'ajoute —— - -
			if( Parametres != false ){
				
				/* —— - - PARAMETRES - - —— */
				/**/
						 
				// Création de l'objet de gestion et mise des variables
				Cible.DragAndDrop = new Object();
				//
				Parametres = Parametres || new Object();
				Zone = Zone || new Array();
				//
				SetAll( Cible.DragAndDrop , Parametres );
				//
				Cible.DragAndDrop.Actif = false;
				Cible.DragAndDrop.Active = true;
				//
				Cible.DragAndDrop.xInitial = Cible.x;
				Cible.DragAndDrop.yInitial = Cible.y;
				//
				Cible.DragAndDrop.Mouse = new MousePort( Cible );
				
				// Parametres par défaut
				Cible.DragAndDrop.boomerang = ( Cible.DragAndDrop.boomerang == null ) ? true : Cible.DragAndDrop.boomerang;
				Cible.DragAndDrop.speed = Cible.DragAndDrop.speed || 10;
				
				
				/* —— - - CALIBRAGE DES ZONES - - —— */
				/**/
						 
				// Conversion des zones
				//
				// Pour chaque zones —— - -
				for( var Z:int = 0 ; Z < Zone.length ; Z++ ){
					
					// S'il n'y a pas de définition mais une zone pleine —— - -
					if( !Zone[ Z ].x1 && Zone[ Z ].Zone ){
						//
						// Calibre la zone dessus
						Zone[ Z ].x1 = Zone[ Z ].Zone.x;
						Zone[ Z ].y1 = Zone[ Z ].Zone.y;
						Zone[ Z ].x2 = Zone[ Z ].Zone.x + Zone[ Z ].Zone.width;
						Zone[ Z ].y2 = Zone[ Z ].Zone.y + Zone[ Z ].Zone.height;
					}
				}
				
				
				/* —— - - FONCTION DE DEPLACEMENT - - —— */
				/**/
						 
				// Donne la fonction de déplacement à l'élément —— - -
				Cible.DragAndDrop.Deplacement = function( event:MouseEvent ):void {
					
					// Récupère les objets principaux
					var DragObject:Object = Cible.DragAndDrop;
					
					// Définit le décalage par rapport au positionnement de la souris
					DragObject.xShift = DragObject.xShift || DragObject.Mouse.localX( Cible.parent ) - Cible.x;
					DragObject.yShift = DragObject.yShift || DragObject.Mouse.localY( Cible.parent ) - Cible.y;
					
					// Positionne l'élément
					Cible.x = DragObject.Mouse.localX( Cible.parent ) - DragObject.xShift;
					Cible.y = DragObject.Mouse.localY( Cible.parent ) - DragObject.yShift;
						
					// S'il dépasse —— - - Il est remis dessus
					if( DragObject.downLimit && Cible.y > DragObject.downLimit ){ Cible.y = DragObject.downLimit; }
					//
					// S'il dépasse —— - - Il est remis dessus
					if( DragObject.upLimit && Cible.y < DragObject.upLimit ){ Cible.y = DragObject.upLimit; }
					//
					// S'il dépasse —— - - Il est remis dessus
					if( DragObject.rightLimit && Cible.x > DragObject.rightLimit ){ Cible.x = DragObject.rightLimit; }
					//
					// S'il dépasse —— - - Il est remis dessus
					if( DragObject.leftLimit && Cible.x < DragObject.leftLimit ){ Cible.x = DragObject.leftLimit; }
					
					// S'il y a une limit —— - -
					if( DragObject.limit ){
						//
						if( Cible.x < DragObject.limit.x ){ Cible.x = DragObject.limit.x; }
						if( Cible.x > DragObject.limit.x + DragObject.limit.width ){ Cible.x = DragObject.limit.x + DragObject.limit.width; }
						//
						if( Cible.y < DragObject.limit.y ){ Cible.y = DragObject.limit.y; }
						if( Cible.y > DragObject.limit.y + DragObject.limit.height ){ Cible.y = DragObject.limit.y + DragObject.limit.height; }
					}
					
					
					/* —— - - CHECK ZONE - - —— */
					/**/
						 
					// Pour chaque zone définie —— - -
					for( var i:int = 0 ; i < Zone.length ; i++ ){
						
						// Si l'élément se trouve dans la zone —— - -
						if( Cible.x > Zone[ i ].x1 && Cible.x < Zone[ i ].x2 
						 && Cible.y > Zone[ i ].y1 && Cible.y < Zone[ i ].y2 ){
							
							// Si cette zone a une methode de survol —— - -
							if( Zone[ i ].fonctionOver ){
								
								// Essaye de lancer l'action rattachée avec arguments —— - -
								try {
									//
									Launch( Zone[ i ].fonctionOver , Cible );
									
								// Si échoue —— - - Sans arguments
								} catch ( e ){
									//
									Launch( Zone[ i ].fonctionOver );
								}
							}
						
						// Si l'élément ne la survole pas —— - -
						} else {
							
							// Si cette zone a une methode de non-survol —— - -
							if( Zone[ i ].fonctionOut ){
								
								// Essaye de lancer l'action rattachée avec arguments —— - -
								try {
									//
									Launch( Zone[ i ].fonctionOut , Cible );
									
								// Si échoue —— - - Sans arguments
								} catch ( e ){
									//
									Launch( Zone[ i ].fonctionOut );
								}
							}
						}
					}
	
					// Rafraichit l'affichage pour un rendu fluide
					event.updateAfterEvent();
				}
				
				
				/* —— - - FONCTION DE RETOUR ANCRE - - —— */
				/**/
						 
				// Donne la fonction de boucle de retour —— - -
				Cible.DragAndDrop.Return = function( event:Event ):void { 
					
					// Récupère les objets principaux
					var DragObject:Object = Cible.DragAndDrop;
					
					// Récupére les valeurs de déplacement fluide pour que l'élément se repositionne où il faut
					var DeplacementX:Number = NumberGoTo( Cible.x , DragObject.xInitial , DragObject.speed , 0.05 );
					var DeplacementY:Number = NumberGoTo( Cible.y , DragObject.yInitial , DragObject.speed , 0.05 );
					
					// Si c'est valeurs sont à 0 —— - - La boucle est retirée
					// Ou si on est en Drag & Drop sur l'élément
					if( DeplacementX == 0 && DeplacementY == 0 || DragObject.Actif ){ 
						//
						RemoveEvents( Cible , DragObject.Return , "ENTER_FRAME" , "DragReturnLoop" );
					}
					
					// Applique le déplacement
					Cible.x = DeplacementX;
					Cible.y = DeplacementY;
				}
				
				
				/* —— - - FONCTION D'APPUIE - - —— */
				/**/
						 
				// Donne la fonction de clic sur l'élément —— - -
				Cible.DragAndDrop.Down = function( event:MouseEvent ):void { 
					
					// Récupère les objets principaux
					var DragObject:Object = Cible.DragAndDrop;
					
					// S'il est activé —— - -
					if( DragObject.Active ){
					
						// Donne à son stage la méthode de déplacement de l'élément
						AddEvents( Cible.stage , DragObject.Deplacement , "MOUSE_MOVE" , "DragMove" + Cible.name );
						
						// Active l'état de Drag & Drop
						DragObject.Actif = true;
						
						// Lance la méthode rattachée
						Launch( DragObject.fonctionDown );
					}
				}
				
				
				/* —— - - FONCTION DE RELACHEMENT - - —— */
				/**/
						 
				// Donne la fonction de relachement du clic sur l'élément —— - -
				Cible.DragAndDrop.Up = function( event:MouseEvent ):void { 
					
					// Récupère les objets principaux
					var DragObject:Object = Cible.DragAndDrop;
					
					// S'il est saisi —— - -
					if( DragObject.Actif ){
						
						// Retire la méthode de déplacement de l'élément de son stage
						RemoveEvents( Cible.stage , DragObject.Deplacement , "MOUSE_MOVE" , "DragMove" + Cible.name );
						
						// Désactive l'état de Drag & Drop
						DragObject.Actif = false;
						
						// Met le décalage à null
						DragObject.xShift = null;
						DragObject.yShift = null;
						
						// Lance la méthode rattachée
						Launch( DragObject.fonctionUp );
						
						// S'il est un Boomerang —— - -
						if( DragObject.boomerang ){
							
							// Lance la boucle de retour
							AddEvents( Cible , DragObject.Return , "ENTER_FRAME" , "DragReturnLoop" );
						}
						
						
						/* —— - - CHECK ZONE - - —— */
						/**/
						 
						// Pour chaque zone définie —— - -
						for( var i:int = 0 ; i < Zone.length ; i++ ){
							
							// Si l'élément se trouve dans la zone —— - -
							if( Cible.x > Zone[ i ].x1 && Cible.x < Zone[ i ].x2 
							 && Cible.y > Zone[ i ].y1 && Cible.y < Zone[ i ].y2 ){
								
								// Si cette zone a une methode —— - -
								if( Zone[ i ].fonction ){
									
									// Essaye de lancer l'action rattachée avec arguments —— - -
									try {
										//
										Launch( Zone[ i ].fonction , Cible );
										
									// Si échoue —— - - Sans arguments
									} catch ( e ){
										//
										Launch( Zone[ i ].fonction );
									}
								}
								
								// S'il doit ancrer —— - -
								if( Zone[ i ].anchor ){
									
									// Change les positions initiales pour celles actuelles
									DragObject.xInitial = Cible.x;
									DragObject.yInitial = Cible.y;
								}
							}
						}
					}
				}
				
				
				/* —— - - FONCTION D'ANCRAGE - - —— */
				/**/
						 
				// Fonction d'ancrage —— - -
				Cible.SetAnchor = function( X:* = null ,
										    Y:* = null
										   ):void {
					
					// Repositionne le ancrage
					Cible.DragAndDrop.xInitial = X || Cible.x;
					Cible.DragAndDrop.yInitial = Y || Cible.y;
				}
				
				
				/* —— - - CALIBRAGE EVENEMENT - - —— */
				/**/
				
				// Donne les événements à l'élément
				AddEvents( Cible , Cible.DragAndDrop.Down , "MOUSE_DOWN" , "DragDown" + Cible.name );
				AddEvents( Cible.stage , Cible.DragAndDrop.Up , "MOUSE_UP" , "DragUp" + Cible.name );
			
			
			// Si on le retire —— - -
			} else {
			
				// Retire les événements de l'élément
				RemoveEvents( Cible , Cible.DragAndDrop.Down , "MOUSE_DOWN" , "DragDown" + Cible.name );
				RemoveEvents( Cible.stage , Cible.DragAndDrop.Up , "MOUSE_UP" , "DragUp" + Cible.name );
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				   SCREEN					  		  					  */
		/*							 Méthodes d'intéractivité orientée autour de l'écran 						  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - SCROLLING - - —————————————————————————————————————————— */
		// Les méthodes permettant de déplacer un script container par rapport à un ou plusieurs éléments qu'il contient
		/*—*/
		
		// —————— SCROLL TRAVELLING           									 	
		//	Suis un objet dans la scène en faisant déplacer le clip de sa scène en sens inverse pour que l'élément reste au
		//	centre de l'écran
		
		public function ScrollTravelling( Element:* ,				// ———— - - La Cible devant se retrouver au centre de l'écran
										  Conteneur:* = null ,		// ———— - - Le Conteneur de la scene, le clip qui va bouger
										 							//		 ou Les Parametres
										 
										  Parametres:Object = null	// ———— - - Les Parametres du scrolling
										):void {
			/*—*/
			
			// Switch des arguments
			if( TypeOf( Conteneur , "Object" ) ){
				//
				Parametres = Conteneur;
				Conteneur = null;
			}
			
			// Récupération du stage
			var leStage:* = Element.stage || Conteneur.stage;
			
			// Arguments par défaut
			Conteneur = Conteneur || Element.parent;
			Parametres = Parametres || new Object();
			
			// Donnes les éléments et parametres
			Conteneur.ScrollingObject = new Object();
			//
			Conteneur.ScrollingObject.CentralElement = Element;
			Conteneur.ScrollingObject.Parametres = Parametres;
			
			// Donne la scène la fonction de scrolling —— - -
			Conteneur.Travelling = function( event:* = null ):void {
				
				// Si la fonction a été lancé par la boucle —— - -
				if( event != null && event != true && event != false ){
					
					// Récupére l'instance de la scène
					var ConteneurCible:* = event.target;
					var ConteneurElement:Object = ConteneurCible.ScrollingObject.CentralElement;
					var ConteneurParametres:Object = ConteneurCible.ScrollingObject.Parametres;
					
					// Récupére la taille écran
					var stageWidth:Number = ( ConteneurParametres.stageWidth || leStage.stageWidth );
					var stageHeight:Number = ( ConteneurParametres.stageHeight || leStage.stageHeight );
					
					// Modifie la position de la scène en fonction de la taille de l'écran et de la position de l'élément central
					ConteneurCible.x = stageWidth / 2 - ConteneurElement.x;
					ConteneurCible.y = stageHeight / 2 - ConteneurElement.y;
					
					// Elle se bloque à droite si elle a dépassé
					if( ConteneurParametres.rightLimit != null && ConteneurCible.x < -ConteneurParametres.rightLimit + stageWidth ){
						//
						ConteneurCible.x = -ConteneurParametres.rightLimit + stageWidth; 
					}
					
					// Elle se bloque à gauche si elle a dépassé
					if( ConteneurParametres.leftLimit != null && ConteneurCible.x > ConteneurParametres.leftLimit ){ 
						//
						ConteneurCible.x = ConteneurParametres.leftLimit;
					}
					
					// Elle se bloque en haut si besoin est
					if( ConteneurParametres.downLimit != null && ConteneurCible.y < -ConteneurParametres.downLimit + stageHeight ){ 
						//
						ConteneurCible.y = -ConteneurParametres.downLimit + stageHeight;
					}
				
					// Elle se bloque en bas si elle a dépassé
					if( ConteneurParametres.upLimit != null && ConteneurCible.y > ConteneurParametres.upLimit ){ 
						//
						ConteneurCible.y = ConteneurParametres.upLimit;
					}
				
				// Si la fonction a été lancé en externe —— - -
				} else {
					
					// Si on argumente faux —— - -
					if( event == false ){
				
						// Retire la boucle
						RemoveEvents( Conteneur , Conteneur.Travelling , "ENTER_FRAME" , "ScrollTravelling" );
					
					// Si on argumente rien ou vrai —— - -
					} else {
				
						// Relance la boucle
						AddEvents( Conteneur , Conteneur.Travelling , "ENTER_FRAME" , "ScrollTravelling" );
					}
				}
			}
			//
			// Donne à la scène l'événement en boucle pour le placement en travelling
			AddEvents( Conteneur , Conteneur.Travelling , "ENTER_FRAME" , "ScrollTravelling" );
		}
	  	
		
		// —————— SCROLL EXTENDING           									 	
		//	Déplace une scène par rapport à un élément qu'il contient de façon à étendre  la distance qu'il peut parcourir
		
		public function ScrollExtending( Element:* ,				// ———— - - La Cible qui va bouger
										 Conteneur:* = null ,		// ———— - - Le Conteneur de la scene, le clip qui va bouger
										 							//		 ou Les Parametres
										 
										 Parametres:Object = null	// ———— - - Les Parametres du scrolling
										):void {
			/*—*/
			
			// Switch des arguments
			if( TypeOf( Conteneur , "Object" ) ){
				//
				Parametres = Conteneur;
				Conteneur = null;
			}
			
			// Récupération des valeurs et arguments par défaut
			var leStage:* = Element.stage;
			Conteneur = Conteneur || Element.parent;
			//
			Parametres = Parametres || new Object();
			//
			Parametres.widthDistance = Parametres.widthDistance || leStage.stageWidth; 
			Parametres.heightDistance = Parametres.heightDistance || leStage.stageHeight;
			//
			Parametres.leftLimit 	= ( Parametres.leftLimit != null ) 	? Parametres.leftLimit 	: -99999999
			Parametres.rightLimit 	= ( Parametres.rightLimit != null ) ? Parametres.rightLimit : 99999999
			Parametres.upLimit 		= ( Parametres.upLimit != null ) 	? Parametres.upLimit 	: -99999999
			Parametres.downLimit 	= ( Parametres.downLimit != null ) 	? Parametres.downLimit 	: 99999999
			
			// Donnes les valeurs à la scène
			Conteneur.ExtendingObject = new Object();
			//
			SetAll( Conteneur.ExtendingObject , Parametres );
			//
			Conteneur.ExtendingObject.CentralElement = Element;
			
			// Donne la scène la fonction de scrolling —— - -
			Conteneur.Extending = function( event:* = null ):void {
				
				// Si l'event n'est pas null ou booléen —— - -
				if( event != null && event != false && event != true ){
					
					// Récupére l'instance du conteneur et de son objet
					var CeConteneur:* = event.target;
					var ExtendingObject:* = CeConteneur.ExtendingObject;
					
					// Récupère la position de l'élément suivant les limites
					var PositionX:Number = BumpNumber( ExtendingObject.CentralElement.x , ExtendingObject.leftLimit , 	ExtendingObject.rightLimit );
					var PositionY:Number = BumpNumber( ExtendingObject.CentralElement.y , ExtendingObject.upLimit , 	ExtendingObject.downLimit );
					
					// Modifie la position de la scène en fonction de la taille de l'écran et de la position de l'élément central
					CeConteneur.x = ( ( ExtendingObject.widthDistance - leStage.stageWidth ) * -( PositionX /  ExtendingObject.widthDistance ) );
					CeConteneur.y = ( ( ExtendingObject.heightDistance - leStage.stageHeight ) * -( PositionY /  ExtendingObject.heightDistance ) );
				
				// Sinon —— - -
				} else {
					
					// S'il est vrai —— - -
					if( event == true ){
				
						// Ajoute l'événement
						AddEvents( CeConteneur , CeConteneur.Extending , "ENTER_FRAME" , "ScrollExtending" );
						
					// S'il est faux ou null —— - -
					} else {
				
						// Retire l'événement
						RemoveEvents( CeConteneur , CeConteneur.Extending , "ENTER_FRAME" , "ScrollExtending" );
					}
				}
			}
			//
			// Donne à la scène l'événement en boucle pour le placement en scrolling
			AddEvents( Conteneur , Conteneur.Extending , "ENTER_FRAME" , "ScrollExtending" );
		}
	  	
	  	
		// —————— SCROLL ENGLOBING           									 	
		//	Suis deux objets ou plus dans une scène en la déplaçant et la redimentionnant de sorte de concerver tout les éléments dans la scène
		
		public function ScrollEnglobing( Element:* ,				// ———— - - Les Cibles devant se retrouver à l'écran ( Tableau )
										 Conteneur:* ,				// ———— - - Le Conteneur de la scene, le clip qui va changer de taille
										 
										 Parametres:Object = null 	// ———— - - Les Parametres du scrolling
								):void {
			/*—*/
			
			// Switch des arguments
			if( TypeOf( Conteneur , "Object" ) ){
				//
				Parametres = Conteneur;
				Conteneur = null;
			}
			
			// Arguments par défaut
			Element = CapsuleArray( Element );
			Conteneur = Conteneur || Element[ 0 ].parent;
			var leStage:* = Element[ 0 ].stage;
			
			// Donnes les valeurs à la scène
			Conteneur.EnglobingObject = new Object();
			//
			SetAll( Conteneur.EnglobingObject , Parametres );
			//
			Conteneur.EnglobingObject.CentralElement = Element;
			
			
			// Donne à la scène la fonction de scrolling —— - -
			Conteneur.Englobing = function( event:* = null ):void {
				
				// Si l'event n'est pas null ou une booléenne —— - -
				if( event != null && event != false && event != true ){
					
					// Récupére l'instance de la scène
					var CeConteneur:* = event.target;
					var EnglobingObject:Object = CeConteneur.EnglobingObject;
					
					// Objet général de position
					var ObjetPosition:Object = { x:0 , y:0 };
					
					// Variables des positions Min et Max
					var MinX:Number = 9999999;
					var MinY:Number = 9999999;
					//
					var MaxX:Number = -9999999;
					var MaxY:Number = -9999999;
					
					// Récupère les positions Minimales et Maximales —— - -
					for( var E:int ; E < EnglobingObject.CentralElement.length ; E++ ){
						
						// Récupére son instance
						var CetElement:* = EnglobingObject.CentralElement[ E ];
						
						// S'il est plus loin dans un sens —— - -
						if( CetElement.x < MinX ){ MinX = CetElement.x; }
						if( CetElement.y < MinY ){ MinY = CetElement.y; }
						//
						// ...et dans l'autre —— - -
						if( CetElement.x > MaxX ){ MaxX = CetElement.x; }
						if( CetElement.y > MaxY ){ MaxY = CetElement.y; }
					}
					
					// S'il y a deux clips minimums —— - -
					if( EnglobingObject.CentralElement.length > 1 ){
						
						// Si l'horizontal est plus grande —— - -
						if( MaxX - MinX > MaxY - MinY ){
							
							// Modifie la taille en rapport à l'horizontal
							CeConteneur.scaleX = ( ( EnglobingObject.width || leStage.stageWidth ) 
											   + ( EnglobingObject.widthLimit || 0 ) ) / ( MaxX - MinX ) 
											   - ( EnglobingObject.widthBump || 10 ) / 100;
											   //
							CeConteneur.scaleY = ( ( EnglobingObject.width || leStage.stageWidth ) 
											   + ( EnglobingObject.widthLimit || 0 ) ) / ( MaxX - MinX ) 
											   - ( EnglobingObject.widthBump || 10 ) / 100;
							
						// Si la vertical est plus grande
						} else {
							
							// Modifie la taille en rapport à la verticale
							CeConteneur.scaleX = ( ( EnglobingObject.height || leStage.stageHeight ) 
											   + ( EnglobingObject.heightLimit || 0 ) ) / ( MaxY - MinY ) 
											   - ( EnglobingObject.heightBump || 10 ) / 100;
											   //
							CeConteneur.scaleY = ( ( EnglobingObject.height || leStage.stageHeight ) 
											   + ( EnglobingObject.heightLimit || 0 ) ) / ( MaxY - MinY ) 
											   - ( EnglobingObject.heightBump || 10 ) / 100;
						}
						
						// Bump de taille
						CeConteneur.scaleX = BumpNumber( CeConteneur.scaleX , EnglobingObject.sizeMin || 0.01 , EnglobingObject.sizeMax || 100 );
						CeConteneur.scaleY = BumpNumber( CeConteneur.scaleY , EnglobingObject.sizeMin || 0.01 , EnglobingObject.sizeMax || 100 );
					}
					
					// Donne les moyennes obtenues à l'objet de position
					ObjetPosition.x = ( MaxX + MinX ) / 2;
					ObjetPosition.y = ( MaxY + MinY ) / 2;
					
					// Modifie la position de la scène en fonction de la taille de l'écran et de la position de l'élément central
					CeConteneur.x = ( EnglobingObject.width || leStage.stageWidth ) / ( 2 * CeConteneur.scaleX ) - ObjetPosition.x 
								  + ( EnglobingObject.xShift || 0 );
					CeConteneur.y = ( EnglobingObject.height || leStage.stageHeight ) / ( 2 * CeConteneur.scaleX ) - ObjetPosition.y 
								  + ( EnglobingObject.yShift || 0 );
					//
					CeConteneur.x *= CeConteneur.scaleX + ( EnglobingObject.scaleShift || 0 );
					CeConteneur.y *= CeConteneur.scaleY + ( EnglobingObject.scaleShift || 0 );
					
					// Elle se bloque à droite si elle a dépassé
					if( EnglobingObject.rightLimit != null && CeConteneur.x < EnglobingObject.rightLimit ){ CeConteneur.x = EnglobingObject.rightLimit; }
					
					// Elle se bloque à gauche si elle a dépassé
					if( EnglobingObject.leftLimit != null && CeConteneur.x > EnglobingObject.leftLimit ){ CeConteneur.x = EnglobingObject.leftLimit; }
					
					// Elle se bloque en bas si elle a dépassé
					if( EnglobingObject.downLimit != null && CeConteneur.y < EnglobingObject.downLimit ){ CeConteneur.y = EnglobingObject.downLimit; }
					
					// Elle se bloque en haut si besoin est
					if( EnglobingObject.upLimit != null && CeConteneur.y > EnglobingObject.upLimit ){ CeConteneur.y = EnglobingObject.upLimit; }
				
				
				// Sinon —— - -
				} else {
					
					// S'il est vrai —— - -
					if( event == true ){
				
						// Ajoute l'événement
						AddEvents( CeConteneur , CeConteneur.Englobing , "ENTER_FRAME" , "ScrollEnglobing" );
						
					// S'il est faux ou null —— - -
					} else {
				
						// Retire l'événement
						RemoveEvents( CeConteneur , CeConteneur.Englobing , "ENTER_FRAME" , "ScrollEnglobing" );
					}
				}
			}
			//
			// Donne à la scène l'événement en boucle pour le scrolling
			AddEvents( Conteneur , Conteneur.Englobing , "ENTER_FRAME" , "ScrollEnglobing" );
		}
	  	
	  	
		// —————— SCROLL SNAPPING
		//	Suis deux objets ou plus dans une scène en la déplaçant et la redimentionnant de sorte de concerver tout les éléments dans la scène
		
		public function ScrollSnapping( Element:* ,					// ———— - - La Cible au centre du suivis
									    Conteneur:* = null ,		// ———— - - La Cible qui est snappée
																	//		 ou Les Parametres
																	
									    Parametres:Object = null ,	// ———— - - Les Parametres du Scrolling
																	//		 ou Les Etats
																	
									    Etat:Object = null			// ———— - - Les États de l'image
									   ):void {
			/*—*/
			
			// Switch des arguments
			if( TypeOf( Conteneur , "Object" ) ){
				//
				if( Parametres ){
					//
					Etat = Parametres;
				}
				//
				Parametres = Conteneur;
				Conteneur = null;
			}
			
			// Arguments par défaut
			Conteneur = Conteneur || Element.parent;
			
			// Récupèration du stage
			var leStage:* = Element.stage;
			
			// Récupération du Script PixelTools
			var Pixel:PixelTools = new PixelTools();
			
			// Arguments par défaut
			var Nom:String = Parametres.name = Parametres.name || Element.name;
			var Remplissage:* = Parametres.background;
			
			// Donnes les valeurs
			Conteneur[ "Snapping" + Parametres.name + "Object" ] = new Object();
			//
			var Ecran:Object = { Droite:Parametres.width || leStage.stageWidth , Bas:Parametres.height || leStage.stageHeight };
			//
			Ecran.Gauche = Parametres.xShift || Parametres.width / 2;
			Ecran.Haut = Parametres.yShift || Parametres.height / 2;
			//
			var CibleSnap:* = Conteneur || Element.parent;
			//
			Conteneur = Parametres.conteiner || Conteneur.parent;
			//
			var Limites:Object = { Gauche:Parametres.leftLimit , Droite:Parametres.rightLimit , Haut:Parametres.upLimit , Bas:Parametres.downLimit };
			
			// Créait le clip recevant le snapping
			var ConteneurSnapping:MovieClip = NewElement( MovieClip , Conteneur , "ConteneurSnapping" , Etat );
			
			// Donne à la scène la fonction de scrolling —— - -
			Conteneur[ "Snapping" + Nom ] = function( event:* = null ):void {
				
				// Si l'event n'est ni null, ni booléen —— - -
				if( event != null && event != true && event != false ){
					
					// Détruit l'ancien conteneur de l'image
					if( ConteneurSnapping.Image ){ DestroyElement( ConteneurSnapping.Image ); }
					
					// Créait le conteneur de l'image
					var Image:MovieClip = NewElement( MovieClip , ConteneurSnapping , "Image" );
					
					// Définit les positions suivants les limitations
					var PositionX:Number = Ecran.Gauche - Element.x;
					var PositionY:Number = Ecran.Haut - Element.y;
					//
					if( Limites.Gauche != null ){
						//
						PositionX = ( PositionX > Limites.Gauche ) ? Limites.Gauche : PositionX;
					}
					//
					if( Limites.Droite != null ){
						//
						PositionX = ( PositionX < -Limites.Droite + Ecran.Droite ) ? -Limites.Droite + Ecran.Droite : PositionX;
					}
					//
					if( Limites.Haut != null ){
						//
						PositionY = ( PositionY > Limites.Haut ) ? Limites.Haut : PositionY;
					}
					//
					if( Limites.Bas != null ){
						//
						PositionY = ( PositionY < -Limites.Bas + Ecran.Bas ) ? -Limites.Bas + Ecran.Bas : PositionY;
					}
					
					// S'il faut opérer un remplissage —— - -
					if( Remplissage ){
						
						// Intégre le remplissage
						var Remplie:* = NewElement( Remplissage.Clip , Remplissage.Conteneur , "Remplissage" , { x:-PositionX , y:-PositionY } );
					}
					
					// Opère le snapping
					Pixel.Snap( CibleSnap , Image , { x:PositionX , y:PositionY } , { width:Ecran.Droite , height:Ecran.Bas } );
					
					// S'il a fallut opérer un remplissage —— - -
					if( Remplissage ){
						
						// Retire le remplissage
						DestroyElement( Remplie );
					}
				
				// Sinon —— - -
				} else {
					
					// S'il est null ou false —— - -
					if( event == null || event == false ){
						
						// Retire l'événement
						RemoveEvents( Conteneur , Conteneur[ "Snapping" + Nom ] , "ENTER_FRAME" , "ScrollSnapping" + Nom );
						
						// Détruit l'ancien conteneur de l'image
						if( ConteneurSnapping.Image ){ DestroyElement( ConteneurSnapping.Image ); }
					
					// S'il est vrai —— - -
					} else {
						
						// Relance l'événement l'événement
						AddEvents( Conteneur , Conteneur[ "Snapping" + Nom ] , "ENTER_FRAME" , "ScrollSnapping" + Nom );
					}
				}
			}
			//
			// Donne à la scène l'événement en boucle pour le placement en scrolling
			AddEvents( Conteneur , Conteneur[ "Snapping" + Nom ] , "ENTER_FRAME" , "ScrollSnapping" + Nom );
		}
	
		
		
		/* —————————————————————————————————————————— - - OFF SCREEN - - —————————————————————————————————————————— */
		// Les méthodes qui permette de gérer les agissement d'éléments quand ils sortent
		/*—*/
		
		// —————— OFF SCREEN ACTION
		//				           									 	
		//	Définie une action lors de la sortie d'écran d'un élément
	
		public function OffScreenAction( Element:* ,			// ———— - - L'Élément concerné
									     Type:* = "Destroy" ,	// ———— - - Type d'action hors-champ ( "Destroy" ou "Block" )
									     Bump:Object = null		// ———— - - Les valeurs des portions de la scène
									  ):void {
			/*—*/
			
			// Switch des arguments
			if( TypeOf( Type , "Object" ) ){
				//
				Bump = Type;
				Type = "Destroy";
			}
			
			// Argument de Bump par défaut
			Bump = Bump || new Object();
			
			// Arguments stage par défaut
			var laScene:* = Element.stage;
			
			// Si on a besoin du stage et qu'on ne l'a pas —— - - trace l'erreur
			if( !TypeOf( laScene , "Stage" ) && !Bump.Droite && !Bump.Bas ){
				//
				TraceError( "DynamicTools" , "MortHorsChamp" , "Impossible de retrouver le stage à partir de l'élément que vous avez donné." );
				
			// Sinon —— - -
			} else {
				
				// Arguments par défaut
				Bump.Haut = Bump.Haut || 0;
				Bump.Bas = Bump.Bas || laScene.stageHeight;
				Bump.Gauche = Bump.Gauche || 0;
				Bump.Droite = Bump.Droite || laScene.stageWidth;
				
				// Si l'élément a déjà un Hors champ —— - - trace l'erreur
				if( Element.OffScreen ){
					//
					TraceError( "DynamicTools" , "MortHorsChamp" , "L'élément " + Element + " a déjà un événement concernant le hors champ." );
					
				// Sinon —— - -
				} else {
					
					// Donne l'objet d'HorsChamp à l'élément
					Element.OffScreen = new Object();
					//
					// Donne le type d'hors-champ
					Element.OffScreen.Type = Type;
					//
					// Donne les paramètres à l'élément
					Element.OffScreen.Bump = Bump;
					Element.OffScreen.laScene = laScene;
					
					// Donne la boucle à l'élément —— - -
					Element.OffScreen.Boucle = function( event:Event ):void {
						
						// Récupére l'instance de l'élément et du champ
						var Cible:* = event.target;
						var Champ:* = Cible.OffScreen;
						
						// S'il est de type destruction —— - -
						if( Champ.Type == "Destroy" ){
						
							// Si l'élément dépasse par un des bors en entier —— - - Il est annihilé
								 if( GetTotal( Cible , "x" ) - GetTotal( Cible , "width" ) / 2 > Champ.Bump.Droite ){ DestroyElement( Cible ); }
							else if( GetTotal( Cible , "x" ) + GetTotal( Cible , "width" ) / 2 < Champ.Bump.Gauche ){ DestroyElement( Cible ); }
							else if( GetTotal( Cible , "y" ) - GetTotal( Cible , "height" ) / 2 > Champ.Bump.Bas ){ DestroyElement( Cible ); }
							else if( GetTotal( Cible , "y" ) + GetTotal( Cible , "height" ) / 2 < Champ.Bump.Haut ){ DestroyElement( Cible ); }
						
						// S'il est de type blocage —— - -
						} else if( Champ.Type == "Block" ){
							
							// Si l'élément dépasse par un des bors en entier —— - - Il est bloqué
							 if( GetTotal( Cible , "x" ) + GetTotal( Cible , "width" ) / 2 > Champ.Bump.Droite ){ 
								Cible.x = Champ.Bump.Droite - GetTotal( Cible , "width" ) / 2; }
							 //
							if( GetTotal( Cible , "x" ) - GetTotal( Cible , "width" ) / 2 < Champ.Bump.Gauche ){ 
								Cible.x = Champ.Bump.Gauche + GetTotal( Cible , "width" ) / 2; }
							//
							if( GetTotal( Cible , "y" ) + GetTotal( Cible , "height" ) / 2 > Champ.Bump.Bas ){ 
								Cible.y = Champ.Bump.Bas - GetTotal( Cible , "height" ) / 2; }
							//
							if( GetTotal( Cible , "y" ) - GetTotal( Cible , "height" ) / 2 < Champ.Bump.Haut ){ 
								Cible.y = Champ.Bump.Haut + GetTotal( Cible , "height" ) / 2; }
						}
					}
					//
					// Donne l'événement de boucle à l'élément
					AddEvents( Element , Element.OffScreen.Boucle , "ENTER_FRAME" , "OffScreenLoop" );
				}
			}
		}
		
		
		
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}