﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        				HIT PROCESS	  	Version 0.5.0										***/
/***				   				   Dernière Mise à Jour : 10-08-14										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         			   Gestionnaire Collision											***/
/***	Ce script accumule des appels de collisions entre objets et les tests en continue. 				    ***/
/***	Il optimise de ce fait les test de collisions.														***/
/***												      													***/
/***	Il permet, également, de définir des principes de collisions différents de la collision standard.	***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Dynamic {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	
	// —— - - DISPLAY
	import flash.display.MovieClip;
	//
	// —— - - EVENT
	import flash.events.Event;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class HitProcess extends MiscTools {
				
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		// —————— Active
	    // Si le script est Actif ou pas
		public var Active:Boolean = true; 

		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function HitProcess( TheLink:* = null	// ———— - - Lien vers la scène
								  ):void {
			/*—*/
			
			// Établit la connexion
			Connexion( TheLink );
			
			// Création de la boucle de test de collision
			AddEvents( this , GlobalLoop , "ENTER_FRAME" );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 GLOBAL					  		  					  */
		/*									 Méthodes de gestion global du Script 								  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
		
		// —————— COUNTER
	    // Le Counter de relancement de la méthode HitTest
		private var Counter:int = 0;
		private var CounterMax:int = 5;
		
		
		
		/* —————————————————————————————————————————— - - LOOP - - —————————————————————————————————————————— */
		// Les boucles de gestion globales
		//*—*//
		
		// —————— REFRESH
	    // Exactement comme Global Loop mais avec un terme différent
		
		public function Refresh( event:* = null ,	// ———— - - Event ou Rien
								 Parametres:* = ""	// ———— - - Les Parametres additifs
							   ):void {
			/*—*/
			
			// Lance la GLobaLoop
			GlobalLoop( event , Parametres );
		}
		
		
		// —————— GLOBAL LOOP
	    // Boucle principale pour les test de collisions
		
		public function GlobalLoop( event:* = null ,	// ———— - - Event ou Rien
									Parametres:* = ""	// ———— - - Les Parametres additifs
								   ):void {
			/*—*/
			
			// Si le script est Active —— - -
			if( Active ){
				
				// Augmente le Counter
				Counter++;
				
				// Si le Counter n'est pas supérieur à la valeur max —— - -
				if( Counter <= CounterMax ){
					
					
					// Si ce n'est pas une demande précise —— - - Lance la destruction à retardement
					if( event != "Obstacle"  
					 && event != "Proximite"  
					 && event != "Collision"  ){ 
						//
						CheckDestruction( Parametres ); 
					}
					
					
					// Si ce n'est pas une demande précise d'obstacle ou de proximité —— - -
					if( event != "Obstacle" 
					 && event != "Proximite" ){
						//
						// Lance le test de collision
						CheckCollision( Parametres );
					}
					
					
					// Si ce n'est pas une demande précise de collision ou de proximité —— - -
					if( event != "Collision" 
					 && event != "Proximite" ){
						//
						// Lance le test d'obstacle
						CheckObstacle( Parametres );
					}
					
					
					// Si ce n'est pas une demande précise de collision ou de proximité —— - -
					if( event != "Collision" 
					 && event != "Obstacle" ){
						//
						// Lance le test de proximité
						CheckProximity( Parametres );
					}
				}
				
				// Le Counter retombe à zéro
				Counter = 0;
			}
		}
		//
		// —————— CHECK COLLISION
	    // Boucle principale pour les test de collisions
		private function CheckCollision( Parametres:* = "" // ———— - - Les Parametres additifs
										):void {
			/*—*/
			
			// Pour chaque collision définie ———— - -
			for( var bloc:Object in Collisions ){
				
				// Si la collision définie n'est pas null ———— - -
				if( Collisions[ bloc ] != null ){
					
					// Trace des erreurs —— - -
					//
					// Si l'élément 1 n'existe pas —— - - Trace l'erreur
					if( !Bodies[ Collisions[ bloc ].Element1 ] ){
						//
						TraceSoftError( "HitProcess" , "Boucle de HitTest" , "L'element 1 : \"" + bloc + "\" n'existe pas ou plus." );
					//
					// Si l'élément 2 n'existe pas —— - - Trace l'erreur
					} else if( !Bodies[ Collisions[ bloc ].Element2 ] ){
						//
						TraceSoftError( "HitProcess" , "Boucle de HitTest" , "L'element 2 : \"" + bloc + "\" n'existe pas ou plus." );

					// Si elle est de type "Objet" ———— - -
					} else if( Collisions[ bloc ].mod == "Object" ){
						
						// S'il y a collision entre les deux éléments définie dans cette collision ———— - -
						if( Bodies[ Collisions[ bloc ].Element1 ].hitTestObject( Bodies[ Collisions[ bloc ].Element2 ] ) ){
							
							// Si on demande l'argumentation —— - -
							if( Collisions[ bloc ].Parametres.Argumentation ){
							
								// Lance la fonction prévue pour chaque élément avec son objet contenant les arguments
								// avec les arguments additifs étant les deux éléments en collision
								Launch( Collisions[ bloc ].Fonction , true , [ Bodies[ Collisions[ bloc ].Element1 ] , 
																			  Bodies[ Collisions[ bloc ].Element2 ] ] );
								
							// Si on ne demande pas l'argumentation —— - -
							} else {

								// Lance la fonction prévue pour chaque élément avec son objet contenant les arguments
								Launch( Collisions[ bloc ].Fonction );
							}
						}
						
						
					// Si elle est de type "Point" ———— - -
					} else if ( Collisions[ bloc ].mod == "Point" ){
						
						// S'il y a collision entre le premier élément et le point centrale x,y du second élément ———— - -
						if( Bodies[ Collisions[ bloc ].Element1 ].hitTestPoint( Bodies[ Collisions[ bloc ].Element2 ].x , 
																				Bodies[ Collisions[ bloc ].Element2 ].y , true ) ){
							
							// Si on demande l'argumentation —— - -
							if( Collisions[ bloc ].Parametres.Argumentation ){
							
								// Lance la fonction prévue pour chaque élément avec son objet contenant les arguments
								// avec les arguments additifs étant les deux éléments en collision
								Launch( Collisions[ bloc ].Fonction , true , [ Bodies[ Collisions[ bloc ].Element1 ] , 
																			  Bodies[ Collisions[ bloc ].Element2 ] ] );
								
							// Si on ne demande pas l'argumentation —— - -
							} else {
							
								// Lance la fonction prévue pour chaque élément avec son objet contenant les arguments
								Launch( Collisions[ bloc ].Fonction );
							}
						}
						
						
					// Si elle est de type "!Object" ———— - -
					} else if( Collisions[ bloc ].mod == "!Object" ){
						
						// S'il y a collision entre les deux éléments définie dans cette collision ———— - -
						if( !Bodies[ Collisions[ bloc ].Element1 ].hitTestObject( Bodies[ Collisions[ bloc ].Element2 ] ) ){
							
							// Si on demande l'argumentation —— - -
							if( Collisions[ bloc ].Parametres.Argumentation ){
							
								// Lance la fonction prévue pour chaque élément avec son objet contenant les arguments
								// avec les arguments additifs étant les deux éléments en collision
								Launch( Collisions[ bloc ].Fonction , true , [ Bodies[ Collisions[ bloc ].Element1 ] , 
																			  Bodies[ Collisions[ bloc ].Element2 ] ] );
								
							// Si on ne demande pas l'argumentation —— - -
							} else {

								// Lance la fonction prévue pour chaque élément avec son objet contenant les arguments
								Launch( Collisions[ bloc ].Fonction );
							}
						}
						
						
					// Si elle est de type "!Point" ———— - -
					} else if ( Collisions[ bloc ].mod == "!Point" ){
						
						// S'il y a collision entre le premier élément et le point centrale x,y du second élément ———— - -
						if( !Bodies[ Collisions[ bloc ].Element1 ].hitTestPoint( Bodies[ Collisions[ bloc ].Element2 ].x , 
																				 Bodies[ Collisions[ bloc ].Element2 ].y , true ) ){
							
							// Si on demande l'argumentation —— - -
							if( Collisions[ bloc ].Parametres.Argumentation ){
							
								// Lance la fonction prévue pour chaque élément avec son objet contenant les arguments
								// avec les arguments additifs étant les deux éléments en collision
								Launch( Collisions[ bloc ].Fonction , true , [ Bodies[ Collisions[ bloc ].Element1 ] , 
																			  Bodies[ Collisions[ bloc ].Element2 ] ] );
								
							// Si on ne demande pas l'argumentation —— - -
							} else {
							
								// Lance la fonction prévue pour chaque élément avec son objet contenant les arguments
								Launch( Collisions[ bloc ].Fonction );
							}
						}
					
						
					// Si elle est de type "AbsolutPoint" ———— - -
					} else if ( Collisions[ bloc ].mod == "AbsolutPoint" ){
						
						// S'il y a collision entre le premier élément et le point centrale x,y du second élément ———— - -
						if( Bodies[ Collisions[ bloc ].Element1 ].hitTestPoint( GetTotal( Bodies[ Collisions[ bloc ].Element2 ] , "x" ) , 
																				GetTotal( Bodies[ Collisions[ bloc ].Element2 ] , "y" ) , true ) ){
							
							// Si on demande l'argumentation —— - -
							if( Collisions[ bloc ].Parametres.Argumentation ){
							
								// Lance la fonction prévue pour chaque élément avec son objet contenant les arguments
								// avec les arguments additifs étant les deux éléments en collision
								Launch( Collisions[ bloc ].Fonction , true , [ Bodies[ Collisions[ bloc ].Element1 ] , 
																			  Bodies[ Collisions[ bloc ].Element2 ] ] );
								
							// Si on ne demande pas l'argumentation —— - -
							} else {
							
								// Lance la fonction prévue pour chaque élément avec son objet contenant les arguments
								Launch( Collisions[ bloc ].Fonction );
							}
						}
					
						
					// Si elle est de type "!AbsolutPoint" ———— - -
					} else if ( Collisions[ bloc ].mod == "!AbsolutPoint" ){
						
						// S'il y a collision entre le premier élément et le point centrale x,y du second élément ———— - -
						if( !Bodies[ Collisions[ bloc ].Element1 ].hitTestPoint( GetTotal( Bodies[ Collisions[ bloc ].Element2 ] , "x" ) , 
																				 GetTotal( Bodies[ Collisions[ bloc ].Element2 ] , "y" ) , true ) ){
							
							// Si on demande l'argumentation —— - -
							if( Collisions[ bloc ].Parametres.Argumentation ){
							
								// Lance la fonction prévue pour chaque élément avec son objet contenant les arguments
								// avec les arguments additifs étant les deux éléments en collision
								Launch( Collisions[ bloc ].Fonction , true , [ Bodies[ Collisions[ bloc ].Element1 ] , 
																			  Bodies[ Collisions[ bloc ].Element2 ] ] );
								
							// Si on ne demande pas l'argumentation —— - -
							} else {
							
								// Lance la fonction prévue pour chaque élément avec son objet contenant les arguments
								Launch( Collisions[ bloc ].Fonction );
							}
						}
					}
				}
			}
		}
		//
		// —————— CHECK OBSTACLE
	    // Test la position de type obstacle entre les éléments
	  
		private function CheckObstacle( Parametres:* = ""	// ———— - - Les Parametres additifs
									  ):void {
			/*—*/
			
			// Pour chaque élément qui subie les obstacles —— - -
			for( var ApplyObstacle:* in ObstaclesSubjects ){
				
				// S'il n'est pas null —— - -
				if( ObstaclesSubjects[ ApplyObstacle ] != null ){
					
					// Si son clip existe —— - -
					if( ObstaclesSubjects[ ApplyObstacle ][ 0 ].Clip ){
					
						// Pour chaque contenu —— - -
						for( var lElement:* in ObstaclesSubjects[ ApplyObstacle ] ){
						
							// S'il n'est pas null —— - -
							if( ObstaclesSubjects[ ApplyObstacle ][ lElement ] != null ){
								
								// S'il n'est pas directement le nom du lanceur —— - -
								if( FindIn( Parametres , ObstaclesSubjects[ ApplyObstacle ][ lElement ].Nom ) == 0 ){
									
									// Lance la méthode de vérification pour le type d'obstacle
									this[ "CheckObstacle" + Obstacles[ ObstaclesSubjects[ ApplyObstacle ][ lElement ].Groupe ]
																	 [ ObstaclesSubjects[ ApplyObstacle ][ lElement ].Nom ].Type ](
										  ObstaclesSubjects[ ApplyObstacle ][ 0 ].Clip,
										  Obstacles[ ObstaclesSubjects[ ApplyObstacle ][ lElement ].Groupe ]
												   [ ObstaclesSubjects[ ApplyObstacle ][ lElement ].Nom ].Parametres ,
										  ObstaclesSubjects[ ApplyObstacle ][ lElement ] , 
										  Parametres + "_" + ObstaclesSubjects[ ApplyObstacle ][ lElement ].Nom );
								}
							} 
						}
						
						// Met à jour ses variables mémoires
						ObstaclesSubjects[ ApplyObstacle ][ 0 ].Clip.ApplyObstacle.MemoireX.push( ObstaclesSubjects[ ApplyObstacle ][ 0 ].Clip.x );
						ObstaclesSubjects[ ApplyObstacle ][ 0 ].Clip.ApplyObstacle.MemoireY.push( ObstaclesSubjects[ ApplyObstacle ][ 0 ].Clip.y );
						
					// Si le clip n'existe pas —— - - Retire l'élément qui subit les obstacles
					} else { ObstaclesSubjects[ ApplyObstacle ] = null; }
				}
			}
		}
		//
		// —————— CHECK PROXIMITY
	    // Test la proximité entre éléments
	  
		private function CheckProximity( Parametres:* = ""	// ———— - - Les Parametres additifs
									    ):void {
			/*—*/
			
			// Pour chaque proximité définie ———— - -
			for( var bloc:Object in Proximities ){
				
				// Si la proximité définie n'est pas null ———— - -
				if( Proximities[ bloc ] != null ){
					
					// Trace des erreurs —— - -
					//
					// Si l'élément 1 n'existe pas —— - -
					if( !Bodies[ Proximities[ bloc ].Element1 ] ){
						TraceError( "HitProcess" , "Boucle de HitTest" , "L'element 1 : \"" + bloc + "\" n'existe pas ou plus." );
					//
					// Si l'élément 2 n'existe pas —— - -
					} else if( !Bodies[ Proximities[ bloc ].Element2 ] ){
						TraceError( "HitProcess" , "Boucle de HitTest" , "L'element 2 : \"" + bloc + "\" n'existe pas ou plus." );
						
					// S'il n'y a pas d'erreur —— - -
					} else {

						// S'il y a proximité entre les deux éléments définie dans cette proximité —— - -
						if( GetDistance( Bodies[ Proximities[ bloc ].Element1 ] , 
										   Bodies[ Proximities[ bloc ].Element2 ] ) < Proximities[ bloc ].Distance ){
							
							// S'il n'était pas dedans —— - -
							if( !Proximities[ bloc ].Dedans ){
								
								// Lance la fonction d'entré
								Launch( Proximities[ bloc ].FonctionEntre );
								
								// Il est dedans
								Proximities[ bloc ].Dedans = true;
							}
							
							// Lance la fonction prévue pour chaque élément avec son objet contenant les arguments
							Launch( Proximities[ bloc ].FonctionBoucle );
						
						
						// S'il n'y a pas de proximité entre les deux éléments définie dans cette proximité —— - -
						} else {
							
							// S'il était dedans —— - -
							if( Proximities[ bloc ].Dedans ){
								
								// Lance la fonction de sortie
								Launch( Proximities[ bloc ].FonctionSort );
								
								// Il est dehors
								Proximities[ bloc ].Dedans = false;
							}
						}
					}
				}
			}
		}
		//
		// —————— CHECK DESTRUCTION
	    // Test la destruction d'élément à retardement
	  
		private function CheckDestruction( Parametres:* = ""	// ———— - - Les Parametres additifs
										 ):void {
			/*—*/
			
			// Pour chaque élément à détruire ———— - -
			for( var i:String in DestroyingBodies ){ 
			
				// Lance sa destruction
				RemoveBody( DestroyingBodies[ i ] , true );
			}
			// Vidage du tableau
			DestroyingBodies.splice( 0 );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 TOOLS					  		  					  */
		/*								  Méthodes outils concernant les collisions 							  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - SET - - —————————————————————————————————————————— */
		// Appliques des modifications en exploitant la collision
		//*—*//
	  
	  	// —————— CORROSION
	  	// Détruit un élément s'il en touche un autre ou s'il touche un autre parmis un ensemble d'objet dans cet élément
	  
		public function Corrosion( Element:* ,						// ———— - - Élément vérifié
								   ElementCorrosif:* ,				// ———— - - Élément ou ensemble d'élément faisant la vérification
								   Mode:String = "Unique" ,			// ———— - - Vérification sur élément unique ( "Unique" ) ou multiples ( "Multiple" )
								   TypeCollision:String = "Object"	// ———— - - Type de vérification de collision ( "Object" ou "Point" )
								   ):Boolean {
			/*—*/
			
			// Vérification unique —— - -
			if( Mode == "Unique" ){
				
				// S'il y a une collision —— - -
				if( Element[ "hitTest" + TypeCollision ]( ElementCorrosif ) ){
					
					// Détruit l'élément
					DestroyElement( Element );
					//
					// Renvoie vrai
					return true;
				}
				
			// Vérification multiple —— - -
			} else {
				
				// Pour chaque élément dans l'élément corrosif —— - -
				for( var i:int = 0 ; i < ElementCorrosif.numChildren ; i++ ){
					
					// Récupère l'instance de l'élément
					var ElementCorrosifEnCour:* = ElementCorrosif.getChildAt( i );
					
					// S'il n'est pas le même que le vérifié et qu'il est en collision avec l'élément vérifié —— - -
					if( ElementCorrosifEnCour != Element && Element[ "hitTest" + TypeCollision ]( ElementCorrosifEnCour ) ){
					
						// Détruit l'élément
						DestroyElement( Element );
						//
						// Renvoie vrai
						return true;
					}
				}
			}
			//
			// Si c'était bon —— - - Renvoie faux
			return false;
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					BODY				  			  					  */
		/*							Méthodes pour la gestion des éléments attachés au script 					  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
		
		// —————— BODIES
		// L'Archive des objets pouvant être ensuite exploité pour les tests de collision
		private var Bodies:Object = new Object();
		
		// —————— DESTROYING BODIES
	    // Tableau permettant de lancer la destruction d'élément du tableau à retardement afin d'éviter les bugs
		private var DestroyingBodies:Array = new Array();
		
		
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Méthodes pour enregistrer des éléments
		//*—*//
		
		// —————— NEW BODY
		// Ajoute un élément à la liste des éléments prévue pour la	collision
		// Cette fonction ne créait rien si le nom existe déjà et retourne le nom qui concerne l'élément souhaité
	  
		public function NewBody( Nom:* ,			// ———— - - Nom de l'élément
													//		 ou Cible
								
								 Cible:* = null ,	// ———— - - Élément concerné
								 Parent:* = null	// ———— - - Parent concerné par le lien
								):String {
			/*—*/
			
			// Switch des éléments —— - -
			if( !TypeOf( Nom , [ "String" , "Array" , "Object" ] ) ){
				//
				Cible = Nom;
				Nom = Nom.name;
				//
			} else if( TypeOf( Nom , "Array" ) ) {
				//
				Cible = Nom[ 1 ];
				Nom = Nom[ 0 ];
				//
			} else if( TypeOf( Nom , "Object" ) ) {
				//
				Cible = Nom.target;
				Nom = Nom.name;
			}
			
			// Si l'élément n'existe pas déjà —— - -
			if( Bodies[ Nom ] == null ){
				
				// Si la cible existe correctement —— - -
				if( Cible ){
				
					// Ajoute l'élément au tableau
					Bodies[ Nom ] = Cible;
					
					// Donne à l'élément le levier qui le relie à HitProcess
					( Parent || Bodies[ Nom ] ).Link2HitProcess = Nom;
					
				// SI la cible n'existe pas —— - - trace l'erreur
				} else {
					//
					TraceError( "HitProcess" , "NewBody" , [ "Pour l'ajout de l'element au nom : \"" + Nom + "\"" , 
															  " La cible choisie n'existe pas." ] );
				}
			}
			
			// Retourne le nom
			return Nom;
		}
		
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Méthodes pour exploiter et modifier les éléments
		//*—*//
		
		// —————— REMOVE BODY
		// Retire un élément de la liste des éléments en deux temps afin d'éviter les bugs
	  
		public function RemoveBody( Nom:String , 			// ———— - - Nom de l'élément
								    Final:Boolean = false	// ———— - - S'il s'agit de la destruction finale
								   ):void {
			/*—*/
			
			// Si ce n'est pas le final —— - -
			if( !Final ){
				
				// S'il existe —— - -
				if( Bodies[ Nom ] ){
					
					// Ajoute le nom de l'élément au tableau des éléments à supprimer
					DestroyingBodies.push( Nom );
				
					// Retire son levier de liaison avec le HitProcess
					Bodies[ Nom ].Link2HitProcess = false;
				
				// S'il n'existe pas —— - - trace l'erreur
				} else { TraceError( "HitProcess" , "SupressionElement" , "Le nom archivé " + Nom + " n'existe pas." ); }
			
			// S'il s'agit du final —— - -
			} else {
				
				// Pour chaque collisions emmagasinée ———— - -
				for( var base:Object in Collisions ){
					
					// Si elle n'est pas null ———— - -
					if( Collisions[ base ] != null ){
							
						// Si l'un des deux éléments de la collision est l'élément retiré ———— - -
						if( Collisions[ base ].Element1 == Nom
						 || Collisions[ base ].Element2 == Nom ){
							
							// Mise à null de cette collision
							Collisions[ base ] = null;
						}
					}
				}
				
				// Pour chaque proximité emmagasinée ———— - -
				for( var base2:Object in Proximities ){
					
					// Si elle n'est pas null ———— - -
					if( Proximities[ base2 ] != null ){
							
						// Si l'un des deux éléments de la collision est l'élément retiré ———— - -
						if( Proximities[ base2 ].Element1 == Nom
						 || Proximities[ base2 ].Element2 == Nom ){
							
							// Mise à null de cette collision
							Proximities[ base2 ] = null;
						}
					}
				}
				
				// Pour chaque clip à obstacle emmagasinée ———— - -
				for( var base3:Object in ObstaclesSubjects ){
					
					// Si elle n'est pas null ———— - -
					if( ObstaclesSubjects[ base3 ] != null ){
							
						// Si l'un des deux éléments de la collision est l'élément retiré ———— - -
						if( base3 == Nom ){
							
							// Mise à null de cette collision
							ObstaclesSubjects[ base3 ] = null;
						}
					}
				}
				
				// Mise à null de l'élément
				Bodies[ Nom ] = null;
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				   COLLISION				  			  				  */
		/*						      Méthodes pour la gestion des collision entre éléments 					  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
		
		// —————— COLLISIONS
	    // Le conteneur des appels de collisions entre éléments
		public var Collisions:Object = new Object();
		
		
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Méthodes pour enregistrer des collisions
		//*—*//
		
		// —————— NEW COLLISION
		// Créait une collision potentiel entre deux éléments
	  
		public function NewCollision( Nom:* ,				// ———— - - Nom de la collision
									  Element1:* ,			// ———— - - Élément n°1 de la collision
									  Element2:* ,			// ———— - - Élément n°2 de la collision
									  Parametres:* = null	// ———— - - Parametres additifs
								   ):String {
			/*—*/
			
			// Switch des arguments
			if( !TypeOf( Nom , "String" )
			 || !Parametres ){
				//
				var MemoParametres:* = Parametres
				Parametres = Element2;
				Element2 = Element1;
				Element1 = Nom;
				Nom = MemoParametres;
			}
			
			// Récupération et ( Si besoin ) création des éléments
			Element1 = NewBody( Element1 );
			Element2 = NewBody( Element2 );
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			//
			var Mod:String = Parametres.type || "Object";
			var Fonction:* = Parametres.fonction;
			//
			Nom = Nom || Element1 + Element2 + "Collision";
			
			// Alterne le nom suivant si il existe déjà
			while( Collisions[ Nom ] != null ){
				//
				Nom = PasteString( Nom );
			}
			
			// Création de l'instance de la collision
			Collisions[ Nom ] = new Object();
			
			// Argumentation de la collision
			Collisions[ Nom ].mod = Mod;
			Collisions[ Nom ].Element1 = Element1;
			Collisions[ Nom ].Element2 = Element2;
			Collisions[ Nom ].Fonction = Fonction;
			Collisions[ Nom ].Parametres = Parametres || new Object();
			
			// Retourne le nom de la collision
			return Nom;
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				   PROXIMITY				  			  				  */
		/*					   Méthodes pour la gestion des effets de proximité entre éléments 					  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
		
		// —————— PROXIMITIES
	    // Le conteneur des appels de proximité entre éléments
		public var Proximities:Object = new Object(); 
		
		
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Méthodes pour enregistrer des proximités
		//*—*//
		
		// —————— NEW PROXIMITY
		// Créait un proximité potentielle entre deux éléments
	  
		public function NewProximity( Nom:* ,				// ———— - - Nom de la proximité
									  Element1:* ,			// ———— - - Élément n°1 de la proximité
									  Element2:* ,			// ———— - - Élément n°2 de la proximité
									  Parametres:* = null	// ———— - - Parametres additifs
								   ):String {
			/*—*/
			
			// Switch des arguments
			if( !TypeOf( Nom , "String" )
			 || !Parametres ){
				//
				var MemoParametres:* = Parametres
				Parametres = Element2;
				Element2 = Element1;
				Element1 = Nom;
				Nom = MemoParametres;
			}
			
			// Récupération et ( Si besoin ) création des éléments
			Element1 = NewBody( Element1 );
			Element2 = NewBody( Element2 );
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			//
			var Distance:Number = Parametres.distance || Bodies[ Element2 ].width / 2;
			//
			var FonctionBoucle:* = Parametres.fonction || Parametres.fonctionLoop;
			var FonctionEntre:* = Parametres.fonctionOn;
			var FonctionSort:* = Parametres.fonctionOff;
			//
			Nom = Nom || Element1 + Element2 + "Proximity";
			
			// Création de l'instance de la proximité
			Proximities[ Nom ] = new Object();
			
			// Argumentation de la proximité
			Proximities[ Nom ].Distance = Distance;
			Proximities[ Nom ].Element1 = Element1;
			Proximities[ Nom ].Element2 = Element2;
			Proximities[ Nom ].FonctionBoucle = FonctionBoucle;
			Proximities[ Nom ].FonctionEntre = FonctionEntre;
			Proximities[ Nom ].FonctionSort = FonctionSort;
			//
			Proximities[ Nom ].Dedans = false;
			
			// Renvoie le nom
			return Nom;
		}
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					OBSTACLE			  			  					  */
		/*		  Méthodes pour la gestion des éléments conscidérés comme obstacles par d'autres éléments 		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
		
		// —————— OBSTACLES
	    // Les archives des obstacles et éléments subissant les obstacles
		public var Obstacles:Object = new Object();
		public var ObstaclesSubjects:Object = new Object();
		
		
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Méthodes pour enregistrer des obstacles
		//*—*//
		
	  	// —————— NOUVEAU GROUPE OBSTACLE
	  	// Créait un nouveau groupe d'obstacle
	  
		public function NewObstacleGroup( Nom:String 	// ———— - - Le Nom du groupe
										):void {
			/*—*/
			
			// Ajoute le groupe
			Obstacles[ Nom ] = new Object();
		}
		
		
	  	// —————— NOUVEL OBSTACLE
	  	// Créait un nouvel obstacle
	  
		public function NewObstacle( Groupe:String ,		// ———— - - Le Groupe
									 Nom:* ,				// ———— - - Le Nom de l'obstacle
									 						// 		 ou Clip Obstacle
									 
									 Parametres:* = null	// ———— - - Les Parametres de l'obstacle
									 						//		 ou Bump ( Si le second argument est le Clip Obstacle )
								   ):void {
			/*—*/
			
			// Switch des arguments
			//
			if( !TypeOf( Nom , "String" ) ){
				//
				Nom.Bump = Parametres || Nom.Bump;
				Parametres = Nom;
				Nom = null;
			}
			//
			// Si le Parametres est un clip —— - -
			if( !TypeOf( Parametres , "Object" ) ){
				
				// Regarde son type suivant sa forme par rapport à son point chaud
				var LeType:String = Parametres.hitTestPoint( Parametres.x - 1 , Parametres.y - 1 ) ? "Circle" : "Rectangle";
				var NouveauxParametres:Object = new Object();
				
				// Suivant le type —— - - Calibre les parametres
				if( LeType == "Circle" ){
					//
					NouveauxParametres.Centre = Parametres;
					NouveauxParametres.Diametre = Parametres.width;
					//
				} else if( LeType == "Rectangle" ){
					//
					NouveauxParametres.PointZero = Parametres;
					NouveauxParametres.Taille = Parametres;
				}
				
				// S'il n'y a pas de nom —— - - Lui donne celui du clip
				Nom = Nom || Parametres.name;
				
				// Transmet les nouveaux parametres
				Parametres = NouveauxParametres;
			}
			
			// Convertie le bump s'il est un clip
			if( Parametres.Bump ){
				//
				if( !TypeOf( Parametres.Bump , "Number" ) ){
					//
					Parametres.Bump = Parametres.Bump.width / 2;
				}
			}
			
			// Si le groupe n'existe pas —— - - Ajoute le groupe
			if( !Obstacles[ Groupe ] ){ NewObstacleGroup( Groupe ); }
			
			// Récupération des valeurs
			var Type:String = Parametres.type || LeType || "Circle";
			
			// Levier de lancement
			var Levier:Boolean = true;
			
			// Si le type d'obstacle est un cercle —— - -
			if( Type == "Circle" ){
				
				// S'il n'a pas de Centre —— - - trace l'erreur
				if( !Parametres.Centre ){ 
					//
					TraceError( "HitProcess" , "NewObstacle" , 
								 "Pour un obstacle de type «Circle» vous devez préciser la position x,y sur la clé «Centre»" );
					//
					Levier = false;
				}
				
				// S'il n'a pas de diametre —— - - Trace l'erreur
				if( !Parametres.Diametre ){ 
					//
					TraceError( "HitProcess" , "NewObstacle" , 
								 "Pour un obstacle de type «Circle» vous devez préciser la valeur de «Diametre»" );
					//
					Levier = false;
				}
				
			// Si le type d'obstacle est un cercle —— - -
			} else if( Type == "Rectangle" ){
				
				// S'il n'a pas de Centre —— - - trace l'erreur
				if( !Parametres.PointZero ){ 
					//
					TraceError( "HitProcess" , "NewObstacle" , 
								 "Pour un obstacle de type «Rectangle» vous devez préciser la position x,y sur la clé «PointZero»" );
					//
					Levier = false;
				}
				
				// S'il n'a pas de diametre —— - - Trace l'erreur
				if( !Parametres.Taille ){ 
					//
					TraceError( "HitProcess" , "NewObstacle" , 
								 "Pour un obstacle de type «Rectangle» vous devez préciser la valeur de «Taille»" );
					//
					Levier = false;
				}
				
			// Si le type n'est pas reconnu —— - - Trace l'erreur
			} else { 
				//
				TraceError( "HitProcess" , "NewObstacle" , "Le Type d'obstacle «" + Type + "» n'existe pas." );
				//
				Levier = false;
			}
			
			// Si le levier est activé —— - -
			if( Levier ){
				
				// Créait le nouvel objet pour l'obstacles
				Obstacles[ Groupe ][ Nom ] = new Object();
				//
				// Insére les éléments de l'obstacle
				Obstacles[ Groupe ][ Nom ].Type = Type;
				Obstacles[ Groupe ][ Nom ].Parametres = Parametres;
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Méthodes pour exploiter et modifier les obstacles
		//*—*//
		
		// —————— APPLY OBSTACLE
		// Un clip subis certains obstacles
		
		public function ApplyObstacle( Groupe:String ,		// ———— - - Le Groupe de l'obstacle
									   Nom:* = "" ,			// ———— - - Le Nom de l'obstacle
									   Clip:* = null ,		// ———— - - Le Clip concerné
									   Parametres:* = null	// ———— - - Parametres additifs
															//		 ou "false" pour désactiver l'obstacle
										):void {
			/*—*/
			
			// Switch des arguments
			if( !Clip ){
				//
				Clip = Nom;
				Nom = "";
			}
			
			// Si l'obstacle n'est pas faux —— - -
			if( Parametres != false ){
				
				// Argument par défaut
				Parametres = Parametres || new Object();
				//
				var Fonction:* = Parametres.fonction || new Object();
				
				// Le clip récupére une variable mémoire de position
				Clip.ApplyObstacle = { MemoireX:[ Clip.x ] , 
									   MemoireY:[ Clip.y ] ,
									   BugBump:20 ,
									   BugBumpReposition:4
									 };
				
				// Si on a rentré le Nom —— - -
				if( SetDefault( Nom ) ){
					
					// Ajoute l'argument de l'élément concerné s'il y a une fonction
					if( TypeOf( Fonction.Argument , "Object" ) ){ Fonction.Argument.Obstacle = Obstacles[ Groupe ][ Nom ].Parametres.Centre; }
					
					// Si le clip n'a pas déjà des obstacle —— - -
					if( !ObstaclesSubjects[ Clip.name ] ){
						
						// Créait l'objet pour ce clip
						ObstaclesSubjects[ Clip.name ] = [ { Clip:Clip , Groupe:Groupe , Nom:Nom , Fonction:Fonction } ];
					
					// Si le déjà a déjà des obstacle —— - -
					} else {
					  
						// Ajoute les notions dans son objet
						ObstaclesSubjects[ Clip.name ].push( { Clip:Clip , Groupe:Groupe , Nom:Nom , Fonction:Fonction } );
					}
				
				// Si on a rentré aucun nom —— - -
				} else {
				  
					// Pour chaque élément dans le groupe —— - -
					for( var E:* in Obstacles[ Groupe ] ){
					  
						// Fait subir l'obstacle par cet élément
						ApplyObstacle( Groupe , E , Clip , CloneObject( Fonction ) );
					}
				}
				
			// Si l'obstacle est false —— - -
			} else {
			  
				// Si le test d'obstacle existe pour ce clip —— - -
				if( ObstaclesSubjects[ Clip.name ] ){
				 
					// Si on a choisit aucun groupe —— - -
					if( Groupe == "" ){
					  
						// Détruit entiérement les obstacles pour ce clip
						ObstaclesSubjects[ Clip.name ] = null;
					  
					  
					// Si on a juste choisit un groupe —— - -
					} else if( Nom == "" ){
					  
						// Pour chaque obstacles pour ce clip —— - -
						for( var i:int = 0 ; i < ObstaclesSubjects[ Clip.name ].length ; i++ ){
						  
							// S'il est du groupe voulu —— - -
							if( ObstaclesSubjects[ Clip.name ][ i ].Groupe == Groupe ){
								//
								// Retire l'obstacle
								ObstaclesSubjects[ Clip.name ][ i ] = null;
							}
						}
					 
					 
					// Si on a choisit un groupe et un nom —— - -
					} else {
						
						// Pour chaque obstacles pour ce clip —— - -
						for( var j:int = 0 ; j < ObstaclesSubjects[ Clip.name ].length ; j++ ){
							
							// S'il est du nom et du groupe voulu —— - -
							if( ObstaclesSubjects[ Clip.name ][ j ].Groupe == Groupe
							&& ObstaclesSubjects[ Clip.name ][ j ].Nom == Nom ){
								//
								// Retire l'obstacle
								ObstaclesSubjects[ Clip.name ][ j ] = null;
							}
						}
					}
					
					// Rafraichit le tableau pour en retirer les valeurs null
					if( ObstaclesSubjects[ Clip.name ] ){ 
						//
						ObstaclesSubjects[ Clip.name ] = DeleteFromArray( ObstaclesSubjects[ Clip.name ] );
					}
				}
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - LOOP - - —————————————————————————————————————————— */
		// Boucle de gestion des obstacles
		//*—*//
		
		// —————— CHECK OBSTACLE CIRCLE
		// Vérification d'un obstacle par rapport à un cercle
	  
		public function CheckObstacleCircle( Clip:* ,			 // ———— - - Le Clip
											 Obstacle:Object ,	 // ———— - - L'Obstacle
											 ClipObject:Object , // ———— - - L'Objet du clip
											 Nom:String = ""	 // ———— - - Le Nom transmis
											):void {
			/*—*/
			
			// Récupére le calcul du diametre de l'obstacle
			var ReceptionDiametre:Number = ( ( TypeOf( Obstacle.Diametre , "Number" ) ) ? Obstacle.Diametre / 2 : Obstacle.Diametre.width / 2 ) 
										 + ( Obstacle.Bump || 0 ) ;
			
			// Levier de vérification
			var Levier:Boolean = false;
			
			// Si le centre n'est pas un clip ou s'il en est un et qu'il n'est pas inActive d'obstacle —— - -
			if( TypeOf( Obstacle.Centre , "Number" ) ){ Levier = true;	} 
			else {
				//
				if( !Obstacle.Centre ){ Levier = true; }
				if( !Obstacle.Centre.ObstacleInActive ){ Levier = true; }
			}
				
			// Si c'est ok —— - -
			if( Levier ){
				
				// Si la distance entre eux-deux est inférieur au diametre et que le centre est Active s'il est un clip —— - -
				if( GetDistance( Clip , Obstacle.Centre )< ReceptionDiametre && Obstacle.Centre.Active != false ){
					
					// S'il y a accrochage pour l'obstacle —— - -
					if( Obstacle.Accroche ){
						
						// Repositionne le clip sur son ancienne position
						Clip.x = Clip.ApplyObstacle.MemoireX[ Clip.ApplyObstacle.MemoireX.length - 1 ];
						Clip.y = Clip.ApplyObstacle.MemoireY[ Clip.ApplyObstacle.MemoireX.length - 1 ];
					}
					
					// Récupére l'angle
					var Angle:Number = GetAngle( Obstacle.Centre , Clip );
					
					
					Clip.ApplyObstacle.MemoireX[ Clip.ApplyObstacle.MemoireX.length - 1 ] = Clip.x;
					Clip.ApplyObstacle.MemoireY[ Clip.ApplyObstacle.MemoireX.length - 1 ] = Clip.y;
					
					
					// Repositionne le clip contre l'obstacle
					Clip.x = GetDirectionTo( Obstacle.Centre , ReceptionDiametre , Angle ).x;
					Clip.y = GetDirectionTo( Obstacle.Centre , ReceptionDiametre , Angle ).y;
					
					// Lance la fonction rattachée
					if( ClipObject.Fonction.Fonction != undefined ){ Launch( ClipObject.Fonction ); }
					
					// Relance un HitTest
					GlobalLoop( "Obstacle" , Nom );
				}
			}
		}
	  
	  
		// —————— CHECK OBSTACLE RECTANGLE
		// Vérification d'un obstacle par rapport à un rectangle
		
		public function CheckObstacleRectangle( Clip:* ,			// ———— - - Le Clip
												Obstacle:Object ,	// ———— - - L'Obstacle
												ClipObject:Object ,	// ———— - - L'Objet du clip
												Nom:String = ""	 	// ———— - - Le Nom transmis
											):void {
			/*—*/
			
			// Levier de vérification
			var Levier:Boolean = false;
			
			// Si le centre n'est pas un clip ou s'il en est un et qu'il n'est pas inActive d'obstacle —— - -
			if( TypeOf( Obstacle.PointZero , "Number" ) ){ Levier = true; } 
			else {
				//
				if( !Obstacle.PointZero ){ Levier = true; }
				if( !Obstacle.PointZero.ObstacleInActive ){ Levier = true; }
			}
				
			// Si c'est ok —— - -
			if( Levier ){
					
				// Calibre les variables mémoires pour l'obstacle
				Obstacle.MemoPointZero = Obstacle.MemoPointZero || { x:0 , y:0 };
				Obstacle.MemoTaille = Obstacle.MemoTaille || { width:0 , height:0 };
				//
				// Recalibre la mémoire du clip si l'obstacle s'est déplacé
				if( Obstacle.MemoPointZero.x != Obstacle.PointZero.x ){ Clip.ApplyObstacle.MemoireX[ Clip.ApplyObstacle.MemoireX.length - 1 ] 
																		+= ( Obstacle.PointZero.x - Obstacle.MemoPointZero.x ); }
				if( Obstacle.MemoPointZero.y != Obstacle.PointZero.y ){ Clip.ApplyObstacle.MemoireY[ Clip.ApplyObstacle.MemoireY.length - 1 ] 
																		+= ( Obstacle.PointZero.y - Obstacle.MemoPointZero.y ); }
				//
				// Recalibre la mémoire du clip si l'obstacle s'est redimensionné
				if( Obstacle.MemoTaille.width < Obstacle.Taille.width ){ Clip.ApplyObstacle.MemoireX[ Clip.ApplyObstacle.MemoireX.length - 1 ]
																		 += ( Obstacle.Taille.width - Obstacle.MemoTaille.width ); }
				if( Obstacle.MemoTaille.height < Obstacle.Taille.height ){ Clip.ApplyObstacle.MemoireY[ Clip.ApplyObstacle.MemoireY.length - 1 ]
																		 += ( Obstacle.Taille.width - Obstacle.MemoTaille.height ); }
				
				
				// Si le clip se trouve dans le rectangle —— - -
				if( Clip.x > Obstacle.PointZero.x - ( Obstacle.Bump || 0 ) 
				 && Clip.x < Obstacle.PointZero.x + Obstacle.Taille.width + ( Obstacle.Bump || 0 )  
				 && Clip.y > Obstacle.PointZero.y - ( Obstacle.Bump || 0 )
				 && Clip.y < Obstacle.PointZero.y + Obstacle.Taille.height + ( Obstacle.Bump || 0 ) 
				 && Obstacle.PointZero.Active != false 
				){
					
					// S'il y a accrochage pour l'obstacle —— - -
					if( Obstacle.Accroche ){
						
						// Repositionne le clip sur son ancienne position
						Clip.x = Clip.ApplyObstacle.MemoireX[ Clip.ApplyObstacle.MemoireX.length - 1 ];
						Clip.y = Clip.ApplyObstacle.MemoireY[ Clip.ApplyObstacle.MemoireY.length - 1 ];
					}
					
					// Mémorise la mémoire de position du clip pour la fin
					var InstantMemoireX:Number = Clip.x;
					var InstantMemoireY:Number = Clip.y;
					
					// Si le clip est bloqué sur l'horizontal —— - -
					if( Clip.ApplyObstacle.MemoireX[ Clip.ApplyObstacle.MemoireX.length - 1 ] > Obstacle.PointZero.x - ( Obstacle.Bump || 0 ) 
					 && Clip.ApplyObstacle.MemoireX[ Clip.ApplyObstacle.MemoireX.length - 1 ]
						< Obstacle.PointZero.x + Obstacle.Taille.width + ( Obstacle.Bump || 0 ) ){
						
						// S'il allait vers la droite, il reste contre le bord gauche de la boite
						if( Clip.ApplyObstacle.MemoireY[ Clip.ApplyObstacle.MemoireY.length - 1 ] 
							<= Obstacle.PointZero.y - ( Obstacle.Bump || 0 ) ){ Clip.y = Obstacle.PointZero.y - ( Obstacle.Bump || 0 ); }
						
						// S'il allait vers la gauche, il reste contre le bord droit de la boite
						if( Clip.ApplyObstacle.MemoireY[ Clip.ApplyObstacle.MemoireY.length - 1 ] 
							>= Obstacle.PointZero.y + Obstacle.Taille.height + ( Obstacle.Bump || 0 ) ){ 
							//
							Clip.y = Obstacle.PointZero.y + Obstacle.Taille.height + ( Obstacle.Bump || 0 ); 
						}
					
					
					// Si le clip est bloqué sur la vertical —— - -
					} else if( Clip.ApplyObstacle.MemoireY[ Clip.ApplyObstacle.MemoireY.length - 1 ] > Obstacle.PointZero.y - ( Obstacle.Bump || 0 )
							&& Clip.ApplyObstacle.MemoireY[ Clip.ApplyObstacle.MemoireY.length - 1 ] 
							< Obstacle.PointZero.y + Obstacle.Taille.height + ( Obstacle.Bump || 0 ) ){
						
						// S'il allait vers le bas, il reste contre le bord haut de la boite
						if( Clip.ApplyObstacle.MemoireX[ Clip.ApplyObstacle.MemoireX.length - 1 ] 
							<= Obstacle.PointZero.x - ( Obstacle.Bump || 0 ) ){ Clip.x = Obstacle.PointZero.x - ( Obstacle.Bump || 0 ); }
						
						// S'il allait vers le haut, il reste contre le bord bas de la boite
						if( Clip.ApplyObstacle.MemoireX[ Clip.ApplyObstacle.MemoireX.length - 1 ]
							>= Obstacle.PointZero.x + Obstacle.Taille.width + ( Obstacle.Bump || 0 ) ){
							//
							Clip.x = Obstacle.PointZero.x + Obstacle.Taille.width + ( Obstacle.Bump || 0 ); 
						}
					
					
					// Si le clip est pile entre vertical et horizontal —— - -
					} else {
						
						// S'il allait vers la droite, il reste contre le bord gauche de la boite
						if( Clip.ApplyObstacle.MemoireX[ Clip.ApplyObstacle.MemoireX.length - 1 ] 
							<= Obstacle.PointZero.x - ( Obstacle.Bump || 0 ) ){ Clip.x = Obstacle.PointZero.x - ( Obstacle.Bump || 0 ); }
						
						// S'il allait vers la gauche, il reste contre le bord droit de la boite
						if( Clip.ApplyObstacle.MemoireX[ Clip.ApplyObstacle.MemoireX.length - 1 ] 
							>= Obstacle.PointZero.x + Obstacle.Taille.width + ( Obstacle.Bump || 0 ) ){
							//
							Clip.x = Obstacle.PointZero.x + Obstacle.Taille.width + ( Obstacle.Bump || 0 ); 
						}
					}
					
					
					// Recalibrage au cas où le clip se trouve directement dans l'obstacle —— - -
					//
					// Si le clip se trouve dans l'horizontal interne —— - -
					if( Clip.y - ( Obstacle.Bump || 0 ) > Obstacle.PointZero.y
					 && Clip.y + ( Obstacle.Bump || 0 ) < Obstacle.PointZero.y + Obstacle.Taille.height
					 && Clip.x - ( Obstacle.Bump || 0 ) < Obstacle.PointZero.x + Obstacle.Taille.width 
					 && Clip.x + ( Obstacle.Bump || 0 ) > Obstacle.PointZero.x ){
						
						// Image de position horizontale
						var SuddenthMemoryX:Number = Clip.x;
						
						// S'il est après la moitié —— - - Reposition le clip à droite
						if( Clip.x - ( Obstacle.PointZero.x + ( Obstacle.Taille.width / 2 ) ) > 0 ){
							Clip.x = Obstacle.PointZero.x + Obstacle.Taille.width + ( Obstacle.Bump || 0 );
							
						// S'il est avant la moitié —— - - Reposition le clip à gauche
						} else {
							Clip.x = Obstacle.PointZero.x - ( Obstacle.Bump || 0 );
						}
						
						// Correcteur de bug
						if( Math.abs( Clip.x - SuddenthMemoryX ) > Clip.ApplyObstacle.BugBump ){
							
							// Repositionne le clip sur son ancienne position
							Clip.x = Clip.ApplyObstacle.MemoireX[ Clip.ApplyObstacle.MemoireX.length - Clip.ApplyObstacle.BugBumpReposition ];
							Clip.y = Clip.ApplyObstacle.MemoireY[ Clip.ApplyObstacle.MemoireY.length - Clip.ApplyObstacle.BugBumpReposition ];
						}
					}
					//
					// Si le clip se trouve dans la vertical interne —— - -
					if( Clip.x - ( Obstacle.Bump || 0 ) > Obstacle.PointZero.x
					 && Clip.x + ( Obstacle.Bump || 0 ) < Obstacle.PointZero.x + Obstacle.Taille.width 
					 && Clip.y - ( Obstacle.Bump || 0 ) < Obstacle.PointZero.y + Obstacle.Taille.height
					 && Clip.y + ( Obstacle.Bump || 0 ) > Obstacle.PointZero.y ){
						
						// Image de position horizontale
						var SuddenthMemoryY:Number = Clip.y;
							
						// S'il est après la moitié —— - - Reposition le clip en bas
						if( Clip.y - ( Obstacle.PointZero.y + ( Obstacle.Taille.height / 2 ) ) > 0 ){
							Clip.y = Obstacle.PointZero.y + Obstacle.Taille.height + ( Obstacle.Bump || 0 );
							
						// S'il est avant la moitié —— - - Reposition le clip en haut
						} else {
							Clip.y = Obstacle.PointZero.y - ( Obstacle.Bump || 0 );
						}
						
						// Correcteur de bug
						if( Math.abs( Clip.x - SuddenthMemoryY ) > Clip.ApplyObstacle.BugBump ){
							
							// Repositionne le clip sur son ancienne position
							Clip.x = Clip.ApplyObstacle.MemoireX[ Clip.ApplyObstacle.MemoireX.length - Clip.ApplyObstacle.BugBumpReposition ];
							Clip.y = Clip.ApplyObstacle.MemoireY[ Clip.ApplyObstacle.MemoireY.length - Clip.ApplyObstacle.BugBumpReposition ];
						}
					}
					
					// Modifie la mémoire du clip pour celles enregistrés
					Clip.ApplyObstacle.MemoireX[ Clip.ApplyObstacle.MemoireX.length - 1 ] = InstantMemoireX;
					Clip.ApplyObstacle.MemoireY[ Clip.ApplyObstacle.MemoireY.length - 1 ] = InstantMemoireY;
						
					// Lance la fonction rattachée
					if( ClipObject.Fonction.Fonction != undefined ){ Launch( ClipObject.Fonction ); }
					
					// Relance le HitTest
					GlobalLoop( "Obstacle" , Nom );
				}
				
				
				// Donne la mémorisation des paramètres de l'obstacle
				Obstacle.MemoPointZero.x = Obstacle.PointZero.x;
				Obstacle.MemoPointZero.y = Obstacle.PointZero.y;
				//
				Obstacle.MemoTaille.width = Obstacle.Taille.width;
				Obstacle.MemoTaille.height = Obstacle.Taille.height;
			}
		}
		
		
		
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}