﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			LEVEL PROCESS	  		Version 0.4.0									***/
/***				   				   Dernière Mise à Jour : 10-08-14										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         			  Gestionnaire Environnement										***/
/***	Ce script archive et gére des notions de physiques et de manipulation générale d'éléments au sein   ***/
/***	de scène aux concepts définit comme, par exemple, un jeu de plate-forme, une vue hexadecimal, etc. 	***/
/***												      													***/
/***	Ce script s'occupe des gestions générales et complexes de physiques et gestion, là où le 		    ***/
/***	BrainProcess ne le fait qu'en ciblé.													 		    ***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Dynamic {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	
	// —— - - DISPLAY
	import flash.display.MovieClip;
	//
	// —— - - EVENT
	import flash.events.Event;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	import drOIde.Dynamic.BrainProcess;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class LevelProcess extends MiscTools{
		
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		// —————— ACTIVE
	    // Si le script est Active
		public var Active:Boolean = true;
		
		
		// —————— LINK
	    // Liaisons des scripts
		private var Brain:BrainProcess;
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function LevelProcess( TheLink:* ,			// ———— - - Le Lien vers la Scène
									  LienBrain:* = null 	// ———— - - Le Lien vers le BrainProcess
									 ){
			/*—*/
			
			// Établie la connexion
			Connexion( TheLink );
			
			// Si le player Process a été transmis —— - -
			if( LienBrain ){
				
				// Récupére le BrainProcess
				Brain = LienBrain;
			
			// Sinon —— - - Trace l'erreur
			} else {
				//
				TraceError( "BrainProcess" , "Initialisation" , 
							 "Vous devez transmettre le BrainProcess en argument à l'initialisation du LevelProcess." )
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	     					DESIGN 				  	  							  */
		/*	 	   	 		Méthodes pour enregistrer et exploiter des designs d'environnement		 			  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
		
		// —————— DESIGN
	    // L'Archive des level designs
		private var Designs:Object = new Object();
		
		
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Les méthodes pour créer de nouveaux designs
		//*—*//
		
		// —————— NEW DESIGN GROUP
		// Ajoute un nouveau groupe de design
		
		public function NewDesignGroup( Nom:String 	// ———— - - Le Nom du groupe
									 ):void {
		  	/*—*/
			
			// Créait ce nouveau groupe
			Designs[ Nom ] = new Object();
		}
	  
	  
		// —————— NEW DESIGN
		// Ajoute un nouveau level design
		
		public function NewDesign( Groupe:String ,			// ———— - - Le Groupe
								   Nom:String ,				// ———— - - Le Nom du design
								   Type:String ,			// ———— - - Le Type du design
								   Intelligence:Object = ""	// ———— - - Le Contenu du design
							     ):void {
			/*—*/
			
			// Arguments par défaut
			Intelligence = Intelligence || new Object();
			
			// Si le groupe n'existe pas —— - - Créait ce groupe
			if( !Designs[ Groupe ] ){ NewDesignGroup( Groupe ); }
			
			// Créait ce nouveau designs
			Designs[ Groupe ][ Nom ] = new Object();
			//
			Designs[ Groupe ][ Nom ].Type = Type;
			Designs[ Groupe ][ Nom ].Intelligence = Intelligence;
		}
		
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Les méthodes pour appliquer et manipuler les designs
		//*—*//
		
		// —————— APPLY DESIGN
		// Applique une intelligence sur un élément
		
		public function ApplyDesign( Groupe:String ,			// ———— - - Le groupe
									 Nom:String ,				// ———— - - Le nom de l'intelligence
									 Element:* ,				// ———— - - L'élément qui acquiert l'intelligence
									 Parametres:Object = null	// ———— - - Les parametres additifs
									):void {
			/*—*/
			
			// Si le groupe existe —— - -
			if( Designs[ Groupe ] ){ 
			
			// Si le design existe —— - -
			if( Designs[ Groupe ][ Nom ] ){ 
				
				// Lance la création du design avec ses paramètres
				var Nom:String = Designs[ Groupe ][ Nom ].Type;
				var Intelligences:Object = Designs[ Groupe ][ Nom ].Intelligence;
				
				
				// Si ce design existe —— - -
				if( this[ Nom + "Loop" ] ){
				  
					// Créait l'objet de control de ce design
					Element[ "LevelDesign" + Nom ] = Intelligences;
					
					// Donne la boucle de ce design à l'élément
					AddEvents( Element , this[ Nom + "Loop" ] , "ENTER_FRAME" , "Design" + Nom + "Loop" );
					
					// Donne à l'élément sa méthode pour ajouter des éléments
					Element[ Nom + "Ajoute" ] = function( lElement:* ,				// —— - - L'élément ajouté
														  leType = "" ,				// —— - - Le type de l'élément ajouté
														  lesParametres:* = null	// —— - - Les parametres de l'éléments
													   ):void {
					  
						// Si l'objet existe —— - -
						if( Element[ "LevelDesign" + Nom ][ "Elements" + leType ] ){
						  
							// Lui donne son LevelDesignControl
							lElement[ "LevelDesignControl" + Nom ] = lesParametres || new Object();
							
							// Ajoute l'élément
							Element[ "LevelDesign" + Nom ][ "Elements" + leType ].push( lElement );
						
						// Sinon —— - - Différe l'envoie
						} else { CountdownLaunch( { Fonction:Element[ Nom + "Ajoute" ] , 
								 Arguments:[ lElement , leType , lesParametres ] } , 1 ); }
					}
					
					// Donne à l'élément sa méthode pour retirer des éléments
					Element[ Nom + "Retire" ] = function( lElement:* ,		// —— - - L'élément retiré
														  leType = ""		// —— - - Le type de l'élément retiré
														):void {
					  
						// Ajoute l'élément
						Element[ "LevelDesign" + Nom ][ "Elements" + leType ] = 
						DeleteFromArray( Element[ "LevelDesign" + Nom ][ "Elements" + leType ] , lElement );
					}
					
					// Donne à l'élément sa méthode pour provoquer l'état plusieurs fois
					Element[ Nom + "Provoque" ] = function( Nombre:int = 1 ):void {
					  
						// Autant de fois —— - -
						for( var i:int = 0 ; i < Nombre ; i++ ){ 
						
							// Provoque l'événement
							This[ Nom + "Loop" ]( { target:Element } );
						} 
					}
				
				// Si ce design n'existe pas —— - - Trace l'erreur
				} else {
					//
					TraceError( "LevelDesign" , "CreationDesign" , "Le design «" + Nom + "» n'existe pas sur le LevelProcess." );
				}
				
			
			// Si l'intelligence n'existe pas —— - - Trace l'erreur
			} else { TraceError( "LevelProcess" , "Design" , "Le design «" + Nom + "» n'existe pas." ); }
			
			// Si le groupe n'existe pas —— - - Trace l'erreur
			} else { TraceError( "LevelProcess" , "Design" , "Le design «" + Groupe + "» n'existe pas." ); }
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	     					GRAVITY				  	  							  */
		/*	 	   	 						Méthodes de Design basées sur la gravité		 				  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - LOOP - - —————————————————————————————————————————— */
		// Les méthodes de boucle du design
		//*—*//
		
		// —————— GRAVITY LOOP
		// Boucle générale de gravité
		
		public function GravityLoop( event:* ):void {
			/*—*/
			
			// Récupère la cible
			var LevelScene:* = event.target;
			
			// Récupère l'objet de contrôle
			var LevelControl:Object = LevelScene.LevelDesignGravite;
			
			// Valeurs par défaut
			LevelControl.Elements = LevelControl.Elements || new Array();
			//
			LevelControl.Gravite = LevelControl.Gravite || 1;
			LevelControl.Max = LevelControl.Max || 20;
			LevelControl.Sol = LevelControl.Sol || null;
			LevelControl.Friction = LevelControl.Friction || 0.75;
			
			// Pour chaque éléments —— - -
			for( var i:int = 0 ; i < LevelControl.Elements.length ; i++ ){
			  
				// S'il existe —— - -
				if( LevelControl.Elements[ i ] ){
				  
					// Subis la gravité
					GravityPressure( LevelControl.Elements[ i ] , LevelControl );
				  
				// Sinon —— - - Le retire
				} else { LevelControl.Elements.splice( i , 1 ); }
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - LAUNCH - - —————————————————————————————————————————— */
		// Les méthodes de fonctionnement du design
		//*—*//
		
		// —————— GRAVITY PRESURE
		// Pression de gravité sur les éléments
		
		public function GravityPressure( Element:* ,			// ———— - - L'Élément concerné
									     LevelControl:Object	// ———— - - Les Parametres de contrôle
									    ):void {
			/*—*/
			
			// Si l'élément est rattaché au BrainProcess —— - -
			if( Element.Brain ){
				
				// La vitesse en Y augmente
				Element.Brain.VitesseY += LevelControl.Gravite;
				
				// Bump
				Element.Brain.VitesseY = BumpNumber( Element.Brain.VitesseY , LevelControl.Max * -1 , LevelControl.Max );
				
				// Collision au sol s'il y en a un
				if( LevelControl.Sol ){
					//
					// S'il dépasse le sol —— - -
					if( Element.x + Element.Brain.VitesseY > LevelControl.Sol ){
						
						// Se mes sur le sol
						Element.x = LevelControl.Sol;
						
						// Rebondie
						Element.Brain.VitesseY *= -1;
						
						// Applique la friction
						Element.Brain.VitesseY *= LevelControl.Friction;
					}
				}
			 
			// Si l'élément n'est pas rattaché au BrainProcess —— - -
			} else {
			  
				// Récupére son LevelDesignControl
				var LevelDesignControl:Object = Element.LevelDesignControlGravite;
				
				// S'il n'a pas de Vitesse en Y —— - - lui en créait une
				if( !LevelDesignControl.VitesseY ){ LevelDesignControl.VitesseY = 0; }
				
				// La vitesse en Y augmente
				LevelDesignControl.VitesseY += LevelControl.Gravite;
				
				// Bump
				LevelDesignControl.VitesseY = BumpNumber( LevelDesignControl.VitesseY , LevelControl.Max * -1 , LevelControl.Max );
				
				// Collision au sol s'il y en a un
				if( LevelControl.Sol ){
					//
					// S'il dépasse le sol —— - -
					if( Element.y + LevelDesignControl.VitesseY > LevelControl.Sol ){
					  
						// Se mes sur le sol
						Element.y = LevelControl.Sol;
						
						// Rebondie
						LevelDesignControl.VitesseY *= -1;
						
						// Applique la friction
						LevelDesignControl.VitesseY *= ( Math.abs( LevelDesignControl.VitesseY ) > 5 ) ? LevelControl.Friction || 0.5 : 0;
					}
				}
				
				// Applique la vitesse
				Element.y += LevelDesignControl.VitesseY;
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	     					HEXAGONAL			  	  							  */
		/*	 	   	 					Méthodes de Design basées sur la vue héxagonale		 					  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - LOOP - - —————————————————————————————————————————— */
		// Les méthodes de boucle du design
		//*—*//
		
		// —————— HEXAGON LOOP
		// Boucle générale de vue héxagonale
		
		public function HexagonLoop( event:* ):void {
			/*—*/
			
			// Récupère la cible
			var LevelScene:* = event.target;
			
			// Récupère l'objet de contrôle
			var LevelControl:Object = LevelScene.LevelDesignHexagonal;
			
			// Valeurs par défaut
			LevelControl.Elements = LevelControl.Elements || new Array();
			LevelControl.ElementsOmbre = LevelControl.ElementsOmbre || new Array();
			
			// Pour chaque éléments —— - -
			for( var i:int = 0 ; i < LevelControl.Elements.length ; i++ ){
			  
				// S'il existe —— - -
				if( LevelControl.Elements[ i ] ){
				  
					// Placement hexagonal
					try{ HexagonPosition( LevelControl.Elements[ i ] , LevelControl ); } catch( e ){}
				  
				// Sinon —— - - Le retire
				} else { LevelControl.Elements.splice( i , 1 ); }
			}
			
			// Pour chaque ombre —— - -
			for( var j:int = 0 ; j < LevelControl.ElementsOmbre.length ; j++ ){
			  
				// S'il existe —— - -
				if( LevelControl.ElementsOmbre[ j ] ){
				  
					// Placement hexagonal
					try{ HexagonGroundPosition( LevelControl.ElementsOmbre[ j ] , LevelControl ); } catch( e ){}
				  
				// Sinon —— - - Le retire
				} else { LevelControl.ElementsOmbre.splice( j , 1 ); }
			}
			
			// S'il y a un conteneur des éléments —— - -
			if( LevelControl.Conteneur ){
			
				// Si les éléments ont les bonnes valeurs —— - - Classes les éléments par position de Sol en Y
				if( LevelControl.Elements[ 0 ] ){ 
					//
					ViewBy( LevelControl.Conteneur , "SolY" ); 
					//
					// S'il y a une fonction de debut —— - - La lance puis la retire
					if( LevelControl.FonctionDebut ){
						//
						Launch( LevelControl.FonctionDebut );
						LevelControl.FonctionDebut = null;
					}
				}
				//
				// Sinon —— - - Classes les éléments par position en y
				else { ViewBy( LevelControl.Conteneur , "y" ); }
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - LAUNCH - - —————————————————————————————————————————— */
		// Les méthodes de fonctionnement du design
		//*—*//
		
		// —————— HEXAGON POSITION
		// Placement dans la vue hexagonale
		
		public function HexagonPosition( Element:* ,			// ———— - - L'Élément concerné
									     LevelControl:Object	// ———— - - Les Parametres de contrôle
									   ):void {
			/*—*/
			
			// Variables générale
			var Control:Object = Element.LevelDesignControlHexagonal;
			
			// Valeurs par défaut
			Element.X = Element.X || 0;
			Element.Y = Element.Y || 0;
			Element.Z = Element.Z || 0;
			
			// S'il y a une gravite —— - -
			if( LevelControl.Gravite ){
				  
				// Donne sa vitesse de chute s'il n'en a pas
				Element.VitesseY = Element.VitesseY || 0;
				
				// S'il est au-desssus du sol —— - -
				if( Element.Y > LevelControl.Sol || Element.VitesseY < 0 || !LevelControl.Sol ){
				  
					// Sa vitesse de chute augmente
					Element.VitesseY += LevelControl.Gravite;
					//
					// Bump de vitesse de chute
					Element.VitesseY = BumpNumber( Element.VitesseY , LevelControl.MaxGravite * -1 , LevelControl.MaxGravite );
					
					// Collision au sol s'il y en a un —— - -
					if( LevelControl.Sol ){
					  
						// S'il dépasse le sol —— - -
						if( Element.Y - Element.VitesseY <= LevelControl.Sol ){
						  
							// Se mes sur le sol
							Element.Y = LevelControl.Sol;
							
							// Rebondie
							Element.VitesseY *= -1;
							
							// Applique la friction
							Element.VitesseY *= ( Math.abs( Element.VitesseY ) > 5 ) ? LevelControl.Friction || 0.5 : 0;
						}
					}
				  
				// S'il est sous le sol —— - - Plus de vitesse
				} else { Element.VitesseY = 0; }
				//
				// Tombe
				Element.Y -= Element.VitesseY;
			}
			
			// Position zéro de l'élément
			Element.x = 0;
			Element.y = 0;
			
			// Vue Droite
			if( !LevelControl.Vue || LevelControl.Vue == "Droite" ){
			  
				// Position X
				Element.x += Element.X;
				
				// Position Z
				Element.y += Element.Z / ( LevelControl.DivisibleZ || 1.3 );
				
				// Récupère la position de sol
				Element.SolX = Element.x;
				Element.SolY = Element.y;
				
				// Position Y
				Element.x += Element.Y * 0;
				Element.y += Element.Y * -1;
			
			// Vue Diagonale
			} else if( LevelControl.Vue == "Diagonale" ){
			  
				// Position X
				Element.x += Element.X;
				Element.y += Element.X / -( LevelControl.DivisibleX || 2 );
				
				// Position Z
				Element.x += Element.Z;
				Element.y += Element.Z / ( LevelControl.DivisibleZ || 2 );
				
				// Récupère la position de sol
				Element.SolX = Element.x;
				Element.SolY = Element.y;
				
				// Position Y
				Element.x += Element.Y * 0;
				Element.y += Element.Y * -1;
			}
			
			// Fonction d'élément ( S'il y en a une )
			if( LevelControl.FonctionElement ){ Launch( LevelControl.FonctionElement , true , Element ); }
		}
		
		
		// —————— HEXAGON GROUND POSITION
		// Placement dans la vue hexagonale au sol
		
		public function HexagonGroundPosition( Element:* ,			// ———— - - L'Élément concerné
											   LevelControl:Object	// ———— - - Les Parametres de contrôle
										     ):void {
			/*—*/
			
			// Variables générale
			var Control:Object = Element.LevelDesignControlHexagonal;
			
			// Récupère les positions
			Element.X = Control.Element.X;
			Element.Z = Control.Element.Z;
			
			// Position zéro de l'élément
			Element.x = 0;
			Element.y = 0;
			
			// Vue Droite
			if( !LevelControl.Vue || LevelControl.Vue == "Droite" ){
			  
				// Position X
				Element.x += Element.X;
				
				// Position Z
				Element.y += Element.Z / ( LevelControl.DivisibleZ || 1.3 );
				
				// Récupère la position de sol
				Element.SolX = Element.x;
				Element.SolY = Element.y;
			
			// Vue Diagonale
			} else if( LevelControl.Vue == "Diagonale" ){
			  
				// Position X
				Element.x += Element.X;
				Element.y += Element.X / -( LevelControl.DivisibleX || 2 );
				
				// Position Z
				Element.x += Element.Z;
				Element.y += Element.Z / ( LevelControl.DivisibleZ || 2 );
				
				// Récupère la position de sol
				Element.SolX = Element.x;
				Element.SolY = Element.y;
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	     					RUNNING 				  	  						  */
		/*	 	   	 		  Méthodes de Design basées sur un parcours de course en continue		 			  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - LOOP - - —————————————————————————————————————————— */
		// Les méthodes de boucle du design
		//*—*//
		
		// —————— RUNNING LOOP
		// Boucle générale de la course
		
		public function RunningLoop( event:* ):void {
			/*—*/
			
			// Récupère la cible
			var LevelScene:* = event.target;
			
			// Récupère l'objet de contrôle
			var LevelControl:Object = LevelScene.LevelDesignCourse;
			
			// Si on n'est pas en Pause —— - -
			if( Active ){
				
				// Valeur par défaut
				LevelControl.Angle = LevelControl.Angle || 0;
				LevelControl.PointZero = LevelControl.PointZero || { x:0 , y:0 };
				
				// Évolution de l'angle
				if( RandomBoolean( LevelControl.ChangementAngle || 100 ) ){
					//
					// Modifie l'angle
					LevelControl.Angle += Random( Aspiration( -LevelControl.Inflection , -1 ) , 
												  Aspiration( LevelControl.Inflection , 1 ) );
					//
					// Bloque l'angle
					LevelControl.Angle = BumpNumber( LevelControl.Angle , Aspiration( LevelControl.AngleMin , -360 ) , 
																	   Aspiration( LevelControl.AngleMax , 360 ) );
				}
				
				// Si c'est la scène qui est en mouvement —— - -
				if( LevelControl.Mouvement ){
					 
					// Déplacement du conteneur en fonction de l'angle
					SetDirectionTo( LevelScene , LevelControl.Vitesse || 5 , LevelControl.Angle , 180 );
					//
					// Déplacement du conteneur en fonction d'une vitesse X ou Y
					LevelScene.x += Aspiration( LevelControl.VitesseX , 0 );
					LevelScene.y += Aspiration( LevelControl.VitesseY , 0 );
					//
					// Mémorise les positions X et Y
					var MemoVerifX:Number = LevelScene.x;
					var MemoVerifY:Number = LevelScene.y;
					//
					// Bump de position
					LevelScene.x = BumpNumber( LevelScene.x , LevelControl.MinX , LevelControl.MaxX );
					LevelScene.y = BumpNumber( LevelScene.y , LevelControl.MinY , LevelControl.MaxY );
					//
					// S'il y a eu changement —— - - Recalibre l'angle
					if( MemoVerifX != LevelScene.x ){
						//
						LevelControl.Angle = EqualNear( LevelControl.Angle , [ -180 , 0 , 180 ] );
					}
					//
					if( MemoVerifY != LevelScene.y ){
						//
						LevelControl.Angle = EqualNear( LevelControl.Angle , [ -90 , 90 ] );
					}
					
					// Mise à jour du point zéro
					LevelControl.PointZero.x -= LevelScene.x - ( LevelControl.MemoX || LevelScene.x );
					LevelControl.PointZero.y -= LevelScene.y - ( LevelControl.MemoY || LevelScene.y );
					//
					// Mémorisation des positions
					LevelControl.MemoX = LevelScene.x;
					LevelControl.MemoY = LevelScene.y;
				  
				// Sinon —— - -
				} else {
					
					// Déplacement du point zéro en fonction de l'angle
					SetDirectionTo( LevelControl.PointZero , Aspiration( LevelControl.Vitesse ) , LevelControl.Angle , 5 );
					//
					// Déplacement du point zéro en fonction d'une vitesse X ou Y
					LevelControl.PointZero.x += LevelControl.VitesseX || 0;
					LevelControl.PointZero.y += LevelControl.VitesseY || 0;
					//
					// Mémorise les positions X et Y
					var MemoVerifPointZeroX:Number = LevelControl.PointZero.x;
					var MemoVerifPointZeroY:Number = LevelControl.PointZero.y;
					//
					// Bump de position
					LevelControl.PointZero.x = BumpNumber( LevelControl.PointZero.x , LevelControl.MinX , LevelControl.MaxX );
					LevelControl.PointZero.y = BumpNumber( LevelControl.PointZero.y , LevelControl.MinY , LevelControl.MaxY );
					//
					// S'il y a eu changement —— - - Recalibre l'angle
					if( MemoVerifPointZeroX != LevelControl.PointZero.x ){
						//
						LevelControl.Angle = EqualNear( LevelControl.Angle , [ -90 , 90 ] );
					}
					//
					if( MemoVerifPointZeroY != LevelControl.PointZero.y ){
						//
						LevelControl.Angle = EqualNear( LevelControl.Angle , [ -180 , 0 , 180 ] );
					}
				}
				
				// Valeur du déplacement du Point Zéro
				LevelControl.PointZero.VitesseX = LevelControl.PointZero.x - ( LevelControl.PointZero.MemoX || LevelControl.PointZero.x );
				LevelControl.PointZero.VitesseY = LevelControl.PointZero.y - ( LevelControl.PointZero.MemoY || LevelControl.PointZero.y );
				//
				LevelControl.PointZero.MemoX = LevelControl.PointZero.x;
				LevelControl.PointZero.MemoY = LevelControl.PointZero.y;
				
				// Valeurs par défaut
				LevelControl.Elements = LevelControl.Elements || new Array();
				
				// Pour chaque éléments —— - -
				for( var i:int = 0 ; i < LevelControl.Elements.length ; i++ ){
					
					// S'il existe —— - -
					if( LevelControl.Elements[ i ] ){
					  
						// Placement hexagonal
						try{} catch( e ){}
					  
					// Sinon —— - - Le retire
					} else { LevelControl.Elements.splice( i , 1 ); }
				}
				
				
				// S'il possède des chemins —— - -
				if( LevelControl.Chemin ){
					
					// L'encapsule au cas où
					LevelControl.Chemin = CapsuleArray( LevelControl.Chemin );
					
					// Pour chaque chemin —— - -
					for( var Chemin:int = 0 ; Chemin < LevelControl.Chemin.length ; Chemin++ ){
					  
						// S'il a son choix de Course —— - -
						if( LevelControl.Chemin[ Chemin ].Course ){
						
							// Applique son choix
							This[ LevelControl.Chemin[ Chemin ].Course ]( LevelControl.Chemin[ Chemin ] , LevelControl );
						  
						// S'il n'a pas de choix de course —— - -
						} else {
						
							// Applique celui par défaut
							RunningHorizontalWay( LevelControl.Chemin[ Chemin ] , LevelControl );
						}
					}
				}
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - APPLY - - —————————————————————————————————————————— */
		// Les méthodes d'applications de cas de figure du design
		//*—*//
		
		// —————— RUNNING HORIZONTAL WAY
		// Fait apparaître un chemin de course sur une scène à partir des éléments choisies le tout en défilement horizontal
		
		public function RunningHorizontalWay( Control:* ,		// ———— - - L'Élément concerné
											  LevelControl:*	// ———— - - Les Parametres de contrôle
										    ):void {
			/*—*/
			
			// S'il a les clés voulues —— - -
			if( TraceIfNotKey( Control , [ "Element" , "Scene" ] , "LevelProcess" , "BoucleCourse" , "Chemin" ) ){
			  
				// Créait l'objet de contrôle s'il n'existe pas
				Control.CheminObject = Control.CheminObject || { Active:true , Levier:0 };
				
				// Créait le conteneur s'il n'existe pas
				if( !Control.Scene.Conteneur ){
					//
					NewElement( MovieClip , Control.Scene , "Conteneur" );
				}
				
				// S'il est Active —— - -
				if( Control.CheminObject.Active ){
				   
				   // Décale la scene sur x
				   Control.Scene.Conteneur.x -= Aspiration( LevelControl.PointZero.VitesseX );
					
					// Si le levier est équivalent à l'intervalle de placement —— - -
					if( Control.CheminObject.Levier >= ( LevelControl.Intervalle || 0 ) ){
						
						// Replace le levier au minimum
						Control.CheminObject.Levier = 0;
						
						// Créait un nouvel élément
						var NouvelElement:* = NewElement( Control.Element , Control.Scene.Conteneur , "ElementChemin" , 
														 { 
														   x:LevelControl.PointZero.x + Aspiration( Control.DecalageX , 0 ) ,
														   y:LevelControl.PointZero.y + Aspiration( Control.DecalageY , 0 )
														 } );
						
						// Donne une rotation à l'élément suivant l'angle du level de course
						NouvelElement.rotation = LevelControl.Angle;
						
						// Si ce n'est pas le premier élément —— - -
						if( Control.CheminObject.AncienElement ){
							
							// Redimensionne l'élément par rapport au placement du précédent
							SetRealScale( NouvelElement , 
										  ( ( Control.BlocageTaille ) ?
										  BumpNumber( 
													GetDistance( NouvelElement , Control.CheminObject.AncienElement ) , 
													GetRealScale( NouvelElement ).width 
												 ) :
										  GetDistance( NouvelElement , Control.CheminObject.AncienElement ) )
										  + Aspiration( Control.DecalageTaille , 0 ) );
							
						// Si c'est le premier élément —— - - Il n'apparaît pas
						} else { NouvelElement.visible = false; }
						
						// Mémorise cet élément comme ancien élément pour le suivant
						Control.CheminObject.AncienElement = NouvelElement;
						
						// Pour chaque élément créé —— - -
						for( var i:int = 0 ; i < Control.Scene.Conteneur.numChildren ; i++ ){
							
							// Récupère son instance
							var CetElement:* = Control.Scene.Conteneur.getChildAt( i );
							
							// S'il dépasse par la gauche —— - -
							if( CetElement.x + Control.Scene.Conteneur.x <= Aspiration( Control.Gauche , 0 ) - CetElement.width ){
								//
								// Il est annihilé
								DestroyElement( CetElement );
							}
						}
					
					// Si le levier est inférieur à l'intervalle —— - - Augmente l'intervalle
					} else { Control.CheminObject.Levier++; }
				}
			}
		}
		
		
		
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}