﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			MOTION CHIP	  			Version 0.6.0									***/
/***				   				   Dernière Mise à Jour : 10-08-17										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         			  Intelligence Comportement											***/
/***	Ce script analyse l'état d'un clip et lui donne une interaction, un mouvement ou une animation.	    ***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Dynamic {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	
	// —— - - DISPLAY
	import flash.display.*;
	//
	// —— - - TEXT
	import flash.text.*
	//
	// —— - - EVENT
	import flash.events.Event;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	import drOIde.Port.MousePort;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class MotionChip extends MiscTools {
		
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		// —————— ELEMENT
	    // L'élément auquel le script est rattaché
		var Element:*;
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function MotionChip():void { 
			/*—*/
			
			// Établie la connexion
			Connexion( this );
			
			// Récupére l'élément sur lequel est la puce
			Element = this; 
			
			// Lance le repérage de sa nomination à rebours
			CountdownLaunch( Check , 1 );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					GLOBAL					  		  					  */
		/*						Méthodes pour manipuler les variables de chaine de caractères 					  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - CHECK - - —————————————————————————————————————————— */
		// Les méthodes vérifiant le contenu de l'élément pour lui appliquer un comportement
		//*—*//
		
		// —————— CHECK           									 	
		//	Vérifie la nomination de l'élément et de chacun de ses enfants pour leur appliquer les effets
	
		public function Check( Cible:* = null	// ———— - - Élément concerné
							  ):void {
			/*—*/
			
			// Arguments par défaut
			Cible = Cible || Element;
			
			
			/* —— - - SONDE - - —— */
			/**/
			
			// Pour chaque enfant de la cible —— - -
			for( var iCible:int = 0 ; iCible < Cible.numChildren ; iCible++ ){
				
				// Récupère le clip
				var leClip:* = Cible.getChildAt( iCible );
				
				// S'il ne s'agit pas d'une shape ou d'un texte —— - -
				if( !TypeOf( leClip , "Shape" ) && !TypeOf( leClip , "TextField" ) ){
					
					// Applique le Check sur lui
					Check( leClip );
				}
			}
			
			
			/* —— - - APPLICATION - - —— */
			/**/
			
			// Vérifie si le nom de l'élément se retrouve dans une des valeurs du script —— - -
			//
			var Valeur:String = GetNearValue( Element , Cible.name , 4 );
			
			// Si on a trouvé quelque chose —— - - L'applique
			if( Valeur != "" ){
				//
				Element[ Valeur ]( Cible );
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					MOTION					  		  					  */
		/*						Méthodes pour manipuler les variables de chaine de caractères 					  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VIBE - - —————————————————————————————————————————— */
		// Les méthodes de comportement de vibration
		//*—*//
		
		// —————— VIBE
		// Le clip vibre mais reste sur son point initial
	
		public function VibeStay( ElementChecked:* = null	// ———— - - Élément concerné 
							     ):void {
			/*—*/
			
			// Element par défaut
			ElementChecked = ElementChecked || Element;
			
			// Paramètre de l'élément
			//
			// Sa nervosité
			ElementChecked.nerve = ElementChecked.nerve || 2;
			//
			// Sa position initiale
			ElementChecked.xInitial = ElementChecked.xInitial || ElementChecked.x;
			ElementChecked.yInitial = ElementChecked.yInitial || ElementChecked.y;
			
			// Boucle de mouvement ▼▼
			ElementChecked.NerveuxStableBoucle = function( event:Event ):void {
				
				// Récupére l'instance de l'élément
				var Cible:* = event.target;
				
				// L'élément bouge en aléatoire
				Cible.x = Cible.xInitial + Random( -Cible.nerve , Cible.nerve );
				Cible.y = Cible.yInitial + Random( -Cible.nerve , Cible.nerve );
			}
			//
			// Donne son événement de boucle
			AddEvents( ElementChecked , ElementChecked.NerveuxStableBoucle , "ENTER_FRAME" , "NerveuxStableLoop" );
			//
			// Donne sa fonction pour interrompre son mouvement ▼▼
			ElementChecked.NerveuxStableStop = function():void {
				
				// Mes à null cette fonction
				ElementChecked.NerveuxStableStop = null;
				
				// Retire son événement de boucle
				RemoveEvents( ElementChecked , ElementChecked.NerveuxStableBoucle , "ENTER_FRAME" , "NerveuxStableLoop" );
			}
		}
		
	  
		// —————— VIBE MOVE
		// Le clip vibre et se déplace
	
		public function VibeMove( ElementChecked:* = null	// ———— - - Élément concerné 
								 ):void {
			/*—*/
			
			// Element par défaut
			ElementChecked = ElementChecked || Element;
			
			// Parametres de l'élément
			//
			// Sa nervosité
			ElementChecked.nerve = ElementChecked.nerve || 2;
			
			// Sa boucle de mouvement ▼▼
			ElementChecked.NerveuxInstableBoucle = function( event:Event ):void {
				
				// Récupére l'instance de l'élément
				var Cible:* = event.target;
				
				// L'élément bouge aléatoirement
				Cible.x += Random( -Cible.nerve , Cible.nerve );
				Cible.y += Random( -Cible.nerve , Cible.nerve );
			}
			//
			// Donne son événement de boucle
			AddEvents( ElementChecked , ElementChecked.NerveuxInstableBoucle , "ENTER_FRAME" , "NerveuxInstableLoop" );
			//
			// Donne sa fonction pour interrompre son mouvement ▼▼
			ElementChecked.NerveuxInstableStop = function():void {
				
				// Mes à null cette fonction
				ElementChecked.NerveuxInstableStop = null;
				
				// Retire son événement de boucle
				RemoveEvents( ElementChecked , ElementChecked.NerveuxInstableBoucle , "ENTER_FRAME" , "NerveuxInstableLoop" );
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - FLOAT - - —————————————————————————————————————————— */
		// Les méthodes de comportement de flottement
		//*—*//
		
		// —————— FLOAT
		// Le clip vibre de façon souple et se déplace
	
		public function FloatStay( ElementChecked:* = null	// ———— - - Élément concerné 
							      ):void {
			/*—*/
			
			// Element par défaut
			ElementChecked = ElementChecked || Element;
			
			// Parametres de l'élément
			//
			// Sa nervosité
			ElementChecked.nerve = ElementChecked.nerve || 2;
			//
			// Ses vitesses
			ElementChecked.xSpeed = ElementChecked.xSpeed || 0;
			ElementChecked.ySpeed = ElementChecked.ySpeed || 0;
			//
			// Ses freins
			ElementChecked.xBrake = ElementChecked.yBrake || 95;
			ElementChecked.yBrake = ElementChecked.yBrake || 95;
			//
			// Ses bumps
			ElementChecked.xBump = ElementChecked.xBump || 100;
			ElementChecked.yBump = ElementChecked.yBump || 100;
			//
			// Sa position initiale
			ElementChecked.xInitial = ElementChecked.xInitial || ElementChecked.x;
			ElementChecked.yInitial = ElementChecked.yInitial || ElementChecked.y;
			
			// Sa boucle de mouvement ▼▼
			ElementChecked.NeuroneStableBoucle = function( event:Event ):void {
				
				// Récupére l'instance de l'élément
				var Cible:* = event.target;
				
				// La vitesse évolue aléatoirment
				Cible.xSpeed += Random( -Cible.nerve , Cible.nerve );
				Cible.ySpeed += Random( -Cible.nerve , Cible.nerve );
				
				// La vitesse retourne dans l'autre direction si elle outrepasse le bump
				//
				// En largeur
				if( Cible.x > Cible.xInitial + Cible.xBump ){ Cible.xSpeed += Random( -Cible.nerve , 0 ); }
				else if( Cible.x < Cible.xInitial - Cible.xBump ){ Cible.xSpeed += Random( 0 , Cible.nerve ); }
				//
				// En hauteur
				if( Cible.y > Cible.yInitial + Cible.yBump ){ Cible.ySpeed += Random( -Cible.nerve , 0 ); }
				else if( Cible.y < Cible.yInitial - Cible.yBump ){ Cible.ySpeed += Random( 0 , Cible.nerve ); }
				
				// La vitesse freine
				Cible.xSpeed *= Cible.xBrake / 100;
				Cible.ySpeed *= Cible.yBrake / 100;
				
				// La vitesse influence la position
				Cible.x += Cible.xSpeed;
				Cible.y += Cible.ySpeed;
			}
			//
			// Donne son événement de boucle
			AddEvents( ElementChecked , ElementChecked.NeuroneStableBoucle , "ENTER_FRAME" , "NeuroneStableLoop" );
			//
			// Donne sa fonction pour interrompre son mouvement ▼▼
			ElementChecked.NeuroneStableStop = function():void {
				
				// Mes à null cette fonction
				ElementChecked.NeuroneStableStop = null;
				
				// Retire son événement de boucle
				RemoveEvents( ElementChecked , ElementChecked.NeuroneStableBoucle , "ENTER_FRAME" , "NeuroneStableLoop" );
			}
		}
		
		  
		// —————— FLOAT MOVE
		// Le clip vibre de façon souple et se déplace
	
		public function FloatMove( ElementChecked:* = null	// ———— - - Élément concerné 
								  ):void {
			/*—*/
			
			// Element par défaut
			ElementChecked = ElementChecked || Element;
			
			// Parametres de l'élément
			//
			// Sa nervosité
			ElementChecked.nerve = ElementChecked.nerve || 2;
			//
			// Ses vitesses
			ElementChecked.xSpeed = ElementChecked.xSpeed || 0;
			ElementChecked.ySpeed = ElementChecked.ySpeed || 0;
			//
			// Ses freins
			ElementChecked.xBrake = ElementChecked.xBrake || 95;
			ElementChecked.yBrake = ElementChecked.yBrake || 95;
			
			// Sa boucle de mouvement ▼▼
			ElementChecked.NeuroneInstableBoucle = function( event:Event ):void {
				
				// Récupére l'instance de l'élément
				var Cible:* = event.target;
				
				// La vitesse évolue suivant la nervosité
				Cible.xSpeed += Random( -Cible.nerve , Cible.nerve );
				Cible.ySpeed += Random( -Cible.nerve , Cible.nerve );
				
				// La vitesse freine
				Cible.xSpeed *= Cible.xBrake / 100;
				Cible.ySpeed *= Cible.yBrake / 100;
				
				// La vitesse influence la position de l'élément
				Cible.x += Cible.xSpeed;
				Cible.y += Cible.ySpeed;
			}
			//
			// Donne son événement de boucle
			AddEvents( ElementChecked , ElementChecked.NeuroneInstableBoucle , "ENTER_FRAME" , "NeuroneInstableLoop" );
			//
			// Donne sa fonction pour interrompre son mouvement ▼▼
			ElementChecked.NeuroneInstableStop = function():void {
				
				// Mes à null cette fonction
				ElementChecked.NeuroneInstableStop = null;
				
				// Retire son événement de boucle
				RemoveEvents( ElementChecked , ElementChecked.NeuroneInstableBoucle , "ENTER_FRAME" , "NeuroneInstableLoop" );
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - MAGNET - - —————————————————————————————————————————— */
		// Les méthodes de comportement de déplacement en attirance-répulsion
		//*—*//
		
		// —————— SATELLITE
		// Le clip gravite autour d'un point central
	
		public function Satellite( ElementChecked:* = null	// ———— - - Élément concerné
								  ):void {
			/*—*/
			
			// Element par défaut
			ElementChecked = ElementChecked || Element;
			
			// Parametres de l'élément
			//
			// Sa nervosité
			ElementChecked.nerve = 1;
			//
			// Ses vitesses
			ElementChecked.xSpeed = ElementChecked.xSpeed || Random( -10 , 10 );
			ElementChecked.ySpeed = ElementChecked.ySpeed || Random( -10 , 10 );
			//
			// Ses freins
			ElementChecked.xBrake = ElementChecked.xBrake || 99.9;
			ElementChecked.yBrake = ElementChecked.yBrake || 99.9;
			//
			// Ses bumps
			ElementChecked.xBump = ElementChecked.xBump || 100;
			ElementChecked.yBump = ElementChecked.yBump || 100;
			//
			// Sa position initiale
			ElementChecked.xInitial = ElementChecked.yInitial || ElementChecked.x;
			ElementChecked.yInitial = ElementChecked.yInitial || ElementChecked.y;
			
			// Sa boucle de mouvement ▼▼
			ElementChecked.GraviteBoucle = function( event:Event ):void {
				
				// Récupére l'instance de l'élément
				var Cible:* = event.target;
				
				// La vitesse de l'élément le fait se diriger vers son point central et bascule légérement en aléatoire
				Cible.xSpeed += ( Cible.xInitial - Cible.x ) / 10 + Random( -Cible.nerve , Cible.nerve );
				Cible.ySpeed += ( Cible.yInitial - Cible.y ) / 10 + Random( -Cible.nerve , Cible.nerve );
				
				// La vitesse freine
				Cible.xSpeed *= Cible.xBrake / 100;
				Cible.ySpeed *= Cible.yBrake / 100;
				
				// La vitesse influence la position et proportionnel au bump
				Cible.x += Cible.xSpeed * ( Cible.xBump / 100);
				Cible.y += Cible.ySpeed * ( Cible.yBump / 100);
			}
			//
			// Donne son événement de boucle
			AddEvents( ElementChecked , ElementChecked.GraviteBoucle , "ENTER_FRAME" , "GraviteBoucle" );
			//
			// Donne sa fonction pour interrompre son mouvement ▼▼
			ElementChecked.GraviteStop = function():void {
				
				// Mes à null cette fonction
				ElementChecked.GraviteStop = null;
				
				// Retire son événement de boucle
				RemoveEvents( ElementChecked , ElementChecked.GraviteBoucle , "ENTER_FRAME" , "GraviteBoucle" );
			}
		}
		
		  
		// —————— WEIGH           									 	
		//	Le clip subit la gravité
	
		public function Weigh( ElementChecked:* = null	// ———— - - Élément concerné
							  ):void {
			/*—*/
			
			// Element par défaut
			ElementChecked = ElementChecked || Element;
			
			// Parametres de l'élément
			//
			// Ses vitesses
			ElementChecked.xSpeed = ElementChecked.xSpeed || 0;
			ElementChecked.ySpeed = ElementChecked.ySpeed || 0;
			//
			// Ses frottements
			ElementChecked.xFriction = ElementChecked.xFriction || 99;
			ElementChecked.yFriction = ElementChecked.yFriction || 100;
			//
			// Ses gravités
			ElementChecked.xGravity = ElementChecked.xGravity || 0;
			ElementChecked.yGravity = ElementChecked.yGravity || 1;
			
			// Sa boucle de mouvement ▼▼
			ElementChecked.NewtonBoucle = function( event:Event ):void {
				
				// Récupére l'instance de l'élément
				var Cible:* = event.target;
				
				// La vitesse de l'élément subit la gravite
				Cible.xSpeed += Cible.xGravity;
				Cible.ySpeed += Cible.yGravity;
				
				// La vitesse de l'élément subit les frottements
				Cible.xSpeed *= Cible.xFriction / 100;
				Cible.ySpeed *= Cible.yFriction / 100;
				
				// L'élément modifie sa position en fonction de sa vitesse
				Cible.x += Cible.xSpeed;
				Cible.y += Cible.ySpeed;
			}
			//
			// Donne son événement de boucle
			AddEvents( ElementChecked , ElementChecked.NewtonBoucle , "ENTER_FRAME" , "NewtonBoucle" );
			//
			// Donne sa fonction pour interrompre son mouvement ▼▼
			ElementChecked.NewtonStop = function():void {
				
				// Mes à null cette fonction
				ElementChecked.NewtonStop = null;
				
				// Retire son événement de boucle
				RemoveEvents( ElementChecked , ElementChecked.NewtonBoucle , "ENTER_FRAME" , "NewtonBoucle" );
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					TIE					  		  					  	  */
		/*					Méthodes pour rattacher un comportenement de l'élément à une cible 					  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - SHAPE - - —————————————————————————————————————————— */
		// Les méthodes de comportement de forme
		//*—*//
		
		// —————— WATCH ELEMENT
		// Suis un élément du regard
	
		public function WatchElement( Clip:* = null ,	// ———— - - Le Clip de la pupille
									  Cible:* = null ,	// ———— - - La Cible en question
									  Fond:* = null		// ———— - - Le Clip du fond de l'oeil
								    ):void {
			/*—*/			
			
			// Valeurs par défaut
			Clip = Clip || Element;
			
			// Si on n'a pas donné de fond —— - -
			if( !Fond ){
				
				// Variable levier
				var LevierRegard:Boolean = false;
				
				// Pour chaque enfant du clip —— - -
				for( var iClip:int = 0 ; iClip < Clip.numChildren ; iClip++ ){
					
					// Si son nom contient "Pupille" —— - -
					if( FindIn( Clip.getChildAt( iClip ).name , "Pupille" ) ){
						
						// Isole l'autre partie de son nom
						var NomPupille:String = Pop( Clip.getChildAt( iClip ).name , "Pupille" );
						
						// Pour chaque enfant du clip —— - -
						for( var jClip:int = 0 ; jClip < Clip.numChildren ; jClip++ ){
							
							// S'il contient la partie du nom de la pupille mais n'est pas le même clip —— - -
							if( FindIn( Clip.getChildAt( jClip ).name , NomPupille ) 
							 && Clip.getChildAt( iClip ).name != Clip.getChildAt( jClip ).name ){
								
								// Applique le regard sur cette pupille et ce fond
								WatchElement( Clip.getChildAt( iClip ) , Cible , Clip.getChildAt( jClip ) );
								
								// Active le levier
								LevierRegard = true;
							}
						}
					}
				}
				
				// Si le levier de regard n'a pas été activé —— - - Trace l'erreur
				if( !LevierRegard ){
					//
					TraceError( "MotionChip" , "WatchElement" , [ "Le Clip demandé pour appliquer le regard ne contient pas de clip de pupille" ,
																  "ou ne contient pas de clip de fond dont le nom est relatif à sa pupille." ,
																  "Pour fonctionner, il faut, par exemple, que votre clip contienne :" ,
																  "\"PupilleDroit\" et \"FondDroit\"" ] );
				}
			
			// Si on a trouvé un fond —— - -
			} else {
				
				// S'il n'y a pas de cible —— - -
				if( !Cible ){
					//
					// Elle est la souris par défaut
					var Mouse:MousePort = Cible = Clip.target = new MousePort( Clip );
				}
				
				// Donne l'objet du regard au clip
				Clip.Regard = new Object();
				
				// Donne les paramètres au clip
				Clip.Regard.Fond = Fond;
				//
				Clip.Regard.Force = Clip.Force || 8;
				
				// Donne la boucle au clip —— - -
				Clip.Regard.Boucle = function( event:Event ):void {
					
					// Récupére l'instance des clips et objet
					var leClip:* = event.target;
					var Regard:* = event.target.Regard;
					var LaCible:* = leClip.target;
					//
					// Récupére la position de la cible ( Par x/y ou X/Y pour Mouse par exemple )
					var PositionCibleX:Number = LaCible.x;
					var PositionCibleY:Number = LaCible.y;
					
					// Distance à donner
					var Distance:Number = GetDistance( { x:GetTotal( Regard.Fond , "x" ) , y:GetTotal( Regard.Fond , "y" ) } , 
													   { x:PositionCibleX , y:PositionCibleY } ) / Regard.Force;
					//
					// Bump la distance
					if( Distance > Regard.Fond.width / 2 ){ Distance = Regard.Fond.width / 2; }
					
					// Positionne la pupille en x
					leClip.x = GetDirectionTo( Regard.Fond , 
											   Distance , 
											   GetAngle( { x:GetTotal( Regard.Fond , "x" ) , y:GetTotal( Regard.Fond , "y" ) }  , 
														 { x:PositionCibleX , y:PositionCibleY } )
												).x;
					//
					// Positionne la pupille en y
					leClip.y = GetDirectionTo( Regard.Fond , 
											   Distance , 
											   GetAngle( { x:GetTotal( Regard.Fond , "x" ) , y:GetTotal( Regard.Fond , "y" ) } , 
														 { x:PositionCibleX , y:PositionCibleY } )
											   ).y;
				}
				
				// Donne l'événement de boucle à la pupille
				AddEvents( Clip , Clip.Regard.Boucle , "ENTER_FRAME" , "BoucleWatchElement" );
			}
		}


		// —————— WATCH DIRECTION	           									 	
		// L'élément regarde toujours dans la direction qui est la sienne
	
		public function WatchDirection( Clip:* = null ,		// ———— - - Le Clip concerné
										Vitesse:Number = 2	// ———— - - Vitesse de rotation
									  ):void {
			/*—*/
			
			// Argument par défaut
			Clip = Clip || Element;
			
			// Donne l'objet du regard au clip
			Clip.LaDirection = new Object();
			//
			Clip.LaDirection.MemoireX = Clip.x;
			Clip.LaDirection.MemoireY = Clip.y;
			//
			Clip.LaDirection.Rotation = Clip.rotation;
			
			// Donne la boucle au clip —— - -
			Clip.LaDirection.Boucle = function( event:Event ):void {
				
				// Récupére l'instance des clips et objet
				var leClip:* = event.target;
				var Direction:* = event.target.LaDirection;
				
				// Définit la rotation
				if( Round( leClip.x / 10 ) != Round( Direction.MemoireX / 10 ) 
				 || Round( leClip.y / 10 ) != Round( Direction.MemoireY / 10 ) ){
					Direction.Rotation = GetAngle( { x:Direction.MemoireX , y:Direction.MemoireY } , leClip );
				}
				
				// mémorise la position parent si elle a changée
				Direction.MemoireX = leClip.x;
				Direction.MemoireY = leClip.y;
				
				// Fait aller vers la rotation de façon fluide
				AngleGoTo( leClip , Direction.Rotation , Vitesse );
			}
			
			// Donne l'événement de boucle à la pupille
			AddEvents( Clip , Clip.LaDirection.Boucle , "ENTER_FRAME" , "WatchDirectionBoucle" );
		}

		
		
		/* —————————————————————————————————————————— - - MOVEMENT - - —————————————————————————————————————————— */
		// Les méthodes de comportement de déplacement
		//*—*//
		
		// —————— STITCH
		// Attache un clip à un autre par sa position x,y
	
		public function Stitch( MailleParent:* = null ,		// ———— - - Parent du clip
								MailleEnfant:* = null ,		// ———— - - Clip attaché
								Parametres:Object = null	// ———— - - Les paramètres additifs
							   ):void {
			/*—*/
			
			// Arguments par défaut
			MailleParent = MailleParent || Element;
			//
			// Récupère son attache
			MailleParent.link = MailleParent.link || 
								MailleParent.parent[ PasteString( MailleParent.name ) ];
			//
			MailleEnfant = MailleParent.link;
			
			// S'il y a une maille enfant —— - -
			if( MailleEnfant ){
				
				// Donne les paramètres de Chaine à l'enfant
				MailleEnfant.Chaine = Parametres || new Object();
				//
				// Donne les données supplémentaire à l'enfant
				MailleEnfant.Chaine.Parent = MailleParent;
				MailleEnfant.Chaine.Gravite = MailleEnfant.Chaine.Gravite || MailleParent.gravity || false;
				MailleEnfant.Chaine.Verrouillage = MailleEnfant.Chaine.Verrouillage ||  MailleParent.lock || false;
				//
				// Donne les variable initiale à l'enfant
				MailleEnfant.Chaine.VitesseY = 0;
				MailleEnfant.Chaine.VitesseRotation = 0;
				//
				// Donne les arguments à l'enfant
				MailleEnfant.Chaine.ForceGravite = MailleEnfant.Chaine.ForceGravite || MailleParent.gravityStrength || 2;
				MailleEnfant.Chaine.FreinGravite = MailleEnfant.Chaine.FreinGravite || MailleParent.gravityBrack || 80;
				MailleEnfant.Chaine.MaxGravite = MailleEnfant.Chaine.MaxGravite || MailleParent.gravityMax || 10;
				MailleEnfant.Chaine.Distance = MailleEnfant.Chaine.Distance || MailleParent.distance || MailleEnfant.width / 2;
				
				// Donne sa boucle à l'enfant —— - -
				MailleEnfant.Chaine.Boucle = function( event:Event ):void {
					
					// Récupére les instances : Enfant, ses paramètres et son parent
					var Cible:* = event.target;
					var Chaine:Object = Cible.Chaine;
					var Parent:* = Chaine.Parent;
					
					// S'il est trop éloigné du parent ou s'il y a le verrouillage —— - -
					if( Round( GetDistance( Parent , Cible ) ) >= Round( Chaine.Distance ) || Chaine.Verrouillage ){
						
						// Si la gravité est mise —— - -
						if( Chaine.Gravite ){
							
							// S'il est trop à droite, sa vitesse de rotation augmente vers la gauche
							if( GetAngle( Parent , Cible ) > -90 && GetAngle( Parent , Cible ) < 80 ){ Chaine.VitesseRotation += Chaine.ForceGravite; } 
							//
							// S'il est trop à gauche, sa vitesse de rotation augmente vers la droite
							else if( GetAngle( Parent , Cible ) < -90 || GetAngle( Parent , Cible ) > 100 ){ Chaine.VitesseRotation -= Chaine.ForceGravite; } 
							//
							// S'il est entre les deux, sa vitesse de rotation freine
							else { Chaine.VitesseRotation *= Chaine.FreinGravite / 100; }
							
							// Si sa vitesse de rotation a dépassé le maximum —— - -
							if( Math.abs( Chaine.VitesseRotation ) > Chaine.MaxGravite ){ 
							
								// Sa vitesse de rotation se mes à son maximum
								Chaine.VitesseRotation = Chaine.MaxGravite * ( Math.abs( Chaine.VitesseRotation ) / Chaine.VitesseRotation ) ;
							}
						}
						
						// Création d'un objet pour les positions du parent
						var Position:Object = { x:Parent.x , y:Parent.y };
						//
						// Impose à l'objet de partir de la position du parent pour aller jusqu'à la position de l'enfant dans la distance voulu
						SetDirectionTo( Position , Chaine.Distance , GetAngle( Parent , Cible ) + Chaine.VitesseRotation );
						//
						// Positionne l'enfant à partir de la position de l'objet
						Cible.x = Position.x;
						Cible.y = Position.y;
						
						// Fait passé la vitesse y à 0
						Chaine.VitesseY = 0;
					
					// S'il n'est trop éloigné du parent et qu'il n'y a pas de verrouillage —— - -
					} else if( Chaine.Gravite ){ 
						
						// La vitesse y de l'enfant augmente
						Chaine.VitesseY += ( Chaine.ForceGravite * ( Chaine.FreinGravite / 100 ) );
						
						// La vitesse y de l'enfant se définie par rapport au max
						Chaine.VitesseY = BumpNumber( Chaine.VitesseY , NaN , Chaine.MaxGravite );
						
						// Sa position y se modifie par rapport à la vitesse y
						Cible.y += Chaine.VitesseY;
					}
				}
				//
				// Donne l'événement de boucle à l'enfant
				AddEvents( MailleEnfant , MailleEnfant.Chaine.Boucle , "ENTER_FRAME" , "BoucleGravite" );
			}
		}
		
		
		// —————— REPULSIVE
		// Fait qu'un clip en repousse un autre
		
		public function Repulsive( Clip2:* ,					// ———— - - Clip repoussé
								   Clip1:* = null ,				// ———— - - Clip repoussant
								   Parametres:Object = null		// ———— - - Les paramètres additifs
								 ):void {
			/*—*/
			
			// Arguments par défauts
			Clip1 = Clip1 || Element;
			
			// Donne les paramètres de repousse au clip
			Clip1.Pousse = Clip1.Pousse || Parametres || new Object();
			//
			// Donne les données supplémentaire au clip
			Clip1.Pousse.Elements = Clip1.Pousse.Elements || new Array();
			Clip1.Pousse.Elements.push( Clip2 );
			Clip1.Pousse.MemoX = Clip1.Pousse.MemoX || 0;
			Clip1.Pousse.MemoY = Clip1.Pousse.MemoY || 0;
			//
			// Donne les arguments au clip
			Clip1.Pousse.Distance = Clip1.Pousse.Distance || Clip1.distance || Clip1.width;
			
			// Si le clip n'a pas la boucle —— - -
			if( !Clip1.Pousse.Boucle ){
				
				// Donne sa boucle au clip —— - -
				Clip1.Pousse.Boucle = function( e:Event ):void {
					
					// Récupére les instances : Clip et ses paramètres
					var Cible:* = e.target;
					var Pousse:Object = Cible.Pousse;
					
					// S'il a bougé —— - -
					if( Pousse.MemoX != Cible.x || Pousse.MemoY != Cible.y ){
						
						// Récupére son placement
						Pousse.MemoX = Cible.x;
						Pousse.MemoY = Cible.y;
						
						// Pour chacun de ses éléments à pousser
						for( var i:int = 0 ; i < Pousse.Elements.length ; i++ ){
							
							// S'il est trop près ▼♥
							if( GetDistance( Cible , Pousse.Elements[ i ] ) < Pousse.Distance ){
								
								// Création d'un objet pour les positions de l'élément
								var Position:Object = { x:Cible.x , y:Cible.y };
								//
								// Impose à l'objet de partir de la position de l'élément pour aller jusqu'à la position 
								// de l'élément poussé dans la distance voulue
								SetDirectionTo( Position , Pousse.Distance , GetAngle( Cible , Pousse.Elements[ i ] ) );
								//
								// Positionne l'élément à partir de la position de l'objet
								Pousse.Elements[ i ].x = Position.x;
								Pousse.Elements[ i ].y = Position.y;
							}
						}
					}
				}
				
				// Donne l'événement de boucle à l'enfant
				AddEvents( Clip1 , Clip1.Pousse.Boucle , "ENTER_FRAME" );
			}
		}
		
		
		// —————— FOLLOWER
		// Pousse un clip à en suivre un autre, le clip peut ensuite être mené à changer de clip qu'il suit
	
		public function Follower( Clip:* = null ,			// ———— - - Le Clip suiveur
								  Cible:* = null , 			// ———— - - La Cible à suivre
								  Parametres:Object = null	// ———— - - Les parametres transmis
								 ):void {
			/*—*/
			
			// Arguments par défaut
			//
			// L'élément est l'animation par défaut
			Parametres = Parametres || new Object();
			
			// Création de l'objet de suivis
			Clip.FollowObject = new Object();
			
			// Les paramétres donné à l'élément qui suis
			Clip.target = Clip.target || Cible;
			Clip.speed = Clip.speed || Parametres.speed || 10;
			//
			Clip.xShift = Clip.xShift || Parametres.xShift || 0;
			Clip.yShift = Clip.yShift || Parametres.yShift || 0;
			//
			Clip.inDirection = Clip.inDirection || Parametres.inDirection || false;
			
			// Si on a pas encore donné sa boucle de suivis à l'élément —— - -
			if( !Clip.FollowObject.Boucle ){
				
				// Donne sa boucle —— - -
				Clip.FollowObject.Boucle = function( event:Event ):void {
					
					// Récupére l'instance
					var leClip:* = event.target;
						
					// Recalle
					leClip.x -= leClip.xShift;
					leClip.y -= leClip.yShift;
					
					// Si sa cible existe —— - -
					if( leClip.target ){
						
						// Positionne l'élément
						leClip.x = NumberGoTo( leClip.x , leClip.target.x , leClip.speed , 0.2 );
						leClip.y = NumberGoTo( leClip.y , leClip.target.y , leClip.speed , 0.2 );
					}
						
					// Décalle
					leClip.x += leClip.xShift;
					leClip.y += leClip.yShift;
					
					
					// S'il subis également la rotation —— - -
					if( leClip.inDirection ){
						
						// Tourne l'élément
						AngleGoTo( leClip , leClip.target.rotation , leClip.speed );
					}
				}
				//
				// Donne l'événement à l'élément
				AddEvents( Clip , Clip.FollowObject.Boucle , "ENTER_FRAME" , "BoucleFollow" );
				
				// Donne à l'élément la fonction "Suis" permettant de modifier sa cible de suivis
				Element.Follow = function( Clip:* ):void { this.target = Clip; }
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					REACTION					  		  				  */
		/*						    Méthodes pour lancer des effets immédiats sur l'élément 					  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - DESTRUCTION - - —————————————————————————————————————————— */
		// Les méthodes de réaction qui détruisent l'élément ensuite
		//*—*//
		
		// —————— BLOW UP
		// Fait exploser le clip
		
		public function BlowUp( Physique:* = null , 			// ———— - - Les paramètres physique
							    Clip:* = null	,				// ———— - - L'Élément concerné
							    SelfAnnihile:Boolean = true		// ———— - - Si l'élément se self-annihile une fois tout ses éléments tombés
							   ):void {
			/*—*/
			
			// Arguments par défaut
			Clip = Clip || Element;
			//
			Physique = Physique || new Object();
			//
			Physique.ForceX = Physique.ForceX || [ -20 , 20 ];
			Physique.ForceY = Physique.ForceY || [ -20 , 20 ];
			Physique.ForceR = Physique.ForceR || [ -20 , 20 ];
			Physique.Gravite = Physique.Gravite || 2;
			Physique.Masse = Physique.Masse || 1;
			
			// Interrompt l'animation de l'élément
			Clip.stop();
			
			// Calibrage des Forces
			if( TypeOf( Physique.ForceX , "Number" ) ){ Physique.ForceX = [ Physique.ForceX , Physique.ForceX ]; }
			if( TypeOf( Physique.ForceY , "Number" ) ){ Physique.ForceY = [ Physique.ForceY , Physique.ForceY ]; }
			if( TypeOf( Physique.ForceR , "Number" ) ){ Physique.ForceR = [ Physique.ForceR , Physique.ForceR ]; }
					
			// Pour chaque clip de l'élément —— - -
			for( var i:int = 0 ; i < Clip.numChildren ; i++ ){
				
				// Récupére son instance
				var TargetElement:* = Clip.getChildAt( i );
				
				// S'il n'est pas de type shape —— - -
				if( !TypeOf( TargetElement , "Shape" ) ){
					
					// Créait son objet d'explosion
					TargetElement.Explosion = new Object();
					//
					// Donne à cet élément ses vitesse ( Aléatoire )
					TargetElement.Explosion.VitesseX = Random( Physique.ForceX[ 0 ] , Physique.ForceX[ 1 ] );
					TargetElement.Explosion.VitesseY = Random( Physique.ForceY[ 0 ] , Physique.ForceY[ 1 ] );
					TargetElement.Explosion.VitesseR = Random( Physique.ForceR[ 0 ] , Physique.ForceR[ 1 ] );
					//
					// Donne à cet élément ses paramètres
					TargetElement.Explosion.Gravite = Physique.Gravite;
					TargetElement.Explosion.Masse = Physique.Masse;
				
					// Donne à cet élément la boucle
					TargetElement.Explosion.Boucle = function( event:Event ):void {
						
						// Récupère son instance
						var Cible:* = event.target;
						
						// Déplace dans l'espace
						Cible.x += Cible.Explosion.VitesseX;
						Cible.y += Cible.Explosion.VitesseY;
						
						// Tourne
						Cible.rotation += Cible.Explosion.VitesseR;
						
						// Modifie les vitesses
						Cible.Explosion.VitesseX *= ( 100 - Cible.Explosion.Masse ) / 100;
						Cible.Explosion.VitesseY += Cible.Explosion.Gravite;
						
						// S'il est tombé très bas, l'annihile
						if( GetTotal( Cible , "y" ) > 2000 ){ DestroyElement( Cible , null , false ); }
					}
					//
					AddEvents( TargetElement , TargetElement.Explosion.Boucle , "ENTER_FRAME" );
				}
			}
			
			// Si l'élément se self-annihile ▼♥
			if( SelfAnnihile ){
				
				// Boucle de l'élément explosé —— - -
				Clip.ExplosionBoucle = function( event:Event ):void {
					
					// Récupère son instance
					var GlobalCible:* = event.target;
					//
					// S'il n'a plus d'enfant —— - - Il s'annihile
					if( GlobalCible.numChildren <= 0 ){ DestroyElement( GlobalCible , null , false ); }
				}
				//
				AddEvents( Clip , Clip.ExplosionBoucle , "ENTER_FRAME" , "ExplosionBoucle" );
			}
		}
		
		
		
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}