﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			  ACTION PROCESS	  	Version 0.2.0									***/
/***				   				   Dernière Mise à Jour : 10-08-14										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         			 	Gestionnaire Fonction											***/
/***	Ce script permet d'archiver des appels de fonctions pour pouvoir les lancer en masse ensuite ou 	***/
/***	selon des critéres particuliers d'argumentations.													***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Global {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	
	// —— - - DISPLAY
	import flash.display.MovieClip;
	//
	// —— - - EVENT
	import flash.events.Event;
	//
	// —— - - UTILS
	import flash.utils.*;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	
	public class ActionProcess extends MiscTools {
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      					  VARIABLES GLOBALES										  */
		/*		  							 Les variables d'utilisations globales								  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		// —————— ACTIONS
		//— Archivage des Actions
		public var Actions:Object = new Object();
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function ActionProcess( TheLink:* = null		// ———— - - Lien vers la scène
									  ):void {
			/*—*/
			
			// Établit la connexion
			Connexion( TheLink );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 ACTION					  		  					  */
		/*							Enregistrement et lancement d'appels de fonctions simples 			  		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Méthodes pour sauvegarder les actions
		//*—*//
		
		// —————— NEW ACTION GROUP
		// Créait un nouveau groupe d'action
		
		public function NewActionGroup( Nom:String // ———— - - Nom à donner au groupe
									  ):void {
			/*—*/
			
			// Créait le groupe
			Actions[ Nom ] = new Object();
		}
		
		
		// —————— NEW ACTION
		// Créait une nouvelle action
		
		public function NewAction( Groupe:String ,				// ———— - - Groupe dans lequel l'action est mise
								   Nom:String ,					// ———— - - Nom de l'action
								   lesActions:* ,				// ———— - - Les Actions la contenant
								   Parametres:Object = null		// ———— - - Les Parametres
								  ):void {
			/*—*/
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			
			// Si le groupe n'existe pas —— - - Le creait
			if( !Actions[ Groupe ] ){ NewActionGroup( Groupe ); }
			
			// Créait l'action
			Actions[ Groupe ][ Nom ] = new Object();
			//
			Actions[ Groupe ][ Nom ].Actions = CapsuleArray( lesActions );
			Actions[ Groupe ][ Nom ].Parametres = Parametres;
		}
		
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Méthodes pour modifier et lancer les actions
		//*—*//
		
		// —————— LAUNCH ACTION
		// Lance une action, à savoir elle lance chacune des fonctions qu'elle contient y comprit avec la possibilités
		// de lui ajouter des arguments supplantés ou additifs.
		// L'intérêt étant que si une de ses fonctions n'est pas en mesure de supporter les arguments ajoutés, elle la lancera quand même
		// sans ces derniers.
		
		public function LaunchAction( Groupe:String , 					// ———— - - Groupe contenant l'action à lancer
									  Nom:String = "" ,					// ———— - - Nom de l'action à lancer
									  ArgumentsSupplantes:* = null ,	// ———— - - Les Arguments ajoutés en supplantation des méthodes
									  ArgumentsAdditifs:* = null		// ———— - - Les Arguments ajoutés en additifs des méthodes
									):void {
			/*—*/
			
			// Si le Nom est inexistant —— - -
			if( Nom == "" ){
				
				// Lance la recherche
				var Search:Boolean = true;
				
				// Pour chaque groupe d'actions —— - -
				for( var j:* in Actions ){
					
					// Pour chaque action qu'il contient —— - -
					for( var k:* in Actions[ j ] ){
						
						// Si l'action est celle recherchée —— - -
						if( k == Groupe && Search ){
							
							// Récupére le nom de l'action
							Nom = Groupe;
							//
							// Récupère le nom du groupe
							Groupe = j;
							
							// Interrompt la recherche
							Search = false;
						}
					}
				}
			}
			
			// Si le groupe existe —— - -
			if( Actions[ Groupe ] ){
				
				// Si l'action existe —— - -
				if( Actions[ Groupe ][ Nom ] ){
						
					// Créait le levier de lancement total
					var LevierTotal:Boolean = false;
					
					// Test l'aléatoirité total
					if( !Actions[ Groupe ][ Nom ].Parametres.TotalAleatoire ){ Levier = true; }
					else { Levier = RandomBoolean( Actions[ Groupe ][ Nom ].Parametres.TotalAleatoire ); }
				
					// Lance les actions si le levier le permet
					if( Levier ){ 
							
						// Pour chaque actions dans cette action —— - -
						for( var i:* in Actions[ Groupe ][ Nom ].Actions ){
							
							// Créait le levier de lancement
							var Levier:Boolean = false;
							
							// Test l'aléatoirité
							if( !Actions[ Groupe ][ Nom ].Parametres.Aleatoire ){ Levier = true; }
							else { Levier = RandomBoolean( Actions[ Groupe ][ Nom ].Parametres.Aleatoire ); }
							
							// Lance cette action si le levier le permet
							if( Levier ){ 
								//
								// Tente de la lancer avec les arguments supplantés et additifs —— - -
								try {
									//
									Launch( Actions[ Groupe ][ Nom ].Actions[ i ] ,
											ArgumentsSupplantes ,
											ArgumentsAdditifs
										   );
									
								// Si échoue —— - -
								} catch( e ){									
									//
									// Tente de la lancer avec les arguments additifs —— - -
									try {
										//
										Launch( Actions[ Groupe ][ Nom ].Actions[ i ] ,
												null ,
												ArgumentsAdditifs
											   ); 
									
									// Si échoue —— - - Lance simplement
									} catch( e ){ Launch( Actions[ Groupe ][ Nom ].Actions[ i ] ); }
								}
							}
						}
					}
				
				// Si l'action n'existe pas —— - - Trace l'erreur
				} else { TraceError( "ActionProcess" , "Action" , "L'action «" + Nom + "» n'existe pas dans " + Groupe + "." ); }
				
			// Si le groupe n'existe pas —— - - Trace l'erreur
			} else { TraceError( "ActionProcess" , "Action" , "Le groupe «" + Groupe + "» n'existe pas." ); }
		}
		
		
  		
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}