﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			FILE PROCESS	  		Version 0.5.0									***/
/***				   				   Dernière Mise à Jour : 10-09-08										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         				Gestionnaire Fichiers											***/
/***	Ce script contient les méthodes pour le chargement d'élément externe tel que des swf ou images.     ***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Link {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	 
	// —— - - DISPLAY
	import flash.display.MovieClip;
	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.display.DisplayObject;
	//
	// —— - - NET
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequest;
	import flash.net.URLVariables;
	import flash.net.URLRequestMethod;
	import flash.net.FileFilter;
	import flash.net.FileReference;
	import flash.net.FileReferenceList;
	//
	// —— - - EVENT
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.HTTPStatusEvent;
	import flash.events.IOErrorEvent;
	import flash.events.DataEvent;
	import flash.events.ProgressEvent;
	//
	// —— - - SYSTEM
	import flash.system.LoaderContext;
	import flash.system.ApplicationDomain;
	
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class FileProcess extends MiscTools {
		
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		// —————— EXTENSION LIST
	  	// Les extensions pour les différents type de fichiers
	  	private var ExtensionList:Object = { Swf:	[ "swf" ] , 
											 Bitmap:[ "jpg" , "png" , "gif" , "bmp" , "jpeg" ] };
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function FileProcess( TheLink:* = null		// ———— - - Lien vers la scène
									 ):void {
			/*—*/
			
			// Établit la connexion
			Connexion( TheLink );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 FILE					  		  					  */
		/*								Archiver et manipuler des fichiers à charger	 					  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
		
		// —————— FILES
		// Les fichiers archivés
		private var Files:Object = new Object();
		
		
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
		
		// —————— NEW FILE GROUP
	 	// Créait un nouveau groupe de fichiers
		
		public function NewFileGroup( Nom:String		// ———— - - Le Nom du groupe
									  ):void {
			/*—*/
			
			// Si le groupe n'existe pas —— - -
			if( !Files[ Nom ] ){
			
				// Créait le groupe	
				Files[ Nom ] = new Object();
			}
		}
		
		
		// —————— NEW FILE
	  	// Créait un nouveau fichier potentiellement à charger
	  
		public function NewFile( Groupe:String ,  				// ———— - - Groupe du fichier
								 Nom:String ,					// ———— - - Nom à donner au fichier
								 Type:String ,					// ———— - - Type du fichier
								 Lien:String ,					// ———— - - Lien du fichier
								 Conteneur:* ,					// ———— - - Conteneur du fichier
								 Parametres:Object = null 		// ———— - - Les Parametres
								):void {
			/*—*/
			
			// Arguments par dégfaut —— - -
			Parametres = Parametres ||new Object();
			
			// Si le groupe n'existe pas, créait le groupe
			if( !Files[ Groupe ] ){ NewFileGroup( Groupe ); }
			
			// Créait le fichier dans le groupe
			Files[ Groupe ][ Nom ] = { Type:Type ,
									   Lien:Lien ,
									   Parametres:Parametres
									  };
		}
		
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
		
		// —————— LOAD FILE
	  	// Charge un fichier archivé
	  
		public function LoadFile( Groupe:String ,  // ———— - - Groupe du fichier
								  Nom:String	   // ———— - - Nom du fichier
							    ):void {
			/*—*/
			
			// Si le groupe existe —— - -
			if( Files[ Groupe ] ){
				  
				// Si le fichier existe —— - -
				if( Files[ Groupe ][ Nom ] ){
					
					// Si le type du fichier à charger existe —— - -
					if( this[ Files[ Groupe ][ Nom ].Type + "Load" ] ){
							
							// Lance le chargement
							this[ Files[ Groupe ][ Nom ].Type + "Load" ]( Files[ Groupe ][ Nom ].Lien ,
																		  Files[ Groupe ][ Nom ].Conteneur ,
																		  Files[ Groupe ][ Nom ].Parametres 
																		  );
					
					// Trace une erreur si le type du fichier n'existe pas
					} else { TraceError( "FileProcess" , "LoadFile" , [ "Le type \"" + Files[ Groupe ][ Nom ].Type 
																		 + "\" du fichier \"" + Nom 
																		 + "\" n'existe pas où n'est pas compris par cette fonction." ] ); }
					
				// Trace une erreur si le type du fichier n'existe pas
				} else { TraceError( "FileProcess" , "LoadFile" , 
									 [ "Le fichier \"" + Nom + "\" n'existe pas dans le groupe \"" + Groupe + "\"." ] ); }
				
			// Trace une erreur si le groupe n'existe pas
			} else { TraceError( "FileProcess" , "LoadFile" , [ "Le groupe \"" + Groupe + "\" n'existe pas." ] ); }
		}
		
		
		// —————— UNLOAD FILE
	  	// Décharge un fichier archivé
	  
		public function UnloadFile( Groupe:String , // ———— - - Groupe du fichier
								    Nom:String		// ———— - - Nom du fichier
							      ):void {
			/*—*/
			
			// Si le groupe existe —— - -
			if( Files[ Groupe ] ){
			  
				// Si le fichier existe —— - -
				if( Files[ Groupe ][ Nom ] ){
					
					// Si le type du fichier à charger existe —— - -
					if( this[ Files[ Groupe ][ Nom ].Type + "Unload" ] ){
						
						// Lance le déchargement
						this[ Files[ Groupe ][ Nom ].Type + "Unload" ]( Files[ Groupe ][ Nom ].Conteneur );
					
					// Trace une erreur si le type du fichier n'existe pas
					} else { TraceError( "FileProcess" , "NouveauFichier" , 
										 [ "Le type \"" + Files[ Groupe ][ Nom ].Type 
										 + "\" du fichier \"" + Nom 
										 + "\" n'existe pas où n'est pas compris par cette fonction." ] ); }
					
				// Trace une erreur si le fichier n'existe pas
				} else { TraceError( "FileProcess" , "NouveauFichier" , 
									 [ "Le fichier \"" + Nom + "\" n'existe pas dans le groupe \"" + Groupe + "\"." ] ); }
			
			// Trace une erreur si le groupe n'existe pas
			} else { TraceError( "FileProcess" , "NouveauFichier" , 
								 [ "Le groupe \"" + Groupe + "\" n'existe pas." ] ); }
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 FLASH					  		  					  */
		/*										   Chargement de fichier Swf 					  				  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - LOAD - - —————————————————————————————————————————— */
		// Méthodes pour lancer le chargement de scène Flash
		//*—*//
		
		// —————— SWF LOAD
	  	// Lance le chargement d'un fichier flash
		
		public function SWFLoad( Lien:String ,				// ———— - - Le Lien du swf
								 Conteneur:* , 				// ———— - - Le Conteneur du swf
								 Parametres:Object = null	// ———— - - Les Parametres du chargement
								):void {
			/*—*/
					
			/* —— - - ARGUMENTS - - —— */
			/**/
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			
			// Récupère les parametres
			var Racine:* = Parametres.root || Conteneur.root;
			var Transmission:Object = Parametres.value;
			var Liaison:Boolean = ( Parametres.link != null ) ? Parametres.link : true;
			var Remplace:Boolean = ( Parametres.replace != null ) ? Parametres.replace : true;
			
			// Ajoute l'extension s'il n'y a pas de lien "swf" 
			Lien = ConcatUnicite( Lien , ".swf" );
				
				
			// S'il ne contient pas déjà de scène —— - -
			if( Conteneur.SceneChargee != Lien ){
					
					
				/* —— - - REMPLACEMENT - - —— */
				/**/
				
				// S'il remplace —— - -
				if( Remplace ){
					
					// Et qu'il a déjà reçu un Chargeur —— - -
					if( Conteneur.Chargeur ){
						
						// Il le décharge
						SWFUnload( Conteneur );
					}
				}
					
					
				/* —— - - LIEN - - —— */
				/**/
				
				// Création du chargeur et de l'objet
				Conteneur.Chargeur = new Loader();
				Conteneur.SceneChargee = Lien;
				Conteneur.Biblio = Parametres.Biblio;
				Conteneur.autoKill = Parametres.autoKill;
				
				// Place l'URL à atteindre
				var Requete:URLRequest = new URLRequest( Lien );
					
					
				/* —— - - CHARGEMENT - - —— */
				/**/
				
				// Si on a demandé un transfert de Classe ou une biblio —— - -
				if( Parametres.Transfert || Parametres.Biblio ){
					
					// Créait les méthodes de transfert
					var Domaine:ApplicationDomain = ApplicationDomain.currentDomain; 
					var Contexte:LoaderContext = new LoaderContext( false , Domaine ); 
				
					// Lance le chargement du contenu en contexte
					Conteneur.Chargeur.load( Requete , Contexte );
				
				// Si l'on a pas demandé de transfert de Classe —— - -
				} else {
				
					// Lance le chargement du contenu simplement
					Conteneur.Chargeur.load( Requete );
				}
					
					
				/* —— - - AFFICHAGE - - —— */
				/**/
				
				// Affichage de l'élément chargé
				Conteneur.addChild( Conteneur.Chargeur );
				
				// Donne les paramètres au conteneur
				Conteneur.Root = Racine;
				Conteneur.Transmission = Transmission;
				Conteneur.LinkParametres = Parametres;
					
					
				/* —— - - SUPPORT - - —— */
				/**/
				
				// Si on doit créer une liaison
				if( Liaison ){
				
					// Donne l'événement de fin de chargement
					Conteneur.Chargeur.contentLoaderInfo.addEventListener ( Event.COMPLETE, SWFLoad_End );
				}
				
				// Créait un nouveau support pour ce chargement
				var NouveauSupport:Object = new Object();
				//
				// Donne les valeurs au support
				NouveauSupport.Conteneur = Conteneur;
					
					
				/* —— - - CONTROL - - —— */
				/**/
				
				// Si on a donné une barre de chargement —— - -
				if( Parametres.loadClip ){
					
					// Calibre le loadMode
					Parametres.loadMode = Parametres.loadMode || "horizontal";
					
					// Donne la fonction de la barre de chargement comme étant celle à lancer pendant le chargement
					NouveauSupport.Conteneur.LinkParametres.fonctionLoad = LoadControl;
					
					// Lance une première fois la fonction pour calibrer la barre
					Launch( NouveauSupport.Conteneur.LinkParametres.fonctionLoad , 
						  { Parametres:NouveauSupport.Conteneur.LinkParametres ,
						    Pourcentage:0 } );
					
				// Si on n'a donné que le mode de chargement —— - - Trace l'erreur 
				} else if( Parametres.loadMode ){
					//
					TraceError( "FileProcess" , "SWFLoad" , 
								"Vous devez indiquer un loadClip si vous donnez un loadMode." );
				}
				
				
				// Fonction du support quand le chargement échoue —— - -
				NouveauSupport.FlashEchoueChargement = function( event:Event ):void {

					// Si on a donné une méthode d'erreur —— - -
					if( NouveauSupport.Conteneur.LinkParametres.fonctionError ){
						//
						// Lance la méthode d'erreur
						Launch( NouveauSupport.Conteneur.LinkParametres.fonctionError );
						
					// Si on n'a donné aucune méthode d'erreur —— - - Trace l'erreur
					} else {
						//
						TraceError( "FileProcesse" , "SWFLoad" , 
									 "Le flash «" + Lien + "» est introuvable ou non compatible." );
					}
				}
				
				
				// Fonction du support quand le flash se charge —— - -
				NouveauSupport.FlashCharge = function( event:ProgressEvent ):void {
					
					// Lance la fonction de chargement en y ajoutant l'argument du pourcentage chargé
					Launch( NouveauSupport.Conteneur.LinkParametres.fonctionLoad , 
						  { Parametres:NouveauSupport.Conteneur.LinkParametres ,
						    Pourcentage:( event.bytesLoaded / event.bytesTotal ) * 100 } );
				}
				
				
				// Donne l'événement d'erreur de chargement
				AddEvents( Conteneur.Chargeur.contentLoaderInfo , NouveauSupport.FlashEchoueChargement , "IO_ERROR" );
				
				// Donne l'événement de progression de chargement
				AddEvents( Conteneur.Chargeur.contentLoaderInfo , NouveauSupport.FlashCharge , "PROGRESS" );
			}
		}
		//
		// —————— SWF LOAD - END
		// À la fin du chargement d'un swf
		private function SWFLoad_End( event:Event ):void {
			/*—*/
			
			/* —— - - VARIABLE - - —— */
			/**/
			
			// Récupére l'instance des info du chargeur et l'instance de la scène chargée
			var Info:LoaderInfo = LoaderInfo ( event.target );
			var Contenu:DisplayObject = Info.content;
			var leConteneur:* = ( Contenu.root.parent.parent as MovieClip );
			
			
			/* —— - - RACINE - - —— */
			/**/
			
			// S'il y a une racine —— - -
			if( leConteneur.Root ){
			
				// Donne à la scène chargée la racine voulue et l'instance de son contenu
				( Contenu as MovieClip ).Root = leConteneur.Root;
				TotalSet( ( Contenu as MovieClip ) , "Root" , leConteneur.Root );
			}
			//
			leConteneur.Root = ( Contenu as MovieClip );
			
			// S'il y a une racine de scène au conteneur —— - -
			if( leConteneur.root ){
				
				// Lui donne son tableau de scenes chargées —— - -
				if( !( leConteneur.root as MovieClip ).FileProcessScene ){
					//
					( leConteneur.root as MovieClip ).FileProcessScene = new Array();
				}
			
				// Ajoute cette scène
				PushUnicite( ( leConteneur.root as MovieClip ).FileProcessScene , leConteneur );
			}
			
			
			/* —— - - BIBLIO - - —— */
			/**/

			// S'il y a une demande de transfert de biblio —— - -
			if( leConteneur.Biblio ){
				
				// S'il contient un tableau de liste —— - -
				if( ( Contenu as MovieClip ).Liste ){
					
					// Pour chaque élément de la liste —— - -
					for( var iListe:int = 0 ; iListe < ( Contenu as MovieClip ).Liste.length ; iListe++ ){
						
						// L'ajoute à la biblio
						leConteneur.Biblio[ Pop( String( ( Contenu as MovieClip ).Liste[ iListe ] ) , [ "[class " , "]" ] ) ] = 
											( Contenu as MovieClip ).Liste[ iListe ];
					}
				}
			}
			
			
			/* —— - - FIN DE CHARGEMENT - - —— */
			/**/
			
			// Lance la fonction de fin de chargement
			Launch( leConteneur.LinkParametres.fonctionEnd );
			
			
			/* —— - - TRANSMISSION - - —— */
			/**/
			
			// Transmet les variables
			var Transmet:Object = leConteneur.Transmission || new Object();
			//
			// Pour chaque variables —— - -
			for( var iTransmet:* in Transmet ){
				
				// Non-Absolut —— - -
				if( !FindIn( iTransmet , "Absolut_" ) ){
					
					// Donne la variable à la scène au nom voulu
					( Contenu as MovieClip )[ iTransmet ] = Transmet[ iTransmet ];
				
				// Absolut —— - -
				} else {
					
					// Donne la variable à la scène en absolut
					TotalSet( ( Contenu as MovieClip ) , Pop( iTransmet , "Absolut_" ) , Transmet[ iTransmet ] );
				}
			}
			
			
			/* —— - - CONCLUSION - - —— */
			/**/
			
			// S'il doit s'auto-détruire —— - -
			if( leConteneur.autoKill ){
				
				// Il se décharge
				SWFUnload( leConteneur );
			
			// S'il n'y a pas de demande de transfert de biblio —— - -
			} else {
			
				// Lance sa fonction Start() s'il en a une
				if( ( Contenu as MovieClip ).Start ){
					//
					( Contenu as MovieClip ).Start(); 
				}
			}
		}
		
		
		// —————— SWF LIBRARY LOAD
	  	// Lance le chargement d'un fichier flash uniquement pour en récupérer son contenu de Class
		
		public function SWFLibraryLoad( Lien:String ,			// ———— - - Le Lien du swf
									    Parametres:* = null 	// ———— - - Les Parametres
									  ):void {
			/*—*/
			
			// Créait le conteneur
			var Conteneur:* = new MovieClip();
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			
			// Lance le chargement du flash avec ses particularités
			SWFLoad( Lien , Conteneur , { replace:false , 
										  fonctionEnd:Parametres.fonction || Parametres.fonctionEnd , 
										  Biblio:Parametres.library , 
										  Transfert:true , 
										  fonctionError:Parametres.fonctionError ,
										  autoKill:true } );
		}
		
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Les méthodes pour modifier un élément flash chargé
		//*—*//
		
		// —————— SWF UNLOAD
	  	// Décharge un fichier flash
		
		public function SWFUnload( Conteneur:* 	// ———— - - Le Conteneur de la scène flash
									  ):void {
			/*—*/
			
			// S'il contient un Chargeur —— - -
			if( Conteneur.Chargeur ){
				
			
				/* —— - - SCENES - - —— */
				/**/
					
				// S'il contient des scènes —— - -
				if( Conteneur.Root.FileProcessScene ){
					
					// Pour chaque scène que contient ce conteneur —— - -
					for( var i:int = 0 ; i < Conteneur.Root.FileProcessScene.length ; i++ ){
						//
						SWFUnload( Conteneur.Root.FileProcessScene[ i ] );
					}
				}
				
				
				/* —— - - ANIMATION - - —— */
				/**/
				
				// Il lui applique un stop total
				TotalStop( Conteneur.Root );
				
				
				/* —— - - ÉVENEMENT - - —— */
				/**/
				
				// Si la racine possède un tableau drOIde —— - -
				if( Conteneur.Root.drOIdeScriptList ){
					
					// Lance le rafraichissement
					TotalRefreshAllEvents( Conteneur.Root.drOIdeScriptList );
				}
				
				
				/* —— - - INTERRUPTION - - —— */
				/**/
				
				// Il cache le tout
				Conteneur.Root.visible = false;
				
				// Il lui coupe tout les sons s'il a un EchoTools
				TotalLaunch( Conteneur.Root , { Fonction:"StopSound" , Element:"Sound" } );
				
				// Lance sa fonction End() s'il en a une
				if( Conteneur.Root.End ){ 
					//
					Conteneur.Root.End(); 
				}
				
				
				/* —— - - DECHARGEMENT - - —— */
				/**/
				
				// Il le décharge
				Conteneur.removeChild( Conteneur.Chargeur );
				Conteneur.Chargeur.unload(); 
				Conteneur.Chargeur = null;
				Conteneur.SceneChargee = null;
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 BITMAP					  		  					  */
		/*											   Chargement d'image 					  					  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - LOAD - - —————————————————————————————————————————— */
		// Méthodes pour lancer le chargement d'images
		//*—*//
		
		// —————— BITMAP LOAD
	  	// Lance le chargement d'une image
		
		public function BitmapLoad(	Lien:String , 					// ———— - - Le Lien de l'image
								    Conteneur:* , 					// ———— - - Le Conteneur de l'image
									Parametres:Object = null		// ———— - - Les Parametres additifs
								  ):void {
			/*—*/
			
			/* —— - - VARIABLES - - —— */
			/**/
			
			// Récupération des parametres
			var Nom:String = Parametres.name || "";
			var Taille:* = Parametres.size || "100%";
			var FonctionFin:* = Parametres.fonction || Parametres.fonctionEnd;
			var FonctionErreur:* = Parametres.fonctionError;
			var Extension:int = Parametres.extension || 0;
			
			// Définie s'il y a une précision d'extension —— - -
			var ExtensionPrecise:Boolean = ( Lien.split( "." )[ Lien.split( "." ).length - 1 ].length <= 4 );
			
			// Argument par défaut
			Nom = ( Nom != "" ) ? Nom : Lien.split( "/" )[ Lien.split( "/" ).length - 1 ];
			Parametres = Parametres || new Object();
			
			// Récupération des parametres
			Conteneur.LinkParametres = Parametres;
			
			
			/* —— - - CHARGEMENT - - —— */
			/**/
			
			// Création du conteneur de l'image
			var NouvelleImage:Loader = new Loader();
			
			// Lance la requête
			var URLImage:URLRequest = new URLRequest( Lien + ( ( ExtensionPrecise ) ? "" : "." + ExtensionList.Bitmap[ Extension ] ) );
			
			// S'il a un pré-chargeur —— - -
			if( Parametres.Chargeur ){
				//
				// Désintégre le précédent chargeur
				if( Conteneur.Chargeur ){
					//
					Conteneur.Chargeur.Disparition = null;
					DestroyElement( Conteneur.Chargeur );
				}
				//
				// Intégre le pré-chargeur
				NewElement( Parametres.Chargeur.Class , Conteneur , "Chargeur" , Parametres.Chargeur );
			}
			
			
			/* —— - - GESTION - - —— */
			/**/
			
			// Créait l'objet de gestion
			var Gestion:Object = new Object();
			//
			// Lui donne sa fonction de gestion erreur —— - -
			Gestion.Fin = function( event:Event ):void {
				
				// Récupére l'instance de cible
				var Cible:* = event.target;
				
				// Si on est en mode "Remplace" et que le conteneur possède déjà un clip du même nom que l'image —— - -
				if( Parametres.Remplace && Conteneur[ Nom ] ){
					//
					// Détruit l'image en place
					DestroyElement( Conteneur[ Nom ] );
				}
				
				// Créait un clip contenant l'image
				NewElement( MovieClip , Conteneur , Nom );
				LastView( Conteneur[ Nom ] );
				
				// Affiche le conteneur
				Conteneur[ Nom ].addChild( NouvelleImage );
				
				// S'il y a un Chargeur —— - - Le détruit
				if( Conteneur.Chargeur ){ DestroyElement( Conteneur.Chargeur ); }
				
				// Modifie sa taille
				//
				// Si elle est un chiffre —— - - Lui donne cette taille
				if( TypeOf( Taille , "Number" ) ){
					//
					ProRataSizeBy( Conteneur[ Nom ] , Taille , "Min" );
					
				// Sinon, si elle contient "%" —— - - Modifie sa taille en pourcentage
				} else if( FindIn( Taille , "%" ) ){
					//
					ProRataSize( Conteneur[ Nom ] , Conteneur[ Nom ].width * ( Number( Pop( Taille , "%" ) ) / 100 ) );
				}
				
				// Modifie sa position
				//
				// Si elle possède une modification de position —— - -
				if( Parametres.Position ){
					
					// Si elle possède une modification de position horizontale —— - -
					if( Parametres.Position.x ){
						
						// Recalibre sa position en proportionnelle à sa taille
						Conteneur[ Nom ].x = Conteneur[ Nom ].width * ( Parametres.Position.x / -100 );
					}
					
					// Si elle possède une modification de position verticale —— - -
					if( Parametres.Position.y ){
						
						// Recalibre sa position en proportionnelle à sa taille
						Conteneur[ Nom ].y = Conteneur[ Nom ].height * ( Parametres.Position.y / -100 );
					}
				}
				
				// Lance la fonction de fin
				Launch( FonctionFin );
			}
			
			
			/* —— - - ERREUR - - —— */
			/**/
			
			// Lui donne sa fonction de gestion erreur —— - -
			Gestion.Erreur = function( event:IOErrorEvent ):void {
				
				// Récupére l'instance de cible
				var Cible:* = event.target;
				
				// Si on n'a pas encore essayé toutes les extensions —— - -
				if( ExtensionList.Bitmap.length > Extension && !ExtensionPrecise ){
					
					// Ajoute le Support au parametres
					Parametres.Support = NouveauSupport;
					
					// Modifie l'extension
					Parametres.extension = Extension + 1;
					
					// Lance un chargement par une autre extension
					BitmapLoad( Conteneur , Lien , Parametres );
					
				// Sinon —— - - 
				} else {
					
					//Trace l'erreur
					TraceError( "FileProcess" , "BitmapLoad" , "L'image «" + Lien + "» est introuvable." );
				
					// Lance la fonction d'ereur
					Launch( FonctionErreur );
				}
			}
			
			
			/* —— - - LOADING - - —— */
			/**/
			
			// Variable de support
			var NouveauSupport:Object;
			
			// S'il n'y a pas eu de support transmis —— - -
			if( !Parametres.Support ){
			
				// Créait un nouveau support pour ce chargement
				NouveauSupport = new Object();
				NouveauSupport.Mot = NouveauSupport.Mot || RandomWord();
				//
				// Donne les valeurs au support
				NouveauSupport.Conteneur = Conteneur;
				//
				// Si on a donné une barre de chargement et un mode de chargement —— - -
				if( Parametres.BarreChargement && Parametres.ModeChargement ){
					
					// Lance la méthode de calibrage de la barre de chargement
					this[ "LoadBarre" + Parametres.ModeChargement ]( Parametres.BarreChargement , NouveauSupport.Conteneur.LinkParametres.Charge );
					//
					// Donne la fonction de la barre de chargement comme étant celle à lancer pendant le chargement
					NouveauSupport.Conteneur.LinkParametres.Charge = Parametres.BarreChargement.Chargement;
					
				// Si on n'a donné que la barre de chargement —— - - Trace l'erreur 
				} else if( Parametres.BarreChargement ){
					//
					TraceError( "FileProcess" , "BitmapLoad" , 
								 "Vous devez indiquer un «ModeChargement» si vous donnez une Barre de chargement." );
					
				// Si on n'a donné que le mode de chargement —— - - Trace l'erreur
				} else if( Parametres.ModeChargement ){
					//
					TraceError( "FileProcess" , "BitmapLoad" , 
								 "Vous devez indiquer un «BarreChargement» si vous donnez un Mode de chargement." );
				}
					
					
				// Fonction du support quand le flash se charge —— - -
				NouveauSupport.FlashCharge = function( event:ProgressEvent ):void {
					
					// Lance la fonction pour calibrer la barre
					Launch( NouveauSupport.Conteneur.LinkParametres.fonctionLoad , 
						  { Parametres:NouveauSupport.Conteneur.LinkParametres ,
						    Pourcentage:( event.bytesLoaded / event.bytesTotal ) * 100 } );
				}
				
				
				// Si on a donné une barre de chargement et un mode de chargement —— - -
				if( Parametres.loadClip ){
					
					// Calibre le loadMode
					Parametres.loadMode = Parametres.loadMode || "horizontal";
					
					// Donne la fonction de la barre de chargement comme étant celle à lancer pendant le chargement
					Parametres.fonctionLoad = LoadControl;
					
					// Lance une première fois la fonction pour calibrer la barre
					Launch( NouveauSupport.Conteneur.LinkParametres.fonctionLoad , 
						  { Parametres:NouveauSupport.Conteneur.LinkParametres ,
						    Pourcentage:0 } );
					
				// Si on n'a donné que le mode de chargement —— - - Trace l'erreur 
				} else if( Parametres.loadMode ){
					//
					TraceError( "FileProcess" , "BitmapLoad" , 
								"Vous devez indiquer un loadClip si vous donnez un loadMode." );
				}
				
				
			// s'il y a déjà une variable de support —— - - La transmet
			} else { NouveauSupport = Parametres.Support; }
			
			
			/* —— - - LANCEMENT - - —— */
			/**/
			
			// Lui donne ses événements
			AddEvents( NouvelleImage.contentLoaderInfo , Gestion.Fin , "COMPLETE" );
			AddEvents( NouvelleImage.contentLoaderInfo , Gestion.Erreur , "IO_ERROR" );
			AddEvents( NouvelleImage.contentLoaderInfo , NouveauSupport.FlashCharge , "PROGRESS" );
			
			// Lance le chargement
			NouvelleImage.load( URLImage );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					LOADING					  		  					  */
		/*						Contrôle du chargement en cours et retour visuel de ce dernier 					  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - CONTROL - - —————————————————————————————————————————— */
		// Les méthodes effectuant le contrôle de chargement en court
		//*—*//
		
		// —————— LOAD CONTROL
	  	// Control un chargement et applique son résultat à un élément visuel
		
		public function LoadControl( Data:*	// ———— - - Les Données de chargement
									):void {
			/*—*/
					
			/* —— - - HORIZONTAL - - —— */
			/**/
			
			// Si on est en mode horizontal —— - -
			if( Data.Parametres.loadMode == "horizontal" ){
				
				// Donne au clip ses valeurs initiales
				Data.Parametres.loadClip.InitialSize = Data.Parametres.loadClip.InitialSize || Data.Parametres.loadClip.width;
					
				// Elle grandit
				Data.Parametres.loadClip.width = Data.Parametres.loadClip.InitialSize * Data.Pourcentage / 100;
			}
			
					
			/* —— - - VERTICAL - - —— */
			/**/
			
			// Si on est en mode vertical —— - -
			else if( Data.Parametres.loadMode == "vertical" ){
				
				// Donne au clip ses valeurs initiales
				Data.Parametres.loadClip.InitialSize = Data.Parametres.loadClip.InitialSize || Data.Parametres.loadClip.height;
				
				// Elle grandit
				Data.Parametres.loadClip.height = Data.Parametres.loadClip.InitialSize * Data.Pourcentage / 100;
			}
				
				
			/* —— - - ROTATION - - —— */
			/**/
			
			// Si on est en mode rotation —— - -
			else if( Data.Parametres.loadMode == "rotation" ){
					
				// Elle grandit
				Data.Parametres.loadClip.rotation = 360 * Data.Pourcentage / 100;
			}
				
				
			/* —— - - FRAME - - —— */
			/**/
			
			// Si on est en mode frame —— - -
			else if( Data.Parametres.loadMode == "frame" ){
					
				// Elle grandit
				Data.Parametres.loadClip.gotoAndStop( Math.round( Data.Parametres.loadClip.totalFrames * Data.Pourcentage / 100 ) );
			}
		}
		
		
		
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}