﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			PAPER TOOLS	  			Version 0.3.0									***/
/***				   				   Dernière mise à jour le 10-09-07										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         				     Liaison XML												***/
/***	Ce script établit la connection avec des fichiers de code de type bloc-note tel que les fichiers	***/
/***	Xml. Il les interprètes de différentes façon selon les circonstances.								***/
/***	Il permet également d'envoyer des ensembles de chaine pour reconstruire un Xml à partir de données  ***/
/***	Objets.																								***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Link {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	 
	// —— - - DISPLAY
	import flash.display.MovieClip;
	//
	// —— - - NET
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequest;
	import flash.net.URLVariables;
	import flash.net.URLRequestMethod;
	import flash.net.FileFilter;
	import flash.net.FileReference;
	import flash.net.FileReferenceList;
	//
	// —— - - EVENT
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.HTTPStatusEvent;
	import flash.events.IOErrorEvent;
	import flash.events.DataEvent;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class PaperTools extends MiscTools {
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function PaperTools( TheLink:* = null		// ———— - - Lien vers la scène
								 ):void {
			/*—*/
			
			// Établit la connexion
			Connexion( TheLink );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 XML					  		  					  */
		/*										 Récupérations de contenu XML 					  				  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - LINK - - —————————————————————————————————————————— */
		// Les méthodes pour établir la connexion avec des fichiers Xml ou des éléments générant du Xml
		//*—*//
		
		// —————— XML LOAD
		// Lance le chargement d'un fichier Xml en y intégrant des appels de fonctions 
		// choisies lors d'événements due au chargement.
	  
		public function XMLLoad( Lien:String ,				// ———— - - Lien du Xml
								 Parametres:Object = null	// ———— - - Parametres additifs
							   ):void {
			/*—*/
			
			/* —— - - VARIABLES - - —— */
			/**/
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			
			// Compile le lien
			Lien = ConcatUnicite( Lien , ".xml" , [ ".xml" , ".php" , ".txt" ] );
			
			// Fonction de fin de chargement —— - -
			var FonctionLoad:Function = function( event:Event ):void {
				
				// Si on a précisé un Post —— - -
				if( Post ){
					
					// Récupère le contenu
					var ContenuXML:* = event.target.data;
					
					// Compile le contenu suivant la demande —— - -
					if( Compilation == "Object" ){
						//
						ContenuXML = XMLToObject( ContenuXML );
						//
					} else if( Compilation == "Array" ){
						//
						ContenuXML = XMLToArray( ContenuXML );
					}
					
					// Retourne le contenu du Xml à la fonction
					Launch( Post , [ ContenuXML ] );
				
				// Si on a rien précisé —— - - Trace l'erreur
				} else {
					//
					TraceError( "PaperTools" , "XMLLoad" , [ "Le fichier XML du lien " + Lien + " a été chargé correctement" ,
														    "mais vous n'avez précisez aucune fonction de retour pour le transmettre." ] );
				}
			}
			
			// Fonction d'erreur par défaut —— - -
			var FonctionError:Function = function():void {
				
				// Trace l'erreur
				TraceError( "PaperTools" , "XMLLoad" , [ "Impossible de charger le fichier XML au lien : " , Lien ] );
			}
			
			// Variables
			var Post:* = null;
			var Erreur:* = null;
			
			// Switch des arguments
			if( !TypeOf( Parametres , "Object" ) ){
				//
				Post = Parametres;
				Parametres = new Object();
				//
			} else if( Parametres.Fonction ){
				//
				Post = Parametres;
				Parametres = new Object();
			}
			
			// Argumentaire par défaut des valeurs Post et Erreur
			Post = Post || Parametres.fonction || Parametres.fonctionEnd;
			Erreur = Parametres.fonctionError || FonctionError;
			
			// Définit le type de compilation
			var Compilation:String = ( Parametres.compilation == null ) ? "Object" : Parametres.compilation;
			
			// Initialise la variable Chargeur permettant de récupérer corectemet le fichier Xml
			var Chargeur = new URLLoader();
			Chargeur.dataFormat = URLLoaderDataFormat.TEXT;
			
			
			/* —— - - EVENEMENTS - - —— */
			/**/
			
			// Evénement de fin de chargement
			AddEvents( Chargeur , FonctionLoad , "COMPLETE" );
			
			// Événement d'erreur
			AddEvents( Chargeur , FonctionError , "IO_ERROR" );
			
			
			/* —— - - CHARGEMENT - - —— */
			/**/
			
			// Variable de Date pour éviter la mise en cache du Xml
			var dateCourante:Date = new Date();
			
			// Lance le chargement du fichier Xml
			Chargeur.load ( new URLRequest ( Lien + 
											( ( Parametres.noCache ) ? "?uniq=" + dateCourante.getTime() : "" ) ) );
		}
		
		

		
		
	//——————————> Fin de Class
	}
	
	
//——————————> Fin de Package
}