﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			 SOFTWARE FACTORY	  	Version 0.1.0									***/
/***				   				   Dernière Mise à Jour : 10-08-14										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         				  Assemblage Interactif											***/
/***	Ce script facilite se base sur la mise en scène logiciel par le biais de communication Xml.		    ***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Link {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	
	// —— - - DISPLAY
	import flash.display.MovieClip;
	//
	// —— - - EVENT
	import flash.events.Event;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	import drOIde.Link.FileProcess;
	import drOIde.Media.SoundProcess;
	import drOIde.Link.PaperTools;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class SoftwareFactory extends MiscTools {
		
		
		
		
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		// —————— LINK
		// Les liaisons aux autres scripts
		private var Paper:PaperTools;
		private var File:FileProcess;
		private var Sound:SoundProcess;
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function SoftwareFactory( TheLink:* = null		// ———— - - Lien vers la scène
									  ):void {
			/*—*/
			
			// Établit la connexion
			Connexion( TheLink );
			
			// Active les scripts
			Paper = new PaperTools( TheLink );
			File = new FileProcess( TheLink );
			Sound = new SoundProcess( TheLink );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 SCENNING					  		  				  */
		/*									 Assemble des scènes flashs bout à bout 							  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Sauvegarde et application des données
		//*—*//
		
		// —————— BUILD SCENE
		// Lance la mise en scenning
		
		public function BuildScene( LienXml:String ,			// ———— - - Le Fichier Xml indiquant les détails
								    Conteneur:* ,			// ———— - - Le Conteneur de la scène
								    Fonction:Object = null ,	// ———— - - La Fonction à lancer à la fin du chargement
								    Parametres:* = null		// ———— - - Les Parametres supplémentaires
								 ):void {
			/*—*/
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			
			// Définit la scène en cour du conteneur
			Conteneur.SceneEnCour = 0;
			Conteneur.Fonction = Fonction;
			Conteneur.ScenesTotales = 0;
			//
			Conteneur.Sound = new SoundProcess();
				
			// Lance la lecture du fichier Xml
			Paper.XMLLoad( LienXml ,
						   {
							   fonctionEnd:{ Fonction:BuildScene_Step2 , 
											 Argument:{ Fonction:Fonction , 
											 			Conteneur:Conteneur } ,
							   fonctionError:Parametres.fonctionError
						   } } );
		}
		//
		// —————— BUILD SCENE - STEP 2
		// Etape N°2 de la mise en scenning après récupération des données         									 	
		public function BuildScene_Step2( Objet:Object ,	// ———— - - L'Objet Xml
										  Elements:Object	// ———— - - Le Clip conteneur
									  ):void {
			/*—*/
			
			// Fonction de transition sur le conteneur des scénes —— - -
			Elements.Conteneur.Transition = function():void {
				
				// Lance la transition pour la scène suivante
				Scene_Transition( Elements.Conteneur );
			};
			
			// Fonction de final d'un son possédant une action sur la scène en cour —— - -
			Elements.Conteneur.FinDuSon = function( Fonction:String ):void {
				
				// Lance la fonction sur la scène en cour
				Elements.Conteneur.Root[ Fonction ]();
			}
			
			// Pour chaque scénes —— - -
			for( var Scenes:* in Objet ){
				
				// Si ce n'est ni un parametres ni du contenu —— - -
				if( Scenes != "Parametres" && Scenes != "Contenu" ){
					
					// Augmente le nombre de scénes
					Elements.Conteneur.ScenesTotales++;
					
					// S'il y a un son relié —— - -
					if( Objet[ Scenes ].Parametres.Son ){
						
						// Ajoute le son relié
						Elements.Conteneur.Sound.NouveauSon( "Scenning" , Scenes , String( Objet[ Scenes ].Parametres.Son ) , 
																				( Objet[ Scenes ].Parametres.SonFin ) ? 
																			  { ActionFin:{ Fonction:"FinDuSon" , 
																				Cible:Elements.Conteneur ,
																				Argument:Objet[ Scenes ].Parametres.SonFin
																				} } : {} );
					}
					
					// Pour chaque élément à l'intérieur —— - -
					for( var Interieur:* in Objet[ Scenes ] ){
						
						// Si ce n'est ni un parametre ni du contenu —— - -
						if( Interieur != "Parametres" && Interieur != "Contenu" ){
							
							// S'il y a un son —— - -
							if( Objet[ Scenes ][ Interieur ].Parametres.Son  ){
								
								// Ajoute ce son
								Elements.Conteneur.Sound.NouveauSon( "Scenning" , Interieur , String( Objet[ Scenes ][ Interieur ].Parametres.Son ) , 
														( Objet[ Scenes ][ Interieur ].Parametres.Fin ) ? 
														{ ActionFin:{ Fonction:"FinDuSon" , 
														  Cible:Elements.Conteneur ,
														  Argument:Objet[ Scenes ][ Interieur ].Parametres.Fin
														} } : {} );
							}
						}
					}
					
					// Archive le chargement de cette scène
					File.NewFile( "Scenning" , 
										 Scenes , 
										 "Flash" , 
										 Objet[ Scenes ].Parametres.Lien , 
										 Elements.Conteneur , 
										 { value:[ [ "Sound" , Elements.Conteneur.Sound ] , 
												   [ "Transition" , Elements.Conteneur.Transition ] ] } );
				}
			}
			
			// Lance la première transition du conteneur
			Elements.Conteneur.Transition();
		}
		//
		// —————— SCENE TRANSITION - STEP 2
		// Provoque une transition de scene
		public function Scene_Transition( Conteneur:*		// ———— - - Le Clip conteneur
										 ):void {
			/*—*/
			
			// Si la scène en cour est la dernière —— - -
			if( Conteneur.SceneEnCour == Conteneur.ScenesTotales ){
				
				// Décharge le flash
				File.SWFUnload( Conteneur );
				
				// Lance la fonction finale
				Launch( Conteneur.Fonction );
				
			// Si la scène en cour n'est pas la dernière —— - -
			} else {
				
				// Passe à la scène suivante
				Conteneur.SceneEnCour++;
				
				// Charge la scène suivante
				File.LoadFile( "Scenning" , "Scene" + Conteneur.SceneEnCour );
				
				// Essaye de lancer le son s'il y en a un
				try { Conteneur.Sound.JoueSon( "Scenning" , "Scene" + Conteneur.SceneEnCour ); } catch( e ){}
			}
		}
		
		  
		  
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}