﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			  SCENE FACTORY	  	  Version 0.3.0										***/
/***				   				   Dernière Mise à Jour : 10-08-28										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         				  Assemblage Animation											***/
/***	  Ce script permet de réaliser des assemblages complexes orientés vers l'animation et la vidéo.	    ***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Media {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*—*/
	
	// —— - - DISPLAY
	import flash.display.MovieClip;
	import flash.display.Shape;
	//
	// —— - - EVENT
	import flash.events.Event;
	import flash.events.MouseEvent;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	import drOIde.Media.SoundProcess;
	import drOIde.Visual.FxTools;
	import drOIde.Visual.FilterTools;
	import drOIde.Link.FileProcess;
	import drOIde.Link.PaperTools;
	import drOIde.Media.VideoProcess;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class SceneFactory extends MiscTools {
		
		
		
		
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		// —————— LINK
		// Les liaisons aux autres scripts
		private var Sound:SoundProcess;
		private var Fx:FxTools;
		private var Filter:FilterTools;
		private var File:FileProcess;
		private var Paper:PaperTools;
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function SceneFactory( TheLink:* = null		// ———— - - Lien vers la scène
									 ):void {
			/*—*/
			
			// Établit la connexion
			Connexion( TheLink );
			
			// Active les scripts
			Sound = new SoundProcess( TheLink );
			Fx = new FxTools( TheLink );
			Filter = new FilterTools( TheLink );
			File = new FileProcess( TheLink );
			Paper = new PaperTools( TheLink );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				PICTURES & SOUND 					  		  			  */
		/*						   Méthodes d'assemblage découlant de l'union images + sons 					  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - SLIDE - - —————————————————————————————————————————— */
		// Méthodes pour générer un diapositif d'images
		/*—*/
		
		// —————— BUILD SLIDE
		// Lance la mise en place du diapositif
		
		public function BuildSlide( LienXml:String ,		// ———— - - Le Fichier Xml indiquant les détails
								    Conteneur:* ,			// ———— - - Le Clip conteneur
									Parametres:* = null		// ———— - - Les Parametres supplémentaires
								   ):* {
			/*—*/
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			
			// Créait le conteneur du diapo
			var ConteneurDiapo:* = NewElement( MovieClip , Conteneur , "Diapositif" );
			
			// Donne les arguments au conteneur
			ConteneurDiapo.FonctionDeFin = Parametres.fonctionEnd;
			ConteneurDiapo.FonctionTransition = Parametres.fonctionTransition;
			//
			ConteneurDiapo.Parametres = Parametres;
			
			// Donne l'instance de l'SoundProcess au conteneur ( Principalement pour que le déchargement coupe les sons )
			Conteneur.Sound = Sound;
			
			// Lance la lecture du fichier Xml
			Paper.XMLLoad( LienXml ,
							{
								fonctionEnd:{
												Fonction:BuildSlide_Step2 ,
												Argument:ConteneurDiapo
											}
							}
						  );
			
			// Retourne le conteneur diapo
			return ConteneurDiapo;
		}
		//
		// —————— BUILD SLIDE - STEP 2
		// Étape N°2 de la mise en place du diapositif après récupération des données
		public function BuildSlide_Step2( Objet:Object ,	// ———— - - L'Objet Xml
										  Conteneur:*		// ———— - - Le Clip conteneur
										  ):void {
			/*—*/
			
			// Récupére le nombre d'image défilant à partir du Xml
			var NombreImages:int = LengthObject( Objet );
			
			// Transmet ses valeurs au conteneur
			Conteneur.ImagesCheckees = 0;
			Conteneur.ImagesMax = NombreImages;
			//
			Conteneur.ImageEnCour = 0;
			
			// Pour chaque image à faire passer —— - -
			for( var i:int = 1 ; i <= NombreImages ; i++ ){
				
				// Récupére l'instance des paramètres de l'image
				var ImageEnCour:* = Objet[ "Image" + i ].Parametres;
				
				// Lance le chargement de l'image
				File.BitmapLoad( Conteneur , ImageEnCour.Image , { name:"Image" + i , 
																   fonctionFin:{ Fonction :"BuildSlide_CheckPicture" , 
																   				 Cible:this , 
																				 Argument:{ Numero:i , Conteneur:Conteneur } } } );
				
				// Lance le chargement du son
				Sound.NewSound( "Diapositif" , "Son" + i , String( ImageEnCour.Son ) , { fonctionEnd:{ Fonction:"ImageSuivante" , 
																					  				   Cible:Conteneur ,
																									   Argument:( ImageEnCour.Pause != null )
																									  } } );
				// Récupére la valeur de la pause
				Conteneur[ "Pause" + i ] = ImageEnCour.Pause;
			}
			// 	
			// Passage à l'image suivante —— - -
			Conteneur.ImageSuivante = function( Pause:Boolean = false ){
				/**/
				
				// Si on n'est pas en pause
				if( !Pause ){
					
					// Interrompt tout les sons
					Sound.StopSound();
					
					// Fait avancer l'image
					Conteneur.ImageEnCour++;
					
					// Si ça n'était pas la dernière —— - -
					if( Conteneur.ImageEnCour <= Conteneur.ImagesMax ){
						
						// Fait apparaître la suivante
						Conteneur[ "Image" + Conteneur.ImageEnCour ].visible = true;
						
						// Lance le son de la suivante
						Sound.PlaySound( "Diapositif" , "Son" + Conteneur.ImageEnCour );
						
					// Si c'était la dernière —— - -
					} else {
						
						// Lance la fonction de fin
						Launch( Conteneur.FonctionDeFin );
						
						// Détruit le conteneur s'il n'y a pas opposition
						if( Conteneur.Parametres.DestructionFin == null || Conteneur.Parametres.DestructionFin ){ DestroyElement( Conteneur ); }
					}
					
					// Si ça n'est pas la première ou la dernière —— - -
					if( Conteneur.ImageEnCour != 1 && Conteneur.ImageEnCour != Conteneur.ImagesMax + 1 ){
						
						// Cache la précédente
						Conteneur[ "Image" + ( Conteneur.ImageEnCour - 1 ) ].visible = false;
						
						// Lance la fonction de transition
						Launch( Conteneur.FonctionTransition );
					}
					
				// Si on est en pause —— - -
				} else {
					
					// Relance cette même fonction sans la pause avec un rebours équivalent à la pause
					CountdownLaunch( Conteneur.ImageSuivante , Conteneur[ "Pause" + Conteneur.ImageEnCour ] );
				}
			}
			//
			// Demande d'interruption —— - -
			Conteneur.InterruptionDiapositif = function( Pause:Boolean = false ){
				/**/
				
				// Interrompt tout les sons
				Sound.StopSound();
				
				// Annihile le diapo
				DestroyElement( Conteneur );
			}
		}
		//
		// —————— BUILD SLIDE - CHECK PICTURE
		// Étape de vérification des images chargées pour lancer le diapositif si toutes les images s'y trouvent
	  	public function BuildSlide_CheckPicture( Objet:* 	// ———— - - L'Objet Diapositif
												 ):void {
			/*—*/
			
			// Récupére l'instance du conteneur
			var Conteneur:* = Objet.Conteneur;
			
			// Cache l'image
			Conteneur[ "Image" + Objet.Numero ].visible = false;
			
			// Augmente le nombre d'image chargée
			Conteneur.ImagesCheckees++;
			
			// Si le nombre d'image chargée est au max —— - -
			if( Conteneur.ImagesCheckees == Conteneur.ImagesMax ){
				
				// Lance le déroulement du diapositif
				Conteneur.ImageSuivante();
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    			   ANIMATION & SOUND 					  		  			  */
		/*					   Méthodes d'assemblage découlant de l'union animation flash + sons 				  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - MOVIE - - —————————————————————————————————————————— */
		// Méthodes pour générer une cinématique possédant plusieurs animations différentes à lancer
		/*—*/
		
		// —————— BUILD MOVIE
		// Lance la mise en place de la cinématique
		
		public function BuildMovie( LienXml:String ,				// ———— - - Le Fichier Xml indiquant les détails
								    Conteneur:* ,					// ———— - - Le Clip conteneur
									Parametres:* = null				// ———— - - Les Parametres supplémentaires
								   ):void {
			/*—*/
			
			// Lance la lecture du fichier Xml
			Paper.XMLLoad( LienXml ,
							{
								Fonction:BuildMovie_Step2 ,
								Argument:{
											Conteneur:Conteneur ,
											Parametres:Parametres
										}
							}
						  );
		}
		//
		// —————— BUILD MOVIE - STEP 2
		// Étape N°2 de la mise en place de la cinématique après récupération des données
		public function BuildMovie_Step2( Objet:Object ,		// ———— - - L'Objet Xml
										  ParametresObject:*	// ———— - - Les Parametres
										):void {
			/*—*/
			
			// Récupère les parametres et le conteneur
			var Conteneur:* = ParametresObject.Conteneur;
			var Parametres:* = ParametresObject.Parametres;
			
			// Objet de sortie
			var Sortie:Object = new Object();
			
			// Récupère et compile la librairie
			var Library:Object = Objet.Library;
			//
			Library.Visual = Library.Visual.Parametres;
			Library.Sound = Library.Sound.Parametres;
			
			// S'il y a une librairie —— - -
			if( Library ){
				
				// Si elle contient des éléments —— - -
				if( LengthObject( Library.Visual ) ){
					
					// Pour chaque cinématique —— - -
					for( var Cinematiques:* in Objet ){
						
						// S'il ne s'agit pas de la librairie —— - -
						if( Cinematiques != "Library" ){
							
							// Créait un clip de cinématique
							var NouvelleCinematique:* = NewElement( MovieClip , Conteneur , Cinematiques );
							
							// Donne à la cinématique son objet d'animation
							NouvelleCinematique.Movie = CloneObject( Objet[ Cinematiques ] );
							
							// Lui créait un clip de chargement
							NewElement( ParametresObject.Parametres.loadingClip || MovieClip , 
										NouvelleCinematique , 
										"Loading" , 
										{ 
											visible:false ,
											positionX:ParametresObject.Parametres.loadingX ,
											positionY:ParametresObject.Parametres.loadingY
										} );
							
							// Lance le traitement de cette cinématique
							BuildMovie_Step3( NouvelleCinematique , Library , Parametres );
							
							// Stock la cinématique dans le tableau de sortie
							Sortie[ Cinematiques ] = NouvelleCinematique;
						}
					}
							
					// Il lance la fonction de fin avec la sortie en argument s'il y en a une —— - -
					if( Parametres.fonction ){
						
						// Avec argument —— - -
						if( TypeOf( Parametres.fonction , "Object" ) ){
							//
							Parametres.fonction.Argument = Sortie;
						}
						
						// Lance la fonction
						Launch( Parametres.fonction );
					}
				
				// Si la Librairie ne contient rien —— - - Trace l'erreur
				} else {
					//
					TraceError( "SceneFactory" , "BuildMovie" , "La Library doit contenir des Visuels." );
				}
			
			// S'il n'y a pas de Librairie —— - - Trace l'erreur
			} else {
				//
				TraceError( "SceneFactory" , "BuildMovie" , "Le fichier Xml doit avoir un noeud \"Library\"." );
			}
		}
		//
		// —————— BUILD MOVIE - STEP 3
		// Étape N°3 de la mise en place de la cinématique, traitement d'une cinématique en individuelle
		public function BuildMovie_Step3( Cinematique:* ,		// ———— - - La Cinématique concernée
										  Library:Object ,		// ———— - - La Librairie
										  ParametresObject:*	// ———— - - Les Parametres
										 ):void {
			/*—*/
			
			/* —— - - VALEURS - - —— */
			/**/
			
			// Objet de cinématiques
			Cinematique.MovieObject = new Object();
			
			// Validitié des chargements
			Cinematique.MovieObject.ActiveVisual = false;
			Cinematique.MovieObject.ActiveSound = false;
			
			// Librairie
			Cinematique.MovieObject.Library = Library;
			
			// Parametres
			Cinematique.MovieObject.Parametres = ParametresObject;
			
			// Tableau des visuels
			Cinematique.MovieObject.Visuels = new Array();
			Cinematique.MovieObject.VisuelsCharges = new Array();
			
			// État d'activité
			Cinematique.Active = false;
			
			
			/* —— - - ORDRE VISUELS - - —— */
			/**/
			
			// Tableau de traitement des visuels
			var VisuelsTraitement:Object = new Object();
			
			// Pour chaque animation —— - -
			for( var iAnimation:* in Cinematique.Movie ){
				
				// Qui n'est pas les parametres —— - -
				if( iAnimation != "Parametres" ){
					
					// Récupère l'animation
					var LAnimation:Object = Cinematique.Movie[ iAnimation ];
					
					// Traite ses paramètres
					LAnimation.Parametres = LAnimation.Parametres || new Object();
					
					// Traite son numéro s'il n'en a pas —— - -
					if( LAnimation.Parametres.Numero == null ){
						//
						LAnimation.Parametres.Numero = NumberInString( iAnimation );
						//
						LAnimation.Parametres.Numero = LAnimation.Parametres.Numero || 1000;
					}
					
					// Pour chaque visuels de l'animation —— - -
					for( var iVisuel:* in LAnimation ){
						
						// Qui n'est pas les parametres —— - -
						if( iVisuel != "Parametres" ){
							
							// Récupère le visuel
							var LeVisuel:Object = LAnimation[ iVisuel ].Parametres;
							
							// S'il existe —— - -
							if( LeVisuel ){
								
								// S'il possède un visuel —— - -
								if( LeVisuel.Visual ){
									
									// Traite son numéro s'il n'en a pas —— - -
									if( LeVisuel.Numero == null ){
										//
										LeVisuel.Numero = NumberInString( iVisuel );
										//
										LeVisuel.Numero = NumberInString( iVisuel ) || 1000;
									}
									
									// Récupère les deux numéro
									var NumeroAnimation:Number = ( iAnimation == "Default" ) ? -100 : LAnimation.Parametres.Numero;
									var NumeroVisuel:Number = LeVisuel.Numero;
									
									// Levier de traitement
									var LevierTraitement:Boolean = false;
									
									// S'il n'a pas de numéro —— - -
									if( VisuelsTraitement[ LeVisuel.Visual ] == null ){
										
										// Active le levier
										LevierTraitement = true;
									
									// S'il a un numéro —— - -
									} else {
										
										// Récupère les deux numéro du traitement
										var LastNumeroAnimation:Number = Number( VisuelsTraitement[ LeVisuel.Visual ].split( "_" )[ 0 ] );
										var LastNumeroVisuel:Number = Number( VisuelsTraitement[ LeVisuel.Visual ].split( "_" )[ 1 ] );
										
										// Si son animation est inférieur ou si elle est la même et que son visuel est inférieur —— - -
										if( NumeroAnimation < LastNumeroAnimation
										 || NumeroAnimation == LastNumeroAnimation && NumeroVisuel < LastNumeroVisuel ){
										
											// Active le levier
											LevierTraitement = true;
										}
									}
									
									// Si le levier de traitement est bon —— - -
									if( LevierTraitement ){
										
										// Ajoute le numéro de ce visuel au tableau de traitement
										VisuelsTraitement[ LeVisuel.Visual ] = NumeroAnimation + "_" + NumeroVisuel;
										
										// S'il s'agit du premier de Default —— - - Le conserve
										if( VisuelsTraitement[ LeVisuel.Visual ] == "-100_1" ){
											//
											var PremierVisuel:String = iVisuel;
										}
									}
									
								// S'il n'a pas de visual —— - - Trace l'erreur
								} else {
								//
								TraceError( "SceneFactory" , "BuildMovie" , "Le visuel \"" + iVisuel + "\" de l'animation " + 
																			 "\"" + iAnimation + "\" n'a pas de Visual." );
								}
							
							// S'il n'existe pas —— - - Trace l'erreur
							} else {
								//
								TraceError( "SceneFactory" , "BuildMovie" , "Le visuel \"" + iVisuel + "\" de l'animation " + 
																			 "\"" + iAnimation + "\" n'a aucun parametres." );
							}
						}
					}
				}
			}
			
			// Tans qu'il reste des visuels traités —— - -
			while( LengthObject( VisuelsTraitement ) > 0 ){
				
				// Les valeurs de récupération
				var MinAnimation:Number = 999999;
				var MinVisuel:Number = 999999;
				//
				var NomVisuel:String; 
				
				// Pour chaque visuel traité —— - -
				for( var iVisuelTraite:* in VisuelsTraitement ){
					
					// S'il n'est pas null —— - -
					if( VisuelsTraitement[ iVisuelTraite ] != null ){
						
						// Récupère les deux numéro du traitement
						var NumAnimation:Number = Number( VisuelsTraitement[ iVisuelTraite ].split( "_" )[ 0 ] );
						var NumVisuel:Number = Number( VisuelsTraitement[ iVisuelTraite ].split( "_" )[ 1 ] );
						
						// Si son animation est inférieur ou est la même et son visuel est inférieur —— - -
						if( NumAnimation < MinAnimation 
						 || NumAnimation == MinAnimation && NumVisuel < MinVisuel ){
							
							MinAnimation = NumAnimation;
							MinVisuel = NumVisuel;
							NomVisuel = iVisuelTraite;
						}
					}
				}
				
				// Ajoute au tableau de fin le visuel —— - -
				Cinematique.MovieObject.Visuels.push( NomVisuel );
				
				// Retire ce visuel des visuels traités
				VisuelsTraitement[ NomVisuel ] = null;
			}
			
			
			/* —— - - PARAMETRAGES - - —— */
			/**/
			
			// Pour chaque animation —— - -
			for( var jAnimation:* in Cinematique.Movie ){
				
				// Qui n'est pas les parametres —— - -
				if( jAnimation != "Parametres" ){
					
					// Récupère l'animation
					LAnimation = Cinematique.Movie[ jAnimation ];
					
					// Valeurs par défaut
					LAnimation.Parametres.Next = LAnimation.Parametres.Next || "Default";
					LAnimation.Parametres.Transition = LAnimation.Parametres.Transition || "cut";
					LAnimation.Parametres.SoundStop = LAnimation.Parametres.SoundStop || "1";
					LAnimation.Parametres.Click = LAnimation.Parametres.Click || "1";
					LAnimation.Parametres.Name = jAnimation;
					
					// Pour chaque visuels de l'animation —— - -
					for( var jVisuel:* in LAnimation ){
						
						// Qui n'est pas les parametres —— - -
						if( jVisuel != "Parametres" ){
							
							// Récupère le visuel
							LeVisuel = LAnimation[ jVisuel ].Parametres;
							
							// Si le visuel a ses parametres —— - -
							if( LeVisuel ){
								
								// S'il s'agit du n°1 —— - - Le donne à son animation
								if( LeVisuel.Numero == 1 ){
									//
									LAnimation.Parametres.FirstVisual = LeVisuel;
								}
								
								// Valeurs par défaut
								LeVisuel.Play = LeVisuel.Play || "normal";
								LeVisuel.Timing = LeVisuel.Timing || "frameLast";
								LeVisuel.Transition = LeVisuel.Transition || "cut";
								LeVisuel.Next = LeVisuel.Next || "";
								LeVisuel.Name = jVisuel;
								//
								if( LeVisuel.Next == "" ){
									//
									LeVisuel.Next = LAnimation[ Pop( jVisuel , String( LeVisuel.Numero ) ) + ( LeVisuel.Numero + 1 ) ]
													? Pop( jVisuel , String( LeVisuel.Numero ) ) + ( LeVisuel.Numero + 1 )
													: "";
								}
							}
						}
					}
					
					// Si l'animation n'a pas de premier visuel —— - - Le prend au hasard
					LAnimation.Parametres.FirstVisual = LAnimation.Parametres.FirstVisual || RandomKey( LAnimation , [ "Parametres" ] );
				}
			}
			
			
			/* —— - - CHARGEMENT VISUELS - - —— */
			/**/
			
			// Définit le nombre de visuels en tout
			Cinematique.MovieObject.NumberVisual = Cinematique.MovieObject.Visuels.length;
			
			// Lance le chargement du premier Swf
			BuildMovie_LoadSwf( Cinematique );
			
			
			/* —— - - CHARGEMENT SONS - - —— */
			/**/
			
			// Donne à la cinématique sa fonction de fin de chargement —— - -
			Cinematique.MovieObject.BuildMovie_LoadSound = function():void {
				/**/
				
				// La cinématique a ses sons actifs
				Cinematique.MovieObject.ActiveSound = true;
				
				// Si les sons et visuels sont actifs —— - - La cinématique est complétement active
				if( Cinematique.MovieObject.ActiveVisual ){
					//
					Cinematique.Active = true;
				}
			}
			
			// Donne à la cinématique sa fonction de fin de son —— - -
			Cinematique.MovieObject.BuildMovie_EndSound = function( LaCinematique:* ):void {
				/**/
				
				// Le son courant est vidé
				LaCinematique.currentSound = "";
				
				// S'il y a un son suivant —— - -
				if( LaCinematique.nextSound.length > 0 ){
					
					// Récupère le son
					LaCinematique.currentSound = LaCinematique.nextSound.shift();
					
					// Lance le son
					Cinematique.MovieObject.Sound.PlaySound( "Sounds" , LaCinematique.currentSound );
				}
			}
			
			// Donne à la cinématique son Sound Process
			Cinematique.MovieObject.Sound = new SoundProcess( RootLink );
			
			// Lui donne la fonction de fin de chargement
			Cinematique.MovieObject.Sound.EndLoadLaunch = Cinematique.MovieObject.BuildMovie_LoadSound;
			
			// Pour chaque sons —— - -
			for( var iSon:* in Cinematique.MovieObject.Library.Sound ){
				
				// Lance le chargement du son
				Cinematique.MovieObject.Sound.NewSound( "Sounds" , 
														 iSon , 
														 String( Cinematique.MovieObject.Library.Sound[ iSon ] ) ,
														 { fonctionEnd:{ Fonction:Cinematique.MovieObject.BuildMovie_EndSound , 
														 			     Argument:Cinematique } } );
			}
			
			
			/* —— - - BOUCLE & LECTURE - - —— */
			/**/
			
			// Essaye —— - -
			try {
				
				// Sa Tête de lecture
				Cinematique.PlayHead = 1;
				
				// L'Animation, le Visuel et le Son en cours
				Cinematique.currentAnimation = "Default";
				Cinematique.nextAnimation = "";
				Cinematique.currentVisual = Cinematique.firstVisual = 
											PremierVisuel || 
											RandomKey( Cinematique.Movie.Default , [ "Parametres" ] ).Parametres.Name;
				Cinematique.currentSound = "";
				Cinematique.nextSound = new Array();
				//
				Cinematique.playing = true;
				Cinematique.playingWait = new Array();
				
				// Tableau des sons à jouer
				Cinematique.orderSound = new Array();
				
				// Donne à la cinématique sa boucle
				AddEvents( Cinematique , BuildMovie_Loop , "ENTER_FRAME" );
				//
			} catch( e ){}
			
			
			/* —— - - FONCTIONS - - —— */
			/**/
			
			// Donne la fonction "Play" à la Cinématique —— - -
			Cinematique.Play = function( Animation:String = "Default" ):void {
				/**/
				
				// S'il possède l'animation en question —— - -
				if( this.Movie[ Animation ] ){
					
					// Cela devient l'animation suivante
					this.nextAnimation = Animation;
				}
			}
			
			// Donne la fonction "Pause" à la Cinématique —— - -
			Cinematique.Pause = function( Etat:* = "switch" ):void {
				/**/
				
				// Lock ou Unlock la boucle
				Cinematique.lock = ( Etat == "switch" ) ? !Cinematique.lock : Etat;
				
				// Lance ou interrompt le visuel
				This[ "Total" + ( Cinematique.lock ? "Stop" : "Play" ) ]( 
								  Cinematique[ Cinematique.Movie[ Cinematique.currentAnimation ]
																  [ Cinematique.currentVisual ].Parametres.Visual ].Root );
				
				// S'il y a un son en court —— - -
				if( Cinematique.currentSound ){
					
					// Interrompt ou relance le son
					Cinematique.MovieObject.Sound.PauseSound( "Sounds" , Cinematique.currentSound , Cinematique.lock );
				}
			}
			
			// Donne la fonction "Destroy" à la Cinématique —— - -
			Cinematique.Destroy = function():void {
				/**/
				
				// Il se lock et ne joue plus
				Cinematique.lock = true;
				Cinematique.playing = false;
				
				// Il s'auto-détruit
				DestroyElement( Cinematique );
			}
		}
		//
		// —————— BUILD MOVIE - LOAD SWF
		// Fonction de chargement d'un visuel
		public function BuildMovie_LoadSwf( Cinematique:*		// ———— - - La Cinématique concernée
										   ):void {
			/*—*/
			
			/* —— - - CALIBRAGE - - —— */
			/**/
			
			// Variable d'éxécution
			var Execution:Boolean = true;
			
			// Variable d'erreur
			Cinematique.error = ( Cinematique.error == null ) ? true : Cinematique.error;
			
			// Si ce n'est pas le premier —— - -
			if( Cinematique.MovieObject.VisuelsCharges.length != 0 ){
				
				// Donne au visuel précédent sa fonction d'affichage/Disaffichage —— - -
				Cinematique[ Cinematique.MovieObject.VisuelsCharges[ 0 ] ].Show = function( Etat:Boolean = true ):void {
					//
					this.visible = Etat;
					//
					this.alpha = 1;
					//
					RemoveEvents( this );
					//
					// Lance —— - -
					if( Etat ){
						//
						TotalPlay( this.Root );
					
					// Ou Interrompt —— - -
					} else {
						//
						TotalGotoAndStop( this.Root , 1 );
					}
				}
				
				// Si le précédent n'est pas d'un type non-compatible —— - -
				if( !TypeOf( Cinematique[ Cinematique.MovieObject.VisuelsCharges[ 0 ] ].Root , "AVM1Movie" ) ){
					
					// Rend actif le précédent visuel
					Cinematique[ Cinematique.MovieObject.VisuelsCharges[ 0 ] ].Active = true;
					
					// Si ce n'est pas le second —— - -
					if( Cinematique.MovieObject.VisuelsCharges.length != 1 ){
						
						// Interrompt le précédent visuel
						Cinematique[ Cinematique.MovieObject.VisuelsCharges[ 0 ] ].Show( false );
					}
					
				// Si le précédent est d'un type non-compatible —— - -
				} else {
					//
					TraceError( "SceneFactory" , "BuildMovie" , 
								[ "Le fichier du visuel \"" + Cinematique[ Cinematique.MovieObject.VisuelsCharges[ 0 ] ] + "\" est" ,
								  "d'un type non-reconnue : \"" + 
								  TypeOf( Cinematique[ Cinematique.MovieObject.VisuelsCharges[ 0 ] ].Root ) + "\"." ,
								  "Pour rendre compatible une scene swf-flv avec le BuildMovie, vous devez importer directement" ,
								  "le flv sur la Time-Line de votre flash." ] );
					//
					Execution = false;
				}
			}
			
			// Si l'éxécution se poursuit —— - -
			if( Execution ){
			
			
				/* —— - - CHARGEMENT - - —— */
				/**/
				
				// S'il reste des visuels à charger —— - -
				if( Cinematique.MovieObject.Visuels.length > 0 ){
					
					// Créait le conteneur du visuel
					var NouveauVisuel:* = NewElement( MovieClip , 
													  Cinematique , 
													  Cinematique.MovieObject.Visuels[ 0 ] , 
													  { 
														Active:false ,
														visible:false
													  } );
					
					// Si la librairie possède son lien —— - -
					if( Cinematique.MovieObject.Library.Visual[ Cinematique.MovieObject.Visuels[ 0 ] ] ){
						
						// Donne à la cinématique sa fonction d'erreur —— - -
						Cinematique.Erreur = function( Chemin:String = "Indéfinie" ):void {
							//
							TraceError( "SceneFactory" , "BuildMovie" , "Le fichier Swf \"" + Chemin + "\" est introuvable." );
							//
							this.error = true;
						}
						
						// Lance le chargement du Flash
						File.SWFLoad( NouveauVisuel , 
									  Cinematique.MovieObject.Library.Visual[ Cinematique.MovieObject.Visuels[ 0 ] ] , 
									  { 
										fonctionEnd:{ Fonction:BuildMovie_LoadSwf , 
													  Argument:Cinematique }  ,
										fonctionError:{ Fonction:Cinematique.Erreur , 
														Argument: Cinematique.MovieObject.Library.Visual[ 
																   Cinematique.MovieObject.Visuels[ 0 ] ] }
									  } );
						
						// Transfert le visuel vers les visuels chargés
						Cinematique.MovieObject.VisuelsCharges.unshift( Cinematique.MovieObject.Visuels.shift() );
					
					// Si la librairie ne possède pas son lien —— - - Trace l'erreur
					} else {
						//
						TraceError( "SceneFactory" , "BuildMovie" , "La Library ne contient pas le lien pour le visuel \"" 
																	 + Cinematique.MovieObject.Visuels[ 0 ] + "\"" );
					}
						
				
				/* —— - - ACTIVATION - - —— */
				/**/
					
				// S'il ne reste plus de visuels à charger —— - -
				} else {
					
					// La cinématique a ses visuels actifs
					Cinematique.MovieObject.ActiveVisual = true;
					
					// Si les sons et visuels sont actifs —— - - La cinématique est complétement active
					if( Cinematique.MovieObject.ActiveSound ){
						//
						Cinematique.Active = true;
					}
				}
						
				
				/* —— - - CALIBRAGE PREMIER - - —— */
				/**/
				
				// Si c'est le premier —— - -
				if( Cinematique.MovieObject.VisuelsCharges.length == 1 
				 && NouveauVisuel ){
					
					// Rend visible le nouveau visuel
					NouveauVisuel.visible = true;
					
					// Lance l'animation en passant en mode sans erreur
					Cinematique.error = false;
					
					// Donne l'événement de click à la cinématique
					AddEvents( Cinematique , BuildMovie_Click , "MOUSE_DOWN" );
				}
			}
		}
		//
		// —————— BUILD MOVIE - LOOP
		// Fonction de boucle de la cinématique
		public function BuildMovie_Loop( event:Event ):void {
			/*—*/
			
			// Récupère la Cinématique
			var Cinematique:* = event.target;
			
			
			/* —— - - GESTION ERREURS - - —— */
			/**/
			
			// S'il n'y a pas d'erreur et que la cinématique n'est pas bloquée —— - -
			if( !Cinematique.error && !Cinematique.lock ){
				//
				// Définit la potentialité d'erreur
				Cinematique.error = true;
				
				
				/* —— - - VALEURS - - —— */
				/**/
				
				// Récupère les objets définissant le visuel et l'animation en cours
				var AnimationObject:Object = Cinematique.Movie[ Cinematique.currentAnimation ].Parametres;
				var VisualObject:Object = Cinematique.Movie[ Cinematique.currentAnimation ][ Cinematique.currentVisual ].Parametres;
				
				// Récupère le visuel courant
				var Visuel:MovieClip = Cinematique[ VisualObject.Visual ];
				
				// Si l'animation courante est Clickable —— - - Définit la cinématique en bouton
				Cinematique.buttonMode = ( AnimationObject.Click == "1" && Cinematique.currentAnimation != "Default" );
				
				// Si le visuel courant est actif —— - -
				if( Visuel.Active ){
					
					// Récupère la racine du visuel courant
					var VisuelInterne:* = Visuel.Root;
						
					
					/* —— - - TIMING - - —— */
					/**/
						
					// Définit le Timing courant
					AnimationObject.currentTiming = AnimationObject.currentTiming || VisualObject.Timing.split( "," );
					
					// Si on joue —— - -
					if( Cinematique.playing ){
						
						// Pour chaque Timing —— - - 
						for( var iTiming:int = 0 ; iTiming < AnimationObject.currentTiming.length ; iTiming++ ){
							
							// Le timing
							var Timing:String = AnimationObject.currentTiming[ iTiming ];
							
							// Le levier
							var LevierTiming:Boolean = false;
							
							// S'il est à la fin de l'animation et qu'on s'y trouve
							if( Timing == "frameLast" && VisuelInterne.currentFrame == VisuelInterne.totalFrames ){
								//
								LevierTiming = true;
								//
							} else if( FindIn( Timing , "frame" ) && VisuelInterne.currentFrame == Number( Pop( Timing , "frame" ) ) ){
								//
								LevierTiming = true;
								//
							} else if( FindIn( Timing , "count" ) && Cinematique.PlayHead == Number( Pop( Timing , "count" ) ) ){
								//
								LevierTiming = true;
								//
							} else if( Timing == "soundEnd" && Cinematique.currentSound == "" && Cinematique.PlayHead != 1 ){
								//
								LevierTiming = true;
							}
							
							// Si le levier est actif —— - - Retire l'élément du tableau
							if( LevierTiming ){
								//
								AnimationObject.currentTiming.splice( iTiming , 1 );
								//
								iTiming--;
							}
						}
						
						
						/* —— - - SOUND - - —— */
						/**/
						
						// Le son à jouer
						var SoundToPlay:String = "";
						
						// Si on est au début et qu'il y a un soundStart —— - - Il est le son à jouer
						if( VisualObject.SoundStart && Cinematique.PlayHead == 1 ){
							//
							SoundToPlay = VisualObject.SoundStart;
						}
						
						// Pour chaque parametres de l'objet visuel —— - -
						for( var iParamVisualObject:* in VisualObject ){
							
							// S'il contient "sound" et n'est pas le son du début ou de fin —— - -
							if( FindIn( iParamVisualObject , "Sound" ) 
							 && iParamVisualObject != "SoundEnd"
							 && iParamVisualObject != "SoundStart" ){
								
								// S'il possède la frame en court —— - - Il est le son à jouer
								if( Number( Pop( iParamVisualObject , "Sound" ) ) == Cinematique.PlayHead ){
									//
									SoundToPlay = VisualObject[ iParamVisualObject ];
								}
							}
						}
						
						// Si on est à la fin et qu'il y a un soundEnd —— - - Il est le son à jouer
						if( VisualObject.SoundEnd && AnimationObject.currentTiming.length == 0 ){
							//
							SoundToPlay = VisualObject.SoundEnd;
						}
						
						// S'il y a un son à jouer
						if( SoundToPlay != "" ){
							
							// S'il y a déjà un son courant —— - - L'interrompt
							if( Cinematique.currentSound != "" ){
								//
								Cinematique.MovieObject.Sound.StopSon( "Sounds" , Cinematique.currentSound , "Sound" );
							}
							
							// Vide le tableau des sons prochains
							Cinematique.nextSound = new Array();
							
							// S'il s'agit d'un tableau —— - - Garde le premier élément et sauve le reste
							if( FindIn( SoundToPlay , "," ) ){
								//
								Cinematique.nextSound = SoundToPlay.split( "," );
								Cinematique.nextSound.shift();
								//
								SoundToPlay = SoundToPlay.split( "," )[ 0 ];
							}
								
							// Change le son courant
							Cinematique.currentSound = SoundToPlay;
							
							// Lance le son
							Cinematique.MovieObject.Sound.PlaySound( "Sounds" , Cinematique.currentSound );
						}
						
						
						/* —— - - CALIBRAGE COURANT - - —— */
						/**/
						
						// La tête de lecture avance
						Cinematique.PlayHead++;
					}
						
						
					/* —— - - FIN DE TIMING - - —— */
					/**/
					
					// S'il n'y a plus de Timing courant, s'il y a un nextAnimation ou un playing interrompu —— - -
					if( AnimationObject.currentTiming.length == 0
					 || Cinematique.nextAnimation != ""
					 || Cinematique.endAnimation
					 || !Cinematique.playing ){
						
						// Si la cinématique joue toujours —— - -

						if( Cinematique.playing ){
							
							// Remet la tête de lecture à 1
							Cinematique.PlayHead = 1
							
							// Supprime le Timing courant
							AnimationObject.currentTiming = null;
							
							// Supprime le Play courant
							Cinematique.currentPlay = null;
							
							
							/* —— - - NEXT - - —— */
							/**/
							
							// S'il n'y a pas de nextAnimation ou endAnimation —— - -
							if( Cinematique.nextAnimation == "" 
							 && !Cinematique.endAnimation ){
								
								// Levier de changement d'animation
								var LevierAnimationChange:Boolean = false;
								
								// La scene suivante
								var VisuelSuivant:*;
									
								// S'il y a un Next —— - -
								if( VisualObject.Next != "" ){
									
									// S'il n'est pas de type "destroy" —— - -
									if( VisualObject.Next != "destroy" ){
										
										// Affiche le visuel suivant
										VisuelSuivant = Cinematique[ Cinematique.Movie[ Cinematique.currentAnimation ]
																					  [ VisualObject.Next ].Parametres.Visual ];
										//
										Cinematique.currentVisual = VisualObject.Next;
									
									// S'il est de type "destroy" —— - -
									} else {
										
										// Détruit la cinématique
										Cinematique.Destroy();
										//
										VisuelSuivant = new Object();
									}
								
								// S'il n'y a pas de Next —— - -
								} else {
									
									// S'il s'agit du Default —— - -
									if( Cinematique.currentAnimation == "Default" ){
										
										// Affiche le premier visuels
										VisuelSuivant = Cinematique[ Cinematique.Movie[ Cinematique.currentAnimation ]
																					  [ Cinematique.firstVisual ].Parametres.Visual ];
										//
										Cinematique.currentVisual = Cinematique.firstVisual;
									
									// S'il ne s'agit pas du Default —— - -
									} else {
										
										// Prévoit de changer d'animation
										LevierAnimationChange = true;
									}
								}
							}
							
							
							/* —— - - NEXT ANIMATION - - —— */
							/**/
							
							// Valeur de transition animation
							var TransitionAnimation:String = "";
							
							// Si le levier de changement est activé ou qu'une demande de fin d'animation est faite —— - -
							if( LevierAnimationChange || Cinematique.endAnimation ){
								
								// Récupère la transition
								TransitionAnimation = AnimationObject.Transition;
								
								// Si elle n'est pas de type "destroy" —— - -
								if( AnimationObject.Next != "destroy" ){
									
									// Passe à l'animation suivante
									VisuelSuivant = Cinematique.Movie[ AnimationObject.Next ].Parametres.FirstVisual;
									VisuelSuivant = ( VisuelSuivant.Parametres != null ) ? VisuelSuivant.Parametres : VisuelSuivant;
									//
									Cinematique.currentAnimation = AnimationObject.Next;
									Cinematique.currentVisual = VisuelSuivant.Name;
									//
									VisuelSuivant = Cinematique[ VisuelSuivant.Visual ];
									
									// Si l'animation interrompt les sons —— - - Coupe le son courant et vide les sons next
									if( Cinematique.Movie[ AnimationObject.Next ].Parametres.SoundStop == "1" ){
										//
										Cinematique.nextSound = new Array();
										Cinematique.MovieObject.Sound.StopSon( "Sounds" , Cinematique.currentSound );
									}
									
									// Enlève la fin d'animation
									Cinematique.endAnimation = false;
									
								// Si elle est de type destroy —— - -
								} else {
									
									// Si l'animation interrompt les sons —— - - Coupe le son courant et vide les sons next
									if( AnimationObject.SoundStop == "1" ){
										//
										Cinematique.nextSound = new Array();
										Cinematique.MovieObject.Sound.StopSon( "Sounds" , Cinematique.currentSound );
									}
									
									// Lance la destruction
									Cinematique.Destroy();
									//
									VisuelSuivant = new Object();
								}
								
							// S'il y a un nextAnimation —— - -
							} else if( Cinematique.nextAnimation != "" && Cinematique.nextAnimation != null ){
								
								// Récupère la transition
								TransitionAnimation = AnimationObject.Transition;
								
								// Si elle n'est pas de type "destroy" —— - -
								if( AnimationObject.Next != "destroy" ){
									
									// Passe à l'animation suivante
									VisuelSuivant = Cinematique.Movie[ Cinematique.nextAnimation ].Parametres.FirstVisual;
									VisuelSuivant = ( VisuelSuivant.Parametres != null ) ? VisuelSuivant.Parametres : VisuelSuivant;
									//
									Cinematique.currentAnimation = Cinematique.nextAnimation;
									Cinematique.currentVisual = VisuelSuivant.Name;
									//
									VisuelSuivant = Cinematique[ VisuelSuivant.Visual ];
									
									// Si l'animation interrompt les sons —— - - Coupe le son courant et vide les sons next
									if( Cinematique.Movie[ AnimationObject.Next ].Parametres.SoundStop == "1" ){
										//
										Cinematique.nextSound = new Array();
										Cinematique.MovieObject.Sound.StopSon( "Sounds" , Cinematique.currentSound );
									}
									
								// Si elle est de type destroy —— - -
								} else {
									
									// Si l'animation interrompt les sons —— - - Coupe le son courant et vide les sons next
									if( AnimationObject.SoundStop == "1" ){
										//
										Cinematique.nextSound = new Array();
										Cinematique.MovieObject.Sound.StopSon( "Sounds" , Cinematique.currentSound );
									}
									
									// Lance la destruction
									Cinematique.Destroy();
									//
									VisuelSuivant = new Object();
								}
								
								// Vide le nextAnimation
								Cinematique.nextAnimation = "";
							}
						}
						
						
						/* —— - - TRANSITION - - —— */
						/**/
						
						// Si on ne joue pas —— - -
						if( !Cinematique.playing && Cinematique.playingWait != null ){
							//
							// S'il faut jouer —— - -
							if( Cinematique.playingWait[ 0 ].Active ){
								
								// Cache le loading
								Cinematique.Loading.visible = false;
								
								// Récupère les valeurs
								VisuelSuivant = Cinematique.playingWait[ 0 ];
								Visuel = Cinematique.playingWait[ 1 ];
								
								// Relance
								Cinematique.playing = true;
								
								// Relance l'animation
								TotalPlay( Visuel.Root );
								
								// S'il y a un son en attente —— - -
								if( Cinematique.playingWait[ 4 ] != "" ){
									
									// Relance le son
									Cinematique.MovieObject.Sound.PauseSon( "Sounds" , Cinematique.playingWait[ 4 ] , "Sound" , false );
								}
							}
						}
						
						// Opére la transition s'ils sont différents et qu'on joue —— - -
						if( VisuelSuivant.name != Visuel.name 
						 && Cinematique.playing ){
							
							// Si le visuel suivant est actif —— - -
							if( VisuelSuivant.Active ){
								
								// CUT —— - -
								if( VisualObject.Transition == "cut" && TransitionAnimation == "" 
								 || TransitionAnimation == "cut"
								 || Cinematique.playingWait[ 2 ] == "cut" && Cinematique.playingWait[ 3 ] == "" 
								 || Cinematique.playingWait[ 3 ]== "cut" ){
									
									// Le visuel en court est invisible et interrompu
									Visuel.Show( false );
									
									// Affiche le visuel suivant
									VisuelSuivant.Show();
								
								// FADE —— - -
								} else if( VisualObject.Transition == "fade" && TransitionAnimation == "" 
										|| TransitionAnimation == "fade"
										|| Cinematique.playingWait[ 2 ] == "fade" && Cinematique.playingWait[ 3 ] == "" 
										|| Cinematique.playingWait[ 3 ]== "fade"  ){
									
									// Lance le fondu du visuel en court
									Next( "Disappear" , Visuel , { alpha:0 } , 10 , "Constant" , 
										 { Fonction:"Show" , Cible:Visuel , Argument:false } );
									
									// Affiche le visuel suivant
									VisuelSuivant.Show();
									
									// Lance le fondu du visuel en court
									VisuelSuivant.alpha = 0;
									//
									Next( "Appear" , VisuelSuivant , { alpha:1 } , 10 , "Constant" );
								}
								
								// Vide la sauvegarde
								Cinematique.playingWait = new Array();
							
							// Si le visuel suivant n'est pas actif —— - -
							} else {
								
								// Interrompt le déroulement de l'animation
								Cinematique.playing = false;
								
								// Sauvegarde les données
								Cinematique.playingWait = [ VisuelSuivant , Visuel , 
															VisualObject.Transition , TransitionAnimation , "" ];
								
								// Fait apparaître le chargement
								Cinematique.Loading.x = Cinematique.Loading.positionX || Cinematique.width / 2;
								Cinematique.Loading.y = Cinematique.Loading.positionY || Cinematique.height / 2;
								//
								Cinematique.Loading.visible = true;
								//
								FirstView( Cinematique.Loading );
								
								// Interrompt l'animation
								TotalStop( Visuel.Root );
								
								// S'il y a un son en court —— - -
								if( Cinematique.currentSound != "" ){
									
									// Interrompt le son
									Cinematique.MovieObject.Sound.PauseSon( "Sounds" , Cinematique.currentSound , "Sound" , true );
									
									// Sauvegarde le son
									Cinematique.playingWait[ 4 ] = ( Cinematique.currentSound );
								}
							}
						}
					}
					
					
					/* —— - - PLAY - - —— */
					/**/
					
					// Si on joue —— - -
					if( Cinematique.playing ){
						
						// S'il n'a pas déjà de Play —— - -
						if( !Cinematique.currentPlay ){
							
							// Récupère le Play courant
							Cinematique.currentPlay = Cinematique.Movie[ Cinematique.currentAnimation ]
																	   [ Cinematique.currentVisual ].Parametres.Play;
							
							// S'il y trouve "frameCopy" —— - -
							if( FindIn( Cinematique.currentPlay , "frameCopy" ) ){
								//
								// Place la frame du nouveau visuel sur la même que l'ancien
								VisuelSuivant.Root.gotoAndPlay( Visuel.currentFrame );
							
							// S'il y trouve "frameLast" —— - -
							} else if( FindIn( Cinematique.currentPlay , "frameLast" ) ){
								//
								// Place la frame du nouveau visuel sur la dernière frame
								VisuelSuivant.Root.gotoAndPlay( VisuelSuivant.Root.totalFrames - 1 );
								
							// S'il y trouve "frame" —— - -
							} else if( FindIn( Cinematique.currentPlay , "frame" ) ){
								//
								// Place la frame du nouveau visuel sur celle voulue
								VisuelSuivant.Root.gotoAndPlay( 
												   Number( Cinematique.currentPlay.split( "frame" )[ 1 ].split( "," )[ 0 ] ) 
												   );
							}
						}
						
						// Si son Play possède "Rewind" —— - -
						if( FindIn( Cinematique.currentPlay , "rewind" ) && !VisuelSuivant ){
							
							// Va vers l'arrière
							Visuel.Root.gotoAndStop( ( Visuel.Root.currentFrame - 1 > 0 ) ? 
													   Visuel.Root.currentFrame - 1 : 
													   Visuel.Root.totalFrames );
						}
					}
				}
				
				// Il n'y a pas eu d'erreur
				Cinematique.error = false;
			}
		}
		//
		// —————— BUILD MOVIE - CLICK
		// Fonction de click sur la cinématique
		public function BuildMovie_Click( event:MouseEvent ):void {
			/*—*/
			
			// Récupère la Cinématique
			var Cinematique:* = event.currentTarget;
			
			// Si on est pas sur Défault et que l'animation en court permet le click —— - -
			if( Cinematique.currentAnimation != "Default"
			 && Cinematique.Movie[ Cinematique.currentAnimation ].Parametres.Click == "1" ){
				
				// On passe l'animation
				Cinematique.endAnimation = true;
			}
		}
		
		  
		  
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}