﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			  SOUND PROCESS	  	  		   1.0.0									***/
/***				   				   Dernière Mise à Jour : 10-09-05										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         			 	  Gestionnaire Audio											***/
/***	Ce script permet la gestion du son de façon global. Il permet d'archiver des sons et de les lancer 	***/
/***	à n'importe quel moment.																			***/
/***												      													***/
/***	En outre, il permet également de lier des action aux sons ou animations.							***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Media {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	  
	// —— - - DISPLAY
	import flash.display.MovieClip;
	//
	// —— - - EVENT
	import flash.events.Event;
	import flash.events.ProgressEvent;
	import flash.events.IOErrorEvent;
	//
	// —— - - MEDIA
	import flash.media.Sound;
	import flash.media.SoundMixer;
	import flash.media.SoundChannel;
	import flash.media.SoundTransform;
	import flash.net.URLRequest;
	//
	// —— - - UTILS
	import flash.utils.*;
	//
	// —— - - OTHER
	import drOIde.Global.MiscTools;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	
	public class SoundProcess extends MiscTools {
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      					  VARIABLES GLOBALES										  */
		/*		  							 Les variables d'utilisations globales								  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		// —————— VOLUME
		// Le Volume général
		public var Volume:Number = 100;
		
		
		// —————— LOAD
		// Le pourcentage d'accomplissement général du chargement
		public var Load:Number = 0;
		
		
		// —————— END LOAD FUNCTION
		// Fonction de fin de chargement
		public var EndLoadFunction:* = null;
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function SoundProcess( TheLink:* = null		// ———— - - Lien vers la scène
									 ):void {
			/*—*/
			
			// Établit la connexion
			Connexion( TheLink );
			
			// Lance la boucle de traitement
			AddEvents( this , GlobalLoop , "ENTER_FRAME" );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 GLOBAL					  		  					  */
		/*									Méthodes d'utilitées global pour le script 			  		  		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - LOOP - - —————————————————————————————————————————— */
		// Méthodes de gestion générales tournant en boucle
		//*—*//
		
		// —————— GLOBAL LOOP
		// Boucle de gestion du script
		
		public function GlobalLoop( event:Event ):void {
			/*—*/
			
			// Variables pour le chargement
			var SoundNumber:int = 0;
			var TotalLoad:Number = 0;
			
			// Pour chaque groupe de sons —— - -
			for( var iGroup:* in Sounds ){
				
				// S'il n'est pas null —— - -
				if( Sounds[ iGroup ] != null ){
					
					// Pour chaque son —— - -
					for( var iSound:* in Sounds[ iGroup ] ){
						
						// S'il n'est pas null et n'est pas les parametres —— - -
						if( iSound != "Parametres" && Sounds[ iGroup ][ iSound ] != null ){
							
							// Récupère le son et son taux en pourcentage
							SoundNumber++;
							TotalLoad += Sounds[ iGroup ][ iSound ].load;
							
							// Si le son est chargé —— - -
							if( Sounds[ iGroup ][ iSound ].load == 100 ){
								
								// Récupère sa liste de sons en court de lecture —— - -
								var Playing:Array = Sounds[ iGroup ][ iSound ].Playing;
								
								// Pour chaque son en court de lecture —— - -
								for( var iPlay:int = 0 ; iPlay < Playing.length ; iPlay++ ){
									
									// Récupère son objet
									var CurrentSound:Object = Playing[ iPlay ];
									
									// Lance son calibrage de volume
									SoundVolumeApply( CurrentSound );
								}
							}
						}
					}
				}
			}
			
			// Applique le pourcentage total
			Load = TotalLoad / SoundNumber;
			
			// Si on està 100% de chargement et qu'il y a une fonction de fin de chargement —— - -
			if( Load == 100 && EndLoadFunction ){
				
				// Lance la fonction de fin de chargement
				Launch( EndLoadFunction );
				
				// Détruit la fonction de fin de chargemen
				EndLoadFunction = null;
			}
		}
		
		
		// —————— SOUND VOLUME APPLY
		// Calibre un son par rapport à son propre volume et à celui de son groupe
		
		private function SoundVolumeApply( PlayObject:Object ):void {
			/*-*/
			
			// Définit un volume global issue du volume du son
			var ActualVolume:Number = PlayObject.SoundObject.volume;
			//
			var Pourcentage:Number = 100;
			var PourcentageFade:Number = 100;
			
			// Calibre le volume par rapport aux autres
			ActualVolume += Aspiration( PlayObject.volume ) - 100;
			ActualVolume += Aspiration( Sounds[ PlayObject.SoundObject.group ].Parametres.volume ) - 100;
			ActualVolume += Aspiration( Volume ) - 100;
			
			// S'il y a une distance de volume —— - -
			if( PlayObject.volumeDistance ){
				
				// Définit le pourcentage de conservation du volume
				Pourcentage = 0;
				
				// Si tout les éléments s'y trouvent —— - -
				if( PlayObject.volumeDistance.Element1 && PlayObject.volumeDistance.Element2 ){
				
					// Récupère la distance entre les éléments
					var Distance:Number = GetDistance( PlayObject.volumeDistance.Element1 , PlayObject.volumeDistance.Element2 );
					
					// Etablie sa valeur duction du min et max
					Pourcentage = ( Distance + ( PlayObject.volumeDistance.min || 50 ) ) 
								/ ( ( PlayObject.volumeDistance.max || 500 ) 
								  + ( PlayObject.volumeDistance.min || 50 ) ) 
								* 100;
								//
					Pourcentage = 100 - Pourcentage;
								
					// Bump le pourcentage
					Pourcentage = BumpNumber( Pourcentage , 0 , 100 );
				}
			}
			
			// S'il y a un fadeIn et qu'on est pas en fermeture —— - -
			if( PlayObject.fadeIn && !PlayObject.close && PlayObject.fade != 100 ){
				
				// Etablie l'état du fondu s'il n'y en a pas
				PlayObject.fade = PlayObject.fade || 0;
				
				// Provoque l'augmentation de l'état de fondu
				PlayObject.fade += PlayObject.fadeIn / 10;
				PlayObject.fade = BumpNumber( PlayObject.fade , 0 , 100 );
				
			// S'il y a un fadeOut et qu'on est en fermeture —— - -
			} else if( PlayObject.fadeOut && PlayObject.close ){
				
				// Etablie l'état du fondu s'il n'y en a pas
				PlayObject.fade = PlayObject.fade == null ? 100 : PlayObject.fade;
				
				// Provoque la réduction de l'état de fondu
				PlayObject.fade -= PlayObject.fadeOut / 10;
				PlayObject.fade = BumpNumber( PlayObject.fade , 0 , 100 );
				
				// Si le porucentage est à zéro —— - -
				if( PlayObject.fade == 0 ){
					
					// Retire le fadeOut
					PlayObject.fadeOut = null;
					
					// Interrompt le son
					PlayObject.Stop();
				}
			}
				
			// Récupère le fondu
			PourcentageFade = ( PlayObject.fade != null ) ? PlayObject.fade : 100;
			
			// Applique le nouveau volume
			PlayObject.transform.volume = BumpNumber( ActualVolume / 100 , 0 , 1 ) 
										* ( Pourcentage / 100 )
										* ( PourcentageFade / 100 );
										//
			PlayObject.channel.soundTransform = PlayObject.transform;
		}
		
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Méthodes de manipulation générales du script
		//*—*//
		
		// —————— END LOAD LAUNCH
		// Définit une fonction à lancer en fin de chargement des sons
		
		public function EndLoadLaunch( Fonction:*	// ———— - - La Fonction donnée
									  ):void {
			/*—*/
			
			// Modifie la variable concernée
			EndLoadFunction = Fonction;
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 SOUND					  		  					  */
		/*									Sauvegarde et lancement de sons standards 			  		  		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables d'utilisation de cette section
		//*—*//
		
		// —————— SOUNDS
		// Objets des sons archivés
		public var Sounds:Object = new Object();
		
		
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Méthodes pour sauvegarder les sons
		//*—*//
		
		// —————— NEW SOUND GROUP
		// Créait un nouveau groupe de son
		
		public function NewSoundGroup( Nom:String ,					// ———— - - Le Nom du groupe
								  	   Parametres:Object = null		// ———— - - Les Parametres du groupe
									  ):void {
			/*—*/
			
			// Si le groupe n'existe pas déjà —— - -
			if( !Sounds[ Nom ] ){
				
				// Créait l'objet du groupe
				Sounds[ Nom ] = new Object();
				
				// Argument par défaut
				Parametres = Parametres || new Object();
				
				// Créait les parametres du groupes
				Sounds[ Nom ].Parametres = CloneObject( Parametres );
				
				// Parametres par défaut
				Sounds[ Nom ].Parametres.volume = Sounds[ Nom ].Parametres.volume || 100;
			}
		}
		
		// —————— NEW SOUND
		// Créait un nouveau son
		
		public function NewSound( Groupe:String ,			// ———— - - Le Groupe concerné
								  Nom:* ,					// ———— - - Le Nom du son
								  Lien:* = null ,			// ———— - - Le Lien du son
								  Parametres:Object = null	// ———— - - Les Parametres du son
								 ):void {
			/*—*/
			
			// Switch des arguments
			if( TypeOf( Lien , "Object" ) || Lien == null ){
				//
				Parametres = Lien;
				Lien = Nom;
				Nom = Groupe;
				Groupe = "Sounds";
			}
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			
			// Si le groupe n'existe pas —— - - Créait le groupe
			if( !Sounds[ Groupe ] ){
				//
				NewSoundGroup( Groupe );
			}
			
			// Créait le nouveau son
			var SoundObject:Object = Sounds[ Groupe ][ Nom ] = CloneObject( Parametres );
			//
			// Lui donne son chemin vers les parametres de son groupe
			SoundObject.GroupObject = Sounds[ Groupe ].Parametres;
			//
			// Lui donne ses parametres principaux
			SoundObject.name = Nom;
			SoundObject.group = Groupe;
			SoundObject.link = Lien;
			//
			SoundObject.Playing = new Array();
			SoundObject.PlayingList = new Object();
			//
			SoundObject.load = TypeOf( Lien , "String" ) ? 0 : 100;
			
			
			// Parametres par défaut
			SoundObject.volume = SoundObject.volume || 100;
			
			// Lui donne sa fonction de fin —— - -
			SoundObject.EndFunction = function( PlayObject:Object ,
											    Interruption:Boolean = false ,
												Fonction:Boolean = true
											   ):void {
				/**/
				
				// S'il n'est pas en pause —— - -
				if( !PlayObject.pause ){
					
					// S'il possède une fin temporisée ou une demande d'interruption —— - -
					if( PlayObject.end || Interruption ){
						
						// Interrompt le son
						PlayObject.channel.stop();
					}
							
					// Lance sa fonction de fin de boucle
					if( Fonction ){
						//
						Launch( PlayObject.fonctionLoopEnd );
					}
					
					// S'il n'est pas en boucle —— - -
					if( PlayObject.loop == 0 ){
							
						// Lance sa fonction de fin
						if( Fonction ){
							//
							Launch( PlayObject.fonctionEnd );
						}
						
						// Pour chaque sons du tableau des sons joués —— - -
						for( var iSound:int = 0 ; iSound < PlayObject.SoundObject.Playing.length ; iSound++ ){
							
							// Si c'est le bon —— - -
							if( PlayObject.SoundObject.Playing[ iSound ].name == PlayObject.name ){
								//
								// Le retire
								PlayObject.SoundObject.PlayingList[ PlayObject.SoundObject.Playing[ iSound ].name ] = null;
								PlayObject.SoundObject.Playing.splice( iSound , 1 );
								//
								// Termine
								iSound = PlayObject.SoundObject.Playing.length;
							}
						}
						
					// S'il est encore en boucle —— - -
					} else {
						
						// Réduit le nombre restant ( S'il n'est pas infinie )
						PlayObject.loop = ( PlayObject.loop != "infinite" ) ? PlayObject.loop - 1 : PlayObject.loop;
						
						// Rejoue le même son
						PlaySound( PlayObject.SoundObject.group , PlayObject.SoundObject.name , PlayObject );
					}
				}
			}
			
			// Lui donne sa fonction d'erreur —— - -
			SoundObject.ErrorFunction = function( LienSoundObject:Object ):void {
				/**/
				
				// Trace l'erreur
				TraceError( "SoundProcess" , "NewSound" , [ "Impossible de charger le son nommé \"" + LienSoundObject.name 
						   								  + "\" du groupe \"" + LienSoundObject.group + "\"." , 
														    "Le son n'est pas accessible au lien : " + LienSoundObject.link ] );
				
				// Retire l'objet de ce son
				Sounds[ LienSoundObject.group ][ LienSoundObject.name ] = null;
			}
			
			// Lui donne sa fonction de chargement —— - -
			SoundObject.LoadFunction = function( event:ProgressEvent ):void {
				/**/
				
				// Trace l'erreur
				SoundObject.load = event.bytesLoaded / event.bytesTotal * 100;
			}
			
			// Créait le son
			//
			// S'il s'agit du liaison externe par le biais d'un string —— - -
			if( TypeOf( Lien , "String" ) ){
				
				// Liaison du son par un fichier externe
				SoundObject.Sound = new Sound ( new URLRequest ( ConcatUnicite( Lien , ".mp3" ) ) );
				
				// Définie son type
				SoundObject.type = "Extern";
			
			// S'il s'agit d'une liaison interne par le biais d'une classe
			} else {
				
				// Liaison du son par une class de son interne
				SoundObject.Sound = new Lien();
				
				// Définie son type
				SoundObject.type = "Intern";
			}
			
			// Donne au son ses événements relatifs à son chargement
			AddEvents( SoundObject.Sound , { Fonction:SoundObject.ErrorFunction , Arguments:[ SoundObject ] } , "IO_ERROR" );
			AddEvents( SoundObject.Sound , SoundObject.LoadFunction , "PROGRESS" );
		}
		
		
		
		/* —————————————————————————————————————————— - - GET - - —————————————————————————————————————————— */
		// Méthodes pour récupérer les valeurs des sons
		//*—*//
		
		// —————— GET SOUND
		// Récupère les parametres d'un son ou d'un groupe de son
		
		public function GetSound( Groupe:* = null ,	// ———— - - Le Groupe concerné
								  Nom:* = null 		// ———— - - Le Nom du son
								 ):Object {
			/*—*/
			
			// Si le groupe est vide —— - - Le cherche par son nom
			if( !Groupe ){
				//
				Groupe = KeyByName( Sounds , Nom );
			}
			
			// Si on a trouvé le groupe —— - -
			if( Groupe ){
				
				// Si le groupe existe —— - -
				if( Sounds[ Groupe ] ){
					
					// Si l'on a pas demandé un nom de son —— - -
					if( !Nom ){
						
						// Retourne les parametres du groupe
						return Sounds[ Groupe ].Parametres;
					
					// Si on a demandé un nom de son —— - -
					} else {
						
						// Si le son existe —— - -
						if( Sounds[ Groupe ][ Nom ] ){
						
							// Retourne les parametres du son
							return Sounds[ Groupe ][ Nom ];
							
						// Si le son n'existe pas —— - - Trace l'erreur
						} else {
							//
							TraceError( "SoundProcess" , "PlaySound" , "Le son \"" + Nom + 
																	   "\" n'existe pas ou n'a pas été trouvé dans le groupe \"" + 
																	   Nom + "\"." );
						}
					}
				
				// Si le groupe n'existe pas —— - - Trace l'erreur
				} else {
					//
					TraceError( "SoundProcess" , "PlaySound" , "Le groupe \"" + Groupe + "\" n'existe pas." );
				}
				
			// Si l'on a pas trouvé le groupe —— - - Trace l'erreur
			} else {
				//
				TraceError( "SoundProcess" , "PlaySound" , "Le son \"" + Nom + 
						   								   "\" est introuvable parmis les sons déjà enregistrés." );
			}
			
			// Ne retourne rien
			return null;
		}
		
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Méthodes pour manipuler les sons
		//*—*//
		
		// —————— PLAY SOUND
		// Lance la lecture d'un son
		
		public function PlaySound( Groupe:String ,			// ———— - - Le Groupe concerné
								   Nom:* = null ,			// ———— - - Le Nom du son
								   Parametres:Object = null	// ———— - - Les Parametres de lancement de ce son
								 ):Object {
			/*—*/
			
			// Switch des arguments
			if( TypeOf( Nom , "Object" ) || Nom == null ){
				//
				Parametres = Nom;
				Nom = Groupe;
				Groupe = "";
			}
			
			// Si le groupe est vide —— - - Le cherche par son nom
			if( Groupe == "" ){
				//
				Groupe = KeyByName( Sounds , Nom );
			}
			
			// Si on a trouvé le groupe —— - -
			if( Groupe ){
				
				// Arguments par défaut
				Parametres = Parametres || new Object();
				
				// Si le groupe existe —— - -
				if( Sounds[ Groupe ] ){
					
					// Si le son existe —— - -
					if( Sounds[ Groupe ][ Nom ] ){
						
						// Récupère son objet
						var SoundObject:Object = Sounds[ Groupe ][ Nom ];
						//
						Parametres.name = Parametres.name || RandomWord();
						
						// S'il est chargé —— - -
						if( SoundObject.load == 100 ){
							
							// Récupère le retardement actuel
							var Countdown:Number = Parametres.countdown || SoundObject.countdown || SoundObject.GroupObject.countdown || 0;
							
							// Récupère la limite actuelle
							var Limit:Number = Parametres.limit || SoundObject.limit || SoundObject.GroupObject.limit || 0;
							
							// S'il n'est pas à retardement ( Positif ) et si la limit n'est pas excédée —— - -
							if( Countdown <= 0  ){
								//
								if( Limit == 0 || Limit > SoundObject.Playing.length ){
									
									// Inverse le retard ( Si retard il y a )
									Parametres.countdown = Countdown * -1;
									
									// Récupère s'il est seul
									var Alone:Boolean = Parametres.alone || SoundObject.alone || SoundObject.GroupObject.alone;
									//
									// S'il est seul —— - -
									if( Alone ){
										//
										// Interrompt les autres sons du même groupe
										StopSound( SoundObject.group );
									}
									
									// Récupère si c'est un son redondant ou non
									var Redondant:Boolean = Parametres.same ? true : false;
									
									// Intégre un nouveau lancement de son
									var PlayObject:Object 
														= SoundObject.PlayingList[ Parametres.name ] 
														= Redondant ?
														  Parametres :
														  { 
															SoundObject:SoundObject ,
															close:false ,
															pause:false ,
															same:true ,
															name:Parametres.name ,
															volume:Parametres.volume || 100 ,
															start:Parametres.start || 
																  SoundObject.start || 
																  SoundObject.GroupObject.start || 
																  0 ,
																  //
															end:Parametres.end || 
																SoundObject.end || 
																SoundObject.GroupObject.end || 
																0 ,
																  //
															loop:Parametres.loop || 
																 SoundObject.loop || 
																 SoundObject.GroupObject.loop || 
																 0 ,
																  //
															repetition:Parametres.repetition || 
																	   SoundObject.repetition || 
																	   SoundObject.GroupObject.repetition || 
																	   0 ,
																  //
															fonctionEnd:Parametres.fonctionEnd || 
																		SoundObject.fonctionEnd || 
																		SoundObject.GroupObject.fonctionEnd ,
																  //
															fonctionStart:Parametres.fonctionStart || 
																		  SoundObject.fonctionStart || 
																		  SoundObject.GroupObject.fonctionStart ,
																  //
															fonctionLoopEnd:Parametres.fonctionLoopEnd || 
																			SoundObject.fonctionLoopEnd || 
																			SoundObject.GroupObject.fonctionLoopEnd ,
																  //
															fonctionLoopStart:Parametres.fonctionLoopStart || 
																			  SoundObject.fonctionLoopStart || 
																			  SoundObject.GroupObject.fonctionLoopStart ,
																  //
															countdown:Parametres.countdown || 
																	  SoundObject.countdown || 
																	  SoundObject.GroupObject.countdown ,
																  //
															volumeDistance:Parametres.volumeDistance || 
																		   SoundObject.volumeDistance || 
																		   SoundObject.GroupObject.volumeDistance ,
																  //
															fadeIn:Parametres.fadeIn || 
																   SoundObject.fadeIn || 
																   SoundObject.GroupObject.fadeIn ,
																  //
															fadeOut:Parametres.fadeOut || 
																	SoundObject.fadeOut || 
																	SoundObject.GroupObject.fadeOut
														  };
									//
									SoundObject.Playing.push( PlayObject );
									
									// Lance le son et récupère son channel
									PlayObject.channel = SoundObject.Sound.play( PlayObject.start , PlayObject.repetition );
									PlayObject.transform = PlayObject.channel.soundTransform;
									
									// Applique sa gestion de volume
									SoundVolumeApply( PlayObject );
									
									// Lance sa fonction de début de boucle
									Launch( PlayObject.fonctionLoopStart );
									
									// Lance sa fonction de début s'il n'est pas redondant
									if( !Redondant ){
										//
										Launch( PlayObject.fonctionStart );
									}
									
									// S'il possède une fin temporisée —— - -
									if( PlayObject.end ){
										
										// Lance l'interruption du son par avance
										TimeLaunch( { Fonction:SoundObject.EndFunction , Arguments:[ PlayObject ] } , PlayObject.end - PlayObject.start );
									}
									
									// Lui rattache sa méthode de fin en tans qu'événement
									AddEvents( PlayObject , 
											  { Fonction:SoundObject.EndFunction , Arguments:[ PlayObject ] } , 
												"SOUND_COMPLETE" , 
											  { target:PlayObject.channel } );
									
									// Lui donne sa fonction d'interruption
									PlayObject.Stop = function( Fonction:Boolean = true ):Boolean {
										/**/
										
										// S'il n'a pas de fadeOut —— - -
										if( !PlayObject.fadeOut ){
											
											// Lance la fonction de fermeture
											SoundObject.EndFunction( PlayObject , true , Fonction );
											
											// Retourne vrai
											return true
										
										// S'il a un fadeOut —— - -
										} else {
											
											// Définit le son comme étant en court de fermeture
											PlayObject.close = true;
										}
										
										// Retourne faux
										return false;
									}
									
									// Lui donne sa fonction de pause
									PlayObject.Pause = function( Etat:* = "switch" ):void {
										/**/
										
										// Définit l'état de pause
										PlayObject.pause = ( Etat != "switch" ) ? Etat : !PlayObject.pause;
										
										// Si on provoque la pause —— - -
										if( PlayObject.pause ){
											
											// Récupère la position de la tête sur le son
											PlayObject.position = PlayObject.channel.position;
											
											// Interrompt le son
											PlayObject.channel.stop();
										
										// Si on retire la pause —— - -
										} else {
											
											// Relance le son depuis sa position d'interruption
											PlayObject.channel = PlayObject.SoundObject.Sound.play( PlayObject.position , PlayObject.repetition );
											
											// Lui rattache sa méthode de fin en tans qu'événement
											AddEvents( PlayObject , 
													  { Fonction:PlayObject.SoundObject.EndFunction , Arguments:[ PlayObject ] } , 
														"SOUND_COMPLETE" , 
													  { target:PlayObject.channel } );
										}
									}
									
									// Retourne l'objet du son lancé
									return PlayObject;
								}
									
							// S'il est à retard positif —— - -
							} else {
								
								// Inverse le retard
								Parametres.countdown = Countdown * -1;
								
								// Lance cette même fonction à retardement
								TimeLaunch( { Fonction:PlaySound , Arguments:[ Groupe , Nom , Parametres ] } , Parametres.countdown * -1 );
							}
							
						// Si le son n'est pas chargé —— - - Trace l'erreur
						} else {
							//
							TraceError( "SoundProcess" , "PlaySound" , [ "Le son \"" + Nom + "\" dans le groupe \"" + Nom + 
									   								   "\" n'a pas fini de se charger." , 
																	   "Il n'en est qu'à " + SoundObject.load + "% pour le moment." , 
																	   "Il est recommandé de vérifier la variable \"Load\" ou d'utiliser la méthode" ,
																	   "EndLoadLaunch() pour contrôler la fin du chargement des sons." ]);
						}
						
					// Si le son n'existe pas —— - - Trace l'erreur
					} else {
						//
						TraceError( "SoundProcess" , "PlaySound" , "Le son \"" + Nom + 
								   								   "\" n'existe pas ou n'a pas été trouvé dans le groupe \"" + 
																   Nom + "\"." );
					}
				
				// Si le groupe n'existe pas —— - - Trace l'erreur
				} else {
					//
					TraceError( "SoundProcess" , "PlaySound" , "Le groupe \"" + Groupe + "\" n'existe pas." );
				}
				
			// Si l'on a pas trouvé le groupe —— - - Trace l'erreur
			} else {
				//
				TraceError( "SoundProcess" , "PlaySound" , "Le son \"" + Nom + 
						   								   "\" est introuvable parmis les sons déjà enregistrés." );
			}
			
			// Ne retourne rien
			return null;
		}
		
		
		// —————— STOP SOUND
		// Lance l'interruption d'un son
		
		public function StopSound( Groupe:* = "" ,			// ———— - - Le Groupe concerné
								   Nom:* = "" ,				// ———— - - Le Nom du son
								   Channel:* = "" ,			// ———— - - Le Nom de channel du son
								   Fonction:Boolean = true	// ———— - - Si les Sons lancent leur fonction de fin
								 ):void {
			/*—*/
			
			// Switch des arguments
			if( TypeOf( Groupe , "Boolean" ) ){ Fonction = Groupe; }
			if( TypeOf( Nom , "Boolean" ) ){ Fonction = Nom; }
			if( TypeOf( Channel , "Boolean" ) ){ Fonction = Channel; }
			
			// Variable de test
			var Test:Boolean;
			
			// S'il y a un groupe —— - -
			if( Groupe != "" ){
				
				// S'il existe —— - -
				if( Sounds[ Groupe ] ){
					
					// S'il y a un son —— - -
					if( Nom != "" ){
						
						// S'il existe —— - -
						if( Sounds[ Groupe ][ Nom ] ){
						
							// S'il y a un channel —— - -
							if( Channel != "" ){
								
								// S'il existe —— - -
								if( Sounds[ Groupe ][ Nom ].PlayingList[ Channel ] ){
									
									// L'interrompt
									Sounds[ Groupe ][ Nom ].PlayingList[ Channel ].Stop();
								}
							
							// S'il n'y a pas de channel —— - -
							} else {
								
								// Pour chaque channel du son —— - -
								for( var kChannel:int = 0 ; kChannel < Sounds[ Groupe ][ Nom ].Playing.length ; kChannel++ ){
									
									// Interrompt le son
									Test = Sounds[ Groupe ][ Nom ].Playing[ kChannel ].Stop();
									//
									if( Test ){ kChannel--; }
								}
							}
						}
					
					// S'il n'y a pas de son —— - -
					} else {
						
						// Pour chaque son du groupe —— - -
						for( var jNom:* in Sounds[ Groupe ] ){
							
							// Si ce n'est pas les parametres et s'il existe —— - -
							if( jNom != "Parametres" && Sounds[ Groupe ][ jNom ] ){
								
								// Pour chaque channel du son —— - -
								for( var jChannel:int = 0 ; jChannel < Sounds[ Groupe ][ jNom ].Playing.length ; jChannel++ ){
									
									// Interrompt le son
									Test = Sounds[ Groupe ][ jNom ].Playing[ jChannel ].Stop();
									//
									if( Test ){ jChannel--; }
								}
							}
						}
					}
				}
			
			// S'il n'y a pas de groupe —— - -
			} else {
					
				// Pour chaque groupe —— - -
				for( var iGroupe:* in Sounds ){
					
					// S'il existe —— - -
					if( Sounds[ iGroupe ] ){
						
						// Pour chaque son du groupe —— - -
						for( var iNom:* in Sounds[ iGroupe ] ){
								
							// Si ce n'est pas les parametres et s'il existe —— - -
							if( iNom != "Parametres" && Sounds[ iGroupe ][ iNom ] ){
						
								// Pour chaque channel du son —— - -
								for( var iChannel:int = 0 ; iChannel < Sounds[ iGroupe ][ iNom ].Playing.length ; iChannel++ ){
									
									// Interrompt le son
									Test = Sounds[ iGroupe ][ iNom ].Playing[ iChannel ].Stop();
									//
									if( Test ){ iChannel--; }
								}
							}
						}
					}
				}
			}
		}
		
		
		// —————— PAUSE SOUND
		// Lance la mise en pause d'un son ou son relancement
		
		public function PauseSound( Groupe:* = "" ,			// ———— - - Le Groupe concerné
								    Nom:* = "" ,			// ———— - - Le Nom du son
								    Channel:* = "" ,		// ———— - - Le Nom de channel du son
								    Etat:* = "switch"		// ———— - - Si on interrompt ou si on relance
								 ):void {
			/*—*/
			
			// Switch des arguments
			if( TypeOf( Groupe , "Boolean" ) || Groupe == "switch" ){ Etat = Groupe; }
			if( TypeOf( Nom , "Boolean" ) || Nom == "switch" ){ Etat = Nom; }
			if( TypeOf( Channel , "Boolean" ) || Channel == "switch" ){ Etat = Channel; }
			
			// S'il y a un groupe —— - -
			if( Groupe != "" ){
				
				// S'il existe —— - -
				if( Sounds[ Groupe ] ){
					
					// S'il y a un son —— - -
					if( Nom != "" ){
						
						// S'il existe —— - -
						if( Sounds[ Groupe ][ Nom ] ){
						
							// S'il y a un channel —— - -
							if( Channel != "" ){
								
								// S'il existe —— - -
								if( Sounds[ Groupe ][ Nom ].PlayingList[ Channel ] ){
									
									// L'interrompt
									Sounds[ Groupe ][ Nom ].PlayingList[ Channel ].Stop();
								}
							
							// S'il n'y a pas de channel —— - -
							} else {
								
								// Pour chaque channel du son —— - -
								for( var kChannel:int = 0 ; kChannel < Sounds[ Groupe ][ Nom ].Playing.length ; kChannel++ ){
									
									// Interrompt le son
									Sounds[ Groupe ][ Nom ].Playing[ kChannel ].Pause( Etat );
								}
							}
						}
					
					// S'il n'y a pas de son —— - -
					} else {
						
						// Pour chaque son du groupe —— - -
						for( var jNom:* in Sounds[ Groupe ] ){
							
							// Si ce n'est pas les parametres et s'il existe —— - -
							if( jNom != "Parametres" && Sounds[ Groupe ][ jNom ] ){
								
								// Pour chaque channel du son —— - -
								for( var jChannel:int = 0 ; jChannel < Sounds[ Groupe ][ jNom ].Playing.length ; jChannel++ ){
									
									// Interrompt le son
									Sounds[ Groupe ][ jNom ].Playing[ jChannel ].Pause( Etat );
								}
							}
						}
					}
				}
			
			// S'il n'y a pas de groupe —— - -
			} else {
					
				// Pour chaque groupe —— - -
				for( var iGroupe:* in Sounds ){
					
					// S'il existe —— - -
					if( Sounds[ iGroupe ] ){
						
						// Pour chaque son du groupe —— - -
						for( var iNom:* in Sounds[ iGroupe ] ){
								
							// Si ce n'est pas les parametres et s'il existe —— - -
							if( iNom != "Parametres" && Sounds[ iGroupe ][ iNom ] ){
						
								// Pour chaque channel du son —— - -
								for( var iChannel:int = 0 ; iChannel < Sounds[ iGroupe ][ iNom ].Playing.length ; iChannel++ ){
									
									// Interrompt le son
									Sounds[ iGroupe ][ iNom ].Playing[ iChannel ].Pause( Etat );
								}
							}
						}
					}
				}
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					  NOISE					  		  					  */
		/*									Sauvegarde et lancement de sons aléatoires 			  		  		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables d'utilisation de cette section
		//*—*//
		
		// —————— NOISES
		// Objets des sons aléatoires archivés
		public var Noises:Object = new Object();
		
		
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Méthodes pour sauvegarder les sons aléatoires
		//*—*//
		
		// —————— NEW NOISE GROUP
		// Créait un nouveau groupe de son
		
		public function NewNoiseGroup( Nom:String 	// ———— - - Le Nom du groupe
								  	 ):void {
			/*—*/
			
			// Si le groupe n'existe pas déjà —— - -
			if( !Noises[ Nom ] ){
				
				// Créait l'objet du groupe
				Noises[ Nom ] = new Object();
			}
		}
			
		
		// —————— NEW NOISE
		// Créait un nouveau son aléatoire
		
		public function NewNoise( Groupe:String ,	// ———— - - Le Groupe concerné
								  Nom:* ,			// ———— - - Le Nom du son
								  Sons:* = null 	// ———— - - Les Sons du noise
								  					//			( Un tableau avec des nom ou des objets de nom )
								 ):void {
			/*—*/
			
			// Si le groupe n'existe pas —— - - Le créait
			if( !Noises[ Groupe ] ){ NewNoiseGroup( Groupe ); }
			
			// Créait le nouveau noise
			Noises[ Groupe ][ Nom ] = Sons;
		}
			
		

		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Méthodes pour manipuler les sons aléatoires
		//*—*//
		
		// —————— PLAY NOISE
		// Lance la lecture d'un son aléatoire
		
		public function PlayNoise( Groupe:String ,			// ———— - - Le Groupe concerné
								   Nom:* = null ,			// ———— - - Le Nom du son
								   Parametres:Object = null	// ———— - - Les Parametres de lancement de ce son
								 ):Object {
			/*—*/
			
			// Switch des arguments
			if( !Nom ){
				//
				Nom = Groupe;
				Groupe = "";
			}
			//
			if( TypeOf( Nom , "Object" ) ){
				//
				Parametres = Nom;
				Nom = Groupe;
				Groupe = "";
			}
			
			// Si l'on a pas donné de groupe —— - -
			if( Groupe == "" ){
				//
				// Cherche le bon son
				Groupe = KeyByName( Noises , Nom );
			}
			
			// Si on a un groupe —— - -
			if( Groupe ){
			
				// Si le groupe existe —— - -
				if( Noises[ Groupe ] ){
					
					// Si le noise existe —— - -
					if( Noises[ Groupe ][ Nom ] ){
						
						// Récupère un de ses sons au hasard
						var GetSound:* = RandomArray( Noises[ Groupe ][ Nom ] );
						//
						var GetGroup:String;
						var GetName:String;
						//
						if( TypeOf( GetSound , "Object" ) ){
							//
							GetGroup = GetSound.group;
							GetName = GetSound.name;
							
						} else if( TypeOf( GetSound , "Array" ) ){
							//
							GetGroup = GetSound[ 1 ];
							GetName = GetSound[ 0 ];
							
						} else {
							//
							GetGroup = "";
							GetName = GetSound;
						}
						
						// Lance le son et retourne son objet
						return PlaySound( GetGroup , GetName , Parametres );
				
					// Si le noise n'existe pas —— - - Trace l'erreur
					} else {
						//
						TraceError( "SoundProcess" , "PlayNoise" , "Le son \"" + Nom + "\" est introuvable dans le groupe \"" 
								  									+ Groupe + "\"" );
					}
				
				// Si le groupe n'existe pas —— - - Trace l'erreur
				} else {
					//
					TraceError( "SoundProcess" , "PlayNoise" , "Le groupe \"" + Groupe + "\" n'existe pas." );
				}
			
			// Sinon —— - - Trace l'erreur
			} else {
				//
				TraceError( "SoundProcess" , "PlayNoise" , "Impossible de trouver le noise \"" + Nom + "\" parmis les groupes." );
			}
			
			// Retourne rien
			return null;
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					  HELP					  		  					  */
		/*							  Méthodes d'aide générale à l'utilisation du script 			  		  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - TRACE - - —————————————————————————————————————————— */
		// Les méthodes pour tracer des informations
		//*—*//
		
		// —————— TELL ME
		// Donne le contenu des sons enregistré
		
		public function TellMe( Total:Boolean = false	// ———— - - S'il indique chaque paramètres également
							   ):void {
			/*—*/
			
			// Trait
			Tr();
			
			// Tableau de sortie
			var Sortie:Array = new Array();
			
			// Pour chaque groupe —— - -
			for( var iGroupe:* in Sounds ){
				
				// Séparateur
				Sortie.push( "——————————————————" );
				
				// S'il n'est pas null —— - -
				if( Sounds[ iGroupe ] ){
					
					// Ajoute le nom du groupe
					Sortie.push( iGroupe );
					
					// S'il faut donner ses parametres —— - -
					if( Total ){
						
						// Pour chaque parametres —— - -
						for( var iGroupeParam:* in Sounds[ iGroupe ].Parametres ){
							
							// S'il n'est pas null
							if( Sounds[ iGroupe ].Parametres[ iGroupeParam ] != null ){
							
								// Ajoute le parametres
								Sortie.push( "\t" + iGroupeParam + " : " + Sounds[ iGroupe ].Parametres[ iGroupeParam ] );
							}
						}
					}
					
					// Pour chaque son —— - -
					for( var iSound:* in Sounds[ iGroupe ] ){
						
						// S'il n'est pas les parametres et pas null —— - -
						if( Sounds[ iGroupe ][ iSound ] && iSound != "Parametres" ){
							
							// Ajoute le nom du son
							Sortie.push( "\t\t" + iSound );
					
							// S'il faut donner ses parametres —— - -
							if( Total ){
								
								// Pour chaque parametres —— - -
								for( var iGroupeSound:* in Sounds[ iGroupe ][ iSound ] ){
									
									// S'il n'est pas null —— - -
									if( Sounds[ iGroupe ][ iSound ][ iGroupeSound ] != null ){
									
										// Ajoute le parametres
										Sortie.push( "\t\t\t" + iGroupeSound + " : " + Sounds[ iGroupe ][ iSound ][ iGroupeSound ] );
									}
								}
							}
						}
					}
				}
			}
			
			// Trace l'ensemble
			TraceAll( Sortie );
		}
			
		  
  		
  		
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}