﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			VIDEO PROCESS	  		Version 0.1.0									***/
/***				   				   Dernière Mise à Jour : 10-08-14										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         				  Gestionnaire Vidéo											***/
/***						Ce script permet d'archiver et appliquer des vidéos.   							***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Media {

	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	
	// —— - - DISPLAY
	import flash.display.MovieClip;
	//
	// —— - - EVENT
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.StatusEvent;
	import flash.events.ActivityEvent;
	import flash.events.NetStatusEvent;
	//
	// —— - - MEDIA
	import flash.media.Video;
	//
	// —— - - NET
	import flash.net.NetConnection;
	import flash.net.NetStream;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;

	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class VideoProcess extends MiscTools {
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function VideoProcess( TheLink:* = null		// ———— - - Lien vers la scène
									 ):void {
			/*—*/
			
			// Établit la connexion
			Connexion( TheLink );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 VIDEO					  		  					  */
		/*									Méthodes pour charger et afficher des vidéos 					  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Méthodes de chargement et manipulation de vidéo
		//*—*//
		
		// —————— LOAD VIDEO
		// Lance le chargement et l'intégration d'une vidéo
	
		public function LoadVideo( Conteneur:* ,			// ———— - - Conteneur de la vidéo
								   Lien:String = "" ,		// ———— - - Lie nexterne vers le .flv de la vidéo
								   Largeur:Number = -1 ,	// ———— - - Largeur de la vidéo
								   Hauteur:Number = -1 ,	// ———— - - Hauteur de la vidéo
								   Nom:String = "Video" ,	// ———— - - Nom de la vidéo
								   Parametres:Object = null	// ———— - - Parametres de la vidéo
								 ):MovieClip {
			/*—*/
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			//
			Parametres.smoothing = Parametres.smoothing || false;
			Parametres.Boucle = Parametres.Boucle || false;
			//
			Parametres.FonctionsTemporelle = Parametres.FonctionsTemporelle || null;
	
			// Si une vidéo du même nom existe déjà et qu'on ne fait pas de cumul
			if( Conteneur[ Nom ] && !Parametres.Cumulable ){
				//
				// Retire la vidéo précédente
				DestroyElement( Conteneur[ Nom ] );
			}
			
			// S'il a donné une tête modifiable et un lien MousePort ou pas de tête modifiable —— - -
			if( Parametres.TeteModifiable && Parametres.Mouse || ! Parametres.TeteModifiable ){
				
				// Création du conteneur de vidéo interne
				var Interne:MovieClip = NewElement( MovieClip , Conteneur , Nom , { drOIdeType:"Video" } );
				
				// Création de la Vidéo
				var RetourVideo:Video = Interne.Video = new Video( ( ( Largeur == -1 ) ? null : Largeur ) ,
																   ( ( Hauteur == -1 ) ? null : Hauteur ) );
				
				// Parametres pour l'ensemble
				Interne.Parametres = Parametres;
				
				// Parametres de la vidéo
				RetourVideo.smoothing = Parametres.smoothing;
				
				// Affiche le rendu
				Interne.addChild( RetourVideo );
				
				// Créait la connection de vidéo
				var laConnection:NetConnection = Interne.Connection = new NetConnection();
				laConnection.connect( null );
				
				// Élément de connection Streaming
				var leStream:NetStream = Interne.Stream = new NetStream( laConnection );
				
				// Au chargement ou relancement de la vidéo —— - -
				Interne.FinChargement = function( Data:Object ):void {
					
					// Donne la taille de la video.
					RetourVideo.width = Data.width;
					RetourVideo.height = Data.height;
					
					// Calibre la taille de la vidéo
					Interne.width = ( ( Largeur == -1 ) ? Interne.width : Largeur );
					Interne.height = ( ( Hauteur == -1 ) ? Interne.height : Hauteur );
					
					// Recupére la durée totale et le pourcentage
					Interne.Duree = Data.duration;
					Interne.Pourcentage = 0;
				}
				
				// Status checking de la vidéo —— - -
				Interne.StatusCheck = function( event:NetStatusEvent ):void {
				
					// Récupération du code
					try{ var Code:String = event.info.code; } catch ( e ){}
					
					// S'il y a des parametres —— - -
					if( Interne.Parametres ){
						
						// En Stop —— - -
						if ( Code == "NetStream.Play.Stop" ) {
							
							// Relance la vidéo s'il boucle
							if( Interne.Parametres.Boucle ){ Interne.Stream.seek( 0 ); }
							
							// Lance la fonction associée
							Launch( Interne.Parametres.Stop );
						}
						
						// En Stop —— - -
						if ( Code == "NetStream.Play.Start" ){
							
							// Lance la fonction associée
							Launch( Interne.Parametres.Start );
						}
						
						// En Stop —— - -
						if ( Code == "NetStream.Buffer.Full" ){
							
							// Lance la fonction associée
							Launch( Interne.Parametres.Full );
						}
						
						// En Stop —— - -
						if ( Code == "NetStream.Buffer.Flush" ){
							
							// Lance la fonction associée
							Launch( Interne.Parametres.Flush );
						}
						
						// En Stop —— - -
						if ( Code == "NetStream.Seek.Notify" ){
							
							// Lance la fonction associée
							Launch( Interne.Parametres.Notify );
						}
					}
				}
				//
				// Attache l'événement de vérification de status
				leStream.addEventListener( NetStatusEvent.NET_STATUS , Interne.StatusCheck );
				
				// Rattache les événements
				leStream.client = { onMetaData : Interne.FinChargement , 
									NetStatusEvent : Interne.StatusCheck };
				
				// Attache le streaming
				RetourVideo.attachNetStream( leStream );
				
				// Charge la vidéo
				leStream.play( Lien + ".flv" );
				
				
				// Donne les méthodes de manipulation —— - -
				//
				// STOP
				Interne.Stop = function():void {
					
					// Met à zéro
					Interne.Stream.seek( 0 );
					
					// Interrompt
					Interne.Stream.pause();
				}
				//
				// PAUSE
				Interne.Pause = function( Etat:Boolean = true ):void {
					
					// Pause
					if( Etat ){ Interne.Stream.pause(); }
					//
					// Dépause —— - -
					else { 
						
						// S'il n'est pas à la fin
						if( Interne.Temps < Math.floor( Interne.Duree ) ){
							//
							Interne.Stream.resume(); 
						
						// S'il est à la fin —— - -
						} else {
							
							// Remet au début
							Interne.Stream.seek( 0 );
							
							// Joue
							Interne.Stream.resume(); 
						}
					}
				}
				//
				// PAUSE
				Interne.Switch = function( Etat:Boolean = true ):void {
					
					// Toggle la pause
					Interne.Stream.togglePause();
				}
				//
				// POSITION
				Interne.Position = function( Valeur:Number = 0 ,		// Valeur
											 Modification:String = "="	// Modificateur
											):void {
					
					// Egalité —— - -
					if( Modification == "=" ){
						
						// Modifie la valeur
						Interne.Stream.seek( Valeur );
					
					} else if( Modification == "+" ){
						
						// Modifie la valeur
						Interne.Stream.seek( Interne.Temps + Valeur );
						
					} else if( Modification == "*" ){
						
						// Modifie la valeur
						Interne.Stream.seek( Interne.Temps * Valeur );
					}
				}
				
				Interne.Boucle = function( event:Event ):void {
					
					// Essaye —— - -
					try {
						
						// Sauvegarde la tête
						Interne.Temps = Interne.Stream.time;
						
						// Modifie la valeur du pourcentage
						Interne.Pourcentage = Interne.Temps / Interne.Duree * 100;
						
						// S'il y a des fonctions temporelle —— - -
						if( Parametres.FonctionsTemporelle ){
							
							// Pour chaque fonction temporelle
							for( var Fonc:* in Parametres.FonctionsTemporelle ){
								
								// S'il s'agit du temps en court ou pas loin —— - -
								if( Math.round( Interne.Temps ) == Fonc && !Parametres.FonctionsTemporelle[ Fonc ].Actif ){
									
									// Lance la méthode
									Launch( Parametres.FonctionsTemporelle[ Fonc ].Fonction );
									
									// La méthode est active
									Parametres.FonctionsTemporelle[ Fonc ].Actif = true;
								
								// S'il ne s'agit pas du temps en court —— - -
								} else if( Math.round( Interne.Temps ) != Fonc ){
									
									// Désactive la méthode
									Parametres.FonctionsTemporelle[ Fonc ].Actif = false;
								}
							}
						}
						
						// Mémorise la Sauvegarde de la tête
						Interne.MemoTemps = Interne.Stream.time;
						
						
						// Si on a une barre et une tete —— - -
						if( Parametres.Barre && Parametres.Tete ){
							
							// S'il y aun pourcentage —— - -
							if( !isNaN( Interne.Pourcentage ) ){
								
								// Si la tête est inactive —— - -
								if( !Parametres.Tete.Actif ){
									
									// Positionne la tête duction du pourcentage
									Parametres.Tete.x = Parametres.Barre.x + Parametres.Barre.width * Interne.Pourcentage / 100;
								
								// Si la tête est active —— - -
								} else {
									
									// Si la tête n'est pas sur la TimeLine —— - -
									if( !TypeOf( Parametres.Tete.parent , "MainTimeline" ) ){
									
										// Positionne la tête duction de la position souris en relatif à la taille barre
										Parametres.Tete.x = Parametres.Mouse.LocalX( Parametres.Tete.parent );
									
									} else {
									
										// Positionne la tête duction de la position souris en relatif à la taille barre
										Parametres.Tete.x = Parametres.Mouse.X;
									}
									
									// Bumpise la position de la tête
									Parametres.Tete.x = BumpNumber( Parametres.Tete.x , Parametres.Barre.x , Parametres.Barre.x + Parametres.Barre.width );
								}
							}
						}
					} catch( e ){}
				}
				//
				AddEvents( Interne , Interne.Boucle , "ENTER_FRAME" , "VideoLoop" );
				
				
				
				// S'il y a une tête de lecture et qu'on peut la repositionner —— - -
				if( Parametres.Tete && Parametres.TeteModifiable ){
					
					// Donne les fonction à la tête
					//
					// Active la tête —— - -
					Parametres.Tete.Active = function( event:MouseEvent ):void {
						//
						event.target.Actif = true; 
					}
					//
					// Désactive la tête —— - -
					Parametres.Tete.Desactive = function( event:MouseEvent ):void {
						
						// Si latête est active —— - -
						if( Parametres.Tete.Actif ){
							
							// Modifie la lecture en cour
							Interne.Position( ( ( Parametres.Tete.x - Parametres.Barre.x ) / Parametres.Barre.width ) * Interne.Duree );
									
							// Positionne la tête duction de la position souris en relatif à la taille barre
							Parametres.Tete.x = Parametres.Mouse.LocalX( Parametres.Tete.parent );
						}
						//
						Parametres.Tete.Actif = false; 
					}
					
					// Lui donne ses événements
					AddEvents( Parametres.Tete , Parametres.Tete.Active , "MOUSE_DOWN" , "VideoActive" );
					AddEvents( Parametres.Tete.stage , Parametres.Tete.Desactive , "MOUSE_UP" , "VideoDesactive" );
				}
			
			// Sinon —— - - Trace l'erreur
			} else {
				//
				TraceError( "VideoProcess" , "Charge" , "Si vous donnez une tête modifiable, vous devez donner un lien vers une MousePort par la clé «Mouse»." );
			}
				
			// Retourne le conteneur interne
			return Interne;
		}
		
		
		
	
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}