﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        				DEEP CAMERA	  	Version 0.3.0										***/
/***				   				   Dernière Mise à Jour : 10-09-10										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         			 Plug - Caméra de profondeur										***/
/***	Ce script génère une caméra dont la position a une influence sur les éléments filmés en x, y et z.  ***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Plug.camera {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	 
	// —— - - DISPLAY
	import flash.display.MovieClip;
	//
	// —— - - EVENT
	import flash.events.Event;
	//
	// —— - - UTILS
	import flash.utils.*;
	//
	// —— - - FILTRES
	import flash.filters.BlurFilter;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
    public class DeepCamera extends MiscTools {
		
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		// —————— PARAMETRES
		// Les parametres de la caméra
		//
		// Parametres de position
//		public var x:Number;
//		public var y:Number;
		public var z:Number;
		//
		// Parametres de champ
		public var angle:Number;
		public var zoom:Number;
		
		
		// —————— CONTENEUR
		// Le Conteneur des éléments filmés
		public var Conteneur:*;
		
		
		// —————— SCREEN
		// Les définitions pour le rendu à l'écran
		public var Screen:Object = new Object();
		
		
		// —————— FOCUS
		// Les altérations des éléments filmés selon la distance
		public var Focus:Object = new Object();
		
		
		// —————— LIMIT
		// Les limites physique de la caméra
		public var Limit:Object = new Object();
		
		
		// —————— ACTIVE
		// Activité de la caméra
		public var Active:Boolean = true;
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
        public function DeepCamera( LeConteneur:* ,				// ———— - - Le Conteneur des éléments filmés
									Parametres:Object = null  	// ———— - - Les Parametres de la camera
								 ):void {
			/*—*/
			
			
			// S'il peut se connecter —— - -
			if( Connexion( LeConteneur ) ){
				
				
				/* —— - - VARIABLES - - —— */
				/**/
				
				// Arguments par défaut
				Parametres = Parametres || new Object();
				
				// Récupère le conteneur
				Conteneur = LeConteneur;
				
				
				/* —— - - PARAMETRES - - —— */
				/**/
				
				// Récupération des données
				this.x = Parametres.x || 0;
				this.y = Parametres.y || 0;
				this.z = Parametres.z || 0;
				this.angle = Parametres.angle || 45;
				this.zoom = Parametres.zoom || 1;
				
				
				/* —— - - ÉCRAN - - —— */
				/**/
				
				// Récupération des données de l'écran
				Screen.x = Parametres.screenWidth || StageLink.stageWidth / 2;
				Screen.y = Parametres.screenWidth || StageLink.stageHeight / 2;
				
				
				/* —— - - FOCUS - - —— */
				/**/
				
				// Récupération des données du focus
				Focus.Lentille = Parametres.lent || 20;
				Focus.BrouillardDistance = Parametres.fog || false;
				Focus.DistanceBrouillard = Parametres.fogDistance || 100;
				Focus.MiseAuPoint = Parametres.focus || 5;
			
			
				/* —— - - FILM - - —— */
				/**/
				
				// Initialisation du tableau des acteurs
				Film.Acteurs = new Array();
				Film.NombreActeurs = 0;
				Film.Scene = Conteneur;
				
			
				/* —— - - CAMERA - - —— */
				/**/
				
				// Initialisation de la caméra
				Limit = { MaxX:Parametres.xMax ,
						   MinX:Parametres.xMin ,
						   MaxY:Parametres.yMax ,
						   MinY:Parametres.yMin ,
						   MaxZ:Parametres.zMax ,
						   MinZ:Parametres.zMin ,
						   MaxZoom:Parametres.zoomMax ,
						   MinZoom:Parametres.zoomMin || 1
						 };
				
				
				/* —— - - INITIALISATION - - —— */
				/**/
				
				// Donne les boucles à la caméra
				AddEvents( this , GlobalLoop , "ENTER_FRAME" );
			
			
			// S'il ne peut pas se connecter —— - - Trace l'erreur
			} else {
				//
				TraceError( "DeepCamera" , "Initialisation" , "Impossible de connecter la caméra au stage." );
			}
        }
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 GLOBAL					  		  					  */
		/*										  Gestion général du script 					  				  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - LOOP - - —————————————————————————————————————————— */
		// Les méthodes de gestion du script lancée en boucle
		//*—*//
		
		// —————— GLOBAL LOOP
		// Boucle central du script
		
		public function GlobalLoop( event:Event ):void {
			/*—*/
			
			/* —— - - CALIBRAGE - - —— */
			/**/
			
			// Lancement du Calibrage de l'opturateur
			ApplyLimit();
			
			
			/* —— - - ACTEUR - - —— */
			/**/
			
			// Si la caméra est active —— - -
			if( Active ){
				
				// pour chaque Acteur —— - -
				for( var O:Object in Film.Acteurs ){
					
					// S'il n'est pas null —— - -
					if( Film.Acteurs[ O ] ){
						
						// Récupère l'instance de l'objet Acteur
						var Acteur:* = Film.Acteurs[ O ];
						
						
						/* —— - - CALIBRAGE ESPACE - - —— */
						/**/
						
						// Lancement du Calibrage de l'acteur dans l'espace
						ApplyActorMove( Acteur );
							
							
						/* —— - - POSITION - - —— */
						/**/
						
						// Récupére sa position Z
						var PositionZ:Number = Acteur.z - this.z;
						
						// S'il est devant la caméra —— - -
						if( PositionZ > 0 ){
							
							// Il est visible
							Acteur.Clip.visible = true;
							// Positionne en X
							var PositionX:Number = Screen.x 
											   + ( Acteur.x - this.x )
											   / ( PositionZ / ( this.angle * this.zoom ) );
							//
							// Positionne en Y
							var PositionY:Number = Screen.y 
											   + ( Acteur.y - this.y )
											   / ( PositionZ / ( this.angle * this.zoom ) );
							//
							// Effectue le positionnement
							Acteur.Clip.x = PositionX;
							Acteur.Clip.y = PositionY;
							
							
							/* —— - - TAILLE - - —— */
							/**/
							
							// Établie le changement de taille
							var PourcentageTaille:Number = PositionZ / this.angle;
							//
							// Effectue le changement de taille
							Acteur.Clip.width = ( Acteur.w / PourcentageTaille ) * this.zoom;
							Acteur.Clip.height = ( Acteur.h / PourcentageTaille ) * this.zoom;
							
							
							/* —— - - FOCUS - - —— */
							/**/
							
							// Si la caméra effectue les brouillard de distance
							if( Focus.BrouillardDistance ){
								
								// Si l'élément est suffisemment loin et est visible —— - -
								if( PositionZ > Focus.DistanceBrouillard && Acteur.Clip.alpha > 0 ){
									
									// L'élément devient invisible de façon fluide
									Acteur.Clip.alpha += -Acteur.Clip.alpha / Focus.MiseAuPoint;
									
								
								// Si l'élément n'est pas suffisemment loin mais est invisible —— - -
								} else if( PositionZ < Focus.DistanceBrouillard && Acteur.Clip.alpha < 1 ) {
									
									// L'élément devient visible de façon fluide
									Acteur.Clip.alpha += ( 1 - Acteur.Clip.alpha ) / Focus.MiseAuPoint;
								}
							}
							
							
						/* —— - - INVISIBLE - - —— */
						/**/
						
						// Si l'élément est derrière la caméra —— - -
						} else {
				
							// Il est invisible
							Acteur.Clip.visible = false;
						}
					}
				}
			}
		}
		
		
		// —————— APPLY ACTORS DEEP
		// Applique l'empilement des acteurs
		
		private function ApplyActorsDeep():void {
			/*—*/
			
			/* —— - - CLASSEMENT - - —— */
			/**/
			
			// Tableau de classement des acteurs
			var InstantActeurs:Array = new Array();
			
			// Tans que l'on a pas récupéré la totalité des acteurs —— - -
			while( InstantActeurs.length != Film.NombreActeurs ){
				
				// Mise à zéro de la tête du plus loin
				var Lointain:Object = { Numero:0 , z:-1000000000000000000000000000000 };
				
				// Pour chaque acteur —— - -
				for( var Act:* in Film.Acteurs ){
					
					// S'il n'est pas null —— - -
					if( Film.Acteurs[ Act ] ){
						
						// S'il est le plus éloigné et n'a pas déjà été récupéré —— - -
						if( Film.Acteurs[ Act ].z > Lointain.z && InstantActeurs.indexOf( Act ) == -1 ){
							
							// La tête du plus loin est mis sur lui
							Lointain.z = Film.Acteurs[ Act ].z;
							Lointain.Numero = Act;
						}
					}
				}
				
				// Récupére celui qui a eu la tête du plus loin au final
				InstantActeurs.push( Lointain.Numero );
			}
			
			
			// Insére le dernier n'ayant pas été mis ( Celui le plus prés )
			//
			// Pour chaque acteur —— - -
			for( var ActLast:* in Film.Acteurs ){
				
				// S'il n'est pas null —— - -
				if( Film.Acteurs[ ActLast ] ){
					
					// S'il n'a pas déjà été récupéré —— - -
					if( InstantActeurs.indexOf( ActLast ) == -1 ){
						
						// Le récupére
						InstantActeurs.push( ActLast );
					}
				}
			}
			
			
			/* —— - - REEMPILEMENT - - —— */
			/**/
			
			// Pour chaque acteur, du plus loin au plus proche —— - -
			for( var i:int = 0 ; i < InstantActeurs.length ; i++ ){
				
				// Place cette acteur dans la scène, les derniers étant devant les premiers
				Film.Scene.addChild( Film.Acteurs[ InstantActeurs[ i ] ].Clip );
			}
			

			// Pour chaque acteur prioritaire, du plus loin au plus proche —— - -
			for( var j:int = 0 ; j < InstantActeurs.length ; j++ ){
				
				// Place cette acteur dans la scène, les derniers étant devant les premiers, s'il est prioritaire
				if( Film.Acteurs[ InstantActeurs[ j ] ].Clip.Prioritaire ){
						Film.Scene.addChild( Film.Acteurs[ InstantActeurs[ j ] ].Clip );
				}
			}
		}
		
		
		// —————— APPLY ACTOR SPACE						 	
		// Calibre un acteurs dans l'espace au cas où il bouge
		
		private function ApplyActorMove( Acteur:*	// ———— - - L'Acteur concerné
										):void {
			/*—*/
			
			// Si l'acteur est âpte à bouger —— - -
			if( Acteur.Clip.Mouvement ){
				
				// Pour chacun de ses état —— - -
				for( var Etat:* in Acteur.Clip.Deep ){
					
					// S'il s'agit de l'état en z, sauvegarde le dernier en date
					if( Etat == "z" ){ var SaveEtat:Number = Acteur[ Etat ]; }
					
					// Modifie l'état
					Acteur[ Etat ] = Acteur.Clip.Deep[ Etat ];
					
					// S'il a bougé en z, recalibre l'empilement des clips suivant les z
					if( !isNaN( SaveEtat ) ){ if( SaveEtat != Acteur[ Etat ] ){ ApplyActorsDeep(); } }
				}
			}
		}
		
		
		// —————— APPLY LIMIT						 	
		// Calibre la caméra par rapport à ses limites
		
		private function ApplyLimit():void {
			/*—*/
			
			// Zoom
			if( Limit.MinZoom && this.zoom < Limit.MinZoom ){
				//
				this.zoom = Limit.MinZoom; 
				//
			} else if( Limit.MaxZoom && this.zoom > Limit.MaxZoom ){
				//
				this.zoom = Limit.MaxZoom; 
			}
			
			// Position X
			if( Limit.MinX && this.x < Limit.MinX ){ 
				//
				this.x = Limit.MinX; 
				//
			} else if( Limit.MaxX && this.x > Limit.MaxX ){ 
				//
				this.x = Limit.MaxX; 
			}
			
			// Position Y
			if( Limit.MinY && this.y < Limit.MinY ){
				//
				this.y = Limit.MinY; 
				//
			} else if( Limit.MaxY && this.y > Limit.MaxY ){ 
				//
				this.y = Limit.MaxY; 
			}
			
			// Position Z
			if( Limit.MinZ && this.z < Limit.MinZ ){
				//
				this.z = Limit.MinZ; 
				//
			} else if( Limit.MaxZ && this.z > Limit.MaxZ ){ 
				//
				this.z = Limit.MaxZ; 
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 ACTOR					  		  					  */
		/*										  Contrôle des éléments filmés 					  				  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
		
		// —————— FILM
		// Les éléments filmés par la caméra
		private var Film:Object = new Object();
		
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Les méthodes pour modifier les acteurs présents dans l'espace 3D
		//*—*//
		
		// —————— ADD ACTOR
		// Place un clip dans l'espace 3D de la caméra
		
		public function AddActor( Clip:* ,					// —— - - L'Élément filmé
								  Parametres:Object = null	// —— - - Les Parametres de l'acteur
								 ):void {
			/*—*/
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			//
			var X:Number = Parametres.x || Clip.x;
			var Y:Number = Parametres.y || Clip.y;
			var Z:Number = Parametres.z || this.angle;
			//
			var W:Number = Parametres.width || Clip.width;
			var H:Number = Parametres.height || Clip.height;
			//
			var Mvm:Boolean = Parametres.movement || false;
			var Prioritaire:Boolean = Parametres.priority || false;
			
			// Création de l'objet de ce nouvel acteur
			Film.Acteurs[ Film.Acteurs.length ] = new Object();
			//
			// Donne les paramètres de ce nouvel acteur
			Film.Acteurs[ Film.Acteurs.length - 1 ].Clip = Clip;
			Film.Acteurs[ Film.Acteurs.length - 1 ].x = X;
			Film.Acteurs[ Film.Acteurs.length - 1 ].y = Y;
			Film.Acteurs[ Film.Acteurs.length - 1 ].z = Z;
			Film.Acteurs[ Film.Acteurs.length - 1 ].w = W;
			Film.Acteurs[ Film.Acteurs.length - 1 ].h = H;
			//
			Film.Acteurs[ Film.Acteurs.length - 1 ].Defaut = new Object();
			Film.Acteurs[ Film.Acteurs.length - 1 ].Defaut.x = Clip.x;
			Film.Acteurs[ Film.Acteurs.length - 1 ].Defaut.y = Clip.y;
			Film.Acteurs[ Film.Acteurs.length - 1 ].Defaut.width = Clip.width;
			Film.Acteurs[ Film.Acteurs.length - 1 ].Defaut.height = Clip.height;
			Film.Acteurs[ Film.Acteurs.length - 1 ].Defaut.alpha = Clip.alpha;
			
			
			// Donne les clées pour agir sur l'état de l'acteur
			Clip.Deep = new Object();
			Clip.Deep.x = Film.Acteurs[ Film.Acteurs.length - 1 ].x;
			Clip.Deep.y = Film.Acteurs[ Film.Acteurs.length - 1 ].y;
			Clip.Deep.z = Film.Acteurs[ Film.Acteurs.length - 1 ].z;
			Clip.Deep.w = Film.Acteurs[ Film.Acteurs.length - 1 ].w;
			Clip.Deep.h = Film.Acteurs[ Film.Acteurs.length - 1 ].h;
			//
			Clip.Mouvement = Mvm;
			Clip.Prioritaire = Prioritaire;
			//
			Clip.Deep.Stop = function():void {
				//
				RemoveActor( Clip );
			}
				
			// Donne à l'élément le levier qui le relie à DeepCamera
			Clip.Link2DeepCamera = this;
			
			
			// S'il y a un flou de distance —— - -
			if( Focus.FlouDistance ){
				
				// Donne la variable de flou à l'acteur
				Clip.Flou = new BlurFilter( Focus.Lentille , Focus.Lentille );
			}
			
			
			// Augmente de 1 le nombre d'acteurs
			Film.NombreActeurs++;
			
			// Lance le calibrage des acteurs
			ApplyActorsDeep();
		}
		
		
		// —————— REMOVE ACTOR
		// Retire un élément de l'espace 3D de la Caméra
		
		public function RemoveActor( Clip:* , 					// ———— - - Le Clip choisit
							         Defaut:Boolean = false		// ———— - - Si on remet ses formes et position par défaut
							       ):void {
			/*—*/
			
			// Pour chaque acteur —— - -
			for( var Acteurs in Film.Acteurs ){
				
				// S'il n'est pas null —— - -
				if( Film.Acteurs[ Acteurs ] ){
					
					// Si c'est l'acteur que l'on cherche —— - -
					if( Film.Acteurs[ Acteurs ].Clip == Clip ){
						
						// Si on lui remet ses formes par défaut —— - -
						if( Defaut ){
							
							// Lui remet ses formes par défaut
							Clip.x = Film.Acteurs[ Acteurs ].Defaut.x;
							Clip.y = Film.Acteurs[ Acteurs ].Defaut.y;
							Clip.width = Film.Acteurs[ Acteurs ].Defaut.width;
							Clip.height = Film.Acteurs[ Acteurs ].Defaut.height;
							Clip.alpha = Film.Acteurs[ Acteurs ].Defaut.alpha;
						}
						
						// Retire cet acteur de l'espace 3D
						Film.Acteurs[ Acteurs ] = null;
						
						// Réduit le nombre d'acteur
						Film.NombreActeurs--;
				
						// Lance le calibrage des acteurs
						ApplyActorsDeep();
					}
				}
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					  MAP					  		  					  */
		/*				  Contrôle de la caméra et des acteurs par le biais de Map composées de clip 			  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Les fonctions pour créer et contrôler une map
		//*—*//
		
		// —————— MAP MAKE FILM
		// À partir d'un clip basé sur du mapping, dispatch dans l'espace 3D les élément de la map
		
		public function MapMakeFilm( Map:* , 			// ———— - - La Map
								     Decors:* = null	// ———— - - L'Espace dans lequel sont dispatchés les éléments
								   ):void {
			/*—*/
			
			// Arguments par défaut
			Decors = Decors || Conteneur;
			
			// Pour chaque élément dans la map —— - -
			for( var i:int ; i < Map.numChildren ; i++ ){
				
				// S'il a une classe autre que Movieclip et n'est pas la caméra ou la grille —— - -
				if( !TypeOf( Map.getChildAt( i ) , "MovieClip" )
				 && !FindIn( TypeOf( Map.getChildAt( i ) ) , "Camera" )
				 && !FindIn( TypeOf( Map.getChildAt( i ) ) , "Grille" )){
					
					// Récupére le nom
					var LinkName:String = Map.getChildAt( i ).name;
					
					// Donne la variable d'instance de l'élément de la map
					Map[ LinkName ] = Map[ LinkName ] || Map.getChildAt( i );
					
					// Créait l'objet pour l'espace
					var Element:* = NewElement( getDefinitionByName( Pop( TypeOf( Map.getChildAt( i ) ) , "Map" ) ) as Class , 
											    Decors ,
											    LinkName
											 );
					
					// Donne le lien de l'objet map à l'objet espace et inversement
					Element.ObjetMap = Map.getChildAt( i );
					Map.getChildAt( i ).ObjetEspace = Element;
					
					// Mes l'objet dans l'espace
					AddActor( Element , { movement:true } );
				}
			}

			// Annonce la map pour l'espace
			MapToFilm( Map );
		}
		
		
		// —————— NEW MAP ELEMENT
		// Insére un élément sur une map et dans l'espace 3D
		
		public function NewMapElement( Element:* ,			// ———— - - Class de l'élément ,
									   Map:* , 				// ———— - - La Map
									   Nom:String ,			// ———— - - Nom de l'élément
									   Parametres:Object ,	// ———— - - Parametrages de l'élément sur la map
								       Decors:* = null		// ———— - - L'espace dans lequel est placés l'élément
								  ):* {
			/*—*/
			
			// Arguments par défaut
			Decors = Decors || Conteneur;
			
			// Insére l'élément
			var NouvelElement:* = NewElement( Element , Map , Nom , Parametres );
		
			// Récupére le nom
			var LinkName:String = NouvelElement.name;
			
			// Donne la variable d'instance de l'élément de la map
			Map[ LinkName ] = Map[ LinkName ] || NouvelElement;
			
			// Créait l'objet pour l'espace
			var Element:* = NewElement( getDefinitionByName( Pop( TypeOf( NouvelElement ) , "Map" ) ) as Class , 
										Decors ,
										LinkName
									 );
			
			// Donne le lien de l'objet map à l'objet espace et inversement
			Element.ObjetMap = NouvelElement;
			NouvelElement.ObjetEspace = Element;
			Element.DecorsEspaceParent = Decors;
			
			// Invisible au départ pour éviter de le voir avant placement
			Element.alpha = 0;
			//
			Element.Apparait = function():void { Element.alpha = 1; }
			//
			CountdownLaunch( { Fonction:Element.Apparait } , 1 );
			
			// Mes l'objet dans l'espace
			AddActor( Element , { movement:true } );
			
			// Retourne l'élément de la map
			return NouvelElement;
		}
		
		
		// —————— DESTROY MAP ELEMENT
		// Retire un élément d'une map et dans l'espace 3D
		
		public function DestroyMapElement( MapElement:*		// ———— - - Element concerné
										 ):void {
			/*—*/
			
			// S'il y a un objet dans l'espace relié à l'élément de map —— - -
			if( MapElement.ObjetEspace ){
				
				// Fait quitter l'espace à l'objet dans l'espace
				RemoveActor( MapElement.ObjetEspace );
				
				// Annihile l'objet map et l'objet espace
				DestroyElement( MapElement.ObjetEspace , MapElement.ObjetEspace.DecorsEspaceParent );
				DestroyElement( MapElement );
				
			// S'il n'y a pas d'objet dans l'espace relié à l'élément de map —— - - Trace l'erreur
			} else {
				//
				TraceError( "DeepCamera" , "DestroyMapElement" , [ "L'élément " + MapElement.name + " n'a pas de variable «ObjetEspace»." ,
																    "Vérifiez qu'il s'agit bien d'un objet de map." ] );
			}	
		}
		
		
		
		/* —————————————————————————————————————————— - - CONVERSION - - —————————————————————————————————————————— */
		// Les fonctions pour convertir des éléments entre map et espace 3D
		//*—*//
		
		// —————— MAP TO FILM
		// À partir d'une map, créait un assemblage d'acteur
		
		public function MapToFilm( Map:* ,					// ———— - - Clip de la Map
								   MultiX:Number = 10 ,		// ———— - - Multiplicatif en X
								   MultiY:Number = 1000 ,	// ———— - - Multiplicatif en Y
								   MultiZ:Number = 1		// ———— - - Multiplicatif en Z
								  ):void {
			/*—*/
			
			// Donne la boucle à l'objet de fonction —— - -
			var MapToFilmBoucle:Function = function( event:Event ):void {
	
				// Récupére l'instance de l'acteur —— - -
				var lesActeurs:int = Map.numChildren;
				
				// Pour chaque élément dans la map —— - -
				for( var i:int = 0 ; i < lesActeurs ; i++ ){
					
					// Récupére son instance et créait les variable de transit d'instance
					var Acteur:* = Map.getChildAt( i );
					var SpaceActeur:* = null;
					var MapActeur:* = Map[ Acteur.name ];
					
					// Pour chaque acteur —— - -
					for( var k:* in Film.Acteurs ){
						
						// S'il n'est pas null —— - -
						if( Film.Acteurs[ k ] ){
							
							// S'il porte le même nom —— - -
							if( Film.Acteurs[ k ].Clip.name == Acteur.name ){
								
								// Récupére son instance
								SpaceActeur = Film.Acteurs[ k ].Clip;
							}
						}
					}
					
					// Si on a trouvé un acteur pour cet élément de map —— - -
					if( SpaceActeur ){
						
						// Calibre l'acteur selon la position de l'élément de map
						SpaceActeur.Deep.x = MapActeur.x * MultiX;
						SpaceActeur.Deep.z = -MapActeur.y * MultiZ;
						SpaceActeur.Deep.y = ( 1 - MapActeur.scaleX ) * MultiY;
						
					// S'il s'agit de la caméra —— - -
					} else if( Acteur.name == "Camera" ){
						
						// Calibre la position de la caméra en fonction de l'élément caméra
						this.x = ( MapActeur.x * MultiX );
						this.y = ( ( 1 - MapActeur.scaleX ) * MultiY );
						this.z = ( -MapActeur.y * MultiZ );
					}
				}
			}
			//
			// Donne l'événement de boucle
			AddEvents( this , MapToFilmBoucle , "ENTER_FRAME" );
		}
		
		
		// —————— FILM TO MAP
		// Lie les placements des éléments d'un map 2D aux placement des éléments de l'interface 3D
		
		public function FilmToMap( Map:* ,					// ———— - - Clip de la Map
								   MultiX:Number = 10 ,		// ———— - - Multiplicatif en X
								   MultiY:Number = 1000 ,	// ———— - - Multiplicatif en Y
								   MultiZ:Number = 1		// ———— - - Multiplicatif en Z
								   ):void {
			/*—*/
			
			// Donne la boucle à l'objet de fonction —— - -
			var FilmToMapBoucle:Function = function( event:Event ):void {
				
				// Pour chaque acteur —— - -
				for( var i:* in Film.Acteurs ){
					
					// Récupère son instance et l'instance de son élément sur la map
					var SpaceActeur:* = Film.Acteurs[ i ].Clip;
					var MapActeur:* = Map[ SpaceActeur.name ];
					
					// Si l'acteur à son élément sur la map —— - -
					if( MapActeur ){
						
						// Replace l'élément sur la map ▼
						//
						// Par position
						MapActeur.x = SpaceActeur.Deep.x / MultiX;
						MapActeur.y = -SpaceActeur.Deep.z / MultiZ;
						//
						// Et taille
						MapActeur.scaleX = 1 - SpaceActeur.Deep.y / MultiY;
						MapActeur.scaleY = 1 - SpaceActeur.Deep.y / MultiY;
					}
				}
				
				// S'il y a la caméra sur la map —— - -
				if( Map.Camera ){
					
					// Replace l'élément de caméra sur la map ▼
					//
					// Par position
					Map.Camera.x = this.x / MultiX;
					Map.Camera.y = -this.z / MultiZ;
					//
					// Et taille
					Map.Camera.scaleX = 1 - this.y / MultiY;
					Map.Camera.scaleY = 1 - this.y / MultiY;
				}
				
				// Mes les clips dans l'ordre
				ViewBy( Map , "scaleX" );
			}
			//
			// Donne l'événement de boucle
			AddEvents( this , FilmToMapBoucle , "ENTER_FRAME" );
		}
		
		
		
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}