﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			CONSOLE POST	  		Version 0.3.0									***/
/***				   				   Dernière Mise à Jour : 10-09-09										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         		   Plug - Console de test et débug										***/
/***	Ce script génére une console à la façon des consoles de test de tous jeux et autres programmes 	    ***/
/***	dévellopés.																							***/
/***	Cette console permet de lancer des appels de lecture de variable ou de fonction, entre autre,  		***/
/***	afin de les tester en temps réel et, ainsi, gagner du temps sur le debuging.				 		***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Plug.control {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	
	// —— - - DISPLAY
	import flash.display.MovieClip;
	import flash.display.Sprite;
	//
	// —— - - TEXT
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFieldType
	//
	// —— - - EVENT
	import flash.events.Event;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	import drOIde.Port.*;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class ConsolePost extends MiscTools {
		
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		// —————— PARAMETRES
	    // Largeur et Hauteur initiales de la console
		public var Width:Number;
		public var Height:Number;
		//
	    // Activité de la console
		public var Active:Boolean = true;
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function ConsolePost( Centre:* = null ,		// ———— - - Le Centre de déploiement des recherches de la console
									 Conteneur:* = null ,	// ———— - - Le Conteneur recevant la console
									 TexteInit:* = null 	// ———— - - Le Texte initiale de la console
									){
			/*—*/
			
			// Lance la tentative de connexion drOIde, Si réussis —— - -
			if( Connexion( Centre ) ){
				
				// Switch des arguments
				if( TypeOf( Conteneur , "String" ) ){
					//
					TexteInit = Conteneur;
					Conteneur = null
				}
				
				// Arguments par défaut
				Conteneur = Conteneur || RootLink;
				
				// Encapsule le texte
				TexteInit = CapsuleArray( TexteInit );
				
				// Récupère la taille de scène initiale
				Width = StageLink.stageWidth;
				Height = StageLink.stageHeight;
				
				// Création du fond de la console
				GenerationBody( Conteneur );
				
				// Création du format du texte de la console
				GenerationForm();
				
				// Création du texte de saisie et de sortie de la console
				GenerationInput( GenerationText( "Input" ) );
				GenerationReturn( GenerationText( "Return" ) );
				
				
				// Intégration du texte initiale
				for( var i:* in TexteInit ){ 
					//
					CheckText( TexteInit[ i ] ) 
				};
				//
				RefreshText();
				
				// Placement de la boucle
				AddEvents( this , GlobalLoop , "ENTER_FRAME" );
				
				// Création du clavier
				var Keyboard:KeyboardPort = new KeyboardPort( RootLink );
				//
				// Création des racourcies clavier
				Keyboard.NewShortKeyEvent( "Open" , Open , "CONTROL" , "NUMPAD_1" , 1 );
				Keyboard.NewShortKeyEvent( "Send" , Send , "CONTROL" , "NUMPAD_4" , 1 );
				//
				Keyboard.NewShortKeyEvent( "ShiftAvant" , { Fonction:Shift , Argument:-1 } , "CONTROL" , "NUMPAD_2" , 1 );
				Keyboard.NewShortKeyEvent( "ShiftArriere" , { Fonction:Shift , Argument:1 } , "CONTROL" , "NUMPAD_5" , 1 );
				
			// Si la connexion a échouée —— - - Trace l'erreur
			} else {
				//
				TraceError( "ConsolePost" , "Initialisation" , 
						    "Vous devez préciser, au minimum, le clip où l'instance auquelle est reliée la console lors de sa création." );
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	     					GLOBAL 				  	  							  */
		/*	 	   	 								Gestion global du Script		 					  		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
		
		// —————— PANNEL
	    // Le clip de la console
		public var Pannel:MovieClip;
		
		// —————— TEXTS
	    // Le texte de sortie et le texte de saisie de la console
		private var Input:TextField;
		private var Return:TextField;
		//
		// Le format des textes
		private var Form:TextFormat;
		
		
		/* —————————————————————————————————————————— - - LOOP - - —————————————————————————————————————————— */
		// Les méthodes tournant en boucle pour la gestion du script
		//*—*//
		
		// —————— GLOBAL LOOP
		// Boucle de contrôle général
		
		public function GlobalLoop( event:Event ){ 
			/*—*/
			
			// Place verticalement le panneau
			Pannel.y += ( Pannel.position - Pannel.y ) / 10;
			
			// Place horizontalement le panneau
			Pannel.x = ( StageLink.stageWidth - Width ) / -2;
			
			// Scale la largeur
			Pannel.Fond.width = StageLink.stageWidth;
			Input.width = StageLink.stageWidth;
			Return.width = StageLink.stageWidth;
			
			// Position Y
			Pannel.position = ( !Pannel.open ) ? Pannel.upPosition : Pannel.downPosition;
			Pannel.downPosition = ( StageLink.stageHeight - Height ) / -2;
			Pannel.upPosition = ( StageLink.stageHeight - Height ) / -2 -220;
		}
		
		
		
		/* —————————————————————————————————————————— - - RECEPTION - - —————————————————————————————————————————— */
		// Les méthodes de réception et traitement des textes dans la console
		//*—*//
		
		// —————— REFRESH TEXT
		// Provoque la mise à jour du texte présenté dans la console
		
		private function RefreshText():void {
			/*—*/
			
			// Effacemment des textes précédent
			Return.replaceText( 0 , Return.length , "" );
			
			// Définition de i pour piocher dans le tableau des données envoyées à la console.
			var i:int = ( Content.length < 12 ) ? -1 : Content.length - 12;
			
			// Tans que i ascendant n'outrepasse pas la dernière donnée du tableau des données
			while( i++ < Content.length - 1 ){
				
				// On récupére l'une des données pour l'afficher sur le panneau de sortie
				Return.appendText( Content[ i - ContentHead ] + "\n" );
			}
			
			// Mise du format au texte dynamique
			Return.setTextFormat( Form );
		}
	  	
		
		// —————— CHECK TEXT
		// Sonde le contenu d'un texte pour voir s'il doit en retourner un effet particulier
		
		private function CheckText( TexteCode:String	// ———— - - Le Code transmis
								  ):void {
			/*—*/
			
			// S'il y a du texte —— - -
			if( TexteCode ){
					
				// Mise du levier en activé
				var Levier:Boolean = true;
				
				// Pour chaque clé de CodeList —————— - -
				for( var iCode in CodeList ){
					
					// Si la clé en cour porte le même nom que l'appel de code —————— - -
					if( TexteCode.split( ":" )[ 0 ] == iCode ){
						
						// Si on ne le chut pas —— - -
						if( TexteCode.split( " Chut" ).length == 1 ){
							
							// Lance la fonction basé sur ce code
							this[ CodeList[ iCode ] ]( TexteCode );
							
						// Si on le chut —— - -
						} else {
							
							// Retaile le code pour enlever le chut
							TexteCode = Pop( TexteCode , " Chut" );
							
							// Lance la fonction basé sur ce code sans les commentaires
							this[ CodeList[ iCode ] ]( TexteCode , false , false );
						}
						
						// Désactive le levier
						Levier = false;
					}
				}
				
				// Lance la fonction par test Functions si le levier est resté activé ou met le texte normalement —— - -
				if( Levier ){ 
					
					// Si on trouve le code dans les Fonctions —— - -
					if( Functions[ TexteCode ] ){
						
						// Essaye —— - -
						try {
						
							// Lance cette fonction
							Launch( Functions[ TexteCode ] );
							
							// Ecrit
							Content.push( TexteCode );
						
						// Si échoue —— - - Trace l'erreur
						} catch( e ){
							//
							Content.push( " => Erreur : Impossible de lancer la fonction." );
						}
						
					// Sinon —— - - Mes le texte unique
					} else {
						//
						NormalCode( TexteCode );
					}
				}
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - COMMANDE - - —————————————————————————————————————————— */
		// Les méthodes pour agir sur la console
		//*—*//
	  
	  	// —————— OPEN
		// Ouvre la console ou la ferme
	  
		public function Open( Etat:* = "switch"	// ———— - - Etat à donner à l'ouverture de la console
							 ):void {
			/*—*/
			
			// Si la console est active —— - -
			if( Active ){
					
				// Si la console est cachée, elle apparaît, sinon, elle disparaît
				Pannel.open = ( Etat == "switch" ) ? !Pannel.open : Etat;
				
				// Si elle apparait —— - - Elle nous donne le focus
				if( Pannel.open ){
					//
					StageLink.focus = Input;
				}
			}
		}
	  	
		
		// —————— SEND
		// Transmet le contenu du champ de saisie à la console
		
		public function Send():void {
			/*—*/
			
			// Si la console est active —— - -
			if( Active ){
				
				// Si la console est ouverte —— - -
				if( Pannel.open ){
					
					// Remplacement de son texte par un texte initial
					Input.replaceText( 0 , Input.length , Pop( Input.text , "►" ) );
					
					// Modifie le texte pour exclure le «►»
					Input.text = Pop( Input.text , "►" );
					
					// Si le texte est vide —— - -
					if( Input.text == "" ){
						
						// Affiche une ligne de séparation
						Input.text = "———————————————————————————————————"
					}
					
					// Envoie le texte dans la saisie à l'analyse code de la console
					CheckText( Input.text );
					
					// Remplacement de son texte par un texte initial
					Input.replaceText( 0 , Input.length , "►" );
			
					// Rafraichissement du texte
					RefreshText();
					
				// Si la console est fermée —— - - L'ouvre
				} else { Pannel.open = true; }
			}
		}
	  	
		
		// —————— SHIFT
		// Décale l'affichage de la console
		
		public function Shift( Direction:int	// ———— - - La direction du décalage
							  ):void {
			/*—*/
			
			// Si la console est active —— - -
			if( Active ){
				
				
				// Vers l'arriere —— - -
				if( Direction < 0 ){
					
					// Si on n'est pas au min —— - -
					if( ContentHead > 0 ){
						
						// Baisse la tete
						ContentHead += Direction;
					}
				}
					
					
				// Vers l'avant —— - -
				if( Direction > 0 ){
					
					// Si on n'est pas au max —— - -
					if( ContentHead <= Content.length - 12 ){
						
						// Monte la tete
						ContentHead += Direction;
					}
				}
					
				// Rafraichissement du texte
				RefreshText();
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - CONSTRUCTION - - —————————————————————————————————————————— */
		// Les méthodes de construction de la console au lancement
		//*—*//
		
		// —————— GENERATION BODY
		// Créait le corps de la console
		
		private function GenerationBody( Conteneur:*	// ———— - - Le Conteneur de la console
									    ):void {
			/*—*/
			
			// Création du Sprite conteneur
			Pannel = NewElement( MovieClip , 
								 Conteneur , 
								 "ConsolePannel" , 
								{
									y:-220  ,
									position:-1000 ,
									downPosition:0 ,
									upPosition:-220 ,
									open:false
								} );
			//
			Pannel.Fond = new Sprite();
			Pannel.addChild( Pannel.Fond );
			
			// Dessin du rectangle noir à la largeur de l'écran
			Pannel.Fond.graphics.beginFill( 0x000000 , 1 );
			Pannel.Fond.graphics.lineTo( StageLink.stageWidth , 0 );
			Pannel.Fond.graphics.lineTo( StageLink.stageWidth , 200 );
			Pannel.Fond.graphics.lineTo( 0 , 200 );
			Pannel.Fond.graphics.endFill();
		}
		
	  
	  	// —————— GENERATION FORM
		// Créait le format de texte
		
		private function GenerationForm():void {
			/*—*/
			
			// Création du format
			Form = new TextFormat;
			
			// Mise de sa couleur
			Form.color = 0xD9D9D9;
		}
		
		
		// —————— GENERATION TEXT
		// Créait un champ de texte texte basique
		
		private function GenerationText( Nom:String	// ———— - - Section concernée ( Saisie ou Sortie )
									   ):TextField {
			/*—*/
			
			// Création de l'objet texte
			this[ Nom ] = new TextField;
			
			// Mise de sa taille
			this[ Nom ].width = StageLink.stageWidth;
			
			// Mise de son format
			this[ Nom ].setTextFormat( Form );
			
			// Mise graphiquement
			Pannel.addChild( this[ Nom ] );
			
			// Renvoie son chemin d'objet
			return( this[ Nom ] );
		}
		
		
		// —————— GENERATION INPUT
		// Calibre un champ de texte pour être le champ de saisie
		
		private function GenerationInput( LeTexte:TextField	// ———— - - Le Champ de texte
										):void {
			/*—*/
			
			// Définition de son type en texte de saisie
			LeTexte.type = TextFieldType.INPUT;
			
			// Placement en bas de la console
			LeTexte.y = 180;
			
			// Définition de sa taille
			LeTexte.height = 20;
			LeTexte.width = StageLink.stageWidth;
			
			// Remplacement de son texte par un texte initial
			LeTexte.replaceText( 0 , LeTexte.length , "►" );
			
			// Mise de son format
			LeTexte.setTextFormat( Form );
			
			// Fonction de changement du texte
			var TextChange:Function = function( event:Event ):void {
				//
				event.target.text = Pop( event.target.text , "►" );
			}
			//
			AddEvents( LeTexte , TextChange , "CHANGE" );
		}
		
		
		// —————— GENERATION RETURN
		// Calibre un champ de texte pour être le champ de retour
		
		private function GenerationReturn( LeTexte:TextField	// ———— - - Le Champ de texte
										):void {
			/*—*/
			
			// Mise en mode multiligne
			LeTexte.multiline = true;
			
			// Mise en mode "saut de ligne"
			LeTexte.wordWrap = true;
			
			// Définition de sa taille
			LeTexte.height = 180;
			
			// Définition de son type en texte dynamique
			LeTexte.type = TextFieldType.DYNAMIC;
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	     					TRACE 				  	  							  */
		/*	 	   	 						Transmettre un message via la console		 					  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
		
		// —————— CONTENT
		// Le tableau de contenu de la console
		private var Content:Array = new Array();
		//
		// La tête de lecture sur le contenu de la console
		public var ContentHead:int = 0;
		
		// —————— NUMERO
		// Le numéro en cours pour le Tn()
	  	var Numero:int = 0;
		
		
		
		/* —————————————————————————————————————————— - - TRACE - - —————————————————————————————————————————— */
		// Les méthodes pour transmettre des messages à la console
		//*—*//
	  
	  	// ——————  TRACE
	  	// Envoie un texte choisis
		
		public function trace( Valeur:*	// ———— - - La Valeur transmise
							  ):void {			
			/*—*/
			
			// Si la console est active ▼♥
			if( Active ){
				
				// Si le texte est vide —— - -
				if( !Valeur ){
					
					// Affiche une ligne de séparation
					Valeur = "null"
				}
				
				// Envoie le texte dans la saisie à l'analyse code de la console
				CheckText( Valeur );
				
				// Rafraichissement du texte
				RefreshText();
			}
		}
		
		
	  	// —————— TN
	  	// Envoie un texte par un numéro incrémentatif
		
		override public function Tn( leNumero:int = -1	// ———— - - Le numéro en court
									):void {			
			/*—*/
			
			// Si le numéro est négatif —— - -
			if( leNumero < 0 ){
				
				// Incrémente et affiche le numéro
				trace( Numero );
				Numero++;
				
			// Sinon —— - -
			} else {
				
				// Change et affiche le numéro
				Trace( leNumero );
				Numero = leNumero;
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	     					 CODES 				  	  							  */
		/*	 	   	 				   Codes spéciales provoquant des effets particuliers		 				  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
		
		// —————— FUNCTIONS
	    // Les fonctions ajoutées dynamiquement à la console
		public var Functions:* = new Object
		
		// —————— CODE LIST
	    // Tableau des codes à rentrer sur la console
		private var CodeList:Object = { SEE : 		"SeeCode" ,
									    TUCH : 		"TuchCode" ,
									    MOD : 		"ModCode" ,
									    REFRESH : 	"RefreshCode" ,
									    CUT : 		"CutCode" ,
									    MASSIVE : 	"MassiveCode"
									   };
									   
									
		
		/* —————————————————————————————————————————— - - NONE - - —————————————————————————————————————————— */
		// Les méthodes sans effets particuliers
		//*—*//
	  
	  	// —————— NORMAL CODE
		// Se contente d'ajouter le code à l'affichage
		
		private function NormalCode( Code:String	// ———— - - Le Code transmis
									):void {
			/*—*/
			
			Content.push( Code );
		}
			
									
		
		/* —————————————————————————————————————————— - - DISPLAY - - —————————————————————————————————————————— */
		// Les méthodes ayant un effet sur l'affichage de la console
		//*—*//
	  
	  	// —————— REFRESH CODE
		// Rafraichit l'affichage
		
		private function RefreshCode( Code:String	// ———— - - Le Code transmis
									 ):void {
			/*—*/
			
			// Vide le contenu
			Content = new Array();
		}
	  	
	  	
	  	// —————— CUT CODE
		// Rafraichit l'affichage depuis la ligne en cour
		private function CutCode( Code:String		// ———— - - Le Code transmis
								):void {
			/*—*/
			
			// Pour chaque éléments passé la tête —— - -
			for( var i:int = 0 ; i < ContentHead ; i++ ){
				
				// Retire l'élément
				Content.splice( Content.length - 1 , 1 );
			}
			
			// Mes la tête à zéro
			ContentHead = 0;
		}
		
		
		
		/* —————————————————————————————————————————— - - GET - - —————————————————————————————————————————— */
		// Les méthodes permettant de récupérer une valeur
		//*—*//
		
	  	// —————— SEE CODE
		// Affiche la valeur d'une variable par son chemin d'accés
		
		private function SeeCode( Code:String		// ———— - - Le Code transmis
								 ):void {
			/*—*/
			
			// Affiche le code
			Content.push( Code );
			
			// Vire le code
			Code = Pop( Code , "SEE:" );
			
			// Si possible —— - -
			try {
				
				// Récupère le lien
				var Lien:* = StringToElement( Code , RootLink );
				
				// Donne le lien
				Content.push( String( Lien ) );
				
			// Si échoue —— - - Trace l'erreur
			} catch( e ){
				//
				Content.push( " => Erreur : Le lien spécifié est introuvable" );
			}
		}
		
		
	  	// —————— MASSIVE CODE
		// Affiche une suite massive de ligne pour tester l'affichage de la console
		
		private function MassiveCode( Code:String		// ———— - - Le Code transmis
								     ):void {
			/*—*/
			
			// Debut
			trace( "———> DEBUT <———" );
			
			// Trente fois —— - -
			for( var i:int = 1 ; i <= 30 ; i++ ){
				//
				// Nouvelle ligne
				trace( i + " : " + RandomWord() );
			}
			
			// Fin
			trace( "———> FIN <———" );
		}
		
		
		
		/* —————————————————————————————————————————— - - SET - - —————————————————————————————————————————— */
		// Les méthodes permettant de provoquer un changement
		//*—*//
		
		// —————— TUCH CODE
		// Lance une fonction nommée
		
		private function TuchCode( Code:String		// ———— - - Le Code transmis
								  ):void {
			/*—*/
			
			// Affiche le code
			Content.push( Code );
			
			// Vire le code
			Code = Pop( Code , [ "TUCH:" , "()" ] );
			
			// Si possible —— - -
			try {
				
				// Récupère le lien
				var Lien:* = StringToElement( Code , RootLink );
				
				// Essaye de lancer la fonction —— - -
				try {
					
					// Lance le lien
					Lien();
					
					// Donne le lien
					Content.push( Code + "() lancé avec succés" );
				
				// Si échoue —— - - Trace l'erreur
				} catch( e ){
					//
					Content.push( " => Erreur : Impossible de lancer la fonction ( Rappel : TUCH ne lance pas les fonctions avec des arguments )" );
				}
				
			// Si échoue —— - - Trace l'erreur
			} catch( e ){
				//
				Content.push( " => Erreur : Le lien spécifié est introuvable" );
			}
		}
		
		
		// —————— MOD CODE
		// Modifie la valeur d'un élément variable
		
		private function ModCode( Code:String 		// ———— - - Le Code transmis
								 ):void {
			/*—*/
			
			// Affiche le code
			Content.push( Code );
			
			// Vire le code
			Code = Pop( Code , "MOD:" );
			
			// Si possible —— - -
			try {
				
				// Retire la valeur à donner
				var Valeur:* = ( Code.split( "=" ).length > 1 ) ? Code.split( "=" )[ 1 ] : Code.split( ":" )[ 1 ];
				//
				Code = ( Code.split( "=" ).length > 1 ) ? Code.split( "=" )[ 0 ] : Code.split( ":" )[ 0 ];
				
				// Si on a bien une valeur —— - -
				if( Valeur ){
					
					// Sépare le code
					var TabCode:Array = Code.split( "." );
					
					// Retire la variable du lien
					var Variable:String = TabCode.pop();
					//
					Code = TabCode.join( "." );
					
					// Récupère le lien
					var Lien:* = StringToElement( Code , RootLink );
					
					// Essaye —— - -
					try {
						
						// Transmet la modification
						Lien[ Variable ] = StringOrNumber( Valeur );
						
						// Donne le lien et sa valeur
						Content.push( String( Lien ) + "." + Variable + " = " + Valeur );
					
					// Si échoue —— - - Trace l'erreur
					} catch( e ){
						//
						Content.push( " => Erreur : Impossible de transmettre la valeur" );
					}
					
				// Si l'on a aucun valeur —— - - Trace l'erreur
				} else {
					//
					Content.push( " => Erreur : Vous devez donner la valeur à la fin en la séparant avec \"=\" ou \":\"" );
				}
				
			// Si échoue —— - - Trace l'erreur
			} catch( e ){
				//
				Content.push( " => Erreur : Le lien spécifié est introuvable" );
			}
		}
		
		
		
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}