﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			 PLAYING CARD	  	   Version 0.1.0									***/
/***				   				   Dernière Mise à Jour : 10-09-10										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         		 Plug - Boîte à outils pour les jeux									***/
/***	Ce script contient des méthodes facilitant et diversifiant la construction de jeux-vidéos.		    ***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Plug.game {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	 
	// —— - - DISPLAY
	import flash.display.MovieClip;
	//
	// —— - - EVENT
	import flash.events.Event;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class PlayingCard extends MiscTools {
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function PlayingCard( TheLink:* = null		// ———— - - Lien vers la scène
									 ):void {
			/*—*/
			
			// Établit la connexion
			Connexion( TheLink );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 SCORE					  		  					  */
		/*								 Créer ou modifier des affichages de score 						  		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - SCORE - - —————————————————————————————————————————— */
		// Les méthodes pour l'affichage de score
		//*—*//
		
		// —————— SCORE TEXT DISPLAY
		// Calibre un champ de texte pour qu'il affiche en permanence une valeur
		
		public function ScoreTextDisplay( Text:TextField ,
										  Cible:* ,
										  Valeur:String = "Score" ,
										  Parametres:Object = null
										 ):void {
			/*—*/
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			
			// Définit la fonction de boucle —— - -
			var BoucleText:Function = function( event:Event ):void {
				
				// Affiche score
				TextTransition( Text , Cible[ Valeur ] , Parametres );
			}
			//
			// Lance l'événement
			AddEvents( Text , BoucleText , "ENTER_FRAME" );
		}
		
		
		// —————— SCORE ELEMENT DISPLAY
		// Lance le placement d'une suite d'éléments sur une ou plusieurs ligne
	
		public function ScoreElementDisplay( Conteneur:* ,				// ———— - - Conteneur où placer les éléments
										     Clip:* ,					// ———— - - Clip de l'élément à afficher
										     Nombre:int = 0 ,			// ———— - - Nombre d'éléments à afficher
										     Nom:String = "" ,			// ———— - - Nom donné aux éléments
										     Parametres:Object = null 	// ———— - - Les Parametres additifs
										    ):void {
			/*—*/
			
			// Si la classe n'est pas un tableau —— - -
			if( !TypeOf( Clip , "Array" ) ){
				
				// Arguments par défaut
				Parametres = Parametres || new Object();
				//
				var PositionX:Number = Parametres.x || 0;
				var PositionX:Number = Parametres.y || 0;
				//
				var DecalageT:Number = Parametres.time || 2;
				var DecalageX:Number = Parametres.shift || 0;
				//
				Nom = ( Nom == "" ) ? String( Clip ) : Nom;
				
				// Pour chaque élément du nombre
				for( var i:int = 1 ; i <= Nombre ; i++ ){
					
					// Créait l'élément
					var NouvelElement:* = NewElement( Clip , Conteneur , Nom + i );
					//
					// Positionne l'élément
					NouvelElement.x = PositionX + ( i * NouvelElement.width ) + DecalageX;
					NouvelElement.y = PositionY;
					//
					// Réduit l'élément
					NouvelElement.scaleX = 0.001;
					NouvelElement.scaleY = 0.001;
					
					// Lance l'apparition de l'élément par Next
					Rebours( { Cible:this , Fonction:"Next" , Arguments:[ "Apparition" + NouvelElement.name , 
																		   NouvelElement , 
																		   { scaleX:1 , scaleY:1 } ] } , DecalageT * i );
				}
			
			// Si la classe est un tableau —— - -
			} else {
				
				// Pour chaque élément du tableau —— - -
				for( var iTableau:int = 0 ; iTableau < Clip.length ; iTableau++ ){
					
					// Affiche l'élément
					ScoreDisplay( Conteneur , 
								  Clip[ iTableau ].clip ,
								  Clip[ iTableau ].number ,
								  Clip[ iTableau ].name ,
								  Clip[ iTableau ]
								 );
				}
			}
		}
		
		
		
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}