﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			 CAM PORT	  			Version 0.1.0									***/
/***				   				   Dernière Mise à Jour : 10-08-31										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         				  Portage Webcam												***/
/***						 Ce script permet de faire des appels de webcam.	  							***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Port {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	  
	// —— - - DISPLAY
	import flash.display.MovieClip;
	//
	// —— - - MEDIA
	import flash.media.Camera;
	import flash.media.Video;
	//
	// —— - - SYSTEM
	import flash.system.Security;
	//
	// —— - - EVENT
	import flash.events.Event;
	import flash.events.StatusEvent;
	import flash.events.ActivityEvent;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class CamPort extends MiscTools {
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function CamPort( TheLink:* = null		// ———— - - Lien vers la scène
								 ):void {
			/*—*/
			
			// Établit la connexion
			Connexion( TheLink );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					CREATION					  		  				  */
		/*						Méthodes pour appliquer des résultats à partir de la Webcam 					  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - APPLY - - —————————————————————————————————————————— */
		// Les méthodes de récupération de la vue webcam
		//*—*//
		
		// —————— LAUNCH FILM
		// Lance la création d'un point de webcam
	
		public function LaunchFilm( Conteneur:* ,				// ———— - - Le Conteneur du film
								    Nom:* = "Webcam" ,			// ———— - - Le Nom du film
								    Parametres:Object = null	// ———— - - Les paramètres du film
								  ):MovieClip {
			/*—*/
			
			// Switch des arguments
			if( TypeOf( Nom , "Object" ) ){
				//
				Parametres = Nom;
				Nom = "Webcam";
			}
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			//
			var Largeur:Number = Parametres.width || -1;
			var Hauteur:Number = Parametres.height || -1;
			var Qualite:int = Parametres.quality || 100;
			//
			var Activation:* = Parametres.activation;
			//
			Parametres.smoothing = Parametres.smoothing || false;
			
			
			// Création du conteneur de vidéo interne
			var Interne:MovieClip = NewElement( MovieClip , Conteneur , Nom );

			// Création de la caméra
			var NouvelleCamera:Camera = Interne.Camera = Camera.getCamera();
			//
			// Qualité de la caméra
			NouvelleCamera.setQuality( 0 , Qualite );
			
			// Si la caméra est bien créée —— - -
			if( NouvelleCamera ) {
				
				// Si elle n'a pas déjà été mémorisé comme autorisée —— - - Montre automatiquement le panneau d'autorisation et mémorisation
				if ( NouvelleCamera.muted ){ Security.showSettings(); }
			}
			
			// Création de la Vidéo
			var RetourVideo:Video = Interne.Video = new Video( ( ( Largeur == -1 ) ? null : Largeur ) ,
											   							  ( ( Hauteur == -1 ) ? null : Hauteur ) );
			
			// Parametres de la vidéo
			RetourVideo.smoothing = Parametres.smoothing;
			
			// Attache la caméra
			RetourVideo.attachCamera( NouvelleCamera );
			
			// Affiche le rendu
			Interne.addChild( RetourVideo );
			
			// S'il y a une fonction d'erreur
			if( Activation ){
				
				// Créait la variable de mémorisation des muted
				Interne.MemoMuted = NouvelleCamera.muted;
				
				// Créait la fonction de test des muted
				Interne.MutedTest = function( event:Event ):void {
					
					// Récupére l'instance du conteneur
					var Cible:* = event.target;
					
					// Si la valeur de muted est différente de la mémoire
					if( Cible.MemoMuted != Cible.Camera.muted ){
						
						// Lance la fonction avec l'argument de l'état du muted
						Launch( Activation , true , { Actif:Cible.Camera.muted } );
						
						// Mémorise le nouveau
						Cible.MemoMuted = Cible.Camera.muted
					}
				}
				//
				// Donne l'événement de boucle 
				AddEvents( Interne , Interne.MutedTest , "ENTER_FRAME" );
				
				// Lance la fonction avec l'argument de l'état du muted
				Launch( Activation , true , { Actif:Interne.Camera.muted } );
			}
			
			
			// Donne à Interne sa méthode de Freeze
			Interne.Freeze = function( Etat:Boolean = true ):void {
				/**/
				
				// Si on freeze —— - -
				if( Etat ){ 
					
					// Retire l'attache de caméra
					Interne.Video.attachCamera( null );
					
				// Si on défreeze —— - -
				} else {
					
					// Replace l'attache de caméra
					Interne.Video.attachCamera( Interne.Camera );
				}
			}
			
			
			// Donne à Interne sa méthode de destruction
			Interne.Kill = function():void {
				/**/
				
				// Freeze
				Interne.Freeze();
				
				// S'il y a une activation —— - -
				if( Activation ){
					
					// Retire l'événement de boucle 
					RemoveEvents( Interne , Interne.MutedTest , "ENTER_FRAME" );
				}
				
				// Détruit vidéo et caméra
				Interne.Video = null;
				Interne.Camera = null;
			}
			
			
			// Retourne le conteneur interne
			return Interne;
		}
	  
		
		// —————— NEW PHOTO
		// Affiche une photo arrétée à partir de la webcam
	
		public function NewPhoto( Conteneur:* ,				// ———— - - Le Conteneur de la photo
								  Nom:* = "Webcam" ,		// ———— - - Le Nom de la photo
								  Parametres:Object = null	// ———— - - Les paramètres de la photo
								 ):MovieClip {
			/*—*/
			
			// Créait la prise de webcam
			var Photo:MovieClip = LaunchFilm( Conteneur , Nom , Parametres );
			
			// Détruit et freeze au bout du temps impartie
			CountdownLaunch( Photo.Kill , Parametres.time || 2 );
			
			// Retourne le conteneur interne
			return Photo;
		}
		
		
		
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}