﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        				MOUSE PORT	  	Version 0.2.0										***/
/***				   				   Dernière Mise à Jour : 10-08-31										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         				  Portage Souris												***/
/***	Ce script contrôle en permanence l'emplacement de la souris pour permettre à l'environnement de     ***/
/***	l'application de récupérer à tout moment la position de la souris.									***/
/***												      													***/
/***	Ce script permet également de remplacer le curseur du joueur par un curseur personnalisé et autres	***/
/***	actions en relation directe avec la souris.															***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Port {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	
	// ——— - - DISPLAY
	import flash.display.MovieClip;
	//
	// ——— - - EVENT
	import flash.events.MouseEvent;
	import flash.events.Event;
	//
	// ——— - - UI
	import flash.ui.Mouse;
	//
	// ——— - - drOIde
	import drOIde.Global.MiscTools;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class MousePort extends MiscTools {
		
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*—*//
		
		// —————— POSITION DE LA SOURIS
		// Positionnement de la souris dans l'espace
		public var X:Number = 0;
		public var Y:Number = 0;
		//
		// Mémorisation
		private var Memo:Object = { x:0 , y:0 , xLoop:0 , yLoop:0 };
		
		
		// —————— ETAT DE LA SOURIS
		// Définit si on check la souris ou non
		public var isCheck:Boolean = false;
		//
		// Définit les états souris
		public var isDown:Boolean = false;
		public var isOver:* = null;
		//
		public var downNumber:int = 0;
		private var downTiming:int = 0;
		
		
		// —————— PARAMETRES DE LA SOURIS
		// Vitesse de déplacement de la souris
		public var xSpeed:Number = 0;
		public var ySpeed:Number = 0;
		//
		// Angle de déplacement de la souris
		public var angle:Number = 0;
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function MousePort( TheLink:* = null ,			// ————— - - Lien vers la scene
								   Checking:Boolean = false		// ————— - - Si on connecte la boucle de vérification
								  ):* {
			/*—*/
			
			// Définit sa position initiale
			this.x = 0;
			this.y = 0;
			
			// Si on a connecté le port ——— - -
			if( Connexion( TheLink ) ){
				
				// Placement de l'événement "Au déplacement de la souris" pour récupérer à chaque déplacement
				// du curseur son nouvel emplacement
				AddEvents( StageLink , GlobalLoop , "MOUSE_MOVE" );
				
				// Placement de l'événement "Au click" & "Au relachement" pour récupérer les états de clic
				AddEvents( StageLink , CheckDown , "MOUSE_DOWN" );
				AddEvents( StageLink , CheckUp , "MOUSE_UP" );
				
				// Placement de l'événement "A la molette"
				AddEvents( StageLink , CheckWheel , "MOUSE_WHEEL" );
				
				// Si on connecte la boucle de vérification ——— - -
				if( Checking ){	
					
					// Lance la boucle de vérification
					LaunchCheckLoop()
				}
				
			// Si on a ommis de connecter le port ——— - -
			} else {
				
				// Sort l'erreur
				TraceError( "MousePort" , "Initialisation de la MousePort" , 
							[ "Vous devez donner au script un lien vers la scene au moment de sa création." ]
							);
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 GLOBAL					  		  					  */
		/*							   Méthodes pour calibrer les valeurs de la souris 					  		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		/*—*/
		
		// —————— FONCTIONS RATTACHÉES
		// Les fonctions ratachées à différents appels souris
		public var Down:Object = new Object();
		public var Up:Object = new Object();
		public var Wheel:Object = new Object();
		
		// —————— TIMERS
		// Timer définissant le temps passé entre deux clic ou mouvement
		public var downTime:int = 0;
		public var moveTime:int = 0;
		//
		private var actionTime:Object = { Click:[] , Move:[] };
		
		
		
		/* —————————————————————————————————————————— - - LOOP - - —————————————————————————————————————————— */
		// Les méthodes lancées en boucle pour calibrer la souris
		/*—*/
		
		// —————— GLOBAL LOOP
		// Méthodes en boucle ( Sur le mouvement souris ) pour récupérer les données souris
		
		public function GlobalLoop( event:MouseEvent ):void {
			/*—*/
				
			/* —— - - CALIBRAGE - - —— */
			/**/
			
			// Récupération de l'emplacement de la souris
			This.x = X = event.stageX;
			This.y = Y = event.stageY;
			
			// Définition de l'angle de la souris
			if( !NearEqual( This.x , Memo.x , 0.5 ) && 
				!NearEqual( This.y , Memo.y , 0.5 ) ){
				//
				angle = GetAngle( { x:Memo.x , y:Memo.y } , 
								  { x:This.x , y:This.y } );
			}
			
			// Récupére la mémorisation des positions
			Memo.x = This.x;
			Memo.y = This.y;
		
			// Remet le temps de move à zéro
			moveTime = 0;
			
			// Remet le temps d'appuie à zéro
			downTiming = 0;
				
				
			/* —— - - CURSEUR - - —— */
			/**/
				
			// S'il y a un curseur et s'il est actif —— - -
			if( Cursor != null ){
				
				// Positionne le curseur
				Cursor.x = This.x;
				Cursor.y = This.y;
				
				// force le rendu pour fluidifié le curseur
				event.updateAfterEvent();
				
				// Cache le curseur windows
				Mouse.hide();
			}
				
				
			/* —— - - CHEMIN - - —— */
			/**/
				
			// Pour chaque chemin ——— - -
			for( var i:* in Ways ){
				
				// Le temps de se chemin passe
				Ways[ i ].TempsPasse++;
				
				// Si la tête n'est pas la dernière ——— - -
				if( Ways[ i ].Tete < Ways[ i ].Points.length ){
					
					// Si la souris est suffisemment proche du prochain point ——— - -
					if( GetDistance( { x:This.x , y:This.y } , 
									   { x:GetTotal( Ways[ i ].Points[ Ways[ i ].Tete ] , "x" ) , 
										 y:GetTotal( Ways[ i ].Points[ Ways[ i ].Tete ] , "y" ) } ) < Ways[ i ].Diametre ){
						
						// Avance la tête de 1
						Ways[ i ].Tete++;
						//
						// Augmente la vitesse
						Ways[ i ].Vitesse += Ways[ i ].Acceleration;
						//
						// Calibre la vitesse si elle est au max
						if( Ways[ i ].Vitesse > Ways[ i ].VitesseMax ){ Ways[ i ].Vitesse = Ways[ i ].VitesseMax; }
						//
						// Redéfinit le point actuel
						Ways[ i ].Actuel = Ways[ i ].Points[ Ways[ i ].Tete - 1 ];
						
						// Récupère le temps passé
						Ways[ i ].Temps = Ways[ i ].TempsPasse;
						
						// Remes le temps passé à zéro
						Ways[ i ].TempsPasse = 0;
					}
				
				// Si la tête est la dernière ——— - -
				} else {
					
					// Si la souris est suffisemment proche du prochain point ——— - -
					if( GetDistance( { x:This.x , y:This.y } , 
									   { x:GetTotal( Ways[ i ].Points[ 0 ] , "x" ) , 
										 y:GetTotal( Ways[ i ].Points[ 0 ] , "y" ) } ) < Ways[ i ].Diametre ){
						
						// Mes la tête sur la première
						Ways[ i ].Tete = 0;
						//
						// Augmente le nombre de tours effectué
						Ways[ i ].Tours++;
						//
						// Augmente la vitesse
						Ways[ i ].Vitesse += Ways[ i ].Acceleration;
						//
						// Calibre la vitesse si elle est au max
						Ways[ i ].Actuel = Ways[ i ].Points[ Ways[ i ].Tete - 1 ];
						//
						// Redéfinit le point actuel
						if( Ways[ i ].Vitesse > Ways[ i ].VitesseMax ){ Ways[ i ].Vitesse = Ways[ i ].VitesseMax; }
						
						// Récupère le temps passé
						Ways[ i ].Temps = Ways[ i ].TempsPasse;
						
						// Remes le temps passé à zéro
						Ways[ i ].TempsPasse = 0;
					}
				}
			}
		}
			
		
		// —————— CHECK LOOP
		// Boucle de vérification des données avancées
		
		public function ChecklLoop( event:Event ):void { 
			/*—*/
			
			/* —— - - CALIBRAGE - - —— */
			/**/
			
			// Établie la vitesse
			xSpeed = this.x - Memo.xLoop;
			ySpeed = this.y - Memo.yLoop;
			
			// Mémorise la position souris
			Memo.xLoop = this.x;
			Memo.yLoop = this.y;
				
				
			/* —— - - CURSEUR - - —— */
			/**/
				
			// S'il y a un curseur et s'il est actif —— - -
			if( Cursor != null ){
				//
				if( Cursor.active ){
						
					// S'il a un corps —— - -
					if( Cursor.Body ){
						
						// Nom de l'élément survolé —— - -
						var ElementSurvole:String = "";
						//
						if( isOver ){
							//
							ElementSurvole = isOver.name;
						}
						
						// S'il est lock mais que la souris est relaché —— - - Unlock
						if( Cursor.Forms.lock && !isDown && Cursor.Forms.lock != ElementSurvole ){
							//
							Cursor.Forms.lock = false;
						}
						
						// S'il n'est pas lock ou en lock sur son survol —— - -
						if( !Cursor.Forms.lock || Cursor.Forms.lock == ElementSurvole ){
						
							// Modifie la forme
							Cursor.Body.gotoAndStop( Cursor.Forms[ ( isDown ) ? "down" : "normal" ] );
							
							// S'il s'apprête à se locker —— - - Se lock
							Cursor.Forms.lock = ( Cursor.Forms.lock == "beLock" ) ? true : Cursor.Forms.lock;
						}
					}
					
					// Cache le curseur windows
					Mouse.hide();
				
				// S'il est inactif —— - -
				} else {
					
					// Affiche le curseur windows
					Mouse.show();
				}
				
			// S'il n'y a pas de curseur —— - -
			} else {
					
				// Affiche le curseur windows
				Mouse.show();
			}
					
					
			/* —— - - TEMPS - - —— */
			/**/
				
					
			// Levier de remise à zéro
			var LevierClic:Boolean = false;
			var LevierMove:Boolean = false;
			
			// Fait croitre le temps de framing du dernier clic et du dernier move
			downTime++;
			moveTime++;
			
			// Si le temps d'appuie a atteint zéro ——— - -
			if( downTiming == 0 ){
				
				// Remet le nombre d'appuie à zéro
				downNumber = 0;
				//
				downTiming = -1;
				
			// Si le temps d'appuie n'a pas atteint zéro ——— - - Le fait décroître
			} else if( downTiming > 0 ){ downTiming--; }
			
			// Pour chaque éléments dans le timer d'action de Move ——— - -
			for( var i:int = 0 ; i < actionTime.Move.length ; i++ ){
				
				// Si le temps l'a atteint ——— - - 
				if( actionTime.Move[ i ].Temps == moveTime ){ 
				
					// Lance la fonction attachée
					Launch( actionTime.Move[ i ].Fonction );
					
					// S'il y a remise à zéro ——— - - Lock le levier de remise à zéro
					if( actionTime.Move[ i ].MiseAZero ){ LevierMove = true; }
				}
			}
			
			// Pour chaque éléments dans le timer d'action de Clic ——— - -
			for( var j:int = 0 ; j < actionTime.Click.length ; j++ ){
				
				// Si le temps l'a atteint ——— - - 
				if( actionTime.Click[ j ].Temps == downTime ){ 
				
					// Lance la fonction attachée
					Launch( actionTime.Click[ j ].Fonction ); 
					
					// S'il y a remise à zéro ——— - - Lock le levier de remise à zéro
					if( actionTime.Click[ j ].MiseAZero ){ LevierClic = true; }
				}
			}
			
			// S'il y a une demande de mise à zéro ——— - - Mes à zéro
			if( LevierMove ){ moveTime = 0; }
			if( LevierClic ){ downTime = 0; }
					
					
			/* —— - - CHEMIN - - —— */
			/**/
				
			// Pour chaque chemin ——— - -
			for( var k:* in Ways ){
				
				// Si la vitesse n'est pas tombé à 0 ——— - -
				if( Ways[ k ].Vitesse - Ways[ k ].Deceleration > 0 ){
					
					// la vitesse décroît
					Ways[ k ].Vitesse -= Ways[ k ].Deceleration;
					
				// Sinon ——— - - La vitesse se plaque à zéro
				} else { Ways[ k ].Vitesse = 0; }
			}
		}
		//
		// —————— LAUNCH CHECK LOOP
		// Lance la boucle de vérification si elle n'est pas déjà active
		private function LaunchCheckLoop():void {
			/*—*/
			
			// Si la boucle n'est pas déjà active —— - -
			if( !isCheck ){
				
				// Lance la boucle
				AddEvents( this , ChecklLoop , "ENTER_FRAME" );
				
				// La boucle est active
				isCheck = true;
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - MOUSE - - —————————————————————————————————————————— */
		// Les méthodes lancées par des actions souris pour calibrer cette dernière
		/*—*/
		
		// —————— CHECK DOWN
		// Observe les appels d'appuis souris
		
		public function CheckDown( event:MouseEvent ):void { 
			/*—*/
				
			/* —— - - VALEURS - - —— */
			/**/
			
			// Est en appuie
			isDown = true;
			
			// Remet le temps de clic à zéro
			downTime = 0;
			
			// Augmente le nombre d'appuie opéré
			downNumber++;
			
			// Mes au max le temps d'appuie
			downTiming = 5;
				
				
			/* —— - - FONCTIONS - - —— */
			/**/
			
			// Lance les fonctions rattachés
			//
			// Pour chaque fonctions rattachées ——— - -
			for( var iDown:* in Down ){
				
				// S'il n'est pas null ——— - -
				if( Down[ iDown ] != null ){
					
					// S'il est un objet —— - -
					if( TypeOf( Down[ iDown ] , "Object" ) ){
						
						// Si son appuie demandé est de -1 ou du nombre d'appuie effectué ——— - - Lance sa fonction
						if( Down[ iDown ].number == downNumber 
						 || !Down[ iDown ].number ){ 
							//
							Launch( Down[ iDown ] ); 
						}
					
					// S'il n'est pas un objet —— - - Lance la fonction
					} else {
						//
						Launch( Down[ iDown ] ); 
					}
				}
			}
		}
		  
		
		// —————— CHECK UP
		// Observe les appels de relachement souris
		
		public function CheckUp( event:MouseEvent ):void { 
			/*—*/
				
			/* —— - - VALEURS - - —— */
			/**/
			
			// Debloque le levier d'appuie
			isDown = false;
				
				
			/* —— - - FONCTIONS - - —— */
			/**/
			
			// Lance les fonctions rattachées
			//
			// Pour chaque fonctions rattachées ——— - -
			for( var iUp:* in Up ){
				
				// S'il n'est pas null ——— - -
				if( Up[ iUp ] != null ){
				
					// Lance sa fonction
					Launch( Up[ iUp ] );
				}
			}
		}
		  
			
		// —————— CHECK WHEEL
		// Concerne la molette souris
		
		public function CheckWheel( event:MouseEvent ):void { 
			/*—*/
			
			// Lance les fonctions rattachés
			//
			// Pour chaque fonctions rattachées ——— - -
			for( var iWheel:* in Wheel ){
				
				// S'il n'est pas null ——— - -
				if( Wheel[ iWheel ] != null ){
					
					// Essaye —— - -
					try {
					
						// Lance sa fonction ave le delta
						Launch( Wheel[ iWheel ] , null , event.delta );
					
					// Si échoue —— - -
					} catch ( e ){
					
						// Lance sa fonction sans argument additifs
						Launch( Wheel[ iWheel ] );
					}
				}
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - APPLY - - —————————————————————————————————————————— */
		// Les méthodes qui appliquent des fonctionnement au curseur ou à la souris
		/*—*/
		
		// —————— ADD TIME ACTION							 	
		// Applique une action par rapport au timer
	
		public function AddTimeAction( Fonction:Object ,				// ————— - - La fonction à lancer
									   Etat:String = "Click" ,			// ————— - - L'État souris concerné
									   Temps:int = 100 ,				// ————— - - Temps avant effet
									   RemiseAZero:Boolean = false		// ————— - - S'il y a remise à zéro après lancement fonction
									):void {
			/*—*/
			
			// Créait ce nouvel élément
			actionTime[ Etat ].push( { Temps:Temps , Fonction:Fonction , MiseAZero:RemiseAZero } );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 GET					  		  					  */
		/*							   	Méthodes pour récupérer des valeurs souris 					  		  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - GET - - —————————————————————————————————————————— */
		// Les méthodes de récupération particulière des valeurs souris
		/*—*/
		
		// —————— LOCAL      									 	
		// Récupére la position souris par rapport à un clip
		
		function local( Element:* 	// ———— - - Élément de départ
					   ):Object {
			/*—*/
			
			// Retourne l'objet des états locaux
			return { x:localX( Element ) , y:localY( Element ) };
		}
		
		
		// —————— LOCAL X      									 	
		// Récupére la position X souris par rapport à un clip
		
		public function localX( Element:* 	// ———— - - Élément de départ
					    ):Number { 
			/*—*/
			
			// Retourne la position absolut en x
			return( (
					  X 							// ——— - - Position x de la souris sur la fenêtre
					- GetTotal( Element , "x" ) )	// ——— - - Moins la position x absolut de l'élément
					/ GetTotal( Element , "scaleX" )	// ——— - - Divisé par le multiplicatif de largeur de l'élément
				   ); 
		}
		
		
		// —————— LOCAL Y     									 	
		// Récupére la position Y souris par rapport à un clip
		
		public function localY( Element:* 	// ———— - - Élément de départ
					    ):Number { 
			/*—*/
			
			// Retourne la position absolut en y
			return( ( 
					  Y 							// ——— - - Position y de la souris sur la fenêtre
					- GetTotal( Element , "y" ) )	// ——— - - Moins la position y absolut de l'élément
					/ GetTotal( Element , "scaleY" )	// ——— - - Divisé par le multiplicatif de hauteur de l'élément
				  ); 
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 CURSOR					  		  					  */
		/*					  Méthodes pour ajouter, retirer et manipuler des curseurs spécifiques				  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		/*—*/
	  
		// —————— CURSOR
		// Clip remplaçant la souris
		public var Cursor:MovieClip;
		
		
		
		/* —————————————————————————————————————————— - - CREATION - - —————————————————————————————————————————— */
		// Les méthodes permettant de créer un curseurs
		/*—*/
		
		// —————— ADD CURSOR
		// Choisit un clip pour remplacer le curseur
	
		public function AddCursor( leCurseur:Class ,	// ————— - - Class de l'élément graphique curseur
								   Conteiner:* 			// ————— - - Conteneur du curseur
								 ):* {
			/*—*/
			
			// Lance la boucle de vérification
			LaunchCheckLoop();
			
			// Place le curseur
			Cursor = NewElement( leCurseur , 
								  Conteiner , 
								  "Curseur" , 
								  { 
								  	active:true ,
									actualForm:""
								  } );
			
			// Tente de compiler son corps s'il n'en a pas de définit
			if( !Cursor.Body ){
				//
				try {
					//
					Cursor.Body = Cursor.getChildAt( 0 );
					//
				} catch( e ){}
			}
			
			// Donne ses objets de forme
			Cursor.Forms = { normal:"Normal" , down:"Down" , lock:true };
			Cursor.FormsInitials = { normal:"Normal" , down:"Down" , lock:true };
			
			// Le clip du curseur est ignoré
			Unknow( Cursor );
			
			// Retourne l'instance du curseur
			return Cursor;
		}
		
		
		
		/* —————————————————————————————————————————— - - MANAGES - - —————————————————————————————————————————— */
		// Les méthodes permettant de manipuler les curseurs
		/*—*/

	    // —————— SHOW
		// Affiche le curseur
	
		public function show():void { 
			/*—*/
			
			Mouse.show(); 
		}
		
		
		// —————— HIDE
		// Cache le curseur
		
		public function hide():void {
			/*—*/
			
			Mouse.hide(); 
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 ELEMENT					  		  				  */
		/*					  Méthodes pour appliquer des effets relatifs souris à des éléments 				  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - APPLY - - —————————————————————————————————————————— */
		// Les méthodes pour appliquer les effets souris
		/*—*/
		
		// —————— UNKNOW       									 	
		// Un clip n'agit plus sur la souris et ne l'empêche plus de passer au travers
	
		public function Unknow( Clip:* ,				// ————— - - Le Clip concerné
							    Etat:Boolean = false	// ————— - - L'État de l'ignorance
							   ):void { 
			/*—*/
			
			// Appose l'ignorance
			Clip.mouseChildren = Etat;
			Clip.mouseEnabled = Etat;
		}
	  
	  
		// —————— APPLY BUTTON MODE
		// Un clip est conscidéré comme un bouton agissant sur la forme du curseur en plus optimisé qu'un simple "buttonMode"
	
		public function ApplyButtonMode( Clip:* ,					// ————— - - Le Clip concerné
										 Action:* = "Over" ,		// ———— - - Le type d'action ( Over ou Down )
										 							//		 ou false pour tout retirer
										 
									     Forme:* = "" , 			// ————— - - La Forme qu'il donne à la souris
										 							//		 ou Lock
										 
										 Lock:Boolean = false		// ———— - - Si l'élément lock la forme
									  ):void { 
			/*—*/
			
			// Si l'action n'est pas fausse —— - -
			if( Action != false ){
				
				// Switch des arguments
				if( TypeOf( Forme , "Boolean" ) ){
					//
					Lock = Forme;
					Forme = "";
				}
				
				// Argument par défaut
				Forme = ( Forme != "" ) ? Forme : Action;
				
				// Valeur d'action contraire
				var ActionContraire:String = ( Action == "Over" ) ? "Out" : 
											 ( Action == "Down" ) ? "Up" : 
											 RandomWord();
				
				// Donne au clip son objet en relation avec l'état de bouton
				Clip.ButtonMode = Clip.ButtonMode || new Object();
				//
				Clip.ButtonMode.Events = Clip.ButtonMode.Events || new Array();
				//
				// Donne au clip la forme qu'il donne à la souris
				Clip.ButtonMode[ Action + "Form" ] = Forme;
				
				// Donne au clip son locking
				Clip.ButtonMode.Lock = Lock || Clip.ButtonMode.Lock;
				
				// Donne au clip sa fonction initiale ——— - -
				Clip.ButtonMode[ Action ] = function( event:MouseEvent ):void {
					
					// Récupére l'instance de la cible
					var Cible:* = event.currentTarget;
					
					// Etat de survol
					isOver = Cible;
					
					// Modifie la forme du curseur
					Cursor.Forms[ Action.toLowerCase() == "over" ? "normal" : "down" ] = Cible.ButtonMode[ Action + "Form" ];
					
					// Applique son locking
					if( Cible.ButtonMode.Lock ){
						//
						Cursor.Forms.lock = Cible.name;
					}
				}
				
				// Donne au clip sa fonction contraire ——— - -
				Clip.ButtonMode[ ActionContraire ] = function( event:MouseEvent ):void {
					
					// Récupére l'instance de la cible
					var Cible:* = event.currentTarget;
					
					// Etat de survol
					isOver = null;
					
					// Modifie la forme du curseur
					Cursor.Forms[ Action.toLowerCase() == "over" ? "normal" : "down" ] = Cursor.FormsInitials[ Action.toLowerCase() ];
				}
				//
				// Donne les événements au clip
				AddEvents( Clip , Clip.ButtonMode[ Action ] , "MOUSE_OVER" , Action + Forme );
				AddEvents( Clip , Clip.ButtonMode[ ActionContraire ] , "MOUSE_OUT" , Action + Forme + "Out" );
				
				// Ajoute les deux événements au tableau
				Clip.ButtonMode.Events.push( Action + Forme );
				Clip.ButtonMode.Events.push( Action + Forme + "Out" );
				
				// Donne le buttonMode au clip
				Clip.buttonMode = true;
			
			
			// Si l'action est fausse —— - -
			} else {
				
				// S'il a des événements —— - -
				if( Clip.ButtonMode ){
				
					// Pour chaque événements donné ainsi —— - -
					for( var iEvent:int = 0 ; iEvent < Clip.ButtonMode.Events.length ; iEvent++ ){
						
						// Retire l'événement
						RemoveEvents( Clip , Clip.ButtonMode.Events[ iEvent ] );
					}
					
					// Si le survol actuel est le sien —— - -
					if( isOver ){
						//
						if( isOver.name == Clip.name ){
							//
							// Le retire et enlève la forme
							isOver = null;
							//
							Cursor.Forms.normal = Cursor.FormsInitials.normal;
							Cursor.Forms.down = Cursor.FormsInitials.down;
						}
					}
					
					// Retire son objet
					Clip.ButtonMode = null;
				
					// Retire son mode bouton
					Clip.buttonMode = false;
				}
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 WAY					  		  					  */
		/*					  Méthodes permettant de créer des chemins virtuels pour la souris 					  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		/*—*/
		
		// —————— CHEMINS
		// Les variables concernant la mise de chemin
		public var Ways:Object = new Object();
		
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Les méthodes pour ajouter et manipuler les chemins de souris virtuels
		/*—*/
		
		// —————— NEW WAY
		//	Créait un nouveau chemin de déplacement souris
	
		public function NewWay( Nom:String ,				// ————— - - Nom du chemin
							    Points:* ,					// ————— - - Tableau des points ou clip conteneur des factices points
							    Parametres:Object = null	// ————— - - Les parametres du chemin
							  ):void {
			/*—*/
			
			// Arguments par défaut
			//
			// Pour les parametres
			Parametres = Parametres || new Object();
			//
			// Les Valeurs
			var Diametre:Number = Parametres.diametre || 50;
			Parametres.Vitesse = Parametres.speed || 0;
			Parametres.VitesseMax = Parametres.speedMax || 100;
			Parametres.Acceleration = Parametres.acceleration || 5;
			Parametres.Deceleration = Parametres.deceleration || 1;
			
			// Si le point est un clip conteneur ——— - -
			if( !TypeOf( Points , "Object" ) ){
				
				// Créait un nouveau tableau
				var NouveauPoints:Array = [];
				
				// Pour chaque enfant du clip conteneur ——— - - Ajoute l'enfant au tableau des points
				for( var i:int = 0 ; i < Points.numChildren ; i++ ){ NouveauPoints.push( Points.getChildAt( i ) ); }
				//
				// Redéfinie les points
				Points = NouveauPoints;
			}
			
			// Définit l'objet pour le nouveau chemin
			var leNouveauChemin:Object = new Object();
			//
			// Place les trois variables principales
			leNouveauChemin.Points = Points;
			leNouveauChemin.Diametre = Diametre;
			leNouveauChemin.Tete = 1;
			//
			// Place le temps
			leNouveauChemin.Temps = 0;
			leNouveauChemin.TempsPasse = 0;
			//
			// Place les principes de vitesse
			leNouveauChemin.Vitesse = Parametres.Vitesse;
			leNouveauChemin.VitesseMax = Parametres.VitesseMax;
			leNouveauChemin.Acceleration = Parametres.Acceleration;
			leNouveauChemin.Deceleration = Parametres.Deceleration;
			//
			// Place le point actuel
			leNouveauChemin.Actuel = Points[ 0 ];
			//
			// Place le nombre de tour
			leNouveauChemin.Tours = 0;
			
			// Créait ce nouvel élément
			Ways[ Nom ] = leNouveauChemin;
		}
		
		
		
	
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}