﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			 PRINT PORT	  			Version 0.1.0									***/
/***				   				   Dernière Mise à Jour : 10-08-31										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         				  Portage Imprimante											***/
/***	Ce script permet de faire des appels d'impression ou de sortie d'image sur l'ordinateur de 		    ***/
/***	l'utilisateur.																					 	***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Port {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	  
	// —— - - DISPLAY
	import flash.display.MovieClip;
	//
	// —— - - GEOMETRY
	import flash.geom.Rectangle;
	//
	// —— - - GEOMETRY
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	//
	// —— - - EVENT
	import flash.printing.PrintJob;
	import flash.printing.PrintJobOrientation;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class PrintPort extends MiscTools {
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
 		/**/
		public function PrintPort( TheLink:* = null		// ———— - - Lien vers la scène
								 ):void {
			/*—*/
			
			// Établit la connexion
			Connexion( TheLink );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 PRINT					  		  					  */
		/*							    	  Méthodes pour lancer des impressions 					  		  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - LAUNCH - - —————————————————————————————————————————— */
		// Les méthodes pour lancer les impressions
		//*—*//
		
		// —————— LAUNCH PRINT
		// Imprime le contenu d'un clip
	
		public function LaunchPrint( Clip:* ,					// ———— - - Le Clip en question
									 Parametres:Object = null ,	// ———— - - Les parametres d'impressions
									 Cadre:Object = null 		// ———— - - Le cadre s'il y en a un
									):void {
			/*—*/
			
			// Variables d'arguments
			Parametres = Parametres || new Object();
			//
			var Frame:* = Parametres.frame || "";
			var Direction:String = Parametres.direction || "";
			var Adaptatif:* = ( Parametres.adaptation == null ) ? true : Parametres.adaptation;
			var Decalage:Object = { x:Parametres.shiftX || 0 , y:Parametres.shiftY || 0 };
			//
			var Reussie:* = Parametres.fonction || Parametres.fonctionEnd;
			var Echoue:* = Parametres.fonctionError;
			
			// Variable du Rectangle de Cadre
			var leRectangle:Rectangle;
			
			// Arguments par défauts
			//
			// Pour la direction
			Direction = ( Direction == "Paysage" ) ? "LANDSCAPE" : ( ( Direction == "Portrait" ) ? "PORTRAIT" : "" )
			//
			// Pour la frame
			Frame = ( Frame == "" ) ? null : Frame;
			//
			// Convertie en tableau s'il faut
			if( FindIn( Frame , "-" ) != 0 ){ Frame = Frame.split( "-" ); 
				//
				// Vérifie la bonne conformité du tableau
				Frame[ 0 ] = ( TypeOf( Frame[ 0 ] , "Number" ) ? Frame[ 0 ] : 1 );
				Frame[ 1 ] = ( TypeOf( Frame[ 1 ] , "Number" ) ? Frame[ 1 ] : 1 );
				//
				// Inverse les deux si la première est plus grande que la seconde
				if( Frame[ 0 ] > Frame[ 1 ] ){
					//
					var Transitoire:int = Frame[ 0 ];
					//
					Frame[ 0 ] = Frame[ 1 ];
					Frame[ 1 ] = Transitoire;
				}
			}
			
			// Créait le rectangle s'il y a un cadre —— - -
			if( Cadre ){ leRectangle = new Rectangle( Cadre.x1 , Cadre.y1 , Cadre.x2 , Cadre.y2 ); }
			
			// Créait l'impression
			var Impression:PrintJob = new PrintJob();
			  
			 // Lance l'impression, Si elle réussie —— - -
			if( Impression.start() ){
				
				// Mémorise les données du clip
				var MemoRotation:Number = Clip.rotation;
				var MemoWidth:Number = Clip.width;
				var MemoHeight:Number = Clip.height;
				var MemoX:Number = Clip.x;
				var MemoY:Number = Clip.y;
				
				// Si l'impression est adaptative —— - -
				if( Adaptatif && !TypeOf( Adaptatif , "Number" ) ){
					
					// Si on est en Portrait ou par défaut —— - -
					if( Direction == "" || Direction == "PORTRAIT" ){
					
						// Redimentionnement si Portrait —— - -
						if ( Impression.orientation == PrintJobOrientation.PORTRAIT && Clip.width > Impression.pageWidth ){ 
							//
							Clip.height *= Impression.pageWidth / Clip.width;
							Clip.width *= Impression.pageWidth / Clip.width; 
						
						// Redimentionnement si Paysage —— - -
						} else if( Impression.orientation == PrintJobOrientation.LANDSCAPE && Clip.width > Impression.pageHeight ){
							//
							Clip.height *= Impression.pageHeight / Clip.width; 
							Clip.width *= Impression.pageHeight / Clip.width;
						}
					
					// Si on est en Paysage par défaut —— - -
					} else {
						
						// Redimentionnement si Paysage —— - -
						if ( Impression.orientation == PrintJobOrientation.LANDSCAPE && Clip.width > Impression.pageWidth ){ 
							//
							Clip.height *= Impression.pageWidth / Clip.width;
							Clip.width *= Impression.pageWidth / Clip.width; 
						
						// Redimentionnement si Portrait —— - -
						} else if( Impression.orientation == PrintJobOrientation.PORTRAIT && Clip.width > Impression.pageHeight ){
							//
							Clip.height *= Impression.pageHeight / Clip.width;
							Clip.width *= Impression.pageHeight / Clip.width; 
						}
					}
					
					
				// Si l'impression est adaptative numériquement —— - -
				} else if( TypeOf( Adaptatif , "Number" ) ){
					
					// Redimentionne
					Clip.height *= Adaptatif / 100;
					Clip.width *= Adaptatif / 100; 
				}
				
				// Si on a demandé une direction particulière —— - -
				if( Direction != "" ){
					
					// Impose une rotation le cas échéant
					if( Impression.orientation != PrintJobOrientation[ Direction ] ){ Clip.rotation = -90; }
				}
				
				// Décalage
				Clip.x += Decalage.x;
				Clip.y += Decalage.y;
				
				// Si on n'imprime qu'une seule frame —— - -
				if( TypeOf( Frame , "Number" ) || Frame == null ){
					
					// Ajoute la page d'impression par le clip
					Impression.addPage( Clip , leRectangle , null , Frame );
				
				// Si on n'imprime plusieurs frame —— - -
				} else if( TypeOf( Frame , "Array" ) ) {
					
					// Pour chaque frame à imprimer —— - -
					for( var i:int = Frame[ 0 ] ; i <= Frame[ 1 ] ; i++ ){
						
						// Ajoute la page d'impression par le clip
						Impression.addPage( Clip , leRectangle , null , i );
					}
				}
				
				// Lance l'impression
				Impression.send();
				 
				// Remet les données par défaut du clip
				Clip.rotation = MemoRotation;
				Clip.width = MemoWidth;
				Clip.height = MemoHeight;
				Clip.x = MemoX;
				Clip.y = MemoY;
				
				// Lance la fonction Launch de réussite
				Launch( Reussie );
				
			// Si l'impression à échoué —— - - Lance la fonction Launche de faillite
			} else { 
				//
				Launch( Echoue ); 
				 
				// Remet les données par défaut du clip
				Clip.rotation = MemoRotation;
				Clip.width = MemoWidth;
				Clip.height = MemoHeight;
				Clip.x = MemoX;
				Clip.y = MemoY;
			}
		}
		
		
		// —————— LAUNCH PRINT ALL
		// Imprime le contenu d'un clip frame par frame
	
		public function LaunchPrintAll( Clip:* ,					// ———— - - Le Clip en question
									 	Parametres:Object = null ,	// ———— - - Les parametres d'impressions
										Cadre:Object = null 		// ———— - - Le cadre s'il y en a un
									   ):void {
			/*—*/
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			
			// Convertie l'objet de parametres
			Parametres = CloneObject( Parametres );
			
			// Pour chaque frame du clip —— - -
			for( var iFrame:int = 1 ; iFrame <= Clip.totalFrames ; iFrame++ ){
				
				// Modifie la frame
				Parametres.frame = iFrame;
				
				// Lance l'impression de cette frame
				LaunchPrint( Clip , Parametres , Cadre );
			}
		}
	  	
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					  FILE					  		  					  */
		/*							    	  Méthodes pour ouvrir des fichiers 					  		  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - LAUNCH - - —————————————————————————————————————————— */
		// Les méthodes pour lancer l'ouverture de fichiers
		//*—*//
		
		// —————— PDF OPEN
		// Ouvre un fichier PDF
	
		public function PDFOpen( Lien:String 	// ———— - - Le Lien vers le fichier PDF
								 ):void {
			/*—*/
			
			// Ajoute l'extension si nécessaire
			Lien = ConcatUnicite( Lien , ".pdf" );
			
			// Créait la requête
			var Request:URLRequest = new URLRequest( Lien );
			
			// Lance la requête
			navigateToURL( Request );
		}
		
		
		
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}