﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			ANIM CHIP	  			Version 0.3.0									***/
/***				   				   Dernière Mise à Jour : 10-08-14										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         			   Intelligence Animation											***/
/***	Ce script des ensembles de méthodes prévues pour être appelées depuis le clip auquel il est attaché ***/
/***	et dont l'utilité est de manipuler la tête de lecture du clip de façon plus poussée.				***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Visual {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	
	// —— - - DISPLAY
	import flash.display.MovieClip;
	//
	// —— - - EVENT
	import flash.events.Event;
	import flash.events.ProgressEvent;
	//
	// —— - - UTILS
	import flash.utils.*;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class AnimChip extends MiscTools {
		
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		// —————— ELEMENT
	    // L'élément auquel ce script est rattaché
		private var Element:*;
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function AnimChip( CibleElement:* = null	// ———— - - La Cible du script si ce n'est pas l'élément auquel il est rattaché
								 ):void {
			/*—*/
			
			// Établie la connexion
			Connexion( CibleElement );
			
			// Récupère l'occurence de l'élément
			Element = CibleElement || this; 
			 
			// Repère les éléments à faire vivre
			LifeCheck();
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					ANIMATION					  		  				  */
		/*									   Méthodes de gestion de l'animation 					  			  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
		
		// —————— CHRONO STOP
	    // Le temps avant la reprise 
		private var ChronoStop:uint;
		
		// —————— REWIND
	    // Les variables en rapport avec un rembobinage
		private var RewindFrame:int;				// ———— - - L'image à atteindre par le rembobinage
		
		// —————— CHAOS
	    // Les variables en rapport avec un chaos
		private var ChaosFrame:Array = new Array();		// ———— - - Images de début et de fin du Chaos
		private var ChaosTime:int;						// ———— - - La Valeur du temps de Chaos
		private var ChaosEnd:int;						// ———— - - La Valeur du temps du Chaos à atteindre
		
		// —————— PLAY HEAD
	    // Les principes des tête de lecture
		public var PlayHead:String = "Normal";					// ———— - - Levier de lecture globale indiquant l'action de la tête de lecture
		public var PlaySpeed:int = 1;							// ———— - - Speed de déplacement de la tête de lecture
		public var PlayParameters:Object = { Fonction:Play };	// ———— - - Objet des parametres de lecture
		
		
		
		/* —————————————————————————————————————————— - - GLOBAL - - —————————————————————————————————————————— */
		// Méthodes de gestion global de l'animation
		//*—*//
		
		// —————— REFRESH PLAY HEAD
		// Rafraichit la tête de lecture
		
		private function RefreshPlayHead():void {
			/*—*/
			
			// Si on était en Sequence —— - - Retire l'évent
			if( PlayHead == "Sequence" ){ RemoveEvents( Element , SequenceLoop , "ENTER_FRAME" , "FonctionSequenceLoop" ); }
			//
			// Retire la boucle de rembobinage si on Rewind
			if( PlayHead == "Rewind" ){ RemoveEvents( Element , RewindLoop , "ENTER_FRAME" , "FonctionRewindLoop" ); }
			//
			// Retire la boucle de Chaos si on chatoise
			if( PlayHead == "Chaos" ){ RemoveEvents( Element , ChaosLoop , "ENTER_FRAME" , "FonctionChaosLoop" ); }
			//
			// Retire la Pause temporelle
			if( PlayHead == "Interrompu" ){ clearInterval( ChronoStop ); }
		}
		
		
		
		/* —————————————————————————————————————————— - - SIMPLE - - —————————————————————————————————————————— */
		// Méthodes de modifications simple de la tête de lecture
		//*—*//
		
		// —————— STOP
		// Stop la tête de lecture
		
		public function Stop():void {
			/*—*/			
				
			// Retire les boucles de tête
			RefreshPlayHead();
			
			// Interruption de la tête de lecture
			Element.stop();
			
			// Mise de l'état de la tête de lecture
			PlayHead = "Arret";
			//
			// Définition des donnée de la tête
			PlayParameters = { Fonction:Stop };
		}
		
		
		// —————— PLAY
		// Lance la tête de lecture
		
		public function Play():void {
			/*—*/
				
			// Retire les boucles de tête
			RefreshPlayHead();
			
			// Démarrage de la tête de lecture
			Element.play();
			
			// Mise de l'état de la tête de lecture
			PlayHead = "Normal";
			//
			// Définition des donnée de la tête
			PlayParameters = { Fonction:Play };
		}
		
		
		// —————— GOTO AND STOP
		// Positionne et stop la tête de lecture
		
		public function GotoAndStop( Frame:* = 1 		// ———— - - Frame à atteindre ( Numérique ou Label )
									):void {
			/*—*/
				
			// Retire les boucles de tête
			RefreshPlayHead();
			
			// S'il dépassse —— - -
			if( Frame > Element.totalFrames ){
				
				// Recalibre Frame
				Frame = Frame - ( Math.floor( Frame / Element.totalFrames ) * Element.totalFrames );
			}
			
			// Placement et arrêt de la tête de lecture sur la frame
			Element.gotoAndStop( Frame );
			
			// Mise de l'état de la tête de lecture
			PlayHead = "Arret";
			//
			// Définition des donnée de la tête
			PlayParameters = { Fonction:Stop };
		}
		
		
		// —————— GOTO AND PLAY
		// Positionne et lance la tête de lecture
		
		public function GotoAndPlay( Frame:* = 1 			// ———— - - Frame à atteindre ( Numérique ou Label )
									):void {
			/*—*/
				
			// Retire les boucles de tête
			RefreshPlayHead();
			
			// S'il dépassse —— - -
			if( Frame > Element.totalFrames ){
				
				// Recalibre Frame
				Frame = Frame - ( Math.floor( Frame / Element.totalFrames ) * Element.totalFrames );
			}
			
			// Placement et démarrage de la tête de lecture sur la frame
			Element.gotoAndPlay( Frame );
			
			// Mise de l'état de la tête de lecture
			PlayHead = "Normal";
			//
			// Définition des donnée de la tête
			PlayParameters = { Fonction:Play };
		}
		
		
		
		/* —————————————————————————————————————————— - - PAUSE - - —————————————————————————————————————————— */
		// Méthodes pour interrompre la tête de lecture pendant une courte durée
		//*—*//
		
		// —————— PAUSE
		// Interrompt momentanément le défilement de la tête de lecture
		
		public function Pause( Duree:* = true		// ———— - - Durée d'interruption
							 ):void {
			/*—*/
				
			// Si on a fait un appel temporelle ou vraie —— - -
			if( Duree != false ){
				
				// Retire les boucles de tête
				RefreshPlayHead();
				
				// Interruption de la tête de lecture
				Element.stop();
				
				// Si c'est temporel
				if( Duree != true ){
				
					// Création de l'intervalle dans la durée indiqué
					ChronoStop = setInterval( PauseEnd , Duree );
				}
				
				// Définition de l'état de la tête de lecture
				PlayHead = "Interrompu";
				
			// Sinon si on est pas en lecture —— - -
			} else if( PlayHead == "Interrompu" ){
				
				// Relance
				PauseEnd();
			}
		}
		//
		// —————— PAUSE END
		// Relance la tête de lecture à la fin de la pause
		private function PauseEnd():void {
			/*—*/
			
			// Relance à partir de la dernière demande
			Launch( PlayParameters );
		}
		
		
		
		/* —————————————————————————————————————————— - - REWIND - - —————————————————————————————————————————— */
		// Méthodes pour procéder à un rembobinage de la tête de lecture
		//*—*//
		
		// —————— REWIND
		// Lance le rembobinage de la tête de lecture
		
		public function Rewind( Fin:int = 1 		// ———— - - Image à atteindre
							  ):void {
			/*—*/
				
			// Retire les boucles de tête
			RefreshPlayHead();
			
			// Interrompt la lecture de l'animation
			Element.stop();
		
			// Définition de l'image à atteindre
			RewindFrame = Fin;
			
			// Mise sur la frame précédent la frame actuel
			Element.gotoAndStop( Element.currentFrame - 1 );
			
			// Lancement de la boucle de rembobinage
			AddEvents( Element , RewindLoop , "ENTER_FRAME" , "FonctionRewindLoop" );
			
			// Définition de l'état de la tête de lecture
			PlayHead = "Rewind";
			//
			// Définition des donnée de la tête
			PlayParameters = { Fonction:Rewind , Arguments:[ Fin ] };
		}
		//
		// —————— REWIND LOOP
		// Boucle de rembobinage
		public function RewindLoop( event:Event ):void {
			/*—*/
			
			// Mise sur la frame précédent la frame actuel
			Element.gotoAndStop( Element.currentFrame - 1 );
			
			// Si la Frame actuelle est à la Frame à atteindre —— - -
			if( Element.currentFrame == RewindFrame ){
				
				// Relancement de la lecture
				Play();
				
			// Si la Frame actuelle est à 1 et qu'on a demandé l'atteinte de zéro —— - -
			} else if( Element.currentFrame == 1 && RewindFrame == 0 ){
				
				// Va sur la dernière image
				gotoAndStop( Element.totalFrames );
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - CHAOS - - —————————————————————————————————————————— */
		// Méthodes pour procéder à une déplacement aléatoire de la tête de lecture
		//*—*//
		
		// —————— CHAOS
		// Lance le déplacement chaotique de la tête de lecture
	  
		public function Chaos( Debut:int = 0 , 		// ———— - - Image de Début
							   Fin:int = 0 ,		// ———— - - Image de Fin
							   Duree:int = 0		// ———— - - Durée du chaos en Frame
							 ):void {
			/*—*/
			
			// Retire les boucles de tête
			RefreshPlayHead();
			
			// Switch des arguments
			if( Fin == 0 && Debut >= 500 ){
				//
				Duree = Debut;
				Debut = 0;
			}
			
			// Définition de l'image de fin au nombre de total de frame si sur 0
			if( Fin == 0 ){ Fin = Element.totalFrames; }
			
			// Récupération de la variable de départ et la variable de fin
			ChaosFrame[ 0 ] = Debut;
			ChaosFrame[ 1 ] = Fin;
			
			// Récupération du temps
			ChaosEnd = Duree;
			
			// Mise du temps de Chaos à 0
			ChaosTime = 0;
			
			// Lancement de la boucle de Chaos
			AddEvents( Element , ChaosLoop , "ENTER_FRAME" , "FonctionChaosLoop" );
			
			// Définition de l'état de la tête de lecture
			PlayHead = "Chaos";
			//
			// Définition des donnée de la tête
			PlayParameters = { Fonction:Chaos , Arguments:[ Debut , Fin , Duree ] };
		}
		//
		// —————— CHAOS LOOP
		// Boucle de chaos
		public function ChaosLoop( event:Event ):void {
			/*—*/
			
			// Mise sur la une frame au hasard entre le début et la fin
			var Chiffre:int = Math.round( Math.random() * ( ChaosFrame[ 1 ] - ChaosFrame[ 0 ] ) + ChaosFrame[ 0 ] );
			Element.gotoAndStop( Chiffre );
			
			// Avancé du temps de chaos
			ChaosTime++;
			
			// Si le temps de Chaos a atteint le temps voulu —— - -
			if( ChaosTime == ChaosEnd ){
				
				// Relancement de la lecture
				Play();
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - SPEED - - —————————————————————————————————————————— */
		// Méthodes pour modifier la Speed de déplacement de la tête de lecture
		//*—*//
		
		// —————— SPEED
		// Modifie la Speed de déplacement de la tête de lecture
	
		public function Speed( Speed:int	// ———— - - La Vitesse
							  ):void {
			/*—*/
			
			// Si la Speed de la tête de lecture était à 1 jusqu'à présent —— - - Donne la boucle
			if( PlaySpeed == 1 ){
				//
				AddEvents( this , SpeedLoop , "ENTER_FRAME" , "FunctionSpeedLoop" );
			}
			
			// Remplace la valeur de la Speed
			PlaySpeed = Speed;
			
			// Si elle est à un —— - - Retire la boucle est fait play
			if( PlaySpeed == 1 ){
				//
				RemoveEvents( this , SpeedLoop , "ENTER_FRAME" , "FunctionSpeedLoop" );
				Play();
			
			// Sinon —— - - Stop
			} else { Stop(); }
		}
		//
		// —————— SPEED LOOP
		// Boucle de vitesse
		public function SpeedLoop( event:Event ):void {
			/*—*/
			
			// Fait défiler suivant la Speed
			AnimationScroll( Element , PlaySpeed );
		}
		
		
		
		/* —————————————————————————————————————————— - - SEQUENCE - - —————————————————————————————————————————— */
		// Méthodes pour générer un déplacement séquencé de la tête de lecture
		//*—*//
		
		// —————— SEQUENCE
		// Donne au défilement de la tête de lecture un positionnement frame par frame
	
		public function Sequence( LaSequence:* ,						// ———— - - Tableau de Sequence ( Série de String )
								  Boucle:Boolean = false ,				// ———— - - S'il boucle ou non
								  SpeedDefaut:int = 1 ,					// ———— - - La Speed par défaut du défilement
								  DefilementDefaut:String = "stop" ,	// ———— - - L'ordre de défilement par défaut
								  Refresh:Boolean = true ,				// ———— - - S'il doit y avoir rafraichissement des valeurs ou non
								  CibleElement:* = null 				// ———— - - Element conscerné
								 ):void {
			/*—*/
			
			// Arguments par défaut
			CibleElement = CibleElement || Element;
			
			// Récupération des arguments
			CibleElement.manip = ( typeof LaSequence == "object" && LaSequence[ 0 ] ) ? LaSequence : LaSequence.split( " " );
			CibleElement.boucle = Boucle;
			CibleElement.SpeedDefaut = SpeedDefaut;
			CibleElement.DefilementDefaut = DefilementDefaut;
			
			// S'il doit y avoir rafraichissement des valeurs —— - -
			if( Refresh ){
				
				// Mise des valeurs initiales
				CibleElement.têteManip = 0;
				CibleElement.têteDeLecture = 0;
			}
			
			// Retire les boucles de tête
			RefreshPlayHead();
			
			// Donne la boucle de Sequence à l'élément
			AddEvents( CibleElement , SequenceLoop , "ENTER_FRAME"  , "FonctionSequenceLoop" );
			
			// Définition de l'état de la tête de lecture
			PlayHead = "Sequence";
			//
			// Définition des donnée de la tête
			PlayParameters = { Fonction:Sequence , Arguments:[ CibleElement , LaSequence , Boucle , SpeedDefaut , DefilementDefaut , false ] };
		}
		//
		// —————— SEQUENCE LOOP
		// Boucle de Sequençage
		public function SequenceLoop( event:Event ):void {
			/*—*/
			
			// Récupération de l'instance de l'élément
			Character = event.target;
			
			// Si l'attente sur la frame est achevé —— - -
			if( Character.têteDeLecture <= 0 ){
				
				// Récupération de la prochaine frame à aller
				Character.têteNext = Character.manip[ Character.têteManip ].split( "-" )[ 0 ];
				
				// Récupération du temps à rester sur cette frame ( Si rien n'est précisé, mes à 1, à savoir juste un temps )
				Character.têteDeLecture = ( Character.manip[ Character.têteManip ].split( "-" )[ 1 ] != null ) 
									  ? int( Character.manip[ Character.têteManip ].split( "-" )[ 1 ] ) : Character.SpeedDefaut;
				
				// Récupération de l'action d'envoie sur la frame ( "play" ou par défaut : "stop" )
				Character.têteAction = ( Character.manip[ Character.têteManip ].split( "-" )[ 2 ] != null ) 
									? Character.manip[ Character.têteManip ].split( "-" )[ 2 ] : Character.DefilementDefaut;
				
				
				// Le fait atteindre atteindre la frame par le biais d'un gotoAndStop ou gotoAndPlay selon la demande
				if( Character.têteAction == "stop" ){ Character.gotoAndStop( Character.têteNext ); } 
				else if( Character.têteAction == "play" ){ Character.gotoAndPlay( Character.têteNext );	}
				
				// Augmente la valeur de la tête de Sequence
				Character.têteManip++
				
				
				// Si on a atteint la dernière partie de la Sequence sur cet élément —— - -
				if( Character.têteManip >= Character.manip.length ){ 
					
					// S'il doit boucler —— - - on le remet à 0
					if( Character.boucle ){ Character.têteManip = 0; } 
					
					// Sinon —— - - On lui retire la boucle de la Sequence
					else { RemoveEvents( Character , SequenceLoop , "ENTER_FRAME"  , "FonctionSequenceLoop" ); }
				}
			}
			
			// Réduction de la tête de lecture
			Character.têteDeLecture--;
		}
		
		
		
		/* —————————————————————————————————————————— - - SPOT - - —————————————————————————————————————————— */
		// Méthodes pour placer des points d'entré/sortie aléatoire sur la time-line
		//*—*//
		
		// —————— SPORT ORDER
		// Place des spot de téléportation de la tête de lecture
		
		public function SpotOrder( Spots:* ,					// ———— - - Les spots
								   Boucle:Boolean = true	, 	// ———— - - Si la boucle est lancé
								   Repassage:Boolean = false	// ———— - - Si c'est un SpotOrder qui passe par dessus un autre
								 ):void {
			/*—*/
			
			// Si c'est un repassage ou que le SpotOrder est le premier
			if( Repassage || !Element.Spots ){
				
				// S'il s'agit d'un string —— - - il le convertie en tableau
				if( typeof Spots == "string" ){	Spots = Spots.split( " " );	}
				
				// Si l'animation n'a pas déjà de tableau de Spots —— - - Lui donne directement ce tableau
				if( !Element.Spots ){ Element.Spots = Spots; }
				//
				// Si l'animation a déjà un tableau de Spots —— - -
				else { 
					
					// Pour chaque éléments du tableau à ajouter —— - -
					for( var i:int = 0 ; i < Spots.length ; i++ ){
						
						// Ajoute cet éléments s'il ne se trouve pas déjà dans le tableau des spots de l'animation
						PushUnicite( Element.Spots , Spots[ i ] );
					}
				}
				
				// Lui donne la boucle s'il faut —— - -
				if( Boucle && !Repassage ){ AddEvents( this , SpotLoop , "ENTER_FRAME" , "FonctionSpotLoop" ); }
			}
		}
		//
		// —————— SPOT LOOP
		// Boucle de Spot
		public function SpotLoop( event:Event ):void {
			/*—*/
			
			// Pour chaque spot —— - -
			for( var i:* in Element.Spots ){
				
				// S'il est quasiement dessus —— - -
				if( Element.Spots[ i ] == Element.currentFrame + 1 || Element.currentFrame == Element.totalFrames - 1 ){
					
					// Lance le spot
					Spot();
				}
			}
		}
		
		
		// —————— SPOT
		// Téléporte la tête de lecture vers un spot aléatoire
		
		public function Spot():void {
			/*—*/
			
			// Si l'animation a un tableau de spot —— - -
			if( Element.Spots ){
				
				// l'animation se rend, aléatoirement, sur l'une des frames spotées
				Element.gotoAndPlay( RandomArray( Element.Spots ) );
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					   SHAPE					  		  				  */
		/*								 Méthodes de modification de la forme de l'élément 					  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Méthodes pour modifier la forme de l'élément
		//*—*//
		
		// —————— RANDOM SHAPE
		// Modifie aléatoirement un état de l'élément, Frame, Rotation, Taille, etc.
	
		public function RandomShape( Forme:String = "Frame" ,	// ———— - - L'état SequenceLoop en aléatoire
									 Lancement:Boolean = false	// ———— - - Si l'animation est lancé ensuite
									):void {
			/*—*/
			
			// Récupération du Choix de la forme
			var ChoixForme:String = Forme.split( "," )[ 0 ];
			
			// Variable de hasard
			var DHasard:int = new int();
			var FHasard:int = new int();
			var HasardDeForme:Number = new Number();
			
			
			// —— - - FRAME
			if( ChoixForme == "Frame" ){ 
			
				// Récupération du début et de la fin du hasard
				DHasard = ( Forme.split( "," )[ 1 ] != null ) ? Forme.split( "," )[ 1 ] : 1;
				FHasard = ( Forme.split( "," )[ 2 ] != null ) ? int( Forme.split( "," )[ 2 ] ) + 1 : Element.totalFrames + 1;
				
				// Calcul du hasard
				HasardDeForme = int( Math.random() * ( FHasard - DHasard ) + DHasard );
				
				// Placement de l'animation sur la valeur de hasard calculé
				Element.gotoAndStop( HasardDeForme );
				
				
			// —— - - ROTATION
			} else if( ChoixForme == "Rotation" ){ 
			
				// Récupération du début et de la fin du hasard
				DHasard = ( Forme.split( "," )[ 1 ] != null ) ? Forme.split( "," )[ 1 ] : -180;
				FHasard = ( Forme.split( "," )[ 2 ] != null ) ? Forme.split( "," )[ 2 ] : 180;
				
				// Calcul du hasard
				HasardDeForme = Math.random() * ( FHasard - DHasard ) + DHasard;
				
				// Rotation de la forme selon la valeur
				Element.rotation = HasardDeForme;
				
			
			// —— - - TAILLE
			} else if( ChoixForme == "Taille" ){ 
				
				// Récupération du début et de la fin du hasard
				DHasard = ( Forme.split( "," )[ 1 ] != null ) ? Forme.split( "," )[ 1 ] : 10;
				FHasard = ( Forme.split( "," )[ 2 ] != null ) ? Forme.split( "," )[ 2 ] : 100;
				
				// Calcul du hasard
				HasardDeForme = Math.random() * ( FHasard - DHasard ) + DHasard;
				
				// Redimensionnement de la forme selon la valeur en pourcentage
				Element.width *= HasardDeForme / 100;
				Element.height *= HasardDeForme / 100;
			}
			
			
			// Lance l'animation s'il le faut
			if( Lancement ){ Element.play(); }
		}
		
		
		// —————— REPLICATION
		// Un clip reste sur la même frame qu'un autre
		
		public function Replication( Cible:* , 				// ———— - - La Cible répliquée
								     CibleElement:* = null	// ———— - - L'élément qui réplique
								    ):void {
			/*—*/
			
			// Arguments par défaut
			//
			// L'élément est l'animation par défaut
			CibleElement = CibleElement || Element;
			
			// Création de l'objet de suivis
			CibleElement.ObjetReplication = new Object();
			
			// Les paramétres donné à l'élément qui Replication
			CibleElement.ObjetReplication.Cible = Cible;
	
			
			// Si on a pas encore donné sa boucle de suivis à l'élément —— - -
			if( !CibleElement.ObjetReplication.Boucle ){
				
				// Donne sa boucle —— - -
				CibleElement.ObjetReplication.Boucle = function( event:Event ):void {
					
					// Récupére l'instance
					var C:* = event.target;
					
					// Repositionne la tête de lecture
					C.gotoAndStop( C.ObjetReplication.Cible.currentFrame );
				}
				
				// Donne l'événement à l'élément
				AddEvents( CibleElement , CibleElement.ObjetReplication.Boucle , "ENTER_FRAME" );
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					  ACTION					  		  				  */
		/*							 Méthodes d'ajout et gestion des actions sur les frames 					  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Méthode pour agir sur les actions des frames de l'élément
		//*—*//
		
		// —————— ADD ACTION
		// Pose une fonction à lancer sur une frame
		
		public function AddAction( Fonction:* ,				// ———— - - La Fonction à lancer
								   Frame:int =1 ,			// ———— - - La frame où la fonction est lancée
								   Nom:String = "" ,		// ———— - - Nom de l'action apposée ( Mis sur le nom de la fontion par défaut )
								   CibleElement:* = null	// ———— - - Element animé sondé s'il n'est pas celui qui contient l'AnimTools
								  ):void {
			/*—*/
			
			// Arguments par défaut
			//
			// Mise du nom sur la fonction par défaut
			if( Nom == "" ){ Nom = Fonction.Fonction; }
			//
			
			// Convertie l'objet de fonction
			if( !TypeOf( Fonction , "Object" ) ){
				//
				Fonction = { Fonction:Fonction };
			}
			
			// L'élément est l'élément animé par défaut
			CibleElement = CibleElement || Element;
			
			// Donne le nom de la fonction à l'objet de fonction
			Fonction.Nom = Nom;
			
			// Création de l'objet des actions si l'élément ne l'a pas déjà
			if( !CibleElement.Actions ){ CibleElement.Actions = new Object(); }
			
			// Création de l'objet des actions pour cette frame s'il ne l'a pas déjà
			if( !CibleElement.Actions[ Frame ] ){ CibleElement.Actions[ Frame ] = new Array(); }
			
			// Ajoute aux tableaux des actions pour cette frame la fonction en question
			CibleElement.Actions[ Frame ].push( Fonction );
			
			// S'il n'a pas encore la fonction qui boucle sur la vérifie les actions à lancer —— - -
			if( !CibleElement.CheckActions ){
				
				// Donne sa fonction de boucle —— - -
				CibleElement.CheckActions = function( e:Event ):void {
					
					// Récupére l'instance de l'élément
					var Cible:* = e.target;
					
					// S'il a, bel et bien, des actions à lancer —— - -
					if( Cible.Actions ){
					
						// S'il a des actions à lancer pour la frame en cours —— - -
						if( Cible.Actions[ Cible.currentFrame ] ){
							
							// Pour chaque action à lancer —— - -
							for( var i:int = 0 ; i < Cible.Actions[ Cible.currentFrame ].length ; i++ ){
							
								// La lance
								Launch( Cible.Actions[ Cible.currentFrame ][ i ] );
							}
						}
					}
				}
				
				// Donne l'événement de boucle à l'élément
				AddEvents( CibleElement , CibleElement.CheckActions , "ENTER_FRAME" , "FonctionCheckActions" );
			}
		}
		
		
		// —————— REMOVE ACTION
		// Retire une fonction à lancer sur une frame
		
		public function RemoveAction( Frame:* = -1 ,			// ———— - - Frame où est apposé la fonction à retirer 
									  Nom:String = "" ,			// ———— - - Nom de l'action à retirer
									  CibleElement:* = null		// ———— - - Element ayant cette fonction à retirer
									 ):void {
			/*—*/
			
			// Switch des arguments
			if( TypeOf( Frame , "String" ) ){
				//
				Nom = Frame;
				Frame = -1;
			}
			
			// L'élément est l'animation par défaut
			CibleElement = CibleElement || Element;
			
			// Si on a choisit aucune frame et aucun nom —— - -
			if( Frame == -1 && Nom == "" ){ 
				
				// Retire l'événement de boucle de vérification des actions de frame à l'élément
				RemoveEvents( CibleElement , CibleElement.CheckActions , "ENTER_FRAME" , "FonctionCheckActions" );
				//
				// Mes à null l'objet des actions et la fonction de vérification des actions de l'élément
				CibleElement.Action = null; 
				CibleElement.CheckActions = null;
			
			// Si on a choisit une frame ou un nom ou les deux —— - -
			} else {
				
				// Si on a choisit au moins une frame ▼♥
				if( Frame != -1 ){
					
					// Si l'élément a des actions —— - -
					if( CibleElement.Actions ){
						
						// Si l'élément a des actions sur cette frame —— - -
						if( CibleElement.Actions[ Frame ] ){
							
							// Si on a choisit un nom —— - -
							if( Nom != "" ){
								
								// Pour chaque actions sur cette frame —— - -
								for( var i:int = 0 ; i < CibleElement.Actions[ Frame ].length ; i++ ){
									
									// Si cette action porte ce nom —— - -
									if( CibleElement.Actions[ Frame ][ i ].Nom == Nom ){
										
										// Mes cette action à null
										CibleElement.Actions[ Frame ][ i ] = null;
									}
								}
							
							// Si on a pas choisit de nom —— - -
							} else {
								
								// Mes toutes les actions de la frame à null
								CibleElement.Actions[ Frame ] = null;
							}
						}
					}
					
					
				// Si on a choisit aucune frame —— - -
				} else {
					
					// Pour chaque frame de l'animation de l'élément —— - -
					for( var j:int = 1 ; j <= CibleElement.totalFrames ; j++ ){
						
						// Si cette frame a des actions —— - -
						if( CibleElement.Actions[ j ] ){
							
							// Si on a choisit un nom
							if( Nom != "" ){
								
								// Pour chaque action de cette frame —— - -
								for( var k:int = 0 ; k < CibleElement.Actions[ j ].length ; k++ ){
									
									// Si cette action porte le nom choisit —— - -
									if( CibleElement.Actions[ j ][ k ].Nom == Nom ){
										
										// mes cette action à null
										CibleElement.Actions[ j ][ k ] = null;
									}
								}
								
							// Si on a choisit aucun nom
							} else {
								
								// Mes toutes la frame à null
								CibleElement.Actions[ j ] = null;
							}
						}
					}
				}
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					   LIFE						  		  				  */
		/*					Méthodes d'ajout de comportement de l'élément pour simuler un état vivant 			  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
		
		// —————— CHARACTER
	    // Récupération du personnage concerné
		private var Character:*;
		
		// —————— COMPORTEMENTS
		// Les différents types de comportements
		public var EyesStock:Array = new Array();
		public var BreathStock:Array = new Array();
		
		
		
		/* —————————————————————————————————————————— - - CHECK - - —————————————————————————————————————————— */
		// Méthode de vérification de l'état de l'élément pour déceler des demandes de comportement
		//*—*//
	  	
		// —————— LIFE
		// Donne un comportement vivant à une partie de l'élément
		
		public function Life( Partie:String,			// ———— - - Nom de la partie du clip
							  CibleElement:*,			// ———— - - Instance de la partie
							  Parametres:* = null		// ———— - - Paramétre suplémentaire de la partie
							):void {
			/*—*/
			
			// S'il n'y a aucun paramètres —— - - on créait le conteneur de paramètre vide
			Parametres = Parametres || new Object();
			
			// Instanciation de l'élément et gain de ses paramétres
			var TableauStock:Array = this[ Partie + "Stock" ];
			TableauStock[ TableauStock.length ] = CibleElement;
			//
			CibleElement.Parametres = Parametres;
			CibleElement.joue = false;
			
			// Arrêt de son animation
			CibleElement.stop();
			
			// On lui donne son intelligence d'animation suivant ce qu'il est comme partie
			AddEvents( CibleElement , this[ "Life" + Partie ] , "ENTER_FRAME" );
		}
		
		
		// —————— LIFE CHECK
		// Vérifie le nom d'un élément pour voir s'il contient un nom relatif pour le rendre vivant, 
		// si c'est le cas, la fonction Life() est lancée pour lui
	
		public function LifeCheck():void {
			/*—*/
			
			try{
					
				// Pour chacun de ses enfants —— - -
				for( var i:int = 0 ; i < Element.numChildren ; i++ ){
					
					// Prend l'occurence de l'élément
					var CibleElement:* = Element.getChildAt( i );
					
					// Yeux
					if( FindIn( CibleElement.name , "Eyes" ) ){ Life( "Eyes" , CibleElement ); }
					
					// Poumon
					else if( FindIn( CibleElement.name , "Breath" ) ){ Life( "Breath" , CibleElement ); }
				}
			} catch( e ){}
		}
		
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Méthode pour agir sur le comportement de l'élément
		//*—*//
		
		// —————— LIFE EYES
		// Clignement de paupière
	
		public function LifeEyes( event:Event ):void {
			/*—*/
			
			// Instance de l'élément
			Character = event.target;
			
			// —— - - Si on se trouve sur la première frame
			if( Character.currentFrame == 1 ){
				
				// Si l'animation est en marche —— - -
				if( Character.joue ){ 
				
					// Elle s'interrompt
					Character.stop(); 
					Character.joue = false;
				}
				
				// Test random d'une valeur
				var TentativeCligne:int = Math.random() * 1000;
				
				// Si la valeur est dans le pourcentage de la nervosité du personnage
				if( TentativeCligne < ( Character.Parametres.Nervosité || 20 ) ){
					
					// Lance son animation
					Character.play();
					Character.joue = true;
				}
			}
		}
		
		
		// —————— LIFE BREATH
		// Respiration
	
		public function LifeBreath( event:Event ):void {
			/*—*/
			
			// Instance de l'élément
			Character = event.target;
			
			// Si c'est le premier passage —— - -
			if( Character.EtatRespiration == null ){ 
				
				// Définie les variables initiales
				Character.EtatRespiration = "Inspire";
				Character.Respire = true;
				Character.Air = 0;
				Character.SpeedAir = 0;
				Character.Largeur = Character.width;
				Character.Hauteur = Character.height;
			}
			
			// Si le personnage Inspire —— - -
			if( Character.EtatRespiration == "Inspire" ){
				
				// Augmente la Speed d'inspiration si elle n'est pas supérieur au max
				if( Character.SpeedAir < ( Character.Parametres.Max || 2 ) ){ 
					//
					Character.SpeedAir += ( Character.Parametres.Nervosité || 1 ) / 100; 
				}
				
				// Augmente la capacité d'Air suivant la Speed d'inspiration
				Character.Air += Character.SpeedAir;
				
				
				// Si on a le Max d'air dans les poumons —— - -
				if( Character.Air >= ( Character.Parametres.Max || 20 ) / 10 ){
					
					// On expire
					Character.EtatRespiration = "Expire";
				}
			
			
			// Si le Characternnage Expire —— - -
			} else if( Character.EtatRespiration == "Expire" ){
				
				// Augmente la Speed d'expiration si elle n'est pas supérieur au max
				if( Character.SpeedAir > ( ( Character.Parametres.Max || 20 ) / 10 ) * -1 ){ 
					//
					Character.SpeedAir -= ( Character.Parametres.Nervosité || 1 ) / 100; 
				}
				
				// Réduit la capacité d'Air suivant la Speed d'expiration
				Character.Air += Character.SpeedAir;
				
				// Si on n'a plus d'air —— - -
				if( Character.Air <= 0 ){
					
					// On inspire
					Character.EtatRespiration = "Inspire";
				}
			}
			
			// Si la capacité d'Air a atteint une de ses extrêmes —— - - La Speed d'Expiration / Inspiration se réduit en fonction de la
			// capacité de Dilatation / Affaissement du ventre
			if( Character.EtatRespiration == "Inspire" && Character.SpeedAir < 0 ){ 
				//
				Character.SpeedAir *= ( Character.Parametres.Dilatation || 7 ) / 10; 
			}
			//
			if( Character.EtatRespiration == "Expire" && Character.SpeedAir > 0 ){ 
				//
				Character.SpeedAir *= ( Character.Parametres.Affaissement || 3 ) / 10; 
			}
			
			
			// Tentative d'apnée
			Character.TentativeApnee = Math.random() * 100;
			
			// Si le personage respire —— - -
			if( Character.Respire ){
				
				// Si sa tentative d'apnée est dans les norme de sa régularité à avoir des apnées —— - -
				if( Character.TentativeApnee < ( Character.Parametres.RegularitéApnée || 2 ) ){ 
					//
					// Il cesse de respirer
					Character.Respire = false;	
				}
				
				
			// Si le personnage ne respire pas —— - -
			} else {
				
				// Si la tentative d'apnée est dans les norme de sa régularité à reprendre sa respiration —— - - 
				if( Character.TentativeApnee < ( Character.Parametres.RegularitéRespire || 7 ) ){ 
					//
					// Il se remet à respirer
					Character.Respire = true; 
				}
				
				// Sa Speed d'Expiration / Inspiration se réduit de moitié
				Character.SpeedAir *= 0.5;
			}
			
			// Modification de la taille de son ventre suivant l'Air à l'intérieur
			Character.width = Character.Largeur * ( Character.Air / 10 + 1 );
			Character.height = Character.Hauteur * ( Character.Air / 10 + 1 );
		}
		
		
		
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}