﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			FILTER TOOLS	  		Version 0.2.0									***/
/***				   				   Dernière Mise à Jour : 10-08-14										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         				    Outils Filtre												***/
/***	Ce script contient les méthodes pour placer et manipuler des effets de filtre.					    ***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Visual {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*—*//
	
	// —— - - DISPLAY
	import flash.display.MovieClip;
	//
	// —— - - EVENT
	import flash.events.Event;
	//
	// —— - - FILTRES
	import flash.filters.BlurFilter;
	import flash.filters.GlowFilter;
	import flash.filters.DropShadowFilter;
	//
	// —— - - GEOM
	import flash.geom.ColorTransform; 
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	import drOIde.Visual.OptimizeProcess;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class FilterTools extends MiscTools {
		
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*—*//
		
		// —————— LINK
	    //— Les liaisons avec d'autres scripts
		private var Optimize:OptimizeProcess;
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function FilterTools( TheLink:* = null ,	// ———— - - Lien vers un élément
									 LienOptimize:* = null	// ———— - - Lien vers le OptimizeProcess
									){
			/*—*/
			
			// Si le lien n'est pas OptimizeProcess —— - - Connexion
			if( !TypeOf( TheLink , "OptimizeProcess" ) ){
				//
				Connexion( TheLink );
			
			// Sinon —— - - Transfert au lien Optimize
			} else {
				//
				LienOptimize = TheLink;
			}
			
			// Récupére le lien vers Optimize s'il y en a un
			if( LienOptimize ){ Optimize = LienOptimize; }
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 APPLY					  		  					  */
		/*									  Méthodes pour appliquer des filtres 					  			  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - GLOBAL - - —————————————————————————————————————————— */
		// Méthodes d'application d'ordre général
		//*—*//
		
		// —————— APPLY FILTER
		// Applique les filtres contenu dans un élément
		
		private function ApplyFilter( Clip:* 	// ———— - - Le Clip concerné
									 ):void {
			/*—*/
			
			// Tableau pour l'application des filtres
			var FiltresAppliquees:Array = new Array();
			
			// Pour chaque filtre de ce clip —— - -
			for( var Filtres:* in Clip.Filtres ){
				
				// S'il n'est pas null —— - -
				if( Clip.Filtres[ Filtres ] != null ){
				
					// Ajoute ce filtre au tableau
					FiltresAppliquees.push( Clip.Filtres[ Filtres ].Filtre );
				}
			}
			
			// Applique les filtres
			Clip.filters = FiltresAppliquees;
		}
		
		
		
		/* —————————————————————————————————————————— - - GLOW - - —————————————————————————————————————————— */
		// Méthodes d'application d'effet de lueur externe
		//*—*//
		
		// —————— APPLY GLOW
		// Applique un effet de Glow externe
		
	  	public function ApplyGlow( Clip:* ,							// ———— - - Clip concerné
								   Parametres:* = null ,			// ———— - - Les parametres du Glow
								   Dynamique:Boolean = false ,		// ———— - - Si le filttre est modifiable dynamiquement
								   QualiteMinimale:String = ""		// ———— - - Qualité minimale pour l'affichage du filtre
								):* {
			/*—*/
			
			// Si le parametres est une boolean —— - -
			if( TypeOf( Parametres , "Boolean" ) ){
				
				// Transfert le parametres au dynamique
				Dynamique = Parametres;
				Parametres = new Object();
				
				// S'il possède un objet Glow —— - -
				if( Clip.Glow ){
				
					// Retire sa boucle
					RemoveEvents( Clip , [ "ENTER_FRAME" , Clip.Glow , "Boucle" ] );
					
					// Met l'objet GLow à null
					Clip.Glow = null;
				}
			
				// S'il n'est pas Dynamique —— - -
				if( !Dynamique ){
					
					// Retire son effet de Glow
					ApplyGlowOn( Clip , false );
					
					// Sort de la fonction
					return null;
				}
			}
			
			// S'il n' possède pas d'objet Glow —— - -
			if( !Clip.Glow ){
				
				// Récupère les valeurs du Glow depuis le paramètres
				Parametres = Parametres || new Object();
				//
				var Couleur:String = 		Parametres.color 	|| "FFFFFF";
				var Alpha:Number = 			Parametres.alpha 	|| 100;
				var DispersionX:Number = 	Parametres.blurX 	|| 10;
				var DispersionY:Number = 	Parametres.blurY 	|| 10;
				var Force:Number = 			Parametres.strength || 2;
				var Qualite:Number = 		Parametres.quality 	|| 1;
				
				// Applique le Glow
				ApplyGlowOn( Clip , Couleur , Alpha , DispersionX , DispersionY , Force , Qualite );
				
				
				// S'il est dynamique —— - -
				if( Dynamique ){
					
					// Donne l'objet de Glow au clip
					Clip.Glow = { color:Couleur ,
								  alpha:Alpha ,
								  blurX:DispersionX ,
								  blurY:DispersionY ,
								  strength:Force ,
								  quality:Qualite
								};
					
					
					// Si on a choisi une qualité minimale —— - -
					if( QualiteMinimale != "" ){
						
						// Si on a instancié le OptimizeProcess —— - -
						if( Optimize ){
							
							// Si la qualité choisie existe —— - - 
							if( Optimize.GetQuality( QualiteMinimale ) != -1 ){ 
								
								// On la lui donne
								Clip.Glow.QualiteMinimale = QualiteMinimale; 
								
							// Si elle n'existe pas —— - -
							} else {
								
								// Trace l'erreur
								TraceError( "FilterTools" , "ApplyGlow" , [ "la qualité \"" + QualiteMinimale+ "\" n'éxiste pas." , 
																			 Optimize.TellMeQuality() ] );
								
								// Donne une pare défaut
								Clip.Glow.QualiteMinimale = "High";
							}
						
						// Si on n'a pas instancé le OptimizeProcess —— - -
						} else {
							
							// Trace l'erreur
							TraceError( "FilterTools" , "ApplyGlow" , [ "Un choix de qualité minimale a été choisi pour cet effet de filtre, or" ,
																		 "le lien vers la OptimizeProcess n'a pas été donné au FilterTools." ,
																		 "Pour le faire, il suffit de mettre, quand on créait l'instance de FilterTools :" ,
																		 "var Filter = new FilterTools( Optimize );" ] )
						}
					}
					
					// On lui donne sa memoire de levier
					Clip.Glow.MemoireLevier = true;
					
					// Donne la mémoire de l'objet de Glow au clip
					Clip.Glow.Memoire = CloneObject( Clip.Glow );
					
					// Donne la boucle du Glow —— - -
					Clip.Glow.Boucle = function( event:Event ):void {
						
						// Récupére l'instance de la cible
						var Cible:* = event.target;
						
						// Récupére l'instance de l'objet rayonement
						var Filtre:Object = Cible.Glow;
						
						// Levier de lancement
						var LevierOk:Boolean = true;
						
						// S'il y a une qualite minimale —— - -
						if( Filtre.QualiteMinimale ){
							
							// Si la qualite est insuffisante —— - -
							if( Optimize.QualityNumero < Optimize.GetQuality( Filtre.QualiteMinimale ) ){
								
								// Bloque le levier
								LevierOk = false;
							}
						}
							
							
						// Si on peut le lancer —— - -
						if( LevierOk ){
							
							// Levier des modifications de filtres
							var Levier:Boolean = true;
							
							// Pour chaque états du Glow —— - -
							for( var Etats:* in Cible.Glow ){
								
								// Si ce n'est pas la boucle, la mémoire ou la qualité minimale —— - -
								if( Etats != "Boucle" && Etats != "Memoire" && Etats != "QualiteMinimale" ){
									
									// Si l'effet a été changé, toggle le levier
									if( Cible.Glow[ Etats ] != Cible.Glow.Memoire[ Etats ] ){ Levier = false; }
								}
							}
							
							// Si le levier a été togglé —— - -
							if( !Levier ){ 
								
								// Réapplique le Glow avec les nouveaux critéres
								ApplyGlowOn( Cible , Filtre.color , Filtre.alpha , Filtre.blurX , Filtre.blurY , Filtre.strength , Filtre.quality ); 
								
								// Récupére la mémoire de l'objet
								Filtre.Memoire = CloneObject( Filtre , [ "Memoire" ] );
							}
							
						// Si on n'a pas put le lancer et que la mémoire indique qu'il a été lancé auparavent —— - -
						} else if( Filtre.MemoireLevier != LevierOk ){
							
							// Si le levier est faux —— - - Stop le Glow
							if( ! LevierOk ){ ApplyGlowOn( Cible , false ); }
							//
							// Si le levier est vrai —— - - lance le Glow (Avec les donnés mémoire pour éviter les bugs)
							else { ApplyGlowOn( Cible , 
												Filtre.Memoire.color , 
												Filtre.Memoire.alpha , 
												Filtre.Memoire.blurX , 
												Filtre.Memoire.blurY , 
												Filtre.Memoire.strength , 
												Filtre.Memoire.quality ); }
						}
						
						// Mémorise le levier
						Filtre.MemoireLevier = LevierOk;
					}
					
					// Donne l'événement de boucle du Glow au clip
					AddEvents( Clip , Clip.Glow.Boucle , "ENTER_FRAME" , "GlowLoop" );
					
					// Retourne l'objet Glow
					return Clip.Glow;
				}
			}
			
			// Ne retourne rien
			return null;
		}
		//
		// —————— APPLY GLOW ON
		// Applique directement un effet de Glow externe
		public function ApplyGlowOn( Clip:* ,					// ———— - - Le Clip concerné
									 Couleur:* = "FFFFFF" ,		// ———— - - Couleur du filtre
									 Alpha:Number = 100 ,		// ———— - - Alpha du filtre
									 DispersionX:Number = 10 ,	// ———— - - Blur en X
									 DispersionY:Number = 10 ,	// ———— - - Blur en Y
									 Force:Number = 2 ,			// ———— - - Force du Blur
									 Qualite:Number = 1			// ———— - - Qualité du Blur
									):void {
			/*—*/
			
			// Convertie la couleur en uint si c'est un string
			if( TypeOf( Couleur , "String" ) ){ Couleur = uint( "0x" + Couleur ); }
			
			// Si le clip n'a pas d'objet spéciale pour ses filtres, il se le crait
			if( !Clip.Filtres ){ Clip.Filtres = new Object(); }
			
			// Si on a mis une boolean à couleur et qu'elle est fausse —— - -
			if( TypeOf( Couleur , "Boolean" ) && !Couleur ){
				
				// Mes à null le filtre de Glow
				Clip.Filtres.Glow = null;
				
			// Sinon —— - -
			} else {
				
				// Il créait son filtre de Glow
				Clip.Filtres.Glow = { 
										color:Couleur ,
										alpha:Alpha / 100 ,
										blurX:DispersionX ,
										blurY:DispersionY ,
										strength:Force ,
										quality:Qualite
									};
				
				// Donne la variable de Glow au clip
				Clip.Filtres.Glow.Filtre = new GlowFilter( Clip.Filtres.Glow.color ,
														   Clip.Filtres.Glow.alpha ,
														   Clip.Filtres.Glow.blurX ,
														   Clip.Filtres.Glow.blurY ,
														   Clip.Filtres.Glow.strength ,
														   Clip.Filtres.Glow.quality
														 );
			}
			
			// Lance l'application des filtres
			ApplyFilter( Clip );
		}
		
		
		
		/* —————————————————————————————————————————— - - BLUR - - —————————————————————————————————————————— */
		// Méthodes d'application d'effet de Blur
		//*—*//
		
		// —————— APPLY BLUR
		// Applique un effet de Blur
	  
	  	public function ApplyBlur( Clip:* ,							// ———— - - Clip concerné
								   Parametres:* = null ,			// ———— - - Les parametres du Blur
								   Dynamique:Boolean = false ,		// ———— - - Si le filttre est modifiable dynamiquement
								   QualiteMinimale:String = ""		// ———— - - Qualité minimale pour l'affichage du filtre
								):* {
			/*—*/
			
			// Si le parametres est une boolean —— - -
			if( TypeOf( Parametres , "Boolean" ) ){
				
				// Transfert le parametres au dynamique
				Dynamique = Parametres;
				Parametres = new Object();
				
				// S'il possède un objet Glow —— - -
				if( Clip.Blur ){
				
					// Retire sa boucle
					RemoveEvents( Clip , [ "ENTER_FRAME" , Clip.Blur , "Boucle" ] );
					
					// Met l'objet GLow à null
					Clip.Blur = null;
				}
				
				// S'il n'est pas Dynamique —— - -
				if( !Dynamique ){
					
					// Retire son effet de Glow
					ApplyBlurOn( Clip , false );
					
					// Sort de la fonction
					return null;
				}
			}
			
			// Si on a mis une boolean à DispersionX et qu'elle est fausse —— - -
			if( !Clip.Blur ){
				
				// Récupère les valeurs du Glow depuis le paramètres
				Parametres = Parametres || new Object();
				//
				var DispersionX:Number = 	Parametres.blurX 	|| 10;
				var DispersionY:Number = 	Parametres.blurY 	|| 10;
				var Qualite:Number = 		Parametres.quality 	|| 1;
			
				// Applique le Blur
				ApplyBlurOn( Clip , DispersionX , DispersionY , Qualite );
				
				
				// S'il est dynamique —— - -
				if( Dynamique ){
					
					// Donne l'objet de Blur au clip
					Clip.Blur = { 
								  blurX:DispersionX ,
								  blurY:DispersionY ,
								  quality:Qualite
								};
					
					
					// Si on a choisi une qualité minimale —— - -
					if( QualiteMinimale != "" ){
						
						// Si on a instancié le OptimizeProcess —— - -
						if( Optimize ){
							
							// Si la qualité choisie existe —— - - 
							if( Optimize.GetQuality( QualiteMinimale ) != -1 ){ 
								
								// On la lui donne
								Clip.Blur.QualiteMinimale = QualiteMinimale; 
								
							// Si elle n'existe pas —— - -
							} else {
								
								// Trace l'erreur
								TraceError( "FilterTools" , "ApplyGlow" , [ "la qualité \"" + QualiteMinimale+ "\" n'éxiste pas." , 
																			 Optimize.TellMeQuality() ] );
								
								// Donne une pare défaut
								Clip.Blur.QualiteMinimale = "High";
							}
						
						// Si on n'a pas instancé le OptimizeProcess —— - -
						} else {
							
							// Trace l'erreur
							TraceError( "FilterTools" , "ApplyGlow" , [ "Un choix de qualité minimale a été choisi pour cet effet de filtre, or" ,
																			"le lien vers la OptimizeProcess n'a pas été donné au FilterTools." ,
																			"Pour le faire, il suffit de mettre, quand on créait l'instance de FilterTools :" ,
																			"var Filter = new FilterTools( Optimize );" ] )
						}
					}
					
					// On lui donne sa memoire de levier
					Clip.Blur.MemoireLevier = true;
					
					// Donne la mémoire de l'objet de Glow au clip
					Clip.Blur.Memoire = CloneObject( Clip.Blur );
					
					// Donne la boucle du Glow —— - -
					Clip.Blur.Boucle = function( event:Event ):void {
						
						// Récupére l'instance de la cible
						var Cible:* = event.target;
						
						// Récupére l'instance de l'objet rayonement
						var Filtre:Object = Cible.Blur;
						
						// Levier de lancement
						var LevierOk:Boolean = true;
						
						// S'il y a une qualite minimale —— - -
						if( Filtre.QualiteMinimale ){
							
							// Si la qualite est insuffisante —— - -
							if( Optimize.QualityNumero < Optimize.GetQuality( Filtre.QualiteMinimale ) ){
								
								// Bloque le levier
								LevierOk = false;
							}
						}
							
							
						// Si on peut le lancer —— - -
						if( LevierOk ){
							
							// Levier des modifications de filtres
							var Levier:Boolean = true;
							
							// Pour chaque états du Glow —— - -
							for( var Etats:* in Cible.Blur ){
								
								// Si ce n'est pas la boucle, la mémoire ou la qualité minimale —— - -
								if( Etats != "Boucle" && Etats != "Memoire" && Etats != "QualiteMinimale" ){
									
									// Si l'effet a été changé, toggle le levier
									if( Cible.Blur[ Etats ] != Cible.Blur.Memoire[ Etats ] ){ Levier = false; }
								}
							}
							
							// Si le levier a été togglé —— - -
							if( !Levier ){ 
							
								// Réapplique le Glow avec les nouveaux critéres
								ApplyBlurOn( Cible , Filtre.blurX , Filtre.blurY , Filtre.quality ); 
								
								// Récupére la mémoire de l'objet
								Filtre.Memoire = CloneObject( Filtre , [ "Memoire" ] );
							}
							
						// Si on n'a pas put le lancer et que la mémoire indique qu'il a été lancé auparavent —— - -
						} else if( Filtre.MemoireLevier != LevierOk ){
							
							// Si le levier est faux —— - - Stop le Glow
							if( !LevierOk ){ ApplyBlurOn( Cible , false ); }
							//
							// Si le levier est vrai —— - - lance le Glow (Avec les donnés mémoire pour éviter les bugs)
							else { ApplyBlurOn( Cible ,
												Filtre.Memoire.blurX , 
												Filtre.Memoire.blurY , 
												Filtre.Memoire.quality ); }
						}
						
						// Mémorise le levier
						Filtre.MemoireLevier = LevierOk;
					}
					
					// Donne l'événement de boucle du Glow au clip
					AddEvents( Clip , Clip.Blur.Boucle , "ENTER_FRAME" , "BlurLoop" );
					
					// Retourne l'objet Blur
					return Clip.Blur;
				}
			}
		}
		//
		// —————— APPLY BLUR ON
		// Applique directement un effet de Blur
	
	  	public function ApplyBlurOn( Clip:* ,					// ———— - - Clip concerné
									 DispersionX:* = 10 ,		// ———— - - Blur en X
									 DispersionY:Number = 10 ,	// ———— - - Blur en Y
									 Qualite:Number = 1			// ———— - - Qualité du Blur
									):void {
			/*—*/
			
			// Si le clip n'a pas d'objet spéciale pour ses filtres, il se le crait
			if( !Clip.Filtres ){ Clip.Filtres = new Object(); }
			
			
			// Si on a mis une boolean à DispersionX et qu'elle est fausse —— - -
			if( TypeOf( DispersionX , "Boolean" ) && !DispersionX ){
				
				// Mes à null le filtre de Glow
				Clip.Filtres.Blur = null;
				
			// Sinon —— - -
			} else {
					
				// Il créait son filtre de Glow
				Clip.Filtres.Blur = { 
										blurX:DispersionX ,
										blurY:DispersionY ,
										quality:Qualite
									};
		
				// Donne la variable de Glow au clip
				Clip.Filtres.Blur.Filtre = new BlurFilter( Clip.Filtres.Blur.blurX ,
														   Clip.Filtres.Blur.blurY ,
														   Clip.Filtres.Blur.quality
														 );
			}
			
			// Lance l'application des filtres
			ApplyFilter( Clip );
		}
		
		
		
		/* —————————————————————————————————————————— - - SHADOW - - —————————————————————————————————————————— */
		// Méthodes d'application d'effet d'ombre
		//*—*//
		
		// —————— APPLY SHADOW
		// Applique un effet d'ombre
	  
	  	public function ApplyShadow( Clip:* ,							// ———— - - Clip concerné
									 Parametres:* = null ,				// ———— - - Les parametres du Shadow
									 Dynamique:Boolean = false ,		// ———— - - Si le filttre est modifiable dynamiquement
									 QualiteMinimale:String = ""		// ———— - - Qualité minimale pour l'affichage du filtre
								   ):* {
			/*—*/
			
			// Si le parametres est une boolean —— - -
			if( TypeOf( Parametres , "Boolean" ) ){
				
				// Transfert le parametres au dynamique
				Dynamique = Parametres;
				Parametres = new Object();
				
				// S'il possède un objet Glow —— - -
				if( Clip.Shadow ){
				
					// Retire sa boucle
					RemoveEvents( Clip , [ "ENTER_FRAME" , Clip.Shadow , "Boucle" ] );
					
					// Met l'objet GLow à null
					Clip.Shadow = null;
				}
				
				// S'il n'est pas Dynamique —— - -
				if( !Dynamique ){
					
					// Retire son effet de Glow
					ApplyShadowOn( Clip , false );
					
					// Sort de la fonction
					return null;
				}
			}
			
			// Si on a mis une boolean à DispersionX et qu'elle est fausse —— - -
			if( !Clip.Shadow ){
				
				// Récupère les valeurs du Glow depuis le paramètres
				Parametres = Parametres || new Object();
				//
				var Couleur:String = 		Parametres.color 		|| "000000";
				var Alpha:Number = 			Parametres.alpha 		|| 100;
				var Distance:Number = 		Parametres.distance 	|| 4;
				var Angle:Number = 			Parametres.angle 		|| 45;
				var Force:Number = 			Parametres.strength 	|| 2;
				var Interieur:Boolean = 	Parametres.inner 		|| false;
				var Masque:Boolean = 		Parametres.knockout 	|| false;
				var Cache:Boolean = 		Parametres.hideObject 	|| false;
				var DispersionX:Number = 	Parametres.blurX 		|| 10;
				var DispersionY:Number = 	Parametres.blurY 		|| 10;
				var Qualite:Number = 		Parametres.quality 		|| 1;
			
				// Applique le Shadow
				ApplyShadowOn( Clip , Couleur , Alpha , Distance , Angle , DispersionX , DispersionY , Force , Qualite , Interieur , Masque , Cache );
				
				
				// S'il est dynamique —— - -
				if( Dynamique ){
					
					// Donne l'objet de Glow au clip
					Clip.Shadow = { 
									color:Couleur ,
									alpha:Alpha ,
									distance:Distance ,
									angle:Angle ,
									blurX:DispersionX ,
									blurY:DispersionY ,
									strength:Force ,
									quality:Qualite ,
									inner:Interieur ,
									knockout:Masque ,
									hideObject:Cache
								};
					
					
					// Si on a choisi une qualité minimale —— - -
					if( QualiteMinimale != "" ){
						
						// Si on a instancié le OptimizeProcess —— - -
						if( Optimize ){
							
							// Si la qualité choisie existe —— - - 
							if( Optimize.GetQuality( QualiteMinimale ) != -1 ){ 
								
								// On la lui donne
								Clip.Shadow.QualiteMinimale = QualiteMinimale; 
								
							// Si elle n'existe pas —— - -
							} else {
								
								// Trace l'erreur
								TraceError( "FilterTools" , "ApplyGlow" , [ "la qualité \"" + QualiteMinimale+ "\" n'éxiste pas." , 
																			 Optimize.TellMeQuality() ] );
								
								// Donne une pare défaut
								Clip.Shadow.QualiteMinimale = "High";
							}
						
						// Si on n'a pas instancé le OptimizeProcess —— - -
						} else {
							
							// Trace l'erreur
							TraceError( "FilterTools" , "ApplyGlow" , [ "Un choix de qualité minimale a été choisi pour cet effet de filtre, or" ,
																			"le lien vers la OptimizeProcess n'a pas été donné au FilterTools." ,
																			"Pour le faire, il suffit de mettre, quand on créait l'instance de FilterTools :" ,
																			"var Filter = new FilterTools( Optimize );" ] )
						}
					}
					
					// On lui donne sa memoire de levier
					Clip.Shadow.MemoireLevier = true;
					
					// Donne la mémoire de l'objet de Glow au clip
					Clip.Shadow.Memoire = CloneObject( Clip.Shadow );
					
					// Donne la boucle du Glow —— - -
					Clip.Shadow.Boucle = function( event:Event ):void {
						
						// Récupére l'instance de la cible
						var Cible:* = event.target;
						
						// Récupére l'instance de l'objet rayonement
						var Filtre:Object = Cible.Shadow;
						
						// Levier de lancement
						var LevierOk:Boolean = true;
						
						// S'il y a une qualite minimale —— - -
						if( Filtre.QualiteMinimale ){
							
							// Si la qualite est insuffisante —— - -
							if( Optimize.QualityNumero < Optimize.GetQuality( Filtre.QualiteMinimale ) ){
								
								// Bloque le levier
								LevierOk = false;
							}
						}
							
							
						// Si on peut le lancer —— - -
						if( LevierOk ){
							
							// Levier des modifications de filtres
							var Levier:Boolean = true;
							
							// Pour chaque états du Glow —— - -
							for( var Etats:* in Cible.Shadow ){
								
								// Si ce n'est pas la boucle, la mémoire ou la qualité minimale —— - -
								if( Etats != "Boucle" && Etats != "Memoire" && Etats != "QualiteMinimale" ){
									
									// Si l'effet a été changé, toggle le levier
									if( Cible.Shadow[ Etats ] != Cible.Shadow.Memoire[ Etats ] ){ Levier = false; }
								}
							}
							
							// Si le levier a été togglé —— - -
							if( !Levier ){ 
							
								// Réapplique le Glow avec les nouveaux critéres
								ApplyShadowOn( Cible , 
											   Filtre.color , 
											   Filtre.alpha , 
											   Filtre.distance , 
											   Filtre.angle , 
											   Filtre.blurX , 
											   Filtre.blurY , 
											   Filtre.strength , 
											   Filtre.quality ,
											   Filtre.inner , 
											   Filtre.knockout , 
											   Filtre.hideObject 
											); 
								   
								// Récupére la mémoire de l'objet
								Filtre.Memoire = CloneObject( Filtre , [ "Memoire" ] );
							}
							
						// Si on n'a pas put le lancer et que la mémoire indique qu'il a été lancé auparavent —— - -
						} else if( Filtre.MemoireLevier != LevierOk ){
							
							// Si le levier est faux —— - - Stop l'Shadow
							if( ! LevierOk ){ ApplyShadowOn( Cible , false ); }
							//
							// Si le levier est vrai —— - - lance l'Shadow (Avec les donnés mémoire pour éviter les bugs)
							else { ApplyShadowOn( Cible , 
												  Filtre.Memoire.color , 
												  Filtre.Memoire.alpha , 
												  Filtre.Memoire.distance , 
												  Filtre.Memoire.angle , 
												  Filtre.Memoire.blurX , 
												  Filtre.Memoire.blurY , 
												  Filtre.Memoire.strength , 
												  Filtre.Memoire.quality ,
												  Filtre.Memoire.inner , 
												  Filtre.Memoire.knockout , 
												  Filtre.Memoire.hideObject 
												); }
						}
						
						// Mémorise le levier
						Filtre.MemoireLevier = LevierOk;
					}
					
					// Donne l'événement de boucle du Glow au clip
					AddEvents( Clip , Clip.Shadow.Boucle , "ENTER_FRAME" , "ShadowLoop" );
					
					// Retourne l'objet de Shadow
					return Clip.Shadow;
				}
			}
		}
		//
		// —————— APPLY SHADOW ON
		// Applique directement un effet de Shadow
	  	public function ApplyShadowOn( Clip:* ,				// ———— - - Clip concerné
									   Couleur:* = "000000" ,		// ———— - - Couleur du filtre
									   Alpha:Number = 100 ,			// ———— - - Alpha du filtre
									   Distance:Number = 4 ,		// ———— - - Distance du Shadow
									   Angle:Number = 45 ,			// ———— - - Angle du Shadow
									   DispersionX:Number = 10 ,	// ———— - - Blur en X
									   DispersionY:Number = 10 ,	// ———— - - Blur en Y
									   Force:Number = 2 ,			// ———— - - Force du Blur
									   Qualite:Number = 1 ,			// ———— - - Qualité du Blur
									   Interieur:Boolean = false ,	// ———— - - Shadow intérieur ( true ) ou extérieur ( false )
									   Masque:Boolean = false ,		// ———— - - Si l'objet est masqué
									   Cache:Boolean = false		// ———— - - Si l'objet est caché
									):void {
			/*—*/
			
			// Convertie la couleur en uint si c'est un string
			if( TypeOf( Couleur , "String" ) ){ Couleur = uint( "0x" + Couleur ); }
			
			// Si le clip n'a pas d'objet spéciale pour ses filtres, il se le crait
			if( !Clip.Filtres ){ Clip.Filtres = new Object(); }
			
			// Si on a mis une boolean à couleur et qu'elle est fausse —— - -
			if( TypeOf( Couleur , "Boolean" ) && !Couleur ){
				
				// Mes à null le filtre de Glow
				Clip.Filtres.Shadow = null;
				
			// Sinon —— - -
			} else {
				
				// Il créait son filtre de Glow
				Clip.Filtres.Shadow = { 
										color:Couleur ,
										alpha:Alpha / 100 ,
										distance:Distance ,
										angle:Angle ,
										blurX:DispersionX ,
										blurY:DispersionY ,
										strength:Force ,
										quality:Qualite ,
										inner:Interieur ,
										knockout:Masque ,
										hideObject:Cache
									};
									
				// Donne la variable de Glow au clip
				Clip.Filtres.Shadow.Filtre = new DropShadowFilter( Clip.Filtres.Shadow.distance ,
																  Clip.Filtres.Shadow.angle ,
																  Clip.Filtres.Shadow.color ,
																  Clip.Filtres.Shadow.alpha ,
																  Clip.Filtres.Shadow.blurX ,
																  Clip.Filtres.Shadow.blurY ,
																  Clip.Filtres.Shadow.strength ,
																  Clip.Filtres.Shadow.quality ,
																  Clip.Filtres.Shadow.inner ,
																  Clip.Filtres.Shadow.knockout ,
																  Clip.Filtres.Shadow.hideObject
																 );
			}
			
			// Lance l'application des filtres
			ApplyFilter( Clip );
		}
		
		
		
		/* —————————————————————————————————————————— - - TINT - - —————————————————————————————————————————— */
		// Méthodes d'application d'effet de Tint de couleurs
		//*—*//
		
		// —————— APPLY TINT
		// Applique un effet de Tint de couleurs
		
		public function ApplyTint( Clip:* ,							// ———— - - Clip concerné
								   Parametres:* = null ,			// ———— - - Les parametres du Shadow
								   Dynamique:Boolean = false ,		// ———— - - Si le filttre est modifiable dynamiquement
								   QualiteMinimale:String = ""		// ———— - - Qualité minimale pour l'affichage du filtre
							   ):* {
			/*—*/
			
			// Si le parametres est une boolean —— - -
			if( TypeOf( Parametres , "Boolean" ) ){
				
				// Transfert le parametres au dynamique
				Dynamique = Parametres;
				Parametres = new Object();
				
				// S'il possède un objet Glow —— - -
				if( Clip.Tint ){
				
					// Retire sa boucle
					RemoveEvents( Clip , [ "ENTER_FRAME" , Clip.Tint , "Boucle" ] );
					
					// Met l'objet GLow à null
					Clip.Tint = null;
				}
				
				// S'il n'est pas Dynamique —— - -
				if( !Dynamique ){
					
					// Sort de la fonction
					return null;
				}
			}
			
			// Si on a mis une boolean à DispersionX et qu'elle est fausse —— - -
			if( !Clip.Tint ){
				
				// Récupère les valeurs du Glow depuis le paramètres
				Parametres = Parametres || new Object();
				//
				var Couleur:String = 		Parametres.color 			|| "000000";
				var Multiplieur:Number = 	Parametres.multiplier 		|| 100;
				var MultiRouge:Number = 	Parametres.redMultiplier 	|| 0;
				var MultiVert:Number = 		Parametres.greenMultiplier 	|| 0;
				var MultiBleu:Number = 		Parametres.blueMultiplier 	|| 0;
				var OffsetRouge:Boolean = 	Parametres.redOffset 		|| 666;
				var OffsetVert:Boolean = 	Parametres.greenOffset 		|| 666;
				var OffsetBleu:Boolean = 	Parametres.blueOffset 		|| 666;
					
				// Applique la Tint
				ApplyTintOn( Clip , Couleur , Multiplieur , MultiRouge , MultiVert , MultiBleu );
				
				// S'il est dynamique —— - -
				if( Dynamique ){
					
					// Donne au clip l'objet de Tint
					Clip.Tint = { Couleur:Couleur ,
								  multiplier:Multiplieur ,
								  redMultiplier:MultiRouge ,
								  greenMultiplier:MultiVert ,
								  blueMultiplier:MultiBleu ,
								  redOffset:OffsetRouge ,
								  greenOffset:OffsetVert ,
								  blueOffset:OffsetBleu };
									
					// Donne au clip sa boucle
					Clip.Tint.Boucle = function( event:Event ):void {
						
						// Récupère son instance
						var Cible:* = event.target;
						
						// Réapplique la Tint
						ApplyTintOn( Cible , Cible.Tint.Couleur , 
									Cible.Tint.multiplier , Cible.Tint.redMultiplier , Cible.Tint.greenMultiplier , Cible.Tint.blueMultiplier ,
									Cible.Tint.redOffset , Cible.Tint.greenOffset , Cible.Tint.blueOffset );
					}
					//
					// Donne son événement
					AddEvents( Clip , Clip.Tint.Boucle , "ENTER_FRAME" , "TintLoop" );
					
					// Retourne l'objet de teinte
					return Clip.Tint;
				}
			}
		}
		//
		// —————— APPLY TINT ON
		// Applique directement un effet de Teinte
	  	public function ApplyTintOn( Clip:* , 						// ———— - - Clip concerné
									 Couleur:String = "000000", 	// ———— - - Couleur à appliquer
									 Multiplieur:Number = 100 ,		// ———— - - Pourcentage de contraste
									 MultiRouge:Number = 0 ,		// ———— - - Pourcentage de contraste rouge
									 MultiVert:Number = 0 ,			// ———— - - Pourcentage de contraste vert
									 MultiBleu:Number = 0 ,			// ———— - - Pourcentage de constraste bleu
									 OffsetRouge:Number = 666 ,		// ———— - - Offset des rouges ( -250 à 250 )
									 OffsetVert:Number = 666 ,		// ———— - - Offset des verts ( -250 à 250 )
									 OffsetBleu:Number = 666		// ———— - - Offset des bleus ( -250 à 250 )
						   		):void {
			/*—*/
			
			// Création de la variable de Tint
			var CouleurTint:ColorTransform = Clip.transform.colorTransform; 
			
			// Donne sa valeur à la Tint
			CouleurTint.color = uint( "0x" + Couleur ); 
			//
			// Modifie les Multipliers pour les contrastes
			CouleurTint.redMultiplier = Multiplieur / 100 + MultiRouge / 100;
			CouleurTint.greenMultiplier = Multiplieur / 100 + MultiVert / 100;
			CouleurTint.blueMultiplier = Multiplieur / 100 + MultiBleu / 100;
			//
			if( OffsetRouge != 666 ){ CouleurTint.redOffset = OffsetRouge; }
			if( OffsetVert != 666 ){ CouleurTint.greenOffset = OffsetVert; }
			if( OffsetBleu != 666 ){ CouleurTint.blueOffset = OffsetBleu; }
			
			// Applique le changement de Tint
			Clip.transform.colorTransform = CouleurTint; 
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 MASK					  		  					  */
		/*								 Méthodes pour appliquer des effets de masques 					  		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - APPLY - - —————————————————————————————————————————— */
		// Méthodes d'application d'effets de masque
		//*—*//
		
		// —————— APPLY REVERSAL MASK
		// Transforme un clip en masque inversé et convertie son parent pour qu'il le supporte. 
		// ATTENTION : cela coupe automatiquement l'animation du clip parent et son propre parent à lui.
	
	  	public function ApplyReversalMask( Clip:*	// ———— - - Le clip concerné
									  	):void {
			/*—*/
			
			// BlendMode du clip en erase
			Clip.blendMode = "erase";
			
			// BlendMode du parent en layer
			Clip.parent.blendMode = "layer";
		}
		
		
		
	
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}