﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			FX TOOLS	  			Version 0.5.0									***/
/***				   				   Dernière Mise à Jour : 10-08-14										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         			   Outils Effets Visuels											***/
/***			  Ce script contient les méthodes pour créer des effets visuels rapidement.				    ***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Visual {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	
	// —— - - DISPLAY
	import flash.display.MovieClip;
	import flash.display.Shape;
	//
	// —— - - EVENT
	import flash.events.Event;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	import drOIde.Visual.OptimizeProcess;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class FxTools extends MiscTools {
		
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		// —————— LINK
		// Les liaisons avec d'autres scripts
		private var Optimize:OptimizeProcess;
		//private var Motion:MotionChip = new MotionChip();
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function FxTools( TheLink:* = null ,		// ———— - - Lien vers un élément
								 LienOptimize:* = null	// ———— - - Lien vers le OptimizeProcess
								){
			/*—*/
			
			// Si le lien n'est pas OptimizeProcess —— - - Connexion
			if( !TypeOf( TheLink , "OptimizeProcess" ) ){
				//
				Connexion( TheLink );
			
			// Sinon —— - - Transfert au lien Optimize
			} else {
				//
				LienOptimize = TheLink;
			}
			
			// Récupére le lien vers Optimize s'il y en a un
			if( LienOptimize ){ Optimize = LienOptimize; }
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				 MANIPULATION					  		  				  */
		/*							  Méthodes pour manipuler visuellement des éléments 					  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - APPLY - - —————————————————————————————————————————— */
		// Méthode appliquant des manipulation visuelles
		//*—*//
		
		// —————— VIBRATE
		// Fait vibrer un élément sur différent de ses paramètres durant une certaines durée
		//
		//	¤VorteX Compatible¤
	
	  	public function Vibrate( Element:* ,						// ———— - - Élément qui va vibrer
								 Duree:int = 10 ,					// ———— - - Durée de vibration en frame
								 Vibration:Object = null ,			// ¤¤—— - - Paramètres de l'éléments qui vibres
								 Repositionnable:Boolean = true 	// ———— - - Si l'objet se remet sur les valeurs des paramètres initiaux à la fin
								):void {
			/*—*/
			
			// Arguments par défaut
			Vibration = Vibration || { x:[ "random" , -10 , 10 ] , y:[ "random" , -10 , 10 ] };
			//
			// Conversion des paramètres de vibration
			for( var Parametres:* in Vibration ){
				
				// S'il s'agit d'un chiffre —— - - Convertie en tableau
				if( TypeOf( Vibration[ Parametres ] , "Number" ) ){ 
					//
					Vibration[ Parametres ] = [ -Vibration[ Parametres ] , Vibration[ Parametres ] ] 
				}
				
				// S'il ne contient pas de string au départ et qu'il est un tableau
				if( TypeOf( Vibration[ Parametres ] , "Array" ) ){
					//
					if( !TypeOf( Vibration[ Parametres ][ 0 ] , "String" ) ){
						
						// Ajoute "random"
						Vibration[ Parametres ].unshift( "random" );
					}
				}
			}
			
			// S'il ne vibre pas déjà ou qu'on ne repositionne pas —— - -
			if( !Element.ObjetVibration || !Repositionnable ){
				
				// Donne à l'élément son objet de vibration
				Element.ObjetVibration = new Object();
				//
				// Donne à l'élément ses paramètres
				Element.ObjetVibration.Vibration = Vibration;
				Element.ObjetVibration.Repositionnable = Repositionnable;
				Element.ObjetVibration.Compte = Duree;
				
				/// Lui donne son objet de paramètres initiaux —— - -
				Element.ObjetVibration.Initial = new Object();
				
				// Pour chaque paramètres de Vibration —— - -
				for( var ParametresInitial:* in Vibration ){
					
					// Récupère sa valeur
					Element.ObjetVibration.Initial[ ParametresInitial ] = Element[ ParametresInitial ];
				}
				
				// Donne la boucle de vibration à l'élément
				Element.ObjetVibration.Boucle = function( Cible:* ):void {
					
					// Pour chaque paramètres de vibration —— - -
					for( var Partie:* in Cible.ObjetVibration.Vibration ){
						
						// Modifie le paramètre en question sur l'élément
						Cible[ Partie ] = Cible.ObjetVibration.Initial[ Partie ] + Aspiration( Cible.ObjetVibration.Vibration[ Partie ] );
					}
					
					// Le compte décroît
					Cible.ObjetVibration.Compte--;
					
					// Si le compte est tombé à 1 et qu'il est repositionnable —— - -
					if( Cible.ObjetVibration.Compte == 0 && Cible.ObjetVibration.Repositionnable ){
						
						// Remet les paramètres à leur valeurs initiales
						for( var ValeursInitiales:* in Cible.ObjetVibration.Initial ){
							//
							Cible[ ValeursInitiales ] = Cible.ObjetVibration.Initial[ ValeursInitiales ];
						}
						
						// Retire l'objet
						Element.ObjetVibration = null;
					}
				}
				//
				// Lance la boucle instantanée
				InstantLaunch( { Fonction:Element.ObjetVibration.Boucle , Argument:Element } , Duree );
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				   ELEMENT					  		  				  	  */
		/*			Méthodes pour générer des effets visuels en exploitant des éléments de la bibliothèque 		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - INSTANT - - —————————————————————————————————————————— */
		// Méthode appliquant des effets à partir d'éléments s'auto-détruisant
		//*—*//
		
		// —————— NEW INSTANT ELEMENT
		// Fait apparaître un élément éphémère qui s'auto-détruit
		//
		//	¤VorteX Compatible¤
	
	  	public function NewInstantElement( Element:* ,							// ¤¤—— - - La Class
										   Cible:* ,							// ¤¤—— - - La Cible l'affichant
										   Nom:String = "NouvelElement" ,		// ———— - - Nom à donner à l'élément
										   Etat:* = null ,						// ¤¤—— - - Etat original de la cible
										   Disparition:String = "Frame" ,		// ———— - - Mode de disparition
										   QualiteMinimal:String = ""			// ———— - - La qualité minimal de l'effet
										  ):* {
			/*—*/
			
			// Levier de lancement
			var Levier:Boolean = false;
			
			// S'il y a une demande de qualité minimale —— - -
			if( SetDefault( QualiteMinimal ) ){
				
				// S'il n'y a pas de lien à la OptimizeTools —— - - retourne l'erreur
				if( !Optimize ){
					TraceError( "FxTools" , "NewInstantElement" , 
							   [ "Une demande de qualité minimale a été faites pour cet effet alors qu'aucun lien vers la OptimizeTools" ,
							     "n'a été donné. Pour pouvoir demandé une qualité minimal à un effet de la FxTools, il faut donner" ,
							     "l'instance de la FxTools à son initialisation :" ,
							     "Exemple : var Fx:FxTools = new FxTools( Optimize );"
							   ] );
					
				// S'il y a le lien OptimizeTools —— - -
				} else {
					
					// Si la qualité existe —— - -
					if( Optimize.GetQuality( QualiteMinimal ) != -1 ){
						
						// Si le numéro de qualité est suffisant —— - -
						if( Optimize.QualityNumero >= Optimize.GetQuality( QualiteMinimal ) ){ Levier = true; }
					
					
					// Si la qualité n'existe pas —— - - trace l'erreur
					} else {
						TraceError( "FxTools" , "NewInstantElement" , 
									[ "La qualité " + QualiteMinimal + " n'éxiste pas." , Optimize.TellMeQuality() ] );
					}
				}
				
			// S'il n'y a pas de demande de qualité minimale —— - -
			} else { Levier = true; }
			
			
			// Si c'est bon
			if( Levier ){
				
				// Créait l'élément
				var NouvelElement = NewElement( Element , Cible , Nom + RandomWord() , Etat );
				
				// Donne l'objet d'instant à l'élément
				NouvelElement.Instant = new Object();
				//
				// Donne les paramètres
				//
				// Si c'est seulement Frame —— - - le donne directement
				if( Disparition == "Frame" ){ NouvelElement.Instant.Disparition = Disparition; }
				//
				// Sinon —— - -
				else {
					
					// S'il le fait en taille ou alpha —— - -
					if( FindIn( Disparition , "Alpha" ) == 1 
					 || FindIn( Disparition , "Taille" ) == 1  
					 || FindIn( Disparition , "Temps" ) == 1 ){
						
						// Lui donne son type de disparition
						NouvelElement.Instant.Disparition = GetIn( Disparition , " " , 1 );
						
						// Lui donne sa vitesse ou la vitesse par défaut
						NouvelElement.Instant.Vitesse = Number( GetIn( Disparition , " " , 2 ) || 5 );
						
						
					// Sinon —— - - Trace l'erreur
					} else {
						
						TraceError( "FxTools" , "NewInstantElement" , 
								   "Le type de disparition \"" + GetIn( Disparition , " " , 1 ) + "\" n'existe pas." );
					}
				}
				
				
				// Lui donne sa boucle —— - -
				NouvelElement.Instant.Boucle = function( event:Event ):void {
					
					// Récupére l'instance
					var Cible:* = event.target;
					//
					// Instance Instant
					var Instant:Object = Cible.Instant;
					
					// Disparition Alpha
					if( Instant.Disparition == "Alpha" ){ Cible.alpha -= Instant.Vitesse / 100; 
					
						// S'il est invisible —— - - il s'annihile
						if( Cible.alpha <= 0 ){ DestroyElement( Cible ); }
					}
					
					// Disparition Taille
					if( Instant.Disparition == "Taille" ){ 
						Cible.width -= Instant.Vitesse;  
						Cible.height -= Instant.Vitesse;  
					
						// S'il est trop petit —— - - Il s'annihile
						if( Cible.width <= 5 || Cible.height <= 5 ){ DestroyElement( Cible ); }
					}
					
					// Disparition Temps
					if( Instant.Disparition == "Temps" ){ Instant.Vitesse--; 
					
						// Si le temps est fini —— - - Il s'annihile
						if( Instant.Vitesse <= 0 ){ DestroyElement( Cible ); }
					}
					
					// Disparition Frame
					if( Instant.Disparition == "Frame" ){
					
						// S'il est sur sa dernière frame —— - - Il s'annihile
						if( Cible.currentFrame == Cible.totalFrames ){ DestroyElement( Cible ); }
					}
				}
				//
				// Donne son événement
				AddEvents( NouvelElement , NouvelElement.Instant.Boucle , "ENTER_FRAME" );
				
				// Retourne l'élément
				return NouvelElement;
			
			// Si c'est pas bon —— - - retourne null
			} else { return null; }
		}
	  			
		
		
		/* —————————————————————————————————————————— - - CONSTANT - - —————————————————————————————————————————— */
		// Méthode appliquant des effets à partir d'éléments réguliers
		//*—*//
		
		// —————— DEFILEMENT
		// Fait défiler des éléments
	
	  	public function Passing( Element:Class ,				// ———— - - Éléments défilant
								 Cible:* ,						// ———— - - Cible conteiner des éléments
								 PositionInitiale:Object ,		// ———— - - Positionnement à l'initial
								 PositionFinale:String ,		// ———— - - Positionnement au final
								 Temps:*	,					// ———— - - Temps entre deux éléments ( Nombre ou tableau pour de l'aléatoire )
								 Vitesse:* ,					// ———— - - Vitesse de défilement des éléments ( Nombre ou tableau pour de l'aléatoire )
								 Direction:String = "x" ,		// ———— - - Direction de défilement
								 QualiteMinimale:String = "" , 	// ———— - - Qualité minimale
								 Initial:int = 0				// ———— - - Provoque une création immédiate d'une série d'éléments mis en place
								):void {
			/*—*/
			
			// Levier de lancement
			var Levier:Boolean = true;
			
			// Si on ne trouve ni le signe supérieur, ni le signe inférieur dans la chaine de position finale —— - -
			if( FindIn( PositionFinale , ">" ) == -1 && FindIn( PositionFinale , "<" ) == -1 ){
				
				// trace l'erreur
				TraceError( "FxTools" , "Defilement" , 
						   [ "Le format de l'argument pour la position finale est incorrect, vous devez mettre un string" ,
							  "contenant un string indiquant « > » ou « < » suivis du nombre en question" ] );
				
				// Levier désactivé
				Levier = false;
			}
			
			// S'il y a déjà un objet de défilement sur la cible —— - -
			if( Cible.Defilement ){
				
				// Trace l'erreur
				TraceError( "FxTools" , "Defilement" , 
						   [ "Le conteiner choisi contient déjà une action de défilement, vous devez choisir des conteiners" ,
							  "différents pour chaque nouveau défilement." ] );
				
				// Levier désactivé
				Levier = false;
			}
			
			// Si le levier est activé —— - -
			if( Levier ){
				
				// Créait l'objet de défilement dans la cible
				Cible.Defilement = new Object();
				
				// Donne les arguments de temps et de vitesse sous la forme correct ( Tableau )
				if( !TypeOf( Temps , "Array" ) ){ Temps = [ Temps , Temps ]; }
				if( !TypeOf( Vitesse , "Array" ) ){ Vitesse = [ Vitesse , Vitesse ]; }
				//
				// Donne les positions
				PositionInitiale.x = PositionInitiale.x || 0;
				PositionInitiale.y = PositionInitiale.y || 0;
				//
				// Convertie les positions en tableau
				if( !TypeOf( PositionInitiale.x , "Array" ) ){ PositionInitiale.x = [ PositionInitiale.x , PositionInitiale.x ]; }
				if( !TypeOf( PositionInitiale.y , "Array" ) ){ PositionInitiale.y = [ PositionInitiale.y , PositionInitiale.y ]; }
				//
				// Donne les autres paramètres :
				Cible.Defilement.Element = Element;						// — - La class
				Cible.Defilement.PositionInitiale = PositionInitiale;	// — - La position initiale
				Cible.Defilement.PositionFinale = PositionFinale;		// — - La position finale
				Cible.Defilement.Temps = Temps;							// — - Temps entre deux créations
				Cible.Defilement.Vitesse = Vitesse;						// — - La vitesse de déplacement
				Cible.Defilement.Direction = Direction;					// — - La direction
				//
				// Donne les autres paramètres complémentaires
				Cible.Defilement.NumeroElement = 0;						// — - Le numéro du dernier élément créé
				Cible.Defilement.TempsActuel = 0;						// — - Le palier du temps
				
				
				// S'il y a une demande de qualité minimale —— - -
				if( SetDefault( QualiteMinimale ) ){
					
					// S'il n'y a pas de lien à la OptimizeTools —— - - retourne l'erreur
					if( !Optimize ){
						TraceError( "FxTools" , "NewInstantElement" , 
								   [ "Une demande de qualité minimale a été faites pour cet effet alors qu'aucun lien vers la OptimizeTools" ,
									 "n'a été donné. Pour pouvoir demandé une qualité minimal à un effet de la FxTools, il faut donner" ,
									 "l'instance de la FxTools à son initialisation :" ,
									 "Exemple : var Fx:FxTools = new FxTools( Optimize );"
								   ] );
						
					// S'il y a le lien OptimizeTools —— - -
					} else {
						
						// Si la qualité n'existe pas —— - - trace l'erreur
						if( Optimize.GetQuality( QualiteMinimale ) == -1 ){
							TraceError( "FxTools" , "NewInstantElement" , 
									   [ "La qualité " + QualiteMinimale + " n'éxiste pas." , Optimize.TellMeQuality() ] );
						
						// Si elle existe —— - - On la récupére chiffré
						} else { Cible.Defilement.QualiteMinimale = Optimize.GetQuality( QualiteMinimale ); }
					}
				}
				
				
				// Donne à la cible sa boucle pour le défilement —— - -
				Cible.Defilement.Boucle = function( event:* ):void {
					
					// Récupére l'instance de la cible et de l'objet de défilement
					var Cible:* = event.target;
					var Defilement:* = Cible.Defilement;
					
					// S'il n'y a pas de qualité minimale ou qu'elle est suffisante —— - -
					if( !Defilement.QualiteMinimale || Optimize.QualityNumero >= Defilement.QualiteMinimale ){
						
						// Le palier de temps se réduit
						Defilement.TempsActuel--;
						
						// Si le palier de temps est tombé à zéro —— - -
						if( Defilement.TempsActuel <= 0 ){
							
							// Le numéro de l'élément augmente
							Defilement.NumeroElement++;
							
							// Récupére une position en aléatoire ( Ou pas selon les tableaux )
							var PositionX:Number = Random( Defilement.PositionInitiale.x[ 0 ] , Defilement.PositionInitiale.x[ 1 ] );
							var PositionY:Number = Random( Defilement.PositionInitiale.y[ 0 ] , Defilement.PositionInitiale.y[ 1 ] );
							
							// Créait un nouvel élément
							var NouvelElement:* = NewElement( Defilement.Element , Cible , Cible.name + Defilement.NumeroElement , 
															{ x:PositionX , y:PositionY } );
							
							// Donne à cet élément sa position finale
							NouvelElement.PositionFinale = Defilement.PositionFinale;
							//
							// Done à cet élément sa direction
							NouvelElement.Direction = Defilement.Direction;
							//
							// Donne à cet élément sa vitesse en aléatoire
							NouvelElement.Vitesse = Random( Defilement.Vitesse[ 0 ] , Defilement.Vitesse[ 1 ] );
							
							// Redéfinie le temps en aléatoire pour le prochain élément à créer
							Defilement.TempsActuel = Random( Defilement.Temps[ 0 ] , Defilement.Temps[ 1 ] );
							
							
							// Donne à cet élément sa boucle de déplacement —— - -
							NouvelElement.Deplacement = function( event:* ):void {
								
								// Récupère l'instance de l'élément
								var Element:* = event.target;
								
								// L'élément se déplace dans sa direction à sa vitesse
								Element[ Element.Direction ] += Element.Vitesse;
								
								// S'il dépasse sa position finale par la gauche pour un "Supérieur à" —— - - Il s'annihile
								if( FindIn( Element.PositionFinale , ">" ) ){
									//
									if( Element[ Element.Direction ] > Number( GetIn( Element.PositionFinale , ">" , 2 ) ) ){ 
										//
										DestroyElement( Element ); 
									}
									
								// S'il dépasse sa position finale par la droite pour un "Inférieur à" —— - - Il s'annihile
								} else {
									//
									if( Element[ Element.Direction ] < Number( GetIn( Element.PositionFinale , "<" , 2 ) ) ){ 
										//
										DestroyElement( Element ); 
									}
								}
							}
							//
							// Donne l'événement de la boucle à cet élément
							AddEvents( NouvelElement , NouvelElement.Deplacement , "ENTER_FRAME" );
							//
							//
							// S'il est provoqué —— - -
							if( Cible.Provoque ){
								
								// Il est déplacé a hauteur de ce qu'il lui faut —— - -
								for( var iProvoque:int = 1 ; iProvoque < Cible.Provoque ; iProvoque++ ){
									//
									NouvelElement[ NouvelElement.Direction ] += NouvelElement.Vitesse;
								}
							}
						}
					}
				}
				//
				// Donne l'événement de la boucle à la cible
				AddEvents( Cible , Cible.Defilement.Boucle , "ENTER_FRAME" );
						
						
				// S'il y a une mise en place initiale —— - -
				if( Initial > 0 ){
					
					// Pour chaque initial —— - -
					while( Initial > 0 ){
						
						// Lui donne sa provocation
						Cible.Provoque = Initial;
						
						// Provoque la création de défilement
						Cible.Defilement.Boucle( { target:Cible } );
						
						// Réduit l'initial
						Initial--;
					}
						
					// Lui retire sa provocation
					Cible.Provoque = null;
				}
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				  PARTICLE					  		  				  	  */
		/*					 Méthodes pour générer des effets visuels à partir de particules 					  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - INSTANT - - —————————————————————————————————————————— */
		// Méthode appliquant des effet de particules momentanées
		//*—*//
		
		// —————— BLOW           									 	
		//	Fait apparaître plusieurs clips sur un point et les fait partir dans tout les sens
		//
		// ¤VorteX Compatible¤
	
	  	public function Blow( Clip:* ,						// ¤¤—— - - Clip des particules
							  Conteneur:* = null ,			// ¤¤—— - - Conteneur de l'affichage des particules
							  Nombre:* = 10 ,				// ¤¤—— - - Nombre de particules
							  Etat:* = null ,				// ¤¤—— - - Etat des éléments
							  Parametres:* = null ,			// ¤¤—— - - Les Parametres de l'effet
							  Nom:String = "BlowParticle" ,	// ———— - - Nom à donner aux particules
							  QualiteMinimal:String = ""	// ———— - - Qualité minimale pour l'affichage de l'effet
							 ):Array {
			/*—*/
			
			// Levier de lancement
			var Levier:Boolean = false;
			
			// S'il y a une demande de qualité minimale —— - -
			if( SetDefault( QualiteMinimal ) ){
				
				// S'il n'y a pas de lien à la OptimizeTools —— - - retourne l'erreur
				if( !Optimize ){
					TraceError( "FxTools" , "NewInstantElement" , 
							   [ "Une demande de qualité minimale a été faites pour cet effet alors qu'aucun lien vers la OptimizeTools" ,
							     "n'a été donné. Pour pouvoir demandé une qualité minimal à un effet de la FxTools, il faut donner" ,
							     "l'instance de la FxTools à son initialisation :" ,
							     "Exemple : var Fx:FxTools = new FxTools( Optimize );"
							   ] );
					
				// S'il y a le lien OptimizeTools —— - -
				} else {
					
					// Si la qualité existe —— - -
					if( Optimize.GetQuality( QualiteMinimal ) != -1 ){
						
						// Si le numéro de qualité est suffisant —— - -
						if( Optimize.QualityNumero >= Optimize.GetQuality( QualiteMinimal ) ){ Levier = true; }
					
					
					// Si la qualité n'existe pas —— - - trace l'erreur
					} else {
						TraceError( "FxTools" , "NewInstantElement" , 
								   [ "La qualité " + QualiteMinimal + " n'éxiste pas." , Optimize.TellMeQuality() ] );
					}
				}
				
			// S'il n'y a pas de demande de qualité minimale —— - -
			} else { Levier = true; }
			
			
			// Si le levier le permet
			if( Levier ){
				
				// Les parametres par défauts
				Parametres = Parametres || new Object();
				//
				var Vitesse:Number = 			Parametres.Vitesse 				|| 3; 
				var Scale:Number = 				Parametres.Taille				|| 100;
				var DisparitionAlpha:Number = 	Parametres.DisparitionAlpha		|| 5;
				var DisparitionScale:Number = 	Parametres.DisparitionTaille 	|| 0;
				var Angle:* = 					Parametres.Angle				|| [ 0 , 360 ];
				
				// Arguments par défauts
				Etat = Etat || new Object();
				//
				// Défaut pour la disparition, si aucune des deux valeurs n'est au-dessus de zéro —— - -
				if( DisparitionAlpha <= 0 && DisparitionScale <= 0 ){ 
					
					// La disparition en scale se mes à 5
					DisparitionScale = 5; 
					
					// Trace l'erreur
					TraceError( "FxTools" , "Blow" , 
							   [ "Une valeur au-dessus ou égal à 0 a été choisie pour la vitesse de disparition en alpha." ,
								"La vitesse de disparition en rétrécissement est à 0 par défaut et donc n'agit pas, elle a été mis à 5 "
							  + "afin déviter les bugs." ,
								"Une des deux formes de disparition doit être active ou les particules ne sont jamais détruites et "
							  + "peuvent empeuser la scène. ;)"
							   ] );
				}
				
				// Aspire le nombre de particule à créer —— - -
				Nombre = Math.round( Aspiration( Nombre ) );
				
				// Créait le tableau de sortie
				var Sortie:Array = new Array();
				
				// Récupère le nombre d'éléments dans le conteneur
				var NombreClips:String = String( Conteneur.numChildren );
				
				// Pour chaque particule a créer —— - -
				for( var i:int = 0 ; i < Nombre ; i++ ){
					
					// Créait et affiche la particule
					var NewParticule:* = NewElement( Clip , Conteneur , Nom + NombreClips + i , Etat );
					
					// Ajoute la particule au tableau de sortie
					Sortie.push( NewParticule );
					
					// Aspire sa taille
					var ScaleADonner:* = Aspiration( Scale );
					
					// Définie sa taille
					NewParticule.width *= Aspiration( ScaleADonner ) / 100;
					NewParticule.height *= Aspiration( ScaleADonner ) / 100;
					
					// Définie sa rotation
					NewParticule.MaRotation = new Object();
					NewParticule.MaRotation.rotation = ( TypeOf( Angle , "Array" ) ) ? 
														 Random( Angle[ 0 ] , Angle[ 1 ] ) : 
														 Aspiration( Angle );
					
					// Définie ses valeurs
					NewParticule.Vitesse = Aspiration( Vitesse );
					NewParticule.DisparitionAlpha = Aspiration( DisparitionAlpha );
					NewParticule.DisparitionScale = Aspiration( DisparitionScale );
					
					
					// La boucle de déplacement de la particule —— - -
					NewParticule.Boucle = function( e ){
						
						// Récupére l'instance de la particule
						var C:* = e.target;
						
						// La Particule se déplace
						SetDirectionTo( C , Aspiration( C.Vitesse ) , Aspiration( C.MaRotation ) );
						
						// La particule s'efface (Si elel le doit)
						C.alpha -= Aspiration( C.DisparitionAlpha ) / 100;
						
						// La particule se redimensionne (Si elle le doit)
						SetRealScale( C , "-" + Aspiration( C.DisparitionScale ) / 10 , "width" );
						SetRealScale( C , "-" + Aspiration( C.DisparitionScale ) / 10 , "height" );
						
						// Si elle est trop petite ou invisible —— - - elle est détruite
						if( C.width <= 2 || C.alpha <= 0 ){ DestroyElement( C ); }
					}
					
					// Donne l'événement de boucle de mouvement à la particule
					AddEvents( NewParticule , NewParticule.Boucle , "ENTER_FRAME" );
				}
				
				// Retourne le tableau
				return Sortie;
			}
			
			// Retourne un tableau vide
			return [];
		}
		
		
		// —————— EXPLODE           									 	
		//	Fait une explosion de clips avec gravité
		//
		// ¤VorteX Compatible¤

	  	public function Explode( Element:* ,						// ¤¤—— - - Clip des particules
								 Cible:* ,							// ¤¤—— - - Le Conteneur des particules
								 Nombre:* = 10 ,					// ¤¤—— - - Nombre d'élément à intégrer
								 Etat:* = null ,					// ¤¤—— - - Etat des éléments
								 Parametres:* = null ,				// ¤¤—— - - Les Parametres de l'effet
								 Nom:String = "ExplodeParticle" ,	// ———— - - Le début du nom à leur donner
								 QualiteMinimal:String = ""			// ———— - - Qualité minimale pour l'affichage de l'effet
								):Array {
			/*—*/
			
			// Levier de lancement
			var Levier:Boolean = false;
			
			// S'il y a une demande de qualité minimale —— - -
			if( SetDefault( QualiteMinimal ) ){
				
				// S'il n'y a pas de lien à la OptimizeTools —— - - retourne l'erreur
				if( !Optimize ){
					TraceError( "FxTools" , "NewInstantElement" , 
							   [ "Une demande de qualité minimale a été faites pour cet effet alors qu'aucun lien vers la OptimizeTools" ,
							     "n'a été donné. Pour pouvoir demandé une qualité minimal à un effet de la FxTools, il faut donner" ,
							     "l'instance de la FxTools à son initialisation :" ,
							     "Exemple : var Fx:FxTools = new FxTools( Optimize );"
							   ] );
					
				// S'il y a le lien OptimizeTools —— - -
				} else {
					
					// Si la qualité existe —— - -
					if( Optimize.GetQuality( QualiteMinimal ) != -1 ){
						
						// Si le numéro de qualité est suffisant —— - -
						if( Optimize.QualityNumero >= Optimize.GetQuality( QualiteMinimal ) ){ Levier = true; }
					
					
					// Si la qualité n'existe pas —— - - trace l'erreur
					} else {
						TraceError( "FxTools" , "NewInstantElement" , 
								   [ "La qualité " + QualiteMinimal + " n'éxiste pas." , Optimize.TellMeQuality() ] );
					}
				}
				
			// S'il n'y a pas de demande de qualité minimale —— - -
			} else { Levier = true; }
				
				// Les parametres par défauts
				Parametres = Parametres || new Object();
				//
				var Disparition:String = Parametres.Disparition || "Alpha"; 
			
			
			// Si le levier dis que c'est ok —— - -
			if( Levier ){
				
				// Arguments par défaut
				Parametres = Parametres || new Object();
				//
				Parametres.ForceX = Parametres.ForceX || [ -20 , 20 ];
				Parametres.ForceY = Parametres.ForceY || [ -20 , 20 ];
				Parametres.ForceR = Parametres.ForceR || [ -20 , 20 ];
				Parametres.Gravite = Parametres.Gravite || 2;
				Parametres.Masse = Parametres.Masse || 1;
				//
				// Calibrage des Forces
				if( TypeOf( Parametres.ForceX , "Number" ) ){ Parametres.ForceX = [ -Parametres.ForceX , Parametres.ForceX ]; }
				if( TypeOf( Parametres.ForceY , "Number" ) ){ Parametres.ForceY = [ -Parametres.ForceY , Parametres.ForceY ]; }
				if( TypeOf( Parametres.ForceR , "Number" ) ){ Parametres.ForceR = [ -Parametres.ForceR , Parametres.ForceR ]; }
				
				// Aspire le nombre
				Nombre = Math.round( Aspiration( Nombre ) );
				
				// Créait le tableau de sortie
				var Sortie:Array = new Array();
				
				// Pour chaque élément à créer —— - -
				for( var i:int = 0 ; i <= Nombre ; i++ ){
					
					// Créer l'élément
					var NouvelElement:* = NewInstantElement(  Element , Cible , Nom + i , Etat , Disparition );
					
					// Ajoute l'élément au tableau de sortie
					Sortie.push( NouvelElement );
					
					// Donne à cet élément ses vitesse ( Aléatoire ) Pour celle étant dans des tableaux
					//
					if( TypeOf( Parametres.ForceX , "Array" ) ){
						NouvelElement.VitesseX = Random( Aspiration( Parametres.ForceX[ 0 ] ) , Aspiration( Parametres.ForceX[ 1 ] ) );
					} else { NouvelElement.VitesseX = Parametres.ForceX; }
					//
					if( TypeOf( Parametres.ForceY , "Array" ) ){
						NouvelElement.VitesseY = Random( Aspiration( Parametres.ForceY[ 0 ] ) , Aspiration( Parametres.ForceY[ 1 ] ) );
					} else { NouvelElement.VitesseY = Parametres.ForceY; }
					//
					if( TypeOf( Parametres.ForceR , "Array" ) ){
						NouvelElement.VitesseR = Random( Aspiration( Parametres.ForceR[ 0 ] ) , Aspiration( Parametres.ForceR[ 1 ] ) );
					} else { NouvelElement.VitesseR = Parametres.ForceR; }
					//
					// Donne à cet élément ses paramètres
					NouvelElement.Gravite = Aspiration( Parametres.Gravite );
					NouvelElement.Masse = Aspiration( Parametres.Masse );
					
					// Donne à cet élément la boucle
					NouvelElement.ExplodeMouvement = function( event:Event ):void {
						
						// Récupète son instance
						var Cible:* = event.target;
						
						// Déplace dans l'espace
						Cible.x += Aspiration( Cible.VitesseX );
						Cible.y += Aspiration( Cible.VitesseY );
						
						// Modifie sa rotation
						Cible.rotation += Aspiration( Cible.VitesseR );
						
						// Modifie les vitesses
						Cible.VitesseX *= ( 100 - Aspiration( Cible.Masse ) ) / 100;
						Cible.VitesseY += Aspiration( Cible.Gravite );
					}
					//
					// Donne l'événement à l'élément
					AddEvents( NouvelElement , NouvelElement.ExplodeMouvement , "ENTER_FRAME" );
				}
				
				// Retourne le tableau
				return Sortie;
			}
			
			// Retourne un tableau vide
			return [];
		}
		
		
		// —————— BLOW SMOKE          									 	
		// Fait une explosion de clips sous forme de fumée se dispersant dans diverse direction
		// ATTENTION : Le tableau renvoyé par la méthode est remplie au fur et à mesure et non immédiatement
		//
		// ¤VorteX Compatible¤

	  	public function BlowSmoke( Element:* ,							// ¤¤—— - - L'élément dans la bibliothèque
								   Cible:* ,							// ¤¤—— - - Le container
								   Nombre:* = 10 ,						// ¤¤—— - - Nombre d'élément à intégrer
								   Etat:Object = null ,					// ¤¤—— - - L'état des éléments intégrer
								   Parametres:Object = null ,			// ¤¤—— - - Les Parametres
								   Nom:String = "BlowSmokeParticle" ,	// ———— - - Le début du nom à leur donner
								   QualiteMinimal:String = ""			// ———— - - Qualité minimale pour l'affichage de l'effet
								):Array {
			/*—*/
			
			// Variables par défaut
			Etat = Etat || { x:0 , y:0 };
			Parametres = Parametres || { Ramification:1 , Taille:100 };
			//
			var Disparition:String = Parametres.Disparition || "Taille 0.75";
			
			// Levier de lancement
			var Levier:Boolean = false;
			
			// S'il y a une demande de qualité minimale —— - -
			if( SetDefault( QualiteMinimal ) ){
				
				// S'il n'y a pas de lien à la OptimizeTools —— - - retourne l'erreur
				if( !Optimize ){
					TraceError( "FxTools" , "NewInstantElement" , 
							   [ "Une demande de qualité minimale a été faites pour cet effet alors qu'aucun lien vers la OptimizeTools" ,
							     "n'a été donné. Pour pouvoir demandé une qualité minimal à un effet de la FxTools, il faut donner" ,
							     "l'instance de la FxTools à son initialisation :" ,
							     "Exemple : var Fx:FxTools = new FxTools( Optimize );"
							   ] );
					
				// S'il y a le lien OptimizeTools —— - -
				} else {
					
					// Si la qualité existe —— - -
					if( Optimize.GetQuality( QualiteMinimal ) != -1 ){
						
						// Si le numéro de qualité est suffisant —— - -
						if( Optimize.QualityNumero >= Optimize.GetQuality( QualiteMinimal ) ){ Levier = true; }
					
					
					// Si la qualité n'existe pas —— - - trace l'erreur
					} else {
						TraceError( "FxTools" , "NewInstantElement" , 
								   [ "La qualité " + QualiteMinimal + " n'éxiste pas." , Optimize.TellMeQuality() ] );
					}
				}
				
			// S'il n'y a pas de demande de qualité minimale —— - -
			} else { Levier = true; }
			
			
			// Si le levier dis que c'est ok —— - -
			if( Levier ){
				
				// Arguments par défaut
				Parametres = Parametres || new Object();
				//
				Parametres.DistanceX = Parametres.DistanceX || [ -50 , 50 ];
				Parametres.DistanceY = Parametres.DistanceY || [ -50 , 50 ];
				//
				Parametres.Ramification = Aspiration( Parametres.Ramification , 1 );
				Parametres.Taille = Aspiration( Parametres.Taille , 100 );
				Parametres.Bump = Aspiration( Parametres.Bump , 2 );
				//
				Etat.x = Etat.x || 0;
				Etat.y = Etat.y || 0;
				
				// Aspire le nombre
				Nombre = Math.round( Aspiration( Nombre ) );
				
				// Pour chaque élément à créer —— - -
				for( var i:int = 0 ; i <= Nombre ; i++ ){
					
					// Créait l'élément
					var NouvelElement:* = NewInstantElement( Element , Cible , Nom + i , Etat , Disparition );
					
					// Donne les paramètres à l'élément
					NouvelElement.DistanceX = Parametres.DistanceX;
					NouvelElement.DistanceY = Parametres.DistanceY;
					//
					NouvelElement.Ramification = Aspiration( Parametres.Ramification );
					NouvelElement.ActuelleRamification = Aspiration( Parametres.Ramification );
					NouvelElement.Taille = Aspiration( Parametres.Taille );
					NouvelElement.Bump = Aspiration( Parametres.Bump );
					NouvelElement.ActuelBump = Parametres.Bump;
					
					// Donne une direction standard à zéro
					NouvelElement.DirectionX = 0;
					NouvelElement.DirectionY = 0;
					
					// Donne le niveau pour éviter qu'il en créait trop
					NouvelElement.Niveau = 0;
					
					// Créait le tableau qui récupère les particule
					var Sortie:Array = [ NouvelElement ];
					
					// Donne à cet élément la boucle —— - -
					NouvelElement.SmokeBlowBoucle = function( event:Event ):void {
						
						// Récupète son instance
						var laCible:* = event.target;
						
						// Lance la création des ramification si le bump est tombé et qu'on est pas monté trop haut dans les niveaux —— - -
						if( laCible.ActuelBump <= 0 && laCible.Niveau < 10 ){
							
							// Créait un double réduit tans qu'il le faut —— - -
							if( laCible.ActuelleRamification > 0 ){
								
								// Modifie la future position selon sa direction
								var NouvelEtat:Object = CloneObject( Etat );
								//
								var DirectionX:Number = laCible.DirectionX + Random( laCible.DistanceX[ 0 ] , laCible.DistanceX[ 1 ] );
								var DirectionY:Number = laCible.DirectionY + Random( laCible.DistanceY[ 0 ] , laCible.DistanceY[ 1 ] );
								//
								NouvelEtat.x += DirectionX;
								NouvelEtat.y += DirectionY;
								
								// Créait l'élément
								var RamNouvelElement:* = NewInstantElement( Element , 
																		    Cible , 
																			Nom + RandomWord() , 
																			NouvelEtat , 
																			Disparition );
								
								// L'ajoute au tableau de sortie
								Sortie.push( RamNouvelElement );
								
								// Donne les paramètres à l'élément
								RamNouvelElement.DistanceX = laCible.DistanceX;
								RamNouvelElement.DistanceY = laCible.DistanceY;
								//
								RamNouvelElement.Ramification = laCible.Ramification;
								RamNouvelElement.ActuelleRamification = laCible.Ramification;
								RamNouvelElement.Taille = laCible.Taille - Random( 10 , 30 );
								RamNouvelElement.Bump = laCible.Bump;
								RamNouvelElement.ActuelBump = laCible.ActuelBump;
								//
								RamNouvelElement.DirectionX = DirectionX;
								RamNouvelElement.DirectionY = DirectionY;
								
								// Donne son niveau
								RamNouvelElement.Niveau = laCible.Niveau + 1;
								
								// Donne la fonction
								RamNouvelElement.SmokeBlowBoucle = laCible.SmokeBlowBoucle;
								
								// Calibre et Modifie sa taille
								RamNouvelElement.Taille = ( RamNouvelElement.Taille < 0 ) ? 2 : RamNouvelElement.Taille
								RamNouvelElement.width *= RamNouvelElement.Taille / 100;
								RamNouvelElement.height *= RamNouvelElement.Taille / 100;
								
								// Si sa taille ou son alpha est encore suffisante —— - - Lui donne sa boucle
								if( RamNouvelElement.Taille > 10 && RamNouvelElement.alpha > 0.1 ){
									AddEvents( RamNouvelElement , RamNouvelElement.SmokeBlowBoucle , "ENTER_FRAME" );
								}
								
								// Réduit le reste à créer
								laCible.ActuelleRamification--;
							}
						//
						// Si on ne doit pas encore les créer —— - - Réduit le palier
						} else { laCible.ActuelBump--; }
					}
					//
					// Donne l'événement à l'élément
					AddEvents( NouvelElement , NouvelElement.SmokeBlowBoucle , "ENTER_FRAME" );
				}
				
				// Retourne le tableau
				return Sortie;
			}
			
			// Retourne un tableau vide
			return [];
		}
		
		
		// —————— SPLASH             									 	
		//	Fait apparaître plusieurs clips sur un point et les fait partir dans tout les sens jusqu'à arrêt complet
		//	Ils sont prévues pour rester ensuite
		//
		//	¤VorteX Compatible¤
	
	  	public function Splash( Clip:* ,						// ¤¤—— - - Clip des particules
								Conteneur:* = null ,			// ¤¤—— - - Clip conteneur s'il est différent du parent de la cible
								Nombre:* = 10 ,					// ¤¤—— - - Nombre de particules
								Etat:* = null ,					// ¤¤—— - - L'état des éléments intégrer
								Parametres:* = null ,			// ———— - - Les paramètres additifs
								Nom:String = "SplashParticle" ,	// ———— - - Le début du nom à leur donner
								QualiteMinimal:String = ""		// ———— - - Qualité minimale pour l'affichage de l'effet
							  ):Array {
			/*—*/
			
			// Levier de lancement
			var Levier:Boolean = false;
			
			// S'il y a une demande de qualité minimale —— - -
			if( SetDefault( QualiteMinimal ) ){
				
				// S'il n'y a pas de lien à la OptimizeTools —— - - retourne l'erreur
				if( !Optimize ){
					TraceError( "FxTools" , "NewInstantElement" , 
							   [ "Une demande de qualité minimale a été faites pour cet effet alors qu'aucun lien vers la OptimizeTools" ,
							     "n'a été donné. Pour pouvoir demandé une qualité minimal à un effet de la FxTools, il faut donner" ,
							     "l'instance de la FxTools à son initialisation :" ,
							     "Exemple : var Fx:FxTools = new FxTools( Optimize );"
							   ] );
					
				// S'il y a le lien OptimizeTools —— - -
				} else {
					
					// Si la qualité existe —— - -
					if( Optimize.GetQuality( QualiteMinimal ) != -1 ){
						
						// Si le numéro de qualité est suffisant —— - -
						if( Optimize.QualityNumero >= Optimize.GetQuality( QualiteMinimal ) ){ Levier = true; }
					
					
					// Si la qualité n'existe pas —— - - trace l'erreur
					} else {
						TraceError( "FxTools" , "NewInstantElement" , 
								   [ "La qualité " + QualiteMinimal + " n'éxiste pas." , Optimize.TellMeQuality() ] );
					}
				}
				
			// S'il n'y a pas de demande de qualité minimale —— - -
			} else { Levier = true; }
			
			
			// Si le levier le permet
			if( Levier ){
								
				// Les parametres par défauts
				Parametres = Parametres || new Object();
				//
				var Vitesse:* = 	Parametres.Vitesse 		|| [ 10 , 20 ]; 
				var Frein:Number = 	Parametres.Frein		|| 90;
				var Scale:* = 		Parametres.Scale		|| [ 50 , 150 ];
				var Rotation:* = 	Parametres.Rotation 	|| [ 0 , 360 ];
				var Angle:* = 		Parametres.Angle		|| [ 0 , 360 ];
				//
				Etat = Etat || new Object();
				
					
				// Valeur de sortie
				var Sortie:Array = new Array();
				
				// Aspire la class
				Clip = Aspiration( Clip );
				
				// Aspire le nombre de particule à créer —— - -
				Nombre = Math.round( Aspiration( Nombre ) );
				
				// Pour chaque particule a créer —— - -
				for( var i:int = 0 ; i < Nombre ; i++ ){
					
					// Tire un nom aléatoire pour cette particule
					var Nom:String = "Splashing" + RandomWord();
					
					// Créait et affiche la particule
					var NewParticule:* = NewElement( Clip , Conteneur , Nom , Etat );
					//
					//
					Sortie.push( NewParticule );
					
					// Donne son nom
					NewParticule.name = Nom;
					
					// Définie sa taille
					var Rescaling:Number = ( TypeOf( Scale , "Array" ) ) ? 
										   Random( Aspiration( Scale[ 0 ] ) , 
										   Aspiration( Scale[ 1 ] ) ) : Aspiration( Scale );
					//
					NewParticule.width *= Aspiration( Rescaling ) / 100;
					NewParticule.height *= Aspiration( Rescaling ) / 100;
					
					// Définie sa rotation
					NewParticule.maRotation = ( TypeOf( Angle , "Array" ) ) ? 
											  Random( Aspiration( Angle[ 0 ] ) , 
											  Aspiration( Angle[ 1 ] ) ) : Aspiration( Angle );
					NewParticule.rotation = ( TypeOf( Rotation , "Array" ) ) ? 
											  Random( Aspiration( Rotation[ 0 ] ) , 
											  Aspiration( Rotation[ 1 ] ) ) : Aspiration( Rotation );
					
					// Définie ses valeurs
					NewParticule.Vitesse = ( TypeOf( Vitesse , "Array" ) ) ? 
											Random( Aspiration( Vitesse[ 0 ] ) , 
											Aspiration( Vitesse[ 1 ] ) ) : Aspiration( Vitesse );
					NewParticule.Frein = Aspiration( Frein );
					
					
					// La boucle de déplacement de la particule —— - -
					NewParticule.Boucle = function( e ){
						
						// Récupére l'instance de la particule
						var C:* = e.target;
						
						// La Particule se déplace
						SetDirectionTo( C , Aspiration( C.Vitesse ) , Aspiration( C.maRotation ) );
						
						// La vitesse décroît
						C.Vitesse *= Aspiration( C.Frein ) / 100;
						
						// Si sa vitesse est à zéro —— - - Elle cesse sa boucle
						if( C.Vitesse <= 0.5 ){ RemoveEvents( C ); }
					}
					
					// Donne l'événement de boucle de mouvement à la particule
					AddEvents( NewParticule , NewParticule.Boucle , "ENTER_FRAME" );
				}
				
				// Retourne les particules
				return Sortie;
			}
			
			// Retourne un tableau vide
			return [];
		}
		
		
		
		/* —————————————————————————————————————————— - - CONSTANT - - —————————————————————————————————————————— */
		// Méthode appliquant des effets de particules constants
		//*—*//
		
		// —————— PARTICLE
		// Lance la diffusion de particules sur une cible ou un emplacement
		//
		// ¤VorteX Compatible¤
	
	  	public function Particle( Clip:* ,							// ¤¤—— - - Clip des particules
								  Conteneur:* = null ,				// ¤¤—— - -	Le conteneur des particules
								  Etat:* = null ,					// ¤¤—— - - La cible central pour l'apparition des particules
								  Physique:* = null ,				// ¤¤—— - - Les parametres physiques
								  Evolution:* = null ,				// ¤¤—— - - Les parametres d'évolution
								  Exponentiel:* = null ,			// ¤¤—— - - Les parametres d'exponentialité
								  Fonction:* = null ,				// ¤¤—— - - Les fonctions par particules
								  QualiteMinimal:String = "" ,		// ———— - - La qualité minimal de l'effet
								  Nom:String = ""					// ———— - - Nom facultatif à donner à la boucle de particule
								):void {
			/*—*/
			
			// Arguments par défaut
			Etat = Etat || new Object();
			//
			Physique = Physique || new Object();
			Evolution = Evolution || new Object();
			Exponentiel = Exponentiel || new Object();
			Fonction = Fonction || new Object();
			//
			// —— - - PHYSIQUE
			Physique.Cadence = Physique.Cadence || 0;
			Physique.CadenceActuelle = Aspiration( Physique.Cadence );
			Physique.Destruction = Physique.Destruction || { alpha:"<0" };
			//
			// —— - - EVOLUTION
			Evolution.x = Evolution.x || 0;
			Evolution.y = Evolution.y || 0;
			Evolution.alpha = ( Evolution.alpha == null ) ? -0.02 : Evolution.alpha;
			
			
			// Si cette particule existait déjà —— - - La retire
			if( Conteneur[ "ObjetParticule" + Nom ] ){ Conteneur.RetireParticule( Nom ); }
			
			// Donne l'objet de particule à la cible
			var Objet:Object = Conteneur[ "ObjetParticule" + Nom ] = new Object();
			//
			// Donne à l'objet de particule ses paramètes
			Objet.Clip = Clip;
			Objet.Conteneur = Conteneur;
			Objet.Physique = Physique;
			Objet.Evolution = Evolution;
			Objet.Exponentiel = Exponentiel;
			Objet.Fonction = Fonction;
			//
			Objet.Numero = 0;
			Objet.Actif = true;
			
			// S'il y a une demande de qualité minimale —— - -
			if( SetDefault( QualiteMinimal ) ){
				
				// S'il n'y a pas de lien à la OptimizeTools —— - - Retourne l'erreur
				if( !Optimize ){
					TraceError( "FxTools" , "Particule", 
							   [ "Une demande de qualité minimale a été faites pour cet effet alors qu'aucun lien vers la OptimizeTools" ,
							   "n'a été donné. Pour pouvoir demandé une qualité minimal à un effet de la FxTools, il faut donner" ,
							   "l'instance de la FxTools à son initialisation :" ,
							   "Exemple : var Fx:FxTools = new FxTools( Optimize );"
							  ] );
				
				// S'il y a le lien —— - -
				} else {
					
					// Si la qualité existe —— - -
					if( Optimize.GetQuality( QualiteMinimal ) != -1 ){
					
						// Donne le lien à la cible
						Objet.Optimize = Optimize;
						//
						// Donne la qualité ( Numérique ) à la cible
						Objet.QualiteMinimal = Optimize.GetQuality( QualiteMinimal );
					
					
					// Si la qualité n'existe pas —— - - trace l'erreur
					} else {
						TraceError( "FxTools" , "Retinal" , 
								   [ "La qualité " + QualiteMinimal + " n'éxiste pas." , Optimize.TellMeQuality() ] );
					}
				}
			}
			
			
			// Donne la boucle —— - -
			Objet.Boucle = function( event:Event ):void {
				
				// Récupère les instances
				var laCible:* = event.target
				//
				var lObjet:Object = laCible[ "ObjetParticule" + Nom ];
				var laPhysique:* = lObjet.Physique;
				var laForme:* = lObjet.Forme;
				var lEvolution:* = lObjet.Evolution;
				var leExponentiel:* = lObjet.Exponentiel;
				var laFonction:* = lObjet.Fonction;
				
				// S'il n'a pas de lien vers Optimize ou que la qualité est suffisante —— - -
				if( !lObjet.Optimize || Optimize.QualityNumero >= lObjet.QualiteMinimal ){
					
					// Si la particule est active —— - -
					if( lObjet.Actif ){
						
						// Pour une cadence inférieur ou égale à zéro —— - -
						if( laPhysique.CadenceActuelle <= 0 ){
							
							// Autant de fois que la cadence en cour est inférieur à zéro —— - -
							for( var i:int = 0 ; i >= laPhysique.CadenceActuelle ; i-- ){
								
								// Créait une particule selon les parametres
								lObjet.CreationParticule( Etat ,
														  lObjet ,
														  laPhysique ,
														  lEvolution ,
														  leExponentiel ,
														  laFonction
														 );
							}
							//
							// Remet la cadence au max
							laPhysique.CadenceActuelle = Aspiration( laPhysique.Cadence );
						
						// Si la cadence est supérieur à zéro —— - - Elle descent de 1
						} else { laPhysique.CadenceActuelle--; }
					}
				}
			}
			//
			// Donne l'événement de boucle
			AddEvents( Conteneur , Objet.Boucle , "ENTER_FRAME" );
			
			
			// Donne la méthode de création de particule —— - -
			Objet.CreationParticule = function( lEtat ,			// —— - - La cible
											    lObjet ,		// —— - - L'objet de contrôle
											    laPhysique ,	// —— - - La physique de la particule
											    lEvolution ,	// —— - - L'évolution de la particule
											    leExponentiel ,	// —— - - Le Exponentiel de la particule
												laFonction		// —— - - Les fonctions de la particule
											  ):void {
				
				// Augmente le numéro de la particule créée
				lObjet.Numero++;
				
				// Créait la nouvelle particule et la fait se positionner sur la cible
				var NouvelleParticule:* = NewElement( Aspiration( lObjet.Clip ) , 
													  Aspiration( lObjet.Conteneur ) ,
													  Nom + "Particule" + lObjet.Numero ,
													  lEtat );
				
				// Applique les décalage
				NouvelleParticule.x += Aspiration( NouvelleParticule.DecalageX , 0 );
				NouvelleParticule.y += Aspiration( NouvelleParticule.DecalageY , 0 );
				
				// S'il y a une cible —— - -
				if( NouvelleParticule.Cible ){
					//
					// Positionne la tête de lecture sur la frame
					NouvelleParticule.x = NouvelleParticule.Cible.x;
					NouvelleParticule.y = NouvelleParticule.Cible.y;
				}
				
				// S'il y a une frame à donner —— - -
				if( NouvelleParticule.Frame ){
					//
					// Positionne la tête de lecture sur la frame
					NouvelleParticule.gotoAndStop( Aspiration( NouvelleParticule.Frame ) );
				}
				
				// S'il y a une taille à donner —— - -
				if( NouvelleParticule.Taille ){
					
					// Récupère la modification de taille
					var ModificationTaille:Number = ( Aspiration( NouvelleParticule.Taille ) );
					//
					// Applique la modification de taille
					NouvelleParticule.width *= ModificationTaille;
					NouvelleParticule.height *= ModificationTaille;
				}
				
				// Pour chaque Exponentiel —— - -
				for( var inExponentiel:* in leExponentiel ){
					//
					// Donne la vitesse relative à ce Exponentiel
					NouvelleParticule[ "Vitesse" + inExponentiel ] = Aspiration( leExponentiel[ "Initial" + inExponentiel ] , 0 );
				}
				
				// Donne l'objet de particule à la particule
				NouvelleParticule.Objet = lObjet;
				
				// Lance la fonction relative à la création d'une particule
				Launch( laFonction.Debut , true , NouvelleParticule );
				
				// Donne à la particule sa boucle
				AddEvents( NouvelleParticule , Objet.BoucleParticule , "ENTER_FRAME" , "BoucleParticule" );
			}
			
			
			// Donne la boucle de particule —— - -
			Objet.BoucleParticule = function( event:Event ):void {
				
				// Récupère les instances
				var laCible:* = event.target
				//
				var lObjet:Object = laCible.Objet;
				var laPhysique:* = lObjet.Physique;
				var lEvolution:* = lObjet.Evolution;
				var leExponentiel:* = lObjet.Exponentiel;
				var laFonction:* = lObjet.Fonction;
				
				// lance la fonction de boucle de la particule
				Launch( laFonction.Boucle , true , laCible );
				
				// Pour chaque évolution —— - -
				for( var Evolutions:* in lEvolution ){
					
					// S'il s'agit d'une évolution de taille —— - -
					if( Evolutions == "Taille" ){
						
						// Tire l'évolution
						var EvolutionEphemereTaille:Number = Aspiration( lEvolution[ Evolutions ] )
						
						// Modifie la taille de l'élément
						laCible.width += EvolutionEphemereTaille;
						laCible.height += EvolutionEphemereTaille;
						
					// S'il s'agit d'une évolution de frame —— - -
					} else if( Evolutions == "Frame" ){
						
						// Modifie la tête de lecture de l'élément
						AnimationScroll( laCible , Aspiration( lEvolution[ Evolutions ] ) );
						
					} else {
					
						// Fait évoluer la partie de la particule en question
						laCible[ Evolutions ] += Aspiration( lEvolution[ Evolutions ] );
					}
				}
				
				// Pour chaque Exponentiel —— - -
				for( var inExponentiel:* in leExponentiel ){
					//
					// Modifie la vitesse relative à ce Exponentiel
					laCible[ "Vitesse" + inExponentiel ] += Aspiration( leExponentiel[ inExponentiel ] );
					//
					// Applique cette vitesse
					laCible[ inExponentiel ] += laCible[ "Vitesse" + inExponentiel ];
				}
				
				// Pour chaque destruction —— - -
				for( var i:* in laPhysique.Destruction ){
					
					// Si elle se base sur un supérieur —— - -
					if( FindIn( laPhysique.Destruction[ i ] , ">" ) ){
						//
						// Si la dite partie est supérieur au nombre donnée —— - - Détruit la particule
						if( laCible[ i ] > Pop( laPhysique.Destruction[ i ] , ">" ) ){ DestroyElement( laCible ); }
						
					// Si elle se base sur un inférieur —— - -
					} else if( FindIn( laPhysique.Destruction[ i ] , "<" ) ){
						//
						// Si la dite partie est supérieur au nombre donnée —— - - Détruit la particule
						if( laCible[ i ] < Pop( laPhysique.Destruction[ i ] , "<" ) ){ DestroyElement( laCible ); }
					}
				}
			}
			
			
			// Donne la fonction d'activation/désactivation de l'effet particule —— - -
			Conteneur.ActiveParticule = function( Etat:Boolean = true ,	// —— - - Etat
												  Nom:String = "" 		// —— - - Nom
												 ):void {
				
				// S'il existe —— - -
				if( Conteneur[ "ObjetParticule" + Nom ] ){
					//
					// Modifie sn état
					Conteneur[ "ObjetParticule" + Nom ].Actif = Etat;
				}
			}
			
			
			// Donne la fonction de destruction de l'effet particule —— - -
			Conteneur.RetireParticule = function( Nom:String = "" ):void {
				
				// S'il existe —— - -
				if( Conteneur[ "ObjetParticule" + Nom ] ){
					//
					// Retire la boucle
					RemoveEvents( Conteneur , Conteneur[ "ObjetParticule" + Nom ].Boucle , "ENTER_FRAME" , "BoucleParticule" );
					//
					// Mes l'objet à null
					Conteneur[ "ObjetParticule" + Nom ] = null;
				}
			}
		}
		
		
		// —————— TAILS
		// Fait apparaître des suite de clips formant une trainée
		//
		// ¤VorteX Compatible¤	           									 	
		
		public function Tails( Cible:* ,						// ———— - - La Cible central pour l'apparition de l'effet
							   Element:* ,						// ¤¤—— - - Class de l'élément faisant la trainée
							   Conteneur:* = null ,				// ¤¤—— - -	Le conteneur de l'effet
							   Etat:* = null ,					// ¤¤—— - - Les états des particules de l'effet
							   Parametres:Object = null ,		// ¤¤—— - - Les Parametres additifs
							   QualiteMinimal:String = "" ,		// ———— - - La qualité minimal de l'effet
							   Nom:String = ""					// ———— - - Nom additif de l'effet afin de pouvoir les cumuler
							  ):Object {
			/*—*/
			
			// Le conteneur est, par défaut, le parent de la cible
			Conteneur = Conteneur || Cible.parent;
			Parametres = Parametres || new Object();
			//
			Etat = Etat || new Object();
			var Taille:* = Etat.Taille || 100;
			//
			Parametres.DisparitionTaille = ( Parametres.DisparitionTaille != null ) ? Parametres.DisparitionTaille : 100;
			Parametres.DisparitionAlpha = ( Parametres.DisparitionAlpha != null ) ? Parametres.DisparitionAlpha : 0;
			//
			var VitesseDisparition:* = Parametres.VitesseDisparition || 10;
			
			// Création de l'objet de l'effet
			var ObjetAlchimie:Object = Cible[ "Alchimie" + Nom ] = new Object();
			
			// Création des variables de mémoires du positionnement de la cible
			ObjetAlchimie.MemoX = Cible.x;
			ObjetAlchimie.MemoY = Cible.y;
			
			// Création du numéro pour les traits ( Afin que la destruction se fasse correctement )
			ObjetAlchimie.Numero = 0;
			
			// Donne les arguments à la cible
			ObjetAlchimie.Element = Element;
			ObjetAlchimie.Taille = Taille;
			ObjetAlchimie.VitesseDisparition = VitesseDisparition;
			ObjetAlchimie.Parametres = Parametres;
			
			
			// S'il y a une demande de qualité minimale —— - -
			if( SetDefault( QualiteMinimal ) ){
				
				// S'il n'y a pas de lien à la OptimizeTools —— - - Retourne l'erreur
				if( !Optimize ){
					TraceError( "FxTools" , "Alchimie" , 
							   [ "Une demande de qualité minimale a été faites pour cet effet alors qu'aucun lien vers la OptimizeTools" ,
							   "n'a été donné. Pour pouvoir demandé une qualité minimal à un effet de la FxTools, il faut donner" ,
							   "l'instance de la FxTools à son initialisation :" ,
							   "Exemple : var Fx:FxTools = new FxTools( Optimize );"
							  ] );
				
				// S'il y a le lien —— - -
				} else {
					
					// Si la qualité existe —— - -
					if( Optimize.GetQuality( QualiteMinimal ) != -1 ){
					
						// Donne le lien à la cible
						ObjetAlchimie.Optimize = Optimize;
						//
						// Donne la qualité ( Numérique ) à la cible
						ObjetAlchimie.QualiteMinimal = Optimize.GetQuality( QualiteMinimal );
					
					
					// Si la qualité n'existe pas —— - - trace l'erreur
					} else {
						TraceError( "FxTools" , "Alchimie" , [ "La qualité " + QualiteMinimal + " n'éxiste pas." , Optimize.TellMeQuality() ] );
					}
				}
			}
			
			
			
			// Constement pour la cible —— - -
			ObjetAlchimie.Boucle = function( event:Event ):void {
				
				// Récupére l'instance de la cible
				var CetteCible:* = event.target;
				
				// Récupère l'instance de l'objet d'Alchimie
				var CetObjetAlchimie:Object = CetteCible[ "Alchimie" + Nom ];
				
				// S'il n'a pas de lien vers Optimize ou que la qualité est suffisante —— - -
				if( !CetObjetAlchimie.Optimize || Optimize.QualityNumero >= CetObjetAlchimie.QualiteMinimal ){
				   
					// S'il n'a pas été vidé de toute substance —— - -
					if( LengthObject( CetteCible ) != 0 ){
						   
						// Créait un nouveau trait
						var NouveauTrait:MovieClip = NewElement( CetObjetAlchimie.Element , 
																 Conteneur , 
																 "NouveauTraitAlchimie" + CetObjetAlchimie.Numero ,
																 Etat
																 );
						
						// Lui donne une couleur s'il en faut une
						if( CetObjetAlchimie.Couleur ){ SetColor( NouveauTrait , Aspiration( CetObjetAlchimie.Couleur ) );	}
						
						// Récupére les valeurs d'arguments
						NouveauTrait.Taille = Aspiration( CetObjetAlchimie.Taille );
						NouveauTrait.Couleur = CetObjetAlchimie.Couleur;
						NouveauTrait.VitesseDisparition = Aspiration( CetObjetAlchimie.VitesseDisparition );
						
						// Récupére les parametres
						NouveauTrait.HauteurInitiale = NouveauTrait.height;
						
						// Récupére l'ancienne et la nouvelle position
						var DX:Number = CetObjetAlchimie.MemoX + ( CetObjetAlchimie.Parametres.x || 0 );
						var DY:Number = CetObjetAlchimie.MemoY + ( CetObjetAlchimie.Parametres.y || 0 );
						var FX:Number = CetteCible.x + ( CetObjetAlchimie.Parametres.x || 0 );
						var FY:Number = CetteCible.y + ( CetObjetAlchimie.Parametres.y || 0 );
						
						// Définie en tans que liaison
						ApplyLinkEffect( NouveauTrait , 
										{ x:DX , y:DY } , 
										{ x:FX , y:FY } , 
										Aspiration( Parametres.DecalagePosition , 0 ) , 
										Aspiration( Parametres.DecalageTaille , 0 ) );
						//
						CetObjetAlchimie.Numero++;
						
						// Constemment pour ce trait —— - -
						NouveauTrait.Boucle = function( event:Event ):void {
						
							// Récupére l'instance de ce trait
							var Cible:* = event.target;
							
							// Redéfinie sa taille
							SetRealScale( Cible , Cible.HauteurInitiale * ( Cible.Taille / 100 ) , "height" );
							
							// Si elle disparait en taille —— - -
							if( Parametres.DisparitionTaille ){
								
								// La taille diminue
								Cible.Taille -= Aspiration( Cible.VitesseDisparition ) * 
											  ( Aspiration( Parametres.DisparitionTaille ) / 100 );
								//
								// Si elle a atteint zéro, le trait est annihilé
								if( Cible.Taille <= 0 ){ DestroyElement( Cible );	}
							}
							
							// Si elle disparait en alpha —— - -
							if( Parametres.DisparitionAlpha ){
								
								// L'alpha diminue
								Cible.alpha -= ( Aspiration( Cible.VitesseDisparition ) * 
											   ( Aspiration( Parametres.DisparitionAlpha ) / 100 ) ) / 100;
								//
								// Si elle a atteint zéro, le trait est annihilé
								if( Cible.alpha <= 0 ){ DestroyElement( Cible );	}
							}
						}
						
						// Donne l'événement de boucle au trait
						AddEvents( NouveauTrait , NouveauTrait.Boucle , "ENTER_FRAME" );
					}
				}
				
				// Mémorise la position de la cible
				CetObjetAlchimie.MemoX = CetteCible.x;
				CetObjetAlchimie.MemoY = CetteCible.y;
			}
			
			// Donne l'événement de boucle retinal à la cible
			AddEvents( Cible , ObjetAlchimie.Boucle , "ENTER_FRAME" );
			
			// Retourne l'objet d'alchimie
			return ObjetAlchimie;
		}
		
		
		// —————— RAIN
		// Fait pleuvoir des particules
		//
		// ¤VorteX Compatible¤

		public function Rain( Element:* ,						// ¤¤—— - - L'élément pris de la bibliothèque
							  Conteneur:* ,						// ¤¤—— - - Le conteneur de la pluie
							  Parametres:Object = null ,		// ¤¤—— - - Les paramètres additifs
							  Nom:String = "" ,					// ———— - - Une partie du nom donnée à l'objet de pluie
							  Bump:Object = null ,				// ¤¤—— - - La zone concernés entre Gauche et Droite, Haut et Bas
							  Obstacles:Array = null ,			// ———— - - Les obstacles à la pluie
							  FonctionBoucle:Object = null		// ———— - - Fonction boucle des gouttes
							  ):void {
			/*—*/
			
			// Arguments par défaut
			//
			// No par défaut
			Nom = ( Nom != "" ) ? Nom : "Rain" + RandomWord();
			//
			// Objets & Tableaux par défaut
			Bump = Bump || new Object(); 
			Parametres = Parametres || new Object();
			Obstacles = Obstacles || new Array();
			FonctionBoucle = FonctionBoucle || new Object();
			//
			var Vent:* = 	Parametres.Vent 	|| 10;
			var Densité:* = Parametres.Densité 	|| 3;
			var Gravité:* = Parametres.Gravité 	|| 20;
			
			// Créait l'objet de pluie
			var NouveauRain:Object = Conteneur[ Nom ] = new Object();
			
			// Donne les paramètres à l'objet de pluie
			//
			// Physique
			NouveauRain.Vent = Vent;
			NouveauRain.Gravité = Gravité;
			NouveauRain.GravitéMax = Parametres.GravitéMax || NouveauRain.Gravité;
			NouveauRain.Densité = Densité;
			//
			// Clips
			NouveauRain.Conteneur = Conteneur;
			NouveauRain.Element = Element;
			//
			// Bump
			NouveauRain.Droite = Bump.Droite || 500;
			NouveauRain.Gauche = Bump.Gauche || 0;
			NouveauRain.Haut = Bump.Haut || 0;
			NouveauRain.Bas = Bump.Bas || 500;
			//
			// Manipulation
			NouveauRain.Inflection = Parametres.Inflection || 0;
			NouveauRain.Rebond = Parametres.Rebond || 1;
			NouveauRain.RebondDisparait = Parametres.RebondDisparait || 1;
			//
			// Liaison
			NouveauRain.Mouse = Parametres.Mouse;
			//
			// Etats partiulier
			NouveauRain.Flocon = Parametres.Flocon || 0;
			//
			// Obstacles
			NouveauRain.Obstacles = Obstacles;
			//
			// Fonctions
			NouveauRain.FonctionBoucle = FonctionBoucle;
			
			// Calibrage de la densité en fonction de sa valeur par rapport à zéro —— - -
			//
			// Si elle est inférieur à zéro —— - -
			if( NouveauRain.Densité < 0 ){
				
				// Place un palier de densité de valeur positive relative à la densité
				NouveauRain.PalierDensité = -NouveauRain.Densité;
				NouveauRain.Palier = NouveauRain.PalierDensité;
				
				// Mes la densité à 1
				NouveauRain.Densité = 1;
			
			// Si elle est supérieur à zéro —— - -
			} else {
				
				// Définit un palier de densité à zéro
				NouveauRain.PalierDensité = 0;
				NouveauRain.Palier = 0;
			}
			
			// Donne la boucle de création de goutte —— - -
			NouveauRain.Boucle = function( event:Event ):void {
				
				// Récupère l'instance du conteiner de pluie et objet pluie
				var Cible:* = event.target;
				var Pluie:Object = Cible[ Nom ];
				
				// Si le palier de pluie est tombé à zéro —— - -
				if( Pluie.Palier == 0 ){
					
					// Ré-aspire la densité
					var laDensité:int = Aspiration( Pluie.Densité );
					
					// Pour chaque goutte à créer —— - -
					for( var i:int = 0 ; i < laDensité ; i++ ){
						
						// Créait une goutte
						var Goutte:* = NewElement( Pluie.Element , Cible , "Goutte" + RandomWord() + i );
						
						// Positionne aléatoirement la goutte sur sa ligne de bump plus un léger décalage pour éviter l'effet de grille
						Goutte.x = Random( Aspiration( Pluie.Gauche ) , Aspiration( Pluie.Droite ) ) + Random( -2 , 2 );
						Goutte.y = Aspiration( Pluie.Haut ) + Random( -2 , 2 );
						
						// Donne une inflection résultant de la valeur d'inflection en aléatoire sur elle
	
						Goutte.Inflection = Random( Aspiration( Pluie.Inflection ) , 0 )
						
						// Donne les paramètres physique à la goutte
						Goutte.Vent = Aspiration( Pluie.Vent );
						Goutte.Gravité = Aspiration( Pluie.Gravité );
						Goutte.GravitéMax = Aspiration( Pluie.GravitéMax );
						
						// Donne les paramètres de rebond à la goutte
						Goutte.Rebond = Aspiration( Pluie.Rebond );
						Goutte.RebondDisparait = Aspiration( Pluie.RebondDisparait );
						
						// Particularité
						Goutte.Flocon = Pluie.Flocon;
						Goutte.VitesseFlocon = 0;
						
						// Donne l'instance du sol à la goutte
						Goutte.Sol = Aspiration( Pluie.Bas );
						
						// Donne l'instances des obstacles
						Goutte.Obstacles = Pluie.Obstacles;
						
						// Donne le lien à son parent
						Goutte.Parent = Pluie;
						
						// Donne l'instances des Fonctions
						//
						var ActualFonctionCible:* = Pluie.FonctionBoucle.Cible;
						Goutte.FonctionBoucle = CloneObject( Pluie.FonctionBoucle );
						Goutte.FonctionBoucle.Cible = ActualFonctionCible
						//
						// En le prenant dans les arguments
						if( Goutte.FonctionBoucle.Argument ){ Goutte.FonctionBoucle.Argument.Cible = Goutte; }
						else { Goutte.FonctionBoucle.Argument = { Cible:Goutte }; }
						
						// Donne la boucle à la goutte —— - -
						Goutte.Boucle = function( event:Event ):void {
							
							// Récupére l'instance de la goutte
							var CibleGoutte:* = event.target;
							
							// La goutte tombe et bouge selon son vent et sa gravité
							CibleGoutte.y += Aspiration( CibleGoutte.Gravité );
							CibleGoutte.x += Aspiration( CibleGoutte.Vent ) + 
											 Aspiration( CibleGoutte.Inflection ) + 
											 Aspiration( CibleGoutte.VitesseFlocon );
							//
							// Si son vent est différent du parent et que c'est un flocon —— - -
							if( CibleGoutte.Flocon != 0 && CibleGoutte.Vent != CibleGoutte.Parent.Vent ){
								
								// Il recalibre son vent
								CibleGoutte.Vent = NumberGoTo( CibleGoutte.Vent , CibleGoutte.Parent.Vent , 30 , 0.1 );
							}
							
							// Modifie sa vitesse flocon
							CibleGoutte.VitesseFlocon += Random( CibleGoutte.Flocon , 0 );
							CibleGoutte.VitesseFlocon *= 0.95;
							
							// Si la gravité de la goutte n'a pas atteint son max —— - - elle augmente
							if( CibleGoutte.Gravité < CibleGoutte.GravitéMax ){	CibleGoutte.Gravité++; }
							//
							// Si elle est supérieur au max et qu'il est un flocon —— - - elle réduit
							if( CibleGoutte.Gravité > CibleGoutte.GravitéMax && CibleGoutte.Flocon != 0 ){ CibleGoutte.Gravité--; }
							
							// Si la goutte atteint le sol —— - - elle est détruite 
							if( CibleGoutte.y > Aspiration( CibleGoutte.Sol ) ){ CibleGoutte.Detruit(); }
							
							// Pour chaque obstacles —— - -
							for( var j:int = 0 ; j < CibleGoutte.Obstacles.length ; j++ ){
								
								// Si la goutte le touche —— - -
								if( CibleGoutte.Obstacles[ j ].hitTestPoint( CibleGoutte.x , CibleGoutte.y ) ){
														
									// Si la goutte n'est pas sous l'obstacles —— - - Elle est détruite
									if( CibleGoutte.y - CibleGoutte.Gravité < CibleGoutte.Obstacles[ j ].y ){ CibleGoutte.Detruit(); }
									//
									// Sinon —— - - Elle rebondit juste en horizontale
									else { CibleGoutte.Vent = -CibleGoutte.Vent; }
								}
							}
							
							// Lance sa fonction s'il en a
							if( CibleGoutte.FonctionBoucle.Fonction ){ Launch( CibleGoutte.FonctionBoucle ) };
						}
						//
						// Donne à la goutte sa fonction de destruction —— - -
						Goutte.Detruit = function( Sol:Boolean = false ):void {
							
							// Si la goutte n'est pas déjà détruite —— - -
							if( !this.EstDetruit ){
									
								// La goutte est détruite
								this.EstDetruit = true;
									
								// Si la goutte a un rebond de zéro —— - - Elle est immédiatement détruite
								if( Goutte.Rebond == 0 ){ DestroyElement( this );	} 
								//
								// Sinon —— - - 
								else { 
									
									// S'il y a un sol —— - - Elle se place sur le sol
									if( Sol ){ this.y = Goutte.Sol; }
									
									// Elle lance une disparition en alpha
									Disappear( this , "Alpha" + this.RebondDisparait );
									
									// Elle rebondit en verticale
									this.Gravité = -this.Gravité / this.Rebond;
								}
							}
						}
						//
						// Donne à la goutte son événement de boucle
						AddEvents( Goutte , Goutte.Boucle , "ENTER_FRAME" );
						
						
						// Si on a donné l'instance de la MousePort —— - -
						if( Pluie.Mouse ){
							
							// Lui donne l'instance de la MousePort
							Goutte.Mouse = Pluie.Mouse;
							
							// Lui donne la boucle de manipulation souris —— - -
							Goutte.ManipulationSouris = function( event:Event ){ 
							
								// Récupère l'instance de la goutte
								var Element:* = event.target;
								
								// Si la souris est proche de la goutte —— - -
								if( Element.Mouse.LocalX( Element ) < 100 && Element.Mouse.LocalX( Element ) > -100
								 && Element.Mouse.LocalY( Element ) < 100 && Element.Mouse.LocalY( Element ) > -100 
								){ 
									// Modifie son vent et sa gravité en fonction de la vitesse souris
									Element.Vent += ( Element.Mouse.VitesseX / 10 ) * ( 1 - ( Math.abs( Element.Mouse.LocalX( Element ) ) / 100 ) ); 
									Element.Gravité += ( Element.Mouse.VitesseY / 5 ) * ( 1 - ( Math.abs( Element.Mouse.LocalY( Element ) ) / 100 ) ); 
								}
							}
							//
							// Donne à la goutte son événement de boucle
							AddEvents( Goutte , Goutte.ManipulationSouris , "ENTER_FRAME" );
						}
					}
					
					// Remet le palier de pluie au max
					Pluie.Palier = Pluie.PalierDensité;
					
				// Si le palier n'a pas atteint zéro —— - - Il réduit
				} else { Pluie.Palier--; }
			}
			//
			// Donne au conteneur son événement de boucle
			AddEvents( Conteneur , NouveauRain.Boucle , "ENTER_FRAME" );
		}
		
		
		
		/* —————————————————————————————————————————— - - APPLY - - —————————————————————————————————————————— */
		// Méthode appliquant des effets de particules
		//*—*//
		
		// —————— DISPATCH
		// Répartie un ensemble de particule de façon aléatoire dans une zone
		//
		//	¤VorteX Compatible¤
	
	  	public function Dispatch(  Element:* ,						// ¤¤—— - - L'élément dans la bibliothèque
								   Cible:* ,						// ¤¤—— - - Le container
								   Etat:Object = null ,				// ¤¤—— - - L'état des éléments
								   Largeur:* = 500 ,				// ¤¤—— - - Largeur de dispatching
								   Hauteur:* = 500 ,				// ¤¤—— - - Hauteur de dispatching
								   Densite:* = 10 ,					// ¤¤—— - - Densité des étoiles
								   Nom:String = "Dispatch" ,		// ———— - - Le début du nom à leur donner
								   Zone:* = null ,					// ———— - - Si les éléments ne doivent être que sur une zone particulière
								   ContreZone:* = null ,			// ———— - - Si les élémeents ne doivent pas être sur une zone particulière
								   Parametres:* = null				// ———— - - Les paramètres supplémentaires
								 ):Array {
			/*—*/
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			Parametres.InitialX = Parametres.InitialX || 0;
			Parametres.InitialY = Parametres.InitialY || 0;
			//
			Parametres.Empilable = ( Parametres.Empilable == null ) ? true : Parametres.Empilable;
			
			// Aspire la largeur et la hauteur
			Largeur = Math.round( Aspiration( Largeur ) );
			Hauteur = Math.round( Aspiration( Hauteur ) );
			
			// Aspire la Densité
			Densite = Aspiration( Densite );
			
			// Tableau des élements créés
			var Sortie:Array = new Array();
			
			// Pour toute la largeur —— - -
			for( var i:int = Parametres.InitialX ; i < Largeur ; i += 10 ){
				
				// Pour toute la hauteur —— - -
				for( var j:int = Parametres.InitialY ; j < Hauteur ; j += 10 ){
					
					// Levier d'activation
					var Levier:Boolean = true;
					
					// S'il y a une zone —— - -
					if( Zone ){
						
						// S'il n'est pas compris dans la zone —— - -
						if( !Zone.hitTestPoint( i , j , true ) ){
							
							// Désactive le levier
							Levier = false;
						}
					}
					
					// Si le levier est activé —— - -
					if( Levier ){
						
						// Aléatoirement selon la densité —— - -
						if( Random( 0 , 1000 , true ) <= Math.round( Aspiration( Densite ) ) ){
							
							// Clone l'état
							var SonEtat:Object = CloneObject( Etat ) || new Object();
							//
							// Lui ajoute la position
							SonEtat.x = i ; SonEtat.y = j ;
							
							// Ajoute l'élément dans la position
							var leNouvelElement:* = NewElement( Element , Cible , Nom + i + j , SonEtat );

							// S'il a une contre-zone —— - -
							if( ContreZone ){
								
								// S'il touche la contre-zone —— - -
								if( ContreZone.hitTestPoint( i , j , true ) ){
									
									// L'élément est détruit
									DestroyElement( leNouvelElement );
								}
							}

							// S'il n'est pas empilable —— - -
							if( leNouvelElement && !Parametres.Empilable ){
								
								// Pour chaque éléments précédemment créé —— - -
								for( var k:int = 0 ; k < Sortie.length ; k++ ){
									
									// S'il le touche —— - -
									if( Sortie[ k ].hitTestObject( leNouvelElement ) ){
										
										// L'élément est détruit
										try{ DestroyElement( leNouvelElement ); } catch( e ){}
										
										// Fin de la boucle
										k = Sortie.length;
									}
								}
							}
							
							// S'il est toujours là —— - - L'ajoute au tableau des éléments créés
							if( leNouvelElement ){ Sortie.push( leNouvelElement ); }
						}
					}
				}
			}
			
			// Retourne la liste des éléments créés
			return Sortie;
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				 	 LINE					  		  				  	  */
		/*						  Méthodes pour générer des effets visuels à partir de traits 					  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - CONSTANT - - —————————————————————————————————————————— */
		// Méthode appliquant des effets de traits de façon constante
		//*—*//
		
		// —————— RETINAL
		// Fait apparaître des traits qui disparaissent pour former une ligne qui s'évaporent apparaissant sur un objet
		//
		// ¤VorteX Compatible¤
	
	  	public function Retinal( Cible:* ,						// ———— - - La cible central pour l'apparition de l'effet
								 Conteneur:* = null ,			// ———— - -	Le conteneur de l'effet
								 Parametres:Object = null ,		// ¤¤—— - - Les Parametres additifs
								 Nom:String = "" ,				// ———— - - Le nom de l'effet retinal en cas de cumul
								 QualiteMinimal:String = ""		// ———— - - La qualité minimal de l'effet
								):Object {
			/*—*/
			
			// Le conteneur est, par défaut, le parent de la cible
			Conteneur = Conteneur || Cible.parent;
			Parametres = Parametres || new Object();
			//
			var Couleur:* = 			Parametres.Couleur 				|| "FFFFFF";
			var Taille:* = 				Parametres.Taille 				|| 10;
			var VitesseDisparition:* = 	Parametres.VitesseDisparition 	|| 10;
			
			// Création de l'objet Retinal
			var ObjetRetinal:Object = Cible[ "Retinal" + Nom ] = new Object();
			
			// Création des variables de mémoires du positionnement de la cible
			ObjetRetinal.MemoX = Cible.x;
			ObjetRetinal.MemoY = Cible.y;
			
			// Création du numéro pour les traits (Afin que la destruction se fasse correctement)
			ObjetRetinal.Numero = 0;
			
			// Donne les arguments à la cible
			ObjetRetinal.Couleur = Couleur;
			ObjetRetinal.Taille = Taille;
			ObjetRetinal.VitesseDisparition = VitesseDisparition;
			ObjetRetinal.Parametres = Parametres;
			
			
			// S'il y a une demande de qualité minimale —— - -
			if( SetDefault( QualiteMinimal ) ){
				
				// S'il n'y a pas de lien à la OptimizeTools —— - - Retourne l'erreur
				if( !Optimize ){
					TraceError( "FxTools" , "Retinal" , 
							   [ "Une demande de qualité minimale a été faites pour cet effet alors qu'aucun lien vers la OptimizeTools" ,
							   "n'a été donné. Pour pouvoir demandé une qualité minimal à un effet de la FxTools, il faut donner" ,
							   "l'instance de la FxTools à son initialisation :" ,
							   "Exemple : var Fx:FxTools = new FxTools( Optimize );"
							  ] );
				
				// S'il y a le lien —— - -
				} else {
					
					// Si la qualité existe —— - -
					if( Optimize.GetQuality( QualiteMinimal ) != -1 ){
					
						// Donne le lien à la cible
						ObjetRetinal.Optimize = Optimize;
						//
						// Donne la qualité ( Numérique ) à la cible
						ObjetRetinal.QualiteMinimal = Optimize.GetQuality( QualiteMinimal );
					
					
					// Si la qualité n'existe pas —— - - trace l'erreur
					} else {
						TraceError( "FxTools" , "Retinal" , [ "La qualité " + QualiteMinimal + " n'éxiste pas." , Optimize.TellMeQuality() ] );
					}
				}
			}
			
			
			
			// Constement pour la cible —— - -
			ObjetRetinal.Boucle = function( event:Event ):void {
				/**/
				
				// Récupére l'instance de la cible
				var CetteCible:* = event.target;
				
				// Récupère l'instance de l'objet Retinal
				var CetObjetRetinal:Object = CetteCible[ "Retinal" + Nom ];
				
				
				// S'il n'a pas de lien vers Optimize ou que la qualité est suffisante —— - -
				if( !CetObjetRetinal.Optimize || Optimize.QualityNumero >= CetObjetRetinal.QualiteMinimal ){
				   
					// S'il n'a pas de Maximal ou si son maximal est dans la norme —— - -
					if( !CetObjetRetinal.Parametres.TailleMax || 
					   GetDistance( { x:CetObjetRetinal.MemoX + ( CetObjetRetinal.Parametres.x || 0 ) ,
									  y:CetObjetRetinal.MemoY + ( CetObjetRetinal.Parametres.y || 0 ) } , 
									{ x:CetteCible.x + ( CetObjetRetinal.Parametres.x || 0 ) ,
									  y:CetteCible.y + ( CetObjetRetinal.Parametres.y || 0 ) } ) < 
									CetObjetRetinal.Parametres.TailleMax ){
						
						// Créait un nouveau trait
						var NouveauTrait:MovieClip = NewElement( MovieClip , Conteneur , "NouveauTrait" + Nom + CetObjetRetinal.Numero );
						var Trait:Shape = new Shape;
						//
						// Affiche le nouveau trait
						NouveauTrait.addChild( Trait );
						
						// Donne au trait son nom puis augmente le numéro de 1
						CetObjetRetinal.Numero++;
						
						// Récupére l'instance du trait
						NouveauTrait.Trait = Trait;
						
						// Récupére les valeurs d'arguments
						NouveauTrait.Numero = CetObjetRetinal.Numero - 1;
						NouveauTrait.Taille = Aspiration( CetObjetRetinal.Taille );
						NouveauTrait.Couleur = Aspiration( CetObjetRetinal.Couleur );
						NouveauTrait.Alpha = 100;
						NouveauTrait.VitesseDisparition = Aspiration( CetObjetRetinal.VitesseDisparition );
						//
						NouveauTrait.Parametres = CetObjetRetinal.Parametres;
						
						// Récupére l'ancienne et la nouvelle position
						NouveauTrait.DX = CetObjetRetinal.MemoX + ( CetObjetRetinal.Parametres.x || 0 );
						NouveauTrait.DY = CetObjetRetinal.MemoY + ( CetObjetRetinal.Parametres.y || 0 );
						NouveauTrait.FX = CetteCible.x + ( CetObjetRetinal.Parametres.x || 0 );
						NouveauTrait.FY = CetteCible.y + ( CetObjetRetinal.Parametres.y || 0 );
						
						// Constemment pour ce trait —— - -
						NouveauTrait.Boucle = function( event:Event ):void {
							
							// Récupére l'instance de ce trait
							var Cible:* = event.target;
							
							// Efface le trait
							Cible.Trait.graphics.clear();
							//
							// Définie le style de ligne
							Cible.Trait.graphics.lineStyle( Cible.Taille , 
														    TypeOf( Cible.Couleur , "String" ) ? "0x" + Cible.Couleur : Cible.Couleur ,
															Cible.Alpha / 100 );
							//
							// Dessine du premier point...
							Cible.Trait.graphics.moveTo( Cible.DX , Cible.DY );
							//
							// ...jusqu'au second point
							Cible.Trait.graphics.lineTo( Cible.FX , Cible.FY );
							
							// Evolution de la taille et alpha s'il y a
							Cible.Taille += Aspiration( Cible.Parametres.Taille , 0 );
							Cible.Alpha -= Aspiration( Cible.Parametres.Alpha , 0 );
							
							// Mouvement des points par Déplacement s'il y en a
							Cible.DX += Aspiration( Cible.Parametres.DeplacementDX , 0 );
							Cible.DY += Aspiration( Cible.Parametres.DeplacementDY , 0 );
							//
							Cible.DX += Aspiration( Cible.Parametres.DeplacementFX , 0 );
							Cible.FY += Aspiration( Cible.Parametres.DeplacementFY , 0 );
							
							// Mouvement des points par Déplacement lié s'il y en a
							//
							if( Cible.Parametres.DeplacementLieDX || Cible.Parametres.DeplacementLieDY ){
								
								// Récupère les variables
								var DeplacementLieDX:Number = Aspiration( Cible.Parametres.DeplacementLieDX );
								var DeplacementLieDY:Number = Aspiration( Cible.Parametres.DeplacementLieDY );
								
								// Déplacement des points de ce trait
								Cible.DX += DeplacementLieDX;
								Cible.DY += DeplacementLieDY;
								
								// S'il a un prédécesseur —— - -
								if( Cible.parent[ "NouveauTrait" + ( Cible.Numero - 1 ) ] ){
									
									// Récupère le prédecesseur
									var Precedent:* = Cible.parent[ "NouveauTrait" + ( Cible.Numero - 1 ) ];
									
									// Déplacement des points de ce trait
									Precedent.FX += DeplacementLieDX;
									Precedent.FY += DeplacementLieDY;
								}
							}
							
							// La taille diminue
							Cible.Taille -= Cible.VitesseDisparition / 10;
							//
							// Si elle a atteint zéro, le trait est annihilé
							if( Cible.Taille <= 0 ){ DestroyElement( Cible );	}
						}
						
						// Donne l'événement de boucle au trait
						AddEvents( NouveauTrait , NouveauTrait.Boucle , "ENTER_FRAME" );
					}
				}
				
				// Mémorise la position de la cible
				CetObjetRetinal.MemoX = CetteCible.x;
				CetObjetRetinal.MemoY = CetteCible.y;
			}
			
			// Donne l'événement de boucle retinal à la cible
			AddEvents( Cible , ObjetRetinal.Boucle , "ENTER_FRAME" );
			
			// Retourne l'objet
			return ObjetRetinal;
		}
		
		
		
	
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}