﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			MODEL CHIP	  			Version 0.3.0									***/
/***				   				   Dernière Mise à Jour : 10-08-14										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         				  Intelligence Forme											***/
/***	Ce script forme un clip pour qu'il puisse être paramètrable par le biais d'une fonction externe.    ***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Visual {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	
	// —— - - DISPLAY
	import flash.display.MovieClip;
	//
	// —— - - EVENT
	import flash.events.Event;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class ModelChip extends MiscTools {
		
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		// —————— ELEMENT
	    // L'élément auquel le script est rattaché
		var Element:*;
		
		
		// —————— CONVERSION FR
	    // Objet de conversion des textes Fr en En
		var ConversionFr:Object = { Largeur:"Width" ,
									Hauteur:"Heigth" ,
									Teinte:"Tint" ,
									Taille:"Size" ,
									Image:"Frame" ,
									Couleur:"Color" ,
									Caché:"Hide"
								  };
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function ModelChip():void { 
			/*—*/
			
			// Établie la connexion
			Connexion( this );
			
			// Récupération de l'élément
			Element = this; 
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				MODELISATION					  		  				  */
		/*						   Méthodes permettant de paramétrer la forme de l'élément 					  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - GLOBAL - - —————————————————————————————————————————— */
		// Les méthodes générales utilisés en externe pour paramétrer l'élément
		//*—*//
		
		// —————— MODEL
	    // Paramètre les éléments contenues dans le clip
	
		public function Model( Parametre:* 	// ———— - - La Parametres transmis
							 ):void {
			/*—*/
			
			// Si le Parametre envoyé n'est pas un objet —— - -
			if( !TypeOf( Parametre , "Object" ) ){
			
				// Donne un rapport d'erreur
				TraceError( "ModelChip" , "Parametrage" , [ "L'appel au parametrage pour l'élément \"" 
														   + GetIn( GetIn( String( this ) , "[object " , 2 ) , "]" , 1 ) 
														   + "\" doit être fait sous forme d'objet." ,
															 "Exemple : Element.Parametrage({ Test:... , etc. })." ,
															 "Ne pas oublier les accolades dans les parenthèses."
															] );
			
			// Si le Parametre envoyé est un objet —— - -
			} else {
			
				// Pour chaque clé du paramètre —— - -
				for( var Key in Parametre ){
					
					// Instance de l'élément
					var lElement:*;
					
					// Si son élément existe —— - - Le récupère
					if( Element[ Key ] ){ lElement = Element[ Key ]; }
						
					// Si son élément n'existe pas —— - - Recherche l'élément
					else { lElement = SearchClip( Key ); }
					
					// Si l'élément existe —— - -
					if( lElement ){
						
						// Si la clé est un string —— - -
						if( TypeOf( Parametre[ Key ] , "String" ) ){
							
							// Retire tout le contenu
							var Contenu:Array = Parametre[ Key ].split( " ; " );
							
							// Pour chaque modif —— - -
							for( var k:int = 0 ; k < Contenu.length ; k++ ){
								
								// Procéde à la conversion de language de la modification
								var Modif:String = Contenu[ k ].split( " " )[ 0 ];
								//
								if( ConversionFr[ Modif ] ){ Modif = ConversionFr[ Modif ]; }
								
								// Si la fonction existe —— - -
								if( this[ Modif ] ){
									
									// Lance le traitement par cette fonction
									this[ Modif ]( lElement , Contenu[ k ].split( " " )[ 1 ] );
								
								// Si la fonction n'existe pas —— - -
								} else {
									//
									// Trace l'erreur
									TraceError( "ModelChip" , "Model" , [ "Pour l'élément " + this.name + " la méthode " , 
																				  Contenu[ k ].split( " " )[ 0 ] + "n'existe pas." ] );
								}
							}
						
						// Si la clé n'est pas un string —— - -
						} else {
							//
							// Trace l'erreur
							TraceError( "ModelChip" , "Model" , "Pour l'élément " + this.name + " la clé " + Key + "doit être un string uniquement." );
						}
					
					// Si l'élément n'existe pas —— - - Trace l'erreur
					} else {
						//
						TraceError( "ModelChip" , "Model" , [ "L'élément nommé «" + Key + "» est introuvable." , 
																	  "Il se peut qu'il soit mal orthographié." , 
																	  "Utilisez la méthode DisMoi() du clip pour connaitre le nom des clips qu'il contient." ] );
					}
				}
			}
		}
		
		
		// —————— SEARCH CLIP
	    // Cherche un clip dans les sous-clips
	
		private function SearchClip( Nom:String ,	// ———— - - Le Nom du clip à trouver
									 Clip:* = null	// ———— - - Le Clip en cours de recherche
								   ):* {
			/*—*/
			
			// Clip par défaut
			Clip = Clip || this;
			
			// Pour chaque enfant du clip —— - -
			for( var i:int = 0 ; i < Clip.numChildren ; i++ ){
				
				// S'il porte le nom voulu —— - -
				if( Clip.getChildAt( i ).name == Nom ){
					//
					// Le retourne
					return Clip.getChildAt( i );
				}
			}
			
			// S'il n'a rien trouvé
			//
			// Créait la variable de sortie
			var Sortie:*;
			
			// Pour chaque enfant du clip —— - -
			for( var j:int = 0 ; j < Clip.numChildren ; j++ ){
				
				// Sonde l'enfant pour en retirer une sortie
				try{ Sortie = SearchClip( Nom , Clip.getChildAt( j ) ); } catch( e ){}
				
				// S'il a trouvé quelque chose —— - - Le renvoie
				if( Sortie ){ return Sortie; }
			}
			
			// S'il n'a rien trouvé —— - - Renvoie null
			return null;
		}
		
		
		
		/* —————————————————————————————————————————— - - SHAPE - - —————————————————————————————————————————— */
		// Les méthodes en interne pour modifier la forme de l'élément
		//*—*//
		
		// —————— ROTATION
	    // L'élément tourne
	
		public function Rotation( Element:* , 	// ———— - - L'Élément concerné
								  Valeur:String // ———— - - La valeur donnée
								 ):void {
			/*—*/
			
			// Applique la modification
			Element.rotation = Number( Aspiration( Valeur ) );
		}
		
		
		// —————— WIDTH
	    // L'élément modifie sa largeur
	
		public function Width( Element:* , 		// ———— - - L'Élément concerné
							   Valeur:String 	// ———— - - La valeur donnée
							  ):void {
			/*-*/
			
			// Applique la modification
			Element.width = Number( Aspiration( Valeur ) );
		}
		
		
		// —————— HEIGHT
	    // L'élément modifie sa hauteur
	
		public function Height( Element:* , 	// ———— - - L'Élément concerné
							    Valeur:String 	// ———— - - La valeur donnée
							  ):void {
			/*—*/
			
			// Applique la modification
			Element.height = Number( Aspiration( Valeur ) );
		}
		
		
		// —————— SIZE
	    // L'élément modifie sa taille
	
		public function Taille( Element:* , 	// ———— - - L'Élément concerné
								Valeur:String 	// ———— - - La valeur donnée
							   ):void {
			/*—*/
			
			// Applique la modification
			Element.width *= Number( Valeur );
			Element.height *= Number( Valeur );
		}
		
		
		
		/* —————————————————————————————————————————— - - BLEND - - —————————————————————————————————————————— */
		// Les méthodes en interne pour modifier les couches, la visibilité et les couleurs de l'élément
		//*—*//
		
		// —————— ALPHA
	    // L'élément modifie son opacité
	
		public function Alpha( Element:* , 		// ———— - - L'Élément concerné
							   Valeur:String 	// ———— - - La valeur donnée
							 ):void {
			/*—*/
			
			// Applique la modification
			Element.alpha = Number( Aspiration( Valeur ) );
		}
		
		
		// —————— HIDE
	    // L'élément est invisible
	
		public function Hide( Element:* , 		// ———— - - L'Élément concerné
							  Valeur:* = ""    // ———— - - La valeur donnée
							 ):void {
			/*—*/
			
			// Arguments par défaut
			Valeur = Valeur || "" ;
			
			// Aspiration
			Valeur = Aspiration( Valeur );
			
			// Applique la modification
			Element.visible = TypeOf( Valeur , "Boolean" ) ? Valeur : ( Valeur != 0 );
		}
		
		
		// —————— TINT
	    // Colorie entiérement l'élément
	
		public function Tint( Element:* ,   // ———— - - L'Élément concerné
							  Valeur:* 	 	// ———— - - La valeur donnée
							 ):void {
			/*—*/
			
			// Si la couleur contient une notion d'aléatoire —— - -
			if( FindIn( Valeur , "," ) ){
				
				// Convertie la couleur
				var Puissance:Number = Number( GetIn( Valeur , "," , 2 ) );
				Valeur = GetIn( Valeur , "," , 1 );

				// Applique la couleur
				SetColor( Element , Aspiration( Valeur ) ); 
				//
				// Applique le random near color 
				SetNearColor( Element , Puissance );
				
			// Si la couleur ne contient rien de spécifique —— - -
			} else {
				
				// Applique la couleur
				SetColor( Element , Aspiration( Valeur ) ); 
			}
		}
		
		
		// —————— COLOR
	    // Colorie l'élément de façon complexe
	
		public function Color( Element:* ,	// ———— - - L'élément concerné
							   Valeur:* 	// ———— - - La valeur donnée
							  ):void {
			/*—*/
			
			// Récupère la couleur
			var Couleur:String = Aspiration( Valeur );
			
			// Si un élément nommé "Corps" se trouve dans l'élément —— - -
			if( Element.Corps ){
				
				// Applique la couleur initiale à cet élément
				SetColor( Element.Corps , Couleur );
				//
				// Pour chaque éléments dans l'élément premier —— - -
				for( var Ele:int = 0 ; Ele < Element.numChildren ; Ele++ ){
					
					// S'il contient "Ombre" —— - -
					if( FindIn( Element.getChildAt( Ele ).name , "Ombre" ) ){
					
						// Récupère la valeur d'assombrissement
						var ValeurAssombrie:* = Number( Valeur.split( "," )[ Valeur.split( "," ).length - 1 ] );
						//
						ValeurAssombrie = ( isNaN( ValeurAssombrie ) ) ? Number( Pop( Element.getChildAt( Ele ).name , "Ombre" ) ) : ValeurAssombrie;
						//
						ValeurAssombrie = ( isNaN( ValeurAssombrie ) || ValeurAssombrie == 0 ) ? 30 : ValeurAssombrie;
						
						// Applique la couleur initiale
						SetColor( Element.getChildAt( Ele ) , Couleur ); 
						//
						// Assombrie la couleur d'autant que le chiffre suivant
						SetDarkerColor( Element.getChildAt( Ele ) , ValeurAssombrie );
					}
					
					// S'il contient "Reflet" —— - -
					if( FindIn( Element.getChildAt( Ele ).name , "Reflet" ) ){
					
						// Récupère la valeur d'éclaircissement
						var ValeurEclaircie:* = Number( Valeur.split( "," )[ Valeur.split( "," ).length - 1 ] );
						//
						ValeurEclaircie = ( isNaN( ValeurEclaircie ) ) ? Number( Pop( Element.getChildAt( Ele ).name , "Reflet" ) ) : ValeurEclaircie;
						//
						ValeurEclaircie = ( isNaN( ValeurEclaircie ) || ValeurEclaircie == 0 ) ? 30 : ValeurEclaircie;
						
						// Applique la couleur initiale
						SetColor( Element.getChildAt( Ele ) , Couleur ); 
						//
						// Eclaircie la couleur d'autant que le chiffre suivant
						SetClearerColor( Element.getChildAt( Ele ) , ValeurEclaircie );
					}
				}
				
			// Si aucun élément nommé "Corps" ne se trouve dans l'élément —— - - Trace l'erreur
			} else {
				//
				TraceError( "ModelChip" , "Color" , [ "Une demande d'application de Couleur a été donné pour « " + Element.name + " »" ,
													   "mais, pour cela, l'élément doit contenir au moins un élément nommé « Corps »." ] );
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - ANIMATION - - —————————————————————————————————————————— */
		// Les méthodes en interne pour modifier la tête de lecture de l'élément
		//*—*//
		
		// —————— FRAME
	    // L'élément modifie sa frame en cour
	
		public function Frame( Element:* , 		// ———— - - L'élément concerné
							   Valeur:String	// ———— - - La valeur donnée
							 ):void {
			/*—*/
			
			// Applique la modification
			Element.gotoAndStop( Aspiration( Valeur ) );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					  HELP					  		  				  	  */
		/*						   					Méthodes d'aide générale 					  	  			  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - TRACE - - —————————————————————————————————————————— */
		// Les méthodes pour provoquer des traces
		//*—*//
		
		// —————— TELL ME CONTENT
	    // L'élément énumére les clips qu'il contient
	
		public function TellMeContent( Clip:* = null , 
									   Niveau:int = 0 
									  ):void {
			/*—*/
			
			// Levier de contrôle
			var Levier:Boolean = true;
			
			// Si le clip n'est pas —— - - Prend celui là et bloque le levier
			if( !Clip ){
				//
				Clip = this; 
				Levier = false; 
			}
			
			// Chaine de tabulation
			var Tabulations:String = "";
			//
			// Conçoit la tabulation —— - -
			for( var j:int = 0 ; j < Niveau ; j++ ){
				//
				Tabulations += "\t";
			}
			
			// Récupére son nombre d'éléments
			var Nombre:int = Clip.numChildren;
			
			// Si le levier est ok —— - -
			if( !Levier ){
				
				// Trace le haut
				Trace( "————————————————————————————————————————————————————————————————" );
				Trace( "Pour l'élément \"" + GetIn( GetIn( String( this ) , "[object " , 2 ) , "]" , 1 ) + "\" les éléments contenus sont les suivants : " );
			}
			
			// Pour chaque élément —— - -
			for( var i:int = 0 ; i < Nombre ; i++ ){
				
				// S'il a un nom, trace son nom
				try{ 
					
					// Si le nom ne contient pas "instance" —— - -
					if( Clip.getChildAt( i ).name.split( "instance" ).length == 1 ){ 
						//
						// Le trace
						Trace( Tabulations + Clip.getChildAt( i ).name ); 
						//
						// Poursuis sur lui
						TellMeContent( Clip.getChildAt( i ) , Niveau + 1 );
					}
					
				} catch( e ){}
			}
			
			// Si le levier est ok —— - -
			if( !Levier ){
				
				// Trace le bas
				Trace( "————————————————————————————————————————————————————————————————" );
			}
		}
		
		
		
		
	
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}