﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			OPTIMIZE PROCESS		  Version 0.2.0									***/
/***				   				   Dernière Mise à Jour : 10-09-06										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         				Gestionnaire Affichage											***/
/***	Ce script contient les méthodes permettant d'optimiser l'affichage et les éléments tournant afin    ***/
/***	d'améliorer, la fluidité du rendu et d'éviter que ça lag.										 	***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Visual {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	 
	// —— - - DISPLAY
	import flash.display.MovieClip;
	import flash.display.Loader;
	//
	// —— - - EVENT
	import flash.events.Event;
	//
	// —— - - UTILS
	import flash.utils.*;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class OptimizeProcess extends MiscTools {
		
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		// —————— QUALITY
		// Les valeurs de qualité d'affichage
		private var QualityList:Array = [ "Worst" , "Low" , "Medium" , "High" , "Best" ]; 
		//
		public var QualityNumero:int = 3;
		public var Quality:String = "High";
		
		
		// —————— FPS
		// Les Images par Seconde
		private var FpsIntern:int = 0;
		public var Fps:int = 30;
		
		
		// —————— TIME
		// Les Durée en seconde de lag ou over-clock
		private var TimeLag:int = 0;
		private var TimeOver:int = 0;
		
		
		// —————— TIME MAX
		// Les durées maximales en seconde pour un lag ou un over-clock
		public var TimeLagMax:int = 5;
		public var TimeOverMax:int = 5;
		
		
		// —————— TOLERANCE
		// Les Tolérances en ips avant qu'on conscidére qu'il y a lag ou over-clock
		public var ToleranceLag:int = 15;
		public var ToleranceOver:int = 25;
		
		
		// —————— ACTIVE
		// Si on souhaite que la qualité se recalibre toutes seules quand il y a un contrôle
		public var Active:Boolean = true;
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function OptimizeProcess( TheLink:* = null ,			// ———— - - Lien vers la scène
									 laQualite:String = "" ,	// ———— - - Qualite Initiale
									 Control:Boolean = true		// ———— - - Si on Lance la boucle de contrôle
									):void {
			/*—*/
			
			// Si on a envoyé un lien à la scène —— - -
			if( Connexion( TheLink ) ){ 
				
				// Lance la bi-boucle de contrôle si on l'a demandé
				if( Control ){ LaunchLoop(); }
				
				// S'il y a une demande de Qualité —— - - Bascule la qualité
				if( laQualite != "" ){ QualityChange( laQualite ); }
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 GLOBAL					  		  					  */
		/*									  		Gestion global du script 						  		  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
		
		// —————— GLOBAL LOOP INTERVAL CONTROL
		// La boucle d'intervale
		private var GlobalLoopIntervalControl:uint;
		
		
		
		/* —————————————————————————————————————————— - - LAUNCH - - —————————————————————————————————————————— */
		// Méthodes pour contrôler les gestions globales
		//*—*//
		
		// —————— LAUNCH LOOP
	  	// Lance la double boucle ( Frame et Intervale ) de contrôle
		
		public function LaunchLoop():void {
			/*—*/
			
			// Si le stage n'a pas été récupéré par Scène —— - -
			if( !StageLink ){
				
				// Trace l'erreur
				TraceError( "OptimizeProcess" , "LaunchLoop" , 
							[ "La OptimizeProcess n'a pas récupéré l'instance du stage et ne peut donc pas ajuster la qualité."
						    , "Plutôt que d'utiliser le LaunchLoop(), il est préférable de mettre \"stage\" dans"
							, "l'instance initial du OptimizeProcess." ] );
			
			// Sinon —— - -
			} else {
			
				// Par défaut, la qualité est mis à "High"
				QualityChange( "High" );
				
				// Lance la boucle de frame
				AddEvents( this , GlobalLoop , "ENTER_FRAME" );
				
				// Lance la boucle d'intervale
				GlobalLoopIntervalControl = setInterval( GlobalLoopInterval , 1000 );
			}
		}
	  
	  
	  	// —————— STOP LOOP
	  	// Interrompt la double boucle de contrôle
		
		public function StopLoop():void {
			/*—*/
			
			// Lance la boucle de frame
			RemoveEvents( this , GlobalLoop , "ENTER_FRAME" );
			
			// Lance la boucle d'intervale
			clearInterval( GlobalLoopIntervalControl );
		}
		
		
		
		/* —————————————————————————————————————————— - - LOOP - - —————————————————————————————————————————— */
		// Méthodes provoquées en boucle pour la gestion du script
		//*—*//
		
		// —————— GLOBAL LOOP
	  	// Boucle de contrôle par frame
		
		public function GlobalLoop( event:Event ):void { 
			/*—*/
			
			// Augmente les Ips
			FpsIntern++; 
		}
		
		
		// —————— GLOBAL LOOP INTERVAL
	  	// Boucle de contrôle par intervale
		
		private function GlobalLoopInterval():void {
			/*—*/
			
			// S'il y a eu un changement imprévu de qualité —— - - Trace l'erreur
			if( Quality != "Worst" 
			 && Quality.toLocaleUpperCase() 
			 != StageLink.quality ){
				// 
				TraceError( "OptimizeProcess" , "General" , 
							[ "Attention !" ,
							  "Un changement involontaire de qualité a eut lieu, si aucune demande externe de changement de" ,
							  "qualité n'a été faite, il se peut que deux OptimizeProcess soit en conflit." ,
							  "Si ce message réapparait à plusieurs reprises rapidement, c'est qu'il s'agit, bel et bien," ,
							  "d'un conflit entre deux OptimizeProcess" ] );
			}
			
			// Si les ips sont descendus sous la barre de tolérance lag —— - -
			if( FpsIntern < ToleranceLag ){
				
				// Ajoute au temps de durée du lag
				TimeLag++;
				
				// Si le temps de durée de lag a outrepassé la durée maximal —— - - réduit la qualité
				if( TimeLag >= TimeLagMax && Active ){ QualityChange( "Baisse" ) ; TimeLag = 0 ; }
			
			
			// Si les ips sont au-dessus de la barre de tolérance —— - - Remet le temps de lag à 0
			} else { TimeLag = 0; }
			
			
			// Si les ips sont montés au-dessus la barre de tolérance over-clock —— - -
			if( FpsIntern > ToleranceOver ){
				
				// Ajoute au temps de durée du OverClock
				TimeOver++;
				
				// Si le temps de durée de OverClock a outrepassé la durée maximal —— - - augmente la qualité
				if( TimeOver >= TimeOverMax && Active ){ QualityChange( "Augmente" ) ; TimeOver = 0 ; }
			
			
			// Si les ips sont au-dessous de la barre de tolérance —— - - Remet le temps de OverClock à 0
			} else { TimeOver = 0; }
			
			// Récupère l'ips 
			Fps = FpsIntern;
		
			// Fait basculer l'ips à 0
			FpsIntern = 0;
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					QUALITY					  		  					  */
		/*									 		  Agir sur la qualité 							  			  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - SET - - —————————————————————————————————————————— */
		// Les méthodes pour modifier les valeurs de qualités
		//*—*//
		
	  	// —————— QUALITY CHANGE
	  	// Modifie la qualité de l'affichage
	  
		public function QualityChange( Type:String = "Medium"	// ———— - - La Qualité choisie
									  ):void {
			/*—*/
		  	
			// Si le stage n'a pas été récupéré par Scène —— - - Trace l'erreur
			if( !StageLink ){
				// 
				TraceError( "OptimizeProcess" , "QualityChange" , 
							[ "La OptimizeProcess n'a pas récupéré l'instance du stage et ne peut donc pas ajuster la qualité."
							, "Il est déconseillé d'appliquer un changement de qualiter par un OptimizeProcess autre que celui"
						    , "de la scène globale."
						    , "Si ce OptimizeProcess est celui de la scène globale, vous devez mettre \"stage\" en argument de"
							, "l'instance du OptimizeProcess et, si vous ne voulez pas que la boucle de contrôle tourne, faire"
							, "StopLoop()." ] );
			
			// Sinon —— - -
			} else {
					
				// Convertie la chaîne envoyé pour qu'elle soit compatible
				Type = NameCase( Type );
				
				// Si on demande une baisse —— - -
				if( Type == "Baisse" ){
				  
					// Si la qualité n'est pas déjà au minimum —— - - la réduit
					if( QualityNumero > 0 ){ QualityNumero--; }
					
					// Récupére la qualité reliée
					Type = QualityList[ QualityNumero ];
				
				
				// Si on demande une augmentation —— - -
				} else if( Type == "Augmente" ){
				  
					// Si la qualité n'est pas déjà au maximum —— - - l'augmente
					if( QualityNumero < 4 ){ QualityNumero++; }
					
					// Récupére la qualité reliée
					Type = QualityList[ QualityNumero ];
				  
				
				// Si on la donne directement
				} else {
					
					// Vérifie qu'elle existe, Sinon —— - - Trace l'erreur
					if( !IndexOf( QualityList , Type ) ){
						//
						TraceError( "OptimizeProcess" , "QualityChange" , 
								   [ "La qualités " + Type + " n'existe pas." ,
									 "Les qualités sont : \"Worst\" , \"Low\" , \"Medium\" , \"High\" et \"Best\"."
									] );
						//
						// Type à Medium par défaut
						Type = "Medium";
					
					// S'il n'y a pas d'erreur —— - -
					} else {
						
						// Donne la qualités au numéro
						QualityNumero = QualityList.indexOf( Type )
					}
				}
				
				// Récupére la qualité
				Quality = Type;
				
				// Switch la visibilités des éléments visibles
				SwitchVisibles();
				
				// Switch l'apparence des éléments graphiques
				SwitchGraphics();
				
				// Switch la jouabilités des éléments animés
				SwitchMotions();
				
				// Applique la qualité
				StageLink.quality = ( Quality != "Worst" ) ? Quality : "Low";
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					  TIE					  		  					  */
		/*							Rattacher la qualités à des valeurs sur des éléments 					  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
		
		// ——————  MOTIONS
		// Les éléments animés
		private var Motions:Array = new Array();
		
		// ——————  GRAPHICS
		// Les éléments graphiques
		private var Graphics:Array = new Array();
		
		// ——————  VISIBLES
		// Les éléments visibles
		private var Visibles:Array = new Array();
		
		
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Les méthodes pour attacher des éléments
		//*—*//
	  
	  	// —————— IS VISIBLE
	  	// Définit un élément comme étant visible
	  
		public function IsVisible( Element:* ,		// ———— - - L'Élément graphique ou le tableau d'élément graphique
								   Quality:String	// ———— - - Qualite minimale pour faire apparaître l'élément
								  ):void {
			/*—*/
			
			// Si la qualité n'existe pas —— - - Trace l'erreur
			if( GetQuality( Quality ) == -1 ){
				//
				TraceError( "OptimizeProcess" , "IsVisible" , [ "La qualité «" + Quality + "» n'existe pas." , TellMeQuality() ] );
			  
			  
			// Sinon —— - - Le fait correctement
			} else {
			
				// Ajoute l'élément
				//
				// Sous forme de tableau —— - -
				if( TypeOf( Element , "Array" ) ){
				
				// Pour chaque élément —— - -
				for( var i:int = 0 ; i < Element.length ; i++ ){
					
					// Ajouet son objet
					Visibles[ Visibles.length ] = new Object();
					Visibles[ Visibles.length - 1 ].Element = Element[ i ];
					Visibles[ Visibles.length - 1 ].Quality = Quality;
					//
					if( QualityNumero < GetQuality( Quality ) ){ 
						//
						Element[ i ].visible = false; 
					}
				}
				//
				// Sous forme d'élément standard —— - -
				} else { 
				
					// Ajouet son objet
					Visibles[ Visibles.length ] = new Object();
					Visibles[ Visibles.length - 1 ].Element = Element;
					Visibles[ Visibles.length - 1 ].Quality = Quality;
					//
					if( QualityNumero < GetQuality( Quality ) ){  
						//
						Element.visible = false; 
					}
				}
			}
		}
		
		
	  	// —————— IS GRAPHIC
	  	// Définit un élément comme étant graphique
	  
		public function IsGraphic( Element:* ,	// ———— - - L'Élément ou le tableau d'élément
								   Image:Object	// ———— - - La Définition des images
							     ):void {
			/*—*/
			
			// Redéfinit le tableau des images
			if( Image.B ){ Image.Best = Image.B; }
			if( Image.H ){ Image.High = Image.H; }
			if( Image.M ){ Image.Medium = Image.M; }
			if( Image.L ){ Image.Low = Image.L; }
			if( Image.W ){ Image.Worst = Image.W; }
			
			// Trace l'erreur si n a oublié une forme
			if( !Image.Best || !Image.High || !Image.Medium || !Image.Low || !Image.Worst ){
				//
				TraceError( "OptimizeProcess" , "IsGraphic" , 
						  [ "L'objet de définition des images est incomplet, vous devez mettre les 5 états :" ,
							"{ Best:1 , High:2 , Medium:2 , Low:3 , Worst:4 } par exemple." ,
							"Vous pouvez également le mettre avec la premières lettre uniquement :" ,
							"{ B:1 , H:2 , M:2 , L:3 , W:4 } par exemple."
						   ] );
			  
			  
			// Sinon —— - - le fait correctement
			} else {
			
			  // Ajoute l'élément
			  //
			  // Sous forme de tableau —— - -
			  if( TypeOf( Element , "Array" ) ){
				  
				  // Pour chaque élément —— - -
				  for( var i:int = 0 ; i < Element.length ; i++ ){
					  
					  // Ajoute son objet
					  Graphics[ Graphics.length ] = new Object();
					  Graphics[ Graphics.length - 1 ].Element = Element[ i ];
					  Graphics[ Graphics.length - 1 ].Image = Image;
					  //
					  Element[ i ].gotoAndStop( Image[ Quality ] );
				  }
				  
				  // Sous forme d'élément standard —— - -
				  } else { 
				  
					// Ajoute son objet
					Graphics[ Graphics.length ] = new Object();
					Graphics[ Graphics.length - 1 ].Element = Element;
					Graphics[ Graphics.length - 1 ].Image = Image;
					//
					Element.gotoAndStop( Image[ Quality ] );
				}
			}
		}
		
		
	  	// —————— IS MOTION
	  	// Définit un élément comme étant animé
	  
		public function IsMotion( Element:* ,		// ———— - - L'Élément ou le tableau d'élément
								  Quality:String	// ———— - - Qualite minimale pour animer l'élément
								 ):void {
			/*—*/
			
			// Si la qualité n'existe pas —— - - Trace l'erreur
			if( GetQuality( Quality ) == -1 ){
				//
				TraceError( "OptimizeProcess" , "IsVisible" , [ "La qualité «" + Quality + "» n'existe pas." , TellMeQuality() ] );
			  
			  
			// Sinon —— - - Le fait correctement
			} else {
			
				// Ajoute l'élément
				//
				// Sous forme de tableau —— - -
				if( TypeOf( Element , "Array" ) ){
				
				// Pour chaque élément —— - -
				for( var i:int = 0 ; i < Element.length ; i++ ){
					
					// Ajouet son objet
					Motions[ Motions.length ] = new Object();
					Motions[ Motions.length - 1 ].Element = Element[ i ];
					Motions[ Motions.length - 1 ].Quality = Quality;
					//
					if( QualityNumero < GetQuality( Quality ) ){ 
						//
						TotalStop( Element ); 
					}
				}
				//
				// Sous forme d'élément standard —— - -
				} else { 
				
					// Ajouet son objet
					Motions[ Motions.length ] = new Object();
					Motions[ Motions.length - 1 ].Element = Element;
					Motions[ Motions.length - 1 ].Quality = Quality;
					//
					if( QualityNumero < GetQuality( Quality ) ){  
						//
						TotalStop( Element ); 
					}
				}
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Les méthodes pour modifier l'état des éléments rattachés
		//*—*//
	  
	  	// —————— SWITCH VISIBLES
	  	// Modifie la visibilités des éléments visibles archivés
	  
		private function SwitchVisibles():void {
			/*—*/
			
			// Pour chaque élément graphique —— - -
			for( var i:int = 0 ; i < Visibles.length ; i++ ){
			  	
				// S'il n'est pas null —— - -
				if( Visibles[ i ].Element ){
				
					// Si sa qualité est plus élevé que la qualité actuel —— - -
					if( QualityNumero < GetQuality( Visibles[ i ].Quality ) ){
					  
						// Il devient invisible
						Visibles[ i ].Element.visible = false;
					
					// Si la qualité est suffisante —— - -
					} else {
					  
						// Il devient visible
						Visibles[ i ].Element.visible = true;
					}
				}
			}
		}

	  
	  	// —————— SWITCH GRAPHICS
	  	// Modifie l'apparence des éléments graphiques archivés
	  
		private function SwitchGraphics():void {
			/*—*/
			
			// Pour chaque élément graphique —— - -
			for( var i:int = 0 ; i < Graphics.length ; i++ ){
			  
				// S'il n'est pas null —— - -
				if( Graphics[ i ].Element ){
				
					// Bascule son image selon la qualité
					Graphics[ i ].Element.gotoAndStop( Graphics[ i ].Image[ Quality ] );
				}
			}
		}
		
		
		// —————— SWITCH MOTIONS
	  	// Modifie l'apparence des éléments animés archivés
	  
	  	private function SwitchMotions():void {
			/*—*/
			
			// Pour chaque élément animé —— - -
			for( var i:int = 0 ; i < Motions.length ; i++ ){
			  	
				// S'il n'est pas null —— - -
				if( Motions[ i ].Element ){
				
					// Si sa qualité est plus élevé que la qualité actuel —— - -
					if( QualityNumero < GetQuality( Motions[ i ].Quality ) ){
					  	
						// Il se stop
						TotalStop( Motions[ i ].Element );
					
					// Si la qualité est suffisante —— - -
					} else {
					  
						// Il se lance
						TotalPlay( Motions[ i ].Element );
					}
				}
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					  HELP					  		  					  */
		/*							Obtenir une aide concernant la manipulation du script 					  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - TRACE - - —————————————————————————————————————————— */
		// Les méthodes pour récupérer une aide écrite
		//*—*//
	  
	  	// —————— GET QUALITE
	  	// Retourne le numéro de qualité à partir de la chaine
		
		public function GetQuality( laQualite:String	// ———— - - La Qualité recherchée
								   ):int {
			/*—*/
			 
			// Retourne la valeur définissant la qualité
			return QualityList.indexOf( laQualite );
		}
		
		
	  	// —————— TELL ME QUALITY
	  	// Retourne une phrase donnant les cinq qualités
		
		public function TellMeQuality():String {
			/*—*/
			
			return( "Les qualités sont : \"Best\" , \"High\" , \"Medium\" , \"Low\" et \"Worst\"." );
		}
		
		
		
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}