﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			PIXEL TOOLS	  			Version 0.2.0									***/
/***				   				   Dernière Mise à Jour : 10-08-14										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         				   Outils Bitmap												***/
/***		Ce script contient les méthodes relative à la gestion des éléments bitmap et des pixels.    	***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Visual {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*—*//
	
	// —— - - DISPLAY
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.BitmapData;
	import flash.display.Bitmap;
	//
	// —— - - EVENT
	import flash.events.Event;
	//
	// —— - - GEOMETRY
	import flash.geom.Matrix;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class PixelTools extends MiscTools {
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function PixelTools( TheLink:* = null	// ———— - - Lien vers la scène
									):void {
			/*—*/
			
			// Établit la connexion
			Connexion( TheLink );
		}

		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 BITMAP					  		  					  */
		/*							Méthodes pour manipuler les éléments et valeurs bitmaps 					  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - GET - - —————————————————————————————————————————— */
		// Récupérer des valeurs à partir de données Bitmap
		//*—*//
		
		// —————— PIXEL RATIO
		// Vérifie le pourcentage de remplissage d'un clip
	
	  	public function PixelRatio( Clip:* ,						// ———— - - Clip vérifié
									Largeur:Number = NaN ,			// ———— - - Largeur de vérification
									Hauteur:Number = NaN ,			// ———— - - Hauteur de vérification
							  		Decalage:Object = null ,		// ———— - - Décalage sur la zone vérifiée
									Verification:Boolean = false	// ———— - - Si on peut voir la vérification ou non ( Debug )
						    	   ):Number {
			/*—*/
			
			// Argument par défaut
			Decalage = Decalage || { x:0 , y:0 };
			//
			Largeur = ( isNaN( Largeur ) ) ? Clip.width : Largeur;
			Hauteur = ( isNaN( Hauteur ) ) ? Clip.height : Hauteur;
			
			// Création des données bitmap
			var NewBitmap:BitmapData = new BitmapData( Largeur , Hauteur , !Verification , 0xFF0000 );
			var NouvelleImage:Bitmap = new Bitmap( NewBitmap );
			
			// transformations actuelles de la pomme
			var NouvelleMatrice:Matrix = NouvelleImage.transform.matrix;
			
			// Repositionne les pixels
			NouvelleMatrice.tx = Decalage.x;
			NouvelleMatrice.ty = Decalage.y;
			
			// Affiche le bitmap
			Clip.parent.addChild( NouvelleImage );
			
			// Applique le dessin
			NewBitmap.draw( Clip , NouvelleMatrice );
			
			// Sortie de calcul
			var Calcul:int = 0;
			var Total:int = 0;
			
			// Horizontal —— - -
			for( var i:int = 1 ; i <= NewBitmap.width ; i++ ){
				//
				// Vertical —— - -
				for( var j:int = 1 ; j <= NewBitmap.height ; j++ ){
					
					// Récupère le pixel
					var Pixel:* = NewBitmap.getPixel32( i , j );
					var PixelCouleur:* = NewBitmap.getPixel( i , j ).toString( 16 );
					
					// S'il n'est pas vide —— - - Calcul augmente de 1
					if( Pixel != "0" && !Verification || PixelCouleur.toUpperCase() != "FF0000" && Verification ){ Calcul++; }
					//
					// Total augmente de 1
					Total++;
				}
			}
			
			// Si on est pas en mode vérification, retire le bitmap
			if( !Verification ){
				//
				Clip.parent.removeChild( NouvelleImage );
				//
				NouvelleImage = null;
			}
			
			// Sort le calcul dans son rapport de pourcentage avec la totalité
			return( ( Calcul / Total ) * 100 );
		}
		
		
		// —————— COLOR RATIO
		// Vérifie le pourcentage de remplissage d'un clip selon des niveau de couleur atteint
	
	  	public function ColorRatio( Clip:* ,						// ———— - - Clip vérifié
									Largeur:Number = NaN ,			// ———— - - Largeur de vérification
									Hauteur:Number = NaN ,			// ———— - - Hauteur de vérification
									Decalage:Object = null ,		// ———— - - Décalage sur la zone vérifiée
									Rouge:Number = NaN ,			// ———— - - Réclammation du pourcentage rouge
									Vert:Number = NaN ,				// ———— - - Réclammation du pourcentage vert
									Bleu:Number = NaN ,				// ———— - - Réclammation du pourcentage bleu
									Verification:Boolean = false	// ———— - - Si on peut voir la vérification ou non ( Debug )
								   ):Number {
			/*—*/
			
			// Argument par défaut
			Decalage = Decalage || { x:0 , y:0 };
			//
			Largeur = ( isNaN( Largeur ) ) ? Clip.width : Largeur;
			Hauteur = ( isNaN( Hauteur ) ) ? Clip.height : Hauteur;
			
			// Création des données bitmap
			var NewBitmap:BitmapData = new BitmapData( Largeur , Hauteur , false , 0xFF5488 );
			var NouvelleImage:Bitmap = new Bitmap( NewBitmap );
			
			// transformations actuelles de la pomme
			var NouvelleMatrice:Matrix = NouvelleImage.transform.matrix;
			
			// Repositionne les pixels
			NouvelleMatrice.tx = Decalage.x;
			NouvelleMatrice.ty = Decalage.y;
			
			// Affiche le bitmap
			Clip.parent.addChild( NouvelleImage );
			
			// Applique le dessin
			NewBitmap.draw( Clip , NouvelleMatrice );
			
			// Sortie de calcul
			var Calcul:int = 0;
			var Total:int = 0;
			
			// Horizontal —— - -
			for( var i:int = 1 ; i <= NewBitmap.width ; i++ ){
				//
				// Vertical —— - -
				for( var j:int = 1 ; j <= NewBitmap.height ; j++ ){
					
					// Récupère le pixel
					var Pixel:* = NewBitmap.getPixel32( i , j );
					var PixelCouleur:* = NewBitmap.getPixel( i , j ).toString( 16 );
					//
					// Convertie en code couleur
					var PixelRouge:* = Pixel >> 16 & 0xFF;
					var PixelVert:* = Pixel >> 8 & 0xFF;
					var PixelBleu:* = Pixel & 0xFF;
					
					// S'il est dans la couleur —— - - Calcul augmente de 1
					if( PixelCouleur.toUpperCase() != "FF5488" ){ 
						//
						var RougeVerification:Boolean = ( isNaN( Rouge ) || Rouge >= PixelRouge );
						var VertVerification:Boolean = ( isNaN( Vert ) || Vert >= PixelVert );
						var BleuVerification:Boolean = ( isNaN( Bleu ) || Bleu >= PixelBleu );
						//
						if( RougeVerification 
						 && VertVerification 
						 && BleuVerification ){	Calcul++; }
					}
					//
					// Total augmente de 1
					Total++;
				}
			}
			
			// Si on est pas en mode vérification, retire le bitmap
			if( !Verification ){
				//
				Clip.parent.removeChild( NouvelleImage );
				//
				NouvelleImage = null;
			}
			
			// Sort le calcul dans son rapport de pourcentage avec la totalité
			return( ( Calcul / Total ) * 100 );
		}
		
		
		
		/* —————————————————————————————————————————— - - CREATION - - —————————————————————————————————————————— */
		// Générer des éléments ou des formes Bitmap
		//*—*//
		
		// —————— SNAP
		// Récupére le contenu d'un clip et le plaque dans une cible
	
	  	public function Snap( ClipInitial:* ,			// ———— - - Clip de référence
						      ClipCible:* ,				// ———— - - Clip recevant le dessin
							  Decalage:* = null ,		// ———— - - Décalage de l'élément dans la matrice
							  Taille:Object = null ,	// ———— - - Taille donné à la capture
							  Destroy:Boolean = false	// ———— - - S'il détruit le clip ensuite
						    ):Bitmap {
			/*—*/
			
			// Argument par défaut
			if( TypeOf( Decalage , "Boolean" ) ){
				//
				Destroy = Decalage;
				Decalage = null;
			}
			//
			Decalage = Decalage || { x:0 , y:0 };
			Taille = Taille || { width:ClipInitial.width , height:ClipInitial.height  }
			
			// Création des données bitmap
			var NewBitmap:BitmapData = new BitmapData( Taille.width , Taille.height );
			var NouvelleImage:Bitmap = new Bitmap( NewBitmap );
			
			// Affiche le bitmap
			ClipCible.addChild( NouvelleImage );
			
			// Transforme le dessin tel que l'est le clip de référence
			var MatriceDeForme:Matrix = ClipInitial.transform.matrix;
			
			// Repositionne les pixels
			MatriceDeForme.tx = Decalage.x;
			MatriceDeForme.ty = Decalage.y;
			
			// Applique le dessin
			NewBitmap.draw( ClipInitial , MatriceDeForme );
			
			// Détruit le clip s'il le faut
			if( Destroy ){
				//
				DestroyElement( ClipInitial );
			}
			
			// Retourne l'élément créé
			return NouvelleImage;
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 VISUAL					  		  					  */
		/*			 Méthodes exploitant le concept pixel et bitmap pour générer des altérations visuelles 		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - GET - - —————————————————————————————————————————— */
		// Récupérer des valeurs à partir de données Bitmap
		//*—*//
		
		// —————— PIXEL ART
		// Applique un effet de pixel art sur une zone donnée
		//
		//  ATTENTION : Cette méthode rame TRES FACILEMENT au delà d'une zone de 300x300 ( Et encore ).
		//				Elle nécessitera, certainement, une optimisation par la suite pour un meilleure rendu.
	
	  	public function PixelArt( Clip:* ,						// ———— - - Clip Screené
								  Largeur:Number = NaN ,		// ———— - - Largeur de vérification
								  Hauteur:Number = NaN ,		// ———— - - Hauteur de vérification
								  TaillePixel:int = 5 ,			// ———— - - Taille des carrés
								  Conteneur:* = null ,			// ———— - - Conteneur du screen
								  Decalage:Object = null , 		// ———— - - Décalage sur la zone screené
								  Nom:String = "Image"			// ———— - - Image d'instance du bitmap
								 ):Bitmap {
			/*—*/
			
			// Argument par défaut
			Decalage = Decalage || { x:0 , y:0 };
			//
			Largeur = ( isNaN( Largeur ) ) ? Clip.width : Largeur;
			Hauteur = ( isNaN( Hauteur ) ) ? Clip.height : Hauteur;
			//
			Conteneur = Conteneur || Clip.root as MovieClip;
			
			// Levier de pré-existance du bitmap
			var LevierExistance:Boolean = ( Conteneur[ Nom ] != null );
			
			// Détruit le bitmap précédent s'il y en a un —— - -
			if( LevierExistance ){
				//
				Conteneur.removeChild( Conteneur[ Nom ] );
				//
				Conteneur[ "Bitmap" + Nom ] = null;
				Conteneur[ Nom ] = null;
			}
			
			// Création des données bitmap
			var NewBitmap:BitmapData = Conteneur[ "Bitmap" + Nom ] = new BitmapData( Largeur , Hauteur , false );
			var NouvelleImage:Bitmap = Conteneur[ Nom ] = new Bitmap( NewBitmap );
			
			// transformations actuelles
			var NouvelleMatrice:Matrix = NouvelleImage.transform.matrix;
			
			// Repositionne les pixels
			NouvelleMatrice.tx = Decalage.x;
			NouvelleMatrice.ty = Decalage.y;
			
			// Affiche le bitmap
			Conteneur.addChild( NouvelleImage );
			
			// Applique le dessin
			NewBitmap.draw( Clip , NouvelleMatrice );
			
			// Procède au lock du bitmap pour économiser de la ressource
			NewBitmap.lock()
			
			// Pour chaque pixel X pixels —— - -
			//
			// Horizontal —— - -
			for( var i:int = 1 ; i <= NewBitmap.width ; i += TaillePixel ){
				//
				// Vertical —— - -
				for( var j:int = 1 ; j <= NewBitmap.height ; j += TaillePixel ){
					
					// Horizontal —— - -
					for( var i3:int = i ; i3 < i + TaillePixel ; i3++ ){
					
						// Vertical —— - -
						for( var j3:int = j ; j3 < j + TaillePixel ; j3++ ){
							
							// Colorie ce pixel de la couleur du centre
							NewBitmap.setPixel( i3 , 
											    j3 ,
												NewBitmap.getPixel( i + Math.round( TaillePixel / 2 ) , 
												j + Math.round( TaillePixel / 2 ) ) );
						}
					}
				}
			}
			
			// Délocke le bitmap
			NewBitmap.unlock()
			
			// Retourne l'image créée
			return NouvelleImage;
		}
		
		
		
	
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}