﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			SHOW PROCESS			Version 0.3.0									***/
/***				   				   Dernière Mise à Jour : 10-08-16										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         			   Gestionnaire Animation											***/
/***	Ce script contient une boucle globale et un ensemble de méthodes prévues pour lancer et gérer	    ***/
/***	des processus d'animations complexes tels que des effets de Set-Up, des filaments, etc.				***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Visual {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	
	// —— - - DISPLAY
	import flash.display.MovieClip;
	import flash.display.Shape;
	//
	// —— - - EVENT
	import flash.events.Event;
	//
	// —— - - UTILS
	import flash.utils.*;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class ShowProcess extends MiscTools {
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function ShowProcess( TheLink:* = null		// ———— - - Lien vers la scène
									 ):void {
			/*—*/
			
			// Établit la connexion
			Connexion( TheLink );
				
			// Lance la boucle
			AddEvents( this , GlobalLoop , "ENTER_FRAME" );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 GLOBAL					  		  					  */
		/*									  Méthodes de gestion global du Script 					  			  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - LOOP - - —————————————————————————————————————————— */
		// Méthodes de Boucles centrale
		//*—*//
		
		// —————— GLOBAL LOOP
		// Boucle centrale de fonctionnement du script
	
		public function GlobalLoop( event:Event ):void {
			/*—*/
			
			// Essaye —— - -
			try {
			
				/* ———— - - TENDONS - - ———— */
				/**/
				
				// Pour chaque tendons —— - -
				for( var j:int = 0 ; j < Tendons.length ; j++ ){
					
					// Si la liaison n'est pas null —— - -
					if( Tendons[ j ] != null ){
						
					// RécuPere l'occurence du fils
					var Fils:* = Tendons[ j ];
					//
					// Mes à zéro les données du fils
					Fils.Rotation = 0;
					Fils.DirectionRotation = 0;
						
						// Si elle n'est pas null et a des parents —— - -
						if( Fils != null && Fils.Parents != null ){
							
							// Redonne au fils ses données initiales
							Fils.x = Fils.Memo.X;
							Fils.y = Fils.Memo.Y;
							Fils.rotation = 0;
							Fils.height = Fils.Memo.H;
							Fils.width = Fils.Memo.W;
							Fils.rotation = Fils.Memo.R;
							
							// Pour chaque parent du fils —— - -
							for( var o:int = 0 ; o < Fils.Parents.length ; o++ ){
							
								// Occurence
								var Définition:Object = Fils.Parents[ o ];
								var Pere:* = Définition.Pere;
							
							
								// —— - - POSITION
								if( Définition.Lien.indexOf( "Position" ) != -1 ) {
									
									// Modification de position par rapport à la position du pére
									Fils.x += Pere.x - Définition.MemoPere.X;
									Fils.y += Pere.y - Définition.MemoPere.Y;
								}
								
								// Memorisation et mise à zéro de rotation
								var InstantMemoRotation:Number = Fils.rotation;
								Fils.rotation = 0;
								
								// —— - - TAILLE
								if( Définition.Lien.indexOf( "Taille" ) != -1 ) {
																				
									// Modification de la taille en proportionnel par rapport à la modification qu'a subit son pére
									Fils.width *= ( Définition.MemoPere.W / Pere.width );
									Fils.height *= ( Définition.MemoPere.H / Pere.height );
								}
								
								// Remise de la rotation
								Fils.rotation = InstantMemoRotation;
		
								
								// —— - - ROTATION
								if( Définition.Lien.indexOf( "Rotation" ) != -1 ) {
									
									// Modification de la rotation par rapport à la rotation du pére
									Fils.Rotation += Pere.rotation - Définition.MemoPere.R;
								}
								
								
								// —— - - ANGLE
								if( Définition.Lien.indexOf( "Angle" ) != -1 ) {
									
									// Récupération de la distance entre le pére et le fils
									var Distance:Number = Math.sqrt( Math.abs( Fils.x - Pere.x )*
																	 Math.abs( Fils.x - Pere.x ) + 
																	 Math.abs( Fils.y - Pere.y )*
																	 Math.abs( Fils.y - Pere.y ) );
									
									// Récupération de l'angle entre le pére et le fils
									var Angle:Number = Math.atan2( Fils.y - Pere.y , Fils.x - Pere.x ) * 180 / ( Math.PI );
									
									// Replacement du fils par rapport à la distance dans la direction de l'angle plus la modification 
									// de rotation qu'a subit le pére
									Fils.x = Pere.x + Math.cos( ( Angle + ( Pere.rotation - Définition.MemoPere.R ) ) / 180 * Math.PI ) * Distance;
									Fils.y = Pere.y + Math.sin( ( Angle + ( Pere.rotation - Définition.MemoPere.R ) ) / 180 * Math.PI ) * Distance;
								}
								
								
								// —— - - DIRECTION (Non-Cumulable)
								if( Définition.Lien.indexOf( "Direction" ) != -1 ) {
																
									// Récupération de l'angle entre le pére et le fils
									Fils.DirectionRotation = Math.atan2( Fils.y - BumpNumber( Pere.y , Définition.Bump.MinY , Définition.Bump.MaxY ) 
																	   , Fils.x - BumpNumber( Pere.x , Définition.Bump.MinX , Définition.Bump.MaxX )  ) 
														   * 180 / ( Math.PI ) + Définition.Bump.rotation;
								}
								
								
								// —— - - ATTACHE (Indépendant du reste)
								if( Définition.Lien.indexOf( "Attache" ) != -1 ) {
									
									// Définie les points de Tendons
									var Pere0:Object = new Object();
									var Pere1:Object = new Object();
									
									// Alterne les points de Tendons par rapport au bump
									//
									Pere0.x = SetDirectionTo( { x:Pere[ 0 ].x , y:Pere[ 0 ].y } ,
															  Définition.Bump.Pere1x || 0 ).x , 
															  Pere[ 0 ].rotation + Définition.Bump.Pere1r;
									Pere0.y = SetDirectionTo( { x:Pere[ 0 ].x , y:Pere[ 0 ].y } ,
															  Définition.Bump.Pere1y || 0 ).y , 
															  Pere[ 0 ].rotation + Définition.Bump.Pere1r;
									//
									Pere1.x = SetDirectionTo( { x:Pere[ 1 ].x , y:Pere[ 1 ].y } , 
															   Pere[ 1 ].rotation , 
															  Définition.Bump.Pere2x || 0 ).x;
									Pere1.y = SetDirectionTo( { x:Pere[ 1 ].x , y:Pere[ 1 ].y } , 
															  Pere[ 1 ].rotation , 
															  Définition.Bump.Pere2y || 0 ).y;
									
									// Récupération de l'angle entre les deux Peres
									Fils.DirectionRotation = Math.atan2( Pere0.y - Pere1.y , Pere0.x - Pere1.x ) * 180 / ( Math.PI ) 
														   + Définition.Bump.rotation;
									
									// Récupération de la position entre les deux Peres
									Fils.x = Pere0.x + ( Pere1.x - Pere0.x ) / 2;
									Fils.y = Pere0.y + ( Pere1.y - Pere0.y ) / 2;
									
									// Récupération de la longueur entre les deux Peres
									Fils.width = GetDistance( Pere0 , Pere1 );
								}
							}
						}
						
						// Applique la modifications d'angle
						Fils.rotation += Fils.Rotation;
						Fils.rotation += Fils.DirectionRotation;
						
						// Applique le bump
						if( Définition.Bump.Rotation ){
							
							Fils.rotation += Définition.Bump.Rotation;
						}
					}
				}
					
					
				/* ———— - - THREAD - - ———— */
				/**/
				
				// Pour chaque fil —— - -
				for( var O:Object in Threads ){
					
					// S'il n'est pas null —— - -
					if( Threads[ O ] != null ){
						
						
						// Occurence de l'objet fil
						var leFil:* = Threads[ O ];
						
						// Création du trait s'il n'éxite pas encore —— - -
						if( !leFil.Conteiner.Trait ){
							leFil.Conteiner.Trait = new Shape();
							leFil.Conteiner.addChild( leFil.Conteiner.Trait );
						}
						
						// Créations des variable instant pour les deux ou trois points
						var Point1:Object = new Object();
						var Point2:Object = new Object();
						var Point3:Object = new Object();
						
						// Récupération des données du point n°1
						Point1.x = SetDirectionTo( { x:leFil.Point1.x , y:leFil.Point1.y } , 
												  leFil.Bump.Point1x || 0 , 
												  ( leFil.Point1.rotation || 0 ) ).x;
						Point1.y = SetDirectionTo( { x:leFil.Point1.x , y:leFil.Point1.y } , 
												  leFil.Bump.Point1y || 0 , 
												  ( leFil.Point1.rotation || 0 ) ).y;
						
						// Récupération des données du point n°2
						Point2.x = SetDirectionTo( { x:leFil.Point2.x , y:leFil.Point2.y } , 
												  leFil.Bump.Point2x || 0 , 
												  ( leFil.Point2.rotation || 0 ) ).x;
						Point2.y = SetDirectionTo( { x:leFil.Point2.x , y:leFil.Point2.y } , 
												  leFil.Bump.Point2y || 0 , 
												  ( leFil.Point2.rotation || 0 ) ).y;
						
						// Effacement de l'ancien trait
						leFil.Conteiner.Trait.graphics.clear();
						
						// Mise du style
						leFil.Conteiner.Trait.graphics.lineStyle( leFil.Taille , leFil.Couleur , leFil.Alpha / 100 );
						
						// Place le point n°1
						leFil.Conteiner.Trait.graphics.moveTo( Point1.x , Point1.y );
						
						
						// S'il y a seulement 2 points —— - -
						if( !leFil.Point3 ){
							
							// Place le point n°2
							leFil.Conteiner.Trait.graphics.lineTo( Point2.x , Point2.y );
							
							
						// S'il y a 3 points —— - -
						} else {
							
							// Récupération des données du point n°3
							Point3.x = SetDirectionTo( { x:leFil.Point3.x , y:leFil.Point3.y } , 
													leFil.Bump.Point3x || 0 , 
													( leFil.Point3.rotation || 0 ) ).x;
							Point3.y = SetDirectionTo( { x:leFil.Point3.x , y:leFil.Point3.y } , 
													leFil.Bump.Point3y || 0 , 
													( leFil.Point3.rotation || 0 ) ).y;
							
							// Place le point n°2 et 3 en Curve
							leFil.Conteiner.Trait.graphics.curveTo( Point2.x , Point2.y , Point3.x , Point3.y );
						}
					}
				}
				
			} catch( e ){}
		}
		
		
		
		/* —————————————————————————————————————————— - - FACTICE - - —————————————————————————————————————————— */
		// Méthodes pour gérer les factices
		//*—*//
		
		// —————— HIDE FACTICE
		// Vérifie le nom d'un MovieClip pour voir s'il contient "Factice" au début, si c'est le cas, il est mis en invisible
	
		public function HideFactice( Cible:*	// ———— - - La Cible concernée
									):void {
			/*—*/
			
			// Essaye —— - -
			try {
					
				// Pour chacun de ses enfants —— - -
				for( var i:int = 0 ; i < Cible.numChildren ; i++ ){
					
					// Prend l'occurence de l'élément
					var Element:* = Cible.getChildAt( i );
					
					// Vérifie "Factice"
					if( Element.name.split( "Factice" ).length > 0 && Element.name.split( "Factice" )[ 0 ] == "" ){
						
						// Invisible si c'est le cas
						Element.visible = false;
				
					// Vérifie "F_"
					} else if( Element.name.split( "F_" ).length > 0 && Element.name.split( "F_" )[ 0 ] == "" ){
						
						// Invisible si c'est le cas
						Element.visible = false;
					}
				}
			} catch( e ){}
		}
		
		
		// —————— SHOW FACTICE
		// Montre les factices
	
		public function ShowFactice( Cible:*	// ———— - - La Cible concernée
									):void {
			/*—*/
			
			// Pour chacun de ses enfants —— - -
			for( var i:int = 0 ; i < Cible.numChildren ; i++ ){
				
				// Prend l'occurence de l'élément
				var Element:* = Cible.getChildAt( i );
				
				// Vérifie "Factice"
				if( Element.name.split( "Factice" ).length > 0 && Element.name.split( "Factice" )[ 0 ] == "" ){
					
					// Visible si c'est le cas
					Element.visible = true;
			
				// Vérifie "F_"
				} else if( Element.name.split( "F_" ).length > 0 && Element.name.split( "F_" )[ 0 ] == "" ){
					
					// Visible si c'est le cas
					Element.visible = true;
				}
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 TENDON					  		  					  */
		/*								 Méthodes de gestion des liens d'état des clips 					  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables de cet ensemble
		//*—*//
		
		// —————— TENDONS
	    // Stockage des tendons
		private var Tendons:Array = new Array();
		private var TendonStock:Object = new Object();
		
		// —————— TENDON SHORT LIST
	    // liste des racourcies de demande de tendons
		private var TendonShortList:Object = { Joint:"Position,Angle" ,
											   Lien:"Direction" 
											  };
		
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Méthodes pour créer et gérer des tendons
		//*—*//
		
		// —————— ADD TENDON
		// Créait un nouveau lien d'état entre un clip vers un autre
		
		public function AddTendon( Nom:String ,									// ———— - - Nom de la liaison
								   Pere:* ,										// ———— - - Pére dans la liaison
								   Fils:* ,										// ———— - - Fils dans la liaison
								   Lien:String = "Position,Rotation,Angle" ,	// ———— - - Type de lien
								   Bump:Object = null							// ———— - - Bump d'état
								  ):void {
			/*—*/
			
			// Vérifie et convertie le lien
			if( TendonShortList[ Lien ] ){
				//
				Lien = TendonShortList[ Lien ];
			}
			
			// Arguments par défaut
			Bump = Bump || new Object
			Bump.rotation = Bump.rotation || 0;
			Bump.x = Bump.x || 0;
			Bump.y = Bump.y || 0;
			
			
			// S'il ne se trouve pas déjà dans la liste —— - -
			if( !TendonStock[ Nom ] ){
			
				// Test la présence actuelle du fils ou non
				//
				// Levier
				var Levier:Boolean = false;
				//
				// Pour chaque Tendons —— - - S'il s'agit du fils, active le levier
				for( var i:int = 0 ; i < Tendons.length ; i++ ){ 
					//
					if( Tendons[ i ] == Fils ){ 
						//
						Levier = true; 
					}
				}
				//
				// Si le clip fils n'existe pas —— - -
				if( !Levier ){ 
					
					// Définit la liaison du fils
					Tendons.push( Fils );
					
					// Mémorise la position initial du fils
					Fils.Memo = new Object();
					Fils.Memo.X = Fils.x;
					Fils.Memo.Y = Fils.y;
					Fils.Memo.R = Fils.rotation;
					Fils.Memo.W = Fils.width;
					Fils.Memo.H = Fils.height;
				}
				
				// Donne l'objet de parents au fils
				Fils.Parents = ( Fils.Parents ) ? Fils.Parents : new Array();
				
				// Ajoute son objet de définition
				Fils.Parents[ Fils.Parents.length ] = new Object();
				var Definition:Object = Fils.Parents[ Fils.Parents.length - 1 ];
				
				// Ajoute son nouveau pére
				Definition.Pere = Pere;
					
					
				// S'il ne s'agit pas d'une attache —— - -
				if( Lien != "Attache" ){
					
					// Mémorise la position initial du Pere
					Definition.MemoPere = new Object();
					Definition.MemoPere.X = Pere.x;
					Definition.MemoPere.Y = Pere.y;
					Definition.MemoPere.R = Pere.rotation;
					Definition.MemoPere.W = Pere.width;
					Definition.MemoPere.H = Pere.height;
				
				// S'il s'agit d'une attache —— - -
				} else {
					
					// Récupére sa rotation actuelle pour le bump
					Bump.rotation += Fils.rotation;
				}
				
				
				// Récupération des types de liens
				Definition.Lien = new Array();
				Definition.Lien = Lien.split( "," );
				
				// Récupération du bump
				Definition.Bump = Bump;
				
				
				// Ajoute la liaison à la liste
				TendonStock[ Nom ] = new Array( Fils , Pere , Lien );
			}
		}
		
		
		// —————— REMOVE TENDON
		// Détruit un lien d'état
		
		public function RemoveTendon( Nom:String 		// ———— - - Nom de la liaison
									 ):void {
			/*—*/
			
			// RécuPere les occurences
			var Fils:* = TendonStock[ Nom ][ 0 ];
			var Pere:* = TendonStock[ Nom ][ 1 ];
			var Lien:* = TendonStock[ Nom ][ 2 ];
			
			// Pour chaque parents du fils —— - -
			for( var i:int = 0 ; i < Fils.Parents.length ; i++ ){
				
				// S'il s'agit de ce parent et de ce lien —— - -
				if( Fils.Parents[ i ].Pere == Pere && Fils.Parents[ i ].Lien.join( "," ) == Lien ){
					
					// Mémorise les modifications
					//
					// Position
					if( Lien.split( "Position" ).length > 1 || Lien.split( "Angle" ).length > 0 ){
						Fils.Memo.X = Fils.x;
						Fils.Memo.Y = Fils.y;
					}
					//
					// Rotation
					if( Lien.split( "Rotation" ).length > 1 ){ Fils.Memo.R = Fils.rotation;	}
					//
					// Taille
					if( Lien.split( "Taille" ).length > 1 ){ 
						Fils.Memo.W = Fils.width;
						Fils.Memo.H = Fils.height;
					}
					
					// Retire le lien
					Fils.Parents.splice( i , 1 );
					TendonStock[ Nom ] = null;
				}
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 THREAD					  		  					  */
		/*								 		  Méthodes de gestion des fils 					  	  			  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables de cet ensemble
		//*—*//
		
		// —————— THREADS
	    // Stockage des fils
		private var Threads:Object = new Object();
		
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Méthodes pour créer et gérer des fils
		//*—*//
		
		// —————— ADD THREAD
		// Créait un fil entre deux ou trois éléments
	
		public function AddThread( Nom:String ,				// ———— - - Nom donnée au fil
								   Points:Array ,			// ———— - - Les points
								   Conteiner:* ,			// ———— - - Conteneur du fil
								   Parametres:* = null ,	// ———— - - Paramètres de forme
								   Bump:Object = null		// ———— - - Bump d'état
								 ):void {
			/*—*/
			
			// Arguments par défaut
			Conteiner = Conteiner;
			Parametres = Parametres || new Object();
			Bump = Bump || new Object();
			
			// Création de l'objet Fil et placement de ses paramètres
			Threads[ Nom ] = new Object();
			//
			// Conteiner
			Threads[ Nom ].Conteiner = NewElement( MovieClip , Conteiner , Nom + "Conteiner" );
			//
			// Parametres de forme
			Threads[ Nom ].Taille = Parametres.Taille || 3;
			Threads[ Nom ].Couleur = Parametres.Couleur || 0x000000;
			Threads[ Nom ].Alpha = Parametres.Alpha || 100;
			//
			Threads[ Nom ].Couleur = TypeOf( Threads[ Nom ].Couleur , "String" ) ? uint( "0x" + Threads[ Nom ].Couleur ) : Threads[ Nom ].Couleur;
			//
			// Points
			Threads[ Nom ].Point1 = Points[ 0 ];
			Threads[ Nom ].Point2 = Points[ 1 ];
			Threads[ Nom ].Point3 = Points[ 2 ];
			//
			// Bump
			Threads[ Nom ].Bump = Bump;
		}
		
		
		// —————— REMOVE THREAD
		// Détruit un fil
	
		public function RemoveThread( Nom:String ,					// ———— - - Nom du fil
									  Effacement:Boolean = true		// ———— - - S'il faut l'effacer
									 ):void {
			/*—*/
			
			// S'il faut l'effacer —— - -
			if( Effacement ){
				
				// L'efface
				Threads[ Nom ].Conteiner.Trait.graphics.clear();
			}
			
			// Mes le fil à null
			Threads[ Nom ] = null;
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				    TIME LINE					  		  				  */
		/*								 		Méthodes de gestion de Time-Line 					  	  		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Méthodes pour créer et gérer des time-lines
		//*—*//
		
		// —————— TIME LINE
		// Construit une Time-Line virtuelle à un élément
	
		public function TimeLine( Clip:* , 				// ———— - - Le Clip concerné
								  Animation:Array ,		// ———— - - L'Animation
								  Nom:String = "" ,		// ———— - - Le Nom de l'animation
								  Parametres:* = null	// ———— - - Les Parametres
								 ):Object {
			/*—*/
			
			// Argument du nom par défaut
			Nom = ( Nom != "" ) ? Nom : RandomWord();
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			
			// Définit l'objet TimeLine sur le clip
			var ObjetTimeLine:Object = Clip[ "TimeLine" + Nom ] = new Object();
			//
			// RécuPere ses paramètres
			ObjetTimeLine.Animation = Animation;
			ObjetTimeLine.Pointeur = -1;
			ObjetTimeLine.Nom = Nom;
			
			// Définit la fonction pour passer à l'animation suivante sur la TimeLine —— - -
			ObjetTimeLine.Suivant = function():void {
				
				// Augmente le pointeur de 1
				ObjetTimeLine.Pointeur++;
				
				// Le pointeur retombe à zéro s'il est au max
				if( ObjetTimeLine.Pointeur >= ObjetTimeLine.Animation.length ){ ObjetTimeLine.Pointeur = 0; }
				
				// RécuPere l'animation suivante
				var AnimationEnCour:Object = ObjetTimeLine.Animation[ ObjetTimeLine.Pointeur ];
				
				// Lance le Next suivant
				Next( ObjetTimeLine.Nom + ObjetTimeLine.Pointeur , 
					  Clip , 
					  AnimationEnCour.Etat || {} , 
					  AnimationEnCour.Vitesse || 10 , 
					  AnimationEnCour.Type || "Constant" ,
					  { Cible:ObjetTimeLine , Fonction:"Suivant" }
					);
			}
			//
			// Lance la première animation
			ObjetTimeLine.Suivant();
			
			// Retourne l'objet de TimeLine
			return ObjetTimeLine;
		}
		
		
		
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}