﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        				VORTEX	  		Version 1.5.0										***/
/***				   				   Dernière Mise à Jour : 10-09-09										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         				Héritage Conversion												***/
/***	Ce script analyse des éléments, String ou Nombre, et les convertie s'ils sont des Strings.		    ***/
/***	Selon ce qui est écrit dans les String en question, les conversions sont différentes.			 	***/
/***	Ce script permet d'ajouter de la souplesse aux autres employant des demandes de formules  	     	***/
/***	mathématiques puisque, au lieu de trop d'arguments, il suffit de rentrer un String contenant la   	***/
/***	demande de formule et le script demandera la conversion au Vortex qui lui retransmettra    		    ***/
/***	ensuite le résultat.   																				***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***	Les arguments de méthode des autres scripts ayant le sigle « ¤ » sont compatibles VorteX. 		    ***/
/***	Les méthodes entiérement compatibles VorteX portent la nomination : « ¤VorteX Compatible¤ ». 		***/
/***												      													***/
/***	Les Scripts portent tous une indiquation :  	     												***/
/***	« Compatibilité VorteX : » indiquant le pourcentage de compatibilité avec le VorteX au même titre  	***/
/***	que le « Contre-Bug » et « Aide ». 		    														***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.VorteX{
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	 
	// —— - - DISPLAY
	import flash.display.MovieClip;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class Vortex extends MovieClip {
		
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		// —————— VORTEX CENTER
		// Base central du Vortex, principalement pour les recherches de rapport
		public var VortexCenter:*;
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/// Inutilisée
		public function Vortex():void {}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 GLOBAL					  		  					  */
		/*										 Utilisation général du script 									  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
	  
	    // —————— L'ASPIRATION
	    // Aspire un élément, s'il est un string, essaye d'en extraire un calcul spécifique
		
		public function Aspiration( Element:* ,			// ———— - - Element à traiter
								    Defaut:* = null		// ———— - - Renvoie par défaut
								   ):* {
			/*—*/
			
			// Argument par défaut
			Defaut = ( Defaut != null ) ? Defaut : Element;
			
			// S'il s'agit déjà d'un nombre —— - - le renvoie immédiatement
			if( !isNaN( Number( Element ) ) ){ return Element; }
			//
			// S'il s'agit déjà d'un objet —— - - le renvoie immédiatement
			try{ if( typeof Element == "object" && !Element[ 0 ] ){ return Element; } } 
			catch( e ){ if( typeof Element == "object" ){ return Element; } }
				
			// Essaye —— - -
			try { 
				
				// S'il s'agit d'un tableau comprenant un string de fonction VorteX en premier
				if( Element[ 0 ] ){
					//
					if( typeof Element[ 0 ] == "string" ){
							
						// S'il s'agit de l'aléatoire —— - - Convertie
						if( Element[ 0 ] == "random" ){
							
							// Si ce doit être une convertion par le biais de chiffre —— - - Convertie e nstring de manipulation
							if( !isNaN( Element[ 1 ] ) && !isNaN( Element[ 2 ] ) 
							 && typeof Element[ 1 ] != "string" && typeof Element[ 2 ] != "string" ){
								//
								Element = Element[ 0 ] + " " + Element[ 1 ] + "," + Element[ 2 ];
							
							// Sinon —— - - Renvoie parmis les deux autres l'un en aléatoire
							} else {
								//
								var CloneElement:Array = new Array();
								//
								for( var i:int = 1 ; i < Element.length ; i++ ){ CloneElement.push( Element[ i ] ); }
								//
								var ATransmettre:* = CloneElement[ Math.round( Math.random() * ( CloneElement.length - 1 ) ) ];
								//
								return( ( !isNaN( Number( ATransmettre ) ) ? Number( ATransmettre ) : ATransmettre ) );
							}
						}
					}
				}
			//
			// Ou se tait
			} catch( e ){}
			
			
			// Convertie la chaine de caractère au cas où elle serait autre chose qu'un string
			Element = String( Element );
				
			// Si la chaine contient une protection —— - -
			if( Element.split( "[" ).length > 1 && Element.split( "]" ).length > 1 ){
				
				// Retire la protection —— - -
				//
				// Départ
				var TransitionElement:Array = Element.split( "[" );
				//
				TransitionElement.shift();
				//
				Element = TransitionElement.join( "[" );
				//
				// Fin
				TransitionElement = Element.split( "]" );
				//
				TransitionElement.pop();
				//
				Element = TransitionElement.join( "]" );
				
				// Retourne la chaine
				return Element;
			}
			
			// Essaye —— - -
			try{ 
				
				var Traitement:String = Element.split( " " )[ 0 ];
				var Arguments:* = Element.split( " " )[ 1 ] || "";
				var PostOp:String = Element.split( " " )[ 2 ];
				var PostOpArguments:* = Element.split( " " )[ 3 ] || "";
				//
				// S'il y a des arguments —— - -
				if( Arguments ){
					//
					// Si l'argument comprend des crochets —— - -
					if( Arguments.split( ";" ).length > 0 ){
						//
						// Récupère l'un de son contenu au hasard
						Arguments = Arguments.split( ";" )[ Math.round( Math.random() * ( Arguments.split( ";" ).length - 1 ) ) ]
					}
				}
				//
				if( Arguments != "" ){ Arguments = Arguments.split( "," ) };
				if( PostOpArguments != "" ){ PostOpArguments = PostOpArguments.split( "," ) };
				//
				var Sortie:*;
				
				// Sonde le nombre d'argument et lance la méthode de traitement équivalent par ce nombre d'argument —— - -
				switch( Arguments.length ) { 
					//
					case 0 : 
						Sortie = this[ Traitement ]();
						break; 
					//
					case 1 : 
						Sortie = this[ Traitement ]( Arguments[ 0 ] );
						break; 
					//
					case 2 : 
					
						Sortie = this[ Traitement ]( Arguments[ 0 ] , 
													 Arguments[ 1 ] );
						break; 
					//
					case 3 : 
						Sortie = this[ Traitement ]( Arguments[ 0 ] , 
													 Arguments[ 1 ] , 
													 Arguments[ 2 ] );
						break;  
					//
					case 4 : 
						Sortie = this[ Traitement ]( Arguments[ 0 ] , 
													 Arguments[ 1 ] , 
													 Arguments[ 2 ] , 
													 Arguments[ 3 ] );
						break; 
					//
					case 5 : 
						Sortie = this[ Traitement ]( Arguments[ 0 ] , 
													 Arguments[ 1 ] , 
													 Arguments[ 2 ] , 
													 Arguments[ 3 ] , 
													 Arguments[ 4 ] );
						break; 
					//
					case 6 : 
						Sortie = this[ Traitement ]( Arguments[ 0 ] , 
													 Arguments[ 1 ] , 
													 Arguments[ 2 ] , 
													 Arguments[ 3 ] , 
													 Arguments[ 4 ] , 
													 Arguments[ 5 ] );
						break; 
				} 
				//
				// S'il y a une demande de post-opératoire —— - -
				if( PostOp && PostOp != "" ){
					
					// Par rapport aux arguments de Post-Op —— - -
					switch( PostOpArguments.length ) { 
						//
						case 0 : Sortie = this[ PostOp ]( Sortie );
						break;
						//
						case 1 : Sortie = this[ PostOp ]( Sortie , PostOpArguments[ 0 ] );
						break;
						//
						case 2 : Sortie = this[ PostOp ]( Sortie , PostOpArguments[ 0 ] , PostOpArguments[ 1 ] );
						break;
					}
				}
				//
				// Retourne la sortie
				return Sortie;
				
			// Si échoue —— - - Renvoie la valeur par défaut
			} catch( e ){ return Defaut; }
		}
	  
	  	
	    // —————— ASPIRATION OBJECT
	    // Aspiration de l'ensemble des clés d'un objet pour en retourner un clone aspiré 
		
		public function AspirationObject( Objet:*	// ———— - - Objet à traiter
										 ):* {
			/*—*/
			
			// Clone l'objet
			var CloneObjet:Object = new Object();
			
			// Pour chaque clé de l'objet —— - -
			for( var Clee:* in Objet ){
				
				// Aspire la clé
				CloneObjet[ Clee ] = Aspiration( Objet[ Clee ] );
			}
			
			// Retourne l'objet
			return CloneObjet;
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				   COMPILATION					  		  				  */
		/*										   Traitement de premier ordre 					  				  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
		
		// —————— OBJETS
		// Objets de maintenance des valeurs numériques
		private var Sawtooth:Object = new Object();
		private var Sinusoidal:Object = new Object();
		private var Exponential:Object = new Object();
		
		
		
		/* —————————————————————————————————————————— - - CALCUL - - —————————————————————————————————————————— */
		// Les méthodes retournant des valeurs issues de calcul
		//*—*//
	  
	    // —————— SIMPLE
	    // Retourne directement un chiffre souhaité ( Utile si seul le post-op est voulu )
		
		private function simple( Chiffre:String = "0" 	// ———— - - Le Chiffre concerné
								):Number {
			/*—*/
			
			// renvoie le chiffre
			return( Number( Chiffre ) );
		}
	  	
	  	
	    // —————— RANDOM
	    // Retourne un chiffre aléatoire
		
		private function random( Chiffre1:String = "0" , 	// ———— - - Chiffre minimal
								 Chiffre2:String = "1" 		// ———— - - Chiffre maximal
								):Number {
			/*—*/
			
			// Calcul et renvoie
			return( Math.random() * ( Number( Chiffre2 ) - Number( Chiffre1 ) ) + Number( Chiffre1 ) );
		}
	  
	  
	    // —————— SAW TOOTH
	    // Retourne un chiffre passant constemment d'une valeur à une autre
		
		private function sawtooth( Nom:String	= "Defaut" ,	// ———— - - Le nom des dents de scie
								   Chiffre1:String = "0" , 		// ———— - - Chiffre minimal
								   Chiffre2:String = "10" , 	// ———— - - Chiffre maximal
								   Pas:String = "1" 			// ———— - - Pas transitif
								  ):Number {
			/*—*/
			
			// S'il n'y a pas encore d'objet dent de scie —— - -
			if( !Sawtooth[ Nom ] ){
				
				// Créait l'objet et lui donne ses références
				Sawtooth[ Nom ] = new Object();
				Sawtooth[ Nom ].Valeur = Number( Chiffre1 );
				Sawtooth[ Nom ].Direction = "Ascendant";
			}
			
			// S'il est ascendant —— - -
			if( Sawtooth[ Nom ].Direction == "Ascendant" ){
				
				// Il augmente
				Sawtooth[ Nom ].Valeur += Number( Pas );
				
				// S'il est au max —— - - Il redescent
				if( Sawtooth[ Nom ].Valeur >= Chiffre2 ){ Sawtooth[ Nom ].Direction = "Descendant"; }
				
			// S'il est descendant —— - -
			} else {
				
				// Il baisse
				Sawtooth[ Nom ].Valeur -= Number( Pas );
				
				// S'il est au min —— - - Il augmente
				if( Sawtooth[ Nom ].Valeur <= Chiffre1 ){ Sawtooth[ Nom ].Direction = "Ascendant"; }
			}
			
			// Renvoie
			return( Sawtooth[ Nom ].Valeur );
		}
	  
	  	
	    // —————— SINUSOIDAL
	    // Retourne un chiffre passant constemment d'une valeur à une autre de façon sinusoidal
		
		private function sinusoidal( Nom:String	= "Defaut" ,	// ———— - - Le nom de la sinusoidale
									 Chiffre1:String = "0" , 	// ———— - - Chiffre minimal
								 	 Chiffre2:String = "10" ,   // ———— - - Chiffre maximal
								 	 Pas:String = "30"			// ———— - - Pas transitif
									):Number {
			/*—*/
			
			// S'il n'y a pas encore d'objet dent de scie —— - -
			if( !Sinusoidal[ Nom ] ){
				
				// Créait l'objet et lui donne ses références
				Sinusoidal[ Nom ] = new Object();
				Sinusoidal[ Nom ].Vitesse = 0;
				Sinusoidal[ Nom ].Valeur = Number( Chiffre2 );
			}
			
			// Fait évoluer la vitesse
			Sinusoidal[ Nom ].Vitesse += ( Number( Chiffre1 ) - Sinusoidal[ Nom ].Valeur ) / Number( Pas );
			//
			// Fait évoluer la valeur par rapport à la vitesse
			Sinusoidal[ Nom ].Valeur += Sinusoidal[ Nom ].Vitesse;
			
			// Renvoie
			return( Sinusoidal[ Nom ].Valeur );
		}
	  	
	  	
	    // —————— EXPONENTIAL
	    // Retourne un chiffre evoluant vers l'infinie
		
		private function exponential( Nom:String = "Defaut" ,		// ———— - - Le nom de l'exponentialité
									  Chiffre:String = "1" , 		// ———— - - Chiffre d'évolution
								 	  Methode:String = "+" ,  		// ———— - - Méthode de calcul
									  Defaut:String = "0"			// ———— - - Le chiffre par défaut
									):Number {
			/*—*/
			
			// S'il n'y a pas encore d'objet dent de scie —— - -
			if( !Exponential[ Nom ] ){
				
				// Créait l'objet et lui donne ses références
				Exponential[ Nom ] = new Object();
				Exponential[ Nom ].Valeur = Number( Defaut );
			}
			
			// Suivant la méthode —— - -
			switch( Methode ){
				
				// Addition
				case "+" : Exponential[ Nom ].Valeur += Number( Chiffre );
				break;
				
				// Soustraction
				case "-" : Exponential[ Nom ].Valeur -= Number( Chiffre );
				break;
				
				// Multiplication
				case "*" : Exponential[ Nom ].Valeur *= Number( Chiffre );
				break;
				
				// Division
				case "/" : Exponential[ Nom ].Valeur /= Number( Chiffre );
				break;
			}
			
			// Renvoie
			return( Exponential[ Nom ].Valeur );
		}
		
		
		
		/* —————————————————————————————————————————— - - VALUE - - —————————————————————————————————————————— */
		// Les méthodes retournant des valeurs issues de cible
		//*—*//
	  
	    // —————— VALUE
	    // Retourne une valeur duction d'une réécupération de valeur
		
		private function value( Chemin:String 	// ———— - - Chemin d'accès vers la valeur
								):* {
			/*—*/
			
			// S'il y a un centre de déploiement —— - -
			if( VortexCenter ){
				
				// S'il n'est pas "this" —— - -
				if( Chemin != "this" ){
				
					// Retourne la valeur
					return this[ "String2Element" ]( Chemin , VortexCenter );
					
				// S'il est "this" —— - -
				} else {
					
					// Retourne le VortexCenter
					return VortexCenter;
				}
			
			// S'il n'y a pas centre de déploiement —— - -
			} else {
				//
				this[ "TraceErreur" ]( "VorteX" , "valeur" , "Le VortexCenter n'a pas été donné au Script lançant l'Aspiration" );
				//
				return( NaN );
			}
		}
	  	
	  	
	    // —————— RANDOM VALUE
	    // Retourne un élément en aléatoire
		
		private function randomValue( Valeur:String = "0;1"		// ———— - - Valeurs
									  ):* {
			/*—*/
			
			// Convertie en tableau
			var leTableau:Array = Valeur.split( ";" );
			
			// Calcul et renvoie une des valeurs du tableau
			return( leTableau[ Math.round( Math.random() * ( leTableau.length - 1 ) ) ] );
		}
	  	
	  	
	    // —————— SCREEN
	    // Retourne la taille écran
		
		private function screen( Taille:String 	// ———— - - Taille demandée
							    ):Number {
			/*—*/
			
			// S'il y a un centre de déploiement —— - -
			if( VortexCenter ){
				
				// Hauteur —— - -
				if( Taille == "hauteur" ){
				
					// Retourne la valeur
					return VortexCenter.stage.stageHeight;
				
				// Largeur —— - - Par Défaut
				} else {
				
					// Retourne la valeur
					return VortexCenter.stage.stageWidth;
				}
			
			// S'il n'y a pas centre de déploiement —— - -
			} else {
				//
				this[ "TraceErreur" ]( "VorteX" , "valeur" , "Le VortexCenter n'a pas été donné au Script lançant l'Aspiration" );
				//
				return( NaN );
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - COLOR - - —————————————————————————————————————————— */
		// Les méthodes retournant des valeurs colorimétriques
		//*—*//
	  
	  
	    // —————— RANDOM COLOR
	    // Retourne une couleur aléatoire
		
		private function randomColor( Rouge:String = "" ,
									  Vert:String = "" ,
									  Bleu:String = ""
									 ):String {
			/*—*/
			
			// Retourne une valeur héxadécimal en aléatoire
			return( this[ "RandomHexadecimal" ]( Rouge , Vert , Bleu ) );
		}
	  	
	  	
	    // —————— NEAR COLOR
	    // Retourne une couleur aléatoire proche de celle donné
		
		private function nearColor( Couleur:String = "FFFFFF" ,
								    Min:String = "-10" ,
								    Max:String = "10"
								  ):String {
			/*—*/
			
			// Tire l'aléatoire
			var ValeurAleatoire:Number = this[ "Random" ]( Number( Min ) , Number( Max ) );
			
			// S'il est supérieur à zéro —— - - Eclaircie
			if( ValeurAleatoire > 0 ){
				return( this[ "Eclaircie" ]( Couleur , ValeurAleatoire ) );
			}
			
			// S'il est supérieur à zéro —— - - Eclaircie
			if( ValeurAleatoire <= 0 ){
				return( this[ "Assombrie" ]( Couleur , -ValeurAleatoire ) );
			}
			
			// Sinon —— - - Renvoie la couleur
			return Couleur;
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				POST-COMPILATION			  		  					  */
		/*										   Traitement de second ordre 					  				  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - CALCUL - - —————————————————————————————————————————— */
		// Les méthodes retournant des valeurs issues de calcul
		//*—*//
	  
	    // —————— ROUND
	    // Arrondie au chiffre le plus proche
		
		private function round( Chiffre:Number 	// ———— - - Le Chiffre en cours
							   ):Number { 
			/*—*/
			
			// Renvoie le calcul
			return Math.round( Chiffre ); 
		}
		
		
		// —————— CEIL
	    // Arrondie au seuil le plus proche
		
		private function ceil( Chiffre:Number 	// ———— - - Le Chiffre en cours
							   ):Number { 
			/*—*/
			
			// Renvoie le calcul
			return Math.ceil( Chiffre ); 
		}
		
		
		// —————— FLOOR
	    // Arrondie au palier
		
		private function floor( Chiffre:Number 	// ———— - - Le Chiffre en cours
							   ):Number { 
			/*—*/
			
			// Renvoie le calcul
			return Math.floor( Chiffre ); 
		}
		
		
		// —————— ABSOLUTE
	    // Fait passer en positif
		
		private function absolute( Chiffre:Number 	// ———— - - Le Chiffre en cours
							     ):Number { 
			/*—*/
			
			// Renvoie le calcul
			return Math.abs( Chiffre ); 
		}
		
		
		// —————— CHAOS
	    // Donne un chaos léger d'un aléatoire de -1 à 1 ou de moins une valeur à une autre
		
		private function chaos( Chiffre:Number ,  	// ———— - - Le Chiffre en cours
							    Valeur:* = 1 		// ———— - - Force de chaos
							  ):Number { 
			/*—*/
			
			// Renvoie le calcul
			return( Chiffre + ( Math.random() * ( Valeur * 2 ) - Valeur ) ); 
		}
		
		
		// —————— ADD
	    // Additionne une valeur 
		
		private function add( Chiffre:Number ,  	// ———— - - Le Chiffre en cours
							  Valeur:* = 1 			// ———— - - Valeur additionnée
							 ):Number {  
			/*—*/
			
			// Renvoie le calcul
			return( Chiffre + Number( Valeur ) ); 
		}
		
		
		// —————— SUBSTRACT
	    // Soustrais une valeur 
		
		private function substract( Chiffre:Number ,  	// ———— - - Le Chiffre en cours
								  	Valeur:* = 1 		// ———— - - Valeur soustraite
								  ):Number {  
			/*—*/
			
			// Renvoie le calcul
			return( Chiffre - Number( Valeur ) ); 
		}
		
		
		// —————— DIVIDE
	    // Divise par une valeur 
		
		private function divide( Chiffre:Number ,  	// ———— - - Le Chiffre en cours
								 Valeur:* = 2 		// ———— - - Valeur divisée
								):Number {  
			/*—*/
			
			// Renvoie le calcul
			return( Chiffre / Number( Valeur ) ); 
		}
		
		
		// —————— MULTIPLY
	    // Multiplie par une valeur 
		
		private function multiply( Chiffre:Number ,  	// ———— - - Le Chiffre en cours
								   Valeur:* = 2 		// ———— - - Valeur multipliée
								  ):Number { 
			/*—*/
			
			// Renvoie le calcul
			 return( Chiffre * Number( Valeur ) ); 
		}
		
		
		// —————— DIVIDE MULTIPLY
	    // Divise par une valeur puis multiplie par une autre
		
		private function divideMultiply( Chiffre:Number ,  	// ———— - - Le Chiffre en cours
										 Valeur1:* = 2 , 	// ———— - - Valeur divisée
										 Valeur2:* = 2 		// ———— - - Valeur multipliée
									   ):Number {  
			/*—*/
			
			// Renvoie le calcul
			return( Chiffre / Number( Valeur1 ) * Number( Valeur2 ) ); 
		}
		
		
		// —————— MULTIPLY DIVIDE
	    // Multiplie par une valeur puis divise par une autre
		
		private function multiplyDivide( Chiffre:Number ,  	// ———— - - Le Chiffre en cours
										 Valeur1:* = 2 , 	// ———— - - Valeur multipliée
										 Valeur2:* = 2 		// ———— - - Valeur divisée
									   ):Number {  
			/*—*/
			
			// Renvoie le calcul
			return( Chiffre * Number( Valeur1 ) / Number( Valeur2 ) );
		}
		
		
		
	
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}