<?php
	
	/***  ***/
	/***  ***/
	/***																											 ***/
	/***						  			  BRIDGE	  Version PHP 1.0.0										 	 ***/
	/***					  				 Dernire Mise  Jour : 10-07-09										 ***/
	/***																											 ***/
	/***  ***/
	/***																											 ***/
	/***										   		Pont de langage										 		 ***/
	/***	Une page Bridge tablie une liaison entre un langage et un autre, elle n'est constitu que de capacit	 ***/
	/***	de rception de donnes, compilation, xcution et renvoie.											 	 ***/
	/***																											 ***/
	/***  ***/
	/***									       cybORg version 0.05											 	 ***/
	/***									        MIND version 0.2											 	 ***/
	/***  ***/
	//
	//  Ockam Razor  ockam.razor@gmail.com
	// MIND universe  Since 26/12/2009
	
	
	/* >>>>> FONCTIONS <<<<< */
	
	// Les trois fonctions suivantes sont impratives et ne peuvent tre appels par des scripts car elles doivent agir avant et pour le chargement de ces scripts

	// 
	// CHARACTER CONVERSION
	// >>>> Convertie une chaine de caratre de faon  remplacer certains caractre par d'autres
	
	function bridge_CharacterConversion( $Chaine ,			// > La chaine de dpart
										 $CaractereDepart ,	// > Le ou les caractre de dpart
										 $CaractereFin		// > Le ou les caractre de fin
										){
		
		// Pour chaque caractres >
		for( $iCaractere = 0 ; $iCaractere < count( $CaractereDepart ) ; $iCaractere++ ){
			
			// Convertie ces caractres
			$TransvasChaine = split( $CaractereDepart[ $iCaractere ] , $Chaine );
			$Chaine = join( $CaractereFin[ $iCaractere ] , $TransvasChaine );
		}
		
		// Retourne la chaine
		return $Chaine;
	}
	
	// 
	// STRING TO NAME
	// >>> Convertie une chaine de caractre pour qu'elle soit exploitable par des transferts ou des nomination en code
	
	function bridge_StringToName( $Chaine ){
		//
		// Valeurs de conversion
		$ConversionNameToString = array( "__POINT__" , "__VIRGU__" , "__GUILL__" , "__GUILL2__" , "__MOINS__" , "__PLUS__" , "__SLASH__" , "__MULTI__" , "__EGAL__" , 
										 "__ASLASH__" , "__POVIR__" ,"__DEUPO__" , "__SPACE__" , "__EXCLA__" , "__ET__" , "__INTER__" , 
										 "__OUPAR__" , "__FEPAR__" , "__OUCRO__" , "__FECRO__" , "__OUACC__" , "__FEACC__" );
		$ConversionStringToName = array( "\." , "," , "'" , "\"" , "-" , "\+" , "/" , "\*" , "=" , "[\\]" , ";" , ":" , 
									 " " , "!" , "&" , "\?" , "\(" , ")" , "\[" , "]" , "\{" , "}" );
		//
		return( bridge_CharacterConversion( $Chaine , $ConversionStringToName , $ConversionNameToString ) );
	}

	// 
	// NAME TO STRING
	// >>> Convertie une chaine prconvertie par StringToName en chaine normale
	
	function bridge_NameToString( $Chaine ){
		//
		// Valeurs de conversion
		$ConversionNameToString = array( "__POINT__" , "__VIRGU__" , "__GUILL__" , "__GUILL2__" , "__MOINS__" , "__PLUS__" , "__SLASH__" , "__MULTI__" , "__EGAL__" , 
										 "__ASLASH__" , "__POVIR__" ,"__DEUPO__" , "__SPACE__" , "__EXCLA__" , "__ET__" , "__INTER__" , 
										 "__OUPAR__" , "__FEPAR__" , "__OUCRO__" , "__FECRO__" , "__OUACC__" , "__FEACC__" );
		$ConversionStringToName = array( "." , "," , "'" , "\"" , "-" , "+" , "/" , "*" , "=" , "\\" , ";" , ":" , 
									 " " , "!" , "&" , "?" , "(" , ")" , "[" , "]" , "{" , "}" );
		//
		return( bridge_CharacterConversion( $Chaine , $ConversionNameToString , $ConversionStringToName ) );
	}
	
	
	/* >>>>> RCEPTION <<<<< */
	
	// Rcupration du code, liens et scripts
	$Code = bridge_NameToString( stripslashes( $_POST[ "Code" ] ) );
	$LienmEkA = bridge_NameToString( stripslashes( $_POST[ "LienmEkA" ] ) );
	$Scripts = split( "," , bridge_NameToString( stripslashes( $_POST[ "Scripts" ] ) ) );
	//
	$Retour = $_POST[ "Retour" ];
	
	// Mise par dfaut des lments reus
	$Code = ( $Code == "" ) ? null : (string) $Code;
	$LienmEkA = ( $LienmEkA == "" ) ? "../../mEkA" : (string) $LienmEkA;
	$Scripts = ( count( $Scripts ) == 1 && $Scripts[ 0 ] == "" ) ? array() : $Scripts;
	
	// Par dfaut, MiscTools de mEkA est charg
	array_push( $Scripts , "Global/MiscTools" );
	
	
	/* >>>>> COMPILATION <<<<< */
	
	// Chargement des scripts
	//
	// Pour chaque script >
	for( $iScript = 0 ; $iScript < count( $Scripts ) ; $iScript++ ){
		
		// Charge le script
		require_once( $LienmEkA . "/" . $Scripts[ $iScript ] . ".inc.php" );
	}
	
	// Dcryptage du code
	$Code = bridge_NameToString( $Code );
	
	
	/* >>>>> XCUTION <<<<< */
	//
	// Lancement d'un eval
	eval( $Code );
	
	
	/* >>>>> RENVOIE <<<<< */
	//
	// Sortie s'il doit y avoir un retour
	if( $Retour != "false" ){
		//
		echo( $Sortie );
	}
?>