﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			GRID GENERATOR	  		Version 0.3.0									***/
/***				   				   Dernière Mise à Jour : 03-09-10										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         				    Générateur Grille											***/
/***	Ce script génére une matrice abstraite et interrargie dans son remplissage afin de créer des  	    ***/
/***	chemins à l'intérieur, des placements d'objets les un par rapport aux autres, etc. 					***/
/***	La matrice ainsi réalisé est exploitable par la suite.							 					***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Creation {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	
	// —— - - DISPLAY
	import flash.display.MovieClip;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class GridGenerator extends MiscTools {
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function GridGenerator( TheLink:* = null		// ———— - - Lien vers la scène
									 ):void {
			/*—*/
			
			// Établit la connexion
			Connexion( TheLink );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				  CREATION						  		  				  */
		/*					 			 Méthodes pour créer un objet de grille 				  				  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - GET - - —————————————————————————————————————————— */
		// Les méthodes utilisées pour récupérer des objets grilles
		//*—*//
		
		// —————— NEW GRID
		// Créé et retourne une grille standard sous forme d'objet avec la grille dans un tableau de l'objet
		
		public function NewGrid( Ligne:int = 10 ,	// ———— - - Nombre de lignes
								 Collone:int = 10 	// ———— - - Nombre de collones
							   ):Object {
			/*—*/
			
			// Création de l'objet Grille
			var NouvelleGrille:Object = new Object();
			//
			NouvelleGrille.Grille = new Array();
			
			// Récupération de la hauteur et largeur
			NouvelleGrille.Vertical = Ligne - 1;
			NouvelleGrille.Horizontal = Collone - 1;
			//
			NouvelleGrille.Cases = Ligne * Collone;
			
			// Pour chaque ligne ———— - -
			for( var iLigne:int = 0 ; iLigne <= NouvelleGrille.Vertical ; iLigne++ ){
				
				// Création du tableau de la ligne
				NouvelleGrille.Grille[ iLigne ] = new Array();
				
				// Pour chaque collone ———— - -
				for( var iCollone:int = 0 ; iCollone <= NouvelleGrille.Horizontal ; iCollone++ ){
					
					// Création de la case
					NouvelleGrille.Grille[ iLigne ][ iCollone ] = new Object();
					
					// Remplissage de la collone avec les valeurs initiales
					NouvelleGrille.Grille[ iLigne ][ iCollone ].Horizontal = iCollone;	// ———— - - Son Numéro de collone
					NouvelleGrille.Grille[ iLigne ][ iCollone ].Vertical = iLigne;		// ———— - - Son Numéro de ligne
				}
			}
			
			// Retourne la grille
			return NouvelleGrille;
	    }
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				    WAY						  		  				  	  */
		/*					 		 Méthodes pour intégrer des chemins à une grille 				  			  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - SET - - —————————————————————————————————————————— */
		// Les méthodes utilisées pour intégrer des chemins
		//*—*//
		
		// —————— ADD MAP
	    // Intégre à une grille un mapping labirynthique basé sur une valeur vrai ou fausse et retourne cette grille
	  
		public function AddMap( Grille:Object ,				// ———— - - La Grille initial ( Tout l'objet et non son objet "Grille" )
							    Cases:* = null ,			// ———— - - Nombre de case à ouvrir
								Valeur:String = "Ouvert" ,	// ———— - - Nom de la variable transmise pour les parties ouvertes
								Detection:Boolean = false	// ———— - - S'il faut effectuer une détection des ouvertures des directions à la fin
							  ):Object {
			/*—*/
			
			/* ► INITIALISATION ◄ */
			
			// Vérifie si la Grille est bonne
			var GrilleCorrecte:Boolean = true;
			//
			// Si la grille ne contient pas l'objet "Grille" —— - - Trace l'erreur
			if( !Grille.Grille ){
				//
				TraceError( "GridGenerator" , "AddMap" , "Vous devez transmettre à cette méthode un objet grille contenant la clé «Grille»." );
				//
				GrilleCorrecte = false;
			}
			//
			try {
				//
				// Si la grille ne contient pas l'agencement adéquate —— - - Trace l'erreur
				if( !Grille.Grille[ 0 ][ 0 ] ){
					//
					TraceError( "GridGenerator" , "AddMap" , "La grille transmise doit contenir un tableau à deux niveau compilé " + 
																  "par la méthode NewGrid()." );
					//
					GrilleCorrecte = false;
				}
			} catch( e ){
				//
				TraceError( "GridGenerator" , "AddMap" , "La grille transmise doit contenir un tableau à deux niveau compilé " + 
															  "par la méthode NewGrid()." );
				//
				GrilleCorrecte = false;
			}
			
			
			// Si la grille est correcte —— - -
			if( GrilleCorrecte ){
				
				
				// Arguments par défaut
				Cases = ( Cases == null ) ? Grille.Cases / 4 : MathOperator( Grille.Cases , Cases );
				
				// Si on a demandé trop de Cases —— - - Trace l'erreur et le mes par défaut
				if( Cases > Grille.Cases ){
					
					TraceError( "GridGenerator" , "AddMap" , [ "Vous avez demandé à ouvrir " + Cases + " cases dans votre grille, or celle-ci" ,
																"n'en possède que " + Grille.Cases + "." ,
																"Vous devez toujours indiquer un nombre de cases à ouvrir plus petit que le nombre" ,
																"de cases total de votre grille." ] )
					//
					Cases = Grille.Cases / 4;
				}
				
				// Commence par fermer tout les objets de la grille —— - -
				for( var Clee1:int = 0 ; Clee1 < Grille.Grille.length ; Clee1++ ){ 
					//
					for( var Clee2:int = 0 ; Clee2 < Grille.Grille[ Clee1 ].length ; Clee2++ ){ 
						//
						Grille.Grille[ Clee1 ][ Clee2 ][ Valeur ] = false; 
					}
				}
				
				// Prend un point de départ au hasard
				var ElementControl:Object = new Object();
				//
				ElementControl.Depart1 = Random( 0 , Grille.Vertical , true );
				ElementControl.Depart2 = Random( 0 , Grille.Horizontal , true );
				
				// Variable de sécurité sur les redondance
				var MaxSecurite:int = 10;
				var Securite:int = MaxSecurite;
				//
				var SecuriteMultiplicatif:int = Math.max( Grille.Horizontal , Grille.Vertical ) / 1.5;
				
				// Variable de test
				var CaseVoulu:int = Cases;
				var CaseTotal:int = 0;
				var CaseOuverte:int = 0;
				var CaseRedondante:int = 0;
				
				
				/* ► CREATION CHEMIN ◄ */
				
				// Tans qu'on a pas obtenu le nombre suffisant de cases ouvertes —— - -
				while( Cases > 0 ){
					
					// Une occurence de case en plus
					CaseTotal++;
					
					// Si la case n'est pas déjà ouverte ou si la sécurité est à zéro —— - -
					if( !Grille.Grille[ ElementControl.Depart1 ][ ElementControl.Depart2 ][ Valeur ] 
					 || Securite <= 0 ){
						
						// Ouvre la case en court
						Grille.Grille[ ElementControl.Depart1 ][ ElementControl.Depart2 ][ Valeur ] = true;
							
						// Réduit le nombre de cases restantes
						Cases--;
							
						// Indique le type de Case ajoutée —— - -
						if( Securite == 0 ){ CaseRedondante++ }
						else { CaseOuverte++ }
						
						// Sécurité au max
						Securite = MaxSecurite;
							
					} else { 
						
						// Réduit la sécuritée
						Securite--;
					}
					
					// Levier pour le passage suivant
					var Levier:Boolean = false;
					
					// Multiplicatif des niveau de recherche
					var Multiplicatif:int = 1;
					
					// Mémorise la case
					ElementControl.MemoryDepart1 = ElementControl.Depart1;
					ElementControl.MemoryDepart2 = ElementControl.Depart2;
					
			
					
					
					// Tans qu'on est locké et que le multiplicatif est inférieur à la sécurité —— - -
					while( !Levier && Multiplicatif < SecuriteMultiplicatif ){
						
						// Définit un tableau pour la prochaine direction
						var Direction:Array = [ [ 1 , 0 ] , [ -1 , 0 ] , 
												[ 0 , 1 ] , [ 0 , -1 ] ];
						//
						var MemoDirection:Array = CloneObject( Direction );
						
						// Convertie puis Retire les directions sortant de la grille
						for( var iDir:int = 0 ; iDir < MemoDirection.length ; iDir++ ){
							
							// Convertie par le multiplicatif
							MemoDirection[ iDir ][ 0 ] *= Multiplicatif;
							MemoDirection[ iDir ][ 1 ] *= Multiplicatif;
							
							// Vérifie et retire —— - -
							if( Grille.Grille[ ElementControl.Depart1 + MemoDirection[ iDir ][ 0 ] ] ){
								//
								if( !Grille.Grille[ ElementControl.Depart1 + MemoDirection[ iDir ][ 0 ] ]
												  [ ElementControl.Depart2 + MemoDirection[ iDir ][ 1 ] ] ){
									//
									Direction = DeleteFromArray( Direction , MemoDirection[ iDir ] );
								}
								//
							} else { Direction = DeleteFromArray( Direction , MemoDirection[ iDir ] ); }
						}
						
						// Tans qu'il reste plus d'une direction possible —— - -
						while( Direction.length >= 1 ){
							
							// Donne la direction suivante au hasard
							var DirectionSuivante:Array = RandomArray( Direction );
							
							// Si la nouvelle destination est déjà ouverte et si ce n'est pas le dernier du tableau
							if( Grille.Grille[ ElementControl.Depart1 + DirectionSuivante[ 0 ] ]
											 [ ElementControl.Depart2 + DirectionSuivante[ 1 ] ][ Valeur ] ){
								//
								// Retire cette direction du tableau
								Direction = DeleteFromArray( Direction , DirectionSuivante );
			
							
							// Sinon —— - - C'est la prochaine direction
							} else {
								//
								ElementControl.Depart1 += DirectionSuivante[ 0 ];
								ElementControl.Depart2 += DirectionSuivante[ 1 ];
								//
								Direction = [];
								//
								Levier = true;
							}
							
							// S'il n'y a plus rien dans le tableau —— - - Relance avec un Multiplicatif plus élevé
							if( Direction.length == 0 ){ Multiplicatif++; }
						}
					}
				}
				
				// Vérifie la correspondance de sortie —— - - Trace l'erreur si elle n'est pas parfaite
				if( CaseVoulu != CaseOuverte ){
					//
					TraceError( "GridGenerator" , "AddMap" , [ "Un taux d'erreur a été repéré sur la grille." ,
																"Sur " + CaseVoulu + " demandée, " + CaseOuverte + 
																" seulement ont été ouvertes pour " + 
																CaseRedondante + " cases redondantes." , 
																"Si vous souhaitez éviter ce taux d'erreur, " + 
																"essayer d'indiquer un nombre de cases à" ,
																"ouvrir moins proche du total de case dans la grille." ] )
				}
				
				
				/* ► DETECTION ◄ */
				
				// S'il faut faire une détection —— - -
				if( Detection ){
					
					// Pour chaque case de la grille —— - -
					for( var iLigne in Grille.Grille ){
						//
						for( var iCollone:* in Grille.Grille[ iLigne ] ){
							
							// Récupère la case
							var Case:Object = Grille.Grille[ iLigne ][ iCollone ];
							
							// Si celle de droite existe et est ouverte —— - - La détecte
							if( Grille.Grille[ iLigne ][ iCollone + 1 ] ){
								//
								if( Grille.Grille[ iLigne ][ iCollone + 1 ][ Valeur ] ){ Case[ "Droite" + ( ( Valeur == "Ouvert" ) ? "" : Valeur ) ] = true; }
							}
							
							// Si celle de gauche existe et est ouverte —— - - La détecte
							if( Grille.Grille[ iLigne ][ iCollone - 1 ] ){
								//
								if( Grille.Grille[ iLigne ][ iCollone - 1 ][ Valeur ] ){ Case[ "Gauche" + ( ( Valeur == "Ouvert" ) ? "" : Valeur ) ] = true; }
							}
							
							// Si celle du bas existe et est ouverte —— - - La détecte
							if( Grille.Grille[ iLigne + 1 ] ){
								//
								if( Grille.Grille[ iLigne + 1 ][ iCollone ][ Valeur ] ){ Case[ "Bas" + ( ( Valeur == "Ouvert" ) ? "" : Valeur ) ] = true; }
							}
							
							// Si celle du haut existe et est ouverte —— - - La détecte
							if( Grille.Grille[ iLigne - 1 ] ){
								//
								if( Grille.Grille[ iLigne - 1 ][ iCollone ][ Valeur ] ){ Case[ "Haut" + ( ( Valeur == "Ouvert" ) ? "" : Valeur ) ] = true; }
							}
						}
					}
				}
			}
			
			// Retourne la grille
			return Grille;
		}
		
		
		// —————— ADD LABYRINTH
		// Intégre à une grille un chemin labirynthique basé sur des ouvertures Haut, Bas, Gauche et Droite
		// A la différence du mapping, le chemin parcour la totalité de la map
	  
		public function AddLabyrinth( Grille:Object ,		// ———— - - La Grille initial ( Tout l'objet et non son objet "Grille" )
									  Valeur:String = "" ,	// ———— - - Nom de la variable transmise pour les parties ouvertes
									  Case:* = null			// ———— - - La Case d'où l'on part
								    ):Object {
			/*—*/
			
			/* ► INITIALISATION ◄ */
			
			// Vérifie si la Grille est bonne
			var GrilleCorrecte:Boolean = true;
			//
			// Si la grille ne contient pas l'objet "Grille" —— - - Trace l'erreur
			if( !Grille.Grille ){
				//
				TraceError( "GridGenerator" , "AddLabyrinth" , "Vous devez transmettre à cette méthode un objet grille contenant la clé «Grille»." );
				//
				GrilleCorrecte = false;
			}
			//
			try {
				//
				// Si la grille ne contient pas l'agencement adéquate —— - - Trace l'erreur
				if( !Grille.Grille[ 0 ][ 0 ] ){
					//
					TraceError( "GridGenerator" , "AddLabyrinth" , "La grille transmise doit contenir un tableau à deux niveau compilé " + 
																  "par la méthode NewGrid()." );
					//
					GrilleCorrecte = false;
				}
			} catch( e ){
				//
				TraceError( "GridGenerator" , "AddLabyrinth" , "La grille transmise doit contenir un tableau à deux niveau compilé " + 
															  "par la méthode NewGrid()." );
				//
				GrilleCorrecte = false;
			}
			
			
			// Si la grille est correcte —— - -
			if( GrilleCorrecte ){
				
				// Argument par défaut
				Case = Case || new Array();
				
				// Prend un point de départ au hasard
				var Depart1:int = ( Case[ 0 ] == null ) ? Random( 0 , Grille.Vertical , true ) : Case[ 0 ];
				var Depart2:int = ( Case[ 1 ] == null ) ? Random( 0 , Grille.Horizontal , true ) : Case[ 1 ];
				
				// Liste des cases consultées
				var ListeCasesConsultees:Array = new Array();
		
				
				/* ► CREATION CHEMIN ◄ */
				
				// En boucle —— - -
				while( true ){
					
					// Récupère la case concernée
					var CaseEnCours:Object = Grille.Grille[ Depart1 ][ Depart2 ];
					
					CaseEnCours.OK = true;
					
					// Les quatres directions
					var Direction:Array = [ [ 1 , 0 , "Bas" , "Haut" ] , 	  [ -1 , 0 , "Haut" , "Bas" ] , 
											[ 0 , 1 , "Droite" , "Gauche" ] , [ 0 , -1 , "Gauche" , "Droite" ] ];
					
					// Levier de brisure
					var LevierBreak:Boolean = false;
					
					// Tans qu'il reste des directions —— - -
					while( Direction.length > 0 ){
						
						// Tire une direction au hasard
						var DirectionAleatoire:Array = RandomArray( Direction );
						
						// Si elle est viable —— - -
						if( Grille.Grille[ Depart1 + DirectionAleatoire[ 0 ] ] ){
							//
							if( Grille.Grille[ Depart1 + DirectionAleatoire[ 0 ] ][ Depart2 + DirectionAleatoire[ 1 ] ] ){
					
								// Si elle n'a pas déjà une ouverture —— - -
								if( !Grille.Grille[ Depart1 + DirectionAleatoire[ 0 ] ][ Depart2 + DirectionAleatoire[ 1 ] ][ "Haut" + Valeur ]
								 && !Grille.Grille[ Depart1 + DirectionAleatoire[ 0 ] ][ Depart2 + DirectionAleatoire[ 1 ] ][ "Bas" + Valeur ]
								 && !Grille.Grille[ Depart1 + DirectionAleatoire[ 0 ] ][ Depart2 + DirectionAleatoire[ 1 ] ][ "Gauche" + Valeur ]
								 && !Grille.Grille[ Depart1 + DirectionAleatoire[ 0 ] ][ Depart2 + DirectionAleatoire[ 1 ] ][ "Droite" + Valeur ] ){
									
									// Suivant le prochain, donne la direction à la case en cour
									Grille.Grille[ Depart1 ][ Depart2 ][ DirectionAleatoire[ 2 ] + Valeur ] = true;
									
									// Liste la case
									if( ListeCasesConsultees.length == 0 ){
										ListeCasesConsultees.push( Grille.Grille[ Depart1 ][ Depart2 ] );
									}
									
									// Change la case en cours pour elle
									Depart1 += DirectionAleatoire[ 0 ];
									Depart2 += DirectionAleatoire[ 1 ];
									
									// Suivant le prochain, donne la direction à la case en cour
									Grille.Grille[ Depart1 ][ Depart2 ][ DirectionAleatoire[ 3 ] + Valeur ] = true;
									
									// Liste la case
									ListeCasesConsultees.push( Grille.Grille[ Depart1 ][ Depart2 ] );
									
									// Retire les Directions
									Direction = [];
									
									// Active le levier
									LevierBreak = true;
									
									// Casse la boucle
									break;
									
								// Sinon —— - - Retire cette direction
								} else { Direction = DeleteFromArray( Direction , DirectionAleatoire ); }
							
									
							// Sinon —— - - Retire cette direction
							} else { Direction = DeleteFromArray( Direction , DirectionAleatoire ); }
						
									
						// Sinon —— - - Retire cette direction
						} else { Direction = DeleteFromArray( Direction , DirectionAleatoire ); }
					}
					
					// Si le levier n'a pas été activé —— - - Casse la boucle
					if( !LevierBreak ){ break; }
				}
			}
			
			
			// Pour chaque case —— - -
			for( var iList:int = 0 ; iList < ListeCasesConsultees.length ; iList++ ){
				
				// Définit le levier de lancement
				var LevierLancement:Boolean = false;
				//
				// Définit les variables de boucle for
				var TableauDeLancement1:Array = [ [ 1 , 0 ] , [ -1 , 0 ] , [ 0 , 1 ] , [ 0 , -1 ] ];
				var TableauDeLancement2:Array = [ "Bas" , "Haut" , "Gauche" , "Droite" ];
				
				// Si la case existe —— - -
				if( ListeCasesConsultees[ iList ] ){
					
					// Pour les quatres cases autour de lui —— - -
					for( var iLance:int = 0 ; iLance < 4 ; iLance++ ){
						
						// Si la vertical existe —— - -
						if( Grille.Grille[ ListeCasesConsultees[ iList ].Vertical + TableauDeLancement1[ iLance ][ 0 ] ] ){
							
							// Si l'horizontal existe —— - -
							if( Grille.Grille[ ListeCasesConsultees[ iList ].Vertical + TableauDeLancement1[ iLance ][ 0 ] ]
											 [ ListeCasesConsultees[ iList ].Horizontal + TableauDeLancement1[ iLance ][ 1 ] ] ){
								
								// Levier de lancement par la valeur
								var LevierSoudainValeur:Boolean = true
								
								// Pour chaque valeur —— - -
								for( var iValeur:int = 0 ; iValeur < TableauDeLancement2.length ; iValeur++ ){
									
									// Si la case la possède déjà —— - -
									if( Grille.Grille[ ListeCasesConsultees[ iList ].Vertical + TableauDeLancement1[ iLance ][ 0 ] ]
												 [ ListeCasesConsultees[ iList ].Horizontal + TableauDeLancement1[ iLance ][ 1 ] ]
												 [ TableauDeLancement2[ iValeur ] + Valeur ] ){
		
										// Verouille le levier
										LevierSoudainValeur = false;
									}
								}
								
								// Si le levier n'a pas été vérouillé —— - - Déverouille le levier de lancement
								if( LevierSoudainValeur ){ LevierLancement = true; };
							}
						}
					}
				}
				
				// Si le levier de lancement est déverouillé —— - -
				if( LevierLancement ){
		
					// Lance la création d'un nouveau sentier à partir de cette case
					AddLabyrinth( Grille , Valeur , [ ListeCasesConsultees[ iList ].Vertical , ListeCasesConsultees[ iList ].Horizontal ] );
				}
			}
			
			// Retourne la grille
			return Grille;
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				    ELEMENT						  		  				  */
		/*					 		 Méthodes pour intégrer des éléments à une grille 				  			  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - SET - - —————————————————————————————————————————— */
		// Les méthodes utilisées pour intégrer des éléments
		//*—*//
		
		// —————— ADD ELEMENTS
		// Dissémines X nombre d'éléments dans une grille en prenant en conscidération des valeurs particulières sur demande 
		
		public function AddElements( Grille:Object ,		// ———— - - La Grille initial ( Tout l'objet et non son objet "Grille" )
									 Element:String ,		// ———— - - Nom de l'élément a disséminer
									 Valeur:* = true ,		// ———— - - ¤ Valeur de l'élément à disséminer
									 Nombre:* = 1 ,			// ———— - - ¤ Nombre de cet élément à disséminer
									 Max:int = -1 ,			// ———— - - Max de cet élément à disséminer
									 Imperatif:* = "" ,		// ———— - - Valeur impérative pour la case visée 
															//			( Nom simple ou tableau [ Nom , Valeur ] )
									 Contreperatif:* = ""	// ———— - - Valeur que la case visée ne doit pas avoir 
															// 			( Nom simple ou tableau [ Nom , Valeur , 
															//			( [ Min Case Verti , Min Case Hori ) ] )
								   ):Object {
			/*—*/
			
			/* ► INITIALISATION ◄ */
			
			// Vérifie si la Grille est bonne
			var GrilleCorrecte:Boolean = true;
			//
			// Si la grille ne contient pas l'objet "Grille" —— - - Trace l'erreur
			if( !Grille.Grille ){
				//
				TraceError( "GridGenerator" , "AddElements" , "Vous devez transmettre à cette méthode un objet grille contenant la clé «Grille»." );
				//
				GrilleCorrecte = false;
			}
			//
			try {
				//
				// Si la grille ne contient pas l'agencement adéquate —— - - Trace l'erreur
				if( !Grille.Grille[ 0 ][ 0 ] ){
					//
					TraceError( "GridGenerator" , "AddElements" , "La grille transmise doit contenir un tableau à deux niveau compilé " + 
																  "par la méthode NewGrid()." );
					//
					GrilleCorrecte = false;
				}
			} catch( e ){
				//
				TraceError( "GridGenerator" , "AddElements" , "La grille transmise doit contenir un tableau à deux niveau compilé " + 
															  "par la méthode NewGrid()." );
				//
				GrilleCorrecte = false;
			}
			
			
			// Si la grille est correcte —— - -
			if( GrilleCorrecte ){
				
				
				// Aspire le nombre
				Nombre = Aspiration( Nombre );
				
				// Compile le max
				Max = ( Max == -1 ) ? Max = 9999999999999 : Max;
				
				// Compile l'Impératif et Contreperatif
				Imperatif = ( Imperatif != "" && TypeOf( Imperatif , "String" ) ) ? [ Imperatif , true ] : Imperatif;
				Contreperatif = ( Contreperatif != "" && TypeOf( Contreperatif , "String" ) ) ? [ Contreperatif , true ] : Contreperatif;
				//
				Contreperatif[ 2 ] = Contreperatif[ 2 ] || [ 0 , 0 ];
				Contreperatif[ 2 ][ 1 ] = Contreperatif[ 2 ][ 1 ] || Contreperatif[ 2 ][ 0 ];
				
				
				/* ► INTEGRATION ELEMENTS ◄ */
				
				// Pour chaque éléments à intégrer —— - -
				for( Nombre ; Nombre > 0 ; Nombre-- ){
					
					// Variable de la case aléatoire tirée
					var CaseAleatoire:Object;
					
					// Levier de case validée
					var LevierCaseAleatoire:Boolean = false;
					
					// Levier d'erreur ( Au cas où il y ait trop d'occurence )
					var LevierErreur:Array = [ 0 , 0 ];
					
					// Tans qu'on n'a pas la bonne case —— - -
					while( !LevierCaseAleatoire ){
						
						// Levier internes
						var LevierValeur:Boolean = false;
						var LevierImperatif:Boolean = false;
						var LevierContreperatif:Boolean = false;
						
						// Récupère une case en aléatoire
						CaseAleatoire = Grille.Grille[ Random( 0 , Grille.Grille.length - 1 , true ) ][ Random( 0 , Grille.Grille[ 0 ].length - 1 , true ) ];
						
						// S'il ne s'agit pas d'une incrémentation et qu'il n'est pas déjà dessus ou s'il est une incrémentation qui n'est pas au max —— - -
						if( !FindIn( Valeur , "+" ) && CaseAleatoire[ Element ] != Valeur
						 || FindIn( Valeur , "+" ) && MathOperator( CaseAleatoire[ Element ] || 0 , Valeur ) < Max ){
							
							// Débloque son levier
							LevierValeur = true;
						}
						
						// Si la case contient les bonnes valeurs —— - -
						if( Imperatif == "" 
						 || CaseAleatoire[ Imperatif[ 0 ] ] == Imperatif[ 1 ] ){
							
							// Débloque son levier
							LevierImperatif = true;
						
						// Sinon —— - - Augmente le levier d'erreur
						} else { 
							//
							LevierErreur[ 0 ]++ 
							//
							// S'il est trop élevé —— - - Erreur et passage au suivant
							if( LevierErreur[ 0 ] >= 3000 ){
								//
								TraceError( "GridGenerator" , "AddElements" , [ "Erreur de dissémination de l'élément «" + Element + "»." ,
																				"L'élément en question nécessite la variable «" + Imperatif[ 0 ] + "»" +
																				" de valeur " + Imperatif[ 1 ] + "." ,
																				"Après 3000 itération, l'élément n'est toujours pas repéré, il se peut" ,
																				"qu'il n'existe pas dans la grille." ] );
								//
								LevierCaseAleatoire = true;
							}
						}
						
						
						// Débloque son levier de Contreperatif
						LevierContreperatif = true;
						
						// Pour chaque case de bump contreperatif en Vertical —— - -
						for( var iContreV:int = 0 ; iContreV <= Contreperatif[ 2 ][ 0 ] ; iContreV++ ){
							
							// Pour chaque case de bump contreperatif en Horizontal —— - -
							for( var iContreH:int = 0 ; iContreH <= Contreperatif[ 2 ][ 1 ] ; iContreH++ ){
								
								// Liste des cases à vérifier
								var ListeCasesVerifiee:Array = [ [ iContreV , iContreH ] , [ -iContreV , -iContreH ] , 
																 [ iContreV , -iContreH ] , [ -iContreV , iContreH ] , ];
								
								// Pour les quatres cases à vérifier —— - -
								for( var iContre:int = 0 ; iContre < ListeCasesVerifiee.length ; iContre++ ){
									
									// Si elle existe en verical —— - -
									if( Grille.Grille[ CaseAleatoire.Vertical + ListeCasesVerifiee[ iContre ][ 0 ] ] ){
										
										// Si elle existe en horizontal —— - -
										if( Grille.Grille[ CaseAleatoire.Vertical + ListeCasesVerifiee[ iContre ][ 0 ] ]
														 [ CaseAleatoire.Horizontal + ListeCasesVerifiee[ iContre ][ 1 ] ] ){
											
											// Si elle possède la valeur contreperative —— - -
											if( Grille.Grille[ CaseAleatoire.Vertical + ListeCasesVerifiee[ iContre ][ 0 ] ]
															 [ CaseAleatoire.Horizontal + ListeCasesVerifiee[ iContre ][ 1 ] ]
															 [ Contreperatif[ 0 ] ] == Contreperatif[ 1 ] ){
											
												// Bloque le levier Contreperatif
												LevierContreperatif = false;
											}
										}
									}
								}
							}
						}
						

						// Si la case contient la mauvaise valeur —— - - Augmente le levier d'erreur
						if( !LevierContreperatif ){ 
							//
							LevierErreur[ 1 ]++ 
							//
							// S'il est trop élevé —— - - Erreur et passage au suivant
							if( LevierErreur[ 1 ] >= 3000 ){
								//
								TraceError( "GridGenerator" , "AddElements" , [ "Erreur de dissémination de l'élément «" + Element + "»." ,
																				"L'élément en question réfute la variable «" + Contreperatif[ 0 ] 
																				+ "»" +
																				" de valeur " + Contreperatif[ 1 ] + "." ,
																				"Après 3000 itération, l'élément est constamment repéré, il se peut" ,
																				"que trop de cases dans la grille contienne cette variable." ] );
								//
								LevierCaseAleatoire = true;
							}
						}
						
						// Si tout les leviers sont déverrouiller —— - - Déverrouille le grand levier
						if( LevierImperatif && LevierContreperatif && LevierValeur ){ 
							//
							LevierCaseAleatoire = true;
						}
					}
						
					// Donne à cette case aléatoire la valeur voulue
					CaseAleatoire[ Element ] = ( !FindIn( Valeur , "+" ) ) ? Aspiration( Valeur ) : MathOperator( CaseAleatoire[ Element ] || 0 , Valeur );
				}
			}
			
			// Retourne la grille
			return Grille;
	  	}
		
		
		// —————— ADD BONES
		// Intégre des ligne de cases portant l'élément voulue en vertical ou horizontal
	  
		public function AddBones( Grille:Object ,		// ———— - - La Grille initial ( Tout l'objet et non son objet "Grille" )
								  Element:String ,		// ———— - - Nom de l'élément a disséminer
								  Nombre:* = 10 ,		// ———— - - ¤ Nombre de ligne à créer
								  MaxV:int = 6 ,		// ———— - -	Taille en case maximum pour la vertical 
								  						//			( 0 pour qu'il n'y ait pas de ligne en vertical )
								  MinV:int = 3 ,		// ———— - - Taille en case minimum pour la vertical
								  MaxH:int = 6 ,		// ———— - - Taille en case maximum pour l'horizontal 
								  						//			( 0 pour qu'il n'y ait pas de ligne en horizontal )
								  MinH:int = 3 			// ———— - - Taille en case minimum pour l'horizontal
								):Object {
			/*—*/
			
			/* ► INITIALISATION ◄ */
			
			// Variable de sortie
			var Sortie:Array = new Array();
			
			// Vérifie si la Grille est bonne
			var GrilleCorrecte:Boolean = true;
			//
			// Si la grille ne contient pas l'objet "Grille" —— - - Trace l'erreur
			if( !Grille.Grille ){
				//
				TraceError( "GridGenerator" , "AddBones" , "Vous devez transmettre à cette méthode un objet grille contenant la clé «Grille»." );
				//
				GrilleCorrecte = false;
			}
			//
			try {
				//
				// Si la grille ne contient pas l'agencement adéquate —— - - Trace l'erreur
				if( !Grille.Grille[ 0 ][ 0 ] ){
					//
					TraceError( "GridGenerator" , "AddBones" , "La grille transmise doit contenir un tableau à deux niveau compilé " + 
																  "par la méthode NewGrid()." );
					//
					GrilleCorrecte = false;
				}
			} catch( e ){
				//
				TraceError( "GridGenerator" , "AddBones" , "La grille transmise doit contenir un tableau à deux niveau compilé " + 
															  "par la méthode NewGrid()." );
				//
				GrilleCorrecte = false;
			}
			
			
			// Si la grille est correcte —— - -
			if( GrilleCorrecte ){
				
				
				// Aspire le nombre
				Nombre = Aspiration( Nombre );
				
				
				/* ► INTEGRATION ELEMENTS ◄ */
				
				// Variable d'erreur en cas de boucle infinie
				var LevierErreur:int = 0;
				
				// Tans que l'on a pas intégré tout les éléments —— - -
				while( Nombre > 0 ){
					
					// Choisit une case aléatoire
					var CaseAleatoire:Object = Grille.Grille[ Random( 0 , Grille.Grille.length - 1 , true ) ]
															[ Random( 0 , Grille.Grille[ 0 ].length - 1 , true ) ];
															
					// Levier de vérification
					var LevierVerification:Boolean = true;
					
					// Tire sa direction en aléatoire
					var Direction:String;
					//
					if( MaxV == 0 ){ Direction = "Horizontal"; }
					else if( MaxH == 0 ){ Direction = "Vertical"; }
					else { Direction = RandomArray( [ "Horizontal" , "Vertical" ] ); }
					
					// Tire le nombre de cases réalisées pour elle en aléatoire
					var NombreCase:int = ( Direction == "Vertical" ) ? Random( MinV , MaxV , true ) : Random( MinH , MaxH , true );
					
					// Pour chaque case à réaliser —— - -
					for( var iCase:int = 0 ; iCase < NombreCase ; iCase++ ){
						
						// Variable d'instance de la case
						var laCase:Object = new Object();
						
						// Essaye —— - -
						try {
							
							// Récupère cette case pour la sonder
							laCase = ( Direction == "Vertical" ) ? Grille.Grille[ CaseAleatoire.Vertical + iCase ][ CaseAleatoire.Horizontal ] :
																   Grille.Grille[ CaseAleatoire.Vertical ][ CaseAleatoire.Horizontal + iCase ];
																   
						//
						} catch( e ){
		
							laCase = null;
						}
		
						// Teste la viabilité de cette case
						if( laCase ){
							//
							if( laCase[ Element ] ){
								//
								LevierVerification = false;
								
								// Le taux d'erreur augmente —— - - En cas de dépassement, on interrompt tout
								LevierErreur++;
								//
								if( LevierErreur >= 3000 ){
									//
									LevierVerification = true;
								}
							}
						} else {
							//
							LevierVerification = false;
								
							// Le taux d'erreur augmente —— - - En cas de dépassement, on interrompt tout
							LevierErreur++;
							//
							if( LevierErreur >= 3000 ){
								//
								LevierVerification = true;
							}
						}
					}
					
					// Si la vérification est bonne —— - -
					if( LevierVerification ){
						
						// Si le taux d'erreur est correcte —— - -
						if( LevierErreur < 3000 ){
							
							// Variable pour transmettre l'objet d'Os
							var ObjetOs:Array = new Array();
							
							// Calibre la ligne et passe à la suivante
							//
							// Pour chaque case à réaliser —— - -
							for( var jCase:int = 0 ; jCase < NombreCase ; jCase++ ){
								
								// Récupère cette case pour la sonder
								laCase = ( Direction == "Vertical" ) ? Grille.Grille[ CaseAleatoire.Vertical + jCase ][ CaseAleatoire.Horizontal ] :
																	   Grille.Grille[ CaseAleatoire.Vertical ][ CaseAleatoire.Horizontal + jCase ];
		
								// On lui donne l'objet de l'Os
								laCase[ "Objet" + Element ] = ObjetOs;
								//
								// On l'ajoute à l'objet Os
								ObjetOs.push( laCase );
		
								// Donne son élément
								laCase[ Element ] = true;
							}
								
							// On ajoute l'Os à l'objet de sortie
							Sortie.push( ObjetOs );
							
							// Une ligne en moins
							Nombre--;
							
							// Erreur à zéro
							LevierErreur = 0;
					
						// Si la vérification n'est pas bonne —— - - Trace l'erreur et Fin de la boucle
						} else {
							//
							TraceError( "GridGenerator" , "AddBones" , "Impossible d'intégrer tous les Os voulues, " + Nombre + " n'ont pus être intégrés." );
							//
							Nombre = 0;
						}
					}
				}
			}
				
			// Retourne la grille et la sorte
			return{ Grille:Grille , Os:Sortie };
		}
		
		
		// —————— ADD BLOCS
		// Intégre des assemblages de cases
	  
		public function AddBlocs( Grille:Object ,		// ———— - - La grille initial ( Tout l'objet et non son objet "Grille" )
								  Element:String ,		// ———— - - Nom de l'élément a disséminer
								  Assemblage:* = null ,	// ———— - - Liste d'assemblage ( Tableau sur trois niveau )
								  Nombre:* = -1 ,		// ———— - - ¤ Nombre de ligne à créer
								  Imperatif:* = "" ,	// ———— - - Valeur impérative pour la case visée ( Nom simple ou tableau [ Nom , Valeur ] )
								  Contreperatif:* = ""	// ———— - - Valeur que la case visée ne doit pas avoir ( Nom simple ou tableau [ Nom , Valeur ] )
							   ):Object {
			/*—*/
			
			/* ► INITIALISATION ◄ */
			
			// Variable de sortie
			var Sortie:Array = new Array();
			
			// Vérifie si la Grille est bonne
			var GrilleCorrecte:Boolean = true;
			//
			// Si la grille ne contient pas l'objet "Grille" —— - - Trace l'erreur
			if( !Grille.Grille ){
				//
				TraceError( "GridGenerator" , "AddBlocs" , "Vous devez transmettre à cette méthode un objet grille contenant la clé «Grille»." );
				//
				GrilleCorrecte = false;
			}
			//
			try {
				//
				// Si la grille ne contient pas l'agencement adéquate —— - - Trace l'erreur
				if( !Grille.Grille[ 0 ][ 0 ] ){
					//
					TraceError( "GridGenerator" , "AddBlocs" , "La grille transmise doit contenir un tableau à deux niveau compilé " + 
																  "par la méthode NewGrid()." );
					//
					GrilleCorrecte = false;
				}
			} catch( e ){
				//
				TraceError( "GridGenerator" , "AddBlocs" , "La grille transmise doit contenir un tableau à deux niveau compilé " + 
															  "par la méthode NewGrid()." );
				//
				GrilleCorrecte = false;
			}
			
			
			// Si la grille est correcte —— - -
			if( GrilleCorrecte ){
				
				
				// Aspire le nombre
				Nombre = Aspiration( Nombre );
			
				// Argument par défaut
				Assemblage = Assemblage || [ [ [ 0 , 0 ] ] ,
											 [ [ 0 , 0 ] , [ 1 , 0 ] ] ,
											 [ [ 0 , 0 ] , [ 0 , 1 ] ] ];
				//
				if( Nombre == -1 ){
					//
					var Infinie:Boolean = true;
					Nombre = 10;
				}
				
				// Compile l'Impératif et Contreperatif
				Imperatif = ( Imperatif != "" && TypeOf( Imperatif , "String" ) ) ? [ Imperatif , true ] : Imperatif;
				Imperatif = ( Imperatif == "" ) ? [ "" , "" ] : Imperatif;
				//
				Contreperatif = ( Contreperatif != "" && TypeOf( Contreperatif , "String" ) ) ? [ Contreperatif , true ] : Contreperatif;
				Contreperatif = ( Contreperatif == "" ) ? [ "" , "" ] : Contreperatif;
				
				
				
				/* ► INTEGRATION ELEMENTS ◄ */
				
				// Variable d'erreur en cas de boucle infinie
				var LevierErreur:int = 0;
				
				// Tans que l'on a pas intégré tout les éléments —— - -
				while( Nombre > 0 ){
					
					// Choisit une case aléatoire
					var CaseAleatoire:Object = Grille.Grille[ Random( 0 , Grille.Grille.length - 1 , true ) ]
															[ Random( 0 , Grille.Grille[ 0 ].length - 1 , true ) ];
					
					// Choisit un assemblage en aléatoire
					var AssemblageAleatoire:Array = RandomArray( Assemblage );
					
					// Leviers de vérification
					var LevierVerification:Boolean = true;
		
					// Pour chaque case de l'assemblage —— - -
					for( var iCase:int = 0 ; iCase < AssemblageAleatoire.length ; iCase++ ){
						
						// Si elle existe en vertical —— - -
						if( Grille.Grille[ CaseAleatoire.Vertical + AssemblageAleatoire[ iCase ][ 0 ] ] ){
							
							// Si elle existe en horizontal —— - -
							if( Grille.Grille[ CaseAleatoire.Vertical + AssemblageAleatoire[ iCase ][ 0 ] ]
											 [ CaseAleatoire.Horizontal + AssemblageAleatoire[ iCase ][ 1 ] ] ){
								
								// Si elle contient déjà l'élément —— - -
								if( Grille.Grille[ CaseAleatoire.Vertical + AssemblageAleatoire[ iCase ][ 0 ] ]
												 [ CaseAleatoire.Horizontal + AssemblageAleatoire[ iCase ][ 1 ] ]
												 [ Element ] ){
									
									// Vérouille le levier de vérification
									LevierVerification = false;
								
								// Sinon —— - - Si on a demandé un impératif et que l'impératif ne s'y trouve pas
								} else if( Imperatif[ 0 ] != "" && Grille.Grille[ CaseAleatoire.Vertical + AssemblageAleatoire[ iCase ][ 0 ] ]
																				[ CaseAleatoire.Horizontal + AssemblageAleatoire[ iCase ][ 1 ] ]
																				[ Imperatif[ 0 ] ] != Imperatif[ 1 ] ){
									
									// Vérouille le levier de vérification
									LevierVerification = false;
									
								// Sinon —— - - Si on a demandé un contreperatif et que le contreperatif s'y trouve
								} else if( Contreperatif[ 0 ] != "" && Grille.Grille[ CaseAleatoire.Vertical + AssemblageAleatoire[ iCase ][ 0 ] ]
																					[ CaseAleatoire.Horizontal + AssemblageAleatoire[ iCase ][ 1 ] ]
																					[ Contreperatif[ 0 ] ] == Contreperatif[ 1 ] ){
									
									// Vérouille le levier de vérification
									LevierVerification = false;
								}
								
							// Sinon —— - -
							} else {
								
								// Vérouille le levier de vérification
								LevierVerification = false;
							}
							
						// Sinon —— - -
						} else {
							
							// Vérouille le levier de vérification
							LevierVerification = false;
						}
					}
					
					// Si le levier de vérification est bon —— - -
					if( LevierVerification ){
					
						// Variable de liste des cases de l'assemblage
						var ListeCasesChoisies:Array = new Array();
						
						// Pour chaque case de l'assemblage —— - -
						for( var iCaseAleatoire:int = 0 ; iCaseAleatoire < AssemblageAleatoire.length ; iCaseAleatoire++ ){
							
							// Lui donne l'élément
							Grille.Grille[ CaseAleatoire.Vertical + AssemblageAleatoire[ iCaseAleatoire ][ 0 ] ]
										 [ CaseAleatoire.Horizontal + AssemblageAleatoire[ iCaseAleatoire ][ 1 ] ]
										 [ Element ] = true;
										 
							// Lui donne l'objet Blocs
							Grille.Grille[ CaseAleatoire.Vertical + AssemblageAleatoire[ iCaseAleatoire ][ 0 ] ]
										 [ CaseAleatoire.Horizontal + AssemblageAleatoire[ iCaseAleatoire ][ 1 ] ]
										 [ "Objet" + Element ] = ListeCasesChoisies;
										 
							// Liste la case
							ListeCasesChoisies.push( Grille.Grille[ CaseAleatoire.Vertical + AssemblageAleatoire[ iCaseAleatoire ][ 0 ] ]
													 [ CaseAleatoire.Horizontal + AssemblageAleatoire[ iCaseAleatoire ][ 1 ] ] );
							
							// Ajoute l'ensemble à la sortie
							Sortie.push( ListeCasesChoisies );
						}
						
						DeleteFromArray( Sortie[ Sortie.length - 1 ] );
						
						// Réduit le nombre
						if( !Infinie ){ Nombre--; }
					
					// Si le levier de vérification n'est pas bon —— - -
					} else {
						
						// Augmente l'erreur
						LevierErreur++;
						
						// Si on a atteint le seuil critique —— - - Trace l'erreur à moins qu'on soit en mode infinie
						if( LevierErreur >= 3000 ){
							//
							if( !Infinie ){
								//
								TraceError( "GridGenerator" , "AddBlocs" , [ "Impossible de placer la totalité des éléments dans la grille." ,
																				   Nombre + " éléments n'ont pas été créés." ] );
							}
							
							// Fin de boucle
							Nombre = 0;
							
							// Levier de comble
							var LevierComble:Boolean = false;
							//
							// Pour chaque assemblage —— - -
							for( var iAssemble:int = 0 ; iAssemble < Assemblage.length ; iAssemble++ ){
		
								// Si c'est un tableau de case unique en 0,0 —— - -
								if( Assemblage[ iAssemble ].length == 1
								 && Assemblage[ iAssemble ][ 0 ][ 0 ] == 0
								 && Assemblage[ iAssemble ][ 0 ][ 1 ] == 0 ){
									
									// Déverrouille le levier
									LevierComble = true;
								}
							}
							
							// Si le levier de comble le permet —— - -
							if( LevierComble ){
								
								// Pour chaque Vertical de la grille —— - -
								for( var iVerti:int = 0 ; iVerti <= Grille.Vertical ; iVerti++ ){
									
									// Pour chaque Horizontal de la grille —— - -
									for( var iHori:int = 0 ; iHori <= Grille.Horizontal ; iHori++ ){
										
										// Si elle n'a pas la valeur, impératif et Contreperatif —— - -
										if( !Grille.Grille[ iVerti ][ iHori ][ Element ] ){
											//
											if( Imperatif[ 0 ] == "" || Grille.Grille[ iVerti ][ iHori ][ Imperatif[ 0 ] ] == Imperatif[ 1 ] ){
												//
												if( Contreperatif[ 0 ] == "" || Grille.Grille[ iVerti ][ iHori ][ Contreperatif[ 0 ] ] != Contreperatif[ 1 ] ){
												
													// La lui donne
													Grille.Grille[ iVerti ][ iHori ][ Element ] = true;
													
													// Lui donne l'objet
													Grille.Grille[ iVerti ][ iHori ][ "Objet" + Element ] = [ Grille.Grille[ iVerti ][ iHori ] ];
													
													// L'ajoute à la sortie
													Sortie.push( Grille.Grille[ iVerti ][ iHori ][ "Objet" + Element ] );
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
				
			// Retourne la grille et la sorte
			return{ Grille:Grille , Bloc:Sortie };
		}
		
		
		
		
	
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}